<div align="left">
    <picture>
        <source media="(prefers-color-scheme: dark)" srcset="https://github.com/sumiya11/Groebner.jl/raw/master/docs/src/assets/logo-dark-with-text.svg">
      <img alt="Groebner.jl logo" src="https://github.com/sumiya11/Groebner.jl/raw/master/docs/src/assets/logo-with-text.svg">
    </picture>
</div>

---

[![Runtests](https://github.com/sumiya11/Groebner.jl/actions/workflows/Runtests.yml/badge.svg)](https://github.com/sumiya11/Groebner.jl/actions/workflows/Runtests.yml)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://sumiya11.github.io/Groebner.jl)
[![codecov](https://codecov.io/github/sumiya11/Groebner.jl/graph/badge.svg?token=J1SZT8ED9S)](https://codecov.io/github/sumiya11/Groebner.jl)

Groebner.jl is a Julia package for computing Groebner bases over fields.
Groebner.jl is distributed under GNU GPL v2.

For documentation please check out https://sumiya11.github.io/Groebner.jl.
For a simple example, see below.

For development plan: [Plans for 2026](https://github.com/sumiya11/Groebner.jl/issues/202).

## Installation

You can install Groebner.jl using the Julia package manager. From the Julia REPL, type

```julia
import Pkg; Pkg.add("Groebner")
```

After the installation, you can run the package tests with

```julia
import Pkg; Pkg.test("Groebner")
```

## How to use Groebner.jl?

The main function provided by Groebner.jl is `groebner`.
It works with polynomials from AbstractAlgebra.jl, DynamicPolynomials.jl, and Nemo.jl. 

### with AbstractAlgebra.jl

We create a ring of polynomials in 3 variables and a simple polynomial system

```julia
using AbstractAlgebra

R, (x1, x2, x3) = QQ["x1", "x2", "x3"]

system = [
  x1 + x2 + x3,
  x1*x2 + x1*x3 + x2*x3,
  x1*x2*x3 - 1
]
```

And compute the Groebner basis by passing the system to `groebner`

```julia
using Groebner

G = groebner(system)
```
```julia
# result
3-element Vector{AbstractAlgebra.Generic.MPoly{Rational{BigInt}}}:
 x3^3 - 1
 x2^2 + x2*x3 + x3^2
 x1 + x2 + x3
```

### with DynamicPolynomials.jl

Similarly to AbstractAlgebra.jl, we create a system of polynomials and pass it to `groebner`

```julia
using DynamicPolynomials, Groebner

@polyvar x1 x2
system = [10*x1*x2^2 - 11*x1 + 10,
        10*x1^2*x2 - 11*x2 + 10]

G = groebner(system)
```
```julia
# result
3-element Vector{Polynomial{DynamicPolynomials.Commutative{DynamicPolynomials.CreationOrder}, Graded{LexOrder}, Rational{BigInt}}}:
 10//11x2 - 10//11x1 - x2² + x1²
 1//1 - 11//10x2 - 10//11x2² + 10//11x1x2 + x2³
 1//1 - 11//10x1 + x1x2²
```

## Contacts

This library is maintained by Alexander Demin (<demin@lix.polytechnique.fr>).

## Contributing

Contributions are very welcome, as are feature requests and suggestions. In particular additional examples and documentation improvements are encouraged. If you encounter any problems, please open an issue or contact a maintainer.

## Acknowledgement

We would like to acknowledge the developers of the msolve library ([https://msolve.lip6.fr/](https://msolve.lip6.fr/)), as several components of Groebner.jl were adapted from msolve. In our F4 implementation, we adapt and adjust the code of monomial hashtable, critical pair handling and symbolic preprocessing, and linear algebra from msolve. The source code of msolve is available at [https://github.com/algebraic-solving/msolve](https://github.com/algebraic-solving/msolve).

We thank Vladimir Kuznetsov for helpful discussions and providing the sources of his F4 implementation.

We are grateful to The Max Planck Institute for Informatics, The MAX team at l'X, and the OURAGAN team at Inria for providing computational resources.

## See also

Other software in Julia that can be used for computing Groebner bases:

- [AlgebraicSolving.jl](https://github.com/algebraic-solving/AlgebraicSolving.jl)
- [GroebnerBasis.jl](https://github.com/ederc/GroebnerBasis.jl), deprecated, see [Oscar.jl](https://github.com/oscar-system/Oscar.jl)
- [Singular.jl](https://github.com/oscar-system/Singular.jl)

If you do not see your package here, we either do not know about it, or forgot to include it, sorry! Feel free to open a PR.

## Citing Groebner.jl

If you find Groebner.jl useful in your work, you can star this repository and cite [this paper](https://arxiv.org/abs/2304.06935)

```
@misc{demin2024groebnerjl,
      title={Groebner.jl: A package for Gr\"obner bases computations in Julia}, 
      author={Alexander Demin and Shashi Gowda},
      year={2024},
      eprint={2304.06935},
      archivePrefix={arXiv},
      primaryClass={cs.MS}
}
```

## Benchmarks

Benchmarks for `Groebner.jl`, `Maple`, `msolve`, `OpenF4`, `Singular`.

The definitions of benchmark systems can be found in `benchmark_systems.jl`.

Computed bases will be verified against short SHA certificate, which are assumed to
be correct.

For running the benchmarks, you will need a Julia client v1.6+ installed (preferably 1.9).
See the official installation guide at
https://julialang.org/downloads/platform/.

## Running benchmarks

To benchmark all available software at once, execute this command in your favorite terminal from this directory:

```
julia one_script_to_run_them_all.jl ALL
```

See below for software-specific instructions.

It is possible to specify command-line options. 
These options are available for all software benchmarked here.
For example, the following command

```
julia one_script_to_run_them_all.jl ALL --timeout=600 --nworkers=16 --nruns=3 --validate=no --suite=1 --bmaple=/path/to/maple/binary --lopenf4=/path/to/openf4/lib --bmsolve=/path/to/msolve/binary
```

runs benchmarks under the following conditions:

- Timeout `600 s` for each benchmark system.
- Distribute benchmarks over `16` worker processes.
- Re-run each benchmark `3` times and average the timings.
- Do not validate the correctness of resulting Groebner bases.
- Use the `1`-st benchmark suite (see `benchmark_systems.jl` for details).
- Use Maple binary from `/path/to/maple/binary`.
- Use OpenF4 library installation from `/path/to/openf4/lib/`.
- Use msolve binary from `/path/to/msolve/binary`.

You can still run the command even if you do not have some of these software. 
For example, if you do not have `msolve` and `OpenF4`, omit the `--bmsolve` and `--lopenf4` options, and the script will benchmark only `Groebner.jl`, `Maple`, and `Singular`.
We use `Singular.jl`, thus the only necessary thing to run Singular benchmarks is a Julia client.

It is advisable to run the benchmarks with no other maple/msolve tasks running in background in parallel. This is because the benchmark script eagerly cleans up the processes and may accidentally kill an innocent maple/msolve process.

## Groebner.jl

#### To run only `Groebner.jl` benchmarks

1. Execute this command in your favorite terminal from this directory:

```
julia one_script_to_run_them_all.jl groebner
```

We compute the bases using the function `Groebner.groebner` with the option `threaded=:no` and other options with default values.

## Singular

*Running Singular benchmarks on Windows is not possible.*

#### To run only `Singular` benchmarks

1. Execute this command in your favorite terminal from this directory:

```
julia one_script_to_run_them_all.jl singular
```

## Maple

#### For `Maple` benchmarks, you will need:

1. A Maple client installed. See the official installation guide at https://www.maplesoft.com/support/install/2021/Maple/Install.html

#### To run only `Maple` benchmarks

1. Execute this command in your favorite terminal from this directory:

```
julia one_script_to_run_them_all.jl maple --bmaple=/path/to/maple/binary
```

Internally, this will use the `Groebner[Basis]` command with `method=fgb`.

## OpenF4

#### For `OpenF4` benchmarks, you will need:

1. OpenF4 library installed. See the official installation guide at http://nauotit.github.io/openf4

#### To run only `OpenF4` benchmarks

1. Execute this command in your favorite terminal from this directory:

```
julia one_script_to_run_them_all.jl openf4 --lopenf4=/path/to/openf4/lib
```

where `/path/to/openf4/lib` is the path to the directory where the `OpenF4` library is installed.

## msolve

#### For `msolve` benchmarks, you will need:

1. `msolve` client installed. See the official installation guide at https://msolve.lip6.fr/ and https://github.com/algebraic-solving/msolve/blob/master/INSTALL

#### To run only `msolve` benchmarks

1. Execute this command in your favorite terminal from this directory:

```
julia one_script_to_run_them_all.jl msolve --bmsolve=/path/to/msolve/binary
```

Internally, this will run

```
msolve -g 2 -l 44 -c 0 -f system.in -o /dev/null
```

for each benchmark system over finite fields, where `msolve` is equal to `/path/to/msolve/binary`.
For benchmarks over the rationals, we do not specify the linear algebra option `-l`.

## Benchmarking monomial implementations

### Generating native code

```julia
julia native.jl
```

### Benchmarking

```julia
julia benchmark.jl
```

### Findings

i5-8250U CPU @ 1.60GHz (2017):

1. `monom_hash` is not inlined for `PackedTuple2`. Also, `monom_hash` checks inbounds in `view` in `PackedTuple2`.

2. `monom_create_divmask` is inlined for `FixedMonomNoDeg` (and not inlined for `Vector{UInt8}` or `PackedTuple2`). Produces +400 lines of assembly => **mark @noinline?**.

3. As a result of 2., xmm6-xmm15 are spilled per calling convention. If `hashtable_insert` is not inlined itself, then the spills may be expensive (=> **mark `monom_create_divmask` @noinline?**).

4. A notable difference between implementations is whether the total degree contributes to hash.

5. Combining exponents in `monom_hash` of `NibbleMonom` is fine.

6. Inserting in the hashtable (`hashtable_insert!`) many times:

- Original code (with `monom_create_divmask` inlined)
```
=======================================================
 Benchmark Results for N = 11 (Min ns / Insertion)
=======================================================
Monomial Type                  | Empty HT   | Filled HT
-------------------------------+------------+----------
PackedTuple2{UInt64, UInt8}    |   104.29   |    22.00
Vector{UInt8}                  |   118.66   |    26.59
FixedVector{16, UInt8}         |    78.90   |    16.51
FixedMonom{16, UInt8}          |    83.20   |    18.08
FixedMonomNoDeg{16, UInt8}     |    81.03   |    16.11
NibbleMonom{8}                 |    82.31   |    11.26
=======================================================

=======================================================
 Benchmark Results for N = 55 (Min ns / Insertion)
=======================================================
Monomial Type                  | Empty HT   | Filled HT
-------------------------------+------------+----------
Vector{UInt8}                  |   164.00   |    41.89
FixedVector{64, UInt8}         |   157.22   |    25.47
FixedMonom{64, UInt8}          |   177.21   |    34.78
FixedMonomNoDeg{64, UInt8}     |   157.84   |    26.58
NibbleMonom{32}                |   158.18   |    18.68
=======================================================
```

- With `monom_create_divmask` marked @noinline:
```
=======================================================
 Benchmark Results for N = 11 (Min ns / Insertion)
=======================================================
Monomial Type                  | Empty HT   | Filled HT
-------------------------------+------------+----------
PackedTuple2{UInt64, UInt8}    |    90.16   |    21.30
Vector{UInt8}                  |   102.22   |    24.55
FixedVector{16, UInt8}         |    75.57   |    12.55
FixedMonom{16, UInt8}          |    76.25   |    13.09
FixedMonomNoDeg{16, UInt8}     |    75.86   |    12.49
NibbleMonom{8}                 |    69.18   |    11.30
=======================================================

=======================================================
 Benchmark Results for N = 55 (Min ns / Insertion)
=======================================================
Monomial Type                  | Empty HT   | Filled HT
-------------------------------+------------+----------
Vector{UInt8}                  |   148.70   |    38.96
FixedVector{64, UInt8}         |   140.58   |    23.31
FixedMonom{64, UInt8}          |   142.83   |    25.57
FixedMonomNoDeg{64, UInt8}     |   140.79   |    22.75
NibbleMonom{32}                |   129.29   |    19.14
=======================================================
```

### Other

1. `monom_product!` for `FixedMonomNoDeg` for `N=11` (rounded to 16) is nice (checked arithmetic):

```julia
julia> code_native(Groebner.monom_product!, Tuple{Groebner.FixedMonomNoDeg{16,UInt8},Groebner.FixedMonomNoDeg{16,UInt8},Groebner.FixedMonomNoDeg{16,UInt8}}; debuginfo=:none)

        .text
        .file   "monom_product!"
        .section        .ltext,"axl",@progbits
        .globl  "julia_monom_product!_278751"   # -- Begin function julia_monom_product!_278751
        .p2align        4, 0x90
        .type   "julia_monom_product!_278751",@function
"julia_monom_product!_278751":          # @"julia_monom_product!_278751"
; Function Signature: monom_product!(Groebner.FixedMonomNoDeg{16, UInt8}, Groebner.FixedMonomNoDeg{16, UInt8}, Groebner.FixedMonomNoDeg{16, UInt8})
        .cfi_startproc
# %bb.0:                                # %top
        #DEBUG_VALUE: monom_product!:a <- [$r8+0]
        #DEBUG_VALUE: monom_product!:b <- [$r9+0]
        vmovdqu xmm1, xmmword ptr [r8]
        vpaddb  xmm0, xmm1, xmmword ptr [r9]
        vpmaxub xmm1, xmm0, xmm1
        vpxor   xmm1, xmm0, xmm1
        vptest  xmm1, xmm1
        jne     .LBB0_2
# %bb.1:                                # %L193
        vmovdqu xmmword ptr [rcx], xmm0
        mov     rax, rcx
        ret
.LBB0_2:                                # %L191
        push    rbp
        .cfi_def_cfa_offset 16
        .cfi_offset rbp, -16
        mov     rbp, rsp
        .cfi_def_cfa_register rbp
        sub     rsp, 32
        movabs  rcx, offset ".Ljl_global#278758.jit"
        movabs  rax, offset j_overflowerror_278757
        call    rax
.Lfunc_end0:
        .size   "julia_monom_product!_278751", .Lfunc_end0-"julia_monom_product!_278751"
        .cfi_endproc
                                        # -- End function
.set ".L+Groebner.FixedMonomNoDeg#278753.jit", 1806300472528
        .size   ".L+Groebner.FixedMonomNoDeg#278753.jit", 8
.set ".Ljl_global#278758.jit", 140735697973696
        .size   ".Ljl_global#278758.jit", 8
        .section        ".note.GNU-stack","",@progbits
```

### Native codes!

1)

```julia
using Groebner, InteractiveUtils

io = open("llvm_vec4.txt", "w")
code_llvm(
    io,
    Groebner.linalg_vector_addmul_sparsedense!,
    Tuple{
        Vector{Groebner.CompositeNumber{4, Int64}},
        Vector{Int32},
        Vector{Groebner.CompositeNumber{4, Int32}},
        Groebner.SignedCompositeArithmeticZp{
            Groebner.CompositeNumber{4, Int64},
            Groebner.CompositeNumber{4, Int32},
            Int64,
            4
        },
    },
    debuginfo=:none
)       
close(io)
```

2)

```julia
using Groebner, InteractiveUtils

io = open("native_vec4.txt", "w")
code_native(
    io,
    Groebner.linalg_vector_addmul_sparsedense!,
    Tuple{
        Vector{Groebner.CompositeNumber{4, Int64}},
        Vector{Int32},
        Vector{Groebner.CompositeNumber{4, Int32}},
        Groebner.SignedCompositeArithmeticZp{
            Groebner.CompositeNumber{4, Int64},
            Groebner.CompositeNumber{4, Int32},
            Int64,
            4
        },
    },
    debuginfo=:none
)       
close(io)
```

3)

```julia
using InteractiveUtils; versioninfo()
```

import AbstractAlgebra

include((@__DIR__) * "/for_gleb.jl")
include((@__DIR__) * "/parser.jl")

function load_SI_problem(name; k=AbstractAlgebra.QQ)
    if name == "SIWR"
        sys = read_SIWR(k=k)[2]
        @assert AbstractAlgebra.internal_ordering(AbstractAlgebra.parent(sys[1])) == :degrevlex
        return sys
    elseif name == "SEAIJRC"
        sys = read_SEAIJRC(k=k)[2]
        @assert AbstractAlgebra.internal_ordering(AbstractAlgebra.parent(sys[1])) == :degrevlex
        return sys
    else
        throw("Beda beda ogorchenie")
    end
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Linear algebra, main entry points

"""
    linalg_main!

Given a `MacaulayMatrix` of the form

    | A B |
    | C D |

linearly reduces the `CD` part with respect to the known pivots from the `AB`
part, and interreduces (or, autoreduces) the result inplace.

In other words, computes the reduced row echelon form of

    D - C inv(A) B.

Returns `true` if successful and `false` otherwise.
"""
function linalg_main!(
    matrix::MacaulayMatrix,
    basis::Basis,
    params::AlgorithmParameters,
    trace=nothing;
    linalg=nothing
)
    @invariant matrix_well_formed(matrix)

    rng = params.rng
    arithmetic = params.arithmetic
    if isnothing(linalg)
        linalg = params.linalg
    end
    changematrix = params.changematrix
    tasks = params.tasks
    flag = if !isnothing(trace)
        _linalg_main_with_trace!(trace, matrix, basis, linalg, tasks, changematrix, arithmetic, rng)
    else
        _linalg_main!(matrix, basis, linalg, tasks, changematrix, arithmetic, rng)
    end

    flag
end

"""
    linalg_autoreduce!

Interreduces the rows of the given `MacaulayMatrix`.

Returns `true` if successful and `false` otherwise.
"""
function linalg_autoreduce!(
    matrix::MacaulayMatrix,
    basis::Basis,
    params::AlgorithmParameters,
    trace=nothing;
    linalg=nothing
)
    @invariant matrix_well_formed(matrix)

    arithmetic = params.arithmetic
    if isnothing(linalg)
        linalg = params.linalg
    end
    changematrix = params.changematrix

    flag = if !isnothing(trace)
        _linalg_autoreduce_with_trace!(trace, matrix, basis, linalg, changematrix, arithmetic)
    else
        _linalg_autoreduce!(matrix, basis, linalg, changematrix, arithmetic)
    end

    flag
end

"""
    linalg_normalform!

Given a `MacaulayMatrix` of the form

    | A B |
    | C D |

linearly reduces the `CD` part with respect to the pivots in the `AB` part.

In contrast to `linalg_main!`, this function does not perform the final
interreduction (or, autoreduction) of the matrix rows.

Returns `true` if successful and `false` otherwise.
"""
function linalg_normalform!(matrix::MacaulayMatrix, basis::Basis, arithmetic::AbstractArithmetic)
    @invariant matrix_well_formed(matrix)
    _linalg_normalform!(matrix, basis, arithmetic)
end

"""
    linalg_isgroebner!

Given a `MacaulayMatrix` of the form

    | A B |
    | C D |

returns `true` if

    D - C inv(A) B

is zero and `false`, otherwise.
"""
function linalg_isgroebner!(matrix::MacaulayMatrix, basis::Basis, params::AlgorithmParameters)
    @invariant matrix_well_formed(matrix)
    flag = if params.linalg.algorithm === :deterministic
        _linalg_isgroebner_deterministic!(matrix, basis, params.arithmetic)
    elseif params.linalg.algorithm === :randomized
        _linalg_isgroebner_randomized!(matrix, basis, params.arithmetic, params.rng)
    else
        throw(DomainError("Cannot pick a suitable linear algebra backend"))
    end
    flag
end

###
# Further dispatch between linear algebra backends

function linalg_should_use_threading(matrix, linalg, tasks)
    nup, nlow, nleft, nright = matrix_block_sizes(matrix)
    if tasks > 1
        # Opt for single thread for small matrices
        if nlow < 2 * tasks
            false
        elseif nleft + nright < 1_000
            false
        else
            true
        end
    else
        false
    end
end

function _linalg_main!(
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    tasks::Int,
    changematrix::Bool,
    arithmetic::AbstractArithmetic,
    rng::AbstractRNG
)
    flag = if changematrix
        linalg_deterministic_sparse_changematrix!(matrix, basis, linalg, arithmetic)
    elseif linalg.algorithm === :deterministic
        if linalg_should_use_threading(matrix, linalg, tasks)
            linalg_deterministic_sparse_threaded!(matrix, basis, linalg, tasks, arithmetic)
        else
            linalg_deterministic_sparse!(matrix, basis, linalg, arithmetic)
        end
    elseif linalg.algorithm === :randomized
        if linalg_should_use_threading(matrix, linalg, tasks)
            linalg_randomized_sparse_threaded!(matrix, basis, linalg, tasks, arithmetic, rng)
        else
            linalg_randomized_sparse!(matrix, basis, linalg, arithmetic, rng)
        end
    else
        throw(DomainError("Cannot pick a suitable linear algebra backend"))
    end

    flag
end

function _linalg_main_with_trace!(
    trace::Trace,
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    tasks::Int,
    changematrix::Bool,
    arithmetic::AbstractArithmetic,
    rng::AbstractRNG
)
    flag = if linalg.algorithm === :learn
        # At the moment, this never opts for multi-threading
        if linalg_should_use_threading(matrix, linalg, tasks)
            linalg_learn_sparse_threaded!(trace, matrix, basis, tasks, arithmetic)
        else
            linalg_learn_sparse!(trace, matrix, basis, arithmetic)
        end
    else
        @assert linalg.algorithm === :apply
        linalg_apply_sparse!(trace, matrix, basis, arithmetic)
    end

    flag
end

function _linalg_autoreduce!(
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    changematrix::Bool,
    arithmetic::AbstractArithmetic
)
    if changematrix
        linalg_deterministic_sparse_interreduction_changematrix!(matrix, basis, arithmetic)
    else
        linalg_deterministic_sparse_interreduction!(matrix, basis, arithmetic)
    end
end

function _linalg_autoreduce_with_trace!(
    trace::Trace,
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    changematrix::Bool,
    arithmetic::AbstractArithmetic
)
    @assert !changematrix
    sort_matrix_upper_rows!(matrix)

    if linalg.algorithm === :learn
        linalg_learn_deterministic_sparse_interreduction!(trace, matrix, basis, arithmetic)
    else
        @assert linalg.algorithm === :apply
        linalg_apply_deterministic_sparse_interreduction!(trace, matrix, basis, arithmetic)
    end

    true
end

function _linalg_normalform!(matrix::MacaulayMatrix, basis::Basis, arithmetic::AbstractArithmetic)
    sort_matrix_upper_rows!(matrix)
    linalg_reduce_matrix_lower_part_do_not_modify_pivots!(matrix, basis, arithmetic)
end

function _linalg_isgroebner_deterministic!(
    matrix::MacaulayMatrix,
    basis::Basis,
    arithmetic::AbstractArithmetic
)
    sort_matrix_upper_rows!(matrix)
    sort_matrix_lower_rows!(matrix)
    linalg_reduce_matrix_lower_part_all_zero!(matrix, basis, arithmetic)
end

function _linalg_isgroebner_randomized!(
    matrix::MacaulayMatrix,
    basis::Basis,
    arithmetic::AbstractArithmetic,
    rng::AbstractRNG
)
    sort_matrix_upper_rows!(matrix)
    sort_matrix_lower_rows!(matrix)
    linalg_randomized_reduce_matrix_lower_part_all_zero!(matrix, basis, arithmetic, rng)
end

using Test, Groebner, AbstractAlgebra, Random

@testset "normalform" begin
    R, x = polynomial_ring(GF(2^31 - 1), "x")

    @test Groebner.normalform([x], R(0)) == R(0)
    @test Groebner.normalform([x], R(1)) == R(1)
    @test Groebner.normalform([x], [R(0)]) == [R(0)]
    @test Groebner.normalform([x], [R(1)]) == [R(1)]
    @test Groebner.normalform([x], [x, R(5), x + 1]) == [R(0), R(5), R(1)]

    R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"])

    @test Groebner.normalform([x], R(0)) == R(0)
    @test Groebner.normalform([x], R(1)) == R(1)
    @test Groebner.normalform([x], [R(0)]) == [R(0)]
    @test Groebner.normalform([x], [R(1)]) == [R(1)]

    Gs = [[x], [x, y], [x, y, z]]

    @test Groebner.normalform(Gs[1], x) == 0
    @test Groebner.normalform(Gs[1], y) == y
    @test Groebner.normalform(Gs[3], x + y^2) == 0
    @test Groebner.normalform(Gs[2], 5x^2 - y^3 - 1) == -1
    @test Groebner.normalform(Gs[2], x + y + 3z) == 3z

    G = [x^2 + y * x + 1, y^2 - y]

    @test Groebner.normalform(G, x + y + z) == x + y + z
    @test Groebner.normalform(G, x^2 + y^2) == y - y * x - 1
    @test Groebner.normalform(G, y^3) == Groebner.normalform(G, y^4) == y

    R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"], internal_ordering=:degrevlex)
    G = [x^2 + y, y^2 + x]
    @test Groebner.normalform(G, x^2 + y^2) == -x - y

    @test_nowarn Groebner.normalform([x, x * y], x)
end

@testset "normalform many variables" begin
    R, xs = polynomial_ring(QQ, ["x$i" for i in 1:63])
    GB = Groebner.groebner(xs)
    @test GB == reverse(xs)
    @test Groebner.normalform(GB, xs[1]) == R(0)

    R, xs = polynomial_ring(QQ, ["x$i" for i in 1:220])
    GB = Groebner.groebner(xs)
    @test GB == reverse(xs)
    @test Groebner.normalform(GB, xs[1]) == R(0)

    R, xs = polynomial_ring(QQ, ["x$i" for i in 1:1025])
    GB = Groebner.groebner(xs)
    @test GB == reverse(xs)
    @test Groebner.normalform(GB, xs) == [zero(R) for _ in 1:length(xs)]
end

@testset "normalform orderings" begin
    R, (x, y, z) = polynomial_ring(QQ, ["x", "y", "z"])

    @test Groebner.normalform([x + y], [x, y]) == [-y, y]
    @test Groebner.normalform([x + y^2], [x, y], ordering=Groebner.DegLex()) == [x, y]
    @test Groebner.normalform([x + y^2], [x, y], ordering=Groebner.DegRevLex()) == [x, y]
    @test Groebner.normalform([x + y], [x, y], ordering=Groebner.Lex(y, x, z)) == [x, -x]
end

@testset "normalform of an array" begin
    for field in [GF(17), GF(2^31 - 1), QQ]
        R, (x, y) = polynomial_ring(field, ["x", "y"])
        gb = [x, y]
        @test Groebner.normalform(gb, [x, y + 1]) == [R(0), R(1)]
        @test Groebner.normalform(gb, [y + 1, x]) == [R(1), R(0)]
        @test Groebner.normalform(gb, [x, 3y, 4x + 5y, 6x * y, 7x + 1, y + 2, x^2 + y^2 + 3]) ==
              [R(0), R(0), R(0), R(0), R(1), R(2), R(3)]

        gb = [x]
        @test Groebner.normalform(gb, [x, 3y, 4x + 5y, 6x * y, 7x + 1, y + 2, x^2 + y^2 + 3]) ==
              [R(0), 3y, 5y, R(0), R(1), y + 2, y^2 + 3]

        gb = [x^2 + y^2, y^3 - y]
        @test Groebner.normalform(
            gb,
            [R(1), R(5), R(16), 3x, y, 4x * y + 2, y^2, x * y^2 - 8x + y]
        ) == [R(1), R(5), R(16), 3x, y, 4x * y + 2, y^2, x * y^2 - 8x + y]

        gb = [x, R(0), y, R(0)]
        @test Groebner.normalform(gb, [R(0)]) == [R(0)]
        @test Groebner.normalform(gb, [R(0), R(1), R(0)]) == [R(0), R(1), R(0)]
        @test Groebner.normalform([R(0), R(0)], [R(0), R(1), R(0)]) == [R(0), R(1), R(0)]
    end
end

function test_params_nf(
    rng,
    nvariables,
    exps,
    nterms,
    npolys,
    grounds,
    coeffssize,
    orderings,
    orderings_groebner
)
    for n in nvariables
        for e in exps
            for nt in nterms
                for np in npolys
                    for gr in grounds
                        for ord in orderings
                            for ord_groebner in orderings_groebner
                                for csz in coeffssize
                                    set1 = Groebner.Examples.random_generating_set(
                                        rng,
                                        gr,
                                        ord,
                                        n,
                                        e,
                                        nt,
                                        np,
                                        csz
                                    )
                                    set2 = Groebner.Examples.random_generating_set(
                                        rng,
                                        gr,
                                        ord,
                                        n,
                                        e,
                                        nt,
                                        np,
                                        csz
                                    )
                                    isempty(set1) && continue

                                    try
                                        gb = Groebner.groebner(set1, ordering=ord_groebner)
                                        f = rand(set1)

                                        @test iszero(
                                            Groebner.normalform(gb, f, ordering=ord_groebner)
                                        )
                                        @test all(
                                            iszero,
                                            Groebner.normalform(gb, gb, ordering=ord_groebner)
                                        )

                                        isempty(set2) && continue
                                        f = rand(set2)
                                        f_nf = Groebner.normalform(gb, f, ordering=ord_groebner)
                                        @test iszero(
                                            Groebner.normalform(
                                                gb,
                                                f - f_nf,
                                                ordering=ord_groebner
                                            )
                                        )
                                    catch
                                        @error "Beda!" n e nt np gr ord ord_groebner
                                        println(err)
                                        println("Rng:\n", rng)
                                        println("Set:\n", set1)
                                        println("Gb:\n", gb)
                                        println("Nf:\n", nf)
                                        rethrow(err)
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end

@testset "normalform random stress tests" begin
    rng = Random.MersenneTwister(42)

    nvariables = [2, 3]
    exps = [2, 4, 3]
    nterms = [2, 3]
    npolys = [2, 3]
    grounds = [GF(2^31 - 1), QQ]
    coeffssize = [3, 1000, 2^31 - 1]
    orderings = [:deglex, :lex, :degrevlex]
    orderings_groebner =
        [Groebner.InputOrdering(), Groebner.Lex(), Groebner.DegLex(), Groebner.DegRevLex()]
    p = prod(
        map(
            length,
            (nvariables, exps, nterms, npolys, grounds, orderings, orderings_groebner, coeffssize)
        )
    )
    @info "Producing $p tests for normal form. This may take a minute"
    test_params_nf(
        rng,
        nvariables,
        exps,
        nterms,
        npolys,
        grounds,
        coeffssize,
        orderings,
        orderings_groebner
    )
end

# This script is not to be run directly. See runtests.jl.

stopwatch = time_ns()

suite = []

# TTFX
t1 = @timed using Groebner
using AbstractAlgebra

R, (x, y) = polynomial_ring(QQ, ["x", "y"], internal_ordering=:degrevlex)
sys = [x^2 + y, x * y^2]
t2 = @timed groebner(sys)

R, (x, y) = polynomial_ring(GF(2^30 + 3), ["x", "y"])
sys = [x^2 + y, x * y^2]
t3 = @timed groebner(sys)

push!(suite, (problem_name="using Groebner", type=:time, result=[t1.time]))
push!(suite, (problem_name="groebner,ttfx,qq drl", type=:time, result=[t2.time]))
push!(suite, (problem_name="groebner,ttfx,zp lex", type=:time, result=[t3.time]))

# Allocations
k = Groebner.Examples.katsuran(7, internal_ordering=:degrevlex)
groebner(k)
a1 = @allocated groebner(k)

k = Groebner.Examples.katsuran(7, k=GF(2^30 + 3), internal_ordering=:degrevlex)
groebner(k)
a2 = @allocated groebner(k)

push!(suite, (problem_name="AA,bytes,QQ,katsura-7", type=:allocs, result=[a1]))
push!(suite, (problem_name="AA,bytes,2^30+3,katsura-7", type=:allocs, result=[a2]))

k = Groebner.Examples.katsuran(7, internal_ordering=:degrevlex)
a1 = @allocations groebner(k)

k = Groebner.Examples.katsuran(7, k=GF(2^30 + 3), internal_ordering=:degrevlex)
a2 = @allocations groebner(k)

push!(suite, (problem_name="AA,allocs,QQ,katsura-7", type=:allocs, result=[a1]))
push!(suite, (problem_name="AA,allocs,2^30+3,katsura-7", type=:allocs, result=[a2]))

k = Groebner.Examples.cyclicn(8, k=GF(2^30 + 3), internal_ordering=:degrevlex)
groebner(k)
a3 = @allocations groebner(k)
push!(suite, (problem_name="AA,allocs,2^30+3,cyclic-8", type=:allocs, result=[a3]))

k = Groebner.Examples.katsuran(11, k=GF(2^30 + 3), internal_ordering=:degrevlex)
groebner(k)
a4 = @allocations groebner(k)
push!(suite, (problem_name="AA,allocs,2^30+3,katsura-11", type=:allocs, result=[a4]))

# Runtime
import Primes
import Nemo

function nemo_make_prime_finite_field(p)
    if p < typemax(UInt)
        Nemo.fpField(convert(UInt, p), false)
    else
        Nemo.FpField(Nemo.ZZRingElem(p), false)
    end
end

function compute_gb(system, trials=7; kws...)
    times = []
    for _ in 1:trials
        GC.gc()
        time = @elapsed groebner(system; kws...)
        push!(times, time)
    end
    times
end

# Compute Groebner bases over integers modulo a large prime
compute_gb(Groebner.Examples.katsuran(9, internal_ordering=:degrevlex, k=GF(2^31 - 1)))
push!(
    suite,
    (
        problem_name="groebner,AA,2^31-1,katsura 9",
        type=:time,
        result=compute_gb(
            Groebner.Examples.katsuran(9, internal_ordering=:degrevlex, k=GF(2^31 - 1))
        )
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,2^31-1,katsura 10",
        type=:time,
        result=compute_gb(
            Groebner.Examples.katsuran(10, internal_ordering=:degrevlex, k=GF(2^31 - 1)),
            5
        )
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,2^31-1,katsura 11",
        type=:time,
        result=compute_gb(
            Groebner.Examples.katsuran(11, internal_ordering=:degrevlex, k=GF(2^31 - 1)),
            3
        )
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,2^30+3,yang1",
        type=:time,
        result=compute_gb(Groebner.Examples.yang1(internal_ordering=:degrevlex, k=GF(2^30 + 3)), 2)
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,2^27+29,katsura 10",
        type=:time,
        result=compute_gb(
            Groebner.Examples.katsuran(10, internal_ordering=:degrevlex, k=GF(2^27 + 29)),
            5
        )
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,2^27+29,cyclic 8",
        type=:time,
        result=compute_gb(
            Groebner.Examples.cyclicn(8, internal_ordering=:degrevlex, k=GF(2^27 + 29)),
            5
        )
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,2^30+3,1000xcyclic 6",
        type=:time,
        result=[
            sum(
                compute_gb(
                    Groebner.Examples.cyclicn(6, internal_ordering=:degrevlex, k=GF(2^30 + 3)),
                    2000
                )
            )
        ]
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,QQ,100xchandra 7",
        type=:time,
        result=[
            sum(compute_gb(Groebner.Examples.chandran(7, internal_ordering=:degrevlex, k=QQ), 100))
        ]
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,QQ,HIV2",
        type=:time,
        result=compute_gb(Groebner.Examples.HIV2(internal_ordering=:degrevlex), 3)
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,2^31-1,cyclic 8",
        type=:time,
        result=compute_gb(
            Groebner.Examples.cyclicn(8, internal_ordering=:degrevlex, k=GF(2^31 - 1)),
            5
        )
    )
)
push!(
    suite,
    (
        problem_name="groebner,Nemo,2^31-1,cyclic 8",
        type=:time,
        result=compute_gb(
            Groebner.Examples.cyclicn(
                8,
                internal_ordering=:degrevlex,
                k=nemo_make_prime_finite_field(2^31 - 1)
            ),
            5
        )
    )
)

function n_variable_set(n; internal_ordering=:degrevlex, k=GF(2^31 - 1))
    R, x = polynomial_ring(k, ["x$i" for i in 1:n], internal_ordering=internal_ordering)
    f = [sum(prod(x[i:(n - kk)], init=1) for i in 1:(kk + 1)) for kk in 0:(n - 1)]
    f
end

compute_gb(n_variable_set(100, internal_ordering=:degrevlex, k=GF(2^31 - 1)))
push!(
    suite,
    (
        problem_name="groebner,AA,100 vars drl",
        type=:time,
        result=compute_gb(n_variable_set(100, internal_ordering=:degrevlex, k=GF(2^31 - 1)))
    )
)

push!(
    suite,
    (
        problem_name="groebner,no-thread,AA,QQ,chandra 10",
        type=:time,
        result=compute_gb(
            Groebner.Examples.chandran(10, internal_ordering=:degrevlex, k=QQ),
            5,
            tasks=1
        )
    )
)

push!(
    suite,
    (
        problem_name="groebner,AA,QQ,chandra 10",
        type=:time,
        result=compute_gb(
            Groebner.Examples.chandran(10, internal_ordering=:degrevlex, k=QQ),
            5
        )
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,2^31-1,cyclic 8",
        type=:time,
        result=compute_gb(
            Groebner.Examples.cyclicn(8, internal_ordering=:degrevlex, k=GF(2^31 - 1)),
            5
        )
    )
)

function learn_and_apply(system; trials=8)
    times = []
    graph, gb = groebner_learn(system)
    for _ in 1:trials
        GC.gc()
        time2 = @elapsed groebner_apply!(graph, system)
        push!(times, time2)
    end
    times
end

# Learn and apply
push!(
    suite,
    (
        problem_name="apply,AA,2^31-1,cyclic 7",
        type=:time,
        result=learn_and_apply(
            Groebner.Examples.cyclicn(7, internal_ordering=:degrevlex, k=GF(2^31 - 1)),
            trials=15
        )
    )
)
push!(
    suite,
    (
        problem_name="apply,Nemo,2^31-1,cyclic 7",
        type=:time,
        result=learn_and_apply(
            Groebner.Examples.cyclicn(
                7,
                internal_ordering=:degrevlex,
                k=nemo_make_prime_finite_field(2^31 - 1)
            ),
            trials=15
        )
    )
)
push!(
    suite,
    (
        problem_name="apply,AA,2^31-1,katsura 10",
        type=:time,
        result=learn_and_apply(
            Groebner.Examples.katsuran(10, internal_ordering=:degrevlex, k=GF(2^31 - 1))
        )
    )
)
push!(
    suite,
    (
        problem_name="apply,AA,2^27+29,katsura 10",
        type=:time,
        result=learn_and_apply(
            Groebner.Examples.katsuran(10, internal_ordering=:degrevlex, k=GF(2^27 + 29))
        )
    )
)
push!(
    suite,
    (
        problem_name="apply,Nemo,2^31-1,katsura 10",
        type=:time,
        result=learn_and_apply(
            Groebner.Examples.katsuran(
                10,
                internal_ordering=:degrevlex,
                k=nemo_make_prime_finite_field(2^31 - 1)
            )
        )
    )
)

# Compute Groebner bases over the rationals
push!(
    suite,
    (
        problem_name="groebner,AA,QQ,katsura 8",
        type=:time,
        result=compute_gb(Groebner.Examples.katsuran(8, internal_ordering=:degrevlex, k=QQ))
    )
)
push!(
    suite,
    (
        problem_name="groebner,Nemo,QQ,katsura 8",
        type=:time,
        result=compute_gb(Groebner.Examples.katsuran(8, internal_ordering=:degrevlex, k=Nemo.QQ))
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,QQ,eco 10",
        type=:time,
        result=compute_gb(Groebner.Examples.eco10(internal_ordering=:degrevlex, k=QQ))
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,QQ,cyclic 7",
        type=:time,
        result=compute_gb(Groebner.Examples.cyclicn(7, internal_ordering=:degrevlex, k=QQ))
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,QQ,noon 8",
        type=:time,
        result=compute_gb(Groebner.Examples.noonn(8, internal_ordering=:degrevlex, k=QQ), 3)
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,QQ,hexapod",
        type=:time,
        result=compute_gb(Groebner.Examples.hexapod(internal_ordering=:degrevlex, k=QQ), 3)
    )
)

function multimodular_gb_problem(nbits; np=AbstractAlgebra)
    R, (x1, x2, x3, x4) =
        polynomial_ring(np.QQ, ["x1", "x2", "x3", "x4"], internal_ordering=:degrevlex)
    nbits_per_prime = 31
    nprimes = max(div(nbits, nbits_per_prime), 1)
    N = prod(map(BigInt, Primes.nextprimes(2^31 - 100, nprimes)))
    system = [
        x1 + x2 + x3 + x4,
        x1 * x2 + x1 * x3 + x1 * x4 + x2 * x3 + x2 * x4 + x3 * x4,
        x1 * x2 * x3 + x1 * x2 * x4 + x1 * x3 * x4 + x2 * x3 * x4,
        x1 * x2 * x3 * x4 + N
    ]
    system
end

push!(
    suite,
    (
        problem_name="groebner,AA,QQ,10_000-bit output",
        type=:time,
        result=compute_gb(multimodular_gb_problem(10000, np=AbstractAlgebra))
    )
)
push!(
    suite,
    (
        problem_name="groebner,Nemo,QQ,10_000-bit output",
        type=:time,
        result=compute_gb(multimodular_gb_problem(10000, np=Nemo))
    )
)
push!(
    suite,
    (
        problem_name="groebner,AA,QQ,100_000-bit output",
        type=:time,
        result=compute_gb(multimodular_gb_problem(100000, np=AbstractAlgebra), 3)
    )
)
push!(
    suite,
    (
        problem_name="groebner,Nemo,QQ,100_000-bit output",
        type=:time,
        result=compute_gb(multimodular_gb_problem(100000, np=Nemo), 3)
    )
)

function compute_normalforms(system)
    R = parent(system[1])
    gb = Groebner.groebner(system)
    times = []
    trials = 7
    for _ in 1:trials
        GC.gc()
        time = @elapsed begin
            n1 = normalform(gb, system)
            n2 = normalform(gb, gb)
        end
        push!(times, time)
    end
    times
end

# Normal forms
push!(
    suite,
    (
        problem_name="normalform,AA,103,cyclic 8",
        type=:time,
        result=compute_normalforms(
            Groebner.Examples.cyclicn(8, internal_ordering=:degrevlex, k=GF(103))
        )
    )
)
push!(
    suite,
    (
        problem_name="normalform,Nemo,103,cyclic 8",
        type=:time,
        result=compute_normalforms(
            Groebner.Examples.cyclicn(
                8,
                internal_ordering=:degrevlex,
                k=nemo_make_prime_finite_field(103)
            )
        )
    )
)
push!(
    suite,
    (
        problem_name="normalform,AA,QQ,katsura 9",
        type=:time,
        result=compute_normalforms(
            Groebner.Examples.katsuran(9, internal_ordering=:degrevlex, k=QQ)
        )
    )
)

stopwatch = time_ns() - stopwatch
push!(suite, (problem_name="total", type=:time, result=[stopwatch / 1e9]))

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Auxiliary functions wrapping libflint.
# Adapted from Nemo.jl/src/flint/fmpq.jl

function flint_mpz_to_zz!(b::Nemo.ZZRingElem, a::BigInt)
    @ccall Nemo.libflint.fmpz_set_mpz(b::Ref{Nemo.ZZRingElem}, a::Ref{BigInt})::Nothing
    b
end

function flint_qq_to_mpq!(b::Rational{BigInt}, a::Nemo.QQFieldElem)
    @ccall Nemo.libflint.fmpq_get_mpz_frac(
        b.num::Ref{BigInt},
        b.den::Ref{BigInt},
        a::Ref{Nemo.QQFieldElem}
    )::Nothing
    b
end

function flint_reconstruct_fmpq_2!(
    c::Nemo.QQFieldElem,
    a::Nemo.ZZRingElem,
    m::Nemo.ZZRingElem,
    N::Nemo.ZZRingElem,
    D::Nemo.ZZRingElem
)
    success = Bool(
        @ccall Nemo.libflint.fmpq_reconstruct_fmpz_2(
            c::Ref{Nemo.QQFieldElem},
            a::Ref{Nemo.ZZRingElem},
            m::Ref{Nemo.ZZRingElem},
            N::Ref{Nemo.ZZRingElem},
            D::Ref{Nemo.ZZRingElem}
        )::Cint
    )
    success, c
end

###
# Rational reconstruction

# Returns the largest integer N (possibly off by 1) such that 2 N^2 < m.
function ratrec_reconstruction_bound(m::BigInt)
    isqrt((m >> UInt64(1)) - 1)
end

function ratrec_nemo!(
    res::Rational{BigInt},
    c::Nemo.QQFieldElem,
    a::Nemo.ZZRingElem,
    m::Nemo.ZZRingElem,
    N::Nemo.ZZRingElem,
    D::Nemo.ZZRingElem
)
    success, _ = flint_reconstruct_fmpq_2!(c, a, m, N, D)
    flint_qq_to_mpq!(res, c)
    success, res
end

function ratrec_nemo(a::Nemo.ZZRingElem, m::Nemo.ZZRingElem, N::Nemo.ZZRingElem, D::Nemo.ZZRingElem)
    ratrec_nemo!(zero(Rational{BigInt}), zero(Nemo.QQFieldElem), a, m, N, D)
end

###
# Element-wise rational reconstruction

# Table of rationals need not be initialized.
# Reconstructs only the witness set.
@timeit _TIMER function ratrec_vec_partial!(
    table_qq::Vector{Vector{Rational{BigInt}}},
    table_zz::Vector{Vector{BigInt}},
    modulo::BigInt,
    witness_set::Vector{Tuple{Int, Int}},
    mask::Vector{BitVector}
)
    @invariant length(table_qq) == length(table_zz)
    @invariant modulo > 1

    bound = ratrec_reconstruction_bound(modulo)
    nemo_bound = Nemo.ZZRingElem(bound)
    nemo_modulo = Nemo.ZZRingElem(modulo)
    rem_nemo = Nemo.ZZRingElem(0)
    nemo_buf = zero(Nemo.QQFieldElem)

    @inbounds for k in 1:length(witness_set)
        i, j = witness_set[k]
        @invariant 1 <= i <= length(table_zz) && 1 <= j <= length(table_zz[i])
        flint_mpz_to_zz!(rem_nemo, table_zz[i][j])
        success, _ =
            ratrec_nemo!(table_qq[i][j], nemo_buf, rem_nemo, nemo_modulo, nemo_bound, nemo_bound)
        !success && return false
        mask[i][j] = true
    end

    true
end

function _ratrec_vec_full!(
    table_qq::Vector{Vector{Rational{BigInt}}},
    table_zz::Vector{Vector{BigInt}},
    modulo::BigInt,
    mask::Vector{BitVector},
    rem_nemo::Nemo.ZZRingElem,
    nemo_buf::Nemo.QQFieldElem,
    nemo_modulo::Nemo.ZZRingElem,
    nemo_bound_N::Nemo.ZZRingElem,
    nemo_bound_D::Nemo.ZZRingElem,
    chunk::Vector{Int}
)
    @inbounds for i in chunk
        @invariant length(table_zz[i]) == length(table_qq[i])
        for j in 1:length(table_zz[i])
            mask[i][j] && continue
            flint_mpz_to_zz!(rem_nemo, table_zz[i][j])
            @invariant 0 <= rem_nemo < modulo
            success, _ = ratrec_nemo!(
                table_qq[i][j],
                nemo_buf,
                rem_nemo,
                nemo_modulo,
                nemo_bound_N,
                nemo_bound_D
            )
            !success && return false
        end
    end
    true
end

# Table of rationals need not be initialized.
@timeit _TIMER function ratrec_vec_full!(
    table_qq::Vector{Vector{Rational{BigInt}}},
    table_zz::Vector{Vector{BigInt}},
    modulo::BigInt,
    mask::Vector{BitVector};
    tasks=1
)
    @invariant length(table_qq) == length(table_zz)
    @invariant modulo > 1
    @invariant tasks >= 1

    bound = ratrec_reconstruction_bound(modulo)
    nemo_bound = Nemo.ZZRingElem(bound)
    nemo_modulo = Nemo.ZZRingElem(modulo)

    tasks = min(tasks, length(table_zz))
    data_chunks = split_round_robin(1:length(table_zz), tasks)
    task_results = Vector{Task}(undef, length(data_chunks))
    for (tid, chunk) in enumerate(data_chunks)
        task = @spawn begin
            local rem_nemo = zero(Nemo.ZZRingElem)
            local nemo_buf = zero(Nemo.QQFieldElem)
            _ratrec_vec_full!(
                table_qq,
                table_zz,
                modulo,
                mask,
                rem_nemo,
                nemo_buf,
                nemo_modulo,
                nemo_bound,
                nemo_bound,
                chunk
            )
        end
        task_results[tid] = task
    end
    all(map(task -> fetch(task)::Bool, task_results))
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

using SmallCollections: FixedVector

###
# All supported monomial implementations in F4

const Monom = Union{
    ExponentVector{T} where {T},
    AbstractPackedTuple,
    FixedVector,
    FixedMonom,
    FixedMonomNoDeg,
    NibbleMonom,
    NibbleNoDeg
}

###
# All supported coefficient types

# CoeffZp is a supertype of polynomial coefficients modulo a prime
const CoeffZp = Union{AbstractFloat, Unsigned, Signed}

const CompositeCoeffZp = CompositeNumber{N, T} where {N, T <: CoeffZp}

# CoeffQQ is a supertype of polynomial coefficients in the rationals
const CoeffQQ = Union{Rational{BigInt}}

# CoeffZZ is a supertype of polynomial coefficients in the integers. Note that
# it is not actually possible to run our F4 over BigInts (or over any other ring
# that is not a field, in fact).
const CoeffZZ = Union{BigInt}

# All supported coefficient types in F4.
const Coeff = Union{CoeffZp, CompositeCoeffZp, CoeffQQ, CoeffZZ, CoeffGeneric}

# Coefficient type used in a single run of classic modular computation
const CoeffModular = UInt64
@assert CoeffModular <: CoeffZp

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Arithmetic in the rationals.

# All implementations of arithmetic in the rationals are a subtype of this 
abstract type AbstractArithmeticQQ{AccumType, CoeffType} <: AbstractArithmetic{AccumType, CoeffType} end

# Standard arithmetic that uses Base.GMP.MPQ
struct ArithmeticQQ{AccumType, CoeffType} <: AbstractArithmeticQQ{AccumType, CoeffType}
    buf1::BigInt
    buf2::Rational{BigInt}
    function ArithmeticQQ()
        new{Rational{BigInt}, Rational{BigInt}}(BigInt(0), Rational{BigInt}(0))
    end
end

function select_arithmetic(
    ::Type{CoeffType1},
    characteristic::CoeffType2,
    _,
    _
) where {CoeffType1 <: CoeffQQ, CoeffType2 <: Coeff}
    @invariant iszero(characteristic)
    ArithmeticQQ()
end

# Arithmetic with generic coefficients.

struct ArithmeticGeneric{CoeffType, AccumType} <: AbstractArithmetic{CoeffType, AccumType} end

function select_arithmetic(::Type{CoeffType}, _, _, _) where {CoeffType <: CoeffGeneric}
    ArithmeticGeneric{CoeffType, CoeffType}()
end

using Groebner, InteractiveUtils

code_native(
    Groebner.linalg_vector_addmul_sparsedense!,
    Tuple{
        Vector{Groebner.CompositeNumber{4, Int64}},
        Vector{Int32},
        Vector{Groebner.CompositeNumber{4, Int32}},
        Groebner.SignedCompositeArithmeticZp{
            Groebner.CompositeNumber{4, Int64},
            Groebner.CompositeNumber{4, Int32},
            Int64,
            4
        },
    },
    debuginfo=:none
)       

using Test, AbstractAlgebra, Base.Threads, Combinatorics, Primes, Random, Groebner

@testset "groebner basic" begin
    R, (x, y) = polynomial_ring(GF(2^31 - 1), ["x", "y"], internal_ordering=:degrevlex)

    @test_throws DomainError Groebner.groebner([])
    @test_throws DomainError Groebner.groebner([1])
    @test_throws DomainError Groebner.groebner(Vector{elem_type(R)}())

    @test Groebner.groebner([R(0)]) == [R(0)]
    @test Groebner.groebner([x, x, x]) == [x]
    @test Groebner.groebner([x, x, y, y, y, x, x, y]) == [y, x]
    @test Groebner.groebner([R(1)]) == [R(1)]
    @test Groebner.groebner([x^2 + y, y * x - 1, R(1), y^4]) == [R(1)]
    @test Groebner.groebner([2x, 3y, 4x + 5y]) == [y, x]

    R, (x1, x2) = polynomial_ring(GF(2^31 - 1), ["x1", "x2"], internal_ordering=:degrevlex)

    fs = [x1^2 * x2^2 + 2 * x1^2 * x2, x1^2 * x2^2 + 3 * x1^2 * x2 + 5 * x1 * x2^2, x1^2 * x2^2]
    @test Groebner.groebner(fs) == [x1 * x2^2, x1^2 * x2]

    fs = [x1 * x2^2 + x1 * x2, x1^2 * x2^2 + 2 * x1 * x2, 2 * x1^2 * x2^2 + x1 * x2]
    @test Groebner.groebner(fs) == [x1 * x2]

    @test_throws AssertionError Groebner.groebner([x1, x2], this_keyword_does_not_exist=":^(")
end

get_data(sys, T) =
    (map(f -> collect(exponent_vectors(f)), sys), map(f -> collect(T.(coefficients(f))), sys))

function test_low_level_interface(ring, sys; passthrough...)
    T(x) = base_ring(parent(sys[1])) == QQ ? Rational{BigInt}(x) : UInt64(lift(x))
    monoms, coeffs = get_data(sys, T)
    gb_monoms1, gb_coeffs1 = Groebner.groebner(ring, monoms, coeffs; passthrough...)
    gb = Groebner.groebner(sys; passthrough...)
    gb_monoms2, gb_coeffs2 = get_data(gb, T)
    @test (gb_monoms1, gb_coeffs1) == (gb_monoms2, gb_coeffs2)
    @test Groebner.isgroebner(ring, gb_monoms1, gb_coeffs1)
    @test all(iszero, Groebner.normalform(ring, gb_monoms1, gb_coeffs1, ring, monoms, coeffs))
end

@testset "groebner low level" begin
    R, (x, y) = polynomial_ring(GF(2^31 - 1), ["x", "y"], internal_ordering=:degrevlex)
    ring_ff = Groebner.PolyRing(2, Groebner.DegRevLex(), 2^31 - 1)
    ring_ff2 = Groebner.PolyRing(2, Groebner.DegRevLex(), 2^32 - 5)
    ring_qq = Groebner.PolyRing(2, Groebner.DegRevLex(), 0)

    @test_throws DomainError Groebner.groebner(
        Groebner.PolyRing(0, Groebner.DegRevLex(), 0),
        [[[0, 0]]],
        [[1]]
    )
    @test_throws DomainError Groebner.groebner(
        Groebner.PolyRing(2, Groebner.DegRevLex(), -2),
        [[[0, 0]]],
        [[1]]
    )
    @test_throws DomainError Groebner.groebner(
        Groebner.PolyRing(2, Groebner.InputOrdering(), 2^31 - 1),
        [[[0, 0]]],
        [[1]]
    )
    @test_throws DomainError Groebner.groebner(
        Groebner.PolyRing(2, Groebner.DegRevLex(), 33),
        [[[0, 0]]],
        [[1]]
    )
    @test_throws DomainError Groebner.groebner(
        Groebner.PolyRing(2, Groebner.DegRevLex(3, 2, 1), 0),
        [[[0, 0]]],
        [[1]]
    )
    @test_throws DomainError Groebner.groebner(
        Groebner.PolyRing(2, Groebner.DegRevLex(1, 2, 2), 0),
        [[[0, 0]]],
        [[1]]
    )

    @test_throws DomainError Groebner.groebner(ring_ff, [], [])
    @test_throws DomainError Groebner.groebner(ring_ff, [[]], [[]])
    @test_throws DomainError Groebner.groebner(ring_ff, [[[1, 2], []]], [[1]])
    @test_throws DomainError Groebner.groebner(ring_ff, [[[1, 2, 3]]], [[1]])
    @test_throws DomainError Groebner.groebner(ring_ff, [[[1, 2]]], [[1, 2]])
    @test_throws DomainError Groebner.groebner(ring_ff, [[[1, 2]]], [[1, 2]])

    @test ([Vector{Vector{Int}}()], [Int[]]) ==
          Groebner.groebner(ring_ff, [Vector{Vector{Int}}(), Vector{Vector{Int}}()], [Int[], Int[]])
    @test ([[[0, 0]]], [[1]]) == Groebner.groebner(ring_ff, [[[0, 0]]], [[1]])
    @test ([[[1, 1]]], [[1]]) == Groebner.groebner(ring_ff, [[[1, 1]]], [[2]])
    @test ([[[1, 1]]], [[1]]) ==
          Groebner.groebner(ring_ff, [[[1, 1]]], [[2]]; ordering=Groebner.DegRevLex())
    @test ([[[1, 1]]], [[1]]) ==
          Groebner.groebner(ring_ff, [[[1, 1]]], [[2]]; ordering=Groebner.Lex(1, 2))
    @test ([[[0, 1], [0, 0]]], [[1, 5]]) ==
          Groebner.groebner(ring_ff, [[[0, 1], [0, 0], [0, 0]]], [[1, 2, 3]])
    @test ([[[0, 1], [0, 0]]], [[1, 5]]) ==
          Groebner.groebner(ring_qq, [[[0, 1], [0, 0], [0, 0]]], [[1, 2, 3]])
    @test ([[[0, 1], [0, 0]]], [[1, 2^31 - 2]]) ==
          Groebner.groebner(ring_ff, [[[0, 1], [0, 0], [0, 0]]], [[1, 2, -3]])
    @test ([[[0, 1]]], [[1]]) ==
          Groebner.groebner(ring_ff, [[[0, 1], [0, 0], [0, 0]]], [[1, 3, -3]])
    @test ([Vector{Vector{Int}}()], [Int[]]) == Groebner.groebner(ring_ff, [[[0, 1]]], [[0]])
    @test ([Vector{Vector{Int}}()], [Int[]]) == Groebner.groebner(ring_qq, [[[0, 1]]], [[0]])
    @test ([[[1, 1]]], [[1]]) == Groebner.groebner(ring_ff, [[[1, 1]]], [[2^31]])
    @test ([[[1, 1], [1, 0]]], [[1, 5]]) == Groebner.groebner(
        ring_ff2,
        [[[1, 1], [1, 0], [1, 0], [0, 0], [0, 0], [0, 0]]],
        [[1, 2^31, 2^31, 2^31, 2^31, -5]]
    )

    # Sorting on the fly
    ring_qq = Groebner.PolyRing(2, Groebner.DegRevLex(), 0)
    @test ([[[1, 1], [0, 0]]], [[1, 3 // 4]]) ==
          Groebner.groebner(ring_qq, [[[0, 0], [1, 1]]], [[3, 4]])

    ring_gf = Groebner.PolyRing(5, Groebner.Lex(), 2^30 + 3)
    sys = Groebner.Examples.cyclicn(5, k=GF(2^30 + 3), internal_ordering=:lex)
    perm = map(i -> shuffle(collect(1:length(sys[i]))), 1:length(sys))
    monoms = map(i -> collect(exponent_vectors(sys[i]))[perm[i]], 1:length(sys))
    coeffs = map(i -> collect(UInt64.(lift.(coefficients(sys[i]))))[perm[i]], 1:length(sys))
    @test get_data(Groebner.groebner(sys), UInt64 ∘ lift) ==
          Groebner.groebner(ring_gf, monoms, coeffs)

    ring = Groebner.PolyRing(2, Groebner.Lex(1, 2), 0)
    @test ([[[1, 0], [0, 1]]], [[1, 6 // 5]]) ==
          Groebner.groebner(ring, [[[1, 0], [0, 1]]], [[-5, -6]])
    ring = Groebner.PolyRing(2, Groebner.Lex(2, 1), 0)
    @test ([[[0, 1], [1, 0]]], [[1, 5 // 6]]) ==
          Groebner.groebner(ring, [[[1, 0], [0, 1]]], [[-5, -6]])
    ring = Groebner.PolyRing(2, Groebner.DegRevLex(1, 2), 7)
    @test ([[[2, 2], [0, 3]]], [[1, 4]]) ==
          Groebner.groebner(ring, [[[0, 3], [2, 2], [2, 1]]], [[1, 2, 0]])

    sys = Groebner.Examples.cyclicn(5, k=GF(2^40 + 15))
    ring = Groebner.PolyRing(5, Groebner.DegRevLex(), 2^40 + 15)
    test_low_level_interface(ring, sys)

    sys = Groebner.Examples.cyclicn(5, k=GF(2^30 + 3), internal_ordering=:lex)
    ring = Groebner.PolyRing(5, Groebner.Lex(), 2^30 + 3)
    test_low_level_interface(ring, sys)

    sys = Groebner.Examples.cyclicn(5, k=QQ)
    ring = Groebner.PolyRing(5, Groebner.DegRevLex(), 0)
    test_low_level_interface(ring, sys)

    sys = Groebner.Examples.cyclicn(5, k=QQ)
    sys_lex = Groebner.Examples.cyclicn(5, k=QQ; internal_ordering=:lex)
    ring = Groebner.PolyRing(5, Groebner.Lex(), 0)
    monoms, coeffs = get_data(sys, Rational)
    gb = get_data(Groebner.groebner(sys_lex), Rational)
    @test gb == Groebner.groebner(ring, monoms, coeffs)

    sys = Groebner.Examples.cyclicn(7, k=GF(11); internal_ordering=:lex)
    sys_drl = Groebner.Examples.cyclicn(7, k=GF(11); internal_ordering=:degrevlex)
    ring = Groebner.PolyRing(7, Groebner.DegRevLex(), 11)
    monoms, coeffs = get_data(sys, UInt64 ∘ lift)
    gb = get_data(Groebner.groebner(sys_drl), UInt64 ∘ lift)
    @test gb == Groebner.groebner(ring, monoms, coeffs)
end

@testset "groebner generic" begin
    # GB over
    # - Zp
    # - Zp for large p
    # - QQ
    n = 5
    syss = [
        Groebner.Examples.cyclicn(n, k=GF(2^40 + 15)),
        Groebner.Examples.cyclicn(n, k=GF(2^40 + 15), internal_ordering=:lex),
        Groebner.Examples.cyclicn(n, k=GF(2)),
        Groebner.Examples.cyclicn(n, k=GF(nextprime(big(2)^1000))),
        Groebner.Examples.cyclicn(n, k=GF(nextprime(big(2)^1000)), internal_ordering=:lex),
        Groebner.Examples.cyclicn(n, k=QQ)
    ]
    for sys in syss
        ord = internal_ordering(parent(sys[1])) == :lex ? Groebner.Lex() : Groebner.DegRevLex()
        ring = Groebner.PolyRing(n, ord, 0, :generic)
        exps, cfs = get_data(sys, Groebner.CoeffGeneric)
        gbexps, gbcfs = groebner(ring, exps, cfs)
        gb = groebner(sys)
        @test isgroebner(gb)
        @test gbexps == get_data(gb, identity)[1]
        @test isgroebner(ring, gbexps, gbcfs)
        @test all(isempty, normalform(ring, gbexps, gbcfs, ring, exps, cfs)[1])
        @test map(c -> Groebner.generic_coeff_data.(c), gbcfs) == get_data(gb, identity)[2]
    end

    # GB over QQ(a,b)
    R_param, (a, b) = QQ["a", "b"]
    R, (x, y, z) = fraction_field(R_param)["x", "y", "z"]
    F = [x^2 + x + (a + 1), x * y + b * y * z + 1 // (a * b), x * z + z + b]
    @test groebner(F) == [
        z^2 + b // (a + 1) * z + b^2 // (a + 1),
        y + (-a - 1) // (a^2 * b^2 + a * b^4 + a * b^2) * z - 1 // (a^2 * b + a * b^3 + a * b),
        x + (-a - 1) // b * z
    ]

    @test groebner([R(a - b), R(a)]) == [one(R)]
end

@testset "groebner reduced=false" begin
    R, (x, y) = polynomial_ring(GF(2^31 - 1), ["x", "y"], internal_ordering=:lex)

    fs = [x + y^2, x * y - y^2]
    gb = Groebner.groebner(fs, reduced=false)
    @test Groebner.isgroebner(gb)

    fs = [x + y, x^2 + y]
    gb = Groebner.groebner(fs, reduced=false)
    @test Groebner.isgroebner(gb)

    fs = [y, x * y + x]
    gb = Groebner.groebner(fs, reduced=false)
    @test gb == [y, x]

    fs = [x^2 + 5, 2y^2 + 3]
    gb = Groebner.groebner(fs, reduced=false)
    @test gb == [y^2 + 1073741825, x^2 + 5]

    fs = [y^2 + x, x^2 * y + y, y + 1]
    gb = Groebner.groebner(fs, reduced=false)
    @test gb == [R(1)]

    fs = [x^2 * y^2, 2 * x * y^2 + 3 * x * y]
    gb = Groebner.groebner(fs, reduced=false)
    @test gb == [x * y^2 + 1073741825 * x * y, x^2 * y]
end

@testset "groebner ground fields" begin
    # Large fields
    fields = [
        GF(2^20 + 7),
        GF(2^29 - 3),
        GF(2^29 + 11),
        GF(2^30 - 35),
        GF(2^30 + 3),
        GF(2^31 - 1),
        GF(2^31 + 11),
        GF(2^32 + 15)
    ]
    fields = vcat(fields, map(GF, Primes.nextprimes(2^20, 10)))
    for field in fields
        R, (x, y) = field["x", "y"]

        @test Groebner.groebner([R(3), R(4)]) == [R(1)]
        @test Groebner.groebner([x - 3, y + 3]) == [y + 3, x - 3]
        noon = Groebner.Examples.noonn(5, k=field, internal_ordering=:degrevlex)
        gb = Groebner.groebner(noon)
        @test Groebner.isgroebner(gb) && all(iszero, Groebner.normalform(gb, noon))

        trace, gb00 = Groebner.groebner_learn(gb)
        flag, gb01 = Groebner.groebner_apply!(trace, gb)
        @test gb == gb00 == gb01 && flag
    end

    # Larger fields
    fields =
        [GF(BigInt(2)^40 + 15), GF(BigInt(2)^63 - 25), GF(BigInt(2)^63 + 29), GF(BigInt(2)^64 - 59)]
    for field in fields
        R, (x, y) = field["x", "y"]

        @test Groebner.groebner([R(3), R(4)]) == [R(1)]
        @test Groebner.groebner([x - 3, y + 3]) == [y + 3, x - 3]
        noon = Groebner.Examples.noonn(5, k=field, internal_ordering=:degrevlex)
        gb = Groebner.groebner(noon)
        @test Groebner.isgroebner(gb) && all(iszero, Groebner.normalform(gb, noon))

        trace, gb00 = Groebner.groebner_learn(gb)
        flag, gb01 = Groebner.groebner_apply!(trace, gb)
        @test gb == gb00 == gb01 && flag
    end

    # Smaller fields
    fields = map(GF, [113, 127, 131, 251, 257, 32749, 32771, 65521, 65537])
    for field in fields
        R, (x, y) = field["x", "y"]

        @test Groebner.groebner([R(3), R(4)]) == [R(1)]
        @test Groebner.groebner([x - 3, y + 3]) == [y + 3, x - 3]
        noon = Groebner.Examples.noonn(5, k=field, internal_ordering=:degrevlex)
        gb = Groebner.groebner(noon)
        @test Groebner.isgroebner(gb) && all(iszero, Groebner.normalform(gb, noon))

        trace, gb00 = Groebner.groebner_learn(gb)
        flag, gb01 = Groebner.groebner_apply!(trace, gb)
        @test gb == gb00 == gb01 && flag
    end

    # Tiny fields
    fields = map(GF, [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41])
    for field in fields
        R, (x, y) = field["x", "y"]

        @test Groebner.groebner([R(3), R(4)]) == [R(1)]
        @test Groebner.groebner([x - 3, y + 3]) == [y + 3, x - 3]
        noon = Groebner.Examples.noonn(5, k=field, internal_ordering=:degrevlex)
        gb = Groebner.groebner(noon)
        @test Groebner.isgroebner(gb) && all(iszero, Groebner.normalform(gb, noon))

        trace, gb00 = Groebner.groebner_learn(gb)
        flag, gb01 = Groebner.groebner_apply!(trace, gb)
        @test gb == gb00 == gb01 && flag
    end
end

@testset "groebner modular" begin
    for modular in [:classic_modular, :learn_and_apply]
        R, (x,) = polynomial_ring(QQ, ["x"], internal_ordering=:degrevlex)
        @test Groebner.groebner([x], modular=modular) == [x]
        @test Groebner.groebner([4x], modular=modular) == [x]
        @test Groebner.groebner([x + 1], modular=modular) == [x + 1]
        @test Groebner.groebner([4x + 1], modular=modular) == [x + 1 // 4]
        @test Groebner.groebner([x + 5], modular=modular) == [x + 5]
        @test Groebner.groebner([x + 2^10], modular=modular) == [x + 2^10]
        @test Groebner.groebner([x + 2^30], modular=modular) == [x + 2^30]
        @test Groebner.groebner([x + 2^30 + 3], modular=modular) == [x + 2^30 + 3]
        @test Groebner.groebner([x + 2^31 - 1], modular=modular) == [x + 2^31 - 1]
        @test Groebner.groebner([x + 2^31 - 1, x^2], modular=modular) == [1]
        @test Groebner.groebner([(3232323 // 7777)x + 7777 // 3232323], modular=modular) ==
              [x + 60481729 // 10447911976329]
        @test Groebner.groebner([((2^31 - 1) // 1)x + 1], modular=modular) == [x + 1 // 2147483647]
        @test Groebner.groebner([(1 // (2^31 - 1))x + 1], modular=modular) == [x + 2147483647]
        @test Groebner.groebner(
            [1 // (2^30 + 3) * x^2 + (2^30 + 3)x + 1 // (1073741831)],
            modular=modular
        ) == [x^2 + 1152921511049297929x + (2^30 + 3) // 1073741831]

        R, (x, y) = polynomial_ring(QQ, ["x", "y"], internal_ordering=:degrevlex)

        fs = [x, y]
        G = Groebner.groebner(fs, modular=modular)
        @test G == [y, x]

        fs = [5y, 3 // 4 * x]
        G = Groebner.groebner(fs, modular=modular)
        @test G == [y, x]

        fs = [x^2 - (1 // 6) * y, x * y]
        G = Groebner.groebner(fs, modular=modular)
        @test G == [y^2, x * y, x^2 - (1 // 6)y]

        fs = [
            QQ(11, 3) * x^2 * y - QQ(2, 4) * x * y - QQ(1, 7) * y,
            QQ(1, 1) * x * y + QQ(7, 13) * x
        ]
        G = Groebner.groebner(fs, modular=modular)
        @test G == [y^2 + 7 // 13 * y, x * y + 7 // 13 * x, x^2 - 3 // 22 * x + 39 // 539 * y]

        root = Groebner.Examples.rootn(3, k=QQ, internal_ordering=:degrevlex)
        gb = Groebner.groebner(root, modular=modular)
        @test Groebner.isgroebner(gb)

        root = Groebner.Examples.rootn(4, k=QQ, internal_ordering=:degrevlex)
        gb = Groebner.groebner(root, modular=modular)
        @test Groebner.isgroebner(gb)

        root = Groebner.Examples.rootn(8, k=QQ, internal_ordering=:degrevlex)
        gb = Groebner.groebner(root, modular=modular)
        @test Groebner.isgroebner(gb)

        noon = Groebner.Examples.noonn(3, k=QQ, internal_ordering=:degrevlex)
        gb = Groebner.groebner(noon, modular=modular)
        @test Groebner.isgroebner(gb)

        noon = Groebner.Examples.noonn(4, k=QQ, internal_ordering=:degrevlex)
        gb = Groebner.groebner(noon, modular=modular)
        @test Groebner.isgroebner(gb)

        chan = Groebner.Examples.chandran(6)
        gb_truth = Groebner.groebner(chan)
        for _composite in (1, 2, 4, 8, 16)
            gb = groebner(chan, _composite=_composite)
            @test gb == gb_truth
        end

        # Test a number of cases directly
        R, (x, y, z) = QQ["x", "y", "z"]
        xs = gens(R)
        system = [z + 1, -y^5 + y^2 + y + 1, x^10 + x^9 + x^7 - x^5 + x^2 + x]
        for i in 1:100
            # Substitute a point of hight of up to 1000 bits. When raised to power
            # 10, this becomes at most 10k bits
            point = map(x -> x * BigInt(2)^rand(1:(10i)), xs)
            system_i = map(poly -> evaluate(poly, point), system)
            gb_i = Groebner.groebner(system_i, modular=modular)
            @test gb_i == map(poly -> divexact(poly, leading_coefficient(poly)), system_i)
        end
    end

    R, (x, y, z, w) = polynomial_ring(QQ, ["x", "y", "z", "w"], internal_ordering=:degrevlex)

    fs = [(12345678 // 12347)x, (222222221111123 // 2131232232097)y + z]
    G = Groebner.groebner(fs)
    @test G == [y + 2131232232097 // 222222221111123 * z, x]

    fs = [(224 // 225) * x + y, x^2 + 1]
    ans = [x + 225 // 224 * y, y^2 + 50176 // 50625]
    @test Groebner.groebner(fs) == ans

    fs = [(12345 // 12345678)x + y, x^2 + 1]
    ans = [x + 4115226 // 4115 * y, y^2 + 16933225 // 16935085031076]
    @test Groebner.groebner(fs) == ans

    fs = [(12345 // 12345678)x + y, x^2 + z^2, y^2 + w^2, x + 2 * y + 3 * z + 4 * w]
    G = Groebner.groebner(fs)

    @test G == [
        y - 12345 // 4106996 * z - 4115 // 1026749 * w,
        x + 6172839 // 2053498 * z + 4115226 // 1026749 * w,
        z * w + 1692834523553 // 4063974 * w^2,
        z^2 - 16935085031076 // 16933225 * w^2,
        w^3
    ]

    G = [(2^30 + 3)x, (1 // (2^30 + 3))y]
    G = Groebner.groebner(G)
    @test G == [y, x]

    G = [(2^31 - 1) * x + y, (1 // (2^31 - 1)) * y + 1]
    G = Groebner.groebner(G)
    @test G == [y + 2147483647, x - 1]

    R, (x, y, z, w) = polynomial_ring(QQ, ["x", "y", "z", "w"], internal_ordering=:lex)
    fs = [(12345678 // 12347)x, (222222221111123 // 2131232232097)y + z]
    G = Groebner.groebner(fs)
    @test G == [y + 2131232232097 // 222222221111123 * z, x]

    P = prod(BigInt, prevprimes(2^31, 100))
    @test groebner([x^2 + P * x + 1]) == [x^2 + P * x + 1]

    @test isgroebner(groebner(Groebner.Examples.cyclicn(7)))
end

@testset "groebner output sorted" begin
    for K in [GF(11), GF(307), GF(12007), GF(2^31 - 1), QQ]
        R, (x, y, z) = polynomial_ring(K, ["x", "y", "z"], internal_ordering=:lex)

        @test Groebner.groebner([x, y]) == Groebner.groebner([y, x]) == [y, x]
        @test Groebner.groebner([x^2 + y, x * y]) == [y^2, x * y, x^2 + y]
        @test Groebner.groebner([3x + 2, 5y]) == [y, x + K(2) // K(3)]
    end
end

@testset "monomial overflow" begin
    R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"], internal_ordering=:degrevlex)

    @test groebner([x^(2^31)]) == [x^2^31]
    @test_throws Groebner.MonomialDegreeOverflow groebner([x^(2^33)])

    for monoms in [:auto, :dense, :packed, :nibblenodeg]
        gb_1 = [x * y^100 + y, x^100 * y + y^100, y^199 + 2147483646 * x^99 * y]
        gb_2 = [x * y^200 + y, x^200 * y + y^200, y^399 + 2147483646 * x^199 * y]
        gb_3 = [x * y^1000 + y, x^1000 * y + y^1000, y^1999 + 2147483646 * x^999 * y]
        @test Groebner.groebner([x^100 * y + y^100, x * y^100 + y], monoms=monoms) == gb_1
        @test Groebner.groebner([x^200 * y + y^200, x * y^200 + y], monoms=monoms) == gb_2
        @test Groebner.groebner([x^1000 * y + y^1000, x * y^1000 + y], monoms=monoms) == gb_3

        @test Groebner.isgroebner(gb_1, monoms=monoms)
        @test Groebner.isgroebner(gb_2, monoms=monoms)
        @test Groebner.isgroebner(gb_3, monoms=monoms)

        @test Groebner.normalform(gb_1, [x, y, R(1), R(0), x^1000], monoms=monoms) ==
              [x, y, R(1), R(0), x^1000]
        @test Groebner.normalform(gb_2, [x, y, R(1), R(0), x^1000], monoms=monoms) ==
              [x, y, R(1), R(0), x^1000]
        @test Groebner.normalform(gb_3, [x, y, R(1), R(0), x^10], monoms=monoms) ==
              [x, y, R(1), R(0), x^10]
        @test Groebner.normalform(gb_3, [x, y, R(1), R(0), x^1000], monoms=monoms) ==
              [x, y, R(1), R(0), x^1000]

        @test Groebner.leading_term.(gb_1, monoms=monoms) == [x * y^100, x^100 * y, y^199]
        @test Groebner.leading_ideal(gb_1, monoms=monoms) == [x * y^100, x^100 * y, y^199]
        @test Groebner.dimension([x^100 + y^2000], monoms=monoms) == 2
        @test Groebner.dimension([x^10 + y^7, y^15, z^200], monoms=monoms) == 0
        @test length(Groebner.quotient_basis([x^200, y^10, z], ordering=Lex(), monoms=monoms)) ==
              2000
        @test length(Groebner.quotient_basis([x^200, y^10, z], ordering=DegLex(), monoms=monoms)) ==
              2000
    end
end

@testset "groebner reduced=true" begin
    root = Groebner.Examples.rootn(3, k=GF(2^31 - 1), internal_ordering=:degrevlex)
    x1, x2, x3 = gens(parent(first(root)))
    gb = Groebner.groebner(root, reduced=true)
    @test gb == [x1 + x2 + x3, x2^2 + x2 * x3 + x3^2, x3^3 + 2147483646]

    root = Groebner.Examples.rootn(6, k=GF(2^31 - 1), internal_ordering=:degrevlex)
    x1, x2, x3, x4, x5, x6 = gens(parent(first(root)))
    gb = Groebner.groebner(root, reduced=true)
    #! format: off
    @test gb == [
        x1 + x2 + x3 + x4 + x5 + x6,
        x2^2 + x2*x3 + x3^2 + x2*x4 + x3*x4 + x4^2 + x2*x5 + x3*x5 + x4*x5 + x5^2 + x2*x6 + x3*x6 + x4*x6 + x5*x6 + x6^2,
        x3^3 + x3^2*x4 + x3*x4^2 + x4^3 + x3^2*x5 + x3*x4*x5 + x4^2*x5 + x3*x5^2 + x4*x5^2 + x5^3 + x3^2*x6 + x3*x4*x6 + x4^2*x6 + x3*x5*x6 + x4*x5*x6 + x5^2*x6 + x3*x6^2 + x4*x6^2 + x5*x6^2 + x6^3,
        x4^4 + x4^3*x5 + x4^2*x5^2 + x4*x5^3 + x5^4 + x4^3*x6 + x4^2*x5*x6 + x4*x5^2*x6 + x5^3*x6 + x4^2*x6^2 + x4*x5*x6^2 + x5^2*x6^2 + x4*x6^3 + x5*x6^3 + x6^4,
        x5^5 + x5^4*x6 + x5^3*x6^2 + x5^2*x6^3 + x5*x6^4 + x6^5,
        x6^6 + 2147483646
    ]
    #! format: on

    ku = Groebner.Examples.ku10(k=GF(2^31 - 1), internal_ordering=:degrevlex)
    x1, x2, x3, x4, x5, x6, x7, x8, x9, x10 = gens(parent(first(ku)))
    gb = Groebner.groebner(ku, reduced=true)

    @test gb == [
        x9 + 1272065637 * x10 + 875418006,
        x8 + 1529540685 * x10 + 617942964,
        x7 + 1539832471 * x10 + 607651173,
        x6 + 1314302432 * x10 + 833181218,
        x5 + 1453635454 * x10 + 693848197,
        x4 + 673118236 * x10 + 1474365406,
        x3 + 269783061 * x10 + 1877700587,
        x2 + 1042807874 * x10 + 1104675778,
        x1 + 389079675 * x10 + 1758403970,
        x10^2 + 1222705397 * x10 + 924778249
    ]
end

@testset "groebner certify" begin
    R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"], internal_ordering=:lex)

    @test Groebner.groebner([x, y], certify=true) == [y, x]
    @test Groebner.groebner([y, x], certify=true) == [y, x]

    fs = [x^2 + y, x * y]
    @test Groebner.groebner(fs, certify=true) == [y^2, x * y, x^2 + y]

    root = Groebner.Examples.rootn(3, k=QQ, internal_ordering=:degrevlex)
    x1, x2, x3 = gens(parent(first(root)))
    gb = Groebner.groebner(root, certify=true)
    @test gb == [x1 + x2 + x3, x2^2 + x2 * x3 + x3^2, x3^3 - 1]

    root = Groebner.Examples.rootn(6, k=QQ, internal_ordering=:deglex)
    x1, x2, x3, x4, x5, x6 = gens(parent(first(root)))
    gb = Groebner.groebner(root, certify=true)
    #! format: off
    @test gb == [
        x1 + x2 + x3 + x4 + x5 + x6,
        x2^2 + x2*x3 + x3^2 + x2*x4 + x3*x4 + x4^2 + x2*x5 + x3*x5 + x4*x5 + x5^2 + x2*x6 + x3*x6 + x4*x6 + x5*x6 + x6^2,
        x3^3 + x3^2*x4 + x3*x4^2 + x4^3 + x3^2*x5 + x3*x4*x5 + x4^2*x5 + x3*x5^2 + x4*x5^2 + x5^3 + x3^2*x6 + x3*x4*x6 + x4^2*x6 + x3*x5*x6 + x4*x5*x6 + x5^2*x6 + x3*x6^2 + x4*x6^2 + x5*x6^2 + x6^3,
        x4^4 + x4^3*x5 + x4^2*x5^2 + x4*x5^3 + x5^4 + x4^3*x6 + x4^2*x5*x6 + x4*x5^2*x6 + x5^3*x6 + x4^2*x6^2 + x4*x5*x6^2 + x5^2*x6^2 + x4*x6^3 + x5*x6^3 + x6^4,
        x5^5 + x5^4*x6 + x5^3*x6^2 + x5^2*x6^3 + x5*x6^4 + x6^5,
        x6^6 - 1
    ]
    #! format: on

    ku = Groebner.Examples.ku10(k=QQ, internal_ordering=:degrevlex)
    x1, x2, x3, x4, x5, x6, x7, x8, x9, x10 = gens(parent(first(ku)))
    gb = Groebner.groebner(ku, certify=true)

    @test gb == [
        x9 + 230965 // 116706 * x10 - 697789 // 116706,
        x8 + 92386 // 335511 * x10 + 578636 // 335511,
        x7 + 5173616 // 8563059 * x10 - 30862793 // 8563059,
        x6 + 87951472 // 192015891 * x10 + 488096201 // 192015891,
        x5 + 131980 // 18759 * x10 - 56944 // 18759,
        x4 + 32995 // 6084 * x10 - 63415 // 6084,
        x3 - 263960 // 229671 * x10 + 493631 // 229671,
        x2 - 65990 // 17043 * x10 + 151205 // 17043,
        x1 - 26396 // 3273 * x10 + 19850 // 3273,
        x10^2 - 71551 // 26396 * x10 + 45155 // 26396
    ]

    system = [
        x1 + BigInt(10)^100 // BigInt(7)^50 * x2,
        BigInt(90) * x1 * x2 + BigInt(19)^50 + x10^3,
        BigInt(2^31 - 1) * x1^2 + BigInt(2^30 + 2)^10 * x2^2
    ]
    @test Groebner.groebner(system) == Groebner.groebner(system, certify=true)
end

@testset "groebner orderings" begin
    R, (x, y, z, w) = polynomial_ring(QQ, ["x", "y", "z", "w"], internal_ordering=:deglex)

    gb = Groebner.groebner([x, y, z, w], ordering=Groebner.Lex(y, x, w, z))
    @test gb == [z, w, x, y]

    # Parent ring persists
    for aa_ord in [:lex, :deglex, :degrevlex]
        R, (x, y, z, w) = polynomial_ring(QQ, ["x", "y", "z", "w"], internal_ordering=aa_ord)

        @test_throws DomainError Groebner.groebner([x, y, z, w], ordering=Groebner.Lex(x))
        @test_throws DomainError Groebner.groebner([x, y], ordering=Groebner.DegLex(x, y))
        @test_throws DomainError Groebner.groebner([x, y], ordering=Groebner.DegRevLex(x, y))

        for gb_ord in [
            Groebner.Lex(),
            Groebner.DegLex(),
            Groebner.DegRevLex(),
            Groebner.Lex(y, w, z, x),
            Groebner.DegLex(y, w, z, x),
            Groebner.DegRevLex(y, w, z, x),
            Groebner.WeightedOrdering(Dict([x, y, z, w] .=> [1, 1, 1, 1])),
            Groebner.Lex(x, y) * Groebner.DegLex(z, w),
            Groebner.Lex(x) * Groebner.DegLex(y) * Groebner.DegRevLex(z, w),
            Groebner.MatrixOrdering([x, y, z, w], [1 2 3 4; 5 6 7 8])
        ]
            gb0 = Groebner.groebner([R(0), R(0)], ordering=gb_ord)
            gb1 = Groebner.groebner([R(5)], ordering=gb_ord)
            gb2 = Groebner.groebner([x + y + z], ordering=gb_ord)
            @test R == parent(gb0[1]) == parent(gb1[1]) == parent(gb2[1])
            @test gb0 == [R(0)] && gb1 == [R(1)] && gb2 == [x + y + z]
        end
    end

    # Normalization is correct
    R, (x, y, z) = polynomial_ring(QQ, ["x", "y", "z"])
    f = [7x + 3, 11y + 5z + 7]
    @test Groebner.groebner(f) == [y + (5 // 11) * z + 7 // 11, x + 3 // 7]
    @test Groebner.groebner(f, ordering=Groebner.Lex(y, x, z)) ==
          [x + 3 // 7, y + (5 // 11) * z + 7 // 11]
    @test Groebner.groebner(f, ordering=Groebner.Lex(z, x, y)) ==
          [x + 3 // 7, z + (11 // 5) * y + 7 // 5]

    f = [7x + 3y + 5z + 11]
    @test Groebner.groebner(f) == [x + (3 // 7) * y + (5 // 7) * z + 11 // 7]
    @test Groebner.groebner(f, ordering=Groebner.Lex(y, x, z)) ==
          [(7 // 3) * x + y + (5 // 3) * z + 11 // 3]
    @test Groebner.groebner(f, ordering=Groebner.Lex(z, x, y)) ==
          [(7 // 5) * x + (3 // 5) * y + z + 11 // 5]

    # The order of output polynomials is correct
    R, (x, y, z, w) = polynomial_ring(QQ, ["x", "y", "z", "w"], internal_ordering=:deglex)
    for i in 1:10
        xs = Random.shuffle([x, y, z, w])
        polys = [x + 1, y + 2, z + 3, w - 4]

        gb = Groebner.groebner(Random.shuffle(polys), ordering=Groebner.Lex(xs))
        @test map(leading_term, gb) == reverse(xs)

        gb = Groebner.groebner(Random.shuffle(polys), ordering=Groebner.DegLex(xs))
        @test map(leading_term, gb) == reverse(xs)

        gb = Groebner.groebner(Random.shuffle(polys), ordering=Groebner.DegRevLex(xs))
        @test map(leading_term, gb) == reverse(xs)
    end

    # Handles rings that are not the same
    R, (a, b) = polynomial_ring(QQ, ["a", "b"])
    R, (A, B, C) = polynomial_ring(QQ, ["a", "b", "c"])
    @test groebner([a, b], ordering=Lex(B, A)) == [a, b]
    @test groebner([a, b], ordering=Lex(B, A, C)) == [a, b]
    @test groebner([a, b], ordering=DegLex(B) * DegRevLex(A)) == [a, b]
    @test groebner([a, b], ordering=DegLex(A) * DegRevLex(B)) == [b, a]

    # Correctness of Lex, DegLex, DegRevLex comparing with AbstractAlgebra
    for aa_ord in [:lex, :deglex, :degrevlex]
        R, (x1, x2, x3, x4) =
            polynomial_ring(QQ, ["x1", "x2", "x3", "x4"], internal_ordering=aa_ord)
        cases = [
            [x1, x2, x3, x4],
            [x2 * x3 + 2x4, x1 * x2 + 3x3],
            [x1 + 2x2 + 3x3 + 4x4, x1, x2, (x1 + x2 + x3 + x4)^3, x3, x4],
            Groebner.Examples.rootn(5)
        ]
        for case in cases
            xs = gens(parent(case[1]))
            for vars in Combinatorics.permutations(xs)
                for (gb_ord, _quot_aa_ord) in [
                    (Groebner.Lex(vars), :lex),
                    (Groebner.DegLex(vars), :deglex),
                    (Groebner.DegRevLex(vars), :degrevlex)
                ]
                    gb = Groebner.groebner(Random.shuffle(case), ordering=gb_ord)

                    # A hack to get the same ranking of variables as in Groebner
                    (__R, _) = polynomial_ring(QQ, map(repr, vars), internal_ordering=_quot_aa_ord)
                    _xs = sort(gens(__R), by=repr)

                    _case = map(poly -> evaluate(poly, _xs), case)
                    _gb = Groebner.groebner(_case)
                    gb = map(poly -> evaluate(poly, _xs), gb)

                    @test gb == _gb
                end
            end
        end
    end

    # WeightedOrdering
    R, (x, y, z, w) = polynomial_ring(QQ, ["x", "y", "z", "w"], internal_ordering=:deglex)
    @test_throws DomainError Groebner.groebner(
        [x, y],
        ordering=Groebner.WeightedOrdering(Dict([x, y, z] .=> [1, 0, 2]))
    )
    @test_throws DomainError Groebner.groebner(
        [x, y],
        ordering=Groebner.WeightedOrdering(Dict([x, y, z, x, x] .=> [1, 0, 1, 9, 10]))
    )

    R, (x1, x2, x3, x4, x5, x6) = QQ["x1", "x2", "x3", "x4", "x5", "x6"]
    @test_throws DomainError Groebner.groebner(
        [x1],
        ordering=Groebner.WeightedOrdering(Dict([x1, x1, x1, x1, x1, x1] .=> [-1, 0, 0, 0, 0, 0]))
    )

    # ProductOrdering
    ord = Groebner.Lex(x6, x2) * Groebner.Lex(x4, x1, x3)
    @test Groebner.groebner([x1, x2], ordering=ord) == [x1, x2]
    @test Groebner.groebner([x4, x6, x3], ordering=ord) == [x3, x4, x6]

    ord = Groebner.Lex(x6, x2, x5) * Groebner.Lex(x4, x1, x3)
    @test [x3, x1, x4, x5, x2, x6] == Groebner.groebner([x1, x2, x3, x4, x5, x6], ordering=ord)
    f1, f2 = x4 + x1 + x3, x1^2
    F = [f1 + x6 * x2 * x5, x6 * x2 * x5, f1 - f2]
    @test Groebner.groebner(F, ordering=ord)[1:2] == [f2, f1]

    ord = Groebner.Lex(x6, x2, x1, x5) * Groebner.Lex(x4, x1, x3)
    @test [x3, x4, x5, x1, x2, x6] == Groebner.groebner([x1, x2, x3, x4, x5, x6], ordering=ord)

    # MatrixOrdering
    c = Groebner.Examples.cyclicn(4)
    x = gens(parent(c[1]))
    ord = Groebner.MatrixOrdering(
        x,
        [
            1 0 0 0
            0 1 0 0
            0 0 1 0
            0 0 0 1
        ]
    )
    @test Groebner.groebner(c, ordering=ord) == Groebner.groebner(c, ordering=Groebner.Lex())

    ord = Groebner.MatrixOrdering(
        x,
        [
            0 0 0 1
            0 0 1 0
            0 1 0 0
            1 0 0 0
        ]
    )
    @test Groebner.groebner(c, ordering=ord) ==
          Groebner.groebner(c, ordering=Groebner.Lex(reverse(x)))

    ord = Groebner.MatrixOrdering(
        x,
        [
            1 1 1 1
            1 0 0 0
            0 1 0 0
            0 0 1 0
            0 0 0 1
        ]
    )
    @test Groebner.groebner(c, ordering=ord) == Groebner.groebner(c, ordering=Groebner.DegLex())

    ord = Groebner.MatrixOrdering(
        x,
        [
            1 1 1 1
            0 0 0 -1
            0 0 -1 0
            0 -1 0 0
            -1 0 0 0
        ]
    )
    @test Groebner.groebner(c, ordering=ord) == Groebner.groebner(c, ordering=Groebner.DegRevLex())
end

@testset "groebner parent rings" begin
    R, x = polynomial_ring(QQ, "x")
    @test R == parent(first(Groebner.groebner([x], ordering=Groebner.Lex())))
    @test R == parent(first(Groebner.groebner([x], ordering=Groebner.DegLex())))
    @test R == parent(first(Groebner.groebner([x], ordering=Groebner.DegRevLex())))

    R, (x, y, z) = polynomial_ring(QQ, ["x", "y", "z"], internal_ordering=:deglex)

    fs = [y^2, x]
    gb = Groebner.groebner(fs, ordering=Groebner.Lex())
    @test parent(gb[1]) == R
    @test Groebner.groebner(fs, ordering=Groebner.Lex()) == [y^2, x]

    gb = Groebner.groebner(fs, ordering=Groebner.DegRevLex())
    @test parent(gb[1]) == R
    @test gb == [x, y^2]

    gb = Groebner.groebner(fs, ordering=Groebner.DegLex())
    @test parent(gb[1]) == R
    @test gb == [x, y^2]

    noon = Groebner.Examples.noonn(2, internal_ordering=:lex)
    gb = Groebner.groebner(noon, ordering=Groebner.Lex())
    x1, x2 = gens(parent(first(noon)))
    @test gb == [
        x2^5 - 10 // 11 * x2^4 - 11 // 5 * x2^3 + 2 * x2^2 + 331 // 1100 * x2 - 11 // 10,
        x1 + x2^4 - 10 // 11 * x2^3 - 11 // 10 * x2^2 + x2 - 10 // 11
    ]

    gb = Groebner.groebner(noon, ordering=Groebner.DegRevLex())
    x1, x2 = gens(parent(first(noon)))
    @test gb == [
        x1^2 - x2^2 - 10 // 11 * x1 + 10 // 11 * x2,
        x2^3 + 10 // 11 * x1 * x2 - 10 // 11 * x2^2 - 11 // 10 * x2 + 1,
        x1 * x2^2 - 11 // 10 * x1 + 1
    ]

    gb = Groebner.groebner(noon, ordering=Groebner.DegLex())
    x1, x2 = gens(parent(first(noon)))
    @test gb == [
        x1^2 - x2^2 - 10 // 11 * x1 + 10 // 11 * x2,
        x2^3 + 10 // 11 * x1 * x2 - 10 // 11 * x2^2 - 11 // 10 * x2 + 1,
        x1 * x2^2 - 11 // 10 * x1 + 1
    ]
end

@testset "groebner monoms" begin
    for domain in (GF(2^31 - 1), QQ)
        for system in [
            Groebner.Examples.cyclicn(2, k=domain),
            Groebner.Examples.noonn(4, k=domain, internal_ordering=:degrevlex),
            Groebner.Examples.katsuran(5, k=domain, internal_ordering=:degrevlex),
            Groebner.Examples.kinema(k=domain, internal_ordering=:degrevlex),
            Groebner.Examples.NFkB_reduced(k=GF(2^30 + 3), internal_ordering=:degrevlex)
        ]
            results = []
            for monoms in [:dense, :packed, :nibblenodeg]
                gb = Groebner.groebner(system, monoms=monoms)
                push!(results, gb)
                @test Groebner.isgroebner(gb)
            end
            @test length(unique(results)) == 1
        end
    end
end

@testset "groebner zeros" begin
    for field in [GF(2), GF(2^31 - 1), QQ]
        R, (x, y, z) = polynomial_ring(field, ["x", "y", "z"], internal_ordering=:lex)

        @test Groebner.groebner([x - x]) == [R(0)]
        @test Groebner.groebner([R(0), R(0), R(0)]) == Groebner.groebner([R(0)]) == [R(0)]
        @test Groebner.groebner([x, R(0), y, R(0)]) == [y, x]

        @test_throws DomainError Groebner.groebner([])
    end
end

@testset "isgroebner zeros" begin
    for field in [GF(2), GF(2^31 - 1), QQ]
        R, (x, y, z) = polynomial_ring(field, ["x", "y", "z"], internal_ordering=:lex)

        @test Groebner.isgroebner([x - x])
        @test Groebner.isgroebner([R(0), R(0), R(0)])
        @test Groebner.isgroebner([R(0), R(0), R(1)])
        @test Groebner.isgroebner([x, R(0), y, R(0)])

        @test_throws DomainError Groebner.isgroebner([])
    end
end

@testset "normalform zeros" begin
    for field in [GF(2), GF(2^31 - 1), QQ]
        R, (x, y, z) = polynomial_ring(field, ["x", "y", "z"], internal_ordering=:lex)

        @test Groebner.normalform([R(0)], [R(0)]) == [R(0)]
        @test Groebner.normalform([R(0), R(0), R(0)], [x + 2, x, x + 1]) == [x + 2, x, x + 1]
        @test Groebner.normalform([R(0), R(0), R(0)], R(0)) == R(0)

        @test_throws DomainError Groebner.normalform([], x)
        @test_throws DomainError Groebner.normalform([], [x])
    end
end

@testset "normalform checks" begin
    R, (x, y, z) = polynomial_ring(QQ, ["x", "y", "z"], internal_ordering=:lex)

    for check in [false, true]
        @test Groebner.normalform([x, y], y, check=check) == R(0)
    end
    @test_throws DomainError Groebner.normalform([x, x + 1], y, check=true)
    @test_throws DomainError Groebner.normalform([x, x + 1], [y], check=true)
end

@testset "groebner arithmetic" begin
    R, (x, y, z) = polynomial_ring(GF(10007), ["x", "y", "z"], internal_ordering=:degrevlex)

    for arithmetic in [:auto, :delayed, :signed, :basic]
        @test Groebner.groebner([x, y], arithmetic=arithmetic, linalg=:deterministic) ==
              Groebner.groebner([y, x]) ==
              [y, x]

        sys = Groebner.Examples.rootn(3, k=GF(10007), internal_ordering=:degrevlex)
        x1, x2, x3 = gens(parent(first(sys)))
        gb1 = Groebner.groebner(sys, arithmetic=arithmetic, linalg=:deterministic)
        gb2 = Groebner.groebner(sys)
        @test gb1 == gb2 == [x1 + x2 + x3, x2^2 + x2 * x3 + x3^2, x3^3 + 10006]

        sys = Groebner.Examples.cyclicn(7, k=GF(2^25 - 39))
        gb1 = Groebner.groebner(sys, arithmetic=arithmetic, linalg=:deterministic)
        gb2 = Groebner.groebner(sys)
        @test gb1 == gb2

        sys = Groebner.Examples.noonn(7, k=GF(2^25 - 39))
        gb1 = Groebner.groebner(sys, arithmetic=arithmetic, linalg=:deterministic)
        gb2 = Groebner.groebner(sys)
        @test gb1 == gb2
    end
end

@testset "groebner linear algebra" begin
    R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"], internal_ordering=:lex)

    for linalg in [:deterministic, :randomized]
        @test Groebner.groebner([x, y], linalg=linalg) == Groebner.groebner([y, x]) == [y, x]

        fs = [x^2 + y, x * y]
        @test Groebner.groebner(fs, linalg=linalg) == Groebner.groebner(fs) == [y^2, x * y, x^2 + y]

        root = Groebner.Examples.rootn(3, k=GF(2^31 - 1), internal_ordering=:degrevlex)
        x1, x2, x3 = gens(parent(first(root)))
        gb1 = Groebner.groebner(root, linalg=linalg)
        gb2 = Groebner.groebner(root)
        @test gb1 == gb2 == [x1 + x2 + x3, x2^2 + x2 * x3 + x3^2, x3^3 + 2147483646]

        root = Groebner.Examples.rootn(6, k=GF(2^31 - 1), internal_ordering=:degrevlex)
        x1, x2, x3, x4, x5, x6 = gens(parent(first(root)))
        gb1 = Groebner.groebner(root, linalg=linalg)
        gb2 = Groebner.groebner(root)
        @test gb1 == gb2

        ku = Groebner.Examples.ku10(k=GF(2^31 - 1), internal_ordering=:degrevlex)
        x1, x2, x3, x4, x5, x6, x7, x8, x9, x10 = gens(parent(first(ku)))
        gb1 = Groebner.groebner(ku)
        gb2 = Groebner.groebner(ku, linalg=linalg)

        @test gb1 ==
              gb2 ==
              [
                  x9 + 1272065637 * x10 + 875418006,
                  x8 + 1529540685 * x10 + 617942964,
                  x7 + 1539832471 * x10 + 607651173,
                  x6 + 1314302432 * x10 + 833181218,
                  x5 + 1453635454 * x10 + 693848197,
                  x4 + 673118236 * x10 + 1474365406,
                  x3 + 269783061 * x10 + 1877700587,
                  x2 + 1042807874 * x10 + 1104675778,
                  x1 + 389079675 * x10 + 1758403970,
                  x10^2 + 1222705397 * x10 + 924778249
              ]
    end
end

@testset "groebner modular-hard problems" begin
    function get_test_system1(R, N)
        (x1, x2, x3, x4) = AbstractAlgebra.gens(R)
        system = [
            x1 + x2 + x3 + x4,
            x1 * x2 + x1 * x3 + x1 * x4 + x2 * x3 + x2 * x4 + x3 * x4,
            x1 * x2 * x3 + x1 * x2 * x4 + x1 * x3 * x4 + x2 * x3 * x4,
            x1 * x2 * x3 * x4 + N
        ]
        result = [
            x1 + x2 + x3 + x4,
            x2^2 + x2 * x3 + x3^2 + x2 * x4 + x3 * x4 + x4^2,
            x3^3 + x3^2 * x4 + x3 * x4^2 + x4^3,
            x4^4 - N
        ]
        system, result
    end

    R, (x1, x2, x3, x4) =
        polynomial_ring(QQ, ["x1", "x2", "x3", "x4"], internal_ordering=:degrevlex)

    N = prod(map(BigInt, nextprimes(2^30 + 3, 5)))
    system, result = get_test_system1(R, N)
    # this should take about 10 primes
    gb = Groebner.groebner(system)
    @test gb == result

    N = prod(map(BigInt, nextprimes(2^31 - 1, 5)))
    system, result = get_test_system1(R, N)
    # this should take about 10 primes
    gb = Groebner.groebner(system)
    @test gb == result

    N = prod(map(BigInt, nextprimes(2^31 - 1, 100)))
    system, result = get_test_system1(R, N)
    # around 200 primes are required
    gb = Groebner.groebner(system)
    @test gb == result

    N = prod(map(BigInt, nextprimes(2^31 - 1, 5_000)))
    # around 10k primes are required
    system, result = get_test_system1(R, N)
    gb = Groebner.groebner(system)
    @test gb == result

    system = [x1 - (2^31 - 1) * x2 - (2^30 + 3) * x3]
    @test Groebner.groebner(system) == system

    for start_of_range in [2^10, 2^20, 2^30, 2^40]
        for size_of_range in [10, 100, 1000]
            N = prod(Primes.nextprimes(BigInt(start_of_range), size_of_range))
            system = [x1 + N // (N + 1), x3 - (N + 1) // (N - 1), x2 + 42]
            gb = Groebner.groebner(system)
            @test gb == [x3 - (N + 1) // (N - 1), x2 + 42, x1 + N // (N + 1)]
        end
    end
end

@testset "groebner strange example" begin
    get_rand_poly(x, d, n) = sum([rand(1:5) * prod(x .^ rand(0:d, length(x))) for _ in 1:n])

    n = 10
    R, x = polynomial_ring(GF(17), ["x$i" for i in 1:n], internal_ordering=:degrevlex)
    f1 = get_rand_poly(x, 10, 2^15)
    @test Groebner.groebner([f1]) == [divexact(f1, leading_coefficient(f1))]

    n = 6
    R, x = polynomial_ring(GF(17), ["x$i" for i in 1:n], internal_ordering=:degrevlex)
    f1 = get_rand_poly(x, 3, 2^10)
    f2 = get_rand_poly(x, 2, 2^10)
    gb = Groebner.groebner([f1, f2])
    @info "GB contains polynomials of lengths: $(sort(map(length, gb)))"
end

@testset "groebner many variables" begin
    function n_variable_set(n)
        R, x = polynomial_ring(QQ, ["x$i" for i in 1:n])
        f = [sum(prod(x[i:(n - k)], init=1) for i in 1:(k + 1)) for k in 0:(n - 1)]
        f
    end

    function test_n_variables(n)
        f = n_variable_set(n)
        x = gens(parent(f[1]))
        gb = Groebner.groebner(f)

        evencf(i) = isone(i) ? 0 // 1 : (2(i - 1)) // (2i - 1)
        oddcf(i) = isone(i) ? 0 // 1 : (2(i - 1) - 1) // (2(i - 1))
        cf(i, n) = (iseven(n) ? oddcf(i) : evencf(i)) * (-1n)^(i == div(n, 2) + 1)

        ans = [x[div(n, 2) - i + 2] - cf(i, n) for i in 1:(div(n, 2) + 1)]

        @test Groebner.groebner(f, ordering=Groebner.DegRevLex()) == ans
        @test Groebner.isgroebner(gb)
        @test all(iszero, Groebner.normalform(gb, f))
        @test gb == ans
    end

    # up to 63
    test_n_variables(8)
    test_n_variables(13)
    test_n_variables(16)
    test_n_variables(20)
    test_n_variables(32)
    for n in 32:8:63
        test_n_variables(n)
    end

    # up to 127
    for n in [64, 100, 101, 127]
        @info "Variables: $n"
        test_n_variables(n)
    end

    # up to 257
    for n in [128, 256, 257]
        @info "Variables: $n"
        R, x = polynomial_ring(QQ, ["x$i" for i in 1:n])
        f = x
        Groebner.groebner(f)
    end
end

# For Lex, DegLex, and DegRevLex, we can have total degrees up to 2^31
@testset "groebner large exponents" begin
    R, (x, y) = polynomial_ring(QQ, ["x", "y"], internal_ordering=:degrevlex)

    # up to 2^8-1
    for (i, d) in enumerate(4:2:255)
        f = [x^d - 1, x * y + 2]
        m, n, k = div(d, 2), div(d, 2) + 1, div(d, 2) - 1
        gb = Groebner.groebner(f)
        @test gb == [
            x * y + 2,
            x^m + (-1)^(i) // BigInt(2)^m * y^m,
            y^n + (-1)^(i + 1) * BigInt(2)^n * x^k
        ]
    end

    # up to 5^6 < 2^14
    for i in 1:6
        u, v = 3^i, 5^i
        f = [x^u * y^v - 1, x^v + y^u]
        gb = Groebner.groebner(f)
        @test gb == [x^v + y^u, y^(v + u) + x^(v - u), x^u * y^v - 1]
    end

    # above 2^16-1
    f = [x^(2^16) + y]
    @test f == Groebner.groebner(f)

    # up to 5^13 < 2^32
    for i in 7:13
        u, v = 3^i, 5^i
        f = [x^u * y^v - 1, x^v + y^u]
        gb = Groebner.groebner(f)
        @test gb == [x^v + y^u, y^(v + u) + x^(v - u), x^u * y^v - 1]
    end

    # total degree 2^30
    f = [x^1073741824 + y]
    @test f == Groebner.groebner(f)

    # total degree 2^31
    f = [x^1073741824 * y^1073741824 + y]
    @test f == Groebner.groebner(f)

    # this should fail.
    f = [x^4294967295 * y^4294967295 + y]
    @test_throws Groebner.MonomialDegreeOverflow f == Groebner.groebner(f)

    for i in [8, 16, 32, 64]
        u, v = i >> 1, i
        f = [x^u * y^v + y^8, x^8 - y^8]
        gb = Groebner.groebner(f)
    end
end

@testset "homogenization, basic" begin
    for field in [GF(113), GF(2^10 + 7), GF(2^62 + 135), QQ]
        R, x = polynomial_ring(field, "x")
        @test Groebner.groebner([x^2 - 1, (x + 1) * x^2], homogenize=:yes) == [x + 1]
        @test Groebner.groebner([x^2 - 1, (x + 1) * x^2], homogenize=:no) == [x + 1]
        @test Groebner.groebner([x^2 - 1, (x + 1) * x^2], homogenize=:auto) == [x + 1]

        for ordering in [:lex, :deglex, :degrevlex]
            R, (x, y) = polynomial_ring(field, ["x", "y"], internal_ordering=ordering)

            @test Groebner.groebner([R(3)], homogenize=:yes) == [R(1)]
            @test Groebner.groebner([R(0)], homogenize=:yes) == [R(0)]
            @test Groebner.groebner([x], homogenize=:yes) == [x]
            @test Groebner.groebner([x + 11y], homogenize=:yes) == [x + 11y]
            @test Groebner.groebner([x, y], homogenize=:yes) == [y, x]
            @test Groebner.isgroebner(Groebner.groebner([x + 1, y + 2], homogenize=:yes))

            if ordering === :lex
                gb = Groebner.groebner([x + y^2, x^2 - 1], homogenize=:yes)
                @test (y^4 - 1) in gb && (x + y^2) in gb
            end

            for case in [
                Groebner.Examples.katsuran(2, k=field, internal_ordering=ordering),
                Groebner.Examples.katsuran(3, k=field, internal_ordering=ordering),
                Groebner.Examples.katsuran(4, k=field, internal_ordering=ordering),
                Groebner.Examples.noonn(2, k=field, internal_ordering=ordering),
                Groebner.Examples.noonn(3, k=field, internal_ordering=ordering)
            ]
                gb = Groebner.groebner(case, homogenize=:yes)
                @test Groebner.isgroebner(gb)
            end
        end
    end
end

@testset "homogenization, orderings" begin
    for field in [GF(113), GF(2^62 + 135), QQ]
        # Test that the basis obtained with the use of homogenization
        # *coincides* with the one obtained without it
        R, (x, y, z) = polynomial_ring(field, ["x", "y", "z"])
        for case in [
            (system=[R(1)], ord=Groebner.Lex()),
            (system=[R(5)], ord=Groebner.DegRevLex()),
            (system=[x, y, z], ord=Groebner.Lex()),
            (system=[x, y, z], ord=Groebner.Lex(z) * Groebner.Lex(x, y)),
            (system=[x^2 + 1, x * y + 2, y * z + 3], ord=Groebner.DegLex()),
            (
                system=[x^20 - x^15 - x^5 + y * z, x * y^10 + x^3 * y^3 + x * y],
                ord=Groebner.DegRevLex()
            ),
            (system=[x + 5y, x + 7z, y + 11z], ord=Groebner.Lex(z) * Groebner.Lex(x, y)),
            (system=[x + 5y + 11z], ord=Groebner.DegRevLex(y) * Groebner.Lex(z, x)),
            (system=[x + 5y + 11z], ord=Groebner.DegRevLex(z) * Groebner.DegRevLex(y, x)),
            (system=[x * y^2 + x + 1, y * z^2 + y + 1, z^4 - z^2 - 1], ord=Groebner.Lex()),
            (system=[x * y^2 + x + 1, y * z^2 + y + 1, z^4 - z^2 - 1], ord=Groebner.DegRevLex()),
            (
                system=[x * y^2 + x + 1, y * z^2 + y + 1, z^4 - z^2 - 1],
                ord=Groebner.DegRevLex(z) * Groebner.DegRevLex(x, y)
            ),
            (
                system=[x * y^2 + x + 1, y * z^2 + y + 1, x * y * z^4 - x * z^2 - y + z],
                ord=Groebner.DegRevLex(y) * Groebner.DegRevLex(z, x)
            ),
            (system=Groebner.Examples.katsuran(4, k=field), ord=Groebner.DegRevLex()),
            (system=Groebner.Examples.rootn(5, k=field), ord=Groebner.Lex()),
            (system=Groebner.Examples.reimern(5, k=field), ord=Groebner.DegRevLex())
        ]
            ord = case.ord
            system = case.system
            @debug "" system ord field

            gb1 = Groebner.groebner(system, ordering=ord, homogenize=:no)
            gb2 = Groebner.groebner(system, ordering=ord, homogenize=:yes)

            @test Groebner.isgroebner(gb1, ordering=ord)

            @test gb1 == gb2

            # Also test learn / apply
            field == QQ && continue

            context3, gb3 = Groebner.groebner_learn(system, ordering=ord, homogenize=:yes)
            context4, gb4 = Groebner.groebner_learn(system, ordering=ord, homogenize=:no)
            for _ in 1:4
                flag3, gb33 = Groebner.groebner_apply!(context3, system)
                flag4, gb44 = Groebner.groebner_apply!(context4, system)
                @test flag3 && flag4
                @test gb1 == gb3 == gb4 == gb33 == gb44
            end
        end
    end
end

@testset "groebner, change matrix" begin
    R, (x, y, z) = polynomial_ring(GF(2^30 + 3), ["x", "y", "z"], internal_ordering=:degrevlex)
    f = [x * y * z - 1, x * y + x * z + y * z, x + y + z]
    g, m = Groebner.groebner_with_change_matrix(f)
    @test m * f == g
    @test size(m) == (length(g), length(f))
    @test Groebner.isgroebner(g)

    for ground in [GF(2^30 + 3), QQ]
        R, (x, y) = polynomial_ring(ground, ["x", "y"], internal_ordering=:degrevlex)

        cases = [
            [R(0), R(0), R(0)],
            [R(0), R(1), R(0)],
            [x],
            [y],
            [x, x, x, x, R(0), R(0), x, x, x, x],
            [x + y, R(1), x^5 - y^5],
            [x^200 + y^250, x^100 * y^200 + 1],
            Groebner.Examples.katsuran(4, k=ground),
            Groebner.Examples.noonn(4, k=ground),
            Groebner.Examples.cyclicn(4, k=ground),
            [x^i * y + x for i in 1:500]
        ]

        for f in cases
            g, m = Groebner.groebner_with_change_matrix(f)
            @test m * f == g
            @test size(m) == (length(g), length(f))
            @test Groebner.isgroebner(g)
        end
    end

    R, (x, y) = polynomial_ring(QQ, ["x", "y"], internal_ordering=:degrevlex)
    f = [(3 // 1) * y + (1 // 2) * x^2, 11 // 1 + (7 // 1) * y + x * y]
    g, m = Groebner.groebner_with_change_matrix(f)
    @test m * f == g
    @test size(m) == (length(g), length(f))
    @test Groebner.isgroebner(g)

    f = Groebner.Examples.katsuran(4, k=QQ, internal_ordering=:lex)
    g, m = Groebner.groebner_with_change_matrix(f, ordering=Groebner.DegRevLex())
    @test m * f == g
    @test_throws DomainError Groebner.groebner_with_change_matrix(f, ordering=Groebner.DegLex())
    @test_throws DomainError Groebner.groebner_with_change_matrix(f)
end

@testset "multi-threading, composable" begin
    sys1 = Groebner.Examples.chandran(8)
    sys2 = Groebner.Examples.cyclicn(7, k=GF(2^30 + 3))
    n = 5
    res = Vector{Any}(undef, n)
    Base.Threads.@threads for i in 1:n
        gb1 = Groebner.groebner(sys1)
        gb2 = Groebner.groebner(sys1, tasks=1)
        gb3 = Groebner.groebner(sys1, tasks=128)
        @eval Groebner._THREADED[] = false
        gb4 = Groebner.groebner(sys1, tasks=128)
        @eval Groebner._THREADED[] = true
        gb5 = Groebner.groebner(sys2)
        gb6 = Groebner.groebner(sys2, tasks=128)
        gb7 = Groebner.groebner(sys2, linalg=:deterministic, tasks=128)
        _, gb8 = Groebner.groebner_learn(sys2, tasks=128)
        @assert fetch(Threads.@spawn Groebner.isgroebner(gb5))
        @assert all(iszero, Groebner.normalform(gb5, sys2))
        res[i] = (gb1, gb2, gb3, gb4, gb5, gb6, gb7, gb8)
    end
    for i in 1:n
        @test res[i][1] == res[i][2] == res[i][3] == res[i][4]
        @test Groebner.isgroebner(res[i][1])
        @test res[i][5] == res[i][6] == res[i][7] == res[i][8]
        @test Groebner.isgroebner(res[i][5])
    end
end

@testset "groebner, multi-threading, Zp" begin
    @info "Testing multi-threading over Zp using $(nthreads()) threads"

    R, (x, y, z) = GF(2^31 - 1)["x", "y", "z"]

    s = [R(1), R(2), R(4)]
    @test Groebner.groebner(s) ==
          Groebner.groebner(s, tasks=1) ==
          Groebner.groebner(s, tasks=128) ==
          [R(1)]

    s = [x^(2^10) + 1, y^3000 + 2, z^1000 + 3]
    @test Groebner.groebner(s) ==
          Groebner.groebner(s, tasks=1) ==
          Groebner.groebner(s, tasks=128) ==
          [z^1000 + 3, y^3000 + 2, x^(2^10) + 1]

    linalg = [:deterministic, :randomized]
    tasks = [:auto, 1, 4, 128]
    grid = [(linalg=l, tasks=t) for l in linalg for t in tasks]
    for system in [
        Groebner.Examples.katsuran(3, internal_ordering=:lex, k=GF(2^31 - 1)),
        Groebner.Examples.katsuran(4, internal_ordering=:lex, k=GF(2^20 + 7)),
        Groebner.Examples.katsuran(7, internal_ordering=:degrevlex, k=GF(2^31 - 1)),
        Groebner.Examples.eco5(internal_ordering=:deglex, k=GF(2^20 + 7)),
        Groebner.Examples.eco5(internal_ordering=:degrevlex, k=GF(2^20 + 7)),
        Groebner.Examples.cyclicn(5, internal_ordering=:degrevlex, k=GF(2^20 + 7)),
        Groebner.Examples.cyclicn(6, internal_ordering=:degrevlex, k=GF(2^20 + 7)),
        Groebner.Examples.ojika4(internal_ordering=:lex, k=GF(2^20 + 7)),
        Groebner.Examples.henrion5(internal_ordering=:degrevlex, k=GF(2^20 + 7)),
        Groebner.Examples.noonn(6, internal_ordering=:degrevlex, k=GF(2^10 + 7)),
        Groebner.Examples.ku10(internal_ordering=:degrevlex, k=GF(2^10 + 7))
    ]
        results = Array{Any}(undef, size(grid))
        for (i, kw) in enumerate(grid)
            gb = Groebner.groebner(system; kw...)
            results[i] = gb
        end
        @test length(unique(results)) == 1
        @test Groebner.isgroebner(results[1])
    end
end

@testset "groebner, multi-threading, QQ" begin
    @info "Testing multi-threading over QQ using $(nthreads()) threads"

    R, (x, y) = QQ["x", "y"]

    tasks = [:auto, 1, 4, 128]
    grid = [(tasks=t,) for t in tasks]
    for system in [
        [x - 1, y - 2],
        [x + (BigInt(2)^1000 + 1) // 2^61, x * y + BigInt(2)^(2^10)],
        Groebner.Examples.katsuran(3, internal_ordering=:lex, k=QQ),
        Groebner.Examples.katsuran(4, internal_ordering=:lex, k=QQ),
        Groebner.Examples.eco5(internal_ordering=:degrevlex, k=QQ),
        Groebner.Examples.econ(4, internal_ordering=:degrevlex, k=QQ),
        Groebner.Examples.cyclicn(5, internal_ordering=:degrevlex, k=QQ),
        Groebner.Examples.ojika4(internal_ordering=:lex, k=QQ),
        Groebner.Examples.noonn(6, internal_ordering=:degrevlex, k=QQ),
        Groebner.Examples.ku10(internal_ordering=:degrevlex, k=QQ),
        [x + BigInt(2)^1_000 // (BigInt(2)^1_000 - 1), y - BigInt(2)^1_000],
        [x + BigInt(2)^10_000 // (BigInt(2)^10_000 - 1), y^2 - BigInt(2)^10_000 * y]
    ]
        results = Array{Any}(undef, size(grid))
        for (i, kw) in enumerate(grid)
            gb = Groebner.groebner(system; kw...)
            results[i] = gb
        end
        @test length(unique(results)) == 1
        @test Groebner.isgroebner(results[1])
    end
end

function test_params(
    rng,
    boot,
    nvariables,
    maxdegs,
    nterms,
    npolys,
    grounds,
    coeffssize,
    orderings,
    linalgs,
    monoms,
    homogenizes,
    tasks
)
    for _ in 1:boot
        for nv in nvariables
            for md in maxdegs
                for nt in nterms
                    for np in npolys
                        for k in grounds
                            for ord in orderings
                                for cf in coeffssize
                                    if ord == :lex
                                        md = min(2, md)
                                    end
                                    set = Groebner.Examples.random_generating_set(
                                        rng,
                                        k,
                                        ord,
                                        nv,
                                        md,
                                        nt,
                                        np,
                                        cf
                                    )
                                    isempty(set) && continue

                                    for linalg in linalgs
                                        for monom in monoms
                                            for homogenize in homogenizes
                                                for thr in tasks
                                                    try
                                                        gb = Groebner.groebner(
                                                            set,
                                                            linalg=linalg,
                                                            monoms=monom,
                                                            homogenize=homogenize,
                                                            tasks=thr
                                                        )
                                                        flag = Groebner.isgroebner(gb)
                                                        if !flag
                                                            @error "Beda!" nv md nt np k ord monom
                                                            println("Rng:\n", rng)
                                                            println("Set:\n", set)
                                                            println("Gb:\n", gb)
                                                        end
                                                        @test flag
                                                    catch err
                                                        @error "Beda!" nv md nt np k ord monom
                                                        println(err)
                                                        println("Rng:\n", rng)
                                                        println("Set:\n", set)
                                                        rethrow(err)
                                                    end
                                                end
                                            end
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end

@testset "groebner random stress tests" begin
    rng = Random.MersenneTwister(42)

    boot       = 1
    nvariables = [2, 3]
    maxdegs    = [2, 4]
    nterms     = [1, 2, 4]
    npolys     = [1, 4, 100]
    grounds    = [GF(1031), GF(2^50 + 55), AbstractAlgebra.QQ]
    coeffssize = [3, 2^31 - 1, BigInt(2)^80, BigInt(2)^2000]
    orderings  = [:degrevlex, :lex, :deglex]
    linalgs    = [:deterministic, :randomized]
    monoms     = [:auto, :dense, :packed, :nibblenodeg]
    homogenize = [:yes, :auto]
    tasks      = [1, 4, 32]
    p          = prod(vcat(boot, map(length, [nvariables, maxdegs, nterms, npolys, grounds, orderings, coeffssize, linalgs, monoms, homogenize, tasks])))
    @info "Producing $p small random tests for groebner. This may take a minute"

    test_params(
        rng,
        boot,
        nvariables,
        maxdegs,
        nterms,
        npolys,
        grounds,
        coeffssize,
        orderings,
        linalgs,
        monoms,
        homogenize,
        tasks
    )
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

### 
# Backend for `isgroebner`

function isgroebner0(polynomials, options)
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    isgroebner1(ring, monoms, coeffs, options)
end

function isgroebner1(ring, monoms, coeffs, options)
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    _isgroebner1(ring, monoms, coeffs, options)
end

function _isgroebner1(ring, monoms, coeffs, options)
    try
        params = AlgorithmParameters(ring, options)
        return __isgroebner1(ring, monoms, coeffs, params)
    catch err
        if isa(err, MonomialDegreeOverflow)
            _info_possible_overflow()
            params = AlgorithmParameters(ring, options; hint=:large_exponents)
            return __isgroebner1(ring, monoms, coeffs, params)
        else
            # Something bad happened.
            rethrow(err)
        end
    end
end

function __isgroebner1(ring, monoms, coeffs, params)
    @invariant ir_is_valid(ring, monoms, coeffs)
    _, ring2, monoms2, coeffs2 = ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    isgroebner2(ring2, monoms2, coeffs2, params)
end

function isgroebner2(ring, monoms, coeffs, params)
    _monoms = filter(!isempty, monoms)
    _coeffs = filter(!isempty, coeffs)
    isempty(_monoms) && return true
    monoms, coeffs = _monoms, _coeffs
    _isgroebner2(ring, monoms, coeffs, params)
end

# Finite fields
function _isgroebner2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffZp}
    basis, pairset, hashtable = f4_initialize_structs(ring, monoms, coeffs, params)
    res = f4_isgroebner!(ring, basis, pairset, hashtable, params)
    res
end

# Generic fields
function _isgroebner2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffGeneric}
    basis, pairset, hashtable = f4_initialize_structs(ring, monoms, coeffs, params)
    res = f4_isgroebner!(ring, basis, pairset, hashtable, params)
    res
end

# Rational numbers
function _isgroebner2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffQQ}
    basis, pairset, hashtable = f4_initialize_structs(ring, monoms, coeffs, params)
    # If an honest computation over the rationals is requested
    if params.certify_check
        flag = f4_isgroebner!(ring, basis, pairset, hashtable, params)
        return flag
    end
    # Otherwise, check modulo primes
    basis_zz = clear_denominators!(basis, deepcopy=false)
    state = ModularState{BigInt, Rational{BigInt}, UInt32}(basis_zz.coeffs)

    prime = modular_random_prime(state, params.rng)
    ring_ff, basis_ff = modular_reduce_mod_p!(ring, basis_zz, prime, deepcopy=true)
    arithmetic = select_arithmetic(CoeffModular, prime, :auto, false)
    params = struct_update(AlgorithmParameters, params, (arithmetic=arithmetic,))
    flag1 = f4_isgroebner!(ring_ff, basis_ff, pairset, hashtable, params)

    prime = modular_random_prime(state, params.rng)
    ring_ff, basis_ff = modular_reduce_mod_p!(ring, basis_zz, prime, deepcopy=true)
    arithmetic = select_arithmetic(CoeffModular, prime, :auto, false)
    params = struct_update(AlgorithmParameters, params, (arithmetic=arithmetic,))
    flag2 = f4_isgroebner!(ring_ff, basis_ff, pairset, hashtable, params)

    if flag1 == flag2
        return flag1
    end

    prime = modular_random_prime(state, params.rng)
    ring_ff, basis_ff = modular_reduce_mod_p!(ring, basis_zz, prime, deepcopy=true)
    arithmetic = select_arithmetic(CoeffModular, prime, :auto, false)
    params = struct_update(AlgorithmParameters, params, (arithmetic=arithmetic,))
    flag3 = f4_isgroebner!(ring_ff, basis_ff, pairset, hashtable, params)
    if flag1 == flag3
        return flag1
    else
        return flag2
    end
    flag1
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Provides the @invariant macro for custom assertion checking.

"""
    @invariant expr

Check that `expr` evaluates to `true` at runtime. If not, throw an
`AssertionError`.

It should be fine to use the `@invariant` macro in performance-critical code, as
long as the code is compiled with `Groebner.invariants_enabled() = false`.
"""
macro invariant(arg)
    expr = quote
        if $(@__MODULE__).invariants_enabled()
            @assert $arg
        else
            nothing
        end
    end
    esc(expr)
end

###
# DANGER # DANGER # DANGER #

"""
    unsafe_unreachable() --> Nothing

Invokes undefined behavior in LLVM.

The compiler may assume that this code is never reached during normal program
execution, and the program may (or may not) be optimized accordingly.

!!! danger
    Only use when able to prove that this is never called during program execution.

## Refs.

    - https://llvm.org/docs/LangRef.html#unreachable-instruction
    - https://llvm.org/docs/LangRef.html#llvm-assume-intrinsic
"""
unsafe_unreachable() = Base.llvmcall("unreachable", Cvoid, Tuple{})

"""
    unsafe_assume(condition) --> Nothing

May convince the compiler that the `condition` holds.

!!! danger
    Only use when able to prove that the condition always holds.
"""
function unsafe_assume(condition)
    # The idea is taken from UnsafeAssume.jl
    # https://gitlab.com/nsajko/UnsafeAssume.jl
    condition || unsafe_unreachable()
    nothing
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

### 
# Monomial hashtable.

# Some monomial implementations are mutable and some are not. To
# maintain generic code that will work for both, we usually write
#   m3 = monom_product!(m3, m1, m2). 
# If a mutable implementation is used, m3 would be overwritten inside
# monom_product!. Otherwise, monom_product! would return a new immutable object
# that is then assigned to m3. That allows us to write more or less
# independently of the monomial implementation.

# Hash of a monomial in the hashtable
const MonomHash = UInt32

# The idenfifier of a monomial. This idenfifier is guaranteed to be unique
# within a particular hashtable. This allows one to use this idenfifier when
# working with monomials
const MonomId = Int32

# Division mask of a monomial
const DivisionMask = UInt32

# Hashtable implements open addressing with linear scan.
mutable struct MonomialHashtable{
    M <: Monom,
    Ord <: AbstractMonomialOrdering,
    V <: AbstractVector{MonomHash}
}
    #= Data =#
    monoms::Vector{M}
    hashtable::Vector{MonomId}
    labels::Vector{Int32}
    hashvals::Vector{MonomHash}
    divmasks::Vector{DivisionMask}

    hash_vector::V

    #= Ring information =#
    nvars::Int
    ord::Ord

    #= Monom divisibility =#
    use_divmask::Bool
    divmask_strategy::Symbol
    divmap::Vector{DivisionMask}
    ndivvars::Int
    ndivbits::Int

    # Hashtable sizes 
    size::Int
    load::Int
    offset::Int

    # If the hashtable is frozen, modification is not allowed
    frozen::Bool
end

###
# Initialization

hashtable_resize_threshold() = 0.4
hashtable_needs_resize(size, load, added) = (load + added) / size > hashtable_resize_threshold()

const _DIVMASK_STRATEGY_MANY_VARIABLES = Ref(:first_variables)
@assert _DIVMASK_STRATEGY_MANY_VARIABLES[] in [:first_variables, :compact_variables]

function hashtable_initialize(
    ring::PolyRing{Ord},
    rng::AbstractRNG,
    MonomT::T;
    use_divmask=true
) where {Ord <: AbstractMonomialOrdering, T}
    initial_size = 2^10

    hashtable = zeros(MonomId, initial_size)

    # The table is filled to no more than 50% at any time so there is no need to
    # allocate the full storage
    half_size = div(initial_size, 2)
    @assert half_size > 0
    monoms = Vector{MonomT}(undef, half_size)
    labels = Vector{Int32}(undef, half_size)
    hashvals = Vector{MonomHash}(undef, half_size)
    divmasks = Vector{DivisionMask}(undef, half_size)

    nvars = ring.nvars
    ord = ring.ord

    hash_vector = monom_construct_hash_vector(rng, MonomT, nvars)

    load = 1
    @invariant initial_size > 1
    size = initial_size

    # Exponents array starts from index 2,
    # We store buffer array at index 1.
    offset = 2

    # Initialize fast divisibility parameters.
    strategy = :first_variables
    nbits = 8 * sizeof(DivisionMask)
    bits_per_var = div(nbits, nvars)
    bits_per_var = max(bits_per_var, 1)
    ndivvars = min(nvars, nbits)
    divmap = zeros(DivisionMask, ndivvars * bits_per_var)
    if nvars <= nbits
        strategy = :first_variables
    else
        strategy = _DIVMASK_STRATEGY_MANY_VARIABLES[]
    end

    # first stored exponent used as buffer lately
    monoms[1] = monom_construct_const(MonomT, nvars)

    MonomialHashtable(
        monoms,
        hashtable,
        labels,
        hashvals,
        divmasks,
        hash_vector,
        nvars,
        ord,
        use_divmask,
        strategy,
        divmap,
        ndivvars,
        bits_per_var,
        size,
        load,
        offset,
        false
    )
end

function hashtable_initialize_secondary(ht::MonomialHashtable{M}) where {M <: Monom}
    # 2^6 seems to be the best out of 2^5, 2^6, 2^7
    initial_size = 2^6
    @invariant initial_size > 1

    hashtable = zeros(MonomId, initial_size)

    half_size = div(initial_size, 2)
    monoms = Vector{M}(undef, half_size)
    labels = Vector{Int32}(undef, half_size)
    hashvals = Vector{MonomHash}(undef, half_size)
    divmasks = Vector{DivisionMask}(undef, half_size)

    # preserve ring info
    nvars = ht.nvars
    ord = ht.ord

    # preserve division info
    divmap = ht.divmap
    ndivbits = ht.ndivbits
    ndivvars = ht.ndivvars

    # preserve hash_vector
    hash_vector = ht.hash_vector

    load = 1
    size = initial_size
    offset = 2

    monoms[1] = monom_construct_const(M, nvars)

    MonomialHashtable(
        monoms,
        hashtable,
        labels,
        hashvals,
        divmasks,
        hash_vector,
        nvars,
        ord,
        ht.use_divmask,
        ht.divmask_strategy,
        divmap,
        ndivvars,
        ndivbits,
        size,
        load,
        offset,
        false
    )
end

function hashtable_reinitialize!(ht::MonomialHashtable{M}) where {M}
    @invariant !ht.frozen

    initial_size = 2^6
    @invariant initial_size > 1

    # Reinitialize counters
    ht.load = 1
    ht.offset = 2
    ht.size = initial_size

    resize!(ht.hashtable, ht.size)

    half_size = div(ht.size, 2)
    resize!(ht.monoms, half_size)
    resize!(ht.labels, half_size)
    resize!(ht.hashvals, half_size)
    resize!(ht.divmasks, half_size)

    hashtable = ht.hashtable
    @inbounds for i in 1:(ht.size)
        hashtable[i] = zero(MonomId)
    end

    ht.monoms[1] = monom_construct_const(M, ht.nvars)

    nothing
end

function hashtable_resize_if_needed!(ht::MonomialHashtable, added::Int)
    newsize = ht.size
    while hashtable_needs_resize(newsize, ht.load, added)
        newsize *= 2
    end
    newsize == ht.size && return nothing

    @invariant !ht.frozen
    @invariant ispow2(newsize)

    ht.size = newsize
    resize!(ht.hashtable, ht.size)

    half_size = div(ht.size, 2)
    @assert half_size >= ht.load
    resize!(ht.monoms, half_size)
    resize!(ht.labels, half_size)
    resize!(ht.hashvals, half_size)
    resize!(ht.divmasks, half_size)

    @inbounds for i in 1:(ht.size)
        ht.hashtable[i] = zero(MonomId)
    end

    mod = MonomHash(ht.size - 1)

    @inbounds for i in (ht.offset):(ht.load)
        # hash for this elem is already computed
        he = ht.hashvals[i]
        hidx = he
        for j in MonomHash(0):MonomHash(ht.size)
            hidx = hashtable_next_lookup_index(he, j, mod)
            !iszero(ht.hashtable[hidx]) && continue
            ht.hashtable[hidx] = i
            break
        end
    end
    nothing
end

###
# Insertion of monomials

# Must be within 1 <= ... <= mod+1
function hashtable_next_lookup_index(h::MonomHash, j::MonomHash, mod::MonomHash)
    ((h + j) & mod) + MonomHash(1)
end

function hashtable_is_hash_collision(ht::MonomialHashtable, vidx, e, he)
    @inbounds ht.hashvals[vidx] != he && return true
    @inbounds !monom_is_equal(ht.monoms[vidx], e) && return true
    false
end

function hashtable_insert!(ht::MonomialHashtable{M}, e::M) where {M <: Monom}
    # Optimizing for the case when the monomial is already in the table.
    # All of the functions in the main code path are inlined.
    @invariant ispow2(ht.size) && ht.size > 1

    he = monom_hash(e, ht.hash_vector)

    hsize = ht.size
    mod = (hsize - 1) % MonomHash
    hidx = hashtable_next_lookup_index(he, 0 % MonomHash, mod)
    @inbounds vidx = ht.hashtable[hidx]

    hit = !iszero(vidx)
    @inbounds if hit && !hashtable_is_hash_collision(ht, vidx, e, he)
        # Hit!
        return vidx
    end

    # Miss or collision
    i = 1 % MonomHash
    mhhsize = hsize % MonomHash
    @inbounds while hit && i < mhhsize
        hidx = hashtable_next_lookup_index(he, i, mod)
        vidx = ht.hashtable[hidx]

        iszero(vidx) && break

        if hashtable_is_hash_collision(ht, vidx, e, he)
            i += (1 % MonomHash)
            continue
        end

        # already present in hashtable
        return vidx
    end

    @invariant !ht.frozen

    # add monomial to hashtable
    vidx = (ht.load + 1) % MonomId
    @invariant vidx <= length(ht.monoms)
    @inbounds ht.hashtable[hidx] = vidx
    @inbounds ht.monoms[vidx] = monom_copy(e)
    divmask = monom_create_divmask(
        e,
        DivisionMask,
        ht.ndivvars,
        ht.divmap,
        ht.ndivbits,
        ht.divmask_strategy
    )
    @inbounds ht.labels[vidx] = NON_PIVOT_COLUMN
    @inbounds ht.hashvals[vidx] = he
    @inbounds ht.divmasks[vidx] = divmask

    ht.load += 1

    return vidx
end

###
# Division masks

function divmask_is_probably_divisible(d1::DivisionMask, d2::DivisionMask)
    iszero(~d1 & d2)
end

function hashtable_fill_divmasks!(ht::MonomialHashtable)
    @invariant !ht.frozen

    ndivvars = ht.ndivvars

    min_exp = Vector{UInt64}(undef, ndivvars)
    max_exp = Vector{UInt64}(undef, ndivvars)

    e = Vector{UInt64}(undef, ht.nvars)
    monom_to_vector!(e, ht.monoms[ht.offset])

    @inbounds for i in 1:ndivvars
        min_exp[i] = e[i]
        max_exp[i] = e[i]
    end

    @inbounds for i in (ht.offset):(ht.load)
        monom_to_vector!(e, ht.monoms[i])
        for j in 1:ndivvars
            if e[j] > max_exp[j]
                max_exp[j] = e[j]
                continue
            end
            if e[j] < min_exp[j]
                min_exp[j] = e[j]
            end
        end
    end

    if ht.divmask_strategy === :first_variables
        # Available bits >= variables
        ctr = 1
        steps = UInt32(0)
        @inbounds for i in 1:ndivvars
            steps = div(max_exp[i] - min_exp[i], UInt32(ht.ndivbits))
            (iszero(steps)) && (steps += UInt32(1))
            for j in 1:(ht.ndivbits)
                ht.divmap[ctr] = steps
                steps += UInt32(1)
                ctr += 1
            end
        end
        # ht.divmap = [mod(i, ht.ndivbits)+1 for i in 0:length(ht.divmap)-1]
    else
        # Available bits < variables.
        # Pack variables tighlty.
        vars_per_bit = div(ht.nvars, 8 * sizeof(DivisionMask))
        vars_covered = vars_per_bit * 8 * sizeof(DivisionMask)
        if vars_covered != ht.nvars
            @invariant vars_covered < ht.nvars
            vars_per_bit += 1
        end
        @invariant vars_per_bit > 1
        @invariant ht.ndivbits == 1
        @invariant ndivvars == length(ht.divmap)
        ctr = 1
        @inbounds for i in 1:ndivvars
            if ht.nvars - ctr + 1 <= (ndivvars - i + 1) * (vars_per_bit - 1)
                vars_per_bit -= 1
            end
            ht.divmap[i] = vars_per_bit
            ctr += vars_per_bit
        end
        @invariant sum(ht.divmap) == ht.nvars
    end

    @inbounds for vidx in (ht.offset):(ht.load)
        divmask = monom_create_divmask(
            ht.monoms[vidx],
            DivisionMask,
            ht.ndivvars,
            ht.divmap,
            ht.ndivbits,
            ht.divmask_strategy
        )
        ht.labels[vidx] = NON_PIVOT_COLUMN
        ht.divmasks[vidx] = divmask
    end

    nothing
end

###
# Monomial arithmetic

function hashtable_monom_is_divisible(h1::MonomId, h2::MonomId, ht::MonomialHashtable)
    @inbounds if ht.use_divmask
        if !divmask_is_probably_divisible(ht.divmasks[h1], ht.divmasks[h2])
            return false
        end
    end
    @inbounds e1 = ht.monoms[h1]
    @inbounds e2 = ht.monoms[h2]
    monom_is_divisible(e1, e2)
end

function hashtable_get_lcm!(
    he1::MonomId,
    he2::MonomId,
    ht1::MonomialHashtable{M},
    ht2::MonomialHashtable{M}
) where {M}
    @inbounds e1 = ht1.monoms[he1]
    @inbounds e2 = ht1.monoms[he2]
    @inbounds etmp = ht1.monoms[1]

    etmp = monom_lcm!(etmp, e1, e2)

    hashtable_insert!(ht2, etmp)
end

###

# Inserts a multiple of the polynomial into symbolic hashtable.
# Writes the resulting monomial identifiers to the given row.
function hashtable_insert_polynomial_multiple!(
    row::Vector{MonomId},
    mult_hash::MonomHash,
    mult::M,
    poly::Vector{MonomId},
    ht::MonomialHashtable{M},
    symbol_ht::MonomialHashtable{M}
) where {M <: Monom}
    @invariant ispow2(ht.size) && ht.size > 1
    @invariant ispow2(symbol_ht.size) && symbol_ht.size > 1
    @invariant length(row) == length(poly)

    iszero(length(poly)) && return row

    ssize = symbol_ht.size % MonomHash
    mod = (symbol_ht.size - 1) % MonomHash
    @inbounds buf = symbol_ht.monoms[1]

    # Iterate over monomials of the given polynomial, multiply them by a
    # monomial multiple, and insert them into symbolic hashtable. 
    # We use the fact that the hash function is linear.
    #
    # It is often the case that the multiple of the leading monomial is already
    # in the symbolic hashtable. In this case, skip it.
    @inbounds for j in 1:length(poly)
        oldmonom = ht.monoms[poly[j]]
        newmonom = monom_product!(buf, mult, oldmonom)

        oldhash = ht.hashvals[poly[j]]
        newhash = mult_hash + oldhash

        hidx = hashtable_next_lookup_index(newhash, 0 % MonomHash, mod)
        vidx = symbol_ht.hashtable[hidx]

        hit = !iszero(vidx)
        if hit && !hashtable_is_hash_collision(symbol_ht, vidx, newmonom, newhash)
            # Hit, go to next monomial.
            row[j] = vidx
            continue
        end

        # Miss or collision.
        i = 1 % MonomHash
        while hit && i <= ssize
            hidx = hashtable_next_lookup_index(newhash, i, mod)
            vidx = symbol_ht.hashtable[hidx]

            # Found a free bucket.
            hit = !iszero(vidx)
            iszero(vidx) && break

            if hashtable_is_hash_collision(symbol_ht, vidx, newmonom, newhash)
                i += (1 % MonomHash)
                continue
            end

            # Hit, go to next monomial.
            row[j] = vidx
            break
        end
        hit && continue
        # Miss! Add monomial multiple to the hash table.

        @invariant !symbol_ht.frozen

        vidx = (symbol_ht.load + 1) % MonomId
        @invariant vidx <= length(symbol_ht.monoms)
        symbol_ht.monoms[vidx] = monom_copy(newmonom)
        symbol_ht.hashtable[hidx] = vidx
        divmask = monom_create_divmask(
            newmonom,
            DivisionMask,
            symbol_ht.ndivvars,
            symbol_ht.divmap,
            symbol_ht.ndivbits,
            symbol_ht.divmask_strategy
        )
        @inbounds symbol_ht.labels[vidx] = NON_PIVOT_COLUMN
        @inbounds symbol_ht.hashvals[vidx] = newhash
        @inbounds symbol_ht.divmasks[vidx] = divmask

        row[j] = vidx
        symbol_ht.load += 1
    end

    row
end

# Activate the environment and add all required packages
import Pkg
include("generate/utils.jl")
julia_pkg_preamble("$(@__DIR__)")

# Load the packages
using AbstractAlgebra
using ArgParse
using Base.Threads
using CpuId, Logging, Pkg, Printf
using Distributed
using Dates
using Groebner
using ProgressMeter, PrettyTables
using NaturalSort

# Load the definitions of benchmark systems
include("benchmark_systems.jl")

# Load the code to generate benchmarks for different software
include("generate/benchmark_generators.jl")

# Load the code to compute the certificate of a groebner basis
include("generate/basis_certificate.jl")

# Set up the logger
global_logger(Logging.ConsoleLogger(stdout, Logging.Info))

# Set the properties of progress bars
const _progressbar_color = :light_green
const _progressbar_value_color = :light_green
progressbar_enabled() = Logging.Info <= Logging.min_enabled_level(current_logger()) < Logging.Warn

const _available_backends = ["groebner", "singular", "maplefgb", "mgb", "msolve", "openf4"]

const _skip_singular = false
const _skip_openf4 = false

# Parses command-line arguments
#! format: off
function parse_commandline()
    s = ArgParseSettings()
    @add_arg_table s begin
        "backend"
            help = """
            The backend to benchmark.
            Possible options are:
            - groebner
            - learn_apply
            - singular
            - maplefgb
            - mgb
            - msolve
            - openf4
            - ALL"""
            arg_type = String
            required = true
        "--lopenf4"
            help = """
            Required if openf4 is the backend. 
            Must point to the location where openf4 library is installed."""
            arg_type = String
            default = ""
            required = false
        "--bmaple"
            help = """
            If maple is the backend, specifies the location of the maple binary.
            """
            arg_type = String
            default = "maple"
            required = false
        "--bmsolve"
            help = """
            If msolve is the backend, specifies the location of the msolve binary.
            """
            arg_type = String
            default = "msolve"
            required = false
        "--suite"
            help = """
            The index of the benchmark suite.
            Possible options are:
            - 1: for benchmarks over integers modulo a prime
            - 2: for benchmarks over integers modulo a small prime
            - 3: for benchmarks over the rationals"""
            arg_type = Int
            default = 1
        "--validate"
            help = """
            Validate the output bases against the correct ones.
            This will result in a huge slowdown for some of the backends.
                
            Possible options are:
            - `yes`: validate results
            - `no`: do not validate results
            - `update`: update the validation certificates"""
            arg_type = String
            default = "no"
        "--nruns"
            help = "Number of times to run the benchmark."
            arg_type = Int
            default = 1
        "--timeout"
            help = "Timeout, s."
            arg_type = Int
            default = 60
        "--nworkers"
            help = "The number of worker processes."
            arg_type = Int
            default = 4
    end

    parse_args(s)
end
#! format: on

function generate_benchmark_file(backend, name, system, dir, validate, nruns, time_filename, args)
    if backend == "groebner"
        benchmark_source = generate_benchmark_source_for_groebner(
            name,
            system,
            dir,
            validate,
            nruns,
            time_filename
        )
        fd = open("$dir/$name.jl", "w")
        println(fd, benchmark_source)
        close(fd)
    elseif backend == "learn_apply"
        benchmark_source = generate_benchmark_source_for_groebner(
            name,
            system,
            dir,
            validate,
            nruns,
            time_filename
        )
        fd = open("$dir/$name.jl", "w")
        println(fd, benchmark_source)
        close(fd)
    elseif backend == "singular"
        benchmark_source = generate_benchmark_source_for_singular(
            name,
            system,
            dir,
            validate,
            nruns,
            time_filename
        )
        fd = open("$dir/$name.jl", "w")
        println(fd, benchmark_source)
        close(fd)
    elseif backend == "maplefgb"
        benchmark_source = generate_benchmark_source_for_maplefgb(
            name,
            system,
            dir,
            validate,
            nruns,
            time_filename
        )
        fd = open("$dir/$name.mpl", "w")
        println(fd, benchmark_source)
        close(fd)
    elseif backend == "mgb"
        benchmark_source =
            generate_benchmark_source_for_mgb(name, system, dir, validate, nruns, time_filename)
        fd = open("$dir/$name.mpl", "w")
        println(fd, benchmark_source)
        close(fd)
    elseif backend == "msolve"
        benchmark_source =
            generate_benchmark_source_for_msolve(name, system, dir, validate, nruns, time_filename)
        fd = open("$dir/$name.in", "w")
        println(fd, benchmark_source)
        close(fd)
    elseif backend == "openf4"
        benchmark_source =
            generate_benchmark_source_for_openf4(name, system, dir, validate, nruns, time_filename)
        fd = open("$dir/$name.cpp", "w")
        println(fd, benchmark_source)
        close(fd)
    end
end

function get_command_to_run_benchmark(
    backend,
    problem_name,
    problem_num_runs,
    problem_set_id,
    validate,
    args
)
    if backend == "groebner"
        return Cmd([
            "julia",
            (@__DIR__) * "/generate/groebner/run_in_groebner.jl",
            "$problem_name",
            "$problem_num_runs",
            "$problem_set_id",
            "$validate"
        ])
    elseif backend == "learn_apply"
        return Cmd([
            "julia",
            (@__DIR__) * "/generate/learn_apply/run_in_learn_apply.jl",
            "$problem_name",
            "$problem_num_runs",
            "$problem_set_id",
            "$validate"
        ])
    elseif backend == "singular"
        return Cmd([
            "julia",
            (@__DIR__) * "/generate/singular/run_in_singular.jl",
            "$problem_name",
            "$problem_num_runs",
            "$problem_set_id",
            "$validate"
        ])
    elseif backend == "maplefgb" || backend == "mgb"
        return Cmd([
            "julia",
            (@__DIR__) * "/generate/maple/run_in_maple.jl",
            "$problem_name",
            "$problem_num_runs",
            "$problem_set_id",
            "$validate",
            "$(args["bmaple"])",
            "$backend"
        ])
    elseif backend == "msolve"
        return Cmd([
            "julia",
            (@__DIR__) * "/generate/msolve/run_in_msolve.jl",
            "$problem_name",
            "$problem_num_runs",
            "$problem_set_id",
            "$validate",
            "$(args["bmsolve"])"
        ])
    elseif backend == "openf4"
        return Cmd([
            "julia",
            (@__DIR__) * "/generate/openf4/run_in_openf4.jl",
            "$problem_name",
            "$problem_num_runs",
            "$problem_set_id",
            "$(args["lopenf4"])"
        ])
    end
end

function populate_benchmarks(args; regenerate=true)
    backend = args["backend"]
    benchmark_id = args["suite"]
    nruns = args["nruns"]
    validate = args["validate"] in ["yes", "update"]
    benchmark = get_benchmark_suite(benchmark_id)
    benchmark_name, systems = benchmark.name, benchmark.systems
    benchmark_dir = (@__DIR__) * "/" * get_benchmark_dir(backend, benchmark_id)
    dir_present = isdir(benchmark_dir)
    if !dir_present || regenerate
        @info "Re-generating the folder with benchmarks"
        try
            if isdir(benchmark_dir)
                rm(benchmark_dir, recursive=true, force=true)
            end
        catch err
            @info "Something went wrong when deleting the directory with benchmarks"
            showerror(stdout, err)
            println(stdout)
        end
    end
    prog = Progress(
        length(systems),
        "Generating benchmark files: $benchmark_name",
        # spinner = true,
        dt=0.1,
        enabled=progressbar_enabled(),
        color=_progressbar_color
    )
    for bmark in systems
        next!(prog) # , spinner = "⌜⌝⌟⌞")
        system_name = bmark[1]
        system = bmark[2]
        @debug "Generating $system_name"
        benchmark_system_dir = "$benchmark_dir/$system_name/"
        mkpath(benchmark_system_dir)
        time_filename = "$benchmark_dir/$system_name/$(timings_filename())"
        generate_benchmark_file(
            backend,
            system_name,
            system,
            benchmark_system_dir,
            validate,
            nruns,
            time_filename,
            args
        )
    end
    finish!(prog)
    true
end

function run_benchmarks(args)
    timestamp = time_ns()
    timeout = args["timeout"]
    @assert timeout > 0
    backend = args["backend"]
    nworkers = args["nworkers"]
    validate = args["validate"] in ["yes", "update"]
    @assert nworkers > 0
    nruns = args["nruns"]
    @assert nruns > 0
    benchmark_id = args["suite"]

    benchmark = get_benchmark_suite(benchmark_id)
    benchmark_name = benchmark.name

    benchmark_dir = (@__DIR__) * "/" * get_benchmark_dir(backend, benchmark_id)
    systems_to_benchmark = first(walkdir(benchmark_dir))[2]
    indices_to_benchmark = collect(1:length(systems_to_benchmark))

    added_timeout_time = 10
    @info """
    Benchmarking $backend.
    Benchmark suite: $benchmark_name
    Number of benchmark systems: $(length(systems_to_benchmark))
    Validate result: $(validate)
    Workers: $(nworkers)
    Timeout: $timeout + $added_timeout_time seconds
    Aggregate results over $nruns runs"""
    @info """
    Benchmark systems:
    $systems_to_benchmark"""

    timeout = timeout + added_timeout_time  # add 10 seconds for compilation time :)
    seconds_passed(from_t) = round((time_ns() - from_t) / 1e9, digits=2)

    queue = [(problem_id=problem,) for problem in indices_to_benchmark]
    processes = []
    running = []
    errored = []
    timedout = []

    global_start_time = time_ns()

    generate_showvalues(processes) =
        () -> [
            (
                :Active,
                join(
                    map(
                        proc -> string(proc.problem_name),
                        filter(proc -> process_running(proc.julia_process), processes)
                    ),
                    ", "
                )
            ),
            (
                :Time,
                "$(round(seconds_passed(global_start_time); digits=0)) / $(round(seconds_passed(global_start_time) + timeout - seconds_passed(maximum(proc -> proc.start_time, filter(proc -> process_running(proc.julia_process), processes); init=0)); digits=0)) s"
            )
        ]

    prog = Progress(
        length(queue),
        "Running benchmarks",
        # spinner = true,
        dt=0.3,
        enabled=progressbar_enabled(),
        color=_progressbar_color
    )
    while true
        if !isempty(queue) && length(running) < nworkers
            task = pop!(queue)
            problem_id = task.problem_id
            problem_name = systems_to_benchmark[problem_id]
            log_filename = generic_filename("logs")
            log_file = open("$benchmark_dir/$problem_name/$log_filename", "w")
            @debug "Running $problem_name. Logs: $benchmark_dir/$problem_name/$log_filename"
            cmd = get_command_to_run_benchmark(
                backend,
                problem_name,
                nruns,
                benchmark_id,
                validate,
                args
            )
            cmd = Cmd(cmd, ignorestatus=true, detach=false, env=copy(ENV))
            proc = run(pipeline(cmd, stdout=log_file, stderr=log_file), wait=false)
            push!(
                processes,
                (
                    problem_id=problem_id,
                    problem_name=problem_name,
                    julia_process=proc,
                    start_time=time_ns(),
                    logfile=log_file
                )
            )
            push!(running, processes[end])
            next!(
                prog,
                showvalues = generate_showvalues(running),
                step       = 0,
                valuecolor = _progressbar_value_color
                # spinner = "⌜⌝⌟⌞",
            )
        end

        sleep(0.2)
        to_be_removed = []
        for i in 1:length(running)
            proc = running[i]
            if process_exited(proc.julia_process)
                push!(to_be_removed, i)
                if proc.julia_process.exitcode != 0
                    push!(errored, proc)
                end
                close(proc.logfile)
                # close(proc.errfile)
                start_time = proc.start_time
                next!(
                    prog,
                    showvalues = generate_showvalues(running),
                    valuecolor = _progressbar_value_color
                )
                @debug "Yielded $(proc.problem_name) after $(seconds_passed(start_time)) seconds"
            end
            if process_running(proc.julia_process)
                start_time = proc.start_time
                if seconds_passed(start_time) > timeout
                    push!(to_be_removed, i)
                    kill(proc.julia_process, Base.SIGKILL)
                    close(proc.logfile)
                    # close(proc.errfile)
                    push!(timedout, proc)
                    next!(
                        prog,
                        showvalues = generate_showvalues(running),
                        valuecolor = _progressbar_value_color
                    )
                    @debug "Timed-out $(proc.problem_name) after $(seconds_passed(start_time)) seconds"
                end
            end
        end
        deleteat!(running, to_be_removed)
        next!(
            prog,
            showvalues = generate_showvalues(running),
            step       = 0,
            valuecolor = _progressbar_value_color
            # spinner = "⌜⌝⌟⌞",
        )
        if isempty(queue) && isempty(running)
            @debug "All benchmarks finished"
            break
        end
    end
    finish!(prog)

    if !isempty(timedout)
        printstyled("(!) Timed-out:\n", color=:light_yellow)
        for proc in timedout
            print("$(proc.problem_name), ")
        end
        println()
    end

    if !isempty(errored)
        printstyled("(!) Maybe errored:\n", color=:light_red)
        for proc in errored
            print("$(proc.problem_name), ")
        end
        println()
    end

    println()
    println("Benchmarking finished in $(round((time_ns() - timestamp) / 1e9, digits=2)) seconds.")
    printstyled("Benchmark results", color=:light_green)
    println(" are written to $benchmark_dir")

    systems_to_benchmark
end

function validate_results(args, problem_names)
    println()
    backend = args["backend"]
    if !(args["validate"] in ["yes", "update"])
        @info "Skipping result validation for $backend"
        return nothing
    end

    update_certificates = args["validate"] == "update"

    benchmark_id = args["suite"]
    benchmark_dir = (@__DIR__) * "/" * get_benchmark_dir(backend, benchmark_id)
    validate_dir = (@__DIR__) * "/" * get_validate_dir(benchmark_id)

    @info """Validating results for $backend. May take some time.
    Directory with the certificates is $validate_dir
    """

    if update_certificates
        @info "Re-generating the folder with certificates"
        try
            if isdir(validate_dir)
                rm(validate_dir, recursive=true, force=true)
            end
        catch err
            @info "Something went wrong when deleting the directory with certificates"
            showerror(stdout, err)
            println(stdout)
        end
    end

    for problem_name in problem_names
        print("$problem_name:")
        problem_validate_path = "$validate_dir/$problem_name/$(certificate_filename())"
        problem_result_path = "$benchmark_dir/$problem_name/$(output_filename())"
        true_result_exists, true_result = false, nothing
        result_exists, result = false, nothing
        try
            result_file = open(problem_result_path, "r")
            result = read(result_file, String)
            result_exists = true
            if isempty(string(strip(result, [' ', '\n', '\r'])))
                result_exists = false
            end
        catch e
            @debug "Cannot collect result data for $name"
        end
        if !result_exists
            printstyled("\tMISSING RESULT\n", color=:light_yellow)
            continue
        end
        try
            true_result_file = open(problem_validate_path, "r")
            true_result = read(true_result_file, String)
            true_result = standardize_certificate(true_result)
            true_result_exists = true
        catch e
            @debug "Cannot collect validation data for $name"
            printstyled("\tMISSING CERTIFICATE...", color=:light_yellow)
        end
        # At this point, the recently computed basis is stored in `result`
        @assert result_exists
        success, result_validation_certificate = compute_basis_validation_certificate(result)
        if !success
            @warn "Bad file encountered at $problem_result_path. Skipping"
            continue
        end
        if update_certificates || !true_result_exists
            mkpath("$validate_dir/$problem_name/")
            true_result_file = open(problem_validate_path, "w")
            println(true_result_file, result_validation_certificate)
            printstyled("\tUPDATED\n", color=:light_green)
            continue
        end
        @assert result_exists && true_result_exists
        @assert is_certificate_standardized(result_validation_certificate)
        @assert is_certificate_standardized(true_result)
        if result_validation_certificate != true_result
            printstyled("\tWRONG\n", color=:light_red)
            println("True certificate:\n$true_result")
            println("Current certificate:\n$result_validation_certificate")
        else
            printstyled("\tOK\n", color=:light_green)
        end
    end

    nothing
end

function collect_timings(args, names)
    backend = args["backend"]
    benchmark_id = args["suite"]
    benchmark_dir = (@__DIR__) * "/" * get_benchmark_dir(backend, benchmark_id)
    benchmark_name = get_benchmark_suite(benchmark_id).name

    if backend == "learn_apply"
        targets = [
            :total_time_F4,
            :total_time_learn,
            :total_time_apply,
            :total_time_apply_4x,
            :total_time_apply_8x
        ]
    else
        targets = [:total_time]
    end
    @assert length(targets) > 0
    println()
    @info """
    Collecting results for $backend. Statistics of interest:
    \t$(join(map(string, targets), "\n\t"))
    """

    cannot_collect = []
    names = sort(names, lt=NaturalSort.natural)

    # Collect timings and data from directory BENCHMARK_RESULTS.
    runtime = Dict()
    for name in names
        @debug "==== Reading $name"
        runtime[name] = Dict()
        timingsfn = timings_filename()
        timings_file = nothing
        #####
        try
            @debug "==== Opening $benchmark_dir/$name/$timingsfn"
            timings_file = open("$benchmark_dir/$name/$timingsfn", "r")
        catch e
            @debug "Cannot collect timings for $name"
            push!(cannot_collect, (name,))
            continue
        end
        lines = readlines(timings_file)
        if isempty(lines)
            @debug "Cannot collect timings for $name"
            push!(cannot_collect, (name,))
            continue
        end
        @assert lines[1] == name
        for line in lines[2:end]
            k, v = split(line, ", ")
            runtime[name][Symbol(k)] = parse(Float64, v)
        end
        close(timings_file)
        #####
        datafn = generic_filename("data")
        data_file = nothing
        try
            @debug "==== Opening $benchmark_dir/$name/$datafn"
            data_file = open("$benchmark_dir/$name/$datafn", "r")
        catch e
            @debug "Cannot collect data for $name"
            continue
        end
        lines = readlines(data_file)
        if isempty(lines)
            @debug "Cannot collect data for $name"
            continue
        end
        @assert lines[1] == name
        for line in lines[2:end]
            k, v = map(strip, split(line, ","))
            runtime[name][Symbol(k)] = v
        end
        close(data_file)
    end

    if !isempty(cannot_collect)
        printstyled("(!) Cannot collect benchmark data for:\n", color=:light_yellow)
        for (name,) in cannot_collect
            print("$name, ")
        end
        println()
    end

    title = "Benchmark results, $backend"
    conf = set_pt_conf(tf=tf_markdown, alignment=:c)
    makecolname(target) = HUMAN_READABLE_CATEGORIES[target]
    columns = [makecolname(target) for target in targets]
    header = vcat("Model", map(string, columns))
    vec_of_vecs = Vector{Vector{Any}}()
    for name in names
        push!(vec_of_vecs, [name])
        for target in targets
            formatting_style = CATEGORY_FORMAT[target]
            if haskey(runtime, name) && haskey(runtime[name], target)
                push!(vec_of_vecs[end], formatting_style(runtime[name][target]))
            else
                push!(vec_of_vecs[end], "-")
            end
        end
    end

    table = Array{Any, 2}(undef, length(vec_of_vecs), length(header))
    for i in 1:length(vec_of_vecs)
        for j in 1:length(vec_of_vecs[i])
            table[i, j] = vec_of_vecs[i][j]
        end
    end
    println()
    pretty_table_with_conf(
        conf,
        table;
        header=header,
        title=title,
        limit_printing=false,
        crop=:none
    )

    # Print the table to BENCHMARK_TABLE.
    resulting_md = ""
    resulting_md *= """
    ## Benchmark results

    $(now())

    Benchmarked backend: $backend

    Benchmark suite: $benchmark_name

    - Workers: $(args["nworkers"])
    - Timeout: $(args["timeout"]) s
    - Aggregated over: $(args["nruns"]) runs

    **All timings in seconds.**

    """

    columns = [makecolname(target) for target in targets]
    resulting_md *= "|Model|" * join(map(string, columns), "|") * "|\n"
    resulting_md *= "|:----|" * join(["---" for _ in columns], "|") * "|\n"
    for name in names
        model_data = runtime[name]
        resulting_md *= "|$name|"
        for target in targets
            if !haskey(model_data, target)
                resulting_md *= " - " * "|"
            else
                formatting_style = CATEGORY_FORMAT[target]
                resulting_md *= formatting_style(model_data[target]) * "|"
            end
        end
        resulting_md *= "\n"
    end

    resulting_md *= "\n*Benchmarking environment:*\n\n"
    resulting_md *= "* Total RAM (GiB): $(div(Sys.total_memory(), 2^30))\n"
    resulting_md *= "* Processor: $(cpubrand())\n"
    resulting_md *= "* Julia version: $(VERSION)\n\n"
    resulting_md *= "Versions of the dependencies:\n\n"

    deps = Pkg.dependencies()
    stid_info = deps[findfirst(x -> x.name == "Groebner", deps)]
    for (s, uid) in stid_info.dependencies
        if deps[uid].version !== nothing
            resulting_md *= "* $s : $(deps[uid].version)\n"
        end
    end

    table_filename =
        (@__DIR__) * "/$BENCHMARK_RESULTS/$backend/$(BENCHMARK_TABLE)_$(benchmark_id).md"
    open(table_filename, "w") do io
        write(io, resulting_md)
    end

    println()
    printstyled("Table with results", color=:light_green)
    println(" is written to $table_filename")

    return runtime
end

function collect_all_timings(args, runtimes, systems)
    benchmark_id = args["suite"]
    benchmark_name = get_benchmark_suite(benchmark_id).name

    targets = [:total_time]
    @assert length(targets) > 0

    backends = collect(keys(runtimes))
    backends = sort(backends, lt=NaturalSort.natural)
    systems = sort(systems, lt=NaturalSort.natural)

    println()
    @info """
    Collecting all results. Statistics of interest:
    \t$(join(map(string, targets), "\n\t"))
    Present backends:
    \t$(join(map(string, backends), "\n\t"))
    """

    _target = targets[1]
    formatting_style = CATEGORY_FORMAT[_target]
    conf = set_pt_conf(tf=tf_markdown, alignment=:c)
    title = "Benchmark results"
    header = vcat("System", backends)
    vec_of_vecs = Vector{Vector{Any}}()
    for name in systems
        row = [name]
        for backend in backends
            if haskey(runtimes[backend], name) && haskey(runtimes[backend][name], _target)
                push!(row, formatting_style(runtimes[backend][name][_target]))
            else
                push!(row, "-")
            end
        end
        push!(vec_of_vecs, row)
    end
    table = Array{Any, 2}(undef, length(vec_of_vecs), length(backends) + 1)
    for i in 1:length(vec_of_vecs)
        for j in 1:(length(backends) + 1)
            table[i, j] = vec_of_vecs[i][j]
        end
    end
    println()
    h1 = Highlighter(
        (data, i, j) ->
            j > 1 &&
            strip(data[i, j]) != "-" &&
            parse(Float64, data[i, j]) ==
            minimum(map(x -> parse(Float64, x), filter(x -> strip(x) != "-", data[i, 2:end]))),
        bold=true
    )
    pretty_table_with_conf(
        conf,
        table;
        header=header,
        title=title,
        limit_printing=false,
        highlighters=(h1,),
        crop=:none
    )
    println("All results are in seconds.")

    # Print the table to BENCHMARK_TABLE.
    resulting_md = ""
    resulting_md *= """
    ## Benchmark results

    $(now())

    Benchmarked backends: $backends

    Benchmark suite: $benchmark_name

    - Workers: $(args["nworkers"])
    - Timeout: $(args["timeout"]) s
    - Aggregated over: $(args["nruns"]) runs

    **All timings in seconds.**

    """

    makecolname(target) = HUMAN_READABLE_CATEGORIES[target]
    columns = backends
    resulting_md *= "|Model|" * join(map(string, columns), "|") * "|\n"
    resulting_md *= "|:----|" * join(["---" for _ in columns], "|") * "|\n"
    for name in systems
        resulting_md *= "|$name|"
        for backend in backends
            model_data = runtimes[backend][name]
            for target in targets
                if !haskey(model_data, target)
                    resulting_md *= " - " * "|"
                else
                    formatting_style = CATEGORY_FORMAT[target]
                    resulting_md *= formatting_style(model_data[target]) * "|"
                end
            end
        end
        resulting_md *= "\n"
    end

    resulting_md *= "\n*Benchmarking environment:*\n\n"
    resulting_md *= "* Total RAM (GiB): $(div(Sys.total_memory(), 2^30))\n"
    resulting_md *= "* Processor: $(cpubrand())\n"
    resulting_md *= "* Julia version: $(VERSION)\n\n"
    resulting_md *= "Versions of the dependencies:\n\n"

    deps = Pkg.dependencies()
    stid_info = deps[findfirst(x -> x.name == "Groebner", deps)]
    for (s, uid) in stid_info.dependencies
        if deps[uid].version !== nothing
            resulting_md *= "* $s : $(deps[uid].version)\n"
        end
    end

    table_filename = (@__DIR__) * "/$BENCHMARK_RESULTS/$(BENCHMARK_TABLE)_$(benchmark_id).md"
    open(table_filename, "w") do io
        write(io, resulting_md)
    end

    println()
    printstyled("Table with results", color=:light_green)
    println(" is written to $table_filename")
end

function check_args(args)
    backend = args["backend"]
    @assert backend in
            ("groebner", "singular", "maplefgb", "mgb", "openf4", "msolve", "learn_apply", "ALL")
    if backend == "openf4" && args["suite"] in [3, 7]
        throw("Running benchmarks over the rationals is not possible for openf4")
    end
    # if backend == "msolve" && args["suite"] in [3, 7] && args["validate"] != "no"
    #     throw(
    #         "Validating results for msolve over the rationals is not possible. Use command line option --validate=no"
    #     )
    # end
    if backend == "learn_apply" && args in [3, 7]
        throw("Cannot learn & apply over the rationals")
    end
end

function cleanup(names=nothing)
    # this is quite bad but fine :^)
    cmd1 = Cmd(`pkill msolve`, ignorestatus=true)
    cmd2 = Cmd(`pkill mserver`, ignorestatus=true)
    run(cmd1)
    run(cmd2)
    if !(names === nothing)
        for name in names
            cmd = Cmd(`pkill -f "$name"`, ignorestatus=true)
            run(cmd)
        end
    end
    nothing
end

function main()
    # Parse command line args
    args = parse_commandline()
    @debug "Command-line args:"
    for (arg, val) in args
        @debug "$arg  =>  $val"
    end

    println("Timestamp: $(now())")

    # Either benchmark all available backends or a single backend
    if args["backend"] == "ALL"
        @info "Benchmarking all available backends"
        runtimes = Dict()
        systems = []
        solved_problems = []
        for backend in _available_backends
            if _skip_singular && backend == "singular"
                continue
            end
            if _skip_openf4 && backend == "openf4"
                continue
            end
            args_ = copy(args)
            args_["backend"] = backend
            try
                check_args(args_)
                populate_benchmarks(args_)
                solved_problems = run_benchmarks(args_)
                validate_results(args_, solved_problems)
                runtime = collect_timings(args_, solved_problems)
                runtimes[backend] = runtime
                union!(systems, solved_problems)
            catch e
                printstyled("(!) ", color=:light_yellow)
                println("Cannot benchmark $backend")
            finally
                # cleanup(systems)
            end
        end
        collect_all_timings(args, runtimes, systems)
    else
        solved_problems = []
        try
            check_args(args)
            populate_benchmarks(args)
            solved_problems = run_benchmarks(args)
            validate_results(args, solved_problems)
            collect_timings(args, solved_problems)
        finally
            # cleanup(solved_problems)
        end
    end
end

main()

function generate_benchmark_source_for_groebner(name, system, dir, validate, nruns, time_filename)
    ring = parent(system[1])
    field = base_ring(ring)
    vars_repr = join(map(string, gens(ring)), ", ")
    field_repr = if iszero(characteristic(field))
        "QQ"
    else
        "GF($(characteristic(field)))"
    end
    vars_repr_quoted = map(s -> "$s", map(string, gens(ring)))
    ring_repr = """ring, ($vars_repr) = polynomial_ring(
        $field_repr, 
        $vars_repr_quoted, 
        internal_ordering=:degrevlex
    )"""
    system_repr = join(map(s -> "\t" * s, map(repr, system)), ",\n")
    system_repr = "system = [\n$system_repr\n]"
    buf = IOBuffer()
    println(buf, "# $name")
    println(buf, "#! format: off")
    println(buf, "using AbstractAlgebra, Groebner")
    println(buf, "")
    println(buf, ring_repr)
    println(buf, system_repr)
    String(take!(buf))
end

function generate_benchmark_source_for_singular(name, system, dir, validate, nruns, time_filename)
    generate_benchmark_source_for_groebner(name, system, dir, validate, nruns, time_filename)
end

function generate_benchmark_source_for_maplefgb(name, system, dir, validate, nruns, time_filename)
    ring = parent(system[1])
    field = base_ring(ring)
    buf = IOBuffer()
    println(buf, "# $name")
    println(buf, "with(Groebner):")
    println(buf, "with(PolynomialIdeals):")
    println(buf, "kernelopts(numcpus=1);")
    system_repr = replace(join(map(s -> "\t\t" * s, map(repr, system)), ",\n"), "//" => "/")
    vars_repr = join(map(string, gens(ring)), ", ")
    println(buf, "")
    println(buf, "runtime := 2^1000:")
    println(buf, "for i from 1 by 1 to 1 do")
    println(buf, "\tJ := [\n$system_repr\n\t]:")
    println(buf, "\tprint(\"Running $name\");")
    println(buf, "\tst := time[real]():")
    println(
        buf,
        "\tG := Groebner[Basis](J, tdeg($vars_repr), method=fgb, characteristic=$(characteristic(field))):"
    )
    println(buf, "\tprint(\"$name: \", time[real]() - st):")
    println(buf, "\truntime := min(runtime, time[real]() - st):")
    println(buf, "end do:")
    println(buf, "")
    println(buf, "timings_fn := \"$time_filename\":")
    println(buf, "FileTools[Text][WriteLine](timings_fn, \"$name\");")
    println(buf, "FileTools[Text][WriteLine](timings_fn, cat(\"total_time, \", String(runtime))):")
    if validate
        println(buf)
        output_fn = output_filename()
        println(buf, "output_fn := \"$dir/$output_fn\":")
        println(buf, "FileTools[Text][WriteLine](output_fn, \"$vars_repr\");")
        println(buf, "FileTools[Text][WriteLine](output_fn, \"$(characteristic(field))\");")
        println(
            buf,
            """
            for poly in G do
                FileTools[Text][WriteLine](output_fn, cat(String(poly), \",\")):
            end do:
            """
        )
    end
    String(take!(buf))
end

function generate_benchmark_source_for_mgb(name, system, dir, validate, nruns, time_filename)
    ring = parent(system[1])
    field = base_ring(ring)
    buf = IOBuffer()
    println(buf, "# $name")
    println(buf, "with(Groebner):")
    println(buf, "with(PolynomialIdeals):")
    println(buf, "kernelopts(numcpus=1);")
    system_repr = replace(join(map(s -> "\t\t" * s, map(repr, system)), ",\n"), "//" => "/")
    vars_repr = join(map(string, gens(ring)), ", ")
    println(buf, "")
    println(buf, "runtime := 2^1000:")
    println(buf, "for i from 1 by 1 to 1 do")
    println(buf, "\tJ := [\n$system_repr\n\t]:")
    println(buf, "\tprint(\"Running $name\");")
    println(buf, "\tst := time[real]():")
    println(buf, "\tG := libmgb:-gbasis($(characteristic(field)),0,[$vars_repr],J):")
    println(buf, "\tprint(\"$name: \", time[real]() - st):")
    println(buf, "\truntime := min(runtime, time[real]() - st):")
    println(buf, "end do:")
    println(buf, "")
    println(buf, "timings_fn := \"$time_filename\":")
    println(buf, "FileTools[Text][WriteLine](timings_fn, \"$name\");")
    println(buf, "FileTools[Text][WriteLine](timings_fn, cat(\"total_time, \", String(runtime))):")
    if validate
        println(buf)
        output_fn = output_filename()
        println(buf, "output_fn := \"$dir/$output_fn\":")
        println(buf, "FileTools[Text][WriteLine](output_fn, \"$vars_repr\");")
        println(buf, "FileTools[Text][WriteLine](output_fn, \"$(characteristic(field))\");")
        println(
            buf,
            """
            for poly in G do
                FileTools[Text][WriteLine](output_fn, cat(String(poly), \",\")):
            end do:
            """
        )
    end
    String(take!(buf))
end

function generate_benchmark_source_for_msolve(name, system, dir, validate, nruns, time_filename)
    ring = parent(system[1])
    field = base_ring(ring)
    vars_repr = join(map(string, gens(ring)), ", ")
    system_repr = replace(join(map(repr, system), ",\n"), "//" => "/")
    buf = IOBuffer()
    println(buf, "$vars_repr")
    println(buf, "$(characteristic(field))")
    println(buf, system_repr)
    String(take!(buf))
end

function generate_benchmark_source_for_openf4(name, system, dir, validate, nruns, time_filename)
    ring = parent(system[1])
    field = base_ring(ring)
    buf = IOBuffer()
    println(buf, "// $name")
    println(buf, "#include <iostream>")
    println(buf, "#include <fstream>")
    println(buf, "#include <string>")
    println(buf, "#include <vector>")
    println(buf, "#include <libopenf4.h>")
    println(
        buf,
        """
        using namespace std;

        int main (int argc, char **argv)
        {
        """
    )
    vars_repr = join(map(s -> "\tvariableName.push_back(\"$s\");", map(repr, gens(ring))), "\n")
    system_repr = join(map(s -> "\tpolynomialArray.emplace_back(\"$s\");", map(repr, system)), "\n")
    println(
        buf,
        """
        \tvector<string> polynomialArray;
        \tvector<string> variableName;

        $vars_repr
        $system_repr

        \tvector<string> basis = groebnerBasisF4($(characteristic(field)), $(length(gens(ring))), variableName, polynomialArray, 1, 0);

        \tstd::cout << \"The basis contains \" << basis.size() << \" elements.\" << std::endl;
        """
    )
    if validate
        vars_ = join(map(repr, gens(ring)), ", ")
        output_fn = output_filename()
        println(buf)
        println(
            buf,
            """
            \tofstream output;
            \toutput.open(\"$dir/$output_fn\");
            \toutput << \"$vars_\" << endl;
            \toutput << \"$(characteristic(field))\" << endl;
            \tfor (size_t i = 0; i < basis.size(); i++) {
            \t\toutput << basis[i] << \",\" << endl;
            \t}
            \toutput.close();
            """
        )
    end
    println(buf, "\treturn 0;")
    println(buf, "}")
    String(take!(buf))
end

using AbstractAlgebra, Groebner

function randpoly(x, d, coeffs=1:10)
    M = collect(monomials((sum(x)+1)^d))
    C = map(_ -> rand(coeffs), M)
    f = parent(x[1])(C, exponent_vector.(M, 1))
    f
end

function randsys(k, n, d, coeffs=1:10)
    R, x = polynomial_ring(k, ["x$i" for i in 1:n], internal_ordering=:degrevlex)
    [randpoly(x, d, coeffs) for _ in 1:n]
end

k = GF(2^30+3)
d = 2
for n in 2:12
    sys = randsys(k, n, d)
    println("n = $n:")
    @time gb = groebner(sys);
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Backend for `normalform`

# polynomials => polynomials
function normalform0(
    polynomials::AbstractVector,
    to_be_reduced::AbstractVector,
    options::KeywordArguments
)
    # TODO: this deepcopy is sad
    _options = deepcopy(options)
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    ring_tbr, monoms_tbr, coeffs_tbr, _ = io_convert_polynomials_to_ir(to_be_reduced, _options)
    monoms_reduced, coeffs_reduced =
        _normalform1(ring, monoms, coeffs, ring_tbr, monoms_tbr, coeffs_tbr, options)
    result =
        io_convert_ir_to_polynomials(ring, polynomials, monoms_reduced, coeffs_reduced, options)
    result
end

# (exponent vectors, coefficients) => (exponent vectors, coefficients)
function normalform1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I1}}},
    coeffs::Vector{Vector{C1}},
    ring_tbr::PolyRing,
    monoms_tbr::Vector{Vector{Vector{I2}}},
    coeffs_tbr::Vector{Vector{C2}},
    options::KeywordArguments
) where {I1 <: Integer, C1 <: Coeff, I2 <: Integer, C2 <: Coeff}
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    ring_tbr, monoms_tbr, coeffs_tbr = ir_ensure_valid(ring_tbr, monoms_tbr, coeffs_tbr)
    _normalform1(ring, monoms, coeffs, ring_tbr, monoms_tbr, coeffs_tbr, options)
end

function _normalform1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I1}}},
    coeffs::Vector{Vector{C1}},
    ring_tbr::PolyRing,
    monoms_tbr::Vector{Vector{Vector{I2}}},
    coeffs_tbr::Vector{Vector{C2}},
    options::KeywordArguments
) where {I1 <: Integer, C1 <: Coeff, I2 <: Integer, C2 <: Coeff}
    try
        params = AlgorithmParameters(ring, options)
        return __normalform1(ring, monoms, coeffs, ring_tbr, monoms_tbr, coeffs_tbr, params)
    catch err
        if isa(err, MonomialDegreeOverflow)
            _info_possible_overflow()
            params = AlgorithmParameters(ring, options; hint=:large_exponents)
            return __normalform1(ring, monoms, coeffs, ring_tbr, monoms_tbr, coeffs_tbr, params)
        else
            # Something bad happened.
            rethrow(err)
        end
    end
end

function __normalform1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I1}}},
    coeffs::Vector{Vector{C1}},
    ring_tbr::PolyRing,
    monoms_tbr::Vector{Vector{Vector{I2}}},
    coeffs_tbr::Vector{Vector{C2}},
    params::AlgorithmParameters
) where {I1 <: Integer, C1 <: Coeff, I2 <: Integer, C2 <: Coeff}
    @invariant ir_is_valid(ring, monoms, coeffs)
    @invariant ir_is_valid(ring_tbr, monoms_tbr, coeffs_tbr)

    _, ring2, monoms2, coeffs2 = ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    _, ring_tbr2, monoms_tbr2, coeffs_tbr2 =
        ir_convert_ir_to_internal(ring_tbr, monoms_tbr, coeffs_tbr, params)
    monoms_reduced2, coeffs_reduced2 =
        normalform2(ring2, monoms2, coeffs2, ring_tbr2, monoms_tbr2, coeffs_tbr2, params)
    monoms_reduced, coeffs_reduced =
        ir_convert_internal_to_ir(ring_tbr2, monoms_reduced2, coeffs_reduced2, params)
    monoms_reduced, coeffs_reduced
end

# internal structs => internal structs
function normalform2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    ring_tbr::PolyRing,
    monoms_tbr::Vector{Vector{M}},
    coeffs_tbr::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    @invariant ring == ring_tbr

    if params.check
        if !isgroebner2(ring, monoms, coeffs, params)
            throw(DomainError("Input polynomials do not look like a Groebner basis."))
        end
    end

    _monoms = filter(!isempty, monoms)
    _coeffs = filter(!isempty, coeffs)
    if isempty(_monoms)
        return monoms_tbr, coeffs_tbr
    end
    monoms, coeffs = _monoms, _coeffs

    nonzero_indices = findall(!isempty, coeffs_tbr)
    if isempty(nonzero_indices)
        return monoms_tbr, coeffs_tbr
    end

    monoms_tbr_nonzero = monoms_tbr[nonzero_indices]
    coeffs_tbr_nonzero = coeffs_tbr[nonzero_indices]

    monoms_reduced, coeffs_reduced =
        _normalform2(ring, monoms, coeffs, monoms_tbr_nonzero, coeffs_tbr_nonzero, params)

    monoms_tbr[nonzero_indices] .= monoms_reduced
    coeffs_tbr[nonzero_indices] .= coeffs_reduced
    monoms_reduced = monoms_tbr
    coeffs_reduced = coeffs_tbr

    monoms_reduced, coeffs_reduced
end

function _normalform2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    monoms_tbr::Vector{Vector{M}},
    coeffs_tbr::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    basis, _, hashtable = f4_initialize_structs(ring, monoms, coeffs, params)
    tobereduced = basis_initialize_using_existing_hashtable(ring, monoms_tbr, coeffs_tbr, hashtable)
    f4_normalform!(ring, basis, tobereduced, hashtable, params.arithmetic)
    basis_export_data(tobereduced, hashtable)
end

# This file is a part of Groebner.jl. License is GNU GPL v2.
module Groebner
# Groebner is a package for computing Gröbner bases. This is the main file.
#
# Groebner works over integers modulo a prime and over the rationals. At its
# heart, Groebner implements F4, multi-modular techniques, and tracing.
#
# Parts of Groebner were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING
#
# More precisely, the F4 implementation in Groebner adapts monomial hashtable
# implementation and routines for critical pair handling, symbolic
# preprocessing, and linear algebra from msolve.

###
# Global switches

"""
    invariants_enabled() -> Bool

Specifies if custom asserts and invariants are checked. If `false`, then all
checks are disabled, and entail no runtime overhead.

It is useful to enable this when debugging the Groebner package.
"""
invariants_enabled() = false

"""
    threading_enabled() -> Bool

Specifies if multi-threading is enabled in Groebner.jl. By default, is enabled.
To disable, set the environment variable GROEBNER_NO_THREADED or set
`Groebner._THREADED[] = false` in the REPL.
"""
threading_enabled() = _THREADED[]

###
# Imports

# Groebner does not provide a polynomial implementation of its own but relies on
# existing symbolic computation packages in Julia for communicating with the
# user. Groebner accepts as its input polynomials from the Julia packages
# AbstractAlgebra.jl, Nemo.jl, and MultivariatePolynomials.jl.
import AbstractAlgebra
import AbstractAlgebra: base_ring, elem_type

import Atomix

import Base: *
import Base.Threads
import Base.Threads: nthreads, threadid, @spawn
import Base.MultiplicativeInverses: UnsignedMultiplicativeInverse

import Combinatorics

using Logging

# At the moment, used only for rational reconstruction
import Nemo

using Printf

import Primes
import Primes: nextprime

import Random
import Random: AbstractRNG

import TimerOutputs
import TimerOutputs: @timeit

###
# Initialization

const _THREADED = Ref(true)

# By default, the timer is disabled to avoid issues with multi-threading.
# https://github.com/KristofferC/TimerOutputs.jl/issues/72
const _TIMER = TimerOutputs.TimerOutput("Groebner.jl")
TimerOutputs.disable_timer!(_TIMER)

function __init__()
    _THREADED[] = !(get(ENV, "GROEBNER_NO_THREADED", "") == "1")
    TimerOutputs.reset_timer!(_TIMER)
    nothing
end

###
# Includes

include("utils/invariants.jl")
include("utils/tuples.jl")
include("utils/packed.jl")
include("utils/tasks.jl")

# Test systems, such as katsura, cyclic, etc
include("utils/examples.jl")

# Monomial orderings
include("monomials/orderings.jl")

include("utils/keywords.jl")

# Monomial implementations
include("monomials/exponent_vector.jl")
include("monomials/packed_vector.jl")
include("monomials/fixedvector.jl")
include("monomials/fixedvector2.jl")
include("monomials/fixednodeg.jl")
include("monomials/nibblemonom.jl")
include("monomials/nibblenodeg.jl")

include("arithmetic/CompositeNumber.jl")
include("arithmetic/CoeffGeneric.jl")

# Defines some type aliases
include("types.jl")

# Fast arithmetic modulo a prime
include("arithmetic/Zp.jl")
include("arithmetic/generic.jl")

# Intermediate representation
include("input_output/intermediate.jl")

# Selecting algorithm parameters
include("groebner/parameters.jl")

# Input-output conversions for polynomials
include("input_output/AbstractAlgebra.jl")

#= generic f4 =#
include("f4/hashtable.jl")
include("f4/basis.jl")
include("f4/trace.jl")
include("f4/matrix.jl")

# Linear algebra backends
include("f4/linalg/linalg.jl")
include("f4/linalg/backend.jl")
include("f4/linalg/backend_changematrix.jl")
include("f4/linalg/backend_threaded.jl")
include("f4/linalg/backend_randomized.jl")
include("f4/linalg/backend_randomized_threaded.jl")
include("f4/linalg/backend_learn_apply.jl")
include("f4/linalg/backend_learn_apply_threaded.jl")

include("f4/sort.jl")
include("f4/f4.jl")
include("f4/learn_apply.jl")

include("reconstruction/crt.jl")
include("reconstruction/ratrec.jl")

#= more high level functions =#
include("groebner/modular.jl")
include("groebner/wrapped_trace.jl")
include("groebner/groebner.jl")
include("groebner/groebner_with_change_matrix.jl")
include("groebner/learn_apply.jl")
include("groebner/isgroebner.jl")
include("groebner/normalform.jl")
include("groebner/autoreduce.jl")
include("groebner/homogenization.jl")
include("groebner/auxiliary.jl")

# API
include("interface.jl")

using PrecompileTools
include("precompile.jl")

###
# Exports

export groebner, groebner_learn, groebner_apply!
export groebner_with_change_matrix
export isgroebner, normalform
export quotient_basis, leading_ideal, dimension

export Lex, DegLex, DegRevLex, InputOrdering, WeightedOrdering, ProductOrdering, MatrixOrdering

@doc read(joinpath(dirname(@__DIR__), "README.md"), String) Groebner

# 라헬
end # module Groebner

import AbstractAlgebra, Groebner

@info "Loading benchmark models.."

include((@__DIR__) * "/generate/benchmark_systems/SIAN/SIAN.jl")
include((@__DIR__) * "/generate/benchmark_systems/MQ/MQ.jl")
include((@__DIR__) * "/generate/benchmark_systems/SI/SI.jl")
include((@__DIR__) * "/generate/benchmark_systems/biomodels/BIOMD.jl")

function get_benchmark_suite(id)
    s = Symbol(:benchmark_set_, Symbol(id))
    @eval $s()
end

function dummy_system(name, ground_field)
    ring, (x, y) = AbstractAlgebra.polynomial_ring(ground_field, ["x", "y"])
    (name, [x^2 + y^2 - 1, x + y])
end

function benchmark_set_0()
    (
        name="dummy benchmark set",
        field=AbstractAlgebra.GF(7),
        systems=[
            dummy_system("dummy 1", AbstractAlgebra.GF(7)),
            dummy_system("dummy 2", AbstractAlgebra.GF(7))
        ]
    )
end

function benchmark_set_1()
    ground_field = AbstractAlgebra.GF(2^30 + 3)

    systems = [
        dummy_system("dummy", ground_field),
        ("cyclic 7", Groebner.Examples.cyclicn(7, k=ground_field)),
        ("cyclic 8", Groebner.Examples.cyclicn(8, k=ground_field)),
        ("cyclic 9", Groebner.Examples.cyclicn(9, k=ground_field)),
        # ("cyclic 10", Groebner.Examples.cyclicn(10, k=ground_field)),
        ("katsura 10", Groebner.Examples.katsuran(10, k=ground_field)),
        ("katsura 11", Groebner.Examples.katsuran(11, k=ground_field)),
        ("katsura 12", Groebner.Examples.katsuran(12, k=ground_field)),
        ("katsura 13", Groebner.Examples.katsuran(13, k=ground_field)),
        # ("katsura 14", Groebner.Examples.katsuran(14, k=ground_field)),
        ("eco 11", Groebner.Examples.eco11(k=ground_field)),
        ("eco 12", Groebner.Examples.eco12(k=ground_field)),
        ("eco 13", Groebner.Examples.eco13(k=ground_field)),
        ("eco 14", Groebner.Examples.eco14(k=ground_field)),
        ("noon 7", Groebner.Examples.noonn(7, k=ground_field)),
        ("noon 8", Groebner.Examples.noonn(8, k=ground_field)),
        ("noon 9", Groebner.Examples.noonn(9, k=ground_field)),
        ("noon 10", Groebner.Examples.noonn(10, k=ground_field)),
        # ("noon 11", Groebner.Examples.noonn(11, k=ground_field)),
        ("henrion 5", Groebner.Examples.henrion5(k=ground_field)),
        ("henrion 6", Groebner.Examples.henrion6(k=ground_field)),
        ("henrion 7", Groebner.Examples.henrion7(k=ground_field)),
        ("henrion 8", Groebner.Examples.henrion8(k=ground_field)),
        ("reimer 6", Groebner.Examples.reimern(6, k=ground_field)),
        ("reimer 7", Groebner.Examples.reimern(7, k=ground_field)),
        ("reimer 8", Groebner.Examples.reimern(8, k=ground_field)),
        # ("reimer 9", Groebner.Examples.reimern(9, k=ground_field)),
        # ("chandra 11", Groebner.chandran(11, k=ground_field)),
        # ("chandra 12", Groebner.chandran(12, k=ground_field)),
        # ("chandra 13", Groebner.chandran(13, k=ground_field)),
        # ("chandra 14", Groebner.chandran(14, k=ground_field)),
        ("Cholera", Cholera(k=ground_field)),
        ("HIV2", HIV2(k=ground_field)),
        ("NFkB (w.)", NFkB_with_weights(k=ground_field)),
        ("Goodwin (w.)", Goodwin_with_weights(k=ground_field)),
        ("yang1", Groebner.Examples.yang1(internal_ordering=:degrevlex, k=ground_field)),
        ("bayes148", Groebner.Examples.bayes148(internal_ordering=:degrevlex, k=ground_field)),
        ("gametwo2", Groebner.Examples.gametwo2(internal_ordering=:degrevlex, k=ground_field)),
        ("jason210", Groebner.Examples.jason210(internal_ordering=:degrevlex, k=ground_field)),
        ("alea6", Groebner.Examples.alea6(internal_ordering=:degrevlex, k=ground_field)),
        ("mayr42", Groebner.Examples.mayr42(internal_ordering=:degrevlex, k=ground_field)),
        ("BIOMD0000000103", BIOMD0000000103(k=ground_field)),
        ("BIOMD0000000123", BIOMD0000000123(k=ground_field))
    ]

    (name="Integers modulo 2^30 + 3", field=ground_field, systems=systems)
end

function benchmark_set_2()
    ground_field = AbstractAlgebra.GF(1031)

    systems = [
        dummy_system("dummy", ground_field),
        ("cyclic 7", Groebner.Examples.cyclicn(7, k=ground_field)),
        ("cyclic 8", Groebner.Examples.cyclicn(8, k=ground_field)),
        ("cyclic 9", Groebner.Examples.cyclicn(9, k=ground_field)),
        # ("cyclic 10", Groebner.Examples.cyclicn(10, k=ground_field)),
        ("katsura 10", Groebner.Examples.katsuran(10, k=ground_field)),
        ("katsura 11", Groebner.Examples.katsuran(11, k=ground_field)),
        ("katsura 12", Groebner.Examples.katsuran(12, k=ground_field)),
        ("katsura 13", Groebner.Examples.katsuran(13, k=ground_field)),
        ("eco 11", Groebner.Examples.eco11(k=ground_field)),
        ("eco 12", Groebner.Examples.eco12(k=ground_field)),
        ("eco 13", Groebner.Examples.eco13(k=ground_field)),
        ("eco 14", Groebner.Examples.eco14(k=ground_field)),
        ("noon 7", Groebner.Examples.noonn(7, k=ground_field)),
        ("noon 8", Groebner.Examples.noonn(8, k=ground_field)),
        ("noon 9", Groebner.Examples.noonn(9, k=ground_field)),
        ("noon 10", Groebner.Examples.noonn(10, k=ground_field)),
        # ("noon 11", Groebner.Examples.noonn(11, k=ground_field)),
        ("henrion 5", Groebner.Examples.henrion5(k=ground_field)),
        ("henrion 6", Groebner.Examples.henrion6(k=ground_field)),
        ("henrion 7", Groebner.Examples.henrion7(k=ground_field)),
        ("henrion 8", Groebner.Examples.henrion8(k=ground_field)),
        ("reimer 6", Groebner.Examples.reimern(6, k=ground_field)),
        ("reimer 7", Groebner.Examples.reimern(7, k=ground_field)),
        ("reimer 8", Groebner.Examples.reimern(8, k=ground_field)),
        # ("reimer 9", Groebner.Examples.reimern(9, k=ground_field)),
        ("chandra 11", Groebner.chandran(11, k=ground_field)),
        ("chandra 12", Groebner.chandran(12, k=ground_field)),
        ("chandra 13", Groebner.chandran(13, k=ground_field)),
        ("chandra 14", Groebner.chandran(14, k=ground_field))
    ]

    (name="Integers modulo 1031", field=ground_field, systems=systems)
end

function benchmark_set_3()
    ground_field = AbstractAlgebra.QQ
    systems = [
        dummy_system("dummy", ground_field),
        ("cyclic 7", Groebner.Examples.cyclicn(7, k=ground_field)),
        ("cyclic 8", Groebner.Examples.cyclicn(8, k=ground_field)),
        # ("cyclic 9", Groebner.Examples.cyclicn(9, k=ground_field)),
        ("katsura 9", Groebner.Examples.katsuran(9, k=ground_field)),
        ("katsura 10", Groebner.Examples.katsuran(10, k=ground_field)),
        ("katsura 11", Groebner.Examples.katsuran(11, k=ground_field)),
        ("eco 10", Groebner.Examples.eco10(k=ground_field)),
        ("eco 11", Groebner.Examples.eco11(k=ground_field)),
        ("eco 12", Groebner.Examples.eco12(k=ground_field)),
        ("eco 13", Groebner.Examples.eco13(k=ground_field)),
        ("noon 7", Groebner.Examples.noonn(7, k=ground_field)),
        ("noon 8", Groebner.Examples.noonn(8, k=ground_field)),
        ("noon 9", Groebner.Examples.noonn(9, k=ground_field)),
        ("henrion 6", Groebner.Examples.henrion6(k=ground_field)),
        ("henrion 7", Groebner.Examples.henrion7(k=ground_field)),
        ("reimer 6", Groebner.Examples.reimern(6, k=ground_field)),
        ("reimer 7", Groebner.Examples.reimern(7, k=ground_field)),
        ("reimer 8", Groebner.Examples.reimern(8, k=ground_field)),
        ("chandra 9", Groebner.Examples.chandran(9, k=ground_field, internal_ordering=:degrevlex)),
        (
            "chandra 10",
            Groebner.Examples.chandran(10, k=ground_field, internal_ordering=:degrevlex)
        ),
        (
            "chandra 11",
            Groebner.Examples.chandran(11, k=ground_field, internal_ordering=:degrevlex)
        ),
        (
            "chandra 12",
            Groebner.Examples.chandran(12, k=ground_field, internal_ordering=:degrevlex)
        ),
        (
            "chandra 13",
            Groebner.Examples.chandran(13, k=ground_field, internal_ordering=:degrevlex)
        ),
        ("ipp", Groebner.Examples.ipp(k=ground_field, tol=0.0, internal_ordering=:degrevlex))
    ]

    (name="The rationals", field=ground_field, systems=systems)
end

function benchmark_set_4()
    ground_field = AbstractAlgebra.GF(2^30 + 3)
    systems = load_SIAN_all(ground=ground_field)

    (name="SIAN modulo 2^30 + 3", field=ground_field, systems=systems)
end

function benchmark_set_5()
    # TODO: this is not correct!!
    ground_field = AbstractAlgebra.GF(2^30 + 3)
    names = [
        "mq_n10_m20_p2_s0",
        "mq_n10_m20_p2_s1",
        "mq_n10_m7_p2_s0",
        "mq_n15_m10_p2_s0",
        "mq_n15_m30_p2_s0",
        "mq_n24_m16_p31_s0",
        "mq_n34_m68_p31_s0"
    ]
    systems = [(name, load_MQ_problem(name)) for name in names]

    (name="MQ", field=ground_field, systems=systems)
end

function benchmark_set_6()
    ground_field = AbstractAlgebra.QQ
    names = ["SIWR", "SEAIJRC"]
    systems = [(name, load_SI_problem(name)) for name in names]

    (name="SI", field=ground_field, systems=systems)
end

function benchmark_set_7()
    ground_field = AbstractAlgebra.QQ
    systems = [
        ("chandra 2", Groebner.chandran(2, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 3", Groebner.chandran(3, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 4", Groebner.chandran(4, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 5", Groebner.chandran(5, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 6", Groebner.chandran(6, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 7", Groebner.chandran(7, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 8", Groebner.chandran(8, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 9", Groebner.chandran(9, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 10", Groebner.chandran(10, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 11", Groebner.chandran(11, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 12", Groebner.chandran(12, internal_ordering=:degrevlex, k=ground_field)),
        ("boon", Groebner.boon(internal_ordering=:degrevlex, k=ground_field)),
        ("rps10", Groebner.rps10(internal_ordering=:degrevlex, k=ground_field)),
        ("ipp", Groebner.ipp(internal_ordering=:degrevlex, k=ground_field))
    ]

    (name="HC", field=ground_field, systems=systems)
end

function benchmark_set_8()
    ground_field = AbstractAlgebra.GF(2^30 + 3)
    systems = [
        ("chandra 5", Groebner.chandran(5, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 6", Groebner.chandran(6, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 7", Groebner.chandran(7, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 8", Groebner.chandran(8, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 9", Groebner.chandran(9, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 10", Groebner.chandran(10, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 11", Groebner.chandran(11, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 12", Groebner.chandran(12, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 13", Groebner.chandran(13, internal_ordering=:degrevlex, k=ground_field)),
        ("chandra 14", Groebner.chandran(14, internal_ordering=:degrevlex, k=ground_field))
    ]

    (name="HC modulo 2^30 + 3", field=ground_field, systems=systems)
end

function benchmark_set_9()
    ground_field = AbstractAlgebra.QQ
    systems = [("BIOMD0000000103", BIOMD0000000103()), ("BIOMD0000000123", BIOMD0000000123())]
    (name="BIOMD, the rationals", field=ground_field, systems=systems)
end

function benchmark_set_10()
    ground_field = AbstractAlgebra.QQ
    systems = load_SIAN_all(ground=ground_field)

    (name="SIAN, the rationals", field=ground_field, systems=systems)
end

function benchmark_set_11()
    ground_field = AbstractAlgebra.QQ
    systems = [
    # ("hexapod", Groebner.Examples.hexapod(k=ground_field)), 
        ("ipp", Groebner.ipp(k=ground_field))
    # ("alea6", Groebner.alea6(k=ground_field))
    ]

    (name="ipp, the rationals", field=ground_field, systems=systems)
end

function benchmark_set_12()
    ground_field = AbstractAlgebra.GF(2^30 + 3)
    systems = [
        dummy_system("dummy", ground_field),
        # ("cyclic 9", Groebner.Examples.cyclicn(9, k=ground_field)),
        # ("katsura 12", Groebner.Examples.katsuran(12, k=ground_field)),
        # ("eco 14", Groebner.Examples.eco14(k=ground_field)),
        # ("noon 10", Groebner.Examples.noonn(10, k=ground_field)),
        ("reimer 9", Groebner.Examples.reimern(9, k=ground_field)),
        ("eco 15", Groebner.Examples.eco15(k=ground_field))
    ]

    (name="2^30+3, larger", field=ground_field, systems=systems)
end

function benchmark_set_13()
    ground_field = GF(2^30 + 3)
    systems = [
        dummy_system("dummy", ground_field),
        ("ipp", Groebner.Examples.hexapod(internal_ordering=:degrevlex, k=ground_field)),
        ("ipp", Groebner.ipp(internal_ordering=:degrevlex, k=ground_field)),
        # ("SIWR", load_SI_problem("SIWR", k=ground_field)),
        # ("SEAIJRC", load_SI_problem("SEAIJRC", k=ground_field)),
        ("BIOMD0000000103", BIOMD0000000103(k=ground_field)),
        ("BIOMD0000000123", BIOMD0000000123(k=ground_field)),
        ("Cholera", Cholera(k=ground_field)),
        ("HIV2", HIV2(k=ground_field)),
        ("NFkB", NFkB(k=ground_field)),
        ("Pharm_with_weights", Pharm_with_weights(k=ground_field)),
        ("SEIRP", SEIRP(k=ground_field))
    ]

    (name="Learn-apply, other", field=ground_field, systems=systems)
end

function benchmark_set_14()
    ground_field = GF(2^30 + 3)
    systems = [
        dummy_system("dummy", ground_field),
        ("yang1", Groebner.yang1(internal_ordering=:degrevlex, k=ground_field)),
        ("bayes148", Groebner.bayes148(internal_ordering=:degrevlex, k=ground_field)),
        ("gametwo2", Groebner.gametwo2(internal_ordering=:degrevlex, k=ground_field)),
        ("jason210", Groebner.jason210(internal_ordering=:degrevlex, k=ground_field)),
        ("alea6", Groebner.alea6(internal_ordering=:degrevlex, k=ground_field)),
        ("mayr42", Groebner.mayr42(internal_ordering=:degrevlex, k=ground_field))
    ]

    (name="Other, modulo 2^30 + 3", field=ground_field, systems=systems)
end

function benchmark_set_15()
    ground_field = GF(2^30 + 3)
    systems = [
        dummy_system("dummy", ground_field),
        ("Cholera", Cholera(k=ground_field)),
        ("HIV2", HIV2(k=ground_field)),
        ("NFkB (w.)", NFkB_with_weights(k=ground_field)),
        # ("Pharm (w.)", Pharm_with_weights(k=ground_field)),
        ("Goodwin (w.)", Goodwin_with_weights(k=ground_field))
        # ("SEIRP", SEIRP(k=ground_field)),
    ]

    (name="SIAN, 2^30+3", field=ground_field, systems=systems)
end

function benchmark_set_16()
    ground_field = AbstractAlgebra.GF(2^30 + 3)
    systems = [
        dummy_system("dummy", ground_field),
        # ("cyclic 9", Groebner.Examples.cyclicn(9, k=ground_field)),
        # ("katsura 12", Groebner.Examples.katsuran(12, k=ground_field)),
        # ("eco 14", Groebner.Examples.eco14(k=ground_field)),
        ("noon 10", Groebner.Examples.noonn(10, k=ground_field))
        # ("reimer 9", Groebner.Examples.reimern(9, k=ground_field)),
        # ("eco 15", Groebner.Examples.eco15(k=ground_field)),
    ]

    (name="2^30+3, larger x2", field=ground_field, systems=systems)
end

function benchmark_set_17()
    ground_field = QQ
    systems = [
        dummy_system("dummy", ground_field),
        ("Cholera", Cholera(k=ground_field)),
        ("HIV2", HIV2(k=ground_field)),
        ("NFkB (w.)", NFkB_with_weights(k=ground_field)),
        ("Pharm (w.)", Pharm_with_weights(k=ground_field)),
        ("Goodwin (w.)", Goodwin_with_weights(k=ground_field)),
        ("SEIRP", SEIRP(k=ground_field))
    ]

    (name="SIAN, QQ", field=ground_field, systems=systems)
end

function benchmark_set_18()
    ground_field = AbstractAlgebra.GF(2^30 + 3)

    systems = [
        dummy_system("dummy", ground_field),
        ("cyclic 7", Groebner.Examples.cyclicn(7, k=ground_field)),
        ("cyclic 8", Groebner.Examples.cyclicn(8, k=ground_field)),
        ("cyclic 9", Groebner.Examples.cyclicn(9, k=ground_field)),
        # ("cyclic 10", Groebner.Examples.cyclicn(10, k=ground_field)),
        ("katsura 10", Groebner.Examples.katsuran(10, k=ground_field)),
        ("katsura 11", Groebner.Examples.katsuran(11, k=ground_field)),
        ("katsura 12", Groebner.Examples.katsuran(12, k=ground_field)),
        ("katsura 13", Groebner.Examples.katsuran(13, k=ground_field)),
        # ("katsura 14", Groebner.Examples.katsuran(14, k=ground_field)),
        ("eco 11", Groebner.Examples.eco11(k=ground_field)),
        ("eco 12", Groebner.Examples.eco12(k=ground_field)),
        ("eco 13", Groebner.Examples.eco13(k=ground_field)),
        ("eco 14", Groebner.Examples.eco14(k=ground_field)),
        ("noon 7", Groebner.Examples.noonn(7, k=ground_field)),
        ("noon 8", Groebner.Examples.noonn(8, k=ground_field)),
        ("noon 9", Groebner.Examples.noonn(9, k=ground_field)),
        # ("noon 10", Groebner.Examples.noonn(10, k=ground_field)),
        # ("noon 11", Groebner.Examples.noonn(11, k=ground_field)),
        ("henrion 5", Groebner.Examples.henrion5(k=ground_field)),
        ("henrion 6", Groebner.Examples.henrion6(k=ground_field)),
        ("henrion 7", Groebner.Examples.henrion7(k=ground_field)),
        ("henrion 8", Groebner.Examples.henrion8(k=ground_field)),
        ("reimer 6", Groebner.Examples.reimern(6, k=ground_field)),
        ("reimer 7", Groebner.Examples.reimern(7, k=ground_field)),
        ("reimer 8", Groebner.Examples.reimern(8, k=ground_field))
        # ("reimer 9", Groebner.Examples.reimern(9, k=ground_field)),
        # ("chandra 11", Groebner.chandran(11, k=ground_field)),
        # ("chandra 12", Groebner.chandran(12, k=ground_field)),
        # ("chandra 13", Groebner.chandran(13, k=ground_field)),
        # ("chandra 14", Groebner.chandran(14, k=ground_field))
    ]

    (name="Integers modulo 2^30 + 3", field=ground_field, systems=systems)
end

# shared utilities for benchmarking
using Printf

# Benchmark results directory
const BENCHMARK_RESULTS = "results"
# Directory with data necessary for validating benchmark results
const BENCHMARK_VALIDATE = "validate"
# Table with results is written to file..
const BENCHMARK_TABLE = "benchmark_result"

# Benchmark directory for a specific backend and benchmark set id
function get_benchmark_dir(backend, id)
    "$BENCHMARK_RESULTS/$backend/benchmark_$id"
end

function get_validate_dir(id)
    "$BENCHMARK_VALIDATE/benchmark_$id"
end

# Statistics of interest
const TIME_CATEGORIES = [
    :total_time,
    :total_time_F4,
    :total_time_learn,
    :total_time_apply,
    :total_time_apply_4x,
    :total_time_apply_8x
]
const DATA_CATEGORIES = []
const ALL_CATEGORIES = union(TIME_CATEGORIES, DATA_CATEGORIES)

const HUMAN_READABLE_CATEGORIES = Dict(
    :total_time => "Total, s",
    :total_time_learn => "Learn, s",
    :total_time_apply => "Apply, s",
    :total_time_apply_4x => "Apply 4x, s",
    :total_time_apply_8x => "Apply 8x, s",
    :total_time_F4 => "F4, s"
)
const CATEGORY_FORMAT = Dict()
for cat in ALL_CATEGORIES
    CATEGORY_FORMAT[cat] = (val) -> if val isa Real
        @sprintf("%.2f", val)
    else
        string(val)
    end
end

# Code templates
function julia_pkg_preamble(dir)
    @info "Activating environment at $dir"
    Pkg.activate(dir)
    Pkg.Registry.add("General")
    Pkg.instantiate()
    nothing
end

timings_filename() = generic_filename("timings")
function timings_filename(id)
    generic_filename("timings", id)
end

certificate_filename() = generic_filename("certificate")
output_filename() = generic_filename("output")

function result_filename(id)
    generic_filename("result", id)
end

function data_filename(id)
    generic_filename("data", id)
end

function generic_filename(name, id)
    "$(name)_$(id)"
end

function generic_filename(name)
    "$(name)"
end

# https://discourse.julialang.org/t/strange-slowdown-with-threads-greedy-with-bigints/132211

using Base.Threads

function crt(x, y, z)
    M = BigInt(2)^3000+3
    Threads.@threads :greedy for i in 1:length(x)
        Base.GMP.MPZ.mul!(x[i], y[i], z[i])
        Base.GMP.MPZ.fdiv_q!(x[i], z[i])
        Base.GMP.MPZ.fdiv_r!(x[i], M)
    end
end

M = 256*256
x = [BigInt() for _ in 1:M]
y = [rand(1:BigInt(2)^3000) for _ in 1:M]
z = [rand(1:BigInt(2)^3000) for _ in 1:M]
@time crt(x, y, z)
@time crt(x, y, z)

# This file is a part of Groebner.jl. License is GNU GPL v2.

function split_round_robin(data, tasks::Int)
    chunk_size = max(1, div(length(data), tasks, RoundUp))
    data_chunks = [
        [i + tasks * (j - 1) for j in 1:chunk_size if i + tasks * (j - 1) <= length(data)] for
        i in 1:tasks
    ]
    data_chunks
end

@assert split_round_robin(1:10, 3) == [[1, 4, 7, 10], [2, 5, 8], [3, 6, 9]]

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

###
# High level

function linalg_randomized_sparse_threaded!(
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    tasks::Int,
    arithmetic::AbstractArithmetic,
    rng::AbstractRNG
)
    sort_matrix_upper_rows!(matrix) # for the AB part
    sort_matrix_lower_rows!(matrix) # for the CD part

    # Reduce CD with AB
    linalg_randomized_reduce_matrix_lower_part_threaded_cas!(matrix, basis, tasks, arithmetic, rng)
    # Interreduce CD
    linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic)
    true
end

###
# Low level

function _linalg_randomized_reduce_matrix_lower_part_threaded_cas!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    chunk::Vector{Int},
    pivots::Vector{Vector{ColumnLabel}},
    row_index_to_coeffs::Vector{Int},
    sentinels::Vector{Int8},
    rowsperblock::Int,
    arithmetic::AbstractArithmetic,
    t_local_row::Vector{AccumType},
    t_local_rows_multipliers::Vector{AccumType},
    t_local_rng::AbstractRNG
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, nlow = matrix_nrows_filled(matrix)
    _, ncols = size(matrix)
    for i in chunk
        nrowsupper = min(i * rowsperblock, nlow)
        nrowstotal = nrowsupper - (i - 1) * rowsperblock
        nrowstotal == 0 && continue

        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)

        new_pivots_count = 0
        @inbounds while new_pivots_count < nrowstotal
            for j in 1:nrowstotal
                t_local_rows_multipliers[j] = mod_p(rand(t_local_rng, AccumType), arithmetic)
            end
            t_local_row .= AccumType(0)
            first_nnz_col = ncols

            for k in 1:nrowstotal
                rowidx = (i - 1) * rowsperblock + k
                sparse_row_support = matrix.lower_rows[rowidx]
                sparse_row_coeffs = basis.coeffs[row_index_to_coeffs[rowidx]]
                @invariant length(sparse_row_support) == length(sparse_row_coeffs)

                first_nnz_col = min(first_nnz_col, sparse_row_support[1])
                for l in 1:length(sparse_row_coeffs)
                    colidx = sparse_row_support[l]
                    t_local_row[colidx] = mod_p(
                        t_local_row[colidx] +
                        AccumType(t_local_rows_multipliers[k]) * AccumType(sparse_row_coeffs[l]),
                        arithmetic
                    )
                end
            end

            # In a somewhat ideal scenario, the loop below executes just once
            success = false
            while !success
                # Reduce the combination by pivots
                @invariant 1 <= first_nnz_col <= length(t_local_row)
                zeroed = linalg_reduce_dense_row_by_pivots_sparse_threadsafe0!(
                    new_sparse_row_support,
                    new_sparse_row_coeffs,
                    t_local_row,
                    matrix,
                    basis,
                    pivots,
                    first_nnz_col,
                    ncols,
                    arithmetic,
                    sentinels
                )

                if zeroed
                    # set the flag so that the outer loop exits immediately
                    new_pivots_count = nrowstotal
                    break
                end

                # Sync point. Everything before this point becomes visible to
                # other threads once they reach this point.
                # Note the absense of a total order on atomic operations
                old, success = Atomix.replace!(
                    Atomix.IndexableRef(sentinels, (Int(new_sparse_row_support[1]),)),
                    Int8(0),
                    Int8(1),
                    Atomix.acquire_release,
                    Atomix.acquire
                )

                @invariant length(new_sparse_row_support) == length(new_sparse_row_coeffs)

                if success
                    # new pivot is formed, wake up from the loop
                    @invariant iszero(old)

                    new_pivots_count += 1
                    absolute_row_index = (i - 1) * rowsperblock + new_pivots_count

                    linalg_row_make_monic!(new_sparse_row_coeffs, arithmetic)

                    matrix.some_coeffs[absolute_row_index] = new_sparse_row_coeffs
                    matrix.lower_to_coeffs[new_sparse_row_support[1]] = absolute_row_index
                    pivots[new_sparse_row_support[1]] = new_sparse_row_support

                    # This atomic write is paired by an atomic load in
                    # `linalg_reduce_dense_row_by_pivots_sparse_threadsafe0!`. The
                    # purpose of these atomics is to fence the above assignment
                    #    pivots[new_sparse_row_support[1]] = new_sparse_row_support
                    # 
                    # This way, the next atomic load from the same location in
                    # `sentinels` will also receive all relevant modifications to
                    # `pivots` as a side-effect.
                    Atomix.set!(
                        Atomix.IndexableRef(sentinels, (Int(new_sparse_row_support[1]),)),
                        Int8(2),
                        Atomix.release
                    )

                    new_sparse_row_support, new_sparse_row_coeffs =
                        linalg_new_empty_sparse_row(CoeffType)
                else
                    # go for another iteration
                    first_nnz_col = new_sparse_row_support[1]
                end
            end
        end
    end
end

function linalg_randomized_reduce_matrix_lower_part_threaded_cas!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    tasks::Int,
    arithmetic::AbstractArithmetic{AccumType, CoeffType},
    rng::AbstractRNG
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    nup, nlow = matrix_nrows_filled(matrix)

    nblocks = linalg_nblocks_in_randomized(nlow)
    nblocks = max(nblocks, min(nlow, tasks))
    @assert nblocks <= nlow
    rem = nlow % nblocks == 0 ? 0 : 1
    rowsperblock = div(nlow, nblocks) + rem

    # Prepare the matrix
    pivots, row_index_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, nlow)
    resize!(matrix.sentinels, ncols)

    # If there is a pivot with the leading column i, then we set
    #   sentinels[i] = 1.
    # If sentinels[i] = 1, and if the pivot is synced, then we set
    #   sentinels[i] = 2.
    # Otherwise, sentinels[i] = 0.
    # Once sentinels[i] becomes 1 or 2, this is unchanged.
    sentinels = matrix.sentinels
    @inbounds for i in 1:ncols
        sentinels[i] = 0
    end
    @inbounds for i in 1:nup
        sentinels[matrix.upper_rows[i][1]] = 2
    end

    # Allocate thread-local buffers
    buffers_rows_multipliers = map(_ -> zeros(AccumType, rowsperblock), 1:tasks)
    buffers_row = map(_ -> zeros(AccumType, ncols), 1:tasks)
    buffers_rng = map(_ -> copy(rng), 1:tasks)

    tasks = min(tasks, nblocks)
    data_chunks = split_round_robin(1:nblocks, tasks)
    task_results = Vector{Task}(undef, tasks)
    for (tid, chunk) in enumerate(data_chunks)
        t_local_rows_multipliers = buffers_rows_multipliers[tid]
        t_local_row = buffers_row[tid]
        t_local_rng = buffers_rng[tid]
        task = @spawn begin
            _linalg_randomized_reduce_matrix_lower_part_threaded_cas!(
                matrix,
                basis,
                chunk,
                pivots,
                row_index_to_coeffs,
                sentinels,
                rowsperblock,
                arithmetic,
                t_local_row,
                t_local_rows_multipliers,
                t_local_rng
            )
        end
        task_results[tid] = task
    end
    for task in task_results
        wait(task)
    end

    true
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Monomial orderings.

# Only global monomial orderings are supported.

# All monomial orderings are subtypes of AbstractMonomialOrdering
abstract type AbstractMonomialOrdering end

"""
    InputOrdering()

Preserves the monomial ordering defined on the input polynomials.

This is the default value for the `ordering` keyword argument.

## Example

```@example
using Groebner, AbstractAlgebra
R, (x, y) = QQ["x", "y"]

# Uses the ordering `InputOrdering`, which, in this case, 
# defaults to the lexicographical ordering with x > y
groebner([x*y + x, x + y^2])
```
"""
struct InputOrdering <: AbstractMonomialOrdering end

"""
    Lex()
    Lex(variables)
    Lex(variables...)

Lexicographical monomial ordering.

We use the definition from Chapter 1, Computational Commutative Algebra 1, by
Martin Kreuzer, Lorenzo Robbiano. DOI: https://doi.org/10.1007/978-3-540-70628-1.

*Dura Lex, sed Lex.*

## Example

```@example
using Groebner, AbstractAlgebra
R, (x, y) = QQ["x", "y"];

# Lexicographical ordering with x > y
groebner([x*y + x, x + y^2], ordering=Lex())

# Lexicographical ordering with y > x
groebner([x*y + x, x + y^2], ordering=Lex([y, x]))

# Lexicographical ordering with x > y
# Both syntax are allowed -- Lex([...]) and Lex(...)
groebner([x*y + x, x + y^2], ordering=Lex(x, y))
```
"""
struct Lex{IsSimple, T} <: AbstractMonomialOrdering
    # A note on the `IsSimple` parameter:
    #
    # We say that a monomial ordering is simple if it is one of Lex, DegLex, or
    # DegRevLex, and it has "the default" order of variables: x1 > ... > xn. In
    # this case, the `IsSimple` parameter is true. We make this distinction
    # because a simple ordering can have a specialized comparator function,
    # which may be faster than a general one.
    variables::Vector{T}

    Lex(variables...) = Lex(collect(variables))

    function Lex(variables::Vector{T}) where {T}
        !(length(unique(variables)) == length(variables)) &&
            throw(DomainError("Variables in the ordering must be unique. Got $variables"))
        issimple = isempty(variables)
        new{issimple, T}(variables)
    end
end

"""
    DegLex()
    DegLex(variables)
    DegLex(variables...)

Degree lexicographical monomial ordering.

We use the definition from Chapter 1, Computational Commutative Algebra 1, by
Martin Kreuzer, Lorenzo Robbiano. DOI: https://doi.org/10.1007/978-3-540-70628-1.

## Example

```@example
using Groebner, AbstractAlgebra
R, (x, y) = QQ["x", "y"];

# Degree lexicographical ordering with x > y
groebner([x*y + x, x + y^2], ordering=DegLex())

# Degree lexicographical ordering with y > x
groebner([x*y + x, x + y^2], ordering=DegLex([y, x]))
```
"""
struct DegLex{IsSimple, T} <: AbstractMonomialOrdering
    variables::Vector{T}

    DegLex(variables...) = DegLex(collect(variables))

    function DegLex(variables::Vector{T}) where {T}
        !(length(unique(variables)) == length(variables)) &&
            throw(DomainError("Variables in the ordering must be unique. Got $variables"))
        issimple = isempty(variables)
        new{issimple, T}(variables)
    end
end

"""
    DegRevLex()
    DegRevLex(variables)
    DegRevLex(variables...)

Degree reverse lexicographical monomial ordering.

We use the definition from Chapter 1, Computational Commutative Algebra 1, by
Martin Kreuzer, Lorenzo Robbiano. DOI: https://doi.org/10.1007/978-3-540-70628-1.

## Example

```@example
using Groebner, AbstractAlgebra
R, (x, y) = QQ["x", "y"];

# Degree reverse lexicographical ordering with x > y
groebner([x*y + x, x + y^2], ordering=DegRevLex())

# Degree reverse lexicographical ordering with y > x
groebner([x*y + x, x + y^2], ordering=DegRevLex(y, x))
```
"""
struct DegRevLex{IsSimple, T} <: AbstractMonomialOrdering
    variables::Vector{T}

    DegRevLex(variables...) = DegRevLex(collect(variables))

    function DegRevLex(variables::Vector{T}) where {T}
        !(length(unique(variables)) == length(variables)) &&
            throw(DomainError("Variables in the ordering must be unique. Got $variables"))
        issimple = isempty(variables)
        new{issimple, T}(variables)
    end
end

"""
    WeightedOrdering(weights)

Weighted monomial ordering.

Only positive weights are supported.

## Example

```@example
using Groebner, AbstractAlgebra
R, (x, y) = QQ["x", "y"];

# x has weight 3, y has weight 1
ord = WeightedOrdering(x => 3, y => 1)
groebner([x*y + x, x + y^2], ordering=ord)
```
"""
struct WeightedOrdering{U, T} <: AbstractMonomialOrdering
    weights::Vector{U}
    variables::Vector{T}

    WeightedOrdering(var2weight...) = WeightedOrdering(Dict(var2weight))

    function WeightedOrdering(var2weight::AbstractDict{T, U}) where {T, U <: Integer}
        variables = Vector{T}()
        weights = Vector{U}()
        for (k, v) in var2weight
            !(v >= 0) && throw(DomainError("Weights must be positive. Got $var2weight"))
            push!(variables, k)
            push!(weights, v)
        end
        weights_unsigned = map(UInt64, weights)
        !(length(unique(variables)) == length(variables)) &&
            throw(DomainError("Variables in the ordering must be unique. Got $variables"))
        new{UInt64, T}(weights_unsigned, variables)
    end
end

"""
    ProductOrdering(ord1, ord2)

Product monomial ordering. Compares by `ord1`, breaks ties by `ord2`.

Can also be constructed with `*`.

## Example

```@example
using Groebner, AbstractAlgebra
R, (x, y, z, w) = QQ["x", "y", "z", "w"];

# Ordering with x, y > w, z
ord = ProductOrdering(DegRevLex(x, y), DegRevLex(w, z))
groebner([x*y + w, y*z - w], ordering=ord)
```

It is possible to use the `*` operator:

```@example
using Groebner, AbstractAlgebra
R, (x, y, z, t) = QQ["x", "y", "z", "t"];

ord1 = Lex(t)
ord2 = DegRevLex(x, y, z)
# t >> x, y, z
ord = ord1 * ord2
groebner([x*y*z + z, t * z - 1], ordering=ord)
```
"""
struct ProductOrdering{Ord1, Ord2} <: AbstractMonomialOrdering
    ord1::Ord1
    ord2::Ord2
    function ProductOrdering(
        ord1::Ord1,
        ord2::Ord2
    ) where {Ord1 <: AbstractMonomialOrdering, Ord2 <: AbstractMonomialOrdering}
        if !isempty(intersect(ordering_variables(ord1), ordering_variables(ord2)))
            @info """
            Two blocks of the product ordering intersect by their variables.
            Block 1: $(ord1)
            Block 2: $(ord2)"""
        end
        # this fires on, for example, Lex() * Lex(). Should be fine to allow.
        # if ordering_is_simple(ord1) || ordering_is_simple(ord2)
        # throw(DomainError("Invalid monomial ordering"))
        # end
        new{Ord1, Ord2}(ord1, ord2)
    end
end

function *(
    ord1::Ord1,
    ord2::Ord2
) where {Ord1 <: AbstractMonomialOrdering, Ord2 <: AbstractMonomialOrdering}
    ProductOrdering(ord1, ord2)
end

"""
    MatrixOrdering(matrix)
    MatrixOrdering(Vector{Vector})
    
Matrix monomial ordering. 

## Example

```@example
using Groebner, AbstractAlgebra
R, (x, y, z, w) = QQ["x", "y", "z", "w"];

# the number of columns equal to the number of variables
ord = MatrixOrdering(
    [x,y,z,w],
    [
    1 0  0  2;
    0 0  1  2;
    0 1  1  1;
    ])
groebner([x*y + w, y*z - w], ordering=ord)
```
"""
struct MatrixOrdering{T} <: AbstractMonomialOrdering
    variables::Vector{T}
    rows::Vector{Vector{Int64}}

    function MatrixOrdering(variables::Vector{V}, mat::Matrix{T}) where {V, T <: Integer}
        m, n = size(mat)
        rows = [mat[i, :] for i in 1:m]
        MatrixOrdering(variables, rows)
    end

    function MatrixOrdering(variables::Vector{V}, rows::Vector{Vector{T}}) where {V, T <: Integer}
        isempty(rows) && throw(DomainError("Invalid ordering."))
        !(length(unique(map(length, rows))) == 1) && throw(DomainError("Invalid ordering."))
        !all(row -> length(row) == length(variables), rows) &&
            throw(DomainError("Invalid ordering."))
        !(length(unique(variables)) == length(variables)) &&
            throw(DomainError("Variables in the ordering must be unique. Got $variables"))
        new{V}(variables, rows)
    end
end

###
# Ordering utilities

# Returns the (ordered) array of variables that define the ordering
ordering_variables(::InputOrdering) = []
ordering_variables(ord::Union{Lex, DegLex, DegRevLex, WeightedOrdering}) = ord.variables
ordering_variables(ord::ProductOrdering) =
    union(ordering_variables(ord.ord1), ordering_variables(ord.ord2))
ordering_variables(ord::MatrixOrdering) = ord.variables

# Equality of orderings
Base.:(==)(ord1::Lex, ord2::Lex) = ordering_variables(ord1) == ordering_variables(ord2)
Base.:(==)(ord1::DegLex, ord2::DegLex) = ordering_variables(ord1) == ordering_variables(ord2)
Base.:(==)(ord1::DegRevLex, ord2::DegRevLex) = ordering_variables(ord1) == ordering_variables(ord2)
Base.:(==)(ord1::WeightedOrdering, ord2::WeightedOrdering) =
    ordering_variables(ord1) == ordering_variables(ord2) && (ord1.weights == ord2.weights)
Base.:(==)(ord1::ProductOrdering, ord2::ProductOrdering) =
    ord1.ord1 == ord2.ord1 && ord1.ord2 == ord2.ord2
Base.:(==)(ord1::MatrixOrdering, ord2::MatrixOrdering) =
    ordering_variables(ord1) == ordering_variables(ord2) && ord1.rows == ord2.rows

ordering_is_simple(::Union{Lex{T}, DegLex{T}, DegRevLex{T}}) where {T} = T
ordering_is_simple(::AbstractMonomialOrdering) = false

ordering_make_not_simple(ord::AbstractMonomialOrdering, n::Int) = ord
ordering_make_not_simple(ord::Lex{true}, n::Int) = Lex(collect(1:n))
ordering_make_not_simple(ord::DegLex{true}, n::Int) = DegLex(collect(1:n))
ordering_make_not_simple(ord::DegRevLex{true}, n::Int) = DegRevLex(collect(1:n))

# Checking consistency against a polynomial ring
function ordering_check_consistency(nvars::Int, ord::AbstractMonomialOrdering)
    isempty(ordering_variables(ord)) && return nothing
    if !issubset(ordering_variables(ord), collect(1:nvars))
        throw(
            DomainError(
                "Monomial ordering is invalid. The ring has variables $(collect(1:nvars)), the ordering has variables $(ordering_variables(ord)), which are incompatible."
            )
        )
    end
    nothing
end

# Transform orderings

function map_variables(vars, varmap)
    isempty(vars) && return vars
    if !(Set(vars) == Set(collect(keys(varmap))))
        # Fallback to string representation
        varmap_str = Dict(string(k) => v for (k, v) in varmap)
        vars_str = map(string, vars)
        if !isempty(setdiff(collect(keys(varmap_str)), vars_str))
            throw(
                DomainError(
                    "Invalid monomial ordering. The ring has variables $(collect(keys(varmap_str))) and the ordering variables are $vars_str, which are incompatible."
                )
            )
        end
        vars_str = filter(var -> var in keys(varmap_str), vars_str)
        return map(v -> varmap_str[v], vars_str)
    end
    map(v -> varmap[v], vars)
end

ordering_transform(ord::InputOrdering, varmap::AbstractDict) = InputOrdering()
ordering_transform(ord::Lex, varmap::AbstractDict) =
    Lex(map_variables(ordering_variables(ord), varmap))
ordering_transform(ord::DegLex, varmap::AbstractDict) =
    DegLex(map_variables(ordering_variables(ord), varmap))
ordering_transform(ord::DegRevLex, varmap::AbstractDict) =
    DegRevLex(map_variables(ordering_variables(ord), varmap))

function ordering_transform(ord::WeightedOrdering, varmap::AbstractDict)
    WeightedOrdering(Dict(map_variables(ordering_variables(ord), varmap) .=> ord.weights))
end

function ordering_transform(ord::ProductOrdering, varmap::AbstractDict)
    varmap1 = filter(
        key_val -> string(key_val[1]) in Set(map(string, ordering_variables(ord.ord1))),
        varmap
    )
    varmap2 = filter(
        key_val -> string(key_val[1]) in Set(map(string, ordering_variables(ord.ord2))),
        varmap
    )
    ProductOrdering(ordering_transform(ord.ord1, varmap1), ordering_transform(ord.ord2, varmap2))
end

function ordering_transform(ord::MatrixOrdering, varmap::AbstractDict)
    MatrixOrdering(map_variables(ordering_variables(ord), varmap), ord.rows)
end

# Print orderings

Base.show(io::IO, ord::AbstractMonomialOrdering) = Base.show(io, MIME("text/plain"), ord)

Base.show(io::IO, ::MIME"text/plain", ord::InputOrdering) = print(io, "InputOrdering()")

function Base.show(
    io::IO,
    ::MIME"text/plain",
    ord::Ord
) where {Ord <: Union{Lex, DegLex, DegRevLex}}
    if ordering_is_simple(ord)
        print(io, "$(nameof(Ord))()")
    else
        print(io, "$(nameof(Ord))($(join(string.(ordering_variables(ord)), ",")))")
    end
end

function Base.show(io::IO, ::MIME"text/plain", ord::WeightedOrdering)
    tmp = ""
    for i in 1:length(ord.variables)
        tmp *= string(ord.variables[i], "=>", ord.weights[i])
        i < length(ord.variables) && (tmp *= ",")
    end
    print(io, "WeightedOrdering($(tmp))")
end

function Base.show(io::IO, ::MIME"text/plain", ord::ProductOrdering)
    print(io, ord.ord1)
    print(io, " × ")
    print(io, ord.ord2)
end

function Base.show(io::IO, ::MIME"text/plain", ord::MatrixOrdering)
    print(io, "MatrixOrdering($(join(string.(ordering_variables(ord)), ",")))\n")
    for row in ord.rows
        print(io, "  ")
        print(io, "[ " * join(string.(row), " ") * " ]\n")
    end
end

using Revise, Groebner, Nemo, TimerOutputs


@info "nthreads=$(Base.Threads.nthreads())"
sys = Groebner.Examples.chandran(11);

TimerOutputs.enable_timer!(Groebner._TIMER); reset_timer!(Groebner._TIMER); @time gb = groebner(sys; threaded=:no); show(Groebner._TIMER, allocations=false)

nothing

# This file is a part of Groebner.jl. License is GNU GPL v2.

"""
    groebner(polynomials; options...)

Computes a Groebner basis of the ideal generated by `polynomials`.

## Arguments

- `polynomials`: an array of polynomials. Supports polynomials from
    AbstractAlgebra.jl, Nemo.jl, and DynamicPolynomials.jl.

## Returns

- `basis`: an array of polynomials, a Groebner basis.

## Possible Options

- `reduced`: A bool, if the returned basis must be autoreduced and unique.
  Default is `true`.
- `ordering`: Specifies the monomial ordering. Available monomial orderings are: 
    - `InputOrdering()` for inferring the ordering from the given `polynomials`
      (default), 
    - `Lex(args...)` for lexicographic, 
    - `DegLex(args...)` for degree lexicographic, 
    - `DegRevLex(args...)` for degree reverse lexicographic, 
    - `WeightedOrdering(args...)` for weighted ordering, 
    - `ProductOrdering(args...)` for block ordering, 
    - `MatrixOrdering(args...)` for matrix ordering.
    For details and examples see the corresponding documentation page.
- `certify`: A bool, whether to certify the obtained basis. When this option is
    `false`, the algorithm is randomized and the result is correct with high
    probability. When this option is `true`, the result is guaranteed to be
    correct in case the ideal is homogeneous. Default is `false`. 
- `linalg`: A symbol, linear algebra backend. Available options are: 
    - `:auto` for the automatic choice (default),
    - `:deterministic` for deterministic sparse linear algebra, 
    - `:randomized` for probabilistic sparse linear algebra.
- `tasks`: The number of tasks used in multi-threading. Available options are:
    - `:auto` for the automatic choice (default). Generally corresponds to
      `Threads.nthreads()`, but may be smaller.
    - `N`, an integer, the number of tasks. Providing `tasks=N` ensures that at
      most `N` tasks run in parallel (excluding the main program).
    See also `Groebner.threading_enabled`.
- `monoms`: Monomial representation used in the computations. Available options
  are: 
    - `:auto` for the automatic choice (default), 
    - `:dense` for classic dense exponent vectors,
    - `:packed` for packed representation,
    - `:nibble` for nibble representation (4 bits per exponent). 
- `modular`: Modular computation algorithm. Only has effect when computing basis
    over rational numbers. Available options are:
    - `:auto` for the automatic choice (default),
    - `:classic_modular` for the classic multi-modular algorithm,
    - `:learn_and_apply` for the learn & apply algorithm.
- `seed`: The seed for randomization. Default is `42`.
- `homogenize`: Controls the use of homogenization in the algorithm. Available
  options are:
    - `:auto`, for the automatic choice (default).
    - `:yes`, always homogenize the input ideal,
    - `:no`, never homogenize the input ideal,

## Example

Using DynamicPolynomials.jl:

```@example
using Groebner, DynamicPolynomials
@polyvar x y
groebner([x*y^2 + x, y*x^2 + y])
```

Using AbstractAlgebra.jl:

```@example
using Groebner, AbstractAlgebra
R, (x, y) = QQ["x", "y"]
groebner([x*y^2 + x, y*x^2 + y])
```

Using Nemo.jl:

```@example
using Groebner, Nemo
R, (x, y) = GF(2^30+3)["x", "y"]
groebner([x*y^2 + x, y*x^2 + y])
```

Or, say, in another monomial ordering:

```@example
# lex with y > x
groebner([x*y^2 + x, y*x^2 + y], ordering=Lex(y, x))

# degree reverse lexicographic
groebner([x*y^2 + x, y*x^2 + y], ordering=DegRevLex())
```

## Notes

- The function is thread-safe.
- For AbstractAlgebra.jl and Nemo.jl, the function is most efficient for
    polynomials over `GF(p)`, `Native.GF(p)`, and `QQ`.
- The default algorithm is probabilistic (with `certify=false`). Results are
    correct with high probability, however, no precise bound on the probability
    is known.
"""
function groebner(polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:groebner, options)
    result = groebner0(polynomials, keywords)
    result
end

#=
    groebner(ring, monoms, coeffs; options...)

Computes a Groebner basis. This function is a part of low level interface.

## Arguments

- `ring`: polynomial ring, a `PolyRing` object.
- `monoms`: vector of monomials of input polynomials.
- `coeffs`: vector of coefficients of input polynomials.

## Returns

Returns a tuple (`gb_monoms`, `gb_coeffs`).

- `gb_monoms`: an array, the monomials of a Groebner basis.
- `gb_coeffs`: an array, the coefficients of a Groebner basis.

## Possible Options

Same as for public `groebner`.

## Example

Computing a Groebner basis of a bivariate ideal modulo 65537 in degrevlex:

```@example
using Groebner
ring = Groebner.PolyRing(2, Groebner.DegRevLex(), 65537)
# {x y - 1,  x^3 + 7 y^2}
monoms = [ [[1, 1], [0, 0]], [[3, 0], [0, 2]] ]
coeffs = [ [1,65536], [1, 7] ]
Groebner.groebner(ring, monoms, coeffs)
```

## Notes

Same as for `groebner`.
=#
function groebner(ring::PolyRing, monoms::AbstractVector, coeffs::AbstractVector; options...)
    keywords = KeywordArguments(:groebner, options)
    ir_is_valid_basic(ring, monoms, coeffs)
    result = groebner1(ring, monoms, coeffs, keywords)
    result
end

"""
    groebner_with_change_matrix(polynomials; options...)

Computes a Groebner basis of the ideal generated by `polynomials` and emits a
change matrix, that is, a map from the original generators to basis elements.

## Arguments

- `polynomials`: an array of polynomials. Supports polynomials from
    AbstractAlgebra.jl, Nemo.jl, and DynamicPolynomials.jl. For
    AbstractAlgebra.jl and Nemo.jl, coefficients of polynomials must belong to
    `GF(p)`, `Native.GF(p)`, or `QQ`. 

## Returns

Returns a tuple (`basis`, `matrix`).

- `basis`: an array of polynomials, a Groebner basis.
- `matrix`: a matrix, so that `matrix * polynomials == basis`.

## Possible Options

Same as for `groebner`.

## Example

Using AbstractAlgebra.jl:

```@example
using Groebner, AbstractAlgebra
R, (x, y) = QQ["x", "y"]
f = [x*y^2 + x, y*x^2 + y]

g, m = groebner_with_change_matrix(f, ordering=DegRevLex())

@assert isgroebner(g, ordering=DegRevLex())
@assert m * f == g
```

## Notes

- Only `DegRevLex` ordering is supported.
- The function is thread-safe.
- The default algorithm is probabilistic (with `certify=false`). Results are
    correct with high probability, however, no precise bound on the probability
    is known.
"""
function groebner_with_change_matrix(polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:groebner_with_change_matrix, options)
    result = groebner_with_change_matrix0(polynomials, keywords)
    result
end

"""
    groebner_learn(polynomials; options...)

Computes a Groebner basis of the ideal generated by `polynomials` and emits a
trace.

The trace can be used to speed up the computation of Groebner bases of
specializations of the same ideal as the one `groebner_learn` had been applied
to.

See also `groebner_apply!`.

## Arguments

- `polynomials`: an array of polynomials. Supports polynomials from
    AbstractAlgebra.jl and Nemo.jl.

## Returns

Returns a tuple (`trace`, `basis`).

- `trace`: an object, a trace. Can be used in `groebner_apply!`.
- `basis`: an array of polynomials, a Groebner basis.

## Possible Options

Same as for `groebner`.

## Example

Using `groebner_learn` and `groebner_apply!` over the same ground field:

```@example
using Groebner, AbstractAlgebra
R, (x, y) = GF(2^31-1)["x", "y"]

# Learn
trace, gb_1 = groebner_learn([x*y^2 + x, y*x^2 + y])

# Apply (same support, different coefficients)
flag, gb_2 = groebner_apply!(trace, [2x*y^2 + 3x, 4y*x^2 + 5y])

@assert flag
```

Using `groebner_learn` and `groebner_apply!` over different ground fields:

```@example
using Groebner, AbstractAlgebra
R, (x, y) = GF(2^31-1)["x", "y"]

# Learn
trace, gb_1 = groebner_learn([x*y^2 + x, y*x^2 + y], ordering=DegRevLex())

# Create a ring with a different modulo
R2, (x2, y2) = GF(2^30+3)["x", "y"]

# Apply (different modulo)
flag, gb_2 = groebner_apply!(
    trace, 
    [2x2*y2^2 + 3x2, 4y2*x2^2 + 5y2], 
    ordering=DegRevLex()
)

@assert flag
@assert gb_2 == groebner([2x2*y2^2 + 3x2, 4y2*x2^2 + 5y2], ordering=DegRevLex())
```

Using `groebner_apply!` in batches:

```@example
using Groebner, AbstractAlgebra
R, (x, y) = polynomial_ring(GF(2^31-1), ["x", "y"], internal_ordering=:degrevlex)

# Learn
trace, gb_1 = groebner_learn([x*y^2 + x, y*x^2 + y])

# Create rings with some other moduli
R2, (x2, y2) = polynomial_ring(GF(2^30+3), ["x", "y"], internal_ordering=:degrevlex)
R3, (x3, y3) = polynomial_ring(GF(2^27+29), ["x", "y"], internal_ordering=:degrevlex)

# Two specializations of the same ideal
batch = ([2x2*y2^2 + 3x2, 4y2*x2^2 + 5y2], [4x3*y3^2 + 4x3, 5y3*x3^2 + 7y3])

# Apply for two sets of polynomials at once
flag, (gb_2, gb_3) = groebner_apply!(trace, batch)

@assert flag
@assert (gb_2, gb_3) == map(groebner, batch)
```

Perhaps, in a more involved example, we will compute Groebner bases of the
Katsura-9 system:

```@example
using Groebner, AbstractAlgebra, BenchmarkTools

# Create the system
kat = Groebner.Examples.katsuran(9, k=ZZ, internal_ordering=:degrevlex)

# Reduce the coefficients modulo 5 different primes
kat_0 = map(f -> map_coefficients(c -> GF(2^30 + 3)(c), f), kat)
kat_1 = map(f -> map_coefficients(c -> GF(2^30 + 7)(c), f), kat)
kat_2 = map(f -> map_coefficients(c -> GF(2^30 + 9)(c), f), kat)
kat_3 = map(f -> map_coefficients(c -> GF(2^30 + 15)(c), f), kat)
kat_4 = map(f -> map_coefficients(c -> GF(2^30 + 19)(c), f), kat)

# Learn the trace
trace, gb_0 = groebner_learn(kat_0);

# Compare the performance of applying with 1 input and with 4 different inputs:

# Apply for one system
@btime groebner_apply!(\$trace, \$kat_1);
#  46.824 ms (19260 allocations: 24.48 MiB)

# Apply for a batch of four systems
@btime groebner_apply!(\$trace, \$(kat_1, kat_2, kat_3, kat_4));
#  72.813 ms (23722 allocations: 59.44 MiB)
```

Observe the better amortized performance of the composite `groebner_apply!`.

## Notes

- The function is thread-safe.
- For AbstractAlgebra.jl and Nemo.jl, the function is most efficient for
    polynomials over `GF(p)`, `Native.GF(p)`.
"""
function groebner_learn(polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:groebner_learn, options)
    result = groebner_learn0(polynomials, keywords)
    result
end

# This function is a part of low level interface.
function groebner_learn(ring::PolyRing, monoms::AbstractVector, coeffs::AbstractVector; options...)
    keywords = KeywordArguments(:groebner_learn, options)
    ir_is_valid_basic(ring, monoms, coeffs)
    result = groebner_learn1(ring, monoms, coeffs, keywords)
    result
end

"""
    groebner_apply!(trace, polynomials; options...)
    groebner_apply!(trace, batch::NTuple{N, Vector}; options...)

Computes a Groebner basis of the ideal generated by `polynomials` following the
given `trace`. 

See also `groebner_learn`.

## Arguments

- `trace`: a trace produced by `groebner_learn`.
- `polynomials`: an array of polynomials. Supports polynomials from
    AbstractAlgebra.jl or Nemo.jl. Alternatively, it is possible to supply
    a tuple of `N` arrays of polynomials to compute `N` Groebner bases
    simultaneously. This could be more efficient than computing them separately.

## Returns

Returns a tuple (`success`, `basis`).

- `success`: a bool, whether the call succeeded.
- `basis`: an array of polynomials, a Groebner basis.
    With tuple input, this is a tuple, a Groebner basis for each element in the batch.

## Possible Options

The `groebner_apply!` function automatically inherits most parameters from the
given `trace`. In particular, it reuses the monomial ordering and the
homogenization strategy used during the learning phase.

## Example

For examples, see the documentation of `groebner_learn`.

## Notes

- In general, `success` may be a false positive. The probability of a false
  positive is considered to be low enough in some practical applications.
- This function is **not** thread-safe since it mutates `trace`.
- For AbstractAlgebra.jl and Nemo.jl, the function is most efficient for
    polynomials over `GF(p)`, `Native.GF(p)`.
- This function is **not** safe against program interruptions. For example,
    pressing `Ctrl + C` while `groebner_apply!(trace, ...)` is running may leave
    `trace` corrupted.
"""
function groebner_apply! end

# Specialization for a single input
function groebner_apply!(trace::WrappedTrace, polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:groebner_apply!, options)
    result = groebner_apply0!(trace, polynomials, keywords)
    result
end

const _supported_batch_size = (1, 2, 4, 8, 16, 32, 64, 128)

# Specialization for a batch of inputs
function groebner_apply!(
    trace::WrappedTrace,
    batch::NTuple{N, T}; # deliberately not ::Tuple{T, Vararg{T, Nminus1}}
    options...
) where {N, T <: AbstractVector}
    !(N in _supported_batch_size) &&
        throw(DomainError("The batch size must be one of the following: $_supported_batch_size"))
    keywords = KeywordArguments(:groebner_apply!, options)
    result = groebner_apply_batch0!(trace, batch, keywords)
    result
end

# Low level specialization for a single input
function groebner_apply!(
    trace::WrappedTrace,
    ring::PolyRing,
    monoms::AbstractVector,
    coeffs::AbstractVector;
    options...
)
    keywords = KeywordArguments(:groebner_apply!, options)
    ir_is_valid_basic(ring, monoms, coeffs)
    result = groebner_apply1!(trace, ring, monoms, coeffs, keywords)
    result
end

# Low level specialization for a batch of inputs
function groebner_apply!(trace::WrappedTrace, batch::NTuple{N, T}; options...) where {N, T}
    !(N in _supported_batch_size) &&
        throw(DomainError("The batch size must be one of the following: $_supported_batch_size"))
    keywords = KeywordArguments(:groebner_apply!, options)
    ir_is_valid_basic(batch)
    result = groebner_apply_batch1!(trace, batch, keywords)
    result
end

"""
    isgroebner(polynomials; options...)

Checks if `polynomials` forms a Groebner basis.

## Arguments

- `polynomials`: an array of polynomials. Supports polynomials from
    AbstractAlgebra.jl, Nemo.jl, and DynamicPolynomials.jl. 

## Returns

- `flag`: a bool, whether `polynomials` is a Groebner basis of the ideal
  generated by `polynomials`.

## Possible Options

- `ordering`: Specifies the monomial ordering. Available monomial orderings are: 
    - `InputOrdering()` for inferring the ordering from the given `polynomials`
      (default), 
    - `Lex()` for lexicographic, 
    - `DegLex()` for degree lexicographic, 
    - `DegRevLex()` for degree reverse lexicographic, 
    - `WeightedOrdering(weights)` for weighted ordering, 
    - `ProductOrdering(args...)` for block ordering, 
    - `MatrixOrdering(matrix)` for matrix ordering. 
  For details and examples see the corresponding documentation page.
- `monoms`: Monomial representation used in the computations. Available options
  are: 
    - `:auto` for the automatic choice, 
    - `:dense` for classic dense exponent vectors (default),
    - `:packed` for packed representation,
    - `:nibble` for nibble representation (4 bits per exponent). 
- `certify`: a bool, whether to use a deterministic algorithm. Default is
  `false`.
- `monoms`: Monomial representation used in the computations. Available options
    are:
    - `:auto` for the automatic choice (default),
    - `:dense` for classic dense exponent vectors,
    - `:packed` for packed representation.
- `seed`: The seed for randomization. Default value is `42`.

## Example

Using `DynamicPolynomials`:

```@example
using Groebner, DynamicPolynomials
@polyvar x y;
isgroebner([x*y^2 + x, y*x^2 + y])
```

Using `AbstractAlgebra`:

```@example
using Groebner, AbstractAlgebra
R, (x, y) = QQ["x", "y"]
isgroebner([x*y^2 + x, y*x^2 + y])
```

## Notes

- The function is thread-safe.
- For AbstractAlgebra.jl and Nemo.jl, the function is most efficient for
    polynomials over `GF(p)`, `Native.GF(p)`, and `QQ`.
- The default algorithm is probabilistic (with `certify=false`). Results are
    correct with high probability, however, no precise bound on the probability
    is known. 
"""
function isgroebner(polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:isgroebner, options)
    result = isgroebner0(polynomials, keywords)::Bool
    result
end

# This function is a part of low level interface.
function isgroebner(ring::PolyRing, monoms::AbstractVector, coeffs::AbstractVector; options...)
    keywords = KeywordArguments(:isgroebner, options)
    ir_is_valid_basic(ring, monoms, coeffs)
    result = isgroebner1(ring, monoms, coeffs, keywords)
    result
end

"""
    normalform(basis, to_be_reduced; options...)

Computes the normal form of polynomials `to_be_reduced` with respect to a
Groebner basis `basis`.

## Arguments

- `basis`: an array of polynomials, a Groebner basis. Supports polynomials from
    AbstractAlgebra.jl, Nemo.jl, and DynamicPolynomials.jl.
- `to_be_reduced`: either a single polynomial or an array of polynomials.
    Supports polynomials from AbstractAlgebra.jl, Nemo.jl, and
    DynamicPolynomials.jl.

## Returns

- `reduced`: either a single polynomial or an array of polynomials, the normal
  forms.

## Possible Options

- `check`: Check if `basis` forms a Groebner basis. Default is `true`.
- `ordering`: Specifies the monomial ordering. Available monomial orderings are: 
    - `InputOrdering()` for inferring the ordering from the given `polynomials`
      (default), 
    - `Lex()` for lexicographic, 
    - `DegLex()` for degree lexicographic, 
    - `DegRevLex()` for degree reverse lexicographic, 
    - `WeightedOrdering(weights)` for weighted ordering, 
    - `ProductOrdering(args...)` for block ordering, 
    - `MatrixOrdering(matrix)` for matrix ordering. 
    For details and examples see the corresponding documentation page.
- `monoms`: Monomial representation used in the computations. Available options
  are: 
    - `:auto` for the automatic choice, 
    - `:dense` for classic dense exponent vectors (default),
    - `:packed` for packed representation,
    - `:nibble` for nibble representation (4 bits per exponent). 

## Example

Fining the normal form a single polynomial:

```@example
using Groebner, DynamicPolynomials
@polyvar x y;
normalform([y^2 + x, x^2 + y], x^2 + y^2 + 1)
```

Or, reducing two polynomials at a time:

```@example
using Groebner, DynamicPolynomials
@polyvar x y;
normalform([y^2 + x, x^2 + y], [x^2 + y^2 + 1, x^10*y^10])
```

## Notes

- The function is thread-safe.
- For AbstractAlgebra.jl and Nemo.jl, the function is most efficient for
    polynomials over `GF(p)`, `Native.GF(p)`, and `QQ`.
- The default algorithm is probabilistic (with `certify=false`). Results are
    correct with high probability, however, no precise bound on the probability
    is known.
"""
function normalform(basis::AbstractVector, to_be_reduced::AbstractVector; options...)
    keywords = KeywordArguments(:normalform, options)
    result = normalform0(basis, to_be_reduced, keywords)
    result
end

normalform(basis::AbstractVector, to_be_reduced; options...) =
    first(normalform(basis, [to_be_reduced]; options...))

function normalform(
    ring::PolyRing,
    monoms::AbstractVector,
    coeffs::AbstractVector,
    ring_to_be_reduced::PolyRing,
    monoms_to_be_reduced::AbstractVector,
    coeffs_to_be_reduced::AbstractVector;
    options...
)
    keywords = KeywordArguments(:normalform, options)
    ir_is_valid_basic(ring, monoms, coeffs)
    ir_is_valid_basic(ring_to_be_reduced, monoms_to_be_reduced, coeffs_to_be_reduced)
    result = normalform1(
        ring,
        monoms,
        coeffs,
        ring_to_be_reduced,
        monoms_to_be_reduced,
        coeffs_to_be_reduced,
        keywords
    )
    result
end

"""
    leading_term(polynomial; options...)

Returns the leading term of a polynomial.

## Arguments

- `polynomial`: a polynomial. Supports polynomials from
    AbstractAlgebra.jl, Nemo.jl, and DynamicPolynomials.jl.

## Possible Options

- `ordering`: Specifies the monomial ordering. Available monomial orderings are:
    - `InputOrdering()` for inferring the ordering from the given `polynomials`
      (default),
    - `Lex()` for lexicographic,
    - `DegLex()` for degree lexicographic,
    - `DegRevLex()` for degree reverse lexicographic,
    - `WeightedOrdering(weights)` for weighted ordering,
    - `ProductOrdering(args...)` for block ordering,
    - `MatrixOrdering(matrix)` for matrix ordering.
    For details and examples see the corresponding documentation page.
- `monoms`: Monomial representation used in the computations. Available options
  are:
    - `:auto` for the automatic choice (default),
    - `:dense` for classic dense exponent vectors,
    - `:packed` for packed representation.

## Notes

- The function is thread-safe.
"""
function leading_term(polynomial; options...)
    first(leading_term([polynomial]; options...))
end

function leading_term(polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:leading_term, options)
    result = leading_term0(polynomials, keywords)
    result
end

"""
    leading_ideal(polynomials; options...)

Returns generators of the ideal of the leading terms.

If the input is not a Groebner basis, computes a Groebner basis.

## Arguments

- `polynomials`: an array of polynomials. Supports polynomials from
    AbstractAlgebra.jl, Nemo.jl, and DynamicPolynomials.jl.

## Returns

- `basis`: the basis of the ideal of the leading terms.

## Possible Options

- `ordering`: Specifies the monomial ordering. Available monomial orderings are:
    - `InputOrdering()` for inferring the ordering from the given `polynomials`
      (default),
    - `Lex()` for lexicographic,
    - `DegLex()` for degree lexicographic,
    - `DegRevLex()` for degree reverse lexicographic,
    - `WeightedOrdering(weights)` for weighted ordering,
    - `ProductOrdering(args...)` for block ordering,
    - `MatrixOrdering(matrix)` for matrix ordering.
    For details and examples see the corresponding documentation page.
- `monoms`: Monomial representation used in the computations. Available options
  are:
    - `:auto` for the automatic choice (default),
    - `:dense` for classic dense exponent vectors,
    - `:packed` for packed representation.

## Example

Using AbstractAlgebra.jl:

```@example
using Groebner, Nemo
R, (x, y) = QQ["x", "y"]
leading_ideal([x*y^2 + x, y*x^2 + y])
```

## Notes

- The function is thread-safe.
- For AbstractAlgebra.jl and Nemo.jl, the function is most efficient for
    polynomials over `GF(p)`, `Native.GF(p)`, and `QQ`.
"""
function leading_ideal(polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:leading_ideal, options)
    result = leading_ideal0(polynomials, keywords)
    result
end

"""
    quotient_basis(polynomials; options...)

Returns a monomial basis of the quotient algebra of a zero-dimensional ideal.

If the input is not a Groebner basis, computes a Groebner basis.
If the input is not a zero-dimensional ideal, an error is raised.

## Arguments

- `polynomials`: an array of polynomials. Supports polynomials from
    AbstractAlgebra.jl, Nemo.jl, and DynamicPolynomials.jl.

## Returns

- `basis`: an array of monomials, a quotient basis.

## Possible Options

- `ordering`: Specifies the monomial ordering. Available monomial orderings are:
    - `InputOrdering()` for inferring the ordering from the given `polynomials`
      (default),
    - `Lex()` for lexicographic,
    - `DegLex()` for degree lexicographic,
    - `DegRevLex()` for degree reverse lexicographic,
    - `WeightedOrdering(weights)` for weighted ordering,
    - `ProductOrdering(args...)` for block ordering,
    - `MatrixOrdering(matrix)` for matrix ordering.
    For details and examples see the corresponding documentation page.
- `monoms`: Monomial representation used in the computations. Available options
  are:
    - `:auto` for the automatic choice (default),
    - `:dense` for classic dense exponent vectors,
    - `:packed` for packed representation.

## Example

Using AbstractAlgebra.jl:

```@example
using Groebner, Nemo
R, (x, y) = QQ["x", "y"]
quotient_basis([x*y^2 + x, y*x^2 + y])
```

## Notes

- The function is thread-safe.
- For AbstractAlgebra.jl and Nemo.jl, the function is most efficient for
    polynomials over `GF(p)`, `Native.GF(p)`, and `QQ`.
"""
function quotient_basis(polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:quotient_basis, options)
    result = quotient_basis0(polynomials, keywords)
    result
end

"""
    dimension(polynomials; options...)

Computes the (Krull) dimension of the ideal generated by `polynomials`.

If input is not a Groebner basis, computes a Groebner basis.

## Arguments

- `polynomials`: an array of polynomials. Supports polynomials from
    AbstractAlgebra.jl, Nemo.jl, and DynamicPolynomials.jl.

## Returns

- `dimension`: an integer, the dimension.

## Possible Options

- `monoms`: Monomial representation used in the computations. Available options
  are:
    - `:auto` for the automatic choice (default),
    - `:dense` for classic dense exponent vectors,
    - `:packed` for packed representation.

## Example

Using AbstractAlgebra.jl:

```@example
using Groebner, Nemo
R, (x, y) = QQ["x", "y"]
dimension([x*y^2 + x, y*x^2 + y])
```

## Notes

- The function is thread-safe.
- For AbstractAlgebra.jl and Nemo.jl, the function is most efficient for
    polynomials over `GF(p)`, `Native.GF(p)`, and `QQ`.
"""
function dimension(polynomials::AbstractVector; options...)
    keywords = KeywordArguments(:dimension, options)
    result = dimension0(polynomials, keywords)
    result
end

using Test, Primes, Groebner, AbstractAlgebra

@testset "regression, generic alignment" begin
    @test Groebner.align_up(13, 20) == 20
    @test Groebner.align_up(21, 20) == 40
    @test Groebner.align_up(29, 20) == 40

    @test Groebner.align_down(13, 20) == 0
    @test Groebner.align_down(21, 20) == 20
    @test Groebner.align_down(40, 20) == 40

    for tasks in 1:16
        composite = 4
        batch = composite * tasks
        for primes_used in 1:1000
            batch = Groebner.get_next_batch(primes_used, batch, 0.1, composite, tasks)
            @test batch % (composite * tasks) == 0
        end
    end
end

@testset "regression, SI.jl normalform" begin
    R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"])

    @test Groebner.normalform([x], R(0)) == R(0)
    @test Groebner.normalform([x], R(1)) == R(1)
    @test Groebner.normalform([x], [R(0)]) == [R(0)]
    @test Groebner.normalform([x], [R(1)]) == [R(1)]
    @test Groebner.normalform([x], [R(0), R(1), R(0)]) == [R(0), R(1), R(0)]
end

@testset "regression, ordering of empty" begin
    R, (x, y) = polynomial_ring(GF(2^31 - 1), ["x", "y"], internal_ordering=:lex)

    ord = Groebner.DegRevLex()
    gb1 = Groebner.groebner([x, y], ordering=ord)
    gb2 = Groebner.groebner([R(0)], ordering=ord)
    @test parent(first(gb1)) == R
    @test parent(first(gb2)) == R
    nf1 = Groebner.normalform([x, y], x, ordering=ord)
    nf2 = Groebner.normalform([x, y], R(0), ordering=ord)
    @test parent(nf1) == R
    @test parent(nf2) == R
end

@testset "regression, SI.jl cmp" begin
    # this may crash if the comparator is invalid
    function bug(gens::Vector{Int}, exps::Vector{Vector{T}}) where {T}
        inds = collect(1:length(gens))
        cmp  = (x, y) -> Groebner.monom_isless(exps[gens[x]], exps[gens[y]], Groebner.DegRevLex())
        sort!(inds, lt=cmp)
        @test true
    end

    gens = [
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        3,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        3,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        3,
        2,
        2,
        2,
        2,
        2
    ]

    exps = Groebner.ExponentVector{UInt64}[[0x0000, 0x0000], [0x0002, 0x0002], [0x0002, 0x0002]]

    bug(gens, exps)
end

@testset "regression, column order in normalform" begin
    P, (x1, x2) = polynomial_ring(GF(1119649), ["x1", "x2"])

    gb = [x1 + 1]
    f = x1 + x2^2
    f_nf = Groebner.normalform(gb, f, ordering=Groebner.DegRevLex())
    residual = Groebner.normalform(gb, f - f_nf, ordering=Groebner.DegRevLex())

    @test iszero(residual)
end

@testset "regression, tracing invariants" begin
    R, (x1, x2, x3, x4, x5, x6, x7, _Z) =
        polynomial_ring(ZZ, [:x1, :x2, :x3, :x4, :x5, :x6, :x7, :_Z], internal_ordering=:degrevlex)
    sys_z_t = [
        2 * x1^2 - 2 * x2^2 + 2 * x3^2 - 2 * x4^2 + 2 * x5^2 - 2 * x6^2 + 2 * x7^2 - 1
        2 * x1^3 - 2 * x2^3 + 2 * x3^3 - 2 * x4^3 + 2 * x5^3 - 2 * x6^3 + 2 * x7^3 - 1
        2 * x1^4 - 2 * x2^4 + 2 * x3^4 - 2 * x4^4 + 2 * x5^4 - 2 * x6^4 + 2 * x7^4 - 1
        2 * x1^5 - 2 * x2^5 + 2 * x3^5 - 2 * x4^5 + 2 * x5^5 - 2 * x6^5 + 2 * x7^5 - 1
        2 * x1^6 - 2 * x2^6 + 2 * x3^6 - 2 * x4^6 + 2 * x5^6 - 2 * x6^6 + 2 * x7^6 - 1
        2 * x1^7 - 2 * x2^7 + 2 * x3^7 - 2 * x4^7 + 2 * x5^7 - 2 * x6^7 + 2 * x7^7 - 1
        2 * x1^8 - 2 * x2^8 + 2 * x3^8 - 2 * x4^8 + 2 * x5^8 - 2 * x6^8 + 2 * x7^8 - 1
        -35 * x1 + 43 * x2 + 63 * x3 - 80 * x4 - 56 * x5 + 73 * x6 - 73 * x7 + _Z
    ]
    pr = 2^28
    bad = 268419493
    sys_zp0 = map(
        f -> AbstractAlgebra.change_base_ring(AbstractAlgebra.GF(Primes.prevprime(pr - 1)), f),
        sys_z_t
    )
    sys_zp2 = map(f -> AbstractAlgebra.change_base_ring(AbstractAlgebra.GF(bad), f), sys_z_t)
    trace, _ = Groebner.groebner_learn(sys_zp0, ordering=Groebner.DegRevLex())
    flag, gb = Groebner.groebner_apply!(trace, sys_zp2)
    @test true
end

@testset "regression, non-invertible composite pivot" begin
    R, (x, y, z) = polynomial_ring(QQ, ["x", "y", "z"])

    # Using a batch of 4 primes, some pivot vanishes modulo the first prime,
    # but does not vanish modulo the other three primes in the batch.
    p = BigInt(Primes.prevprime(Groebner.FIRST_LUCKY_PRIME_CANDIDATE - 1))
    system = [x^2 + p * y + 1, x * y + z + 1]

    gb = Groebner.groebner(system; homogenize=:no, tasks=1, _composite=4)
    expected = [
        y^3 + 1 // p * y^2 + 1 // p * z^2 + 2 // p * z + 1 // p,
        x * z + x - p * y^2 - y,
        x * y + z + 1,
        x^2 + p * y + 1
    ]

    @test gb == expected
end

# https://github.com/sumiya11/Groebner.jl/issues/175
@testset "regression, basis" begin
    R, (x1, x2) = polynomial_ring(QQ, ["x1", "x2"], internal_ordering=:deglex)
    set = [613 * x1^2 * x2^3 + 1413 * x1 * x2^2, 428 * x1^3 * x2 + 529 * x1 * x2^2]
    gb = groebner(set)
    @test isgroebner(gb)
end

@testset "regression, dimension with duplicate generators" begin
    R, x = polynomial_ring(QQ, ["x$i" for i in 1:5])
    system = [x[1]^2 - 1, x[1]^2 - 1, x[2]^2 - 2, x[2]^2 - 2]

    @test dimension(system) == 3
end

# https://github.com/sumiya11/Groebner.jl/issues/219
@testset "regression, rational change matrix reconstruction" begin
    R, (x,) = polynomial_ring(QQ, ["x"])
    coefficient = big(10)^10 + 1
    system = [coefficient * x + 1, x]

    basis, matrix = groebner_with_change_matrix(system; ordering=DegRevLex())

    @test matrix * system == basis
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# CRT

# Auxiliary functions allowing to avoid overflow
# on Windows for numbers between 32 and 64 bits
function my_set_ui!(a::BigInt, b::UInt64)
    @static if Culong == UInt64
        Base.GMP.MPZ.set_ui!(a, b)
    else
        if b < 2^32
            Base.GMP.MPZ.set_ui!(a, b)
        else
            Base.GMP.MPZ.set!(a, BigInt(b))
        end
    end
end

function my_mul_ui!(a::BigInt, b::BigInt, c::UInt64)
    @static if Culong == UInt64
        Base.GMP.MPZ.mul_ui!(a, b, c)
    else
        if c < 2^32
            Base.GMP.MPZ.mul_ui!(a, b, c)
        else
            Base.GMP.MPZ.mul!(a, b, BigInt(c))
        end
    end
end

function my_mul_ui!(a::BigInt, b::UInt64)
    @static if Culong == UInt64
        Base.GMP.MPZ.mul_ui!(a, b)
    else
        if b < 2^32
            Base.GMP.MPZ.mul_ui!(a, b)
        else
            Base.GMP.MPZ.mul!(a, BigInt(b))
        end
    end
end

"""
    crt!

Chinese Remainder lifting. Computes the unique `x` such that for all `i`
        
    x ≡ ai mod mi.

Writes the answer to `buf` inplace.

## Additional parameters:

- `M`: must be equal to `∏ mi`
- `buf`, `n1`, `n2`: additional buffers
- `ci`: an array of numbers, with `ci[i] = πi * invmod(πi, mi)`, `πi = M / mi`

Then, `x` is obtained as `x = ∑ ci[i] ai[i] mod M`.
"""
function crt!(M::BigInt, buf::BigInt, n1::BigInt, n2::BigInt, ai::Vector{UInt}, ci::Vector{BigInt})
    @invariant length(ai) == length(ci)

    my_set_ui!(n1, UInt(0))
    for i in 1:length(ai)
        my_mul_ui!(n2, ci[i], ai[i])
        Base.GMP.MPZ.add!(n1, n2)
    end

    Base.GMP.MPZ.set!(buf, n1)
    Base.GMP.MPZ.fdiv_r!(buf, M)

    nothing
end

"""
    crt_precompute!

Given the moduli, precomputes the multipliers `ci`, and the modulo `M` for CRT.

`n1` and `n2` are additional buffers.
"""
function crt_precompute!(
    M::BigInt,
    n1::BigInt,
    n2::BigInt,
    ci::Vector{BigInt},
    moduli::Vector{UInt}
)
    @invariant length(ci) == length(moduli)

    n3, n4 = BigInt(), BigInt()
    @inbounds my_set_ui!(M, moduli[1])
    @inbounds for i in 2:length(moduli)
        my_mul_ui!(M, moduli[i])
    end

    @inbounds for i in 1:length(moduli)
        my_set_ui!(n2, moduli[i])
        Base.GMP.MPZ.tdiv_q!(ci[i], M, n2)
        Base.GMP.MPZ.gcdext!(n2, n3, n4, ci[i], n2)
        Base.GMP.MPZ.mul!(ci[i], n3)
    end

    nothing
end

###
# Element-wise CRT

# Reconstructs only the witness set.
# Table of big integers must be initialized.
@timeit _TIMER function crt_vec_partial!(
    table_zz::Vector{Vector{BigInt}},
    modulo::BigInt,
    tables_ff::Vector{Vector{Vector{T}}},
    moduli::Vector{U},
    witness_set::Vector{Tuple{Int, Int}},
    mask::Vector{BitVector}
) where {T <: Integer, U <: Integer}
    @invariant length(tables_ff) == length(moduli)
    @invariant length(table_zz) == length(mask)

    # Precompute CRT multipliers
    buf, n1, n2 = BigInt(), BigInt(), BigInt()
    mults = Vector{BigInt}(undef, length(moduli))
    for i in 1:length(mults)
        mults[i] = BigInt()
    end

    crt_precompute!(modulo, n1, n2, mults, map(UInt64, moduli))

    rems = Vector{UInt64}(undef, length(moduli))
    @inbounds for k in 1:length(witness_set)
        i, j = witness_set[k]
        for t in 1:length(moduli)
            rems[t] = UInt64(tables_ff[t][i][j])
        end
        crt!(modulo, buf, n1, n2, rems, mults)
        Base.GMP.MPZ.set!(table_zz[i][j], buf)
        mask[i][j] = true
    end

    nothing
end

function _crt_vec_full!(
    table_zz::Vector{Vector{BigInt}},
    modulo::BigInt,
    buf::BigInt,
    n1::BigInt,
    n2::BigInt,
    rems::Vector{UInt64},
    tables_ff::Vector{Vector{Vector{T}}},
    mults::Vector{BigInt},
    moduli::Vector{U},
    chunk::Vector{Int},
    mask::Vector{BitVector}
) where {T <: Integer, U <: Integer}
    @inbounds for i in chunk
        @invariant length(table_zz[i]) == length(mask[i])
        for j in 1:length(table_zz[i])
            mask[i][j] && continue
            for k in 1:length(moduli)
                @invariant 0 <= tables_ff[k][i][j] < moduli[k]
                rems[k] = UInt64(tables_ff[k][i][j])
            end
            crt!(modulo, buf, n1, n2, rems, mults)
            Base.GMP.MPZ.set!(table_zz[i][j], buf)
        end
    end
    nothing
end

# Table of big integers must be initialized.
@timeit _TIMER function crt_vec_full!(
    table_zz::Vector{Vector{BigInt}},
    modulo::BigInt,
    tables_ff::Vector{Vector{Vector{T}}},
    moduli::Vector{U},
    mask::Vector{BitVector};
    tasks=1
) where {T <: Integer, U <: Integer}
    @invariant length(tables_ff) == length(moduli)
    @invariant length(table_zz) == length(mask)
    @invariant tasks >= 1 && !isempty(moduli)

    n1, n2 = BigInt(), BigInt()
    mults = Vector{BigInt}(undef, length(moduli))
    for i in 1:length(mults)
        mults[i] = BigInt()
    end

    crt_precompute!(modulo, n1, n2, mults, map(UInt64, moduli))

    tasks = min(tasks, length(table_zz))
    data_chunks = split_round_robin(1:length(table_zz), tasks)
    task_results = Vector{Task}(undef, tasks)
    for (tid, chunk) in enumerate(data_chunks)
        task = @spawn begin
            local buf, n1, n2 = BigInt(), BigInt(), BigInt()
            local rems = Vector{UInt64}(undef, length(moduli))
            _crt_vec_full!(
                table_zz,
                modulo,
                buf,
                n1,
                n2,
                rems,
                tables_ff,
                mults,
                moduli,
                chunk,
                mask
            )
        end
        task_results[tid] = task
    end
    for task in task_results
        wait(task)
    end
    nothing
end

using Test, Groebner

@testset "exponent vector" begin
    PV{T} = Groebner.ExponentVector{T} where {T}

    x = [1, 2, 3, 0, 4]
    ev = Groebner.monom_construct_from_vector(PV{UInt64}, x)
    @test ev == UInt64.([10, 1, 2, 3, 0, 4])
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt64
    @test Groebner.monom_totaldeg(ev) == UInt64(10)
    tmp = similar(x)
    @test Groebner.monom_to_vector!(tmp, ev) == x
    @test tmp == x

    @test Groebner.monom_overflow_check(ev)

    ev = Groebner.monom_construct_from_vector(PV{UInt32}, x)
    @test ev == UInt32.([10, 1, 2, 3, 0, 4])
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt32
    @test Groebner.monom_totaldeg(ev) == UInt32(10)

    for T in (UInt64, UInt32, UInt16, UInt8)
        for k in 1:10
            n = rand(1:20)
            x = rand(0:6, n)
            ev = Groebner.monom_construct_from_vector(PV{T}, x)
            tmp = similar(x)
            @test x == Groebner.monom_to_vector!(tmp, ev)
            @test x == tmp
        end
    end
end

import Pkg

include("../utils.jl")
julia_pkg_preamble("$(@__DIR__)")

using CpuId, Logging, Pkg, Printf
using Statistics

logger = Logging.ConsoleLogger(stdout, Logging.Info)
global_logger(logger)

const runtime = Dict()

const PROBLEM_NAME = ARGS[1]
const NUM_RUNS = parse(Int, ARGS[2])
const BENCHMARK_SET = parse(Int, ARGS[3])
const LIB_PATH = ARGS[4]
index1 = startswith(LIB_PATH, "/") ? 2 : 1
index2 = endswith(LIB_PATH, "/") ? length(LIB_PATH) - 1 : length(LIB_PATH)
const LIB_PATH_NORM = LIB_PATH[index1:index2]
const BENCHMARK_DIR = "../../" * get_benchmark_dir("openf4", BENCHMARK_SET)

@info "" ARGS
@info "" PROBLEM_NAME
@info "" NUM_RUNS
@info "" BENCHMARK_SET
@info "" "$(@__DIR__)"
flush(stdout)
flush(stderr)

function process_system()
    @info "Processing $PROBLEM_NAME"
    @info """
    Averaging over $NUM_RUNS runs."""

    runtime[PROBLEM_NAME] = Dict{Any, Any}()
    for cat in ALL_CATEGORIES
        runtime[PROBLEM_NAME][cat] = Inf
    end

    problempath = (@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/"
    cmd_compille = Cmd(
        `g++ $(problempath)$(PROBLEM_NAME).cpp -I/$LIB_PATH_NORM/include/ -L/$LIB_PATH_NORM/lib/ -lopenf4 -Wl,-rpath=/$LIB_PATH_NORM/lib/ -o $(problempath)$(PROBLEM_NAME)`,
        detach=false
    )
    proc = run(cmd_compille, wait=true)
    if proc.exitcode != 0
        @warn "Failed to compile for openf4"
        exit(1)
    end
    cd("$(problempath)")
    for iter in 1:NUM_RUNS
        @info "Computing GB.." iter
        cmd_exec = Cmd(["./$PROBLEM_NAME"])
        timing = @timed proc = run(cmd_exec, wait=true)
        @assert process_exited(proc)
        if proc.exitcode != 0
            @warn "Something probably went wrong in openf4"
            exit(1)
        end
        @debug "Result is" result
        runtime[PROBLEM_NAME][:total_time] = min(runtime[PROBLEM_NAME][:total_time], timing.time)
    end
end

function dump_timings()
    timings = ""
    timings *= "$PROBLEM_NAME\n"
    for (key, model_runtime) in runtime
        for c in [:total_time]
            timings *= "$c, "
            timings *= string(model_runtime[c]) * "\n"
        end
    end
    filename = timings_filename()
    open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "w") do io
        write(io, timings)
    end
end

process_system()
dump_timings()

using Test, Groebner

@testset "packed exponent tuple-1" begin
    EV{T, U} = Groebner.PackedTuple1{T, U} where {T, U}

    x = [1, 2, 3, 0, 4]
    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt8}, x)
    @test ev.a1 == 0x0a00000400030201
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt8
    @test Groebner.monom_totaldeg(ev) == UInt8(10)
    tmp = similar(x)
    @test Groebner.monom_to_vector!(tmp, ev) == [1, 2, 3, 0, 4]
    @test tmp == [1, 2, 3, 0, 4]

    @test Groebner.monom_max_vars(Groebner.PackedTuple1{UInt64, UInt8}) == 7
    @test Groebner.monom_max_vars(Groebner.PackedTuple1{UInt64, UInt16}) == 3

    y = [10, 20, 30, 40, 50]
    @test_throws Groebner.MonomialDegreeOverflow Groebner.monom_construct_from_vector(
        EV{UInt64, UInt8},
        y
    )

    for B in (UInt8, UInt16)
        for T in (UInt64, UInt32)
            for k in 1:10
                maxvars = div(sizeof(T), sizeof(B)) - 1
                n = rand(1:maxvars)
                @assert maxvars > 0
                x = rand(0:10, n)
                ev = Groebner.monom_construct_from_vector(EV{T, B}, x)
                tmp = similar(x)
                @test x == Groebner.monom_to_vector!(tmp, ev)
                @test x == tmp
            end
        end
    end
end

@testset "packed exponent tuple-2" begin
    EV{T, U} = Groebner.PackedTuple2{T, U} where {T, U}

    x = [i for i in 1:15]
    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt8}, x)
    @test ev.a1 == 0x780f0e0d0c0b0a09
    @test ev.a2 == 0x0807060504030201
    @test Groebner.monom_totaldeg(ev) == sum(x)
    tmp = similar(x)
    @test Groebner.monom_to_vector!(tmp, ev) == x

    x = [1, 2, 3, 0, 4]
    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt8}, x)
    @test ev.a1 == 0x0a00000400030201
    @test ev.a2 == 0x0000000000000000
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt8
    @test Groebner.monom_totaldeg(ev) == UInt8(10)
    tmp = similar(x)
    @test Groebner.monom_to_vector!(tmp, ev) == [1, 2, 3, 0, 4]

    @test Groebner.monom_max_vars(Groebner.PackedTuple2{UInt64, UInt8}) == 15
    @test Groebner.monom_max_vars(Groebner.PackedTuple2{UInt64, UInt16}) == 7

    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt16}, x)
    @test (ev.a1, ev.a2) == (0x000a000000000004, 0x0000000300020001)
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt16
    @test Groebner.monom_totaldeg(ev) == UInt16(10)

    y = [10, 20, 30, 40, 50]
    @test_throws Groebner.MonomialDegreeOverflow Groebner.monom_construct_from_vector(
        EV{UInt64, UInt8},
        y
    )

    for B in (UInt8, UInt16)
        for T in (UInt64, UInt32)
            for k in 1:10
                maxvars = 2 * div(sizeof(T), sizeof(B)) - 1
                n = rand(1:maxvars)
                @assert maxvars > 0
                x = rand(0:10, n)
                tmp = similar(x)
                ev = Groebner.monom_construct_from_vector(EV{T, B}, x)
                @test x == Groebner.monom_to_vector!(tmp, ev)
                @test x == tmp
            end
        end
    end
end

@testset "packed exponent tuple-3" begin
    EV{T, U} = Groebner.PackedTuple3{T, U} where {T, U}

    x = [div(i, 5) for i in 1:23]
    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt8}, x)
    @test ev.a1 == 0x2e04040404030303
    @test ev.a2 == 0x0303020202020201
    @test ev.a3 == 0x0101010100000000
    @test Groebner.monom_totaldeg(ev) == sum(x)
    tmp = similar(x)
    @test Groebner.monom_to_vector!(tmp, ev) == x

    x = [1, 2, 3, 0, 4]
    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt8}, x)
    @test ev.a1 == 0x0a00000400030201
    @test ev.a2 == 0x0000000000000000
    @test ev.a3 == 0x0000000000000000
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt8
    @test Groebner.monom_totaldeg(ev) == UInt8(10)
    tmp = similar(x)
    @test Groebner.monom_to_vector!(tmp, ev) == [1, 2, 3, 0, 4]

    @test Groebner.monom_max_vars(Groebner.PackedTuple3{UInt64, UInt8}) == 23
    @test Groebner.monom_max_vars(Groebner.PackedTuple3{UInt64, UInt16}) == 11

    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt16}, x)
    @test (ev.a1, ev.a2) == (0x000a000000000004, 0x0000000300020001)
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt16
    @test Groebner.monom_totaldeg(ev) == UInt16(10)

    y = [10, 20, 30, 40, 50]
    @test_throws Groebner.MonomialDegreeOverflow Groebner.monom_construct_from_vector(
        EV{UInt64, UInt8},
        y
    )

    y = [1, 2, 3, 4, 5]
    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt32}, y)
    @test ev.a1 == 0x0000000f00000005
    @test ev.a2 == 0x0000000400000003
    @test ev.a3 == 0x0000000200000001

    for B in (UInt8, UInt16)
        for T in (UInt64, UInt32)
            for k in 1:10
                maxvars = 3 * div(sizeof(T), sizeof(B)) - 1
                n = rand(1:maxvars)
                @assert maxvars > 0
                x = rand(0:div(typemax(B), 4 * n), n)
                tmp = similar(x)
                ev = Groebner.monom_construct_from_vector(EV{T, B}, x)
                @test x == Groebner.monom_to_vector!(tmp, ev)
                @test x == tmp
            end
        end
    end
end

@testset "packed exponent tuple-4" begin
    EV{T, U} = Groebner.PackedTuple4{T, U} where {T, U}

    x = [1, 2, 3, 0, 4]
    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt8}, x)
    @test ev.a1 == 0x0a00000400030201
    @test ev.a2 == 0x0000000000000000
    @test ev.a3 == 0x0000000000000000
    @test ev.a4 == 0x0000000000000000
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt8
    @test Groebner.monom_totaldeg(ev) == UInt8(10)
    tmp = similar(x)
    @test Groebner.monom_to_vector!(tmp, ev) == [1, 2, 3, 0, 4]

    @test Groebner.monom_max_vars(Groebner.PackedTuple4{UInt64, UInt8}) == 31
    @test typeof(Groebner.monom_totaldeg(ev)) === UInt8
    @test Groebner.monom_totaldeg(ev) == UInt8(10)

    y = [10, 20, 30, 40, 50]
    @test_throws Groebner.MonomialDegreeOverflow Groebner.monom_construct_from_vector(
        EV{UInt64, UInt8},
        y
    )

    y = [1, 2, 3, 4, 5]
    ev = Groebner.monom_construct_from_vector(EV{UInt64, UInt32}, y)
    @test ev.a1 == 0x0000000f00000005
    @test ev.a2 == 0x0000000400000003
    @test ev.a3 == 0x0000000200000001

    for B in (UInt8, UInt16)
        for T in (UInt64, UInt32)
            for k in 1:10
                maxvars = 4 * div(sizeof(T), sizeof(B)) - 1
                n = rand(1:maxvars)
                @assert maxvars > 0
                x = rand(0:div(typemax(B), 4 * n), n)
                tmp = similar(x)
                ev = Groebner.monom_construct_from_vector(EV{T, B}, x)
                @test x == Groebner.monom_to_vector!(tmp, ev)
                @test x == tmp
            end
        end
    end
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

###
# High level

function linalg_learn_sparse!(
    trace::Trace,
    matrix::MacaulayMatrix,
    basis::Basis,
    arithmetic::AbstractArithmetic
)
    sort_matrix_upper_rows!(matrix) # for the AB part
    sort_matrix_lower_rows!(matrix) # for the CD part

    # Reduce CD with AB
    linalg_learn_reduce_matrix_lower_part!(trace, matrix, basis, arithmetic)
    # Interreduce CD
    linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic)

    true
end

function linalg_apply_sparse!(
    trace::Trace,
    matrix::MacaulayMatrix,
    basis::Basis,
    arithmetic::AbstractArithmetic
)
    # NOTE: here, we do not need to sort the rows in the upper part, as they
    # have already been collected in the right order
    sort_matrix_lower_rows!(matrix) # for the CD part

    # Reduce CD with AB
    flag = linalg_apply_reduce_matrix_lower_part!(trace, matrix, basis, arithmetic)
    if !flag
        return flag
    end
    # Interreduce CD
    linalg_apply_interreduce_matrix_pivots!(trace, matrix, basis, arithmetic)

    true
end

function linalg_learn_deterministic_sparse_interreduction!(
    trace::Trace,
    matrix::MacaulayMatrix,
    basis::Basis,
    arithmetic::AbstractArithmetic
)
    # Prepare the matrix
    linalg_prepare_matrix_pivots_in_interreduction!(matrix, basis)
    # Interreduce AB
    linalg_learn_interreduce_matrix_pivots!(trace, matrix, basis, arithmetic, left_to_right=true)

    true
end

function linalg_apply_deterministic_sparse_interreduction!(
    trace::Trace,
    matrix::MacaulayMatrix,
    basis::Basis,
    arithmetic::AbstractArithmetic
)
    # Prepare the matrix
    linalg_prepare_matrix_pivots_in_interreduction!(matrix, basis)
    # Interreduce AB
    flag = linalg_apply_interreduce_matrix_pivots!(
        trace,
        matrix,
        basis,
        arithmetic,
        left_to_right=true
    )

    flag
end

###
# Low level

record_active_reducer(active_reducers::Nothing, matrix, idx) = nothing
function record_active_reducer(active_reducers, matrix, idx)
    push!(active_reducers, idx)
    nothing
end

# Returns `false` if any row reduced to zero (since we expect that on the apply
# stage the rows are linearly independent)
function linalg_apply_reduce_matrix_lower_part!(
    trace::Trace,
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    _, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_index_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, nlow)

    # Allocate the buffers
    row = [AccumType(zero(basis.coeffs[1][1])) for _ in 1:ncols]
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)

    @inbounds for i in 1:nlow
        # Select the row from the lower part of the matrix to be reduced
        sparse_row_support = matrix.lower_rows[i]
        # Locate the array of coefficients of this row.
        sparse_row_coeffs = basis.coeffs[row_index_to_coeffs[i]]

        @invariant length(sparse_row_support) == length(sparse_row_coeffs)

        # Load coefficients into a dense array
        linalg_load_sparse_row!(row, sparse_row_support, sparse_row_coeffs)

        # Reduce the row with respect to the known `pivots` from the upper part
        # of the matrix.
        first_nnz_column = sparse_row_support[1]
        zeroed = linalg_reduce_dense_row_by_pivots_sparse!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            first_nnz_column,
            ncols,
            arithmetic
        )

        # If the row is fully reduced
        if zeroed
            return false
        end

        @invariant length(new_sparse_row_coeffs) == length(new_sparse_row_support)
        success, _ = linalg_row_make_monic!(new_sparse_row_coeffs, arithmetic)
        !success && return false

        # Store the new row in the matrix, AND add it to the active pivots
        matrix.some_coeffs[i] = new_sparse_row_coeffs
        pivots[new_sparse_row_support[1]] = new_sparse_row_support
        # Set a reference to the coefficients of this row in the matrix
        matrix.lower_to_coeffs[new_sparse_row_support[1]] = i

        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
    end

    true
end

function linalg_learn_interreduce_matrix_pivots!(
    trace::Trace,
    matrix::MacaulayMatrix{C},
    basis::Basis{C},
    arithmetic::A;
    left_to_right::Bool=false
) where {C <: Coeff, A <: AbstractArithmetic}
    # Perform interreduction
    flag, _, not_reduced_to_zero =
        linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic, left_to_right=left_to_right)
    !flag && return flag

    # Update the computation trace
    _, ncols = size(matrix)
    nup, nlow = matrix_nrows_filled(matrix)
    push!(
        trace.matrix_infos,
        (nup=matrix.nrows_filled_upper, nlow=matrix.nrows_filled_lower, ncols=ncols)
    )
    push!(trace.matrix_nonzeroed_rows, not_reduced_to_zero)
    push!(trace.matrix_upper_rows, (matrix.upper_to_coeffs[1:nup], matrix.upper_to_mult[1:nup]))
    push!(trace.matrix_lower_rows, (Vector{Int}(), Vector{Int}()))

    true
end

function linalg_apply_interreduce_matrix_pivots!(
    trace::Trace,
    matrix::MacaulayMatrix{C},
    basis::Basis{C},
    arithmetic::A;
    left_to_right::Bool=false
) where {C <: Coeff, A <: AbstractArithmetic}
    flag, any_zeroed, _ =
        linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic, left_to_right=left_to_right)
    flag && !any_zeroed
end

function linalg_learn_reduce_matrix_lower_part!(
    trace::Trace,
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    nup, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_idx_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, nlow)

    # Allocate the buffers
    row = [AccumType(zero(basis.coeffs[1][1])) for _ in 1:ncols]
    not_reduced_to_zero = Vector{Int}()
    useful_reducers = Set{Int}()
    reducer_rows = Vector{Int}()
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)

    @inbounds for i in 1:nlow
        sparse_row_support = matrix.lower_rows[i]
        sparse_row_coeffs = basis.coeffs[row_idx_to_coeffs[i]]

        linalg_load_sparse_row!(row, sparse_row_support, sparse_row_coeffs)

        # Additionally record the indices of rows that participated in reduction
        # of the given row
        empty!(reducer_rows)
        first_nnz_column = sparse_row_support[1]
        zeroed = linalg_reduce_dense_row_by_pivots_sparse!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            first_nnz_column,
            ncols,
            arithmetic,
            reducer_rows
        )

        # if fully reduced
        zeroed && continue

        # NOTE: we are not recording reducers from the lower part of the matrix
        push!(not_reduced_to_zero, i)
        for reducer_row in reducer_rows
            push!(useful_reducers, reducer_row)
        end

        @invariant length(new_sparse_row_support) == length(new_sparse_row_coeffs)
        linalg_row_make_monic!(new_sparse_row_coeffs, arithmetic)

        matrix.some_coeffs[i] = new_sparse_row_coeffs
        pivots[new_sparse_row_support[1]] = new_sparse_row_support
        matrix.lower_to_coeffs[new_sparse_row_support[1]] = i

        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
    end

    # Update the tracer information
    # NOTE: we sort reducers by their original position in the array of pivots.
    # This way, the rows are already sorted at the apply stage.
    useful_reducers_sorted = sort(collect(useful_reducers))
    push!(
        trace.matrix_infos,
        (nup=matrix.nrows_filled_upper, nlow=matrix.nrows_filled_lower, ncols=ncols)
    )
    push!(trace.matrix_nonzeroed_rows, not_reduced_to_zero)
    push!(
        trace.matrix_upper_rows,
        (
            map(f -> matrix.upper_to_coeffs[f], useful_reducers_sorted),
            map(f -> matrix.upper_to_mult[f], useful_reducers_sorted)
        )
    )
    push!(
        trace.matrix_lower_rows,
        (row_idx_to_coeffs[not_reduced_to_zero], matrix.lower_to_mult[not_reduced_to_zero])
    )

    true
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

### 
# Main file that defines the f4! function.

@timeit _TIMER function f4_initialize_structs(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters;
    make_monic=true,
    sort_input=true
) where {M <: Monom, C <: Coeff}
    basis = basis_initialize(ring, length(monoms), C)
    pairset = pairset_initialize(typeof(monom_totaldeg(monoms[1][1])))
    hashtable = hashtable_initialize(ring, params.rng, M; use_divmask=params.use_divmask)

    basis_fill_data!(basis, hashtable, monoms, coeffs)
    hashtable_fill_divmasks!(hashtable)

    if params.changematrix
        basis_changematrix_initialize!(basis, hashtable)
    end

    if sort_input
        # The order of polynomials is not deterministic across different Julia
        # versions when sorting only w.r.t. the leading term.
        permutation = sort_polys_by_lead_increasing!(basis, hashtable, params.changematrix)
    else
        permutation = collect(1:(basis.n_filled))
    end

    # We do not need monic polynomials when computing normal forms
    if make_monic
        basis_make_monic!(basis, params.arithmetic, params.changematrix)
    end

    basis, pairset, hashtable, permutation
end

@timeit _TIMER function f4_reduction!(
    ring::PolyRing,
    basis::Basis,
    matrix::MacaulayMatrix,
    ht::MonomialHashtable,
    symbol_ht::MonomialHashtable,
    params::AlgorithmParameters
)
    matrix_fill_column_to_monom_map!(matrix, symbol_ht)
    linalg_main!(matrix, basis, params)
    matrix_convert_rows_to_basis_elements!(
        matrix,
        basis,
        ht,
        symbol_ht,
        params;
        batched_ht_insert=true
    )
end

@timeit _TIMER function f4_update!(
    pairset::Pairset,
    basis::Basis,
    ht::MonomialHashtable,
    update_ht::MonomialHashtable
)
    @invariant basis.n_processed <= basis.n_filled
    for i in (basis.n_processed + 1):(basis.n_filled)
        basis_mark_redundant_elements!(pairset, basis, ht, update_ht, i)
        pairset_update!(pairset, basis, ht, update_ht, i)
    end
    basis_update!(basis, ht)
end

# Monomials that represent the columns of the matrix are stored in the symbol_ht
# hashtable.
# We traverse monomials searching for a reducer for each monomial. The hashtable
# may grow as reducers are added to the matrix, and the loop accounts for that.
@timeit _TIMER function f4_symbolic_preprocessing!(
    basis::Basis,
    matrix::MacaulayMatrix,
    ht::MonomialHashtable,
    symbol_ht::MonomialHashtable
)
    matrix_resize_upper_part_if_needed!(matrix, matrix.ncols_left + symbol_ht.load)
    i = symbol_ht.offset
    @inbounds while i <= symbol_ht.load
        if symbol_ht.labels[i] != NON_PIVOT_COLUMN
            i += 1
            continue
        end
        matrix_resize_upper_part_if_needed!(matrix, matrix.nrows_filled_upper + 1)

        symbol_ht.labels[i] = UNKNOWN_PIVOT_COLUMN
        matrix.ncols_left += 1
        f4_find_multiplied_reducer!(basis, matrix, ht, symbol_ht, MonomId(i))
        i += 1
    end
end

@timeit _TIMER function f4_autoreduce!(
    ring::PolyRing,
    basis::Basis,
    matrix::MacaulayMatrix,
    ht::MonomialHashtable{M},
    symbol_ht::MonomialHashtable{M},
    params::AlgorithmParameters
) where {M <: Monom}
    etmp = monom_construct_const(M, ht.nvars)

    matrix_reinitialize!(matrix, basis.n_nonredundant)
    uprows = matrix.upper_rows
    lowrows = matrix.lower_rows

    @inbounds for i in 1:(basis.n_nonredundant)
        matrix.nrows_filled_upper += 1
        row_idx = matrix.nrows_filled_upper
        uprows[row_idx] = matrix_polynomial_multiple_to_row!(
            matrix,
            symbol_ht,
            ht,
            MonomHash(0),
            etmp,
            basis.monoms[basis.nonredundant_indices[i]]
        )
        matrix.upper_to_coeffs[row_idx] = basis.nonredundant_indices[i]
        matrix.upper_to_mult[row_idx] = hashtable_insert!(ht, etmp)
        symbol_ht.labels[uprows[row_idx][1]] = UNKNOWN_PIVOT_COLUMN
    end

    f4_symbolic_preprocessing!(basis, matrix, ht, symbol_ht)

    @inbounds for i in (symbol_ht.offset):(symbol_ht.load)
        symbol_ht.labels[i] = UNKNOWN_PIVOT_COLUMN
    end

    matrix_fill_column_to_monom_map!(matrix, symbol_ht)

    linalg_autoreduce!(matrix, basis, params)

    matrix_convert_rows_to_basis_elements!(matrix, basis, ht, symbol_ht, params)

    basis.n_filled = matrix.npivots + basis.n_processed
    basis.n_processed = matrix.npivots

    k = 0
    i = 1
    @label Letsgo
    @inbounds while i <= basis.n_processed
        @inbounds for j in 1:k
            if hashtable_monom_is_divisible(
                basis.monoms[basis.n_filled - i + 1][1],
                basis.monoms[basis.nonredundant_indices[j]][1],
                ht
            )
                i += 1
                @goto Letsgo
            end
        end
        k += 1
        basis.nonredundant_indices[k] = basis.n_filled - i + 1
        basis.divmasks[k] = ht.divmasks[basis.monoms[basis.nonredundant_indices[k]][1]]
        i += 1
    end
    basis.n_nonredundant = k
end

function f4_select_tobereduced!(
    basis::Basis,
    tobereduced::Basis{C},
    matrix::MacaulayMatrix,
    symbol_ht::MonomialHashtable{M},
    ht::MonomialHashtable{M}
) where {C, M}
    matrix_reinitialize!(matrix, max(basis.n_filled, tobereduced.n_filled))
    resize!(matrix.lower_rows, tobereduced.n_filled)
    resize!(matrix.some_coeffs, tobereduced.n_filled)

    etmp = monom_construct_const(M, ht.nvars)

    @inbounds for i in 1:(tobereduced.n_filled)
        matrix.nrows_filled_lower += 1
        row_idx = matrix.nrows_filled_lower

        gen = tobereduced.monoms[i]
        h = MonomHash(0)
        matrix.lower_rows[row_idx] =
            matrix_polynomial_multiple_to_row!(matrix, symbol_ht, ht, h, etmp, gen)
        matrix.lower_to_coeffs[row_idx] = i
        # TODO: not really needed here
        matrix.lower_to_mult[row_idx] = hashtable_insert!(ht, etmp)
        matrix.some_coeffs[row_idx] = tobereduced.coeffs[i]
    end

    basis.n_nonredundant = basis.n_processed = basis.n_filled
    basis.is_redundant .= 0
    @inbounds for i in 1:(basis.n_nonredundant)
        basis.nonredundant_indices[i] = i
        basis.divmasks[i] = ht.divmasks[basis.monoms[i][1]]
    end
end

const _DIVMASK_CHECKS = Ref{Int}(0)
const _DIVMASK_FALSE_POSITIVES = Ref{Int}(0)

function f4_find_lead_divisor_use_divmask(i, divmask, basis)
    lead_divmasks = basis.divmasks
    @inbounds while i <= basis.n_nonredundant
        _DIVMASK_CHECKS[] += 1
        if divmask_is_probably_divisible(divmask, lead_divmasks[i])
            break
        end
        i += 1
    end
    i
end

function f4_find_lead_divisor(i, monom, basis, ht)
    @inbounds while i <= basis.n_nonredundant
        lead_monom = ht.monoms[basis.monoms[basis.nonredundant_indices[i]][1]]
        if monom_is_divisible(monom, lead_monom)
            break
        end
        i += 1
    end
    i
end

# Finds a polynomial from the basis with the leading term that divides the given
# monomial. If such a polynomial is found, writes a multiple of it to the
# symbolic hashtable.
function f4_find_multiplied_reducer!(
    basis::Basis,
    matrix::MacaulayMatrix,
    ht::MonomialHashtable,
    symbol_ht::MonomialHashtable,
    monomid::MonomId
)
    @inbounds monom = symbol_ht.monoms[monomid]
    @inbounds quotient = ht.monoms[1]
    @inbounds divmask = symbol_ht.divmasks[monomid]

    # Start of the search loop.
    i = 1
    @label Letsgo

    if ht.use_divmask
        i = f4_find_lead_divisor_use_divmask(i, divmask, basis)
    else
        i = f4_find_lead_divisor(i, monom, basis, ht)
    end

    # Reducer is not found, yield.
    i > basis.n_nonredundant && return nothing

    # Here, we have found a polynomial from the basis with the leading monom
    # that divides the given monom.
    @inbounds poly = basis.monoms[basis.nonredundant_indices[i]]
    @inbounds lead = ht.monoms[poly[1]]

    success, quotient = monom_is_divisible!(quotient, monom, lead)
    if !success # division mask failed for some reason
        i += 1
        _DIVMASK_FALSE_POSITIVES[] += 1
        @goto Letsgo
    end

    # Using the fact that the hash is linear.
    @inbounds quotient_hash = symbol_ht.hashvals[monomid] - ht.hashvals[poly[1]]
    @invariant quotient_hash == monom_hash(quotient, ht.hash_vector)

    hashtable_resize_if_needed!(ht, length(poly))
    row = matrix_polynomial_multiple_to_row!(matrix, symbol_ht, ht, quotient_hash, quotient, poly)
    matrix.nrows_filled_upper += 1
    row_id = matrix.nrows_filled_upper
    @inbounds matrix.upper_rows[row_id] = row
    @inbounds matrix.upper_to_coeffs[row_id] = basis.nonredundant_indices[i]

    # Insert the quotient into the main hashtable.
    # TODO: This line is here with one sole purpose -- to support tracing.
    #       Probably want to factor it out.
    @inbounds matrix.upper_to_mult[row_id] = hashtable_insert!(ht, quotient)

    # Mark the current monomial as a pivot since a reducer has been found.
    @inbounds symbol_ht.labels[monomid] = PIVOT_COLUMN

    nothing
end

const _MAX_DEG = Ref{Int}(0)

@timeit _TIMER function f4_select_critical_pairs!(
    pairset::Pairset,
    basis::Basis,
    matrix::MacaulayMatrix,
    ht::MonomialHashtable,
    symbol_ht::MonomialHashtable;
    select_all::Bool=false
)
    if select_all
        npairs = pairset.load
    else
        npairs = pairset_partition_by_degree!(pairset)
    end
    @invariant npairs > 0

    sort_pairset_by_lcm!(pairset, npairs, ht)

    f4_add_critical_pairs_to_matrix!(pairset, npairs, basis, matrix, ht, symbol_ht)

    deg = pairset.degrees[1]
    _MAX_DEG[] = max(_MAX_DEG[], deg)

    # Remove selected pairs from the pairset.
    @inbounds for i in 1:(pairset.load - npairs)
        pairset.pairs[i] = pairset.pairs[i + npairs]
        pairset.degrees[i] = pairset.degrees[i + npairs]
    end
    pairset.load -= npairs

    deg, npairs
end

function f4_add_critical_pairs_to_matrix!(
    pairset::Pairset,
    npairs::Int,
    basis::Basis,
    matrix::MacaulayMatrix,
    ht::MonomialHashtable,
    symbol_ht::MonomialHashtable
)
    matrix_reinitialize!(matrix, npairs)
    pairs = pairset.pairs
    uprows = matrix.upper_rows
    lowrows = matrix.lower_rows

    polys = Vector{Int}(undef, 2 * npairs)
    @inbounds etmp = ht.monoms[1]

    i = 1
    @inbounds while i <= npairs
        npolys = 1
        lcm = pairs[i].lcm
        j = i
        while j <= npairs && pairs[j].lcm == lcm
            polys[npolys] = pairs[j].poly1
            npolys += 1
            polys[npolys] = pairs[j].poly2
            npolys += 1
            j += 1
        end
        npolys -= 1

        sort_generators_by_position!(polys, npolys)

        prev = polys[1]
        vidx = basis.monoms[prev][1]
        etmp = monom_division!(etmp, ht.monoms[lcm], ht.monoms[vidx])
        htmp = ht.hashvals[lcm] - ht.hashvals[vidx]

        matrix.ncols_left += 1

        matrix.nrows_filled_upper += 1
        row_idx = matrix.nrows_filled_upper
        uprows[row_idx] = matrix_polynomial_multiple_to_row!(
            matrix,
            symbol_ht,
            ht,
            htmp,
            etmp,
            basis.monoms[prev]
        )
        matrix.upper_to_coeffs[row_idx] = prev
        matrix.upper_to_mult[row_idx] = hashtable_insert!(ht, etmp)

        symbol_ht.labels[uprows[row_idx][1]] = PIVOT_COLUMN

        for k in 1:npolys
            polys[k] == prev && continue

            # hashtable could have been reallocated, so refresh the pointer.
            elcm = ht.monoms[lcm]

            prev = polys[k]
            vidx = basis.monoms[prev][1]
            eidx = ht.monoms[vidx]
            etmp = monom_division!(etmp, elcm, eidx)
            htmp = ht.hashvals[lcm] - ht.hashvals[vidx]

            matrix.nrows_filled_lower += 1
            row_idx = matrix.nrows_filled_lower
            lowrows[row_idx] = matrix_polynomial_multiple_to_row!(
                matrix,
                symbol_ht,
                ht,
                htmp,
                etmp,
                basis.monoms[prev]
            )
            matrix.lower_to_coeffs[row_idx] = prev
            matrix.lower_to_mult[row_idx] = hashtable_insert!(ht, etmp)

            symbol_ht.labels[lowrows[row_idx][1]] = PIVOT_COLUMN
        end

        i = j
    end
end

@timeit _TIMER function f4!(
    ring::PolyRing,
    basis::Basis{C},
    pairset::Pairset,
    hashtable::MonomialHashtable{M},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    @invariant basis_well_formed(ring, basis, hashtable)
    @invariant basis.n_processed == basis.n_nonredundant == 0

    basis_make_monic!(basis, params.arithmetic, params.changematrix)

    matrix = matrix_initialize(ring, C)
    update_ht = hashtable_initialize_secondary(hashtable)
    symbol_ht = hashtable_initialize_secondary(hashtable)

    f4_update!(pairset, basis, hashtable, update_ht)

    while !isempty(pairset)
        f4_select_critical_pairs!(pairset, basis, matrix, hashtable, symbol_ht)
        f4_symbolic_preprocessing!(basis, matrix, hashtable, symbol_ht)
        f4_reduction!(ring, basis, matrix, hashtable, symbol_ht, params)
        f4_update!(pairset, basis, hashtable, update_ht)
        hashtable_reinitialize!(symbol_ht)
    end

    basis_discard_redundant_elements!(basis)

    if params.reduced
        f4_autoreduce!(ring, basis, matrix, hashtable, symbol_ht, params)
    end

    basis_standardize!(ring, basis, hashtable, params.arithmetic, params.changematrix)

    @invariant basis_well_formed(ring, basis, hashtable)
    @invariant basis.n_processed == basis.n_nonredundant == basis.n_filled

    nothing
end

function f4_isgroebner!(
    ring::PolyRing,
    basis::Basis{C},
    pairset::Pairset,
    hashtable::MonomialHashtable,
    params::AlgorithmParameters
) where {C <: Coeff}
    @invariant basis_well_formed(ring, basis, hashtable)
    @invariant basis.n_processed == basis.n_nonredundant == 0
    basis_make_monic!(basis, params.arithmetic, false)
    matrix = matrix_initialize(ring, C)
    symbol_ht = hashtable_initialize_secondary(hashtable)
    update_ht = hashtable_initialize_secondary(hashtable)
    f4_update!(pairset, basis, hashtable, update_ht)
    isempty(pairset) && return true
    f4_select_critical_pairs!(pairset, basis, matrix, hashtable, symbol_ht, select_all=true)
    f4_symbolic_preprocessing!(basis, matrix, hashtable, symbol_ht)
    matrix_fill_column_to_monom_map!(matrix, symbol_ht)
    linalg_isgroebner!(matrix, basis, params)
end

function f4_normalform!(
    ring::PolyRing,
    basis::Basis{C},
    tobereduced::Basis{C},
    ht::MonomialHashtable,
    arithmetic::AbstractArithmetic
) where {C <: Coeff}
    @invariant basis_well_formed(ring, basis, ht)
    basis_make_monic!(basis, arithmetic, false)
    matrix = matrix_initialize(ring, C)
    symbol_ht = hashtable_initialize_secondary(ht)
    f4_select_tobereduced!(basis, tobereduced, matrix, symbol_ht, ht)
    f4_symbolic_preprocessing!(basis, matrix, ht, symbol_ht)
    matrix_fill_column_to_monom_map!(matrix, symbol_ht)
    linalg_normalform!(matrix, basis, arithmetic)
    matrix_convert_rows_to_basis_elements_nf!(matrix, tobereduced, ht, symbol_ht)
    nothing
end

using Groebner, AbstractAlgebra, Test

@testset "leading term" begin
    R, (x, y) = QQ["x", "y"]

    @test Groebner.leading_term(2x - 3y) == 2x
    @test Groebner.leading_term(2x - 3y, ordering=Lex(x, y)) == 2x
    @test Groebner.leading_term(2x - 3y, ordering=Lex(y, x)) == -3y

    @test_throws DomainError Groebner.leading_term([1, 2, 3])

    R, (X, Y) = fraction_field(R)["X", "Y"]
    @test Groebner.leading_term(2 * x * Y - 3 * y * X, ordering=Lex(X, Y)) == -3 * y * X
    @test Groebner.leading_term(2 * x * Y - 3 * y * X, ordering=Lex(Y, X)) == 2 * x * Y
    @test Groebner.leading_term(zero(R)) == zero(R)
    @test Groebner.leading_term(-one(R)) == -one(R)
end

@testset "leading ideal" begin
    R, (x, y) = QQ["x", "y"]
    @test Groebner.leading_ideal([R(5)]) == [R(1)]
    @test Groebner.leading_ideal([x - 5, y - 1]) == [y, x]
    @test Groebner.leading_ideal([x * y, y, x, R(0)]) == [y, x]
    @test Groebner.leading_ideal([x^1000]) == [x^1000]
    @test Groebner.leading_ideal([R(0), x, R(0)]) == [x]

    @test_throws DomainError Groebner.leading_ideal([1, 2, 3])

    x0, x1, x2, x3 = gens(parent(Groebner.Examples.katsuran(3)[1]))
    @test Groebner.leading_ideal(Groebner.Examples.katsuran(3), ordering=Lex()) ==
          [x3^8, x2, x1, x0]

    x0, x1, x2, x3 = gens(parent(Groebner.Examples.katsuran(3)[1]))
    @test Groebner.leading_ideal(Groebner.Examples.katsuran(3), ordering=DegRevLex()) ==
          [x0, x2^2, x1 * x2, x1^2, x2 * x3^2, x1 * x3^2, x3^4]
end

@testset "quotient basis" begin
    R, (x, y) = QQ["x", "y"]
    @test Groebner.quotient_basis([R(5)]) == Vector{elem_type(R)}()
    @test Groebner.quotient_basis([x - 5, y - 1]) == [R(1)]
    @test Groebner.quotient_basis([x * y, y, x, R(0)]) == [R(1)]
    @test length(Groebner.quotient_basis([x^100, y^2])) == 100 * 2
    @test Groebner.quotient_basis([R(0), x, R(0), y]) == [R(1)]

    @test_throws DomainError Groebner.quotient_basis([])
    @test_throws DomainError Groebner.quotient_basis([x])
    @test_throws DomainError Groebner.quotient_basis([R(0)])

    for k in [
        AbstractAlgebra.GF(2^30 + 3),
        fraction_field(AbstractAlgebra.QQ["t"][1]),
        AbstractAlgebra.QQ
    ]
        for (i, sys) in enumerate([
            Groebner.Examples.katsuran(1, k=k),
            Groebner.Examples.katsuran(2, k=k),
            Groebner.Examples.katsuran(3, k=k)
        ])
            @test length(Groebner.quotient_basis(sys)) == 2^i
        end
    end
end

@testset "dimension" begin
    R, (x, y) = QQ["x", "y"]
    @test Groebner.dimension([R(5)]) == -1
    @test Groebner.dimension([x - 5, y - 1]) == 0
    @test Groebner.dimension([x - 5]) == 1
    @test Groebner.dimension([R(0)]) == -1
    @test Groebner.dimension([x * y, y, x, R(0)]) == 0

    @test_throws DomainError Groebner.dimension([])

    n = 100
    R, x = polynomial_ring(AbstractAlgebra.GF(2^30 + 3), ["x$i" for i in 1:n])
    @test Groebner.dimension([sum(x)]) == n - 1
    @test Groebner.dimension([sum(x), prod(x), sum([i for i in 1:n] .* x)]) == n - 3
end

# @testset "auxiliary funcs, low level" begin
#
#     ring_qq = Groebner.PolyRing(2, Groebner.DegRevLex(), 0)
#     @test 1 == Groebner.dimension(ring_qq, [[[0, 0], [1, 1]]], [[3, 4]])
#     @test 0 == Groebner.dimension(ring_qq, [[[1, 0]], [[0, 1]]], [[3], [-7]])
#     @test -1 == Groebner.dimension(ring_qq, [[[1, 0]], [[0, 1]]], [[0], [0]])
# end

using SmallCollections: FixedVector, SmallVector, fixedvector, sum_fast, dot_fast, bits

struct NibbleMonom{N}
    ev::FixedVector{N, UInt8}
    deg::UInt8
end

function NibbleMonom(ev::FixedVector{N}) where {N}
    a = NibbleMonom(ev, zero(UInt8))
    @invariant sum(i -> monom_exponent(a, i), 1:monom_max_vars(a)) <= typemax(UInt16)
    d = sum_fast(lownibbles(a) + highnibbles(a); init=zero(UInt16))
    d > typemax(UInt8) && __throw_monom_overflow_error()
    NibbleMonom(ev, d % UInt8)
end

Base.@propagate_inbounds function monom_exponent(a::NibbleMonom, i::Int)
    @invariant 1 <= i <= 2 * length(a.ev)
    isodd(i) ? a.ev[i ÷ 2 + 1] & 0x0f : a.ev[i ÷ 2] >> 4
end

lownibbles(a::NibbleMonom) = a.ev .& 0x0f
highnibbles(a::NibbleMonom) = a.ev .>> 4
uppernibbles(a::NibbleMonom) = a.ev .& 0xf0

monom_max_vars(a::NibbleMonom) = monom_max_vars(typeof(a))

monom_max_vars(::Type{<:NibbleMonom{N}}) where {N} = 2 * N
monom_totaldeg(a::NibbleMonom) = a.deg % UInt8
monom_copy(a::NibbleMonom) = a

function monom_construct_hash_vector(rng::AbstractRNG, ::Type{NibbleMonom{N}}, ::Integer) where {N}
    rand(rng, FixedVector{N, MonomHash})
end

function monom_construct_from_vector(::Type{NibbleMonom{N}}, ev::AbstractVector) where {N}
    all(<=(15), ev) || __throw_monom_overflow_error()
    v = fixedvector(SmallVector{2 * N, UInt8}(ev))
    ev = FixedVector{N}(view(v, 1:2:(2 * N - 1))) .| (FixedVector{N}(view(v, 2:2:(2 * N))) .<< 4)
    NibbleMonom(ev)
end

function monom_construct_const(::Type{NibbleMonom{N}}, ::Integer) where {N}
    NibbleMonom(zero(FixedVector{N, UInt8}))
end

function monom_hash(a::NibbleMonom{N}, b::FixedVector{N}) where {N}
    dot_fast(a.ev, b)::MonomHash
end

function monom_to_vector!(tmp::AbstractVector, a::NibbleMonom)
    for i in 1:length(tmp)
        @inbounds tmp[i] = monom_exponent(a, i)
    end
    tmp
end

function monom_is_supported_ordering(::Type{<:NibbleMonom}, ::Ord) where {Ord}
    Ord <: Union{DegLex{true}, DegRevLex{true}, InputOrdering}
end

function monom_isless(a::NibbleMonom{N}, b::NibbleMonom{N}, ::DegLex{true}) where {N}
    a.deg != b.deg && return a.deg < b.deg
    for (k, l) in zip(a.ev, b.ev)
        k != l && return bitrotate(k, 4) < bitrotate(l, 4)
    end
    false
end

function monom_isless(a::NibbleMonom{N}, b::NibbleMonom{N}, ::DegRevLex{true}) where {N}
    a.deg < b.deg || (a.deg == b.deg && bits(a.ev) > bits(b.ev))
end

function monom_lcm!(_, a::NibbleMonom{N}, b::NibbleMonom{N}) where {N}
    NibbleMonom(max.(lownibbles(a), lownibbles(b)) .| max.(uppernibbles(a), uppernibbles(b)))
end

function monom_is_gcd_const(a::NibbleMonom{N}, b::NibbleMonom{N}) where {N}
    iszero(min.(lownibbles(a), lownibbles(b)) .| min.(uppernibbles(a), uppernibbles(b)))
end

function monom_product!(_, a::NibbleMonom{N}, b::NibbleMonom{N}) where {N}
    ev, s = Base.Checked.add_with_overflow(a.ev, b.ev)
    lower_check = (ev .⊻ a.ev .⊻ b.ev) .& 0x10
    if isempty(s) & iszero(lower_check)
        d = a.deg + b.deg
        d < a.deg && __throw_monom_overflow_error()
        NibbleMonom(ev, d)
    else
        __throw_monom_overflow_error()
    end
end

function monom_division!(_, a::NibbleMonom{N}, b::NibbleMonom{N}) where {N}
    NibbleMonom(a.ev - b.ev, a.deg - b.deg)
end

function monom_is_divisible(a::NibbleMonom{N}, b::NibbleMonom{N}) where {N}
    first(monom_is_divisible!(a, a, b))  # the first `a` is a dummy
end

function monom_is_divisible!(_, a::NibbleMonom{N}, b::NibbleMonom{N}) where {N}
    ev, s = Base.Checked.sub_with_overflow(a.ev, b.ev)
    lower_check = iszero((ev .⊻ a.ev .⊻ b.ev) .& 0x10)
    isempty(s) & lower_check, NibbleMonom(ev, a.deg - b.deg)
end

function monom_is_equal(a::NibbleMonom{N}, b::NibbleMonom{N}) where {N}
    a.ev == b.ev
end

function monom_create_divmask(
    a::NibbleMonom,
    ::Type{Mask},
    ndivvars::Int,
    divmap::Vector{U},
    ndivbits::Int,
    strategy::Symbol
) where {Mask, U}
    @invariant strategy == :first_variables
    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)
    @inbounds for i in 1:ndivvars
        for _ in 1:ndivbits
            if monom_exponent(a, i) >= divmap[ctr]
                res |= o << ((ctr - 1) % UInt)
            end
            ctr += o
        end
    end
    res
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Handling keyword arguments for functions in the interface.

const INT_INF = typemax(Int)

#! format: off
# Syntax formatting is disabled for the next several lines.
#
# Maps a function name from the interface to a set of supported keyword
# arguments with their corresponding default values.
const _supported_kw_args = (
    dimension = (
        monoms       = :auto,
    ),
    groebner = (
        reduced      = true,
        ordering     = InputOrdering(),
        certify      = false,
        linalg       = :auto,
        monoms       = :auto,
        arithmetic   = :auto,
        seed         = 42,
        selection    = :auto,
        modular      = :auto,
        tasks        = :auto,
        homogenize   = :auto,
        changematrix = false,
        _composite   = 4,
        _generic     = false,
        _use_divmask = true,
    ),
    groebner_apply! = (
        seed        = 42,
        ordering    = InputOrdering(),
        monoms      = :auto,
        arithmetic  = :auto,
        tasks       = :auto,
        _generic     = false,
    ),
    groebner_learn = (
        seed        = 42,
        ordering    = InputOrdering(),
        monoms      = :auto,
        arithmetic  = :auto,
        homogenize  = :auto,
        tasks       = :auto,
        _generic     = false,
    ),
    groebner_with_change_matrix = (
        reduced      = true,
        ordering     = InputOrdering(),
        certify      = false,
        linalg       = :auto,
        monoms       = :auto,
        arithmetic   = :auto,
        seed         = 42,
        selection    = :auto,
        modular      = :auto,
        tasks        = :auto,
        homogenize   = :auto,
        changematrix = true,
        _composite   = 4,
    ),
    isgroebner = (
        ordering    = InputOrdering(),
        certify     = false,
        seed        = 42,
        monoms      = :auto,
        linalg      = :auto,
    ),
    leading_term = (
        ordering    = InputOrdering(),
        monoms      = :auto,
    ),
    leading_ideal = (
        ordering    = InputOrdering(),
        monoms      = :auto,
    ),
    normalform = (
        check       = false,
        ordering    = InputOrdering(),
        monoms      = :auto,
    ),
    quotient_basis = (
        ordering    = InputOrdering(),
        monoms      = :auto,
    ),
)
#! format: on

mutable struct KeywordArguments
    function_id::Symbol
    reduced::Bool
    ordering::Any
    certify::Bool
    linalg::Symbol
    tasks::Any
    monoms::Symbol
    arithmetic::Symbol
    seed::Int
    selection::Symbol
    modular::Symbol
    _composite::Int
    check::Bool
    homogenize::Symbol
    _use_divmask::Bool
    changematrix::Bool
    _generic::Bool
end

function KeywordArguments(function_id::Symbol, kws)
    @assert haskey(_supported_kw_args, function_id)
    default_kw_args = _supported_kw_args[function_id]
    for (key, _) in kws
        if !haskey(default_kw_args, key)
            error_msg = join(sort(map(string, collect(keys(default_kw_args)))), ", ")
            throw(AssertionError("""
            Keyword \"$key\" is not supported by Groebner.$(function_id).
            Supported keyword arguments for Groebner.$(function_id) are:\n$error_msg"""))
        end
    end

    reduced = get(kws, :reduced, get(default_kw_args, :reduced, true))
    ordering = get(kws, :ordering, get(default_kw_args, :ordering, InputOrdering()))
    certify = get(kws, :certify, get(default_kw_args, :certify, false))

    linalg = get(kws, :linalg, get(default_kw_args, :linalg, :auto))
    @assert linalg in
            (:auto, :randomized, :deterministic, :experimental_1, :experimental_2, :experimental_3) """
                                                                                                  Not recognized linear algebra option: $linalg
                                                                                                  Possible choices for keyword "linalg" are:
                                                                                                  `:auto`, `:randomized`, `:deterministic`"""

    tasks = get(kws, :tasks, get(default_kw_args, :tasks, :auto))
    @assert tasks === :auto || (tasks isa Integer && tasks >= 1) """
    Not recognized tasks option: $tasks
    Possible choices for keyword "tasks" are:
    `:auto`, `1`, `2`, `3`, ... (any positive integer)"""

    monoms = get(kws, :monoms, get(default_kw_args, :monoms, :dense))
    @assert monoms in (:auto, :dense, :packed, :fixed, :fixed2, :fixednodeg, :nibble, :nibblenodeg) """
    Not recognized monomial representation: $monoms
    Possible choices for keyword "monoms" are:
    `:auto`, `:dense`, `:packed`, `:nibble`"""

    arithmetic = get(kws, :arithmetic, get(default_kw_args, :arithmetic, :auto))
    @assert arithmetic in (:auto, :delayed, :signed, :basic) """
    Not recognized arithmetic: $arithmetic
    Possible choices for keyword "arithmetic" are:
    `:auto`, `:delayed`, `:signed`, `:basic`"""

    seed = get(kws, :seed, get(default_kw_args, :seed, 42))

    modular = get(kws, :modular, get(default_kw_args, :modular, :auto))
    @assert modular in (:auto, :classic_modular, :learn_and_apply) """
    Not recognized modular strategy: $modular
    Possible choices for keyword "modular" are:
    `:auto`, `:classic_modular`, `:learn_and_apply`"""

    _composite = get(kws, :_composite, get(default_kw_args, :_composite, 4))
    _use_divmask = get(kws, :_use_divmask, get(default_kw_args, :_use_divmask, true))

    selection = get(kws, :selection, get(default_kw_args, :selection, :auto))
    @assert selection in (:auto, :normal, :sugar, :be_divided_and_perish)

    check = get(kws, :check, get(default_kw_args, :check, true))
    homogenize = get(kws, :homogenize, get(default_kw_args, :homogenize, :auto))
    @assert homogenize in (:auto, :no, :yes) """
    Not recognized homogenization strategy: $homogenize
    Possible choices for keyword "homogenize" are:
    `:auto`, `:no`, `:yes`"""

    changematrix = get(kws, :changematrix, get(default_kw_args, :changematrix, false))

    _generic = get(kws, :_generic, get(default_kw_args, :_generic, false))

    KeywordArguments(
        function_id,
        reduced,
        ordering,
        certify,
        linalg,
        tasks,
        monoms,
        arithmetic,
        seed,
        selection,
        modular,
        _composite,
        check,
        homogenize,
        _use_divmask,
        changematrix,
        _generic
    )
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
#  Autoreducing polynomials

function autoreduce2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    _monoms = filter(!isempty, monoms)
    _coeffs = filter(!isempty, coeffs)
    if isempty(_monoms)
        return [monoms[1]], [coeffs[1]]
    end
    monoms, coeffs = _monoms, _coeffs
    _autoreduce2(ring, monoms, coeffs, params)
end

function _autoreduce2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    basis, _, hashtable = f4_initialize_structs(ring, monoms, coeffs, params)
    basis_update!(basis, hashtable)
    matrix = matrix_initialize(ring, C)
    symbol_ht = hashtable_initialize_secondary(hashtable)
    f4_autoreduce!(ring, basis, matrix, hashtable, symbol_ht, params)
    basis_standardize!(ring, basis, hashtable, params.arithmetic, params.changematrix)
    basis_export_data(basis, hashtable)
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

### 
# Macaulay matrix

# MacaulayMatrix is a sparse matrix with columns labeled by distinct monomials.
# MacaulayMatrix represents a block matrix of the following structure:
#
#   | A  B |
#   | C  D |
#
# The primary action on a MacaulayMatrix is computing
#   D - C inv(A) B,
# which is equivalent to reducing the CD block (lower part of the matrix) with
# the AB block (upper part of the matrix) via Gaussian elimination.
#
# Usually, by construction,
# - Block A is already in row-echelon-form.
# - Block A is the largest block, and is very-very sparse.
# - Permuting columns is not allowed.

# Each column in the matrix is associated with a single integer of this type.
const ColumnLabel = Int32

# Tags for matrix columns from different blocks.
const NON_PIVOT_COLUMN = 0      # not a pivot, column from the block B
const UNKNOWN_PIVOT_COLUMN = 1  # maybe a pivot, undecided yet
const PIVOT_COLUMN = 2          # a pivot, column from the block A

mutable struct MacaulayMatrix{T <: Coeff}
    # A row in the matrix is represented (usually) sparsely by two vectors: the
    # support and the coefficients. The coefficients can be stored in different
    # places:
    # - Either as a pointer to a polynomial in the basis
    # - Or stored explicitly in the matrix, in this struct.

    upper_rows::Vector{Vector{ColumnLabel}}
    lower_rows::Vector{Vector{ColumnLabel}}

    # Explicitly stored coefficients of upper rows
    upper_coeffs::Vector{Vector{T}}
    # Explicitly stored coefficients of *some* rows. Usage of this field may
    # differ in runtime depending on the algorithm in use
    some_coeffs::Vector{Vector{T}}

    # Maps the columns of the matrix to corresponding monomial labels
    column_to_monom::Vector{MonomId}

    # The number of columns in the left part of the matrix (in the blocks A, C)
    ncols_left::Int
    # The number of columns in the right part of the matrix (in the blocks B, D)
    ncols_right::Int

    # The number of rows actually filled in the upper/lower parts of the matrix
    nrows_filled_upper::Int
    nrows_filled_lower::Int

    # The number of pivots, i.e. the number of linearly independent rows
    # discovered in the block CD after performing linear reduction by AB
    npivots::Int
    # Maps a column to a pivot row. We have `pivots[i][1] == i`.
    # May be un-assigned.
    pivots::Vector{Vector{ColumnLabel}}
    # A lightweight version of the above `pivots`, only for some specific cases.
    pivot_indices::Vector{Int}

    # Index of the row --> position of the array of coefficients for this row
    upper_to_coeffs::Vector{Int}
    lower_to_coeffs::Vector{Int}

    # Index of the row --> monomial multiplier
    upper_to_mult::Vector{MonomId}
    lower_to_mult::Vector{MonomId}

    sentinels::Vector{Int8}

    changematrix::Vector{Dict{Tuple{Int, MonomId}, T}}
end

# The number of allocated (not necessarily filled) rows and columns in the
# blocks in the matrix
function matrix_block_sizes(matrix::MacaulayMatrix)
    (matrix.nrows_filled_upper, matrix.nrows_filled_lower, matrix.ncols_left, matrix.ncols_right)
end

# The total number of allocated (not necessarily filled) rows and columns
function Base.size(matrix::MacaulayMatrix)
    mup, mlow, nleft, nright = matrix_block_sizes(matrix)
    (mup + mlow, nleft + nright)
end

# The number of actually filled rows in the matrix
function matrix_nrows_filled(matrix::MacaulayMatrix)
    (matrix.nrows_filled_upper, matrix.nrows_filled_lower)
end

# The number of actually filled columns in the matrix
function matrix_ncols_filled(matrix::MacaulayMatrix)
    (matrix.ncols_left, matrix.ncols_right)
end

# Initializes an empty matrix with coefficients of type T
function matrix_initialize(ring::PolyRing, ::Type{T}) where {T <: Coeff}
    MacaulayMatrix(
        Vector{Vector{ColumnLabel}}(),
        Vector{Vector{ColumnLabel}}(),
        Vector{Vector{T}}(),
        Vector{Vector{T}}(),
        Vector{MonomId}(),
        0,
        0,
        0,
        0,
        0,
        Vector{Vector{ColumnLabel}}(),
        Vector{Int}(),
        Vector{Int}(),
        Vector{Int}(),
        Vector{MonomId}(),
        Vector{MonomId}(),
        Vector{Int8}(),
        Vector{Dict{Tuple{Int, MonomId}, T}}()
    )
end

# It may be a good idea to call this on the entry to linear algebra
function matrix_well_formed(matrix::MacaulayMatrix)
    # TODO: not much is checked at the moment, but it can be improved :^)
    nupper, nlower = matrix_nrows_filled(matrix)
    nleft, nright = matrix_ncols_filled(matrix)
    true
end

function matrix_resize_upper_part!(matrix::MacaulayMatrix, size::Int)
    size <= length(matrix.upper_rows) && return nothing
    resize!(matrix.upper_rows, size)
    resize!(matrix.upper_to_coeffs, size)
    resize!(matrix.upper_to_mult, size)
    nothing
end

function matrix_resize_lower_part!(matrix::MacaulayMatrix, size::Int)
    size <= length(matrix.lower_rows) && return nothing
    resize!(matrix.lower_rows, size)
    resize!(matrix.lower_to_coeffs, size)
    resize!(matrix.lower_to_mult, size)
    nothing
end

function matrix_reinitialize!(matrix::MacaulayMatrix, size::Int)
    new_size = size * 2
    matrix_resize_upper_part!(matrix, new_size)
    matrix_resize_lower_part!(matrix, new_size)
    matrix.ncols_left = 0
    matrix.ncols_right = 0
    matrix.nrows_filled_upper = 0
    matrix.nrows_filled_lower = 0
    matrix.npivots = 0
    matrix
end

function matrix_resize_upper_part_if_needed!(matrix::MacaulayMatrix, new_size::Int)
    current_size = length(matrix.upper_rows)
    while current_size < new_size
        current_size *= 2
    end
    if current_size > length(matrix.upper_rows)
        matrix_resize_upper_part!(matrix, current_size)
    end
    nothing
end

###

###
# Change matrix

function matrix_changematrix_initialize!(matrix::MacaulayMatrix{T}, n) where {T <: Coeff}
    resize!(matrix.changematrix, n)
    for i in 1:length(matrix.changematrix)
        matrix.changematrix[i] = Dict{Tuple{Int, MonomId}, T}()
    end
    nothing
end

###
# Stuff

function matrix_convert_rows_to_basis_elements!(
    matrix::MacaulayMatrix,
    basis::Basis{C},
    ht::MonomialHashtable,
    symbol_ht::MonomialHashtable,
    params::AlgorithmParameters;
    batched_ht_insert::Bool=false
) where {C}
    # We mutate the basis directly by adding new elements

    basis_resize_if_needed!(basis, matrix.npivots)
    rows = matrix.lower_rows
    crs = basis.n_processed

    _, _, nl, nr = matrix_block_sizes(matrix)
    support_size = 0
    for i in 1:length(rows)
        if isassigned(rows, i)
            support_size += length(rows[i])
        end
    end

    if batched_ht_insert && matrix.npivots > 1 && support_size > 4 * nr
        column_to_basis_monom = zeros(MonomId, nr)
        @inbounds for i in 1:(matrix.npivots)
            for j in 1:length(rows[i])
                idx = rows[i][j]
                column_to_basis_monom[idx - nl] = 1
            end
        end
        matrix_insert_in_basis_hashtable_pivots_masked!(
            column_to_basis_monom,
            ht,
            symbol_ht,
            matrix.column_to_monom,
            nl
        )
        @inbounds for i in 1:(matrix.npivots)
            colidx = rows[i][1]
            for j in 1:length(rows[i])
                columnid = rows[i][j]
                rows[i][j] = column_to_basis_monom[columnid - nl]
            end
            basis.coeffs[crs + i] = matrix.some_coeffs[matrix.lower_to_coeffs[colidx]]
            basis.monoms[crs + i] = matrix.lower_rows[i]
            @invariant length(basis.coeffs[crs + i]) == length(basis.monoms[crs + i])
        end
    else
        @inbounds for i in 1:(matrix.npivots)
            colidx = rows[i][1]
            matrix_insert_in_basis_hashtable_pivots!(rows[i], ht, symbol_ht, matrix.column_to_monom)
            basis.coeffs[crs + i] = matrix.some_coeffs[matrix.lower_to_coeffs[colidx]]
            basis.monoms[crs + i] = matrix.lower_rows[i]
            @invariant length(basis.coeffs[crs + i]) == length(basis.monoms[crs + i])
        end
    end

    if params.changematrix
        resize!(basis.changematrix, basis.n_filled + matrix.npivots)
        for i in 1:(matrix.npivots)
            basis.changematrix[crs + i] = Dict{Int, Dict{MonomId, C}}()
            for ((poly_idx, poly_mult), cf) in matrix.changematrix[i]
                basis_changematrix_addmul!(
                    basis,
                    ht,
                    symbol_ht,
                    crs + i,
                    poly_idx,
                    poly_mult,
                    cf,
                    params.arithmetic
                )
            end
        end
    end

    basis.n_filled += matrix.npivots
end

function matrix_convert_rows_to_basis_elements_nf!(
    matrix::MacaulayMatrix,
    basis::Basis{C},
    ht::MonomialHashtable,
    symbol_ht::MonomialHashtable
) where {C}
    _, nlow = matrix_nrows_filled(matrix)
    basis_resize_if_needed!(basis, matrix.npivots)

    @inbounds for i in 1:nlow
        basis.n_processed += 1
        basis.n_nonredundant += 1
        basis.nonredundant_indices[basis.n_nonredundant] = basis.n_processed
        if isassigned(matrix.some_coeffs, i)
            row = matrix.lower_rows[i]
            matrix_insert_in_basis_hashtable_pivots!(row, ht, symbol_ht, matrix.column_to_monom)
            basis.coeffs[basis.n_processed] = matrix.some_coeffs[i]
            basis.monoms[basis.n_processed] = row
        else
            empty!(basis.coeffs[basis.n_processed])
            empty!(basis.monoms[basis.n_processed])
        end
    end

    nothing
end

function matrix_polynomial_multiple_to_row!(
    matrix::MacaulayMatrix,
    symbol_ht::MonomialHashtable{M},
    basis_ht::MonomialHashtable{M},
    monom_hash::MonomHash,
    mult::M,
    poly::Vector{MonomId}
) where {M <: Monom}
    row = similar(poly)
    hashtable_resize_if_needed!(symbol_ht, length(poly))

    hashtable_insert_polynomial_multiple!(row, monom_hash, mult, poly, basis_ht, symbol_ht)
end

function matrix_fill_column_to_monom_map!(matrix::MacaulayMatrix, symbol_ht::MonomialHashtable)
    @invariant !symbol_ht.frozen

    column_to_monom = Vector{MonomId}(undef, symbol_ht.load - 1)
    j = 1
    k = 0
    @inbounds for i in (symbol_ht.offset):(symbol_ht.load)
        column_to_monom[j] = i
        j += 1
        if symbol_ht.labels[i] == PIVOT_COLUMN
            k += 1
        end
    end

    sort_partition_columns_by_labels!(column_to_monom, symbol_ht)

    cmp = let monoms = symbol_ht.monoms, ord = symbol_ht.ord
        function _cmp(x, y, ord)
            monom_isless(@inbounds(monoms[y]), @inbounds(monoms[x]), ord)
        end
        (x, y) -> _cmp(x, y, ord)
    end
    sort_part!(column_to_monom, 1, k, lt=cmp)
    sort_part!(column_to_monom, k + 1, length(column_to_monom), lt=cmp)

    matrix.ncols_left = k
    # -1 as long as hashtable symbol_ht.load is always 1 more than actual
    matrix.ncols_right = symbol_ht.load - matrix.ncols_left - 1

    # store the other direction of mapping,
    # hash -> column
    @inbounds for k in 1:length(column_to_monom)
        symbol_ht.labels[column_to_monom[k]] = k
    end

    @inbounds for k in 1:(matrix.nrows_filled_upper)
        row = matrix.upper_rows[k]
        for j in 1:length(row)
            row[j] = symbol_ht.labels[row[j]]
        end
    end

    @inbounds for k in 1:(matrix.nrows_filled_lower)
        row = matrix.lower_rows[k]
        for j in 1:length(row)
            row[j] = symbol_ht.labels[row[j]]
        end
    end

    matrix.column_to_monom = column_to_monom
end

# TODO: this does not belong here!...
function matrix_insert_in_basis_hashtable_pivots!(
    row::Vector{ColumnLabel},
    ht::MonomialHashtable{M},
    symbol_ht::MonomialHashtable{M},
    column_to_monom::Vector{MonomId}
) where {M <: Monom}
    hashtable_resize_if_needed!(ht, length(row))

    sexps = symbol_ht.monoms

    mod = MonomHash(ht.size - 1)
    bexps = ht.monoms
    bhash = ht.hashtable

    l = 1
    @label Letsgo
    @inbounds while l <= length(row)
        hidx = column_to_monom[row[l]]
        h = symbol_ht.hashvals[hidx]

        lastidx = ht.load + 1
        bexps[lastidx] = sexps[hidx]
        e = bexps[lastidx]

        k = h
        i = MonomHash(0)
        @inbounds while i <= ht.size
            k = hashtable_next_lookup_index(h, i, mod)
            hm = bhash[k]

            iszero(hm) && break

            if hashtable_is_hash_collision(ht, hm, e, h)
                i += MonomHash(1)
                continue
            end

            row[l] = hm
            l += 1
            @goto Letsgo
        end

        @invariant !ht.frozen

        bhash[k] = pos = lastidx
        row[l] = pos
        l += 1

        ht.labels[pos] = symbol_ht.labels[hidx]
        ht.hashvals[pos] = h
        ht.divmasks[pos] = symbol_ht.divmasks[hidx]

        ht.load += 1
    end

    nothing
end

# TODO: ...and this!
function matrix_insert_in_basis_hashtable_pivots_masked!(
    row::Vector{ColumnLabel},
    ht::MonomialHashtable{M},
    symbol_ht::MonomialHashtable{M},
    column_to_monom::Vector{MonomId},
    shift::Int
) where {M <: Monom}
    hashtable_resize_if_needed!(ht, length(row))

    sexps = symbol_ht.monoms

    mod = MonomHash(ht.size - 1)
    bexps = ht.monoms
    bhash = ht.hashtable

    l = 1
    @label Letsgo
    @inbounds while l <= length(row)
        if iszero(row[l])
            l += 1
            continue
        end

        hidx = column_to_monom[shift + l]

        h = symbol_ht.hashvals[hidx]

        lastidx = ht.load + 1
        bexps[lastidx] = sexps[hidx]
        e = bexps[lastidx]

        k = h
        i = MonomHash(0)
        @inbounds while i <= ht.size
            k = hashtable_next_lookup_index(h, i, mod)
            hm = bhash[k]

            iszero(hm) && break

            if hashtable_is_hash_collision(ht, hm, e, h)
                i += MonomHash(1)
                continue
            end

            row[l] = hm
            l += 1
            @goto Letsgo
        end

        @invariant !ht.frozen

        bhash[k] = pos = lastidx
        row[l] = pos
        l += 1

        ht.labels[pos] = symbol_ht.labels[hidx]
        ht.hashvals[pos] = h
        ht.divmasks[pos] = symbol_ht.divmasks[hidx]

        ht.load += 1
    end

    nothing
end

using Test, Nemo, Groebner

@testset "Nemo.jl, univariate" begin
    for ff in [Nemo.Native.GF(2^62 + 135), Nemo.GF(2^62 + 135)]
        R, x = Nemo.polynomial_ring(ff, "x")
        @test Groebner.groebner([R(2)]) == [R(1)]
        @test Groebner.groebner([R(0), R(0)]) == [R(0)]
        @test Groebner.groebner([R(0), R(3), R(0)]) == [R(1)]
        @test Groebner.groebner([R(0), R(3), R(0)]) == [R(1)]
        @test Groebner.groebner([x + 100]) == [x + 100]
    end

    for ff in [
        Nemo.Native.GF(2^31 - 1),
        Nemo.Native.GF(2^62 + 135),
        Nemo.GF(2^62 + 135),
        Nemo.GF(Nemo.ZZRingElem(2^62 + 135)),
        Nemo.QQ
    ]
        for gb_ord in [Groebner.Lex(), Groebner.DegLex(), Groebner.DegRevLex()]
            R, x = Nemo.polynomial_ring(ff, "x")
            @test Groebner.groebner([x^2 - 4, x + 2], ordering=gb_ord) == [x + 2]
        end
    end
end

@testset "Nemo.jl, generic" begin
    # Test generic coefficients with some interesting fields from Nemo.jl.

    # Single extension
    K, a = Nemo.finite_field(3, 2, "a")
    R, (X, Y) = K["X", "Y"]
    @test groebner([a * X - Y, X * Y - 1]) == [Y^2 + 2 * a, X + (2 * a + 1) * Y]

    # TODO: Tower of extensions
    # K, a = Nemo.finite_field(3, 2, "a")
    # Kx, x = Nemo.polynomial_ring(K, "x")
    # L, b = Nemo.finite_field(x^3 + x^2 + x + 2, "b")
    # R, (X, Y) = L["X", "Y"]
    # sys = [a * b * X - Y, X * Y - 1]
    # res = [Y^2 + b^5 + b^4 + 2*b^2 + 2*b + 2, X + (b^3 + 2*b^2 + b)*Y]
    # @test groebner(sys) == res

    # Q bar
    Q_bar = Nemo.algebraic_closure(Nemo.QQ)
    R, (X, Y) = Q_bar["X", "Y"]
    e2 = Nemo.root_of_unity(Q_bar, 5, 2)
    e3 = Nemo.root_of_unity(Q_bar, 5, 3)
    e4 = Nemo.root_of_unity(Q_bar, 5, 4)
    @test groebner([e3 * X - e2 * Y]) == [X - e4 * Y]

    # Cyclic extension
    K, a = Nemo.cyclotomic_field(5)
    R, (X, Y) = K["X", "Y"]
    @test groebner([a * X + 1]) == [X - a^3 - a^2 - a - 1]
    @test isgroebner([X - a^3 - a^2 - a - 1])
    @test normalform([X - a^3 - a^2 - a - 1], [X, X - a^3 - a^2 - a - 1]) ==
          [R(a^3 + a^2 + a + 1), R(0)]
    @test_throws DomainError groebner_with_change_matrix(
        [X - a^3 - a^2 - a - 1],
        ordering=Groebner.DegRevLex()
    )
end

@testset "Nemo.jl, input-output" begin
    # R, (x, y) = Nemo.GF(Nemo.ZZRingElem(Primes.nextprime(BigInt(2)^100)))["x", "y"]
    # @test_throws DomainError Groebner.groebner([x, y])

    # R, (x, y) = Nemo.GF(2, 2)["x", "y"]
    # @test_throws DomainError Groebner.groebner([x, y])

    R, (x, y) = Nemo.ZZ["x", "y"]
    @test_throws DomainError Groebner.groebner([x, y])

    R_, (a) = Nemo.QQ["a"]
    R, (x, y) = R_["x", "y"]
    @test_throws DomainError Groebner.groebner([x, y])

    # R_, (a) = Nemo.QQ["a"]
    # R, (x, y) = AbstractAlgebra.FractionField(R_)["x", "y"]
    # @test_throws DomainError Groebner.groebner([x, y])

    nemo_orderings_to_test = [:lex, :deglex, :degrevlex]
    nemo_grounds_to_test = [
        Nemo.Native.GF(2^62 + 135),
        Nemo.Native.GF(2^31 - 1),
        Nemo.Native.GF(17),
        Nemo.GF(2^62 + 135),
        Nemo.GF(2^31 - 1),
        Nemo.QQ
    ]

    for ord in nemo_orderings_to_test
        for ground in nemo_grounds_to_test
            R, x = Nemo.polynomial_ring(ground, "x")
            gb = Groebner.groebner([(x - 1) * (x + 8), (x + 8) * (x + 10)])
            @test gb == [(x + 8)]

            R, (x, y) = Nemo.polynomial_ring(ground, ["x", "y"], internal_ordering=ord)
            fs = [x^2 * y + 3, (2^31 - 5) * x - (2^31 - 4) * y]
            gb = Groebner.groebner(fs)
            @test parent(gb[1]) == R
            @test Groebner.isgroebner(gb)
        end
    end

    c = Groebner.Examples.cyclicn(6, k=Nemo.GF(2^30 + 3))
    gb1 = Groebner.groebner(c)
    trace, gb2 = Groebner.groebner_learn(c)
    flag, gb3 = Groebner.groebner_apply!(trace, c)
    flag, _gb4 = Groebner.groebner_apply!(trace, (c, c, c, c))
    @test gb1 == gb2 == gb3 == _gb4[1]

    c = Groebner.Examples.cyclicn(6, k=Nemo.Native.GF(2^30 + 3))
    gb1 = Groebner.groebner(c)
    trace, gb2 = Groebner.groebner_learn(c)
    flag, gb3 = Groebner.groebner_apply!(trace, c)
    flag, _gb4 = Groebner.groebner_apply!(trace, (c, c, c, c))
    @test gb1 == gb2 == gb3 == _gb4[1]

    # Test for different Groebner.jl orderings
    for nemo_ord in [:lex, :deglex, :degrevlex]
        for ground in nemo_grounds_to_test
            R, (x,) = Nemo.polynomial_ring(ground, ["x"], internal_ordering=nemo_ord)
            for gb_ord in [
                Groebner.Lex(),
                Groebner.DegLex(),
                Groebner.DegRevLex(),
                Groebner.Lex(x),
                Groebner.DegLex(x)
            ]
                gb = Groebner.groebner([x^2], ordering=gb_ord)
                @test parent(first(gb)) == R
                @test gb == [x^2]
            end

            R, (x, y) = Nemo.polynomial_ring(ground, ["x", "y"], internal_ordering=nemo_ord)
            fs = [x^2 + 3, y - 1]
            for gb_ord in [
                Groebner.Lex(),
                Groebner.DegLex(),
                Groebner.DegRevLex(),
                Groebner.Lex(x, y),
                Groebner.Lex(y, x)
            ]
                gb = Groebner.groebner(fs, ordering=gb_ord)
                @test parent(first(gb)) == R
                @test all(in(fs), gb) && all(in(gb), fs)
            end
        end
    end
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Tracer for F4

mutable struct Trace{C1 <: Coeff, C2 <: Coeff, M <: Monom, Ord1, Ord2}
    stopwatch::UInt64
    empty::Bool

    ring::PolyRing{Ord1, C2}
    original_ord::Ord2

    # Buffers for storing basis elements
    input_basis::Basis{C1}
    buf_basis::Basis{C1}
    gb_basis::Basis{C1}
    hashtable::MonomialHashtable{M, Ord1}

    # Permutation of input polynomials and their terms, if needed
    input_permutation::Vector{Int}
    term_sorting_permutations::Vector{Vector{Int}}
    term_homogenizing_permutations::Vector{Vector{Int}}

    # Information about the non-redundant rows of the matrix
    matrix_infos::Vector{NamedTuple{(:nup, :nlow, :ncols), Tuple{Int64, Int64, Int64}}}
    matrix_nonzeroed_rows::Vector{Vector{Int}}
    matrix_upper_rows::Vector{Tuple{Vector{Int}, Vector{MonomId}}}
    matrix_lower_rows::Vector{Tuple{Vector{Int}, Vector{MonomId}}}
    matrix_sorted_columns::Vector{Vector{Int32}}
    matrix_pivot_signatures::Vector{UInt64}
    matrix_pivot_indices::Vector{Vector{Int}}
    matrix_is_columns_cached::Bool

    critical_pair_sequence::Vector{Tuple{Int, Int}}

    output_nonredundant_indices::Vector{Int}
    nonredundant_indices_before_reduce::Vector{Int}
    output_sort_indices::Vector{Int}

    params::AlgorithmParameters
    representation::PolynomialRepresentation

    napply::Int
    nfail::Int
end

function trace_initialize_empty(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    basis = basis_initialize(ring, 0, C)
    hashtable = hashtable_initialize(ring, params.rng, M; use_divmask=params.use_divmask)
    trace = trace_initialize(ring, basis, hashtable, Int[], params)
    trace.empty = true
    trace
end

function trace_initialize(
    ring::PolyRing,
    input_basis::Basis,
    hashtable::MonomialHashtable,
    permutation::Vector{Int},
    params::AlgorithmParameters
)
    Trace(
        time_ns(),
        false,
        ring,
        params.original_ord,
        basis_deepcopy(input_basis),
        basis_deepcopy(input_basis),
        input_basis,
        hashtable,
        permutation,
        Vector{Vector{Int}}(),
        Vector{Vector{Int}}(),
        Vector{NamedTuple{(:nup, :nlow, :ncols), Tuple{Int64, Int64, Int64}}}(),
        Vector{Vector{Int}}(),
        Vector{Tuple{Vector{Int}, Vector{MonomId}}}(),
        Vector{Tuple{Vector{Int}, Vector{MonomId}}}(),
        Vector{Vector{Int32}}(),
        Vector{UInt64}(),
        Vector{Vector{Int}}(),
        false,
        Vector{Tuple{Int, Int}}(),
        Vector{Int}(),
        Vector{Int}(),
        Vector{Int}(),
        params,
        PolynomialRepresentation(ExponentVector{UInt64}, UInt64, false),
        0,
        0
    )
end

function trace_copy(
    trace::Trace{C1, C3, M, Ord1, Ord2},
    repr::PolynomialRepresentation,
    ::Type{C2}
) where {C1 <: Coeff, C3 <: Coeff, C2 <: Coeff, M <: Monom, Ord1, Ord2}
    new_sparse_row_coeffs = Vector{Vector{C2}}()
    new_input_basis = basis_shallow_copy_with_new_coeffs(trace.input_basis, new_sparse_row_coeffs)

    new_buf_basis_coeffs = Vector{Vector{C2}}(undef, length(trace.buf_basis.coeffs))
    for i in 1:(trace.buf_basis.n_filled)
        new_buf_basis_coeffs[i] = Vector{C2}(undef, length(trace.buf_basis.coeffs[i]))
    end
    new_buf_basis = basis_shallow_copy_with_new_coeffs(trace.buf_basis, new_buf_basis_coeffs)

    new_gb_basis_coeffs = Vector{Vector{C2}}(undef, length(trace.gb_basis.coeffs))
    for i in 1:(trace.gb_basis.n_filled)
        new_gb_basis_coeffs[i] = Vector{C2}(undef, length(trace.gb_basis.coeffs[i]))
    end
    new_gb_basis = basis_shallow_copy_with_new_coeffs(trace.gb_basis, new_gb_basis_coeffs)

    new_representation = PolynomialRepresentation(
        trace.representation.monomtype,
        C2,
        repr.using_wide_type_for_coeffs
    )
    new_char = C2 <: Union{CoeffGeneric, CoeffQQ} ? trace.ring.characteristic : zero(C2)
    new_ring = PolyRing(trace.ring.nvars, trace.ring.ord, new_char, trace.ring.ground)

    Trace(
        trace.stopwatch,
        trace.empty,
        new_ring,
        trace.original_ord,
        new_input_basis,
        new_buf_basis,
        new_gb_basis,
        trace.hashtable,
        trace.input_permutation,
        trace.term_sorting_permutations,
        trace.term_homogenizing_permutations,
        trace.matrix_infos,
        trace.matrix_nonzeroed_rows,
        trace.matrix_upper_rows,
        trace.matrix_lower_rows,
        copy(trace.matrix_sorted_columns),
        trace.matrix_pivot_signatures,
        trace.matrix_pivot_indices,
        trace.matrix_is_columns_cached,
        trace.critical_pair_sequence,
        trace.output_nonredundant_indices,
        trace.nonredundant_indices_before_reduce,
        trace.output_sort_indices,
        trace.params,
        new_representation,
        trace.napply,
        trace.nfail
    )
end

function trace_finalize!(trace::Trace)
    trace.buf_basis = basis_deepcopy(trace.gb_basis)
    trace.buf_basis.n_nonredundant = trace.input_basis.n_nonredundant
    trace.buf_basis.n_processed = trace.input_basis.n_processed
    trace.buf_basis.n_filled = trace.input_basis.n_filled
    trace.stopwatch = time_ns() - trace.stopwatch
    nothing
end

function trace_export_matrices(trace::Trace)
    @assert length(trace.matrix_infos) ==
            length(trace.matrix_lower_rows) ==
            length(trace.matrix_upper_rows)
    matrices = []
    nvars = trace.ring.nvars
    for i in 1:length(trace.matrix_infos)
        reducers = (
            index=trace.matrix_upper_rows[i][1],
            multiplier=map(
                m -> monom_to_vector!(zeros(Int, nvars), trace.hashtable.monoms[m]),
                trace.matrix_upper_rows[i][2]
            )
        )
        to_be_reduced = (
            index=trace.matrix_lower_rows[i][1],
            multiplier=map(
                m -> monom_to_vector!(zeros(Int, nvars), trace.hashtable.monoms[m]),
                trace.matrix_lower_rows[i][2]
            )
        )
        matrix = (reducers=reducers, to_be_reduced=to_be_reduced)
        push!(matrices, matrix)
    end
    map(identity, matrices)
end

Base.show(io::IO, trace::Trace) = Base.show(io, MIME("text/plain"), trace)

function Base.show(io::IO, ::MIME"text/plain", trace::Trace)
    tm = round(trace.stopwatch / 10^9, digits=3)
    sz = round((Base.summarysize(trace) / 2^20), digits=2)
    printstyled(io, "# Trace of F4 recorded in $(tm) s ($sz MiB).\n", bold=true)
    println(
        io,
        """
        ring  : Z[x1,...,x$(trace.ring.nvars)] mod $(trace.ring.characteristic)
        input : $(trace.input_basis.n_filled) polynomials
        output: $(trace.gb_basis.n_filled) polynomials
        apply : $(trace.napply) / $(trace.nfail) (success/fail)
        """
    )

    permute_input =
        !isempty(trace.term_homogenizing_permutations) ||
        !isempty(trace.term_homogenizing_permutations)
    printstyled(io, "# Parameters\n", bold=true)
    println(
        io,
        """
        input order  : $(trace.original_ord)
        output order : $(trace.ring.ord)
        homogenize   : $(trace.params.homogenize)
        permute      : $(permute_input)
        monom. type  : $(trace.representation.monomtype)
        coeff. type  : $(trace.representation.coefftype)
        arithmetic   : $(typeof(trace.params.arithmetic))
        """
    )

    total_iterations = length(trace.matrix_infos)
    total_matrix_low_rows = sum(x -> x.nlow, trace.matrix_infos; init=0)
    total_matrix_up_rows = sum(x -> x.nup, trace.matrix_infos; init=0)
    total_matrix_up_rows_useful = sum(length ∘ first, trace.matrix_upper_rows; init=0)
    total_matrix_low_rows_useful = sum(length ∘ first, trace.matrix_lower_rows; init=0)
    critical_pair_degree_sequence = map(first, trace.critical_pair_sequence)
    critical_pair_count_sequence = map(last, trace.critical_pair_sequence)
    printstyled(io, "# F4 statistics\n", bold=true)
    print(
        io,
        """
        iterations     : $(total_iterations)
        hashtable      : $(trace.hashtable.load) / $(trace.hashtable.size) filled
        matrix up-rows : $(total_matrix_up_rows) ($(round(total_matrix_up_rows_useful / total_matrix_up_rows * 100, digits=2)) % useful)
        matrix low-rows: $(total_matrix_low_rows) ($(round(total_matrix_low_rows_useful / total_matrix_low_rows * 100, digits=2)) % useful)
        pair degrees   : """
    )
    if length(critical_pair_degree_sequence) > 0
        print(io, string(critical_pair_degree_sequence[1]))
        print(io, ",")
    end
    for i in 2:length(critical_pair_degree_sequence)
        if critical_pair_degree_sequence[i] < critical_pair_degree_sequence[i - 1]
            printstyled(io, string(critical_pair_degree_sequence[i]), color=:red, bold=true)
        else
            print(io, string(critical_pair_degree_sequence[i]))
        end
        if i != length(critical_pair_degree_sequence)
            print(io, ",")
        end
    end
    println(io)
    println(
        io,
        """
        pair count     : $(join(string.(critical_pair_count_sequence), ","))"""
    )
end

using AbstractAlgebra, Test, Primes, Groebner

@testset "AbstractAlgebra.jl, univariate" begin
    R, x = polynomial_ring(GF(2^62 + 135), "x")
    @test Groebner.groebner([R(2)]) == [R(1)]
    @test Groebner.groebner([R(0), R(0)]) == [R(0)]
    @test Groebner.groebner([R(0), R(3), R(0)]) == [R(1)]

    for ground in [GF(2^31 - 1), GF(2^62 + 135), QQ]
        for gb_ord in [Groebner.Lex(), Groebner.DegLex(), Groebner.DegRevLex()]
            R, x = polynomial_ring(ground, "x")
            @test Groebner.groebner([x^2 - 4, x + 2], ordering=gb_ord) == [x + 2]
        end
    end
end

@testset "AbstractAlgebra.jl, input-output" begin
    # R, (x, y) = AbstractAlgebra.GF(Primes.nextprime(BigInt(2)^100))["x", "y"]
    # @test_throws DomainError Groebner.groebner([x, y])

    R, (x, y) = AbstractAlgebra.ZZ["x", "y"]
    @test_throws DomainError Groebner.groebner([x, y])

    R_, (a) = AbstractAlgebra.QQ["a"]
    R, (x, y) = R_["x", "y"]
    @test_throws DomainError Groebner.groebner([x, y])

    # R_, (a) = AbstractAlgebra.QQ["a"]
    # R, (x, y) = AbstractAlgebra.FractionField(R_)["x", "y"]
    # @test_throws DomainError Groebner.groebner([x, y])

    aa_orderings_to_test = [:lex, :degrevlex, :deglex]
    aa_grounds_to_test = [
        AbstractAlgebra.GF(2^62 + 135),
        AbstractAlgebra.GF(2^31 - 1),
        AbstractAlgebra.GF(17),
        AbstractAlgebra.QQ
    ]

    for aaord in aa_orderings_to_test
        R, (x, y) = AbstractAlgebra.polynomial_ring(
            AbstractAlgebra.GF(5),
            ["x", "y"],
            internal_ordering=aaord
        )
        fs = [x + 3y, R(0)]
        for gbord in [
            Groebner.Lex(x, y),
            Groebner.DegLex(x, y),
            Groebner.DegRevLex(x, y),
            Groebner.DegLex(x) * Groebner.DegRevLex(y)
        ]
            gb = Groebner.groebner(fs)
            @test gb == [x + 3y]
            @test parent(gb[1]) == R
        end
    end

    for ord in aa_orderings_to_test
        for ground in aa_grounds_to_test
            R, (x,) = polynomial_ring(ground, ["x"], internal_ordering=ord)
            @test parent(first(Groebner.groebner([x]))) == R

            R, (x, y) = polynomial_ring(ground, ["x", "y"], internal_ordering=ord)
            fs = [x^2 * y + 3, (2^31 - 5) * x - (2^31 - 4) * y]
            gb = Groebner.groebner(fs)
            @test parent(gb[1]) == R
            @test all(
                in([
                    y^3 + ground(13835057990857654347) // ground(4611686001247518736),
                    x - ground(2147483644) // ground(2147483643) * y
                ]),
                gb
            )

            @test Groebner.isgroebner(gb)
            @test all(iszero, Groebner.normalform(gb, gb))
        end
    end

    # Test for different Groebner.jl orderings
    aa_ord = :lex
    for ground in aa_grounds_to_test
        R, (x,) = polynomial_ring(ground, ["x"], internal_ordering=aa_ord)
        for case in [
            Groebner.Lex(),
            Groebner.DegLex(),
            Groebner.DegRevLex(),
            Groebner.Lex(x),
            Groebner.DegLex(x)
        ]
            gb = Groebner.groebner([x^2], ordering=case)
            @test parent(first(gb)) == R
            @test gb == [x^2]
        end

        R, (x, y) = polynomial_ring(ground, ["x", "y"], internal_ordering=aa_ord)
        fs = [x^2 + 3, y - 1]
        for case in [
            Groebner.Lex(),
            Groebner.DegLex(),
            Groebner.DegRevLex(),
            Groebner.Lex(x, y),
            Groebner.Lex(y, x)
        ]
            gb = Groebner.groebner(fs, ordering=case)
            @test parent(first(gb)) == R
            @test all(in(fs), gb)
        end
    end
end

using Revise, Groebner, AbstractAlgebra

# 1. Create the system
k = GF(2^30 + 3)
sys = sort(Groebner.Examples.katsuran(4, k=k), by=leading_monomial)

# 2. Learn the trace
trace, gb_truth = groebner_learn(sys)

# 3. Get the F4 matrices
matrices = Groebner.trace_export_matrices(trace.recorded_traces[UInt32])

# 4. Inspect the data structure
function make_matrix(sys, matrix)
    x = gens(parent(sys[1]))
    make_poly(idx, mult) = sys[idx] * prod(x .^ mult)
    reducers = map(make_poly, matrix.reducers.index, matrix.reducers.multiplier)
    to_be_reduced = map(make_poly, matrix.to_be_reduced.index, matrix.to_be_reduced.multiplier)
    (reducers=reducers, to_be_reduced=to_be_reduced)
end

matrix_1 = make_matrix(sys, matrices[1])
@info "The first matrix:" matrix_1.reducers matrix_1.to_be_reduced

# 5. Construct a basis by reducing the matrices
function follow_the_trace(sys, matrices)
    gb = sys
    for matrix in matrices
        matrix = make_matrix(gb, matrix)
        # Can be computed via lin-alg
        reduced = broadcast(AbstractAlgebra.normal_form, matrix.to_be_reduced, Ref(matrix.reducers))
        gb = vcat(gb, reduced)
    end
    gb
end

gb = follow_the_trace(sys, matrices)

@assert groebner(gb) == gb_truth   # autoreduce by calling `groebner`

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Intermediate representation of polynomials (ir)

# Polynomials in the intermediate representation are represented by two arrays:
# an array of exponent vectors and an array of coefficients. Zero polynomial is
# represented with two empty arrays.

const IR_exponent = UInt32
const IR_coeff = Union{Number, CoeffGeneric}

# Intermediate representation (ir) enforces a number assumtpions:
# - Intermediate representation owns the memory.
# - Monomials in intermediate representation are sorted and unique.
# - Coefficients in intermediate representation are nonzero and normalized.

# Our conventions on some edge cases:
# - Trying to compute a Groebner basis of an empty set is an error.
# - The Groebner basis of [0] is [0].
# - The Groebner basis of [f1,...,fn, 0] is the Groebner basis of [f1...fn]

struct PolyRing{Ord <: AbstractMonomialOrdering, C <: Union{CoeffZp, CompositeCoeffZp}}
    nvars::Int
    ord::Ord
    characteristic::C
    ground::Symbol

    PolyRing(nvars::Int, ord, ch) = PolyRing(nvars, ord, ch, iszero(ch) ? :qq : :zp)

    function PolyRing(nvars::Int, ord::Ord, ch::C, ground::Symbol) where {Ord, C}
        !(ground in (:zp, :qq, :generic)) && throw(DomainError("Invalid ground field."))
        !(nvars >= 0) && throw(DomainError("The number of variables must be non-negative."))
        new{Ord, C}(nvars, ord, ch, ground)
    end
end

Base.:(==)(r1::PolyRing, r2::PolyRing) =
    r1.nvars == r2.nvars &&
    r1.ord == r2.ord &&
    r1.characteristic == r2.characteristic &&
    r1.ground == r2.ground

ir_is_valid_basic(batch) = throw(DomainError("Invalid IR, unknown types."))
ir_is_valid_basic(ring, monoms, coeffs) = throw(DomainError("Invalid IR, unknown types."))

function ir_is_valid_basic(batch::NTuple{N, T}) where {N, T}
    for el in batch
        length(el) != 3 && throw(DomainError("Invalid IR."))
    end
    for el in batch
        ir_is_valid_basic(el...)
    end
end

function ir_is_valid_basic(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{E}}},
    coeffs::Vector{Vector{C}}
) where {E <: Integer, C <: IR_coeff}
    !(length(monoms) == length(coeffs)) && throw(DomainError("Invalid IR."))
    isempty(monoms) && throw(DomainError("Invalid IR."))
    !(ring.nvars >= 0) && throw(DomainError("The number of variables must be non-negative."))
    !(ring.characteristic >= 0) && throw(DomainError("Field characteristic must be nonnegative."))
    if ring.ground == :zp
        !(C <: Integer) && throw(DomainError("Coefficients must be integers."))
        (C <: BigInt) && throw(DomainError("Coefficients must fit in a machine register."))
        !(ring.characteristic <= typemax(C)) && throw(DomainError("Invalid IR."))
        !Primes.isprime(ring.characteristic) &&
            throw(DomainError("Ring characteristic must be prime"))
    elseif ring.ground == :qq
        !(C <: Rational || C <: Integer || C <: CoeffGeneric) &&
            throw(DomainError("Coefficients must be integer or rational."))
    else
        !(C <: CoeffGeneric) && throw(DomainError("Coefficients must be CoeffGeneric."))
    end
    (ring.ord == InputOrdering()) && throw(DomainError("Invalid monomial ordering."))
    vars = ordering_variables(ring.ord)
    if !isempty(vars) && !(Set(vars) == Set(1:(ring.nvars)))
        throw(
            DomainError(
                "Invalid monomial ordering. Expected variables to be numbers from 1 to $(ring.nvars), but got: $(vars)"
            )
        )
    end
end

function ir_is_valid(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}}
) where {I <: Integer, C <: IR_coeff}
    ir_is_valid_basic(ring, monoms, coeffs)
    for i in 1:length(monoms)
        !(length(monoms[i]) == length(coeffs[i])) && throw(DomainError("Invalid IR."))
        for j in 1:length(monoms[i])
            !(length(monoms[i][j]) == ring.nvars) && throw(DomainError("Invalid IR."))
            !(all(>=(0), monoms[i][j])) && throw(DomainError("Invalid IR."))
            iszero(coeffs[i][j]) && throw(DomainError("Invalid IR")) # can be relaxed
            if (ring.ground == :zp)
                !(0 < coeffs[i][j] < ring.characteristic) && throw(DomainError("Invalid IR."))
            end
        end
    end
    true
end

function ir_ensure_valid(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}}
) where {I <: Integer, C <: Coeff}
    ir_is_valid_basic(ring, monoms, coeffs)
    # Copy input
    new_monoms, new_coeffs = empty(monoms), empty(coeffs)
    for i in 1:length(monoms)
        !(length(monoms[i]) == length(coeffs[i])) && throw(DomainError("Invalid IR."))
        push!(new_monoms, empty(monoms[i]))
        push!(new_coeffs, empty(coeffs[i]))
        for j in 1:length(monoms[i])
            !(length(monoms[i][j]) == ring.nvars) && throw(DomainError("Invalid IR."))
            !(all(>=(0), monoms[i][j])) && throw(DomainError("Invalid IR."))
            push!(new_monoms[i], monoms[i][j])
            push!(new_coeffs[i], coeffs[i][j])
        end
    end
    # Normalize
    for i in 1:length(new_monoms)
        for j in 1:length(new_monoms[i])
            if ring.ground == :zp
                new_coeffs[i][j] = mod(new_coeffs[i][j], ring.characteristic)
            end
        end
    end
    # Sort terms if needed
    tdeg(e) = vcat(sum(e), e)
    for i in 1:length(new_monoms)
        if !issorted(new_monoms[i], lt=(a, b) -> monom_isless(tdeg(a), tdeg(b), ring.ord), rev=true)
            perm = collect(1:length(new_monoms[i]))
            sort!(
                perm,
                lt=(a, b) -> monom_isless(tdeg(new_monoms[i][a]), tdeg(new_monoms[i][b]), ring.ord),
                rev=true
            )
            new_monoms[i] = new_monoms[i][perm]
            new_coeffs[i] = new_coeffs[i][perm]
        end
    end
    # Merge terms
    _new_monoms = empty(new_monoms)
    _new_coeffs = empty(new_coeffs)
    for i in 1:length(new_monoms)
        push!(_new_monoms, empty(new_monoms[i]))
        push!(_new_coeffs, empty(new_coeffs[i]))
        if !isempty(new_coeffs[i])
            push!(_new_monoms[i], new_monoms[i][1])
            push!(_new_coeffs[i], new_coeffs[i][1])
        end
        slow_idx = 1
        for fast_idx in 2:length(new_monoms[i])
            if _new_monoms[i][slow_idx] != new_monoms[i][fast_idx]
                push!(_new_monoms[i], new_monoms[i][fast_idx])
                push!(_new_coeffs[i], new_coeffs[i][fast_idx])
                slow_idx += 1
                continue
            end
            _new_coeffs[i][slow_idx] =
                Base.Checked.checked_add(_new_coeffs[i][slow_idx], new_coeffs[i][fast_idx])
            if ring.ground == :zp && _new_coeffs[i][slow_idx] >= ring.characteristic
                _new_coeffs[i][slow_idx] -= ring.characteristic
                @invariant _new_coeffs[i][slow_idx] < ring.characteristic
            end
        end
    end
    new_monoms, new_coeffs = _new_monoms, _new_coeffs
    # Remove zero coefficients (zero polynomials stay)
    for i in 1:length(new_monoms)
        perm = collect(1:length(new_monoms[i]))
        filter!(j -> !iszero(new_coeffs[i][j]), perm)
        new_monoms[i] = new_monoms[i][perm]
        new_coeffs[i] = new_coeffs[i][perm]
    end
    ring, new_monoms, new_coeffs
end

# Process polynomials on the apply stage

function ir_extract_coeffs_raw!(trace, coeffs::Vector{Vector{C}}) where {C <: Coeff}
    # write new coefficients directly to trace buffer
    input_polys_perm = trace.input_permutation
    term_perms = trace.term_sorting_permutations
    homog_term_perms = trace.term_homogenizing_permutations
    CoeffsType = trace.representation.coefftype

    permute_input_terms = !isempty(term_perms)
    permute_homogenizing_terms = !isempty(homog_term_perms)

    @inbounds for i in 1:length(coeffs)
        basis_cfs = trace.buf_basis.coeffs[i]
        poly_index = input_polys_perm[i]
        poly = coeffs[poly_index]
        isempty(poly) && return false
        !(length(poly) == length(basis_cfs)) && return false
        for j in 1:length(poly)
            coeff_index = j
            if permute_input_terms
                coeff_index = term_perms[poly_index][coeff_index]
            end
            if permute_homogenizing_terms
                coeff_index = homog_term_perms[poly_index][coeff_index]
            end
            coeff = poly[coeff_index]
            basis_cfs[j] = convert(CoeffsType, coeff)
        end
    end

    if trace.params.homogenize
        if trace.ring.ground == :zp
            o = one(trace.buf_basis.coeffs[1][1])
            trace.buf_basis.coeffs[length(coeffs) + 1][1] = o
            trace.buf_basis.coeffs[length(coeffs) + 1][2] = trace.ring.characteristic - o
        elseif trace.ring.ground == :generic
            o = one(trace.buf_basis.coeffs[1][1])
            trace.buf_basis.coeffs[length(coeffs) + 1][1] = o
            trace.buf_basis.coeffs[length(coeffs) + 1][2] = -o
        else
            @assert false
        end
    end

    true
end

# Packed coefficients utils

function ir_pack_coeffs(batch::NTuple{N, T}) where {N, T}
    ring = batch[1][1]
    ch = CompositeNumber(map(el -> el[1].characteristic, batch))
    new_ring = PolyRing(ring.nvars, ring.ord, ch, ring.ground)
    monoms = batch[1][2]
    coeffs = Vector{Vector{CompositeNumber{N, UInt64}}}(undef, length(monoms))
    @assert allequal(map(el -> el[2], batch))
    for i in 1:length(batch[1][2])
        coeffs[i] = Vector{CompositeNumber{N, UInt64}}(undef, length(batch[1][2][i]))
        for j in 1:length(batch[1][2][i])
            coeffs[i][j] = CompositeNumber(ntuple(k -> batch[k][3][i][j], N))
        end
    end
    true, new_ring, monoms, coeffs
end

function ir_unpack_composite_coefficients(
    composite_coeffs::Vector{Vector{CompositeNumber{N, T}}}
) where {N, T <: CoeffZp}
    coeffs_part_i = ntuple(_ -> Vector{Vector{T}}(undef, length(composite_coeffs)), N)
    @inbounds for i in 1:length(composite_coeffs)
        for k in 1:N
            coeffs_part_i[k][i] = Vector{T}(undef, length(composite_coeffs[i]))
        end
        for j in 1:length(composite_coeffs[i])
            ai = composite_coeffs[i][j].data
            for k in 1:N
                coeffs_part_i[k][i][j] = ai[k]
            end
        end
    end
    coeffs_part_i
end

###
# Converting to internal representation

@timeit _TIMER function ir_convert_ir_to_internal(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params
) where {M <: Monom, C <: Coeff}
    repr = params.representation
    monoms2 = Vector{Vector{repr.monomtype}}(undef, length(monoms))
    CT = repr.coefftype
    if !isconcretetype(CT)
        CT = C
    end

    coeffs2 = Vector{Vector{CT}}(undef, length(monoms))
    @inbounds for i in 1:length(monoms)
        monoms2[i] = Vector{repr.monomtype}(undef, length(monoms[i]))
        coeffs2[i] = Vector{CT}(undef, length(monoms[i]))
        for j in 1:length(monoms[i])
            monoms2[i][j] = monom_construct_from_vector(repr.monomtype, monoms[i][j])
            coeffs2[i][j] = CT(coeffs[i][j])
        end
    end
    ring2, term_sorting_permutations = ir_set_monomial_ordering!(ring, monoms2, coeffs2, params)
    term_sorting_permutations, ring2, monoms2, coeffs2
end

@timeit _TIMER function ir_convert_internal_to_ir(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params
) where {M <: Monom, C <: Coeff}
    monoms2 = Vector{Vector{Vector{IR_exponent}}}(undef, length(monoms))
    if eltype(eltype(coeffs)) <: AbstractFloat
        coeffs2 = map(cc -> map(c -> UInt(c), cc), coeffs)
    else
        coeffs2 = coeffs
    end
    @inbounds for i in 1:length(monoms)
        monoms2[i] = Vector{Vector{IR_exponent}}(undef, length(monoms[i]))
        for j in 1:length(monoms[i])
            monoms2[i][j] = Vector{IR_exponent}(undef, ring.nvars)
            monom_to_vector!(monoms2[i][j], monoms[i][j])
        end
    end
    monoms2, coeffs2
end

# Checks that the monomial ordering is consistent.
# Sorts the polynomials terms w.r.t. the target ordering.
function ir_set_monomial_ordering!(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params
) where {M <: Monom, C <: Coeff}
    ordering_check_consistency(ring.nvars, params.target_ord)
    if ring.ord == params.target_ord
        # No reordering of terms needed
        return ring, Vector{Vector{Int}}()
    end
    ring = PolyRing(ring.nvars, params.target_ord, ring.characteristic, ring.ground)
    permutations = sort_input_terms_to_change_ordering!(monoms, coeffs, params.target_ord)
    ring, permutations
end

using Test, Random, AbstractAlgebra, Primes, Groebner

@testset "learn & apply, same field" begin
    K = AbstractAlgebra.GF(2^31 - 1)
    R, (x, y) = polynomial_ring(K, ["x", "y"]; internal_ordering=:degrevlex)
    trace, gb1 = Groebner.groebner_learn([x, y])
    flag, gb2 = Groebner.groebner_apply!(trace, [x, y])
    @assert gb1 == gb2 && flag

    show(trace)

    K = AbstractAlgebra.GF(2^31 - 1)
    R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)
    R2, xs = polynomial_ring(K, ["x$i" for i in 1:30], internal_ordering=:degrevlex)

    trace, gb = Groebner.groebner_learn([R(0), R(0)])
    flag, gb2 = Groebner.groebner_apply!(trace, [R(0), R(0)])
    @test gb == gb2 == [R(0)] && flag

    cases = [
        (system=[x],),
        (system=[R(1)],),
        (system=[x, y],),
        (system=[x, x],),
        (system=[x, y, x * y],),
        (system=[x + 1, y + 2, x * y + 3],),
        (system=[x^20 * y + x + 1, x * y^20 + y + 1],),
        (system=[x^20 * y + x + 1, x * y^20 + y + 1],),
        (system=Groebner.Examples.noonn(3, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.noonn(4, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.noonn(5, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.katsuran(3, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.katsuran(4, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.katsuran(5, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.cyclicn(5, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.rootn(5, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.rootn(5, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.rootn(6, internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.eco5(internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.ku10(internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.kinema(internal_ordering=:degrevlex, k=K),),
        (system=Groebner.Examples.s9_1(internal_ordering=:degrevlex, k=K),),
        (system=[sum(xs) + prod(xs), sum(xs)^2, prod(xs) - 1],)
    ]

    for case in cases
        # Learn and apply on the same system
        system = case.system
        true_gb = Groebner.groebner(system)
        trace, gb_1 = Groebner.groebner_learn(system)
        flag, gb_2 = Groebner.groebner_apply!(trace, system)
        @test flag && gb_2 == true_gb

        # Apply on a different system N times
        N = 5
        X = gens(parent(first(system)))
        for _ in 1:N
            point = map(t -> iszero(t) ? t + 1 : t, rand(K, length(X))) .* X
            system_ = map(f -> evaluate(f, point), system)
            true_gb = Groebner.groebner(system_)
            flag, gb_2 = Groebner.groebner_apply!(trace, system_)
            @test flag && gb_2 == true_gb
        end
    end
end

@testset "learn & apply, different fields" begin
    # Some small tests and corner cases
    K, K2, K3 = GF(5), GF(7), GF(11)
    R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)
    R2, (x2, y2) = polynomial_ring(K2, ["x", "y"], internal_ordering=:degrevlex)
    R3, (x3, y3) = polynomial_ring(K3, ["x", "y"], internal_ordering=:degrevlex)
    system = [x^4 + 2y^3 + 3x^2 + 4y, 4y^4 + 3x^3 + 2y^2 + 1x]
    system2 = map(f -> AbstractAlgebra.map_coefficients(c -> K2(data(c)), f), system)

    trace, gb_1 = Groebner.groebner_learn(system)
    flag, gb_2 = Groebner.groebner_apply!(trace, system2)
    @test flag && gb_2 == Groebner.groebner(system2)

    @test R != R2
    @test parent(first(gb_1)) == parent(first(system)) == R
    @test parent(first(gb_2)) == parent(first(system2)) == R2

    trace, gb_1 = Groebner.groebner_learn(system2)
    flag, gb_2 = Groebner.groebner_apply!(trace, system)
    @test flag && gb_2 == Groebner.groebner(system)

    system = [6x2^4 + 6y2 + 1, y2 + 3]
    system2 = map(f -> AbstractAlgebra.map_coefficients(c -> K(data(c)), f), system)
    system3 = map(f -> AbstractAlgebra.map_coefficients(c -> K3(data(c)), f), system)
    trace, gb_1 = Groebner.groebner_learn(system)
    flag, gb_2 = Groebner.groebner_apply!(trace, system2)
    @test flag && gb_2 == Groebner.groebner(system2)
    flag, gb_3 = Groebner.groebner_apply!(trace, system3)
    @test flag && gb_3 == Groebner.groebner(system3)

    system = [5x2 + 5, 5y2 + 1]
    system2 = map(f -> AbstractAlgebra.map_coefficients(c -> K(data(c)), f), system)
    trace, gb_1 = Groebner.groebner_learn(system)
    flag, _ = Groebner.groebner_apply!(trace, system2)
    @test !flag
    system = [x2 + 5, y2 + 1]
    system2 = map(f -> AbstractAlgebra.map_coefficients(c -> K(data(c)), f), system)
    trace, gb_1 = Groebner.groebner_learn(system)
    flag, _ = Groebner.groebner_apply!(trace, system2)
    @test !flag

    # Going from small characteristic to large is not allowed
    # NOTE: it should be allowed
    K1, K2 = GF(2^31 - 1), GF(2^60 + 33)
    R, (x, y) = polynomial_ring(K1, ["x", "y"], internal_ordering=:degrevlex)
    R2, (x2, y2) = polynomial_ring(K2, ["x", "y"], internal_ordering=:degrevlex)
    system2 = [(2^49 + 1) * x2 - 1, (2^50) * y2 + (2^56 + 99)]
    system = map(f -> AbstractAlgebra.map_coefficients(c -> K1(data(c)), f), system2)
    trace, gb_1 = Groebner.groebner_learn(system)
    # TODO
    # flag, gb_2 = Groebner.groebner_apply!(trace, system2)
    # @test_broken gb_2 == [y2 + (2^56 + 99) // K2(2^50), x2 - 1 // K2(2^49 + 1)]

    # The trace ordering is reused unless an incompatible ordering is requested.
    K1, K2 = GF(2^31 - 1), GF(2^60 + 33)
    R, (x, y) = polynomial_ring(K1, ["x", "y"], internal_ordering=:lex)
    R2, (x2, y2) = polynomial_ring(K2, ["x", "y"], internal_ordering=:degrevlex)
    system = [x + 1, y - 1]
    system2 = [x2 + 1, y2 - 1]
    trace, gb_1 = Groebner.groebner_learn(system)
    flag, gb_2 = Groebner.groebner_apply!(trace, system2)
    @test flag && gb_2 == Groebner.groebner(system2; ordering=Groebner.Lex())

    K1, K2 = GF(2^31 - 1), GF(2^60 + 33)
    R, (x, y) = polynomial_ring(K1, ["x", "y"], internal_ordering=:lex)
    R2, (x2, y2) = polynomial_ring(K2, ["x", "y"], internal_ordering=:degrevlex)
    system = [x + 1, y - 1]
    system2 = [x2 + 1, y2 - 1]
    trace, gb_1 = Groebner.groebner_learn(system)
    @test_throws DomainError Groebner.groebner_apply!(trace, system2; ordering=Groebner.DegRevLex())

    # NOTE: these systems are only relatively very large.
    # We should also test for larger systems and larger primes!!
    R, (x, y) = polynomial_ring(ZZ, ["x", "y"], internal_ordering=:degrevlex)
    cases = [
        (system=[x, R(0)],),
        (system=[R(1)],),
        (system=[x, y],),
        (system=[x, x],),
        (system=[x, y, x * y],),
        (system=[x + 1, y + 2, x * y + 3],),
        (system=[x^20 * y + x + 1, x * y^20 + y + 1],),
        (system=[x^20 * y + x + 1, x * y^20 + y + 1],),
        (system=Groebner.Examples.noonn(3, internal_ordering=:lex, k=ZZ),),
        (system=Groebner.Examples.noonn(4, internal_ordering=:deglex, k=ZZ),),
        (system=Groebner.Examples.noonn(5, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.katsuran(3, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.katsuran(4, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.katsuran(5, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.katsuran(6, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.katsuran(7, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.cyclicn(5, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.cyclicn(6, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.rootn(5, internal_ordering=:lex, k=ZZ),),
        (system=Groebner.Examples.rootn(5, internal_ordering=:deglex, k=ZZ),),
        (system=Groebner.Examples.rootn(6, internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.eco5(internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.ku10(internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.kinema(internal_ordering=:degrevlex, k=ZZ),),
        (system=Groebner.Examples.s9_1(internal_ordering=:degrevlex, k=ZZ),)
    ]

    # Some bigger tests
    K = AbstractAlgebra.GF(2^31 - 1)
    Ks = [
        AbstractAlgebra.GF(2^31 - 1),
        AbstractAlgebra.GF(2^30 + 3),
        AbstractAlgebra.GF(2^31 + 11),
        AbstractAlgebra.GF(2^20 + 7),
        AbstractAlgebra.GF(2^20 + 13),
        AbstractAlgebra.GF(2^20 + 25),
        AbstractAlgebra.GF(2^15 + 3),
        AbstractAlgebra.GF(2^15 + 11),
        AbstractAlgebra.GF(2^15 + 15)
        # it may be dangerous to use learn & apply for small primes..
        # AbstractAlgebra.GF(2^11 + 5),
        # AbstractAlgebra.GF(2^11 + 15),
        # AbstractAlgebra.GF(2^11 + 21)
    ]
    for case in cases
        # Learn and apply on the same system
        system = case.system
        system_zp = map(f -> AbstractAlgebra.map_coefficients(c -> K(BigInt(c)), f), system)
        true_gb = Groebner.groebner(system_zp)
        trace, gb_1 = Groebner.groebner_learn(system_zp)
        flag, gb_2 = Groebner.groebner_apply!(trace, system_zp)
        @test flag && gb_2 == true_gb

        # Apply on the same system but modulo a different prime 
        for K_ in Ks
            system_zp_2 = map(f -> AbstractAlgebra.map_coefficients(c -> K_(BigInt(c)), f), system)
            flag, gb_2 = Groebner.groebner_apply!(trace, system_zp_2)
            @test flag && gb_2 == Groebner.groebner(system_zp_2)
        end
    end

    K1 = GF(2^31 - 1)
    R, (x, y) = polynomial_ring(ZZ, ["x", "y"], internal_ordering=:lex)
    system = [BigInt(2)^1000 * x + (BigInt(2)^1001 + 1) * y + 1]
    system_zp = map(f -> AbstractAlgebra.map_coefficients(c -> K1(BigInt(c)), f), system)
    _x, _y = gens(parent(system_zp[1]))
    trace, gb_1 = Groebner.groebner_learn(system_zp; ordering=Groebner.DegRevLex(_y, _x))
    for K in Primes.nextprimes(2^31, 200)
        system_zp = map(f -> AbstractAlgebra.map_coefficients(c -> GF(K)(BigInt(c)), f), system)
        _x, _y = gens(parent(system_zp[1]))
        true_gb = Groebner.groebner(system_zp; ordering=Groebner.DegRevLex(_y, _x))
        flag, gb_2 = Groebner.groebner_apply!(trace, system_zp; ordering=Groebner.DegRevLex(_y, _x))
        @test flag && gb_2 == true_gb
    end
end

@testset "learn & apply, generic" begin
    trace_keys(trace) = Set(keys(trace.recorded_traces))
    coeff_key(K) = Groebner.CoeffGeneric{typeof(one(K))}
    generic_coeff_data(sys) = map(f -> Groebner.CoeffGeneric.(collect(coefficients(f))), sys)

    # 1. learn specialized, apply generic.
    begin
        p, generic_p = 2^30 + 3, nextprime(big(2)^100)
        K, K_generic = GF(p), GF(generic_p)
        R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)
        sys = [x * y + 2 * y + 3, x + 4 * y + 5]
        R, (x, y) = polynomial_ring(K_generic, ["x", "y"], internal_ordering=:degrevlex)
        sys_generic = [x * y + 7 * y + 11, x + 13 * y + 17]
        trace, _ = Groebner.groebner_learn(sys)
        flag, _ = Groebner.groebner_apply!(trace, sys_generic)
        @test flag
        @test trace_keys(trace) == Set([UInt32, coeff_key(K_generic)])
    end

    # 2. learn generic, apply generic.
    begin
        p, generic_p = nextprime(big(2)^100), nextprime(big(2)^110)
        K, K_generic = GF(p), GF(generic_p)
        R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)
        sys = [x * y + 2 * y + 3, x + 4 * y + 5]
        R, (x, y) = polynomial_ring(K_generic, ["x", "y"], internal_ordering=:degrevlex)
        sys_generic = [x * y + 7 * y + 11, x + 13 * y + 17]
        trace, _ = Groebner.groebner_learn(sys)
        flag1, _ = Groebner.groebner_apply!(trace, sys_generic)
        flag2, _ = Groebner.groebner_apply!(trace, sys_generic)
        @test flag1 && flag2
        @test trace_keys(trace) == Set([coeff_key(K)])
    end

    # 3. learn generic, apply specialized, then apply over Z/pZ(t).
    begin
        p, generic_p = 2^30 + 3, nextprime(big(2)^100)
        K, K_generic = GF(p), GF(generic_p)
        Rt, (t,) = polynomial_ring(GF(101), ["t"])
        Kt = fraction_field(Rt)
        R, (x, y) = polynomial_ring(K_generic, ["x", "y"], internal_ordering=:degrevlex)
        sys_generic = [x * y + 2 * y + 3, x + 4 * y + 5]
        R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)
        sys = [x * y + 7 * y + 11, x + 13 * y + 17]
        R, (x, y) = polynomial_ring(Kt, ["x", "y"], internal_ordering=:degrevlex)
        sys_rat = [x * y + Kt(t) * y + one(Kt), x + Kt(t + 1) * y + Kt(2)]
        trace, _ = Groebner.groebner_learn(sys_generic)
        flag1, _ = Groebner.groebner_apply!(trace, sys)
        flag2, _ = Groebner.groebner_apply!(trace, sys_rat)
        flag3, _ = Groebner.groebner_apply!(trace, sys)
        flag4, _ = Groebner.groebner_apply!(trace, sys_rat)
        @test flag1 && flag2 && flag3 && flag4
        @test trace_keys(trace) == Set([UInt32, coeff_key(K_generic), coeff_key(Kt)])
    end

    # 4. learn specialized, then visit many specialized and generic.
    begin
        p8, p16, p32, p64 = 251, 65521, 2^30 + 3, nextprime(big(2)^40)
        generic_p1 = nextprime(big(2)^100)
        generic_p2 = nextprime(generic_p1 + 1000)

        K8, K16, K32, K64 = GF(p8), GF(p16), GF(p32), GF(p64)
        K_generic_1 = GF(generic_p1)
        K_generic_2 = GF(generic_p2)
        Rt, (t,) = polynomial_ring(GF(101), ["t"])
        Kt = fraction_field(Rt)

        R, (x, y) = polynomial_ring(K32, ["x", "y"], internal_ordering=:degrevlex)
        sys32 = [x * y + 2 * y + 3, x + 4 * y + 5]
        R, (x, y) = polynomial_ring(K8, ["x", "y"], internal_ordering=:degrevlex)
        sys8 = [x * y + 7 * y + 11, x + 13 * y + 17]
        R, (x, y) = polynomial_ring(K16, ["x", "y"], internal_ordering=:degrevlex)
        sys16 = [x * y + 19 * y + 23, x + 29 * y + 31]
        R, (x, y) = polynomial_ring(K64, ["x", "y"], internal_ordering=:degrevlex)
        sys64 = [x * y + 37 * y + 41, x + 43 * y + 47]
        R, (x, y) = polynomial_ring(K_generic_1, ["x", "y"], internal_ordering=:degrevlex)
        sys_generic_1 = [x * y + 53 * y + 59, x + 61 * y + 67]
        R, (x, y) = polynomial_ring(K_generic_2, ["x", "y"], internal_ordering=:degrevlex)
        sys_generic_2 = [x * y + 71 * y + 73, x + 79 * y + 83]
        R, (x, y) = polynomial_ring(Kt, ["x", "y"], internal_ordering=:degrevlex)
        sys_rat_1 = [x * y + Kt(t) * y + one(Kt), x + Kt(t + 1) * y + Kt(2)]
        sys_rat_2 = [x * y + Kt(t + 3) * y + Kt(5), x + Kt(t + 7) * y + Kt(11)]
        R, (x, y) = polynomial_ring(QQ, ["x", "y"], internal_ordering=:degrevlex)
        sys_qq = [x * y + 89 * y + 97, x + 101 * y + 103]

        trace, _ = Groebner.groebner_learn(sys32)
        for sys in (sys8, sys16, sys64, sys_generic_1, sys_generic_2, sys_rat_1, sys_rat_2)
            flag, _ = Groebner.groebner_apply!(trace, sys)
            @test flag
        end
        flag, _ = Groebner.groebner_apply!(trace, sys_qq)
        @test flag

        @test trace_keys(trace) == Set([
            UInt8,
            UInt16,
            UInt32,
            UInt64,
            coeff_key(K_generic_1),
            coeff_key(Kt),
            Rational{BigInt}
        ])
    end

    @testset "equivalent orderings recognized" begin
        p = nextprime(big(2)^100)
        K = GF(p)
        R, (x1, y1) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)
        sys = [x1 * y1 + 2 * y1 + 3, x1 + 4 * y1 + 5]

        Rt, (t,) = polynomial_ring(GF(101), ["t"])
        Kt = fraction_field(Rt)
        R, (x2, y2) = polynomial_ring(Kt, ["x", "y"], internal_ordering=:degrevlex)
        sys_rat = [x2 * y2 + Kt(t) * y2 + one(Kt), x2 + Kt(t + 1) * y2 + Kt(2)]

        trace, _ = Groebner.groebner_learn(sys; ordering=Groebner.Lex(y1, x1))
        flag, gb2 = Groebner.groebner_apply!(trace, sys_rat; ordering=Groebner.Lex(y2, x2))
        @test flag
        @test gb2 == Groebner.groebner(sys_rat; ordering=Groebner.Lex(y2, x2))
    end

    @testset "forced generic agrees" begin
        K = GF(2^30 + 3)
        sys1 = Groebner.Examples.katsuran(4, internal_ordering=:degrevlex, k=K)
        sys2 = Groebner.Examples.katsuran(4, internal_ordering=:lex, k=K)

        for sys in (sys1, sys2)
            gb = Groebner.groebner(sys)

            trace_spec, gb_spec = Groebner.groebner_learn(sys)
            trace_gen, gb_gen = Groebner.groebner_learn(sys; _generic=true)

            flag_gen_spec, gb_apply_gen_spec = Groebner.groebner_apply!(trace_gen, sys)
            flag_spec_gen, gb_apply_spec_gen =
                Groebner.groebner_apply!(trace_spec, sys; _generic=true)

            @test gb_spec == gb_gen == gb
            @test flag_gen_spec && gb_apply_gen_spec == gb
            @test flag_spec_gen && gb_apply_spec_gen == gb
            @test trace_keys(trace_spec) == Set([UInt32, coeff_key(K)])
            @test trace_keys(trace_gen) == Set([UInt32, coeff_key(K)])
        end
    end

    @testset "generic reuse after failure" begin
        K = GF(2^30 + 3)
        R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)
        sys_ok = [x + 1, x * y + 7 * y]
        sys_fail = [x + 1, x * y + y]

        trace, gb = Groebner.groebner_learn(sys_ok; _generic=true)
        flag_fail, _ = Groebner.groebner_apply!(trace, sys_fail; _generic=true)
        flag_ok, gb_ok = Groebner.groebner_apply!(trace, sys_ok; _generic=true)

        @test !flag_fail
        @test flag_ok && gb_ok == gb == Groebner.groebner(sys_ok)
        @test trace_keys(trace) == Set([coeff_key(K)])
    end

    monom_data(sys) = map(f -> collect(exponent_vectors(f)), sys)
    coeff_data(sys) = map(f -> collect(coefficients(f)), sys)
    strip_generic(coeffs) = map(c -> Groebner.generic_coeff_data.(c), coeffs)
    @testset "generic low level" begin
        p = nextprime(big(2)^100)
        p2 = nextprime(p + 1000)
        K, K2 = GF(p), GF(p2)
        R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)
        sys1 = [x * y + 2 * y + 3, x + 4 * y + 5]
        R, (x, y) = polynomial_ring(K2, ["x", "y"], internal_ordering=:degrevlex)
        sys2 = [x * y + 7 * y + 11, x + 13 * y + 17]

        ring = Groebner.PolyRing(2, Groebner.DegRevLex(), UInt(0), :generic)
        monoms1 = monom_data(sys1)
        coeffs1 = generic_coeff_data(sys1)
        monoms2 = monom_data(sys2)
        coeffs2 = generic_coeff_data(sys2)

        trace1, gb_monoms1, gb_coeffs1 = Groebner.groebner_learn(ring, monoms1, coeffs1)
        trace2, gb2 = Groebner.groebner_learn(sys1)
        flag1, gb_apply_coeffs1 = Groebner.groebner_apply!(trace1, ring, monoms2, coeffs2)
        flag2, gb_apply2 = Groebner.groebner_apply!(trace2, sys2)

        @test gb_monoms1 == monom_data(gb2)
        @test strip_generic(gb_coeffs1) == coeff_data(gb2)
        @test flag1 && flag2
        @test strip_generic(gb_apply_coeffs1) == coeff_data(gb_apply2)
        @test trace_keys(trace1) == Set([coeff_key(K)])
        @test trace_keys(trace1) == trace_keys(trace2)
    end
end

@testset "learn & apply, orderings" begin
    K = GF(2^31 - 1)
    R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:lex)

    ord_1 = Groebner.Lex()
    trace_1, gb_1 = Groebner.groebner_learn([x + 2y + 3, y], ordering=ord_1)
    @test gb_1 == [y, x + 3]

    flag, gb_1_apply = Groebner.groebner_apply!(trace_1, [x + y + 3, y])
    @test flag && gb_1 == gb_1_apply

    ord_2 = Groebner.Lex(y, x)
    trace_2, gb_2 = Groebner.groebner_learn([y, x + 2y^2 + 3], ordering=ord_2)
    @test gb_2 == [x + 3, y]

    flag, gb_2_apply = Groebner.groebner_apply!(trace_2, [y, x + 2y^2 + 3])
    @test flag && gb_2 == gb_2_apply
    @test_throws DomainError Groebner.groebner_apply!(
        trace_2,
        [y, x + 2y^2 + 3],
        ordering=Groebner.Lex()
    )

    K = GF(2^31 - 1)
    n = 10
    R, x = polynomial_ring(K, [["x$i" for i in 1:n]...], internal_ordering=:degrevlex)
    F = (x .+ (1:n) .* circshift(x, 1)) .^ 2
    # F = [(x1 + xn)^2, (x2 + 2 x1)^2, ..., (xn + n x_{n-1})^2]
    for i in 0:(2n)
        if i < n
            xi = circshift(x, -i)
        else
            xi = Random.shuffle(x)
        end

        ord = Groebner.Lex(xi)
        input = Random.shuffle(F)
        gb = Groebner.groebner(input, ordering=ord)
        trace, gb_1 = Groebner.groebner_learn(input, ordering=ord)
        flag, gb_2 = Groebner.groebner_apply!(trace, input)
        @test gb == gb_1
        @test flag && gb == gb_2

        ord = Groebner.DegRevLex(xi)
        input = Random.shuffle(F)
        gb = Groebner.groebner(input, ordering=ord)
        trace, gb_1 = Groebner.groebner_learn(input, ordering=ord)
        flag, gb_2 = Groebner.groebner_apply!(trace, input)
        @test gb == gb_1
        @test flag && gb == gb_2
    end
end

@testset "learn & apply, copy trace" begin
    K1, K2 = GF(2^30 + 3), GF(2^31 - 1)
    R1, (x1, y1) = polynomial_ring(K1, ["x", "y"])
    R2, (x2, y2) = polynomial_ring(K2, ["x", "y"])

    trace1, gb1 = Groebner.groebner_learn([x1 + 2y1 + 3, y1])
    @test gb1 == [y1, x1 + 3]

    trace2 = deepcopy(trace1)

    flag, gb1_apply = Groebner.groebner_apply!(trace2, [x1 + y1 + 3, y1])
    @test flag && gb1 == gb1_apply

    flag, gb2_apply = Groebner.groebner_apply!(trace1, [x2 + y2 + 3, y2])
    @test flag && [y2, x2 + 3] == gb2_apply
    flag, gb2_apply = Groebner.groebner_apply!(trace2, [x2 + y2 + 3, y2])
    @test flag && [y2, x2 + 3] == gb2_apply
end

@testset "learn & apply, tricky" begin
    for K in [GF(2^31 - 1), GF(2^62 + 135)]
        R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)

        s = [x^100 * y + y^100, x * y^100 + y]
        trace, gb_1 = Groebner.groebner_learn(s)
        flag, gb_2 = Groebner.groebner_apply!(trace, s)
        @test gb_1 == gb_2 == [x * y^100 + y, x^100 * y + y^100, y^199 - x^99 * y]

        s = [x^200 * y + y^200, x * y^200 + y]
        trace, gb_1 = Groebner.groebner_learn(s)
        flag, gb_2 = Groebner.groebner_apply!(trace, s)
        @test gb_1 == gb_2 == [x * y^200 + y, x^200 * y + y^200, y^399 - x^199 * y]

        s = [x^1000 * y + y^1000, x * y^1000 + y]
        trace, gb_1 = Groebner.groebner_learn(s)
        show(trace)
        for _ in 1:5
            flag, gb_2 = Groebner.groebner_apply!(trace, s)
            @test gb_1 == gb_2 == [x * y^1000 + y, x^1000 * y + y^1000, y^1999 - x^999 * y]
        end
    end

    K = AbstractAlgebra.GF(2^31 - 1)
    R, (x, y) = polynomial_ring(K, ["x", "y"], internal_ordering=:degrevlex)

    # s-poly of x + 1 and x*y + 7y is y - 7y.
    system_1 = [x + 1, x * y + 7y]
    trace, gb_1 = Groebner.groebner_learn(system_1)
    flag, gb_2 = Groebner.groebner_apply!(trace, system_1)
    @test flag && gb_2 == gb_1

    flag, _ = Groebner.groebner_apply!(trace, [x, y])
    @test !flag

    # Cancellation of a leading term:
    # s-poly of x + 1 and x*y + y is 0 = y - y.
    system_2 = [x + 1, x * y + y]
    flag, gb_2 = Groebner.groebner_apply!(trace, system_2)
    @test !flag

    # s-poly of x + y + 1 and x*y + 7y is y^2 - 7y
    system_1 = [x + y + 1, x * y + 7y]
    trace, gb_1 = Groebner.groebner_learn(system_1)
    flag, gb_2 = Groebner.groebner_apply!(trace, system_1)
    @test flag && gb_2 == gb_1

    # Cancellation of a trailing term:
    # s-poly of x + y + 1 and x*y + y is y^2
    # TODO: produce a warning here
    system_2 = [x + y + 1, x * y + y]
    flag, gb_2 = Groebner.groebner_apply!(trace, system_2)
    @test !flag

    # Input is a Groebner basis already:
    N = 3
    for system in [
        Groebner.Examples.noonn(4, internal_ordering=:degrevlex, k=K),
        Groebner.Examples.katsuran(5, internal_ordering=:degrevlex, k=K),
        [x, x^2, y^2, x * y, x^3, y^4, x^10, y^10, x * y^10]
    ]
        gb = Groebner.groebner(system)
        for i in 1:N
            trace, gb_1 = Groebner.groebner_learn(gb)
            flag, gb_2 = Groebner.groebner_apply!(trace, gb)
            @test flag && gb_2 == gb_1 == gb
        end
    end

    # Leading term in the matrix cancel out
    R, (x, y) = polynomial_ring(QQ, ["x", "y"], internal_ordering=:degrevlex)
    p, p2 = 3, 19
    sys = [-11 * x * y + 53 * y, 83 * x * y + x - 70 * y]
    sys_mod_p = map(
        f -> AbstractAlgebra.map_coefficients(c -> GF(p)(numerator(c)), f),
        [x * y + 2 * y, 2 * x * y + x + 2 * y]
    )
    sys_mod_p2 = map(
        f -> AbstractAlgebra.map_coefficients(c -> GF(p2)(numerator(c)), f),
        [8 * x * y + 15 * y, 7 * x * y + x + 6 * y]
    )
    Groebner.groebner(sys_mod_p)
    Groebner.groebner(sys_mod_p2)

    trace, gb1 = Groebner.groebner_learn(sys_mod_p)
    flag2, gb2 = Groebner.groebner_apply!(trace, sys_mod_p)
    @test flag2
    flag3, gb3 = Groebner.groebner_apply!(trace, sys_mod_p2)
    flag4, gb4 = Groebner.groebner_apply!(trace, sys_mod_p2)
    flag5, gb5 = Groebner.groebner_apply!(trace, sys_mod_p2)

    flag6, gb6 = Groebner.groebner_apply!(trace, sys_mod_p)
    @test flag6 && gb6 == gb2

    trace, gb = Groebner.groebner_learn(sys_mod_p2)
    flag, gb = Groebner.groebner_apply!(trace, sys_mod_p2)
    @test flag
    flag, gb = Groebner.groebner_apply!(trace, sys_mod_p)
end

@testset "learn & apply low level" begin
    function test_low_level_interface(ring, sys; passthrough...)
        T(x) = base_ring(parent(sys[1])) == QQ ? Rational{BigInt}(x) : UInt64(lift(x))
        monoms = map(f -> collect(exponent_vectors(f)), sys)
        coeffs = map(f -> collect(T.(coefficients(f))), sys)
        trace1, gb_monoms1, gb_coeffs1 =
            Groebner.groebner_learn(ring, monoms, coeffs; passthrough...)
        trace2, gb2 = Groebner.groebner_learn(sys; passthrough...)
        gb_monoms2 = map(f -> collect(exponent_vectors(f)), gb2)
        gb_coeffs2 = map(f -> collect(T.(coefficients(f))), gb2)
        @test (gb_monoms1, gb_coeffs1) == (gb_monoms2, gb_coeffs2)
        flag3, gb_coeffs3 = Groebner.groebner_apply!(trace1, ring, monoms, coeffs; passthrough...)
        flag4, gb4 = Groebner.groebner_apply!(trace2, sys; passthrough...)
        gb_coeffs4 = map(f -> collect(T.(coefficients(f))), gb4)
        @test (flag3, gb_coeffs3) == (flag4, gb_coeffs4)
    end

    R, (x, y) = polynomial_ring(GF(2^31 - 1), ["x", "y"], internal_ordering=:degrevlex)

    ring = Groebner.PolyRing(2, Groebner.DegRevLex(), 2^31 - 1)
    @test_throws DomainError Groebner.groebner_learn(ring, [], [])
    @test ([[[0, 0]]], [[1]]) == Groebner.groebner_learn(ring, [[[0, 0]]], [[1]])[2:3]
    @test ([[[1, 1]]], [[1]]) == Groebner.groebner_learn(ring, [[[1, 1]]], [[2]])[2:3]
    trace, _ = Groebner.groebner_learn(ring, [[[1, 1]]], [[2]])
    @test (true, [[1]]) == Groebner.groebner_apply!(trace, ring, [[[1, 1]]], [[2]])
    # ring = Groebner.PolyRing(2, Groebner.Lex(), 2^30 + 3)
    # @test ([[[0, 0]]], [[1]]) == Groebner.groebner_learn(ring, [[[0, 0]]], [[1]])[2:3]
    # @test ([[[1, 1]]], [[1]]) == Groebner.groebner_learn(ring, [[[1, 1]]], [[2]])[2:3]

    ring0 = Groebner.PolyRing(2, Groebner.DegLex(), 5)
    ring1 = Groebner.PolyRing(2, Groebner.DegLex(), 7)
    ring2 = Groebner.PolyRing(2, Groebner.DegLex(), 11)
    ring3 = Groebner.PolyRing(2, Groebner.DegLex(), 13)
    ring4 = Groebner.PolyRing(2, Groebner.DegLex(), 17)
    trace, (gb0...) = Groebner.groebner_learn(ring0, [[[0, 0], [1, 1]]], [[1, -1]])
    @test gb0 == ([[[1, 1], [0, 0]]], [[1, 4]])
    flag1, gb1 = Groebner.groebner_apply!(trace, ring1, [[[0, 0], [1, 1]]], [[1, -1]])
    flag2, gb2 = Groebner.groebner_apply!(trace, ring2, [[[1, 1], [0, 0]]], [[-1, 1]])
    flag3, gb3 = Groebner.groebner_apply!(trace, ring3, [[[0, 0], [0, 1], [1, 1]]], [[1, 0, -1]])
    flag4, gb4 = Groebner.groebner_apply!(trace, ring4, [[[0, 0], [1, 1]]], [[1, -1]])
    @test flag1 && flag2 && flag3 && flag4
    @test gb1 == ([[1, 6]])
    @test gb2 == ([[1, 10]])
    @test gb3 == ([[1, 12]])
    @test gb4 == ([[1, 16]])

    flag1, gb1 = Groebner.groebner_apply!(trace, ring1, [[[0, 0]]], [[1]])
    flag2, gb2 = Groebner.groebner_apply!(trace, ring2, [[[1, 1], [0, 0]]], [[-1, 0]])
    flag3, gb3 = Groebner.groebner_apply!(trace, ring3, [[[0, 0], [0, 1], [1, 1]]], [[1, 0, -1]])
    flag4, gb4 = Groebner.groebner_apply!(trace, ring4, [[[0, 0], [1, 1]]], [[1, -1]])
    @test !flag1 && !flag2 && flag3 && flag4

    sys = Groebner.Examples.cyclicn(5, k=GF(2^40 + 15))
    ring = Groebner.PolyRing(5, Groebner.DegRevLex(), 2^40 + 15)
    test_low_level_interface(ring, sys)

    sys = Groebner.Examples.cyclicn(5, k=GF(2^30 + 3))
    ring = Groebner.PolyRing(5, Groebner.DegRevLex(), 2^30 + 3)
    test_low_level_interface(ring, sys; ordering=Groebner.DegRevLex())
end

@testset "learn & apply, stress" begin
    # stress test for small primes for errors
    Random.seed!(42)
    R, (x, y) = polynomial_ring(QQ, ["x", "y"], internal_ordering=:degrevlex)
    for sys in [[x * y + y, x * y + x + y], Groebner.Examples.cyclicn(5)]
        A, B = 0, 0
        boot = 10
        primes1 = vcat(Primes.nextprimes(2, 10), 1031, 2^20 + 7, 2^27 - 39, 2^27 + 29)
        primes2 = primes1
        @info """
        Stress testing groebner_apply! on:
        primes =    $primes1
        boot =      $boot
        system =
        $sys"""

        for p in primes1
            for i in 1:boot
                sys_x = empty(sys)
                for f in sys
                    _f = zero(f)
                    for t in AbstractAlgebra.monomials(f)
                        __c = rand(-100:100)
                        _f += t * __c
                    end
                    push!(sys_x, _f)
                end
                sys_x_mod_p =
                    map(f -> AbstractAlgebra.map_coefficients(c -> GF(p)(numerator(c)), f), sys_x)
                all(iszero, sys_x_mod_p) && continue
                trace, gb = Groebner.groebner_learn(sys_x_mod_p)
                backup = deepcopy(trace)
                for p2 in primes2
                    p == p2 && continue
                    sys_x_mod_p2 = map(
                        f -> AbstractAlgebra.map_coefficients(c -> GF(p2)(numerator(c)), f),
                        sys_x
                    )
                    success, gb2 = Groebner.groebner_apply!(trace, sys_x_mod_p2)
                    if !success
                        A += 1
                        trace = backup
                        backup = deepcopy(trace)
                    end
                    B += 1
                end
            end
        end
        @info "Apply (expectedly) failed in $A / $B cases."
    end
end

@testset "learn & apply, in batches" begin
    # Simple sanity checks
    ks = map(GF, Primes.nextprimes(2^30, 40))

    R, (x, y) = polynomial_ring(AbstractAlgebra.ZZ, ["x", "y"], internal_ordering=:degrevlex)
    sys_qq = [44x^2 + x + 2^50, y^10 - 10 * y^5 - 99]
    sys_gf = map(
        j ->
            map(poly -> AbstractAlgebra.map_coefficients(c -> (k = ks[j]; k(c)), poly), sys_qq),
        1:length(ks)
    )

    trace, gb = Groebner.groebner_learn(sys_gf[1])

    flag1, gb1 = Groebner.groebner_apply!(trace, sys_gf[1])
    flag2, gb2 = Groebner.groebner_apply!(trace, sys_gf[2])
    flag3, (gb3, gb4) = Groebner.groebner_apply!(trace, (sys_gf[3], sys_gf[4]))
    flag4, (gb5, gb6, gb7, gb8) =
        Groebner.groebner_apply!(trace, (sys_gf[3], sys_gf[4], sys_gf[5], sys_gf[6]))
    flag5, (gb9, gb10, gb11, gb12, gb13, gb14, gb15, gb16) = Groebner.groebner_apply!(
        trace,
        (sys_gf[3], sys_gf[4], sys_gf[5], sys_gf[6], sys_gf[7], sys_gf[8], sys_gf[9], sys_gf[10])
    )
    # he-he
    flag6, gbs = Groebner.groebner_apply!(trace, (sys_gf[3:18]...,))

    @test flag1 && flag2 && flag3 && flag4 && flag5 && flag6

    true_gb = map(Groebner.groebner, sys_gf)
    @test [gb1, gb2, gb3, gb4] == true_gb[1:4]
    @test [gb5, gb6, gb7, gb8] == true_gb[3:6]
    @test [gb9, gb10, gb11, gb12, gb13, gb14, gb15, gb16] == true_gb[3:10]
    @test collect(gbs) == true_gb[3:18]

    function test_learn_apply(system, primes)
        @assert length(primes) > 4
        systems_zp =
            map(p -> map(f -> AbstractAlgebra.map_coefficients(c -> GF(p)(c), f), system), primes)

        trace, gb_0 = Groebner.groebner_learn(systems_zp[1])

        flag, gb = Groebner.groebner_apply!(trace, systems_zp[2])
        @test gb == Groebner.groebner(systems_zp[2])

        flag, (gb,) = Groebner.groebner_apply!(trace, (systems_zp[2],))
        @test gb == Groebner.groebner(systems_zp[2])

        flag, gbs = Groebner.groebner_apply!(trace, (systems_zp[2:5]...,))
        @test collect(gbs) == map(Groebner.groebner, systems_zp[2:5])
    end

    kat = Groebner.Examples.katsuran(8, k=ZZ, internal_ordering=:degrevlex)
    cyc = Groebner.Examples.cyclicn(6, k=ZZ, internal_ordering=:degrevlex)
    cyc_lex = Groebner.Examples.cyclicn(5, k=ZZ, internal_ordering=:lex)

    ps1 = Primes.nextprimes(2^30, 5)
    ps2 = [2^31 - 1, 2^30 + 3, 2^32 + 15, 2^40 + 15, 2^30 + 3]

    test_learn_apply(kat, ps1)
    test_learn_apply(kat, ps2)
    test_learn_apply(cyc, ps2)
    test_learn_apply(cyc_lex, ps2)
end

@testset "learn & apply, recover after failed batch" begin
    bad_primes = (241, 239, 233, 229)
    good_primes = (227, 223, 211, 199)

    function system(characteristic)
        R, (x, y) = polynomial_ring(GF(characteristic), ["x", "y"])
        [x + y, x + (first(bad_primes) + 1) * y + 1]
    end

    trace, _ = Groebner.groebner_learn(system(251), ordering=Groebner.DegRevLex())

    bad_systems = map(system, bad_primes)
    success, _ = Groebner.groebner_apply!(trace, bad_systems, ordering=Groebner.DegRevLex())
    @test !success

    good_systems = map(system, good_primes)
    success, bases = Groebner.groebner_apply!(trace, good_systems, ordering=Groebner.DegRevLex())
    @test success
    @test collect(bases) == map(
        system -> Groebner.groebner(system, ordering=Groebner.DegRevLex()),
        collect(good_systems)
    )
end

@testset "learn & apply low level, in batches" begin
    ring0 = Groebner.PolyRing(2, Groebner.DegLex(), 5)
    ring1 = Groebner.PolyRing(2, Groebner.DegLex(), 7)
    ring2 = Groebner.PolyRing(2, Groebner.DegLex(), 11)
    ring3 = Groebner.PolyRing(2, Groebner.DegLex(), 13)
    ring4 = Groebner.PolyRing(2, Groebner.DegLex(), 17)
    trace, (gb0...) = Groebner.groebner_learn(ring0, [[[0, 0], [1, 1]]], [[1, -1]])
    @test gb0 == ([[[1, 1], [0, 0]]], [[1, 4]])
    flag, (gb1, gb2, gb3, gb4) = Groebner.groebner_apply!(
        trace,
        (
            (ring1, [[[0, 0], [1, 1]]], [[1, -1]]),
            (ring2, [[[1, 1], [0, 0]]], [[-1, 1]]),
            (ring3, [[[0, 0], [0, 1], [1, 1]]], [[1, 0, -1]]),
            (ring4, [[[0, 0], [1, 1]]], [[1, -1]])
        )
    )
    @test flag
    @test gb1 == ([[1, 6]])
    @test gb2 == ([[1, 10]])
    @test gb3 == ([[1, 12]])
    @test gb4 == ([[1, 16]])

    @test_throws AssertionError Groebner.groebner_apply!(
        trace,
        ((ring1, [[[0, 0]]], [[1]]), (ring2, [[[1, 1], [0, 0]]], [[-1, 1]]))
    )
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Backend for auxiliary function: leading_term

# polynomials => polynomials
function leading_term0(polynomials, options::KeywordArguments)
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    result_monoms, result_coeffs = _leading_term1(ring, monoms, coeffs, options)
    result = io_convert_ir_to_polynomials(ring, polynomials, result_monoms, result_coeffs, options)
    result
end

# (exponent vectors, coefficients) => (exponent vectors, coefficients)
function leading_term1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    _leading_term1(ring, monoms, coeffs, options)
end

function _leading_term1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    @invariant ir_is_valid(ring, monoms, coeffs)
    params = AlgorithmParameters(ring, options; hint=:large_exponents)
    _, _ring, _monoms, _coeffs = ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    _result_monoms, _result_coeffs = leading_term2(_ring, _monoms, _coeffs, params)
    result_monoms, result_coeffs =
        ir_convert_internal_to_ir(_ring, _result_monoms, _result_coeffs, params)
    result_monoms, result_coeffs
end

# internal structs => internal structs
function leading_term2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    result_monoms = map(f -> isempty(f) ? f : [first(f)], monoms)
    result_coeffs = map(f -> isempty(f) ? f : [first(f)], coeffs)
    result_monoms, result_coeffs
end

###
# Backend for auxiliary function: leading_ideal

# polynomials => polynomials
function leading_ideal0(polynomials, options::KeywordArguments)
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    result_monoms, result_coeffs = _leading_ideal1(ring, monoms, coeffs, options)
    result = io_convert_ir_to_polynomials(ring, polynomials, result_monoms, result_coeffs, options)
    result
end

# (exponent vectors, coefficients) => (exponent vectors, coefficients)
function leading_ideal1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    _leading_ideal1(ring, monoms, coeffs, options)
end

function _leading_ideal1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    try
        params = AlgorithmParameters(ring, options)
        return __leading_ideal1(ring, monoms, coeffs, params)
    catch err
        if isa(err, MonomialDegreeOverflow)
            _info_possible_overflow()
            params = AlgorithmParameters(ring, options; hint=:large_exponents)
            return __leading_ideal1(ring, monoms, coeffs, params)
        else
            # Something bad happened.
            rethrow(err)
        end
    end
end

function __leading_ideal1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {I <: Integer, C <: Coeff}
    @invariant ir_is_valid(ring, monoms, coeffs)
    _, _ring, _monoms, _coeffs = ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    _result_monoms, _result_coeffs = leading_ideal2(_ring, _monoms, _coeffs, params)
    result_monoms, result_coeffs =
        ir_convert_internal_to_ir(_ring, _result_monoms, _result_coeffs, params)
    result_monoms, result_coeffs
end

# internal structs => internal structs
function leading_ideal2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    if !isgroebner2(ring, monoms, coeffs, params)
        monoms, coeffs = groebner2(ring, monoms, coeffs, params)
    end
    monoms, coeffs = autoreduce2(ring, monoms, coeffs, params)
    result_monoms = map(f -> isempty(f) ? f : [first(f)], monoms)
    result_coeffs = map(f -> isempty(f) ? f : [first(f)], coeffs)
    result_monoms, result_coeffs
end

###
# Backend for auxiliary function: quotient_basis
# Copied from StructuralIdentifiability.jl. The license is MIT.
# Copied from RationalUnivariateRepresentation.jl. The license is MIT.

# polynomials => polynomials
function quotient_basis0(polynomials, options::KeywordArguments)
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    result_monoms, result_coeffs = _quotient_basis1(ring, monoms, coeffs, options)
    result = io_convert_ir_to_polynomials(ring, polynomials, result_monoms, result_coeffs, options)
    result
end

# (exponent vectors, coefficients) => (exponent vectors, coefficients)
function quotient_basis1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    _quotient_basis1(ring, monoms, coeffs, options)
end

function _quotient_basis1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    try
        params = AlgorithmParameters(ring, options)
        return __quotient_basis1(ring, monoms, coeffs, params)
    catch err
        if isa(err, MonomialDegreeOverflow)
            _info_possible_overflow()
            params = AlgorithmParameters(ring, options; hint=:large_exponents)
            return __quotient_basis1(ring, monoms, coeffs, params)
        else
            # Something bad happened.
            rethrow(err)
        end
    end
end

function __quotient_basis1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {I <: Integer, C <: Coeff}
    @invariant ir_is_valid(ring, monoms, coeffs)
    _, _ring, _monoms, _coeffs = ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    _result_monoms, _result_coeffs = quotient_basis2(_ring, _monoms, _coeffs, params)
    result_monoms, result_coeffs =
        ir_convert_internal_to_ir(_ring, _result_monoms, _result_coeffs, params)
    result_monoms, result_coeffs
end

# internal structs => internal structs
function quotient_basis2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    monoms, coeffs = leading_ideal2(ring, monoms, coeffs, params)
    # GB = {0}
    if isempty(monoms[1])
        throw(DomainError("Input does not define a zero-dimensional ideal."))
    end
    n = ring.nvars
    leading_exponents = map(m -> monom_to_vector!(zeros(Int, n), first(m)), monoms)
    # GB != {1} and GB is not zero dimensional
    if monoms[1][1] != monom_construct_const(M, n) &&
       length(filter(e -> count(iszero, e) == n - 1, leading_exponents)) < n
        throw(DomainError("Input does not define a zero-dimensional ideal."))
    end
    @invariant begin
        # `dimension2` requires DegRevLex; we ensure monomials are compatible
        if monom_is_supported_ordering(params.representation.monomtype, DegRevLex())
            params_drl = struct_update(AlgorithmParameters, params, (target_ord=DegRevLex(),))
            dimension2(ring, monoms, coeffs, params_drl) in (-1, 0)
        end
    end
    exponents_to_check = Vector{Vector{Int}}()
    exponents_checked = Set{Vector{Int}}()
    basis_exponents = Set{Vector{Int}}()
    push!(exponents_to_check, zeros(Int, n))
    function _divisible(e1, e2)
        for i in 1:length(e1)
            e1[i] < e2[i] && return false
        end
        true
    end
    while length(exponents_to_check) > 0
        e = popfirst!(exponents_to_check)
        push!(exponents_checked, e)
        if !any(le -> _divisible(e, le), leading_exponents)
            push!(basis_exponents, e)
            for i in 1:n
                next_e = copy(e)
                next_e[i] += 1
                if !(next_e in exponents_checked) && !(next_e in exponents_to_check)
                    push!(exponents_to_check, next_e)
                end
            end
        end
    end
    qb_len = length(basis_exponents)
    basis_exponents = [[monom_construct_from_vector(M, v)] for v in basis_exponents]
    basis_coeffs = Vector{Vector{C}}([[one(coeffs[1][1])] for _ in 1:qb_len])
    return basis_exponents, basis_coeffs
end

###
# Backend for auxiliary function: dimension
# Copied from AlgebraicSolving.jl. The license is GNU GPL, Version 3.0+.

# polynomials => polynomials
function dimension0(polynomials, options::KeywordArguments)
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    _dimension1(ring, monoms, coeffs, options)
end

# (exponent vectors, coefficients) => (exponent vectors, coefficients)
function dimension1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    _dimension1(ring, monoms, coeffs, options)
end

function _dimension1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    options = struct_update(KeywordArguments, options, (ordering=DegRevLex(),))
    try
        params = AlgorithmParameters(ring, options)
        return __dimension1(ring, monoms, coeffs, params)
    catch err
        if isa(err, MonomialDegreeOverflow)
            _info_possible_overflow()
            params = AlgorithmParameters(ring, options; hint=:large_exponents)
            return __dimension1(ring, monoms, coeffs, params)
        else
            # Something bad happened.
            rethrow(err)
        end
    end
end

function __dimension1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {I <: Integer, C <: Coeff}
    @invariant ir_is_valid(ring, monoms, coeffs)
    _, _ring, _monoms, _coeffs = ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    result = dimension2(_ring, _monoms, _coeffs, params)
    result
end

# internal structs => internal structs
function dimension2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    @assert params.target_ord == DegRevLex()
    params = struct_update(AlgorithmParameters, params, (target_ord=DegRevLex(),))
    monoms, coeffs = leading_ideal2(ring, monoms, coeffs, params)
    # GB = {0} or GB = {1}
    if isempty(monoms[1])
        return -1
    end
    res = [trues(ring.nvars)]
    lead_exps = map(x -> monom_to_vector!(zeros(Int, ring.nvars), first(x)), monoms)
    for lexp in lead_exps
        to_del = Int[]
        new_miss = BitVector[]
        for (i, mis) in enumerate(res)
            nz_exps_inds = findall(e -> !iszero(e), lexp)
            ind_var_inds = findall(mis)
            if issubset(nz_exps_inds, ind_var_inds)
                for j in nz_exps_inds
                    new_mis = copy(mis)
                    new_mis[j] = false
                    push!(new_miss, new_mis)
                end
                push!(to_del, i)
            end
        end
        deleteat!(res, to_del)
        append!(res, new_miss)
        unique!(res)
    end
    length(res) == 0 && return -1
    max_length = maximum(mis -> length(findall(mis)), res)
    return max_length
end

using Test, InteractiveUtils, Groebner
using InteractiveUtils, Random

# Check invariants during testing.
@eval Groebner invariants_enabled() = true

function is_github_ci()
    return parse(Bool, get(ENV, "GITHUB_ACTIONS", "false"))
end

if is_github_ci()
    @info "Running in a Github CI job. Printing specs!"
    versioninfo(verbose=true)
else
    versioninfo()
end

# Taken from JuMP/test/solvers.jl
function try_import(name::Symbol)
    try
        @eval import $name
        return true
    catch e
        return false
    end
end

# Isolate tests into separate modules so they don't interfere
function isolated_testset(name)
    @assert endswith(name, ".jl")
    @info "Running $name"
    mod = gensym(Symbol(chop(name, tail=2)))
    @time @eval module $mod
    include($name)
    end
end

@test isempty(Test.detect_ambiguities(Groebner))

@time @testset "All tests" verbose = true begin
    isolated_testset("arithmetic.jl")
    isolated_testset("crt.jl")
    isolated_testset("ratrec.jl")

    # Different implementations of a monomial
    isolated_testset("monoms/exponentvector.jl")
    isolated_testset("monoms/packedtuples.jl")
    isolated_testset("monoms/nibblemonom.jl")
    isolated_testset("monoms/monom_arithmetic.jl")
    isolated_testset("monoms/monom_orders.jl")

    isolated_testset("groebner.jl")
    isolated_testset("learn_and_apply.jl")
    isolated_testset("isgroebner.jl")
    isolated_testset("normalform.jl")
    isolated_testset("auxiliary.jl")

    isolated_testset("output_inferred.jl")
    isolated_testset("regressions.jl")

    # Test for different frontends: 
    # - AbstractAlgebra.jl
    # - Nemo.jl
    # - DynamicPolynomials.jl
    # isolated_testset("input_output/AbstractAlgebra.jl")
    if try_import(:DynamicPolynomials)
        isolated_testset("input_output/GroebnerDynamicPolynomialsExt.jl")
    end
    if try_import(:Nemo)
        isolated_testset("input_output/Nemo.jl")
    end
end

import Pkg

include("../utils.jl")
julia_pkg_preamble("$(@__DIR__)")

using CpuId, Logging, Pkg, Printf
using Statistics

logger = Logging.ConsoleLogger(stdout, Logging.Info)
global_logger(logger)

const runtime = Dict()

const PROBLEM_NAME = ARGS[1]
const NUM_RUNS = parse(Int, ARGS[2])
const BENCHMARK_SET = parse(Int, ARGS[3])
const VALIDATE = parse(Bool, ARGS[4])
const BIN_PATH = ARGS[5]
index1 = startswith(BIN_PATH, "/") ? 1 : 1
index2 = endswith(BIN_PATH, "/") ? length(BIN_PATH) - 1 : length(BIN_PATH)
const BIN_PATH_NORM = BIN_PATH[index1:index2]

const BENCHMARK_DIR = "../../" * get_benchmark_dir("msolve", BENCHMARK_SET)

@info "" ARGS
@info "" PROBLEM_NAME
@info "" NUM_RUNS
@info "" BENCHMARK_SET
@info "" VALIDATE
@info "" "$(@__DIR__)"
flush(stdout)
flush(stderr)

# const children = []

# function kill_children_procs()
#     for child in children
#         kill(child)
#     end
#     nothing
# end

# atexit(kill_children_procs)

function process_system()
    @info "Processing $PROBLEM_NAME"
    @info """
    Averaging over $NUM_RUNS runs."""

    runtime[PROBLEM_NAME] = Dict{Any, Any}()
    for cat in ALL_CATEGORIES
        runtime[PROBLEM_NAME][cat] = Inf
    end
    for iter in 1:NUM_RUNS
        @info "Computing GB.." iter
        problemfile = (@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$(PROBLEM_NAME).in"
        __io = open(problemfile, "r")
        CHAR = parse(Int, readlines(__io)[2])
        close(__io)
        outputfile =
            VALIDATE ? (@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$(output_filename())" :
            "/dev/null"
        cmd = if CHAR > 0
            Cmd(`$BIN_PATH_NORM -g 2 -l 44 -c 0 -f $problemfile -o $outputfile`, detach=false)
        else
            Cmd(`$BIN_PATH_NORM -g 2 -c 0 -f $problemfile -o $outputfile`, detach=false)
        end
        timing = time_ns()
        proc = run(cmd, wait=true)
        # push!(children, proc)
        timing = (time_ns() - timing) / 1e9
        @assert process_exited(proc)
        if proc.exitcode != 0
            @warn "Something probably went wrong in msolve"
            exit(1)
        end
        @debug "Result is" result
        runtime[PROBLEM_NAME][:total_time] = min(runtime[PROBLEM_NAME][:total_time], timing)
    end
end

function dump_timings()
    timings = ""
    timings *= "$PROBLEM_NAME\n"
    for (key, model_runtime) in runtime
        for c in [:total_time]
            timings *= "$c, "
            timings *= string(model_runtime[c]) * "\n"
        end
    end
    filename = timings_filename()
    open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "w") do io
        write(io, timings)
    end
end

process_system()
dump_timings()

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

###
# High level

function linalg_randomized_sparse!(
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    arithmetic::AbstractArithmetic,
    rng::AbstractRNG
)
    sort_matrix_upper_rows!(matrix) # for the AB part
    sort_matrix_lower_rows!(matrix) # for the CD part

    # Reduce CD with AB
    linalg_randomized_reduce_matrix_lower_part!(matrix, basis, arithmetic, rng)
    # Interreduce CD
    linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic)
    true
end

###
# Low level

# The number of blocks to split the matrix into
function linalg_nblocks_in_randomized(nrows::Int)
    floor(Int, sqrt(nrows / 3)) + 1
end

# Given a matrix of the following form, where A is in REF,
#   A B
#   C D
# reduces the lower part CD with respect to the pivots in the upper part AB.
# As a result, a matrix of the following form is produced:
#   A B
#   0 D'
function linalg_randomized_reduce_matrix_lower_part!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType, CoeffType},
    rng::AbstractRNG
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    _, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_idx_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, matrix.nrows_filled_lower)

    # Set up the blocks
    nblocks = linalg_nblocks_in_randomized(nlow)
    rem = nlow % nblocks == 0 ? 0 : 1
    rowsperblock = div(nlow, nblocks) + rem

    # Allocate the buffers
    row = zeros(AccumType, ncols)
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
    rows_multipliers = zeros(AccumType, rowsperblock)

    # Split the rows in the lower part of the matrix into several blocks. 
    # Handle each block separately. 
    # For each block, produce a random linear combination of the rows in the
    # block and reduce it by pivot rows. Repeat while nonzero rows are emerging.
    for i in 1:nblocks
        nrowsupper = nlow > i * rowsperblock ? i * rowsperblock : nlow
        nrowstotal = nrowsupper - (i - 1) * rowsperblock
        nrowstotal == 0 && continue

        new_pivots_count = 0
        @inbounds while new_pivots_count < nrowstotal
            # Produce a random linear combination of rows in this block
            # TODO: does not work for the rationals
            # TODO: can vectorize random number generation
            # TODO: sample from a smaller range of values
            for j in 1:nrowstotal
                rows_multipliers[j] = mod_p(rand(rng, AccumType), arithmetic)
            end
            row .= AccumType(0)
            first_nnz_col = ncols

            for k in 1:nrowstotal
                rowidx = (i - 1) * rowsperblock + k
                sparse_row_support = matrix.lower_rows[rowidx]
                sparse_row_coeffs = basis.coeffs[row_idx_to_coeffs[rowidx]]
                @invariant length(sparse_row_support) == length(sparse_row_coeffs)

                first_nnz_col = min(first_nnz_col, sparse_row_support[1])
                for l in 1:length(sparse_row_coeffs)
                    colidx = sparse_row_support[l]
                    row[colidx] = mod_p(
                        row[colidx] +
                        AccumType(rows_multipliers[k]) * AccumType(sparse_row_coeffs[l]),
                        arithmetic
                    )
                end
            end

            # Reduce the random linear combination by pivots
            @invariant 1 <= first_nnz_col <= length(row)
            zeroed = linalg_reduce_dense_row_by_pivots_sparse!(
                new_sparse_row_support,
                new_sparse_row_coeffs,
                row,
                matrix,
                basis,
                pivots,
                first_nnz_col,
                ncols,
                arithmetic
            )

            zeroed && break

            new_pivots_count += 1

            linalg_row_make_monic!(new_sparse_row_coeffs, arithmetic)
            @invariant length(new_sparse_row_support) == length(new_sparse_row_coeffs)

            pivots[new_sparse_row_support[1]] = new_sparse_row_support

            absolute_row_index = (i - 1) * rowsperblock + new_pivots_count
            matrix.some_coeffs[absolute_row_index] = new_sparse_row_coeffs
            matrix.lower_to_coeffs[new_sparse_row_support[1]] = absolute_row_index

            new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
        end
    end

    true
end

function linalg_randomized_reduce_matrix_lower_part_all_zero!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType},
    rng::AbstractRNG
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    _, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_idx_to_coeffs = linalg_prepare_matrix_pivots!(matrix)

    # Set up the blocks
    nblocks = 1  # sum all the rows
    rem = nlow % nblocks == 0 ? 0 : 1
    rowsperblock = div(nlow, nblocks) + rem

    # Allocate the buffers
    row = zeros(AccumType, ncols)
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
    rows_multipliers = zeros(AccumType, rowsperblock)

    for i in 1:nblocks
        nrowsupper = nlow > i * rowsperblock ? i * rowsperblock : nlow
        nrowstotal = nrowsupper - (i - 1) * rowsperblock
        nrowstotal == 0 && continue

        for j in 1:nrowstotal
            rows_multipliers[j] = mod_p(rand(rng, AccumType), arithmetic)
        end
        row .= AccumType(0)
        first_nnz_col = ncols

        for k in 1:nrowstotal
            rowidx = (i - 1) * rowsperblock + k
            sparse_row_support = matrix.lower_rows[rowidx]
            sparse_row_coeffs = basis.coeffs[row_idx_to_coeffs[rowidx]]
            @invariant length(sparse_row_support) == length(sparse_row_coeffs)

            first_nnz_col = min(first_nnz_col, sparse_row_support[1])
            for l in 1:length(sparse_row_coeffs)
                colidx = sparse_row_support[l]
                row[colidx] = mod_p(
                    row[colidx] + AccumType(rows_multipliers[k]) * AccumType(sparse_row_coeffs[l]),
                    arithmetic
                )
            end
        end

        # Reduce the random linear combination by pivots
        @invariant 1 <= first_nnz_col <= length(row)
        zeroed = linalg_reduce_dense_row_by_pivots_sparse!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            first_nnz_col,
            ncols,
            arithmetic
        )

        # If fully reduced
        zeroed && continue

        return false
    end

    true
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Backend for `groebner`

# polynomials => polynomials
function groebner0(polynomials::AbstractVector, options::KeywordArguments)
    isempty(polynomials) && throw(DomainError("Empty input."))
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    gb_monoms, gb_coeffs = _groebner1(ring, monoms, coeffs, options)
    result = io_convert_ir_to_polynomials(ring, polynomials, gb_monoms, gb_coeffs, options)
    result
end

# (exponent vectors, coefficients) => (exponent vectors, coefficients)
function groebner1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    _groebner1(ring, monoms, coeffs, options)
end

_info_possible_overflow() = @info(
    """Possible overflow of exponent vector detected.
    Restarting with at least 32 bits per exponent.""",
    maxlog = 1
)

function _groebner1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    try
        params = AlgorithmParameters(ring, options)
        return __groebner1(ring, monoms, coeffs, params)
    catch err
        if isa(err, MonomialDegreeOverflow)
            _info_possible_overflow()
            params = AlgorithmParameters(ring, options; hint=:large_exponents)
            return __groebner1(ring, monoms, coeffs, params)
        else
            # Something bad happened.
            rethrow(err)
        end
    end
end

function __groebner1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {I <: Integer, C <: Coeff}
    @invariant ir_is_valid(ring, monoms, coeffs)
    _, ring2, monoms2, coeffs2 = ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    gb_monoms2, gb_coeffs2 = groebner2(ring2, monoms2, coeffs2, params)
    gb_monoms, gb_coeffs = ir_convert_internal_to_ir(ring2, gb_monoms2, gb_coeffs2, params)
    gb_monoms, gb_coeffs
end

# internal structs => internal structs
function groebner2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    _monoms = filter(!isempty, monoms)
    _coeffs = filter(!isempty, coeffs)
    if isempty(_monoms)
        return [monoms[1]], [coeffs[1]]
    end
    monoms, coeffs = _monoms, _coeffs

    if params.homogenize
        _, ring, monoms, coeffs, params = homogenize_generators(ring, monoms, coeffs, params)
    end

    gb_monoms, gb_coeffs = _groebner2(ring, monoms, coeffs, params)

    if params.homogenize
        ring, gb_monoms, gb_coeffs, params =
            dehomogenize_generators(ring, gb_monoms, gb_coeffs, params)
        if params.reduced
            gb_monoms, gb_coeffs = _groebner2(ring, gb_monoms, gb_coeffs, params)
        end
    end

    gb_monoms, gb_coeffs
end

###
# Groebner basis over Z_p. Calls F4 directly.

function _groebner2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffZp}
    basis, pairset, hashtable = f4_initialize_structs(ring, monoms, coeffs, params)
    f4!(ring, basis, pairset, hashtable, params)
    gbmonoms, gbcoeffs = basis_export_data(basis, hashtable)
    gbmonoms, gbcoeffs
end

###
# Groebner basis over generic field. Calls F4 directly.

function _groebner2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffGeneric}
    basis, pairset, hashtable = f4_initialize_structs(ring, monoms, coeffs, params)
    f4!(ring, basis, pairset, hashtable, params)
    gbmonoms, gbcoeffs = basis_export_data(basis, hashtable)
    gbmonoms, gbcoeffs
end

###
# Groebner basis over Q.

# GB over the rationals uses modular computation.
function _groebner2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffQQ}
    if params.modular_strategy === :learn_and_apply
        _groebner_learn_and_apply(ring, monoms, coeffs, params)
    else
        @assert params.modular_strategy === :classic_modular
        _groebner_classic_modular(ring, monoms, coeffs, params)
    end
end

###
# Learn & Apply startegy

# The next batch is a multiple of the previous ones
function get_next_batch(
    primes_used::Int,
    prev_batch::Int,
    batch_scaling::Float64,
    composite::Int,
    tasks::Int
)
    new_batch = max(composite, round(Int, primes_used * batch_scaling))
    new_batch = align_up(new_batch, composite * tasks)
    max(new_batch, prev_batch)
end

@timeit _TIMER function _groebner_guess_lucky_prime(
    state::ModularState,
    ring::PolyRing,
    basis_zz::Basis,
    pairset::Pairset,
    hashtable::MonomialHashtable{M},
    params::AlgorithmParameters
) where {M <: Monom}
    prime_1 = modular_random_prime(state, params.rng)
    ring_ff_1, basis_ff_1 = modular_reduce_mod_p!(ring, basis_zz, prime_1, deepcopy=true)
    params_zp = param_mod_p(params, prime_1)
    f4!(ring_ff_1, basis_ff_1, pairset, hashtable, params_zp)

    prime_2 = modular_random_prime(state, params.rng)
    ring_ff_2, basis_ff_2 = modular_reduce_mod_p!(ring, basis_zz, prime_2, deepcopy=true)
    params_zp = param_mod_p(params, prime_2)
    f4!(ring_ff_2, basis_ff_2, pairset, hashtable, params_zp)

    if basis_ff_1.monoms == basis_ff_2.monoms
        return prime_1
    end

    prime_3 = modular_random_prime(state, params.rng)
    ring_ff_3, basis_ff_3 = modular_reduce_mod_p!(ring, basis_zz, prime_3, deepcopy=true)
    params_zp = param_mod_p(params, prime_3)
    f4!(ring_ff_3, basis_ff_3, pairset, hashtable, params_zp)

    if basis_ff_1.monoms == basis_ff_3.monoms
        return prime_1
    elseif basis_ff_2.monoms == basis_ff_3.monoms
        return prime_2
    else
        throw("Cannot find a lucky prime. Groebner.jl gives up.")
    end

    prime_1
end

###
# Learn & Apply strategy

# internal function for multi-threading
function _process_chunk(
    chunk::Vector{Int},
    ring::PolyRing,
    basis_zz::Basis,
    composite::Int,
    trace::Trace,
    primes::Vector{Int32},
    params::AlgorithmParameters,
    gb_coeffs::Vector{Tuple{Int32, Vector{Vector{Int32}}}}
)
    for i in 1:length(chunk)
        primes_x = ntuple(k -> primes[(i - 1) * composite + k], composite)
        ring_zp_x, basis_zp_x = modular_reduce_mod_p_in_batch!(ring, basis_zz, primes_x)
        params_zp = param_mod_p(
            params,               # can be mutated later
            CompositeNumber{composite, Int32}(primes_x),
            using_wide_type_for_coeffs=false
        )
        trace.buf_basis = basis_zp_x
        trace.ring = ring_zp_x
        flag = f4_apply!(trace, params_zp)
        !flag && return
        gb_coeffs_unpacked = ir_unpack_composite_coefficients(trace.gb_basis.coeffs)
        append!(gb_coeffs, collect(zip(primes_x, gb_coeffs_unpacked)))
    end
    return
end

function _groebner_learn_and_apply(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffQQ}
    # Guess lucky prime
    basis, pairset, hashtable, permutation =
        f4_initialize_structs(ring, monoms, coeffs, params, make_monic=false)
    basis_zz = clear_denominators!(basis, deepcopy=false)
    state = ModularState{BigInt, C, Int32}(basis_zz.coeffs)
    prime = _groebner_guess_lucky_prime(state, ring, basis_zz, pairset, hashtable, params)

    # Learn
    ring_ff, basis_ff = modular_reduce_mod_p!(ring, basis_zz, prime, deepcopy=true)
    params_zp = param_mod_p(params, prime)
    trace = trace_initialize(ring_ff, basis_ff, hashtable, permutation, params_zp)
    f4_learn!(trace, pairset, params_zp)

    # CRT and rational reconstruction settings
    # TODO: no need to deepcopy!
    push!(state.used_primes, prime)
    push!(state.gb_coeffs_ff_all, deepcopy(trace.gb_basis.coeffs))
    modular_prepare!(state)
    witness_set = modular_witness_set(state.gb_coeffs_zz, params)

    # Continue to compute Groebner bases modulo different primes in batches. 
    composite = params.composite
    tasks = params.tasks
    batch_scaling = params.batch_scaling
    primes_used = 1
    correct_basis = false
    batch = composite * tasks

    # Initialize a tracer that computes the bases using composite numbers
    trace_x = trace_copy(
        trace,
        PolynomialRepresentation(M, CompositeNumber{composite, Int32}, false),
        CompositeNumber{composite, Int32}
    )

    # Task local buffers
    task_results = Vector{Task}(undef, tasks)
    tasklocal_trace_x = map(_ -> deepcopy(trace_x), 1:tasks)
    tasklocal_gb_coeffs = Vector{Vector{Tuple{Int32, Vector{Vector{Int32}}}}}(undef, tasks)
    for i in 1:tasks
        tasklocal_gb_coeffs[i] = Vector{Tuple{Int, Vector{Vector{Int32}}}}()
    end
    tasklocal_params = map(_ -> deepcopy(params), 1:tasks)

    while !correct_basis
        batch = get_next_batch(primes_used, batch, batch_scaling, composite, tasks)
        @invariant iszero(batch % (composite * tasks))

        tasklocal_primes =
            [map(_ -> Int32(modular_next_prime!(state)), 1:div(batch, tasks)) for _ in 1:tasks]
        for i in 1:tasks
            empty!(tasklocal_gb_coeffs[i])
        end

        data_chunks = split_round_robin(1:composite:batch, tasks)
        for (tid, chunk) in enumerate(data_chunks)
            task = @spawn begin
                _process_chunk(
                    chunk,
                    ring,
                    basis_zz,
                    composite,
                    tasklocal_trace_x[tid],
                    tasklocal_primes[tid],
                    tasklocal_params[tid],
                    tasklocal_gb_coeffs[tid]
                )
            end
            task_results[tid] = task
        end
        for task in task_results
            wait(task)
        end

        primes_used += batch

        tasklocal_gb_coeffs_union = reduce(vcat, tasklocal_gb_coeffs)
        sort!(tasklocal_gb_coeffs_union, by=first, rev=true)
        for (prime_, coeffs_ff_) in tasklocal_gb_coeffs_union
            push!(state.used_primes, prime_)
            push!(state.gb_coeffs_ff_all, coeffs_ff_)
        end

        crt_vec_partial!(
            state.gb_coeffs_zz,
            state.modulo,
            state.gb_coeffs_ff_all,
            state.used_primes,
            witness_set,
            state.crt_mask
        )
        success_reconstruct = ratrec_vec_partial!(
            state.gb_coeffs_qq,
            state.gb_coeffs_zz,
            state.modulo,
            witness_set,
            state.ratrec_mask
        )

        if !success_reconstruct
            continue
        end

        if params.heuristic_check
            success_check =
                modular_lift_heuristic_check_partial(state.gb_coeffs_qq, state.modulo, witness_set)
            if !success_check
                continue
            end
        end

        # Perform full reconstruction
        crt_vec_full!(
            state.gb_coeffs_zz,
            state.modulo,
            state.gb_coeffs_ff_all,
            state.used_primes,
            state.crt_mask;
            tasks=params.tasks
        )
        success_reconstruct = ratrec_vec_full!(
            state.gb_coeffs_qq,
            state.gb_coeffs_zz,
            state.modulo,
            state.ratrec_mask,
            tasks=params.tasks
        )

        # This should happen rarely
        if !success_reconstruct
            continue
        end

        correct_basis =
            modular_lift_check!(state, ring_ff, basis, basis_zz, trace.gb_basis, hashtable, params)
    end

    gb_monoms, _ = basis_export_data(trace.gb_basis, hashtable)
    gb_coeffs_qq = state.gb_coeffs_qq

    return gb_monoms, gb_coeffs_qq
end

###
# Classic multi-modular strategy

function _groebner_classic_modular(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffQQ}
    # Initialize supporting structs
    basis, pairset, hashtable =
        f4_initialize_structs(ring, monoms, coeffs, params, make_monic=false)
    basis_zz = clear_denominators!(basis, deepcopy=false)
    state = ModularState{BigInt, C, CoeffModular}(basis_zz.coeffs)
    prime = _groebner_guess_lucky_prime(state, ring, basis_zz, pairset, hashtable, params)

    ring_ff, basis_ff = modular_reduce_mod_p!(ring, basis_zz, prime, deepcopy=true)
    params_zp = param_mod_p(params, prime)
    f4!(ring_ff, basis_ff, pairset, hashtable, params_zp)
    # NOTE: basis_ff may not own its coefficients, one should not mutate it
    # directly further in the code

    # CRT and rational reconstruction settings
    push!(state.used_primes, prime)
    push!(state.gb_coeffs_ff_all, basis_ff.coeffs)
    modular_prepare!(state)
    witness_set = modular_witness_set(state.gb_coeffs_zz, params)

    # At this point, either the reconstruction or the correctness check failed.
    # Continue to compute Groebner bases modulo different primes in batches. 
    composite = 1
    tasks = 1
    batch_scaling = params.batch_scaling
    primes_used = 1
    correct_basis = false
    batch = 1

    while !correct_basis
        batch = get_next_batch(primes_used, batch, batch_scaling, composite, tasks)

        for j in 1:batch
            prime = modular_next_prime!(state)
            ring_ff, basis_ff = modular_reduce_mod_p!(ring, basis_zz, prime, deepcopy=true)
            params_zp = param_mod_p(params, prime)
            f4!(ring_ff, basis_ff, pairset, hashtable, params_zp)
            push!(state.used_primes, prime)
            push!(state.gb_coeffs_ff_all, basis_ff.coeffs)
            primes_used += 1
        end

        crt_vec_partial!(
            state.gb_coeffs_zz,
            state.modulo,
            state.gb_coeffs_ff_all,
            state.used_primes,
            witness_set,
            state.crt_mask
        )
        success_reconstruct = ratrec_vec_partial!(
            state.gb_coeffs_qq,
            state.gb_coeffs_zz,
            state.modulo,
            witness_set,
            state.ratrec_mask
        )

        if !success_reconstruct
            continue
        end

        if params.heuristic_check
            success_check =
                modular_lift_heuristic_check_partial(state.gb_coeffs_qq, state.modulo, witness_set)
            if !success_check
                continue
            end
        end

        # Perform full reconstruction
        crt_vec_full!(
            state.gb_coeffs_zz,
            state.modulo,
            state.gb_coeffs_ff_all,
            state.used_primes,
            state.crt_mask,
            tasks=params.tasks
        )
        success_reconstruct = ratrec_vec_full!(
            state.gb_coeffs_qq,
            state.gb_coeffs_zz,
            state.modulo,
            state.ratrec_mask,
            tasks=params.tasks
        )

        if !success_reconstruct
            continue
        end

        correct_basis =
            modular_lift_check!(state, ring_ff, basis, basis_zz, basis_ff, hashtable, params)
    end

    gb_monoms, _ = basis_export_data(basis_ff, hashtable)
    gb_coeffs_qq = state.gb_coeffs_qq

    return gb_monoms, gb_coeffs_qq
end

using AbstractAlgebra
import Nemo

function randpoly(x, d)
    K = base_ring(parent(x[1]))
    M = collect(monomials((sum(x)+1)^d))
    C = map(_ -> rand(K), M)
    f = parent(x[1])(C, exponent_vector.(M, 1))
    f
end

function randsys(n, d)
    R, x = polynomial_ring(k, ["x$i" for i in 1:n], internal_ordering=:degrevlex)
    [randpoly(x, d) for _ in 1:n]
end

n, d = 3, 5
R, x = polynomial_ring(GF(2^30+3), ["x$i" for i in 1:n], internal_ordering=:degrevlex)
sys = [randpoly(x, d) for _ in 1:n]

n, d = 20, 1
R, x = polynomial_ring(Nemo.GF(2^30+3), ["x$i" for i in 1:n], internal_ordering=:degrevlex)
A = rand(base_ring(parent(x[1])), n, n) 
sys = A*x;

# TimerOutputs.enable_timer!(Groebner._TIMER); reset_timer!(Groebner._TIMER); @time gb = groebner(sys); show(Groebner._TIMER, allocations=false)

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Homogenization & saturation

function extend_ordering_in_homogenization(
    nvars::Int,
    ord::Ord,
    homogenizing_vairable=:last
) where {Ord <: Union{DegRevLex, DegLex, Lex, ProductOrdering}}
    @assert homogenizing_vairable === :last
    lex_part = Lex(nvars + 1)
    new_ord = ProductOrdering(ordering_make_not_simple(ord, nvars), lex_part)
    new_ord
end

function restrict_ordering_in_dehomogenization(ord, homogenizing_vairable=:last)
    ord.ord1
end

function extend_ordering_in_saturation(
    nvars::Int,
    ord::Ord,
    saturating_vairable=:last
) where {Ord <: Union{DegRevLex, DegLex, Lex, ProductOrdering}}
    @assert saturating_vairable === :last
    lex_part = Lex(nvars + 1)
    new_ord = ProductOrdering(lex_part, ordering_make_not_simple(ord, nvars))
    new_ord
end

function restrict_ordering_in_desaturation(ord, saturating_vairable=:last)
    ord.ord2
end

function homogenize_generators(
    ring::PolyRing{Ord},
    monoms::Vector{Vector{Vector{T}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {Ord, T, C <: Coeff}
    @assert length(monoms) == length(coeffs)
    coeffs = deepcopy(coeffs)
    nvars = ring.nvars
    new_nvars = nvars + 1
    new_monoms = Vector{Vector{Vector{T}}}(undef, length(monoms))
    @inbounds for i in 1:length(monoms)
        D = maximum(monom_totaldeg, monoms[i]; init=zero(T))
        new_monoms[i] = Vector{Vector{T}}(undef, length(monoms[i]))
        for j in 1:length(monoms[i])
            # `+ 1` since exponent vectors also store the total degree
            new_monoms[i][j] = Vector{T}(undef, new_nvars + 1)
            d = monom_totaldeg(monoms[i][j])
            @invariant d <= D
            new_monoms[i][j][1] = D
            new_monoms[i][j][end] = D - d
            for k in 2:(nvars + 1)
                new_monoms[i][j][k] = monoms[i][j][k]
            end
        end
    end
    # TODO: clarify the order of variables
    new_ord = extend_ordering_in_homogenization(ring.nvars, ring.ord)
    new_ring = PolyRing(new_nvars, new_ord, ring.characteristic, ring.ground)
    term_permutation = sort_input_terms_to_change_ordering!(new_monoms, coeffs, new_ord)
    sat_var_index = new_nvars
    new_ring_sat, new_monoms, coeffs, params =
        saturate_generators_by_variable(new_ring, new_monoms, coeffs, params, sat_var_index)
    params = struct_update(AlgorithmParameters, params, (target_ord=new_ring_sat.ord,))
    term_permutation, new_ring_sat, new_monoms, coeffs, params
end

function dehomogenize_generators(
    ring,
    monoms::Vector{Vector{Vector{T}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {T, C <: Coeff}
    ring_desat, monoms, coeffs, params = desaturate_generators(ring, monoms, coeffs, params)
    @assert length(monoms) == length(coeffs)
    nvars = ring_desat.nvars
    @assert nvars > 1
    new_nvars = nvars - 1
    new_monoms = Vector{Vector{Vector{T}}}(undef, length(monoms))
    reduced_to_zero = Vector{Int}()
    @inbounds for i in 1:length(monoms)
        new_monoms[i] = Vector{Vector{T}}(undef, length(monoms[i]))
        for j in 1:length(monoms[i])
            new_monoms[i][j] = Vector{T}(undef, new_nvars + 1)
            for k in 2:(new_nvars + 1)
                new_monoms[i][j][k] = monoms[i][j][k]
            end
            new_monoms[i][j][1] = sum(new_monoms[i][j][2:end])
        end
        # if all(monom -> iszero(monom_totaldeg(monom)), new_monoms[i])
        #     push!(reduced_to_zero, i)
        # end
    end
    deleteat!(new_monoms, reduced_to_zero)
    deleteat!(coeffs, reduced_to_zero)
    new_ord = restrict_ordering_in_dehomogenization(ring_desat.ord)
    new_ring = PolyRing(new_nvars, new_ord, ring_desat.characteristic, ring.ground)
    sort_input_terms_to_change_ordering!(new_monoms, coeffs, new_ord)
    params = struct_update(AlgorithmParameters, params, (target_ord=new_ring.ord,))
    new_ring, new_monoms, coeffs, params
end

function desaturate_generators(
    ring,
    monoms::Vector{Vector{Vector{T}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {T, C <: Coeff}
    @assert length(monoms) == length(coeffs)
    coeffs = deepcopy(coeffs)
    nvars = ring.nvars
    @assert nvars > 1
    new_nvars = nvars - 1
    new_monoms = Vector{Vector{Vector{T}}}(undef, length(monoms))
    new_sparse_row_coeffs = similar(coeffs)
    new_size = 0
    # remove the saturating variable
    @inbounds for i in 1:length(monoms)
        to_skip = false
        for j in 1:length(monoms[i])
            if monoms[i][j][end] > zero(T)
                to_skip = true
                break
            end
            to_skip && break
        end
        to_skip && break
        new_size += 1
        new_sparse_row_coeffs[new_size] = coeffs[i]
        new_monoms[new_size] = Vector{Vector{T}}(undef, length(monoms[i]))
        for j in 1:length(monoms[i])
            new_monoms[i][j] = Vector{T}(undef, new_nvars + 1)
            for k in 2:(new_nvars + 1)
                new_monoms[i][j][k] = monoms[i][j][k]
            end
            new_monoms[i][j][1] = sum(new_monoms[i][j][2:end])
        end
    end
    @assert new_size > 0
    resize!(new_sparse_row_coeffs, new_size)
    resize!(new_monoms, new_size)
    new_ord = restrict_ordering_in_desaturation(ring.ord)
    new_ring = PolyRing(new_nvars, new_ord, ring.characteristic, ring.ground)
    params = struct_update(AlgorithmParameters, params, (target_ord=new_ring.ord,))
    new_ring, new_monoms, new_sparse_row_coeffs, params
end

function saturate_generators_by_variable(
    ring,
    monoms::Vector{Vector{Vector{T}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters,
    sat_var_index
) where {T, C <: Coeff}
    @assert length(monoms) == length(coeffs)
    coeffs = deepcopy(coeffs)
    nvars = ring.nvars
    new_nvars = nvars + 1
    new_monoms = Vector{Vector{Vector{T}}}(undef, length(monoms))
    @inbounds for i in 1:length(monoms)
        new_monoms[i] = Vector{Vector{T}}(undef, length(monoms[i]))
        for j in 1:length(monoms[i])
            # `+ 1` since exponent vectors also store the total degree
            new_monoms[i][j] = Vector{T}(undef, new_nvars + 1)
            for k in 1:(nvars + 1)
                new_monoms[i][j][k] = monoms[i][j][k]
            end
            new_monoms[i][j][end] = zero(T)
        end
    end
    # Construct `xi*t - 1`, where `i` is the `sat_var_index`
    new_poly_monoms = Vector{Vector{T}}(undef, 2)
    const_monom = zeros(T, new_nvars + 1)
    lead_monom = zeros(T, new_nvars + 1)
    lead_monom[sat_var_index + 1] = one(T)
    lead_monom[end] = one(T)
    lead_monom[1] = one(T) + one(T)
    new_poly_monoms[1] = lead_monom
    new_poly_monoms[2] = const_monom
    new_poly_coeffs = Vector{C}(undef, 2)
    new_poly_coeffs[1] = one(coeffs[1][1])
    minus_one = if ring.ground == :qq
        -one(coeffs[1][1])
    elseif ring.ground == :zp
        ring.characteristic - one(coeffs[1][1])
    else
        -one(coeffs[1][1])
    end
    new_poly_coeffs[2] = minus_one
    push!(new_monoms, new_poly_monoms)
    push!(coeffs, new_poly_coeffs)
    new_ord = extend_ordering_in_saturation(ring.nvars, ring.ord)
    new_ring = PolyRing(new_nvars, new_ord, ring.characteristic, ring.ground)
    params = struct_update(AlgorithmParameters, params, (target_ord=new_ring.ord,))
    new_ring, new_monoms, coeffs, params
end

using LightXML
using AbstractAlgebra
using Groebner

function parse_polys_with_given_ring(ring, polys_str)
    polys_str = filter(!isempty, polys_str)
    base_field, vars = base_ring(ring), gens(ring)
    str_to_var_idx = Dict{String, Int}(string(v) => i for (i, v) in enumerate(vars))
    polys = Vector{AbstractAlgebra.elem_type(ring)}()
    constant_type = base_field == AbstractAlgebra.QQ ? Rational{BigInt} : Int64
    for poly_str in polys_str
        terms_str_plus = split(poly_str, '+')
        terms_str = empty(terms_str_plus)
        @assert length(terms_str_plus) > 0
        for term_str in terms_str_plus
            term_str_minus = split(term_str, '-')
            if !isempty(strip(term_str_minus[1]))
                push!(terms_str, strip(term_str_minus[1]))
            end
            append!(terms_str, map(s -> "-1*$(strip(s))", term_str_minus[2:end]))
        end
        terms_exploded_str = map(t -> map(strip, split(t, "*")), terms_str)
        cfs, exps =
            parse_polynomial_from_terms(ring, constant_type, terms_exploded_str, str_to_var_idx)
        poly = ring(cfs, exps)
        push!(polys, poly)
    end
    polys
end

function load_system_symbolic_data(filename)
    # parse ex1.xml:
    # xdoc is an instance of XMLDocument, which maintains a tree structure
    xdoc = parse_file(filename)

    # get the root element
    xroot = LightXML.root(xdoc)  # an instance of XMLElement
    # print its name

    vars_str = []
    polys_str = []

    # traverse all its child nodes and print element names
    for c in child_nodes(xroot)  # c is an instance of XMLNode
        if is_elementnode(c)
            e = XMLElement(c)  # this makes an XMLElement instance
            if name(e) == "vars"
                vars_str = map(strip, split(LightXML.content(e), ","))
            elseif name(e) == "basis"
                for poly_node in child_nodes(e)
                    push!(polys_str, strip(LightXML.content(poly_node)))
                end
            end
        end
    end
    @assert !isempty(vars_str)
    @assert !isempty(polys_str)

    ring, xs = polynomial_ring(QQ, vars_str, internal_ordering=:degrevlex)
    polys = parse_polys_with_given_ring(ring, polys_str)

    return ring, polys
end

ring, sys =
    load_system_symbolic_data("/home/demin/SymbolicData/XMLResources/IntPS/SignalTheory.f966.xml")

@time groebner(sys);

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

# y, s.t. y >= x and n | y.
function align_up(x::Integer, n::Integer)
    @invariant n > 0
    cld(x, n) * n
end

# y, s.t y <= x and n | y.
function align_down(x::Integer, n::Integer)
    @invariant n > 0
    fld(x, n) * n
end

### 
# Sorting monomials, polynomials, and other things.

_default_sorting_alg() = Base.Sort.DEFAULT_UNSTABLE

# Sorts arr at the range of indices from..to. 
# This function is perhaps type unstable
function sort_part!(
    arr::AbstractVector{T},
    from::Int,
    to::Int;
    lt=isless,
    alg=_default_sorting_alg(),
    by=identity,
    scratch::Union{Vector{T}, Nothing}=nothing
) where {T}
    from > to && return nothing
    ordr = Base.Sort.ord(lt, by, nothing)
    sort!(arr, from, to, alg, ordr, scratch)
    nothing
end

# Permute a part of the array from the given index according to the permutation.
function permute_array!(
    arr::AbstractVector{T},
    perm::Vector{I},
    buf::Vector{T},
    from::Int,
    sz::Int
) where {T, I}
    @invariant length(buf) >= sz && sz <= length(perm)
    @invariant from + sz - 1 <= length(arr)
    @inbounds for i in 1:sz
        buf[i] = arr[perm[i]]
    end
    @inbounds for i in 1:sz
        arr[from + i - 1] = buf[i]
    end
    nothing
end

function sort_polys_by_lead_increasing!(
    basis::Basis,
    hashtable::MonomialHashtable,
    changematrix::Bool;
    ord::Ord=hashtable.ord
) where {Ord <: AbstractMonomialOrdering}
    b_monoms = basis.monoms
    h_monoms = hashtable.monoms
    permutation = collect(1:(basis.n_filled))
    cmps =
        (x, y) -> monom_isless(
            @inbounds(h_monoms[b_monoms[x][1]]),
            @inbounds(h_monoms[b_monoms[y][1]]),
            ord
        )

    # stable sort to preserve the order of polynomials with the same lead
    sort!(permutation, lt=cmps, alg=Base.Sort.DEFAULT_STABLE)

    # use array assignment insted of elemewise assignment
    # (seems to compile to better code)
    basis.monoms[1:(basis.n_filled)] = basis.monoms[permutation]
    basis.coeffs[1:(basis.n_filled)] = basis.coeffs[permutation]

    if changematrix
        @invariant length(basis.changematrix) >= basis.n_filled
        @inbounds basis.changematrix[1:(basis.n_filled)] = basis.changematrix[permutation]
    end

    permutation
end

function is_sorted_by_lead_increasing(
    basis::Basis,
    hashtable::MonomialHashtable,
    ord::Ord=hashtable.ord
) where {Ord <: AbstractMonomialOrdering}
    b_monoms = basis.monoms
    h_monoms = hashtable.monoms
    permutation = collect(1:(basis.n_filled))
    cmps =
        (x, y) -> monom_isless(
            @inbounds(h_monoms[b_monoms[x][1]]),
            @inbounds(h_monoms[b_monoms[y][1]]),
            ord
        )
    issorted(permutation, lt=cmps)
end

function sort_pairset_by_degree!(pairset::Pairset, from::Int, sz::Int)
    pairs = pairset.pairs
    degs = pairset.degrees
    if length(pairset.scratch4) < sz
        resize!(pairset.scratch4, nextpow(2, sz + 1))
    end
    permutation = pairset.scratch4
    for i in 1:sz
        permutation[i] = from + i - 1
    end
    sort_part!(permutation, 1, sz, by=i -> degs[i], scratch=pairset.scratch1)
    if length(pairset.scratch2) < length(permutation)
        resize!(pairset.scratch2, nextpow(2, length(permutation) + 1))
    end
    if length(pairset.scratch3) < length(permutation)
        resize!(pairset.scratch3, nextpow(2, length(permutation) + 1))
    end
    permute_array!(pairs, permutation, pairset.scratch2, from, sz)
    permute_array!(degs, permutation, pairset.scratch3, from, sz)
    nothing
end

function sort_pairset_by_lcm!(pairset::Pairset, npairs::Int, hashtable::MonomialHashtable)
    monoms = hashtable.monoms
    pairs = pairset.pairs
    cmps =
        (i, j) -> monom_isless(
            @inbounds(monoms[pairs[i].lcm]),
            @inbounds(monoms[pairs[j].lcm]),
            hashtable.ord
        )
    permutation = collect(1:npairs)
    sort_part!(permutation, 1, npairs, lt=cmps, scratch=pairset.scratch1)
    if length(pairset.scratch2) < length(permutation)
        resize!(pairset.scratch2, nextpow(2, length(permutation) + 1))
    end
    if length(pairset.scratch3) < length(permutation)
        resize!(pairset.scratch3, nextpow(2, length(permutation) + 1))
    end
    permute_array!(pairs, permutation, pairset.scratch2, 1, npairs)
    permute_array!(pairset.degrees, permutation, pairset.scratch3, 1, npairs)
    nothing
end

function sort_generators_by_position!(polys::Vector{Int}, load::Int)
    sort_part!(polys, 1, load)
end

###
# Sorting matrix rows and columns.

function matrix_row_decreasing_cmp(a::Vector{T}, b::Vector{T}) where {T <: ColumnLabel}
    # Compare the indices of the leading columns
    @inbounds va = a[1]
    @inbounds vb = b[1]
    if va > vb
        return false
    end
    va < vb
end

function matrix_row_increasing_cmp(a::Vector{T}, b::Vector{T}) where {T <: ColumnLabel}
    # Compare the indices of the leading columns
    @inbounds va = a[1]
    @inbounds vb = b[1]
    if va > vb
        return true
    end
    if va < vb
        return false
    end
    # Compare the density of rows
    va = length(a)
    vb = length(b)
    if va > vb
        return false
    end
    if va < vb
        return true
    end
    return false
end

function sort_matrix_upper_rows!(matrix::MacaulayMatrix)
    #= smaller means pivot being more to the left  =#
    #= and density being smaller                   =#
    permutation = collect(1:(matrix.nrows_filled_upper))
    # TODO: use "let" here!
    cmp =
        (x, y) -> matrix_row_decreasing_cmp(
            @inbounds(matrix.upper_rows[x]),
            @inbounds(matrix.upper_rows[y])
        )
    sort!(permutation, lt=cmp, alg=_default_sorting_alg())
    matrix.upper_rows[1:(matrix.nrows_filled_upper)] = matrix.upper_rows[permutation]
    matrix.upper_to_coeffs[1:(matrix.nrows_filled_upper)] = matrix.upper_to_coeffs[permutation]
    # TODO: this is a bit hacky
    if !isempty(matrix.upper_to_mult)
        matrix.upper_to_mult[1:(matrix.nrows_filled_upper)] = matrix.upper_to_mult[permutation]
    end
    matrix
end

function sort_matrix_lower_rows!(matrix::MacaulayMatrix)
    #= smaller means pivot being more to the right =#
    #= and density being larger                    =#
    permutation = collect(1:(matrix.nrows_filled_lower))
    cmp =
        (x, y) -> matrix_row_increasing_cmp(
            @inbounds(matrix.lower_rows[x]),
            @inbounds(matrix.lower_rows[y])
        )
    sort!(permutation, lt=cmp, alg=_default_sorting_alg())
    matrix.lower_rows[1:(matrix.nrows_filled_lower)] = matrix.lower_rows[permutation]
    matrix.lower_to_coeffs[1:(matrix.nrows_filled_lower)] = matrix.lower_to_coeffs[permutation]
    # TODO: this is a bit hacky
    if !isempty(matrix.lower_to_mult)
        matrix.lower_to_mult[1:(matrix.nrows_filled_lower)] = matrix.lower_to_mult[permutation]
    end
    matrix
end

function sort_partition_columns_by_labels!(
    column_to_monom::Vector{T},
    symbol_ht::MonomialHashtable
) where {T}
    labels = symbol_ht.labels
    m = length(column_to_monom)
    i, j = 0, m + 1
    @inbounds while true
        i += 1
        j -= 1
        while i < m && labels[i + 1] == PIVOT_COLUMN
            i += 1
        end
        while j > 1 && (labels[j + 1] == NON_PIVOT_COLUMN || labels[j + 1] == UNKNOWN_PIVOT_COLUMN)
            j -= 1
        end
        i >= j && break
        column_to_monom[i], column_to_monom[j] = column_to_monom[j], column_to_monom[i]
    end
    nothing
end

function sort_input_terms_to_change_ordering!(
    exps::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    ord::AbstractMonomialOrdering
) where {M <: Monom, C <: Coeff}
    permutations = Vector{Vector{Int}}(undef, length(exps))
    @inbounds for polyidx in 1:length(exps)
        comparator =
            (x, y) -> monom_isless(@inbounds(exps[polyidx][y]), @inbounds(exps[polyidx][x]), ord)

        permutation = collect(1:length(exps[polyidx]))
        sort!(permutation, lt=comparator, alg=_default_sorting_alg())

        exps[polyidx][1:end] = exps[polyidx][permutation]
        coeffs[polyidx][1:end] = coeffs[polyidx][permutation]

        permutations[polyidx] = permutation
    end
    permutations
end

import Pkg
Pkg.activate(@__DIR__)
Pkg.develop(path=(@__DIR__) * "/../../../")
Pkg.instantiate()
Pkg.status()

id = ARGS[1]

include("../common.jl")
include("../run_benchmarks.jl")

dump_results((@__DIR__) * "/results_$id", "nightly")

# This file is a part of Groebner.jl. License is GNU GPL v2.

# CompositeNumber is a tuple of several numbers

struct CompositeNumber{N, T}
    data::NTuple{N, T}
end

function CompositeNumber{N, T}(a::CompositeNumber{N, U}) where {N, T, U}
    CompositeNumber{N, T}(a.data .% T)
end

Base.convert(::Type{CompositeNumber{N, T}}, a::CompositeNumber{N, U}) where {N, T, U} =
    CompositeNumber{N, T}(map(x -> convert(T, x), a.data))

Base.isinteger(ci::CompositeNumber{N, T}) where {N, T} = all(isinteger.(ci.data))

Base.typemax(::Type{CompositeNumber{N, T}}) where {N, T} =
    CompositeNumber(ntuple(_ -> typemax(T), N))
Base.typemin(::Type{CompositeNumber{N, T}}) where {N, T} =
    CompositeNumber(ntuple(_ -> typemin(T), N))

Base.rem(a::CompositeNumber{N, T}, ::Type{CompositeNumber{N, U}}) where {N, T, U} =
    CompositeNumber(a.data .% U)

Base.widen(::Type{CompositeNumber{N, T}}) where {N, T} = CompositeNumber{N, widen(T)}

Base.isless(ci::CompositeNumber{N, T}, cj::CompositeNumber{N, U}) where {N, T, U} =
    all(ci.data .< cj.data)
Base.isless(ci::CompositeNumber{N, T}, x::U) where {N, T, U <: Number} = all(<(x), ci.data)
Base.isless(x::U, ci::CompositeNumber{N, T}) where {N, T, U <: Number} = all(x .< ci.data)

Base.iszero(ci::CompositeNumber) = all(iszero, ci.data)
Base.isone(ci::CompositeNumber)  = all(isone, ci.data)

Base.zero(x::CompositeNumber{N, T}) where {N, T} = zero(typeof(x))
Base.one(x::CompositeNumber{N, T}) where {N, T} = one(typeof(x))

Base.zero(::Type{CompositeNumber{N, T}}) where {N, T} =
    CompositeNumber(ntuple(_ -> zero(T), Val(N)))
Base.one(::Type{CompositeNumber{N, T}}) where {N, T} = CompositeNumber(ntuple(_ -> one(T), N))

Base.inv(a::CompositeNumber{N, T}) where {N, T} = CompositeNumber(inv.(a.data))

Base.:+(a::CompositeNumber{N, T}, b::CompositeNumber{N, T}) where {N, T} =
    CompositeNumber(a.data .+ b.data)

Base.:-(a::CompositeNumber{N, T}, b::CompositeNumber{N, T}) where {N, T} =
    CompositeNumber(a.data .- b.data)

Base.:*(a::CompositeNumber{N, T}, b::CompositeNumber{N, T}) where {N, T} =
    CompositeNumber(a.data .* b.data)

using Test, Groebner

@testset "crt" begin
    cases = []

    push!(
        cases,
        Dict(
            :moduli => Vector{UInt64}([1099511627791, 3518437208889]),
            :ai => Vector{UInt64}([8590035092, 8589936485])
        ),
        Dict(
            :moduli => Vector{UInt64}([1099511627791, 17, 3518437208889]),
            :ai => Vector{UInt64}([8590035092, 3, 8589936485])
        ),
        Dict(
            :moduli => Vector{UInt64}([1099511627791, 2^30 + 3, 3518437208889]),
            :ai => Vector{UInt64}([8590035092, 42, 0])
        ),
        Dict(
            :moduli => Vector{UInt64}([1099511627791, 2^30 + 3, 3518437208889]),
            :ai => Vector{UInt64}([0, 0, 0])
        )
    )

    for c in cases
        ai = c[:ai]
        moduli = c[:moduli]
        M = prod(Vector{BigInt}(moduli))
        ci = Vector{BigInt}([0 for _ in moduli])
        n1, n2 = BigInt(0), BigInt(0)
        Groebner.crt_precompute!(M, n1, n2, ci, moduli)
        for i in 1:length(ci)
            pii = div(M, moduli[i])
            @test ci[i] % pii == 0
            @test (ci[i] - 1) % moduli[i] == 0
        end
        buf = BigInt(0)
        Groebner.crt!(M, buf, n1, n2, ai, ci)
        @test 0 <= buf < M
        for i in 1:length(ci)
            @test (buf - ai[i]) % moduli[i] == 0
        end
    end
end

@testset "crt table" begin
    table_zz = [BigInt[], [BigInt(), BigInt()]]
    moduli = UInt64.([2, 3])
    res = [BigInt[], [BigInt(5), BigInt(0)]]
    modulo = BigInt()
    tables_ff = [
        [
            Int32[mod(res[i][j], moduli[k]) for j in 1:length(table_zz[i])] for
            i in 1:length(table_zz)
        ] for k in 1:length(moduli)
    ]
    mask = [falses(length(table_zz[i])) for i in 1:length(table_zz)]
    Groebner.crt_vec_full!(table_zz, modulo, tables_ff, moduli, mask)
    @test table_zz == res

    table_zz = [[BigInt(), BigInt(), BigInt()], [BigInt()], [BigInt(), BigInt()]]
    moduli = UInt64.([31, 39, 41])
    res = [[BigInt(prod(moduli) - 1), BigInt(21), BigInt(39)], [BigInt(1)], [BigInt(0), BigInt(7)]]
    modulo = BigInt()
    tables_ff = [
        [[mod(res[i][j], moduli[k]) for j in 1:length(table_zz[i])] for i in 1:length(table_zz)] for k in 1:length(moduli)
    ]
    mask = [falses(length(table_zz[i])) for i in 1:length(table_zz)]
    for tasks in [1, 2, 3, 4]
        Groebner.crt_vec_full!(table_zz, modulo, tables_ff, moduli, mask; tasks=tasks)
        @test table_zz == res
        @test modulo == prod(BigInt, moduli)
    end
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

struct CoeffGeneric{T}
    data::T
end

generic_coeff_data(x) = x
generic_coeff_data(x::CoeffGeneric) = x.data

CoeffGeneric(x::CoeffGeneric{T}) where {T} = x
CoeffGeneric{T}(x::CoeffGeneric{T}) where {T} = x

Base.:+(x::CoeffGeneric, y::CoeffGeneric) = CoeffGeneric(x.data + y.data)
Base.:-(x::CoeffGeneric, y::CoeffGeneric) = CoeffGeneric(x.data - y.data)
Base.:*(x::CoeffGeneric, y::CoeffGeneric) = CoeffGeneric(x.data * y.data)
Base.inv(x::CoeffGeneric) = CoeffGeneric(inv(x.data))
Base.:-(x::CoeffGeneric) = zero(x) - x

Base.one(x::CoeffGeneric{T}) where {T} = CoeffGeneric{T}(one(x.data))
Base.zero(x::CoeffGeneric{T}) where {T} = CoeffGeneric{T}(zero(x.data))

Base.isone(x::CoeffGeneric) = isone(x.data)
Base.iszero(x::CoeffGeneric) = iszero(x.data)

# This file is a part of Groebner.jl. License is GNU GPL v2.

### 
# Backend for `groebner_with_change_matrix`

function groebner_with_change_matrix0(polynomials, options)
    isempty(polynomials) && throw(DomainError("Empty input."))
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    gb_monoms, gb_coeffs, matrix_monoms, matrix_coeffs =
        _groebner_with_change_matrix1(ring, monoms, coeffs, options)
    result = io_convert_ir_to_polynomials(ring, polynomials, gb_monoms, gb_coeffs, options)
    rows = [
        io_convert_ir_to_polynomials(ring, polynomials, m, c, options) for
        (m, c) in zip(matrix_monoms, matrix_coeffs)
    ]
    matrix = collect(transpose(reduce(hcat, rows)))
    result, matrix
end

function groebner_with_change_matrix1(ring, monoms, coeffs, options)
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    _groebner_with_change_matrix1(ring, monoms, coeffs, options)
end

function _groebner_with_change_matrix1(ring::PolyRing, monoms, coeffs, options)
    try
        params = AlgorithmParameters(ring, options)
        return __groebner_with_change_matrix1(ring, monoms, coeffs, params)
    catch err
        if isa(err, MonomialDegreeOverflow)
            _info_possible_overflow()
            params = AlgorithmParameters(ring, options; hint=:large_exponents)
            return __groebner_with_change_matrix1(ring, monoms, coeffs, params)
        else
            # Something bad happened.
            rethrow(err)
        end
    end
end

function __groebner_with_change_matrix1(ring, monoms, coeffs, params)
    @invariant ir_is_valid(ring, monoms, coeffs)
    _, ring2, monoms2, coeffs2 = ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    gb_monoms2, gb_coeffs2, matrix_monoms2, matrix_coeffs2 =
        groebner_with_change_matrix2(ring2, monoms2, coeffs2, params)
    gb_monoms, gb_coeffs = ir_convert_internal_to_ir(ring2, gb_monoms2, gb_coeffs2, params)
    matrix_monoms_and_coeffs = [
        ir_convert_internal_to_ir(ring2, _matrix_monoms2, _matrix_coeffs2, params) for
        (_matrix_monoms2, _matrix_coeffs2) in zip(matrix_monoms2, matrix_coeffs2)
    ]
    matrix_monoms, matrix_coeffs =
        map(first, matrix_monoms_and_coeffs), map(last, matrix_monoms_and_coeffs)
    gb_monoms, gb_coeffs, matrix_monoms, matrix_coeffs
end

function groebner_with_change_matrix2(ring, monoms, coeffs, params)
    nonzero_indices = findall(!isempty, coeffs)
    zero_indices = setdiff(collect(1:length(monoms)), nonzero_indices)

    __monoms = monoms
    __coeffs = coeffs
    _monoms = filter(!isempty, monoms)
    _coeffs = filter(!isempty, coeffs)
    if isempty(_monoms)
        return [monoms[1]],
        [coeffs[1]],
        [[monoms[1] for _ in 1:length(monoms)]],
        [[coeffs[1] for _ in 1:length(coeffs)]]
    end
    monoms, coeffs = _monoms, _coeffs

    if params.homogenize
        _, ring, monoms, coeffs = homogenize_generators!(ring, monoms, coeffs, params)
    end

    gb_monoms, gb_coeffs, matrix_monoms, matrix_coeffs =
        _groebner_with_change_matrix2(ring, monoms, coeffs, params)

    if params.homogenize
        ring, gb_monoms, gb_coeffs = dehomogenize_generators!(ring, gb_monoms, gb_coeffs, params)
        if params.reduced
            gb_monoms, gb_coeffs = groebner2(ring, gb_monoms, gb_coeffs, params)
        end
    end

    if !isempty(zero_indices)
        for i in 1:length(matrix_monoms)
            _matrix_monoms_i = resize!(similar(matrix_monoms[i]), length(__monoms))
            _matrix_coeffs_i = resize!(similar(matrix_coeffs[i]), length(__monoms))
            zero_indices = setdiff(collect(1:length(__monoms)), nonzero_indices)
            _matrix_monoms_i .= [__monoms[zero_indices[1]]]
            _matrix_coeffs_i .= [__coeffs[zero_indices[1]]]
            for j in 1:length(nonzero_indices)
                _matrix_monoms_i[nonzero_indices[j]] = matrix_monoms[i][j]
                _matrix_coeffs_i[nonzero_indices[j]] = matrix_coeffs[i][j]
            end
            matrix_monoms[i] = _matrix_monoms_i
            matrix_coeffs[i] = _matrix_coeffs_i
        end
    end

    gb_monoms, gb_coeffs, matrix_monoms, matrix_coeffs
end

###
# Groebner basis over Z_p. Calls F4 directly.

function _groebner_with_change_matrix2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffZp}
    basis, pairset, hashtable = f4_initialize_structs(ring, monoms, coeffs, params)
    f4!(ring, basis, pairset, hashtable, params)
    gbmonoms, gbcoeffs = basis_export_data(basis, hashtable)
    matrix_monoms, matrix_coeffs = basis_changematrix_export(basis, hashtable, length(monoms))
    gbmonoms, gbcoeffs, matrix_monoms, matrix_coeffs
end

###
# Groebner basis over Q.

# GB over the rationals uses modular computation.
function _groebner_with_change_matrix2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffQQ}
    _groebner_with_change_classic_modular(ring, monoms, coeffs, params)
end

###
# Classic multi-modular strategy

function _groebner_with_change_classic_modular(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: CoeffQQ}
    input_denominators = map(cfs -> common_denominator!(BigInt(), cfs), coeffs)

    # Initialize supporting structs
    basis, pairset, hashtable, input_permutation =
        f4_initialize_structs(ring, monoms, coeffs, params, make_monic=false)
    basis_zz = clear_denominators!(basis, deepcopy=false)
    state = ModularState{BigInt, C, CoeffModular}(basis_zz.coeffs)
    prime = _groebner_guess_lucky_prime(state, ring, basis_zz, pairset, hashtable, params)

    # Perform reduction modulo prime and store result in basis_ff
    ring_ff, basis_ff = modular_reduce_mod_p!(ring, basis_zz, prime, deepcopy=true)
    params_zp = param_mod_p(params, prime)
    f4!(ring_ff, basis_ff, pairset, hashtable, params_zp)
    # NOTE: basis_ff may not own its coefficients, one should not mutate it
    # directly further in the code

    push!(state.used_primes, prime)
    push!(state.gb_coeffs_ff_all, basis_ff.coeffs)

    changematrix_monoms, changematrix_coeffs =
        basis_changematrix_export(basis_ff, hashtable, length(monoms))
    push!(state.changematrix_coeffs_ff_all, changematrix_coeffs)

    modular_prepare!(state)
    witness_set = modular_witness_set(state.gb_coeffs_zz, params)

    # At this point, either the reconstruction or the correctness check failed.
    # Continue to compute Groebner bases modulo different primes in batches. 
    batch_scaling = params.batch_scaling
    composite = 1
    tasks = 1
    primes_used = 1
    batch = 1
    correct_basis = false

    while !correct_basis
        batch = get_next_batch(primes_used, batch, batch_scaling, composite, tasks)

        for j in 1:batch
            prime = modular_next_prime!(state)
            ring_ff, basis_ff = modular_reduce_mod_p!(ring, basis_zz, prime, deepcopy=true)
            params_zp = param_mod_p(params, prime)
            f4!(ring_ff, basis_ff, pairset, hashtable, params_zp)
            push!(state.used_primes, prime)
            push!(state.gb_coeffs_ff_all, basis_ff.coeffs)
            _, changematrix_coeffs = basis_changematrix_export(basis_ff, hashtable, length(monoms))
            push!(state.changematrix_coeffs_ff_all, changematrix_coeffs)
            primes_used += 1
        end

        crt_vec_partial!(
            state.gb_coeffs_zz,
            state.modulo,
            state.gb_coeffs_ff_all,
            state.used_primes,
            witness_set,
            state.crt_mask
        )

        success_reconstruct = ratrec_vec_partial!(
            state.gb_coeffs_qq,
            state.gb_coeffs_zz,
            state.modulo,
            witness_set,
            state.ratrec_mask
        )

        if !success_reconstruct
            continue
        end

        if params.heuristic_check
            success_check =
                modular_lift_heuristic_check_partial(state.gb_coeffs_qq, state.modulo, witness_set)
            if !success_check
                continue
            end
        end

        # Perform full reconstruction
        crt_vec_full!(
            state.gb_coeffs_zz,
            state.modulo,
            state.gb_coeffs_ff_all,
            state.used_primes,
            state.crt_mask
        )

        success_reconstruct = ratrec_vec_full!(
            state.gb_coeffs_qq,
            state.gb_coeffs_zz,
            state.modulo,
            state.ratrec_mask
        )

        if !success_reconstruct
            continue
        end

        modular_crt_full_changematrix!(state)
        success_reconstruct_changematrix = modular_ratrec_full_changematrix!(state)
        if !success_reconstruct_changematrix
            continue
        end

        if !modular_lift_changematrix_check!(
            state,
            ring,
            basis_zz,
            basis_ff,
            input_permutation,
            changematrix_monoms,
            hashtable,
            params
        )
            continue
        end
        correct_basis =
            modular_lift_check!(state, ring_ff, basis, basis_zz, basis_ff, hashtable, params)
    end

    # Construct the output basis.
    gb_monoms, _ = basis_export_data(basis_ff, hashtable)
    gb_coeffs_qq = state.gb_coeffs_qq
    changematrix_coeffs_qq = state.changematrix_coeffs_qq

    # The modular computation clears the denominators of input polynomials.
    # Rescale the columns so that the change matrix refers to the original input.
    for row in changematrix_coeffs_qq
        for (column, denominator) in zip(row, input_denominators)
            for i in eachindex(column)
                column[i] *= denominator
            end
        end
    end

    gb_monoms, gb_coeffs_qq, changematrix_monoms, changematrix_coeffs_qq
end

using SmallCollections: FixedVector, SmallVector, fixedvector, sum_fast, bits

struct FixedMonomNoDeg{N, T}
    ev::FixedVector{N, T}
end

monom_max_vars(a::FixedMonomNoDeg) = monom_max_vars(typeof(a))

monom_max_vars(::Type{<:FixedMonomNoDeg{N}}) where {N} = N
function monom_totaldeg(a::FixedMonomNoDeg)
    @invariant sum(Int, a.ev) <= typemax(UInt16)
    sum_fast(a.ev; init=zero(UInt16)) % UInt16
end
monom_copy(a::FixedMonomNoDeg) = a

function monom_construct_hash_vector(
    rng::AbstractRNG,
    ::Type{<:FixedMonomNoDeg{N}},
    ::Integer
) where {N}
    rand(rng, FixedVector{N, MonomHash})
end

function monom_construct_from_vector(::Type{FixedMonomNoDeg{N, T}}, ev::AbstractVector) where {N, T}
    all(<=(typemax(T)), ev) || __throw_monom_overflow_error()
    FixedMonomNoDeg(fixedvector(SmallVector{N, T}(ev)))
end

function monom_construct_const(::Type{FixedMonomNoDeg{N, T}}, ::Integer) where {N, T}
    FixedMonomNoDeg(zero(FixedVector{N, T}))
end

function monom_hash(a::FixedMonomNoDeg{N}, b::FixedVector{N}) where {N}
    dot_fast(a.ev, b) % MonomHash
end

function monom_to_vector!(tmp::AbstractVector, a::FixedMonomNoDeg)
    copyto!(tmp, 1, a.ev, 1, length(tmp))
end

function monom_is_supported_ordering(::Type{<:FixedMonomNoDeg}, ::Ord) where {Ord}
    Ord <: Union{DegLex{true}, DegRevLex{true}, InputOrdering}
end

function monom_isless(a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}, ::DegLex{true}) where {N}
    adeg = monom_totaldeg(a)
    bdeg = monom_totaldeg(b)
    adeg < bdeg || (adeg == bdeg && a.ev < b.ev)
end

function monom_isless(a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}, ::DegRevLex{true}) where {N}
    adeg = monom_totaldeg(a)
    bdeg = monom_totaldeg(b)
    if sizeof(a) <= 64
        adeg < bdeg || (adeg == bdeg && bits(a.ev) > bits(b.ev))
    else
        adeg != bdeg && return adeg < bdeg
        aev = reinterpret(UInt64, a.ev)
        bev = reinterpret(UInt64, b.ev)
        @inbounds for i in length(aev):-1:1
            aev[i] != bev[i] && return aev[i] > bev[i]
        end
        false
    end
end

function monom_lcm!(_, a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}) where {N}
    FixedMonomNoDeg(max.(a.ev, b.ev))
end

function monom_lcm!(_, a::FixedMonomNoDeg{8, UInt8}, b::FixedMonomNoDeg{8, UInt8})
    # conversion to UInt16 to force vectorization
    ev = max.(a.ev .% UInt16, b.ev .% UInt16)
    FixedMonomNoDeg(ev .% UInt8)
end

function monom_is_gcd_const(a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}) where {N}
    iszero(min.(a.ev, b.ev))
end

function monom_product!(_, a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}) where {N}
    ev, s = Base.Checked.add_with_overflow(a.ev, b.ev)
    isempty(s) || __throw_monom_overflow_error()
    FixedMonomNoDeg(ev)
end

function monom_division!(_, a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}) where {N}
    FixedMonomNoDeg(a.ev - b.ev)
end

function monom_is_divisible(a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}) where {N}
    all(a.ev .>= b.ev)
end

function monom_is_divisible!(_, a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}) where {N}
    ev, s = Base.Checked.sub_with_overflow(a.ev, b.ev)
    isempty(s), FixedMonomNoDeg(ev)
end

function monom_is_equal(a::FixedMonomNoDeg{N}, b::FixedMonomNoDeg{N}) where {N}
    a.ev == b.ev
end

function monom_create_divmask(
    a::FixedMonomNoDeg,
    ::Type{Mask},
    ndivvars::Int,
    divmap::Vector{U},
    ndivbits::Int,
    strategy::Symbol
) where {Mask, U}
    @invariant strategy == :first_variables
    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)
    @inbounds for i in 1:ndivvars
        for _ in 1:ndivbits
            if a.ev[i] >= divmap[ctr]
                res |= o << ((ctr - 1) % UInt)
            end
            ctr += o
        end
    end
    res
end

using Nemo, Groebner, BenchmarkTools, PrettyTables, Printf

k = Nemo.GF(2^30+3)
systems = [
    ("chandra-9", Groebner.Examples.chandran(9, k=k)),
    ("chandra-10", Groebner.Examples.chandran(10, k=k)),
    ("chandra-11", Groebner.Examples.chandran(11, k=k)),
    ("chandra-12", Groebner.Examples.chandran(12, k=k)),
    ("cyclic-7", Groebner.Examples.cyclicn(7, k=k)),
    ("cyclic-8", Groebner.Examples.cyclicn(8, k=k)),
    ("cyclic-9", Groebner.Examples.cyclicn(9, k=k)),
    ("eco-11", Groebner.Examples.econ(11, k=k)),
    ("eco-12", Groebner.Examples.econ(12, k=k)),
    ("eco-13", Groebner.Examples.econ(13, k=k)),
    ("noon-7", Groebner.Examples.noonn(7, k=k)),
    ("noon-8", Groebner.Examples.noonn(8, k=k)),
    ("noon-9", Groebner.Examples.noonn(9, k=k)),
    ("katsura-9", Groebner.Examples.katsuran(9, k=k)),
    ("katsura-10", Groebner.Examples.katsuran(10, k=k)),
    ("katsura-11", Groebner.Examples.katsuran(11, k=k)),
    ("katsura-12", Groebner.Examples.katsuran(12, k=k)),
    ("hexapod", Groebner.Examples.hexapod(k=k)),
    ("alea6", Groebner.Examples.alea6(k=k)),
    ("hiv2", Groebner.Examples.HIV2(k=k)),
    ("goodwin", Groebner.Examples.Goodwin_with_weights(k=k)),
    ("crn", Groebner.Examples.ChemicalReactionNetwork(k=k)),
    ("jason210", Groebner.Examples.jason210(k=k)),
    ("gametwo2", Groebner.Examples.gametwo2(k=k)),
    ("yang1", Groebner.Examples.yang1(k=k)),
    ("bayes148", Groebner.Examples.bayes148(k=k)),
    ("mayr42", Groebner.Examples.mayr42(k=k)),
]

try
    include("siwr.jl")
    sys = siwr()
    push!(systems, ("siwr", map(f -> map_coefficients(c -> k(numerator(c)) // k(denominator(c)), f), sys)))
catch e @warn "Could not include siwr.jl system: $e"; end

println("Running the following systems: ", map(first, systems))

data = []
for (name, sys) in systems
    @info "Running $name.."
    t1, t2, t3, t4 = 0, 0, 0, 0
    for _ in 1:2
        t1 = @elapsed groebner(sys; threaded=:no)
        t2 = @elapsed trace, _ = groebner_learn(sys)
        t3 = @elapsed groebner_apply!(trace, sys)
        t3 = @elapsed groebner_apply!(trace, sys)
        t4 = @elapsed groebner_apply!(trace, (sys, sys, sys, sys))
        t4 = @elapsed groebner_apply!(trace, (sys, sys, sys, sys))
    end
    push!(data, [name, t1, t2, t3, t4, t1 / t3, 4t1 / t4])
end

matrix = permutedims(reduce(hcat, data))
pretty_table(
    matrix, 
    column_labels=[
        [EmptyCells(2), MultiColumn(3, "Learn & Apply"), MultiColumn(2, "Speedup")], 
        ["Name", "Monte-Carlo", "Learn", "Apply", "Apply 4x", "M.C. / Apply", "4*M.C. / Apply 4x"]
    ],
    title="Timings in seconds",
    formatters=[(v,i,j) -> v isa Number ? @sprintf("%.2f", v) : v],
    table_format = TextTableFormat(borders = text_table_borders__ascii_rounded);  
)

#=
                          Timings in seconds
.------------.-------------.----------------.------------------------.
|            |             | Learn & Apply  |                        |
|       Name | Monte-Carlo |  Learn | Apply | Speedup (M.C. / Apply) |
:------------+-------------+--------+-------+------------------------:
|  chandra-9 |        0.03 |   0.04 |  0.01 |                   2.46 |
| chandra-10 |        0.10 |   0.32 |  0.04 |                   2.52 |
| chandra-11 |        1.18 |   1.75 |  0.28 |                   4.26 |
|   cyclic-7 |        0.14 |   0.12 |  0.03 |                   4.30 |
|   cyclic-8 |        0.86 |   2.83 |  0.86 |                   1.00 |
|     eco-11 |        0.40 |   0.92 |  0.15 |                   2.66 |
|     eco-12 |        1.94 |   6.17 |  1.53 |                   1.27 |
|     noon-7 |        0.13 |   0.31 |  0.05 |                   2.76 |
|     noon-8 |        1.21 |   1.43 |  0.33 |                   3.68 |
|     noon-9 |       11.14 |  11.70 |  3.65 |                   3.05 |
|  katsura-9 |        0.15 |   0.79 |  0.08 |                   1.83 |
| katsura-10 |        0.92 |   3.92 |  0.60 |                   1.53 |
| katsura-11 |        5.31 |  35.84 |  2.72 |                   1.95 |
|    hexapod |        0.00 |   0.01 |  0.00 |                   1.93 |
|      alea6 |        0.09 |   0.20 |  0.21 |                   0.43 |
|       hiv2 |        1.17 |   1.33 |  0.20 |                   5.71 |
|    goodwin |      108.04 | 113.70 | 13.98 |                   7.73 |
|        crn |        0.13 |   0.49 |  0.04 |                   2.86 |
|   jason210 |        2.93 |   3.32 |  0.68 |                   4.34 |
|   gametwo2 |       10.83 |  36.61 |  6.70 |                   1.62 |
|      yang1 |       13.61 |  76.82 |  0.97 |                  14.09 |
|   bayes148 |       29.17 |  58.14 |  0.74 |                  39.52 |
|     mayr42 |       33.47 |  46.58 |  0.18 |                 185.58 |
|       siwr |       17.95 |  16.30 |  0.20 |                  89.91 |
'------------'-------------'--------'-------'------------------------'
=#

import Pkg

include("../utils.jl")
julia_pkg_preamble("$(@__DIR__)")

using CpuId, Logging, Pkg, Printf
using Statistics

import Singular

logger = Logging.ConsoleLogger(stdout, Logging.Info)
global_logger(logger)

const runtime = Dict()

const PROBLEM_NAME = ARGS[1]
const NUM_RUNS = parse(Int, ARGS[2])
const BENCHMARK_SET = parse(Int, ARGS[3])
const VALIDATE = parse(Bool, ARGS[4])

const BENCHMARK_DIR = "../../" * get_benchmark_dir("singular", BENCHMARK_SET)

@info "" ARGS
@info "" PROBLEM_NAME
@info "" NUM_RUNS
@info "" BENCHMARK_SET
@info "" VALIDATE
@info "" "$(@__DIR__)"
flush(stdout)
flush(stderr)

# Load the system
path = (@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$PROBLEM_NAME.jl"
include(path)

function aa_system_to_singular(system)
    R = AbstractAlgebra.parent(system[1])
    modulo = AbstractAlgebra.characteristic(R)
    n = AbstractAlgebra.nvars(R)
    if !iszero(modulo)
        ground_s = Singular.N_ZpField(modulo)
        R_s, _ = Singular.polynomial_ring(
            ground_s,
            map(string, symbols(R)),
            internal_ordering=:degrevlex
        )
        system_s = map(
            f -> AbstractAlgebra.change_base_ring(
                ground_s,
                AbstractAlgebra.map_coefficients(c -> ground_s(AbstractAlgebra.data(c)), f),
                parent=R_s
            ),
            system
        )
    else
        ground_s = Singular.QQ
        R_s, _ = Singular.polynomial_ring(
            ground_s,
            map(string, symbols(R)),
            internal_ordering=:degrevlex
        )
        system_s = map(
            f -> AbstractAlgebra.change_base_ring(
                ground_s,
                AbstractAlgebra.map_coefficients(c -> ground_s(c), f),
                parent=R_s
            ),
            system
        )
    end
    ideal_s = Singular.Ideal(R_s, system_s)
    ideal_s
end

# Compile
singular_system = aa_system_to_singular(system)
Singular.std(singular_system, complete_reduction=true)

function process_system()
    @info "Processing $PROBLEM_NAME"
    @info """
    Averaging over $NUM_RUNS runs."""

    runtime[PROBLEM_NAME] = Dict{Any, Any}()
    for cat in ALL_CATEGORIES
        runtime[PROBLEM_NAME][cat] = Inf
    end
    for iter in 1:NUM_RUNS
        @info "Computing GB.." iter
        singular_system = aa_system_to_singular(system)
        timing = @timed result = Singular.std(singular_system, complete_reduction=true)
        @debug "Result is" result
        runtime[PROBLEM_NAME][:total_time] = min(runtime[PROBLEM_NAME][:total_time], timing.time)
        if VALIDATE
            output_fn = (@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$(output_filename())"
            @info "Printing the basis to $output_fn"
            output_file = open(output_fn, "w")
            ring = parent(system[1])
            vars_str = join(map(repr, Singular.gens(ring)), ", ")
            println(output_file, vars_str)
            println(output_file, Singular.characteristic(base_ring(ring)))
            println(output_file, join(map(repr, Singular.gens(result)), ",\n"))
            close(output_file)
        end
    end
end

function dump_timings()
    timings = ""
    timings *= "$PROBLEM_NAME\n"
    for (key, model_runtime) in runtime
        for c in [:total_time]
            timings *= "$c, "
            timings *= string(model_runtime[c]) * "\n"
        end
    end
    filename = timings_filename()
    open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "w") do io
        write(io, timings)
    end
end

function dump_results()
    filename = result_filename(GLOBAL_ID)
    open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "w") do io
        if haskey(runtime, PROBLEM_NAME)
            println(io, runtime[PROBLEM_NAME][:return_value])
        end
    end
    filename = data_filename(GLOBAL_ID)
    open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "w") do io
        write(io, "$PROBLEM_NAME\n")
    end
    for cat in ID_DATA_CATEGORIES
        if !haskey(runtime[PROBLEM_NAME], cat)
            continue
        end
        if cat === :something_important
            # make a separate file for it
            filename_cat = generic_filename(cat, GLOBAL_ID)
            open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename_cat", "w") do io
                # print something
            end
            continue
        end
        # otherwise, print in the data file
        open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "a+") do io
            write(io, "$cat, ")
            write(io, string(runtime[PROBLEM_NAME][cat]))
            write(io, "\n")
        end
    end
end

process_system()
dump_timings()
# dump_results()

import Nemo
using SHA

include((@__DIR__) * "/layman_parser.jl")

function hash_polynomial(poly, h)
    poly_str = repr(poly)
    sha3_256(poly_str)
end

function get_certificate(ring, polys)
    filter!(!iszero, polys)
    @assert !isempty(polys)
    sort!(polys, by=Nemo.leading_monomial)
    polys = map(poly -> Nemo.divexact(poly, Nemo.leading_coefficient(poly)), polys)
    h = map(i -> UInt8(0), 1:32)
    for (i, poly) in enumerate(polys)
        i_8 = i % UInt8
        h = i_8 .⊻ hash_polynomial(poly, h)
    end
    certificate = bytes2hex(h)
    certificate
end

function is_certificate_standardized(certificate)
    certificate == standardize_certificate(certificate)
end

function standardize_certificate(certificate)
    certificate = strip(string(certificate), ['\n', ' ', '\r'])
    certificate
end

function compute_basis_validation_certificate(result)
    ring, polys = parse_system_naive(result)
    if isempty(polys)
        return false, ""
    end
    certificate = get_certificate(ring, polys)
    true, standardize_certificate(certificate)
end

using Revise, InteractiveUtils, Groebner

##############################
## MONOM DIVISIBILITY CHECK ##
##############################

io = open(joinpath(@__DIR__, "native_PackedTuple1_monom_is_divisible.txt"), "w")
code_native(
    io,
    Groebner.monom_is_divisible,
    Tuple{
        Groebner.PackedTuple1{UInt64, UInt8},
        Groebner.PackedTuple1{UInt64, UInt8}
    },
    debuginfo=:none
)       
close(io)

io = open(joinpath(@__DIR__, "native_PackedTuple2_monom_is_divisible.txt"), "w")
code_native(
    io,
    Groebner.monom_is_divisible,
    Tuple{
        Groebner.PackedTuple2{UInt64, UInt8},
        Groebner.PackedTuple2{UInt64, UInt8}
    },
    debuginfo=:none
)       
close(io)

io = open(joinpath(@__DIR__, "native_PackedTuple4_monom_is_divisible.txt"), "w")
code_native(
    io,
    Groebner.monom_is_divisible,
    Tuple{
        Groebner.PackedTuple4{UInt64, UInt8},
        Groebner.PackedTuple4{UInt64, UInt8}
    },
    debuginfo=:none
)       
close(io)

Groebner.monom_is_divisible(
    Groebner.PackedTuple2{UInt64, UInt8}(0x03020100, 0x00000000),
    Groebner.PackedTuple2{UInt64, UInt8}(0x02020100, 0x00000000)
)

# Sasha: probably need to read llvm IR docs to understand why this does not work
# @inline @generated function _packed_vec_uwu(a::NTuple{2,UInt64}, b::NTuple{2,UInt64})
#     N = 16
#     textir = """
#     define i8 @entry(ptr nocapture noundef nonnull readonly align 8 dereferenceable(16) %0, ptr nocapture noundef nonnull readonly align 8 dereferenceable(16) %1) #0 {
#     top:
#         %val.0   = load <2 x i64>, ptr %0
#         %val.1   = load <2 x i64>, ptr %1
#         %av      = bitcast <2 x i64> %val.0 to <$N x i8>
#         %bv      = bitcast <2 x i64> %val.1 to <$N x i8>
#         %mask    = icmp uge <$N x i8> %av, %bv
#         %mask.i  = bitcast <$N x i1> %mask to i$N
#         %res     = icmp eq i$N %mask.i, $(big(2)^N - 1)
#         %retval  = zext i1 %res to i8
#         ret i8 %retval
#     }
#     attributes #0 = { alwaysinline }
#     """
#     quote
#         Base.llvmcall(($textir, "entry"), Bool, Tuple{NTuple{2,UInt64}, NTuple{2,UInt64}}, a, b)
#     end
# end

# _packed_vec_uwu(UInt64.((0x03020100, 0x00000000)), UInt64.((0x02020100, 0x00000000)))
# @code_llvm _packed_vec_uwu(UInt64.((0x03020100, 0x00000000)), UInt64.((0x02020100, 0x00000000)))

##############################
## MONOM CO-PRIMALITY CHECK ##
##############################

io = open(joinpath(@__DIR__, "native_PackedTuple1_monom_is_gcd_const.txt"), "w")
code_native(
    io,
    Groebner.monom_is_gcd_const,
    Tuple{
        Groebner.PackedTuple1{UInt64, UInt8},
        Groebner.PackedTuple1{UInt64, UInt8}
    },
    debuginfo=:none
)       
close(io)

io = open(joinpath(@__DIR__, "native_PackedTuple2_monom_is_gcd_const.txt"), "w")
code_native(
    io,
    Groebner.monom_is_gcd_const,
    Tuple{
        Groebner.PackedTuple2{UInt64, UInt8},
        Groebner.PackedTuple2{UInt64, UInt8}
    },
    debuginfo=:none
)       
close(io)

##############################
##     MONOM LCM COMPUTE    ##
##############################

io = open(joinpath(@__DIR__, "native_PackedTuple1_monom_lcm!.txt"), "w")
code_native(
    io,
    Groebner.monom_lcm!,
    Tuple{
        Groebner.PackedTuple1{UInt64, UInt8},    
        Groebner.PackedTuple1{UInt64, UInt8},
        Groebner.PackedTuple1{UInt64, UInt8}
    },
    debuginfo=:none
)       
close(io)

io = open(joinpath(@__DIR__, "native_PackedTuple2_monom_lcm!.txt"), "w")
code_native(
    io,
    Groebner.monom_lcm!,
    Tuple{
        Groebner.PackedTuple2{UInt64, UInt8},    
        Groebner.PackedTuple2{UInt64, UInt8},
        Groebner.PackedTuple2{UInt64, UInt8}
    },
    debuginfo=:none
)       
close(io)

##############################
##    MONOM HASH COMPUTE    ##
##############################

io = open(joinpath(@__DIR__, "native_PackedTuple1_monom_hash.txt"), "w")
code_native(
    io,
    Groebner.monom_hash,
    Tuple{
        Groebner.PackedTuple1{UInt64, UInt8},    
        Vector{UInt64}
    },
    debuginfo=:none
)       
close(io)

# @inline @generated function _packed_vec_dot2(
#     a::T,
#     b::NTuple{8, MH},
#     ::Type{B}
# ) where {T, MH, B}
#     ts, bs = sizeof(T), sizeof(B)
#     @assert bs * div(ts, bs) == ts
#     epc = div(ts, bs)
#     shift = bs * 8
#     x = :x
#     ans = :(x = $MH(0))
#     for i in 1:epc
#         ans = :($ans;
#         @inbounds iz = $MH(mod(a, $B)) * b[$i];
#         x = x + iz;
#         a = a >> $shift)
#     end
#     :($ans; return $x)
# end

# @inline function _packed_vec_dot3(
#     a::UInt64,
#     b::NTuple{8, UInt64},
# )
#     sum(reinterpret(NTuple{8, UInt8}, a) .* b)
# end

import Nemo

function extract_ring(line1, line2)
    vars_str = map(f -> string(strip(f, [',', ' ', '\t'])), split(line1, ","))
    char = parse(BigInt, strip(line2))
    @assert char < typemax(UInt)
    base_field = iszero(char) ? Nemo.QQ : Nemo.GF(UInt(char))
    ring_nemo, vars_nemo = Nemo.polynomial_ring(base_field, vars_str, internal_ordering=:degrevlex)
    base_field, ring_nemo, vars_nemo
end

function parse_polynomial_from_terms(
    ring_nemo,
    constant_type::T,
    terms_exploded_str,
    str_to_var_idx
) where {T}
    base_field = Nemo.base_ring(ring_nemo)
    n = Nemo.nvars(ring_nemo)
    cfs = Vector{Nemo.elem_type(base_field)}(undef, length(terms_exploded_str))
    exps = Vector{Vector{Int}}(undef, length(terms_exploded_str))
    for (i, t) in enumerate(terms_exploded_str)
        exp_ = zeros(Int, n)
        cf_ = one(base_field)
        for m in t
            varexp = split(m, "^")
            if length(varexp) == 1
                x = varexp[1]
                if haskey(str_to_var_idx, x)
                    exp_[str_to_var_idx[x]] += 1
                else
                    constant = parse(constant_type, x)
                    cf_ *= base_field(constant)
                end
            else
                @assert length(varexp) == 2
                x, y = varexp
                exp_[str_to_var_idx[x]] += parse(Int, y)
            end
        end
        cfs[i] = cf_
        exps[i] = exp_
    end
    cfs, exps
end

function getlines_backend_dependent(result)
    result_ = string(strip(result, [' ', ',', '\t', '\n']))
    exploded = split(result_, "\n")
    if length(exploded) == 2
        return vcat(exploded[1], "0", map(strip, split(exploded[2], ",")))
    end
    if startswith(result, "#")
        lines = split(result, "\n")
        @assert all(line -> startswith(line, "#"), lines[1:7])
        line2 = strip(split(lines[3])[end])
        line1 = join(map(strip, split(split(lines[4], ":")[end], ",")), ",")
        lines_polys = filter(!isempty, map(f -> string(strip(f, [' ', '\n', '\r'])), lines[8:end]))
        @assert startswith(lines_polys[1], "[")
        lines_polys[1] = lines_polys[1][2:end]
        @assert endswith(lines_polys[end], "]:")
        lines_polys[end] = lines_polys[end][1:(end - 2)]
        return vcat(line1, line2, lines_polys)
    end
    if contains(result, ")") && contains(result, "(")
        result = replace(result, "(" => "", ")" => "")
    end
    filter(!isempty, split(result, "\n"))
end

function parse_polys_with_given_ring(ring, polys_str)
    polys_str = filter(!isempty, polys_str)
    base_field, vars = Nemo.base_ring(ring), Nemo.gens(ring)
    str_to_var_idx = Dict{String, Int}(string(v) => i for (i, v) in enumerate(vars))
    polys = Vector{Nemo.elem_type(ring)}()
    constant_type = base_field == Nemo.QQ ? Rational{BigInt} : Int64
    for poly_str in polys_str
        terms_str_plus = split(poly_str, '+')
        terms_str = empty(terms_str_plus)
        @assert length(terms_str_plus) > 0
        for term_str in terms_str_plus
            term_str_minus = split(term_str, '-')
            if !isempty(strip(term_str_minus[1]))
                push!(terms_str, strip(term_str_minus[1]))
            end
            append!(terms_str, map(s -> "-1*$(strip(s))", term_str_minus[2:end]))
        end
        terms_exploded_str = map(t -> map(strip, split(t, "*")), terms_str)
        cfs, exps =
            parse_polynomial_from_terms(ring, constant_type, terms_exploded_str, str_to_var_idx)
        poly_nemo = ring(cfs, exps)
        push!(polys, poly_nemo)
    end
    polys
end

function parse_system_naive(result::String)
    lines = getlines_backend_dependent(result)
    @assert length(lines) >= 2
    base_field, ring_nemo, vars_nemo = extract_ring(lines[1], lines[2])
    if length(lines) == 2
        return ring_nemo, []
    end
    polys_str = map(s -> string(strip(s, [' ', ',', '\t'])), lines[3:end])
    polys_nemo = parse_polys_with_given_ring(ring_nemo, polys_str)
    ring_nemo, polys_nemo
end

# inline tests
for parse_system in [parse_system_naive]
    ring, polys = parse_system("""
    x, y,z  
    13
    17
    x - y + 13*z - 4*x - 3*y + 18*z,
    x^3*y + 14,
    """)

    flag1 = Nemo.symbols(ring) == [:x, :y, :z]
    flag2 = Nemo.base_ring(ring) == Nemo.GF(13)
    flag3 = map(string, polys) == ["4", "10*x + 9*y + 5*z", "x^3*y + 1"]
    @assert flag1 && flag2 && flag3 "Parsing routine $parse_system is broken for groebner"

    ring, polys = parse_system("""
    x1,x2  
    0
    5*x1^2 - 10*x2 + 1267650600228229401496703205376// 1267650600228229401496703205375,
    -x2^20*x1,
    -2*x1 - 3*x2,
    -1,
    0
    """)

    flag1 = Nemo.symbols(ring) == [:x1, :x2]
    flag2 = Nemo.base_ring(ring) == Nemo.QQ
    flag3 =
        map(string, polys) == [
            "5*x1^2 - 10*x2 + 1267650600228229401496703205376//1267650600228229401496703205375",
            "-x1*x2^20",
            "-2*x1 - 3*x2",
            "-1",
            "0"
        ]
    @assert flag1 && flag2 && flag3 "Parsing routine $parse_system is broken for groebner"

    ring, polys = parse_system("""
    #Reduced Groebner basis data
    #---
    #field characteristic: 0
    #variable order:       x, y
    #monomial order:       graded reverse lexicographical
    #length of basis:      2 elements sorted by increasing leading monomials
    #---
    [1*x^1+1*y^1,
    1*y^2+536870913]:
    """)
    flag1 = Nemo.symbols(ring) == [:x, :y]
    flag2 = Nemo.base_ring(ring) == Nemo.QQ
    flag3 = map(string, polys) == ["x + y", "y^2 + 536870913"]
    @assert flag1 && flag2 && flag3 "Parsing routine $parse_system is broken for msolve"

    ring, polys = parse_system("""
    x, y  
    13
    (1*x^1) + (1*y^1),
    (1*y^2) + (16*1),
    """)
    flag1 = Nemo.symbols(ring) == [:x, :y]
    flag2 = Nemo.base_ring(ring) == Nemo.GF(13)
    flag3 = map(string, polys) == ["x + y", "y^2 + 3"]
    @assert flag1 && flag2 && flag3 "Parsing routine $parse_system is broken for openf4"

    ring, polys = parse_system("""
    x, y  
    x + 30*y^29, 1//2*y^2 + 16//3*y,
    """)
    flag1 = Nemo.symbols(ring) == [:x, :y]
    flag2 = Nemo.base_ring(ring) == Nemo.QQ
    flag3 = map(string, polys) == ["30*y^29 + x", "1//2*y^2 + 16//3*y"]
    @assert flag1 && flag2 && flag3 "Parsing routine $parse_system is broken for SI.jl"
end

using Test, AbstractAlgebra, Groebner

supports_ordering = Groebner.monom_is_supported_ordering
monom_construct_from_vector = Groebner.monom_construct_from_vector
lex = (x, y) -> Groebner.monom_isless(x, y, Groebner.Lex())
dl = (x, y) -> Groebner.monom_isless(x, y, Groebner.DegLex())
drl = (x, y) -> Groebner.monom_isless(x, y, Groebner.DegRevLex())

implementations_to_test = [
    Groebner.ExponentVector{T} where {T},
    Groebner.PackedTuple1{T, UInt8} where {T},
    Groebner.PackedTuple2{T, UInt8} where {T},
    Groebner.PackedTuple3{T, UInt8} where {T},
    Groebner.PackedTuple4{T, UInt8} where {T},
    Groebner.NibbleMonom{16},
    Groebner.NibbleNoDeg{16},
    Groebner.FixedMonomNoDeg{16, UInt8},
    Groebner.FixedMonom{16, UInt8}
]

max_deg(::Type{<:Groebner.ExponentVector{T}}) where {T} = typemax(T)
max_deg(::Type{<:Groebner.AbstractPackedTuple{T, B}}) where {T, B} = typemax(B)
max_deg(::Type{Groebner.NibbleMonom{N}}) where {N} = 15
max_deg(::Type{Groebner.NibbleNoDeg{N}}) where {N} = 15
max_deg(::Type{Groebner.FixedMonomNoDeg{N, T}}) where {N, T} = typemax(T)
max_deg(::Type{Groebner.FixedMonom{N, T}}) where {N, T} = typemax(T)

@testset "monom orders: display" begin
    ord_display(ord) = begin
        io = IOBuffer()
        show(io, MIME("text/plain"), ord)
        String(take!(io))
    end

    ord = Groebner.WeightedOrdering(:x => 1, :y => 2, :z => 3)
    str = ord_display(ord)
    str = chopprefix(str, "WeightedOrdering(")
    str = chopsuffix(str, ")")
    @test issubset(split(str, ","), ["x=>1", "y=>2", "z=>3"])

    ord1 = Groebner.Lex(3:4)
    str1 = ord_display(ord1)
    ord2 = Groebner.DegRevLex(1:2)
    str2 = ord_display(ord2)

    ord = Groebner.ProductOrdering(Groebner.Lex(3:4), Groebner.DegRevLex(1:2))
    str = ord_display(ord)
    @test occursin(str1, str)
    @test occursin(str2, str)

    ord = Groebner.MatrixOrdering([1, 2, 3], [0 0 0; 0 1 0; 1 1 1])
    ord_display(ord)
end

@testset "monom orders: Lex, DegLex, DegRevLex" begin
    x = [1, 1, 1, 1, 1, 0, 1, 1, 0, 1]
    y = [1, 1, 1, 1, 1, 0, 1, 1, 0, 1]
    a = monom_construct_from_vector(Groebner.ExponentVector{UInt32}, x)
    b = monom_construct_from_vector(Groebner.ExponentVector{UInt32}, y)
    @test !lex(a, b) && !dl(a, b) && !drl(a, b)

    x = [1, 1, 1, 1, 1, 0, 1, 2, 0, 1]
    y = [1, 1, 1, 1, 1, 0, 2, 1, 0, 1]
    a = monom_construct_from_vector(Groebner.ExponentVector{UInt32}, x)
    b = monom_construct_from_vector(Groebner.ExponentVector{UInt32}, y)
    @test lex(a, b) && dl(a, b) && drl(a, b)

    n = 12
    for i in 2:n
        xx = ones(Int32, n)
        xx[i] = xx[i] + 1
        yy = ones(Int32, n)
        yy[i - 1] = yy[i - 1] + 1
        a = monom_construct_from_vector(Groebner.ExponentVector{UInt32}, xx)
        b = monom_construct_from_vector(Groebner.ExponentVector{UInt32}, yy)
        @test lex(a, b) && dl(a, b) && drl(a, b)
    end

    for T in (UInt64, UInt32, UInt16, UInt8)
        for EV in implementations_to_test
            MonomType = isconcretetype(EV) ? EV : EV{T}
            if MonomType <: Groebner.AbstractPackedTuple{T, UInt8} && T == UInt8
                continue
            end

            a = monom_construct_from_vector(MonomType, [0])
            b = monom_construct_from_vector(MonomType, [0])
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test !drl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test !lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test !dl(a, b)

            a = monom_construct_from_vector(MonomType, [0])
            b = monom_construct_from_vector(MonomType, [1])
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test drl(a, b)
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test !drl(b, a)
            supports_ordering(MonomType, Groebner.Lex()) && @test lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test dl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test !lex(b, a)
            supports_ordering(MonomType, Groebner.DegLex()) && @test !dl(b, a)

            2 > Groebner.monom_max_vars(MonomType) && continue
            a = monom_construct_from_vector(MonomType, [1, 1])
            b = monom_construct_from_vector(MonomType, [2, 0])
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test drl(a, b)
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test !drl(b, a)
            supports_ordering(MonomType, Groebner.Lex()) && @test lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test dl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test !lex(b, a)
            supports_ordering(MonomType, Groebner.DegLex()) && @test !dl(b, a)

            a = monom_construct_from_vector(MonomType, [1, 1])
            b = monom_construct_from_vector(MonomType, [0, 2])
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test drl(b, a)
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test !drl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test !lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test !dl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test lex(b, a)
            supports_ordering(MonomType, Groebner.DegLex()) && @test dl(b, a)

            a = monom_construct_from_vector(MonomType, [1, 1])
            b = monom_construct_from_vector(MonomType, [1, 1])
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test !drl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test !lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test !dl(a, b)

            a = monom_construct_from_vector(MonomType, [1, 1])
            b = monom_construct_from_vector(MonomType, [2, 2])
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test !drl(b, a)
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test drl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test dl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test !lex(b, a)
            supports_ordering(MonomType, Groebner.DegLex()) && @test !dl(b, a)

            3 > Groebner.monom_max_vars(MonomType) && continue
            a = monom_construct_from_vector(MonomType, [1, 0, 2])
            b = monom_construct_from_vector(MonomType, [2, 0, 1])
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test drl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test dl(a, b)

            a = monom_construct_from_vector(MonomType, [1, 5, 0])
            b = monom_construct_from_vector(MonomType, [1, 0, 1])
            @test !drl(a, b)

            25 > Groebner.monom_max_vars(MonomType) && continue
            a = monom_construct_from_vector(MonomType, ones(UInt, 25))
            b = monom_construct_from_vector(MonomType, ones(UInt, 25))
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test !drl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test !lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test !dl(a, b)

            30 > Groebner.monom_max_vars(MonomType) && continue
            a = monom_construct_from_vector(MonomType, ones(UInt, 30))
            b = monom_construct_from_vector(MonomType, ones(UInt, 30))
            supports_ordering(MonomType, Groebner.DegRevLex()) && @test !drl(a, b)
            supports_ordering(MonomType, Groebner.Lex()) && @test !lex(a, b)
            supports_ordering(MonomType, Groebner.DegLex()) && @test !dl(a, b)
        end

        # test that different implementations agree
        for n in 1:10
            k = rand(1:60)

            implementations_to_test_local =
                map(EV -> isconcretetype(EV) ? EV : EV{T}, implementations_to_test)
            implementations_to_test_local =
                filter(MT -> Groebner.monom_max_vars(MT) >= k, implementations_to_test_local)

            t = div(typemax(UInt8), 2k) - 1
            t = min(t, div(minimum(max_deg.(implementations_to_test_local)), 2))
            x, y = rand(0:t, k), rand(0:t, k)
            as = [
                monom_construct_from_vector(MonomType, x) for
                MonomType in implementations_to_test_local
            ]
            bs = [
                monom_construct_from_vector(MonomType, y) for
                MonomType in implementations_to_test_local
            ]

            if all(supports_ordering.(implementations_to_test_local, Ref(Groebner.DegRevLex())))
                @test length(unique(map(drl, as, bs))) == 1
            end
            if all(supports_ordering.(implementations_to_test_local, Ref(Groebner.Lex())))
                @test length(unique(map(lex, as, bs))) == 1
            end
            if all(supports_ordering.(implementations_to_test_local, Ref(Groebner.DegLex())))
                @test length(unique(map(dl, as, bs))) == 1
            end

            # test that a < b && b < a does not happen
            for (a, b) in zip(as, bs)
                k > Groebner.monom_max_vars(a) && continue
                if supports_ordering(typeof(a), Groebner.Lex()) && lex(a, b)
                    @test !lex(b, a)
                end
                if supports_ordering(typeof(a), Groebner.DegLex()) && dl(a, b)
                    @test !dl(b, a)
                end
                if supports_ordering(typeof(a), Groebner.DegRevLex()) && drl(a, b)
                    @test !drl(b, a)
                end
            end
        end
    end
end

function test_circular_shift(a, b, n, Ord, answers)
    R, x = AbstractAlgebra.QQ[["x$i" for i in 1:n]...]
    vars_to_index = Dict(x .=> 1:n)
    orders = map(i -> Groebner.ordering_transform(Ord(circshift(x, -i)), vars_to_index), 0:(n - 1))
    cmps = map(ord -> ((x, y) -> Groebner.monom_isless(x, y, ord)), orders)

    for (cmp, ord, answer) in zip(cmps, orders, answers)
        if supports_ordering(typeof(a), ord)
            @test answer == cmp(a, b) && !answer == cmp(b, a)
        end
    end
end

@testset "monoms, variable permutation" begin
    for T in (UInt64, UInt32, UInt16)
        for EV in implementations_to_test
            MonomType = isconcretetype(EV) ? EV : EV{T}

            n = 3
            n >= Groebner.monom_max_vars(MonomType) && continue

            a = monom_construct_from_vector(MonomType, [5, 5, 3])
            b = monom_construct_from_vector(MonomType, [1, 1, 10])

            test_circular_shift(a, b, n, Groebner.Lex, [false, false, true])
            test_circular_shift(a, b, n, Groebner.DegLex, [false, false, false])
            test_circular_shift(a, b, n, Groebner.DegRevLex, [false, false, false])

            n = 5
            n >= Groebner.monom_max_vars(MonomType) && continue

            a = monom_construct_from_vector(MonomType, [1, 2, 3, 4, 5])
            b = monom_construct_from_vector(MonomType, [4, 3, 2, 1, 5])

            test_circular_shift(a, b, n, Groebner.Lex, [true, true, false, false, true])
            test_circular_shift(a, b, n, Groebner.DegLex, [true, true, false, false, true])
            test_circular_shift(a, b, n, Groebner.DegRevLex, [true, false, false, true, true])
        end
    end
end

function test_orderings(n, v1, v2, ords_to_test)
    R, x = AbstractAlgebra.QQ[["x$i" for i in 1:n]...]
    var_to_index = Dict(x .=> 1:n)
    for wo in ords_to_test
        ord = wo.ord
        ans = wo.ans
        internal_ord = Groebner.ordering_transform(ord, var_to_index)
        @test Groebner.monom_isless(v1, v2, internal_ord) == ans[1]
        @test Groebner.monom_isless(v2, v1, internal_ord) == ans[2]
        @test Groebner.monom_isless(v2, v2, internal_ord) == false
        @test Groebner.monom_isless(v1, v1, internal_ord) == false
    end
end

@testset "monom orders: WeightedOrdering" begin
    R, x = AbstractAlgebra.QQ[["x$i" for i in 1:3]...]

    pv = Groebner.ExponentVector{T} where {T}

    v1 = Groebner.monom_construct_from_vector(pv{UInt64}, [1, 2, 3])
    v2 = Groebner.monom_construct_from_vector(pv{UInt64}, [3, 2, 1])

    @test_throws DomainError Groebner.WeightedOrdering(Dict(x .=> [-1, 0, 0]))

    ords_to_test = [
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 1, 1])), ans=[true, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [0, 0, 1])), ans=[false, true]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [0, 1, 0])), ans=[true, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 0, 0])), ans=[true, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 1, 5])), ans=[false, true]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 0, 0])), ans=[true, false])
    ]

    test_orderings(3, v1, v2, ords_to_test)

    v1 = Groebner.monom_construct_from_vector(pv{UInt64}, [1, 2, 3])
    v2 = Groebner.monom_construct_from_vector(pv{UInt64}, [1, 2, 3])

    ords_to_test = [
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 1, 1])), ans=[false, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [0, 0, 1])), ans=[false, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [0, 1, 0])), ans=[false, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 0, 0])), ans=[false, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 1, 5])), ans=[false, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 0, 0])), ans=[false, false])
    ]

    test_orderings(3, v1, v2, ords_to_test)

    R, x = AbstractAlgebra.QQ[["x$i" for i in 1:6]...]

    v1 = Groebner.monom_construct_from_vector(pv{UInt64}, [1, 2, 3, 0, 0, 7])
    v2 = Groebner.monom_construct_from_vector(pv{UInt64}, [4, 5, 0, 0, 1, 4])

    ords_to_test = [
        (ord=Groebner.WeightedOrdering(Dict(x .=> [1, 1, 1, 1, 1, 1])), ans=[true, false]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [0, 0, 0, 0, 0, 4])), ans=[false, true]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [0, 2, 5, 0, 0, 0])), ans=[false, true]),
        (ord=Groebner.WeightedOrdering(Dict(x .=> [0, 2, 2, 0, 0, 0])), ans=[true, false])
    ]

    test_orderings(6, v1, v2, ords_to_test)
end

@testset "monom orders: ProductOrdering" begin
    pv = Groebner.ExponentVector{T} where {T}

    R, x = AbstractAlgebra.QQ[["x$i" for i in 1:3]...]
    v1 = Groebner.monom_construct_from_vector(pv{UInt64}, [1, 2, 3])
    v2 = Groebner.monom_construct_from_vector(pv{UInt64}, [3, 2, 1])

    ords_to_test = [
        (
            ord=Groebner.ProductOrdering(Groebner.Lex(x[1]), Groebner.DegLex(x[2], x[3])),
            ans=[true, false]
        ),
        (
            ord=Groebner.ProductOrdering(Groebner.DegRevLex(x[1:2]), Groebner.Lex(x[3])),
            ans=[true, false]
        )
    ]

    test_orderings(3, v1, v2, ords_to_test)

    R, x = AbstractAlgebra.QQ[["x$i" for i in 1:6]...]
    v1 = Groebner.monom_construct_from_vector(pv{UInt64}, [4, 1, 7, 0, 9, 8])
    v2 = Groebner.monom_construct_from_vector(pv{UInt64}, [1, 6, 3, 5, 9, 100])

    ords_to_test = [
        (
            ord=Groebner.ProductOrdering(Groebner.DegLex(x[1]), Groebner.DegLex(x[2:6])),
            ans=[false, true]
        ),
        (
            ord=Groebner.ProductOrdering(Groebner.DegLex(x[1:2]), Groebner.DegLex(x[3:6])),
            ans=[true, false]
        ),
        (
            ord=Groebner.ProductOrdering(Groebner.DegLex(x[1:3]), Groebner.DegLex(x[4:6])),
            ans=[false, true]
        ),
        (
            ord=Groebner.ProductOrdering(Groebner.DegLex(x[1:4]), Groebner.DegLex(x[5:6])),
            ans=[true, false]
        ),
        (
            ord=Groebner.ProductOrdering(
                Groebner.ProductOrdering(Groebner.DegLex(x[1:2]), Groebner.DegLex(x[3:4])),
                Groebner.DegLex(x[5:6])
            ),
            ans=[true, false]
        ),
        (
            ord=Groebner.ProductOrdering(
                Groebner.ProductOrdering(Groebner.DegLex(x[1:3]), Groebner.DegLex(x[4])),
                Groebner.DegLex(x[5:6])
            ),
            ans=[false, true]
        ),
        (
            ord=Groebner.DegLex(x[1:3]) * Groebner.DegLex(x[4]) * Groebner.DegLex(x[5:6]),
            ans=[false, true]
        )
    ]

    test_orderings(6, v1, v2, ords_to_test)
end

@testset "monom orders: MatrixOrdering" begin
    R, x = AbstractAlgebra.QQ[["x$i" for i in 1:3]...]

    pv = Groebner.ExponentVector{T} where {T}

    v1 = Groebner.monom_construct_from_vector(pv{UInt64}, [1, 2, 3])
    v2 = Groebner.monom_construct_from_vector(pv{UInt64}, [3, 2, 1])

    ord1 = Groebner.MatrixOrdering(
        x,
        [
            1 0 0
            0 1 0
            0 0 1
        ]
    )
    ord2 = Groebner.MatrixOrdering(
        x,
        [
            1 0 2;
        ]
    )
    ord3 = Groebner.MatrixOrdering(
        x,
        [
            0 0 0
            0 1 0
            1 1 1
        ]
    )
    @test_throws DomainError Groebner.MatrixOrdering(
        x,
        [
            1 0;
        ]
    )

    mo_to_test = [
        (ord=ord1, ans=[true, false]),
        (ord=ord2, ans=[false, true]),
        (ord=ord3, ans=[false, false])
    ]
    test_orderings(3, v1, v2, mo_to_test)
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# A wrapper around the F4 tracer exposed to the user

mutable struct WrappedTrace
    # One specialized trace per key.
    recorded_traces::Dict{Any, Any}   # Dict{Key, Trace}
    sys_support::Vector{Vector{Vector{IR_exponent}}}
    gb_support::Vector{Vector{Vector{IR_exponent}}}
    target_ord::AbstractMonomialOrdering

    WrappedTrace(sys_support, gb_support, target_ord) =
        new(Dict{Any, Any}(), sys_support, gb_support, target_ord)
end

function wrapped_trace_assert_compatible(trace::Trace, ring::PolyRing, key)
    @assert key <: CoeffGeneric ? trace.representation.coefftype <: CoeffGeneric :
            trace.representation.coefftype == key
    @assert trace.ring.ord == ring.ord
    @assert trace.ring.ground == ring.ground
    if key <: CoeffGeneric
        @assert typeof(trace.ring.characteristic) == typeof(ring.characteristic)
        @assert trace.ring.characteristic == ring.characteristic
    else
        @assert trace.ring.characteristic == typeof(trace.ring.characteristic)(ring.characteristic)
    end
    true
end

function wrapped_trace_save!(
    wrapped_trace::WrappedTrace,
    specialized_trace::Trace{CoeffType}
) where {CoeffType <: Coeff}
    key = CoeffType <: CoeffGeneric ? CoeffType : specialized_trace.representation.coefftype
    @assert key <: CoeffGeneric ? specialized_trace.representation.coefftype <: CoeffGeneric :
            specialized_trace.representation.coefftype == key
    if !isempty(wrapped_trace.recorded_traces)
        reference_trace = first(values(wrapped_trace.recorded_traces))
        @assert reference_trace.params.homogenize == specialized_trace.params.homogenize
        @assert reference_trace.ring.ord == specialized_trace.ring.ord
    end
    wrapped_trace.recorded_traces[key] = specialized_trace
end

function wrapped_trace_create_suitable_trace!(
    wrapped_trace::WrappedTrace,
    ring::PolyRing,
    params::AlgorithmParameters,
    ::Type{CoeffType}
) where {CoeffType <: Coeff}
    requested_key = CoeffType <: CoeffGeneric ? CoeffType : params.representation.coefftype
    # Try to find a suitable trace among the existing ones
    if haskey(wrapped_trace.recorded_traces, requested_key)
        trace = wrapped_trace.recorded_traces[requested_key]
        trace.ring.ord != ring.ord && throw(DomainError("ordering invalid in trace"))
        trace.ring = PolyRing(
            trace.ring.nvars,
            trace.ring.ord,
            typeof(trace.ring.characteristic)(ring.characteristic),
            trace.ring.ground
        )
        @invariant wrapped_trace_assert_compatible(trace, ring, requested_key)
        return trace
    end

    # Otherwise, create a new trace based on one of the existing ones
    default_trace = first(values(wrapped_trace.recorded_traces))
    default_trace.ring.ord != ring.ord && throw(DomainError("ordering invalid in trace"))
    if requested_key <: Union{CoeffGeneric, CoeffQQ}
        for trace in values(wrapped_trace.recorded_traces)
            if typeof(trace.ring.characteristic) == typeof(ring.characteristic)
                default_trace = trace
                break
            end
        end
    end
    new_trace = trace_copy(default_trace, params.representation, requested_key)
    new_char =
        requested_key <: Union{CoeffGeneric, CoeffQQ} ? ring.characteristic :
        convert(requested_key, ring.characteristic)
    new_trace.ring = PolyRing(ring.nvars, ring.ord, new_char, ring.ground)
    @invariant wrapped_trace_assert_compatible(new_trace, ring, requested_key)
    wrapped_trace_save!(wrapped_trace, new_trace)

    # the resulting trace may be in a invalid state, and needs to be filled with
    # the coefficients of the input polynomials
    new_trace
end

function wrapped_trace_check_input(
    trace::WrappedTrace,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}}
) where {I <: Integer, C <: Coeff}
    !(length(trace.sys_support) == length(monoms)) && return false
    for i in 1:length(monoms)
        !(length(trace.sys_support[i]) == length(monoms[i])) && return false
        for j in 1:length(monoms[i])
            if trace.sys_support[i][j] != monoms[i][j]
                return false
            end
        end
    end
    true
end

Base.show(io::IO, trace::WrappedTrace) = Base.show(io, MIME("text/plain"), trace)

function Base.show(io::IO, ::MIME"text/plain", wrapped_trace::WrappedTrace)
    println(io, "Recorded $(length(wrapped_trace.recorded_traces)) traces. Showing only one.\n")
    show(io, MIME("text/plain"), first(values(wrapped_trace.recorded_traces)))
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Precompile some calls for better ttfx

@setup_workload begin
    # Putting some things in `setup` can reduce the size of the
    # precompile file and potentially make loading faster.
    @compile_workload begin
        # all calls in this block will be precompiled, regardless of whether
        # they belong to your package or not (on Julia 1.8 and higher)
        R, (x, y) =
            AbstractAlgebra.polynomial_ring(AbstractAlgebra.QQ, ["x", "y"], internal_ordering=:lex)
        arr = [x * y^3 + x * y + 1, x^3 * y^2 + x * y^2 + x + 1]
        gb = groebner(arr)
        isgroebner(arr)
        normalform(gb, arr)
        leading_term(arr)
        leading_ideal(arr)
        quotient_basis(arr)
        # dimension(arr)

        R, (x, y) = AbstractAlgebra.polynomial_ring(AbstractAlgebra.GF(2^31 - 1), ["x", "y"])
        arr = [x^2 * y + x * y + 1, x * y^5 + y^4 + 1]
        gb = groebner(arr, ordering=DegRevLex())

        trace, gb = groebner_learn(arr, ordering=DegRevLex())
        flag, gb = groebner_apply!(trace, arr)

        R, (x, y) = AbstractAlgebra.polynomial_ring(
            AbstractAlgebra.GF(2^31 - 1),
            ["x", "y"],
            internal_ordering=:degrevlex
        )
        arr = [x^2 * y + x * y + 1, x * y^5 + y^4 + 1]
        gb = groebner(arr)

        trace, gb = groebner_learn(arr)
        flag, gb = groebner_apply!(trace, arr)
    end
end

precompile(groebner, (Vector{AbstractAlgebra.Generic.MPoly{AbstractAlgebra.Rational{BigInt}}},))

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

###
# High level

function linalg_learn_sparse_threaded!(
    trace::Trace,
    matrix::MacaulayMatrix,
    basis::Basis,
    tasks::Int,
    arithmetic::AbstractArithmetic
)
    sort_matrix_upper_rows!(matrix) # for the AB part
    sort_matrix_lower_rows!(matrix) # for the CD part

    # Reduce CD with AB
    linalg_learn_reduce_matrix_lower_part_threaded!(trace, matrix, basis, tasks, arithmetic)
    # Interreduce CD
    linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic)

    true
end

function _linalg_learn_reduce_matrix_lower_part_threaded!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    chunk::Vector{Int},
    pivots::Vector{Vector{ColumnLabel}},
    row_idx_to_coeffs::Vector{Int},
    sentinels::Vector{Int8},
    arithmetic::AbstractArithmetic,
    t_local_row::Vector{AccumType},
    t_local_not_reduced_to_zero::Vector{Int},
    t_local_useful_reducers::Set{Int},
    t_local_reducer_rows::Vector{Int}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
    @inbounds for i in chunk
        sparse_row_support = matrix.lower_rows[i]
        sparse_row_coeffs = basis.coeffs[row_idx_to_coeffs[i]]
        @invariant length(sparse_row_support) == length(sparse_row_coeffs)

        linalg_load_sparse_row!(t_local_row, sparse_row_support, sparse_row_coeffs)

        # Additionally record the indices of rows that participated in reduction
        # of the given row
        empty!(t_local_reducer_rows)
        first_nnz_column = sparse_row_support[1]

        success = false
        @inbounds while !success
            @invariant 1 <= first_nnz_column <= length(t_local_row)

            zeroed = linalg_reduce_dense_row_by_pivots_sparse_threadsafe0!(
                new_sparse_row_support,
                new_sparse_row_coeffs,
                t_local_row,
                matrix,
                basis,
                pivots,
                first_nnz_column,
                ncols,
                arithmetic,
                sentinels,
                t_local_reducer_rows
            )

            # if fully reduced
            zeroed && break

            # Sync point. Everything before this point becomes visible to
            # all other threads once they reach this point.
            # Note the absense of a total ordering on atomic operations
            old, success = Atomix.replace!(
                Atomix.IndexableRef(sentinels, (Int(new_sparse_row_support[1]),)),
                Int8(0),
                Int8(1),
                Atomix.acquire_release,
                Atomix.acquire
            )

            @invariant length(new_sparse_row_support) == length(new_sparse_row_coeffs)

            if success
                # new pivot is formed, wake up from the inner loop
                @invariant iszero(old)

                # NOTE: we are not recording reducers from the lower part of the matrix
                push!(t_local_not_reduced_to_zero, i)
                for reducer_row in t_local_reducer_rows
                    push!(t_local_useful_reducers, reducer_row)
                end

                linalg_row_make_monic!(new_sparse_row_coeffs, arithmetic)

                matrix.some_coeffs[i] = new_sparse_row_coeffs
                matrix.lower_to_coeffs[new_sparse_row_support[1]] = i
                pivots[new_sparse_row_support[1]] = new_sparse_row_support

                # This atomic write is paired by an atomic load in
                # `linalg_reduce_dense_row_by_pivots_sparse_threadsafe0!`. The
                # purpose of these atomics is to fence the above assignment
                #    pivots[new_sparse_row_support[1]] = new_sparse_row_support
                # 
                # This way, the next atomic load from the same location in
                # `sentinels` will also receive all relevant modifications to
                # `pivots` as a side-effect.
                Atomix.set!(
                    Atomix.IndexableRef(sentinels, (Int(new_sparse_row_support[1]),)),
                    Int8(2),
                    Atomix.release
                )

                new_sparse_row_support, new_sparse_row_coeffs =
                    linalg_new_empty_sparse_row(CoeffType)
            else
                # go for another iteration
                first_nnz_column = new_sparse_row_support[1]
            end
        end
    end
end

function linalg_learn_reduce_matrix_lower_part_threaded!(
    trace::Trace,
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    tasks::Int,
    arithmetic::AbstractArithmetic{AccumType, CoeffType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    nup, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_idx_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, nlow)
    resize!(matrix.sentinels, ncols)

    # If there is a pivot with the leading column i, then we set
    #   sentinels[i] = 1.
    # If sentinels[i] = 1, and if the pivot is synced, then we set
    #   sentinels[i] = 2.
    # Otherwise, sentinels[i] = 0.
    # Once sentinels[i] becomes 1 or 2, this is unchanged.
    sentinels = matrix.sentinels
    @inbounds for i in 1:ncols
        sentinels[i] = 0
    end
    @inbounds for i in 1:nup
        sentinels[matrix.upper_rows[i][1]] = 2
    end

    # Allocate thread-local buffers
    buffers_row = map(_ -> zeros(AccumType, ncols), 1:tasks)
    not_reduced_to_zero = map(_ -> Vector{Int}(), 1:tasks)
    useful_reducers = map(_ -> Set{Int}(), 1:tasks)
    reducer_rows = map(_ -> Vector{Int}(), 1:tasks)

    tasks = min(tasks, nlow)
    data_chunks = split_round_robin(1:nlow, tasks)
    task_results = Vector{Task}(undef, tasks)
    for (tid, chunk) in enumerate(data_chunks)
        t_local_row = buffers_row[tid]
        t_local_not_reduced_to_zero = not_reduced_to_zero[tid]
        t_local_useful_reducers = useful_reducers[tid]
        t_local_reducer_rows = reducer_rows[tid]
        task = @spawn begin
            _linalg_learn_reduce_matrix_lower_part_threaded!(
                matrix,
                basis,
                chunk,
                pivots,
                row_idx_to_coeffs,
                sentinels,
                arithmetic,
                t_local_row,
                t_local_not_reduced_to_zero,
                t_local_useful_reducers,
                t_local_reducer_rows
            )
        end
        task_results[tid] = task
    end
    for task in task_results
        wait(task)
    end

    # Update the tracer information
    # NOTE: we sort reducers by their original position in the array of pivots.
    # This way, the rows are already sorted at the apply stage.
    useful_reducers_sorted = sort(collect(reduce(union, useful_reducers)))
    push!(
        trace.matrix_infos,
        (nup=matrix.nrows_filled_upper, nlow=matrix.nrows_filled_lower, ncols=ncols)
    )
    _not_reduced_to_zero = sort(reduce(vcat, not_reduced_to_zero))
    push!(trace.matrix_nonzeroed_rows, _not_reduced_to_zero)
    push!(
        trace.matrix_upper_rows,
        (
            map(f -> matrix.upper_to_coeffs[f], useful_reducers_sorted),
            map(f -> matrix.upper_to_mult[f], useful_reducers_sorted)
        )
    )
    push!(
        trace.matrix_lower_rows,
        (row_idx_to_coeffs[_not_reduced_to_zero], matrix.lower_to_mult[_not_reduced_to_zero])
    )

    true
end

using Revise, Base.Threads, Primes, Groebner

function crt!(M, buf, n1, n2, ai, ci)
    Base.GMP.MPZ.set_ui!(n1, UInt(0))
    for i in 1:length(ai)
        Base.GMP.MPZ.mul_ui!(n2, ci[i], ai[i])
        Base.GMP.MPZ.add!(n1, n2)
    end
    Base.GMP.MPZ.set!(buf, n1)
    Base.GMP.MPZ.fdiv_r!(buf, M)
end

function crt_vec_full!(table_zz, modulo, tables_ff, mults, moduli)
    NN = Threads.maxthreadid()
    buf = [BigInt() for _ in 1:NN]
    n1 = [BigInt() for _ in 1:NN]
    n2 = [BigInt() for _ in 1:NN]
    rems = [Vector{UInt64}(undef, length(moduli)) for _ in 1:NN]
    Threads.@threads :static for i in 1:length(table_zz)
        t = Threads.threadid()
        for j in 1:length(table_zz[i])
            for k in 1:length(moduli)
                rems[t][k] = UInt64(tables_ff[k][i][j])
            end
            crt!(modulo, buf[t], n1[t], n2[t], rems[t], mults)
            Base.GMP.MPZ.set!(table_zz[i][j], buf[t])
        end
    end
    @assert NN == Threads.maxthreadid()
end

# Preallocate data
M, P = 1024, 101
table_zz = [[BigInt() for _ in 1:i] for i in 1:M]
moduli = UInt64.(prevprimes(2^31-1, P))
modulo = prod(BigInt, moduli)
mults = [rand(1:modulo-1) for _ in 1:length(moduli)]
tables_ff = [ [[mod(rand(UInt64), moduli[j]) for _ in 1:i] for i in 1:M] for j in 1:P]
mask = [falses(M) for _ in 1:M]

@time Groebner.crt_vec_full!(table_zz,modulo,tables_ff,moduli,mask; n_tasks=1)
@time Groebner.crt_vec_full!(table_zz,modulo,tables_ff,moduli,mask; n_tasks=1)

@time Groebner.crt_vec_full!(table_zz,modulo,tables_ff,moduli,mask; n_tasks=8)
@time Groebner.crt_vec_full!(table_zz,modulo,tables_ff,moduli,mask; n_tasks=8)

@time Groebner.crt_vec_full!(table_zz,modulo,tables_ff,moduli,mask; n_tasks=16)
@time Groebner.crt_vec_full!(table_zz,modulo,tables_ff,moduli,mask; n_tasks=16)

@time Groebner.crt_vec_full!(table_zz,modulo,tables_ff,moduli,mask; n_tasks=32)
@time Groebner.crt_vec_full!(table_zz,modulo,tables_ff,moduli,mask; n_tasks=32)

# This file is a part of Groebner.jl. License is GNU GPL v2.

# The sequence of lucky prime candidates is decreasing and deterministic.
# Make sure this number is at most 31 bits to be able to use signed ints.
const FIRST_LUCKY_PRIME_CANDIDATE = 2^31 - 1

const RANDOM_PRIME_LB = 2^29
const RANDOM_PRIME_UB = 2^30

mutable struct ModularState{T1 <: CoeffZZ, T2 <: CoeffQQ, T3}
    gb_coeffs_zz::Vector{Vector{T1}}
    gb_coeffs_qq::Vector{Vector{T2}}
    gb_coeffs_ff_all::Vector{Vector{Vector{T3}}}

    gen_coeffs_zz::Vector{Vector{T1}}

    modulo::BigInt
    current_prime::UInt64
    used_primes::Vector{UInt64}

    crt_mask::Vector{BitVector}
    ratrec_mask::Vector{BitVector}

    changematrix_coeffs_ff_all::Vector{Vector{Vector{Vector{T3}}}}
    changematrix_coeffs_zz::Vector{Vector{Vector{T1}}}
    changematrix_coeffs_qq::Vector{Vector{Vector{T2}}}

    function ModularState{T1, T2, T3}(
        coeffs_zz::Vector{Vector{T1}}
    ) where {T1 <: CoeffZZ, T2 <: CoeffQQ, T3 <: CoeffZp}
        new(
            Vector{Vector{T1}}(),
            Vector{Vector{T2}}(),
            Vector{Vector{Vector{T3}}}(),
            coeffs_zz,
            BigInt(),
            UInt64(FIRST_LUCKY_PRIME_CANDIDATE),
            Vector{UInt64}(),
            Vector{BitVector}(),
            Vector{BitVector}(),
            Vector{Vector{Vector{Vector{T3}}}}(),
            Vector{Vector{Vector{T1}}}(),
            Vector{Vector{Vector{T2}}}()
        )
    end
end

###
# Prime number selection

function modular_accept_prime(state::ModularState, prime::UInt64)
    p = BigInt(prime)
    buf = BigInt()
    @inbounds for coeffs in state.gen_coeffs_zz
        c = coeffs[1]
        if Base.GMP.MPZ.cmp_ui(Base.GMP.MPZ.tdiv_r!(buf, c, p), 0) == 0
            return false
        end
        c = coeffs[end]
        if Base.GMP.MPZ.cmp_ui(Base.GMP.MPZ.tdiv_r!(buf, c, p), 0) == 0
            return false
        end
    end
    true
end

function modular_next_prime!(state::ModularState)
    prime = Primes.prevprime(state.current_prime - 1)
    while !modular_accept_prime(state, prime)
        prime = Primes.prevprime(prime - 1)
    end
    state.current_prime = prime
    prime
end

function modular_random_prime(state::ModularState, rng::AbstractRNG)
    lb, ub = RANDOM_PRIME_LB, RANDOM_PRIME_UB
    while true
        candidate = rand(rng, lb:ub) % UInt64
        !modular_accept_prime(state, candidate) && continue
        Primes.isprime(candidate) && return UInt64(candidate)
    end
    UInt64(0)
end

###
# Other stuff

function modular_witness_set(
    gb_coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {C <: Coeff}
    witness_set = Vector{Tuple{Int, Int}}(undef, length(gb_coeffs))
    rng = params.rng
    k = 1
    @inbounds for i in 1:length(gb_coeffs)
        l = length(gb_coeffs[i])
        isone(l) && continue
        nl = max(floor(Int, log2(l)) - 1, 1)
        while k + nl + 1 > length(witness_set)
            resize!(witness_set, 2 * length(witness_set))
        end
        for j in 1:nl
            witness_set[k] = (i, rand(rng, 2:l))
            k += 1
        end
        witness_set[k] = (i, l)
        k += 1
    end
    resize!(witness_set, k - 1)
    unique!(witness_set)
    witness_set
end

function common_denominator!(den::BigInt, coeffs::Vector{T}) where {T <: CoeffQQ}
    Base.GMP.MPZ.set_si!(den, 1)
    @inbounds for i in 1:length(coeffs)
        c = coeffs[i]
        Base.GMP.MPZ.lcm!(den, denominator(c))
    end
    den
end

function _clear_denominators!(coeffs_qq::Vector{Vector{T}}) where {T <: CoeffQQ}
    coeffs_zz = [[BigInt(0) for _ in 1:length(c)] for c in coeffs_qq]
    den, buf = BigInt(), BigInt()
    @inbounds for i in 1:length(coeffs_qq)
        @invariant length(coeffs_zz[i]) == length(coeffs_qq[i])
        den = common_denominator!(den, coeffs_qq[i])
        for j in 1:length(coeffs_qq[i])
            num = numerator(coeffs_qq[i][j])
            Base.GMP.MPZ.tdiv_q!(buf, den, denominator(coeffs_qq[i][j]))
            Base.GMP.MPZ.mul!(coeffs_zz[i][j], num, buf)
        end
    end
    coeffs_zz
end

function clear_denominators!(basis::Basis{T}; deepcopy=false) where {T <: CoeffQQ}
    coeffs_zz = _clear_denominators!(basis.coeffs)
    if deepcopy
        basis_deep_copy_with_new_coeffs(basis, coeffs_zz)
    else
        basis_shallow_copy_with_new_coeffs(basis, coeffs_zz)
    end
end

function bigint_mod_p!(buf::BigInt, x::BigInt, prime::Unsigned, prime_big::BigInt)
    if Base.GMP.MPZ.cmp_ui(x, 0) < 0
        Base.GMP.MPZ.fdiv_q!(buf, x, prime_big)
        Base.GMP.MPZ.neg!(buf)
        Base.GMP.MPZ.mul_ui!(buf, prime)
        Base.GMP.MPZ.add!(x, buf)
    end
    Base.GMP.MPZ.tdiv_r!(buf, x, prime_big)
    buf
end

function modular_reduce_mod_p!(
    ring::PolyRing,
    coeffs_zz::Vector{Vector{T1}},
    prime::T2
) where {T1 <: CoeffZZ, T2 <: CoeffZp}
    coeffs_ff = [Vector{CoeffModular}(undef, length(c)) for c in coeffs_zz]
    p = BigInt()
    buf = BigInt()
    c = BigInt()
    Base.GMP.MPZ.set_ui!(p, prime)
    @inbounds for i in 1:length(coeffs_zz)
        cfs_zz_i = coeffs_zz[i]
        for j in 1:length(cfs_zz_i)
            Base.GMP.MPZ.set!(c, cfs_zz_i[j])
            bigint_mod_p!(buf, c, prime, p)
            coeffs_ff[i][j] = CoeffModular(buf)
        end
    end
    ring_ff = PolyRing(ring.nvars, ring.ord, UInt(prime), :zp)
    ring_ff, coeffs_ff
end

function modular_reduce_mod_p!(
    ring::PolyRing,
    basis::Basis{T1},
    prime::T2;
    deepcopy=true
) where {T1 <: CoeffZZ, T2 <: CoeffZp}
    ring_ff, coeffs_ff = modular_reduce_mod_p!(ring, basis.coeffs, prime)
    new_basis = if deepcopy
        basis_deep_copy_with_new_coeffs(basis, coeffs_ff)
    else
        basis_shallow_copy_with_new_coeffs(basis, coeffs_ff)
    end
    ring_ff, new_basis
end

function modular_reduce_mod_p_in_batch!(
    ring::PolyRing,
    basis::Basis{C},
    prime_xn::NTuple{N, T}
) where {C, N, T}
    coeffs_zz = basis.coeffs
    coeffs_ff_xn = [Vector{CompositeNumber{N, T}}(undef, length(c)) for c in coeffs_zz]

    p = BigInt()
    buf = BigInt()
    xn = map(_ -> BigInt(0), 1:N)
    c = BigInt()
    prime_big_xn = map(BigInt, prime_xn)

    @inbounds for i in 1:length(coeffs_zz)
        cfs_zz_i = coeffs_zz[i]
        for j in 1:length(cfs_zz_i)
            for k in 1:N
                Base.GMP.MPZ.set!(xn[k], cfs_zz_i[j])
            end
            data = ntuple(k -> T(bigint_mod_p!(buf, xn[k], UInt(prime_xn[k]), prime_big_xn[k])), N)
            coeffs_ff_xn[i][j] = CompositeNumber{N, T}(data)
        end
    end
    ring_ff_Nx = PolyRing(ring.nvars, ring.ord, CompositeNumber{N, T}(prime_xn), :zp)
    basis_ff_Nx = basis_deep_copy_with_new_coeffs(basis, coeffs_ff_xn)

    ring_ff_Nx, basis_ff_Nx
end

function modular_prepare!(state::ModularState)
    gb_coeffs = state.gb_coeffs_ff_all[1]
    resize!(state.gb_coeffs_zz, length(gb_coeffs))
    resize!(state.gb_coeffs_qq, length(gb_coeffs))
    resize!(state.crt_mask, length(gb_coeffs))
    resize!(state.ratrec_mask, length(gb_coeffs))

    @inbounds for i in 1:length(gb_coeffs)
        state.gb_coeffs_zz[i] = [zero(BigInt) for _ in 1:length(gb_coeffs[i])]
        state.gb_coeffs_qq[i] = [zero(Rational{BigInt}) for _ in 1:length(gb_coeffs[i])]
        state.crt_mask[i] = falses(length(gb_coeffs[i]))
        state.ratrec_mask[i] = falses(length(gb_coeffs[i]))
    end

    nothing
end

###
# Lifting change matrix

function modular_ratrec_full_changematrix!(state::ModularState)
    @inbounds for i in 1:length(state.changematrix_coeffs_zz)
        flag = ratrec_vec_full!(
            state.changematrix_coeffs_qq[i],
            state.changematrix_coeffs_zz[i],
            state.modulo,
            [
                falses(length(state.changematrix_coeffs_qq[i][j])) for
                j in 1:length(state.changematrix_coeffs_qq[i])
            ]
        )
        !flag && return flag
    end
    true
end

function modular_crt_full_changematrix!(state::ModularState)
    if isempty(state.changematrix_coeffs_zz)
        coeffs_ff = state.changematrix_coeffs_ff_all[1]
        resize!(state.changematrix_coeffs_zz, length(coeffs_ff))
        resize!(state.changematrix_coeffs_qq, length(coeffs_ff))
        @inbounds for i in 1:length(coeffs_ff)
            state.changematrix_coeffs_zz[i] = Vector{Vector{BigInt}}(undef, length(coeffs_ff[i]))
            state.changematrix_coeffs_qq[i] =
                Vector{Vector{Rational{BigInt}}}(undef, length(coeffs_ff[i]))
            for j in 1:length(coeffs_ff[i])
                state.changematrix_coeffs_zz[i][j] = [BigInt(0) for _ in 1:length(coeffs_ff[i][j])]
                state.changematrix_coeffs_qq[i][j] =
                    [Rational{BigInt}(1) for _ in 1:length(coeffs_ff[i][j])]
            end
        end
    end

    @inbounds for i in 1:length(state.changematrix_coeffs_zz)
        modulo = BigInt()
        crt_vec_full!(
            state.changematrix_coeffs_zz[i],
            modulo,
            [state.changematrix_coeffs_ff_all[ell][i] for ell in 1:length(state.used_primes)],
            state.used_primes,
            [
                falses(length(state.changematrix_coeffs_ff_all[1][i][j])) for
                j in 1:length(state.changematrix_coeffs_ff_all[1][i])
            ]
        )
    end
end

@timeit _TIMER function modular_lift_changematrix_check!(
    state::ModularState,
    ring::PolyRing,
    input_zz::Basis,
    gb_ff::Basis,
    input_permutation::Vector{Int},
    changematrix_monoms::Vector{Vector{Vector{M}}},
    hashtable::MonomialHashtable{M},
    params::AlgorithmParameters
) where {M <: Monom}
    prime = modular_random_prime(state, params.rng)
    prime_big = BigInt(prime)
    while any(c -> iszero(mod(denominator(c), prime_big)), Iterators.flatten(state.gb_coeffs_qq)) ||
        any(
            c -> iszero(mod(denominator(c), prime_big)),
            Iterators.flatten(Iterators.flatten(state.changematrix_coeffs_qq))
        )
        prime = modular_random_prime(state, params.rng)
        prime_big = BigInt(prime)
    end

    _, input_ff = modular_reduce_mod_p!(ring, input_zz, prime, deepcopy=true)

    @invariant gb_ff.n_nonredundant == length(state.gb_coeffs_qq) == length(changematrix_monoms)
    @invariant length(input_permutation) == input_ff.n_filled
    @invariant length(changematrix_monoms) == length(state.changematrix_coeffs_qq)

    # The input basis is sorted internally, while change-matrix columns refer
    # to the original input order.
    inverse_input_permutation = invperm(input_permutation)
    @inbounds for row_idx in 1:length(changematrix_monoms)
        residual = Dict{MonomId, CoeffModular}()

        gb_idx = gb_ff.nonredundant_indices[row_idx]
        for (monom_id, coeff) in zip(gb_ff.monoms[gb_idx], state.gb_coeffs_qq[row_idx])
            coeff_mod_p = CoeffModular(
                mod(numerator(coeff) * invmod(denominator(coeff), prime_big), prime_big)
            )
            coeff_mod_p = iszero(coeff_mod_p) ? coeff_mod_p : prime - coeff_mod_p
            residual[monom_id] =
                mod(get(residual, monom_id, zero(CoeffModular)) + coeff_mod_p, prime)
            iszero(residual[monom_id]) && delete!(residual, monom_id)
        end

        for column_idx in 1:length(changematrix_monoms[row_idx])
            input_idx = inverse_input_permutation[column_idx]
            matrix_monoms = changematrix_monoms[row_idx][column_idx]
            matrix_coeffs = state.changematrix_coeffs_qq[row_idx][column_idx]
            input_monoms = input_ff.monoms[input_idx]
            input_coeffs = input_ff.coeffs[input_idx]
            hashtable_resize_if_needed!(hashtable, length(matrix_monoms) * length(input_monoms))

            for (matrix_monom, matrix_coeff) in zip(matrix_monoms, matrix_coeffs)
                matrix_coeff_mod_p = CoeffModular(
                    mod(
                        numerator(matrix_coeff) * invmod(denominator(matrix_coeff), prime_big),
                        prime_big
                    )
                )
                for (input_monom_id, input_coeff) in zip(input_monoms, input_coeffs)
                    input_monom = hashtable.monoms[input_monom_id]
                    product = monom_product!(monom_copy(matrix_monom), matrix_monom, input_monom)
                    product_id = hashtable_insert!(hashtable, product)
                    coeff_mod_p = mod(matrix_coeff_mod_p * input_coeff, prime)
                    residual[product_id] =
                        mod(get(residual, product_id, zero(CoeffModular)) + coeff_mod_p, prime)
                    iszero(residual[product_id]) && delete!(residual, product_id)
                end
            end
        end

        !isempty(residual) && return false
    end
    true
end

### 
# Checking modular lifts in modular computation

@timeit _TIMER function modular_lift_check!(
    state::ModularState,
    ring::PolyRing,
    basis_qq::Basis,
    basis_zz::Basis,
    basis_ff::Basis,
    hashtable::MonomialHashtable,
    params::AlgorithmParameters
)
    # First we check the size of the coefficients with a heuristic
    if params.heuristic_check
        if !modular_lift_heuristic_check(state.gb_coeffs_qq, state.modulo)
            return false
        end
    end

    # Then check that a basis is also a basis modulo a prime
    if params.randomized_check
        if !modular_lift_randomized_check!(state, ring, basis_zz, basis_ff, hashtable, params)
            return false
        end
    end

    # Finally we check over the rationals
    if params.certify_check
        return modular_lift_certify_check!(state, ring, basis_qq, basis_ff, hashtable, params)
    end

    true
end

# Heuristic bound on the size of coefficients of the basis.
threshold_in_heuristic_check(num::BigInt, den::BigInt, modsz::Int) =
    1.10 * (Base.GMP.MPZ.sizeinbase(num, 2) + Base.GMP.MPZ.sizeinbase(den, 2)) >= modsz

# Checks that 
#   ln(num) + ln(den) < C ln(modulo)
# for all coefficients of form num/den
@timeit _TIMER function modular_lift_heuristic_check(
    table_qq::Vector{Vector{T}},
    modulo::BigInt
) where {T <: CoeffQQ}
    modsz = Base.GMP.MPZ.sizeinbase(modulo, 2)
    @inbounds for i in 1:length(table_qq)
        for j in 1:length(table_qq[i])
            n = numerator(table_qq[i][j])
            d = denominator(table_qq[i][j])
            threshold_in_heuristic_check(n, d, modsz) && return false
        end
    end
    true
end

@timeit _TIMER function modular_lift_heuristic_check_partial(
    table_qq::Vector{Vector{T}},
    modulo::BigInt,
    witness_set::Vector{Tuple{Int, Int}}
) where {T <: CoeffQQ}
    modsz = Base.GMP.MPZ.sizeinbase(modulo, 2)
    @inbounds for k in 1:length(witness_set)
        i, j = witness_set[k]
        n = numerator(table_qq[i][j])
        d = denominator(table_qq[i][j])
        threshold_in_heuristic_check(n, d, modsz) && return false
    end
    true
end

# !!! note that this function may modify the given hashtable!
@timeit _TIMER function modular_lift_randomized_check!(
    state::ModularState,
    ring::PolyRing,
    input_zz::Basis,
    gb_ff::Basis,
    hashtable::MonomialHashtable,
    params::AlgorithmParameters
)
    checks = 1
    for _ in 1:checks
        prime = modular_random_prime(state, params.rng)
        ring_ff, input_ff = modular_reduce_mod_p!(ring, input_zz, prime, deepcopy=true)
        # TODO: do we really need to re-scale things to be fraction-free?
        gb_coeffs_zz = _clear_denominators!(state.gb_coeffs_qq)
        gb_zz = basis_deep_copy_with_new_coeffs(gb_ff, gb_coeffs_zz)
        ring_ff, gb_ff = modular_reduce_mod_p!(ring, gb_zz, prime, deepcopy=false)
        arithmetic = select_arithmetic(CoeffModular, prime, :auto, false)
        basis_make_monic!(gb_ff, arithmetic, params.changematrix)
        # Check that some polynomial is not reduced to zero
        f4_normalform!(ring_ff, gb_ff, input_ff, hashtable, arithmetic)
        for i in 1:(input_ff.n_processed)
            if !isempty(input_ff.coeffs[i])
                return false
            end
        end
        # Check that the basis is a groebner basis
        pairset = pairset_initialize(typeof(monom_totaldeg(hashtable.monoms[1])))
        # TODO: accessing fields in this way is not very nice.
        gb_ff.n_processed = 0
        gb_ff.n_nonredundant = 0
        params = struct_update(
            AlgorithmParameters,
            params,
            (linalg=LinearAlgebra(:randomized, :sparse), arithmetic=arithmetic)
        )
        if !f4_isgroebner!(ring_ff, gb_ff, pairset, hashtable, params)
            return false
        end
    end
    true
end

@timeit _TIMER function modular_lift_certify_check!(
    state::ModularState,
    ring::PolyRing,
    input_qq::Basis,
    gb_ff::Basis,
    hashtable::MonomialHashtable,
    params::AlgorithmParameters
)
    gb_qq = basis_deep_copy_with_new_coeffs(gb_ff, state.gb_coeffs_qq)
    ring_qq = PolyRing(ring.nvars, ring.ord, 0, :qq)
    input_qq = basis_deepcopy(input_qq)
    # Check that some polynomial is not reduced to zero
    f4_normalform!(ring_qq, gb_qq, input_qq, hashtable, params.arithmetic)
    for i in 1:(input_qq.n_processed)
        if !isempty(input_qq.coeffs[i])
            return false
        end
    end
    # Check that the basis is a groebner basis
    pairset = pairset_initialize(typeof(monom_totaldeg(hashtable.monoms[1])))
    # TODO: accessing fields in this way is not very nice.
    gb_qq.n_processed = 0
    gb_qq.n_nonredundant = 0
    if !f4_isgroebner!(ring_qq, gb_qq, pairset, hashtable, params)
        return false
    end
    true
end

using AbstractAlgebra, Groebner, BenchmarkTools, PrettyTables, Printf, TimerOutputs

include("gizmos.jl")

k = AbstractAlgebra.GF(2^30+3)
system_solving = [
    ("chandra-9", Groebner.Examples.chandran(9, k=k)),
    ("chandra-10", Groebner.Examples.chandran(10, k=k)),
    ("chandra-11", Groebner.Examples.chandran(11, k=k)),
    ("chandra-12", Groebner.Examples.chandran(12, k=k)),
    ("chandra-13", Groebner.Examples.chandran(13, k=k)),
    ("cyclic-7", Groebner.Examples.cyclicn(7, k=k)),
    ("cyclic-8", Groebner.Examples.cyclicn(8, k=k)),
    ("cyclic-9", Groebner.Examples.cyclicn(9, k=k)),
    ("eco-11", Groebner.Examples.econ(11, k=k)),
    ("eco-12", Groebner.Examples.econ(12, k=k)),
    ("eco-13", Groebner.Examples.econ(13, k=k)),
    ("eco-14", Groebner.Examples.econ(14, k=k)),
    ("noon-7", Groebner.Examples.noonn(7, k=k)),
    ("noon-8", Groebner.Examples.noonn(8, k=k)),
    ("noon-9", Groebner.Examples.noonn(9, k=k)),
    ("noon-10", Groebner.Examples.noonn(10, k=k)),
    ("henrion-6", Groebner.Examples.henrion6(k=k)),
    ("henrion-7", Groebner.Examples.henrion7(k=k)),
    ("henrion-8", Groebner.Examples.henrion8(k=k)),
    ("katsura-9", Groebner.Examples.katsuran(9, k=k)),
    ("katsura-10", Groebner.Examples.katsuran(10, k=k)),
    ("katsura-11", Groebner.Examples.katsuran(11, k=k)),
    ("katsura-12", Groebner.Examples.katsuran(12, k=k)),
    ("reimer-6", Groebner.Examples.reimern(6, k=k)),
    ("reimer-7", Groebner.Examples.reimern(7, k=k)),
    ("reimer-8", Groebner.Examples.reimern(8, k=k)),
    ("hexapod", Groebner.Examples.hexapod(k=k)),
]
sian = [
    ("cholera", Groebner.Examples.Cholera(k=k)),
    ("hiv2", Groebner.Examples.HIV2(k=k)),
    ("goodwin", Groebner.Examples.Goodwin_with_weights(k=k)),
    ("crn", Groebner.Examples.ChemicalReactionNetwork(k=k)),

]
other = [
    ("alea6", Groebner.Examples.alea6(k=k)),
    ("jason210", Groebner.Examples.jason210(k=k)),
    ("gametwo2", Groebner.Examples.gametwo2(k=k)),
    ("yang1", Groebner.Examples.yang1(k=k)),
    ("bayes148", Groebner.Examples.bayes148(k=k)),
    ("mayr42", Groebner.Examples.mayr42(k=k))
]
random = sort(reduce(vcat, [
    ("rand-$(n)-$d", randsys(n, d))
    for n in 4:6, d in 4:6
]), by=first)
random = sort(reduce(vcat, [
    ("rand-$(n)-$d", randsys(n, d))
    for n in 8:14, d in 2:2
]), by=first)
systems = vcat(system_solving, sian, other, random)
systems = vcat(random)

println("Running the following systems: ", map(first, systems))

timers = []
for (name, sys) in systems
    @info "Running $name.."
    # t1, t2, t3, t4, t5 = 0, 0, 0, 0, 0
    for t in 1:2
        TimerOutputs.enable_timer!(Groebner._TIMER); 
        reset_timer!(Groebner._TIMER); 
        groebner(sys); 
        if t == 2 show(Groebner._TIMER, allocations=false); println() end
    end
    push!(timers, [name, copy(Groebner._TIMER)])
end

labels = ["Name", "Select Pairs", "Symb Prepr", "Reduction", "Update", "Autoreduce", "IO", "Total"]
data = []
for entry in timers
    name = entry[1]
    timer = entry[2]
    time_select_pairs = TimerOutputs.time(timer["f4!"]["f4_select_critical_pairs!"])
    time_symb_preprc = TimerOutputs.time(timer["f4!"]["f4_symbolic_preprocessing!"])
    time_reduction = TimerOutputs.time(timer["f4!"]["f4_reduction!"])
    time_update = TimerOutputs.time(timer["f4!"]["f4_update!"])
    time_autoreduce = TimerOutputs.time(timer["f4!"]["f4_autoreduce!"])
    time_io = TimerOutputs.time(timer["io_convert_polynomials_to_ir"]) +
              TimerOutputs.time(timer["io_convert_ir_to_polynomials"]) +
              TimerOutputs.time(timer["ir_convert_internal_to_ir"]) +
                TimerOutputs.time(timer["ir_convert_ir_to_internal"])
    time_total = TimerOutputs.tottime(timer)
    push!(data, [name, time_select_pairs, time_symb_preprc, time_reduction, time_update, time_autoreduce, time_io, time_total])
end

matrix = permutedims(reduce(hcat, data))

threshold = 0.15
hl_select = TextHighlighter((v,i,j) -> (total = v[i,end]; j == 2 && v[i,j] isa Number && v[i,j] / total > threshold), crayon"red bold")
hl_symb_prepr = TextHighlighter((v,i,j) -> (total = v[i,end]; j == 3 && v[i,j] isa Number && v[i,j] / total > threshold), crayon"red bold")
hl_update = TextHighlighter((v,i,j) -> (total = v[i,end]; j == 5 && v[i,j] isa Number && v[i,j] / total > threshold), crayon"red bold")
hl_io = TextHighlighter((v,i,j) -> (total = v[i,end]; j == 7 && v[i,j] isa Number && v[i,j] / total > threshold), crayon"bold bg:light_gray")

pretty_table(
    matrix, 
    column_labels=labels,
    title="Timings in seconds",
    formatters=[
        (v,i,j) -> v isa Number ? @sprintf("%.2f", v / 1e9) : v, 
    ],
    row_group_labels = [1 => "System solving", length(system_solving)+1 => "SIAN", length(system_solving)+length(sian)+1 => "Other"],
    highlighters  = [hl_select, hl_symb_prepr, hl_update, hl_io],
    table_format = TextTableFormat(borders = text_table_borders__ascii_rounded),
    summary_row_labels = ["Total"],
    summary_rows = [(data, i) -> i > 1 ? @sprintf("%.2f", sum(data[:, i]) / 1e9) : ""],
    fit_table_in_display_vertically = false,
)

using SmallCollections: FixedVector, SmallVector, fixedvector, sum_fast, dot_fast, bits

struct FixedMonom{N, T}
    ev::FixedVector{N, T}
    deg::T
end

function FixedMonom(ev::FixedVector{N, T}) where {N, T}
    @invariant sum(Int, ev) <= typemax(UInt16)
    d = sum_fast(ev; init=zero(UInt16))
    d > typemax(T) && __throw_monom_overflow_error()
    FixedMonom(ev, d % T)
end

monom_max_vars(a::FixedMonom) = monom_max_vars(typeof(a))

monom_max_vars(::Type{<:FixedMonom{N}}) where {N} = N
monom_totaldeg(a::FixedMonom{N, T}) where {N, T} = a.deg % T
monom_copy(a::FixedMonom) = a

function monom_construct_hash_vector(rng::AbstractRNG, ::Type{<:FixedMonom{N}}, ::Integer) where {N}
    rand(rng, FixedVector{N, MonomHash})
end

function monom_construct_from_vector(::Type{FixedMonom{N, T}}, ev::AbstractVector) where {N, T}
    all(<=(typemax(T)), ev) || __throw_monom_overflow_error()
    FixedMonom(fixedvector(SmallVector{N, T}(ev)))
end

function monom_construct_const(::Type{FixedMonom{N, T}}, ::Integer) where {N, T}
    FixedMonom(zero(FixedVector{N, T}))
end

function monom_hash(a::FixedMonom{N}, b::FixedVector{N}) where {N}
    dot_fast(a.ev, b)::MonomHash
end

function monom_to_vector!(tmp::AbstractVector, a::FixedMonom)
    copyto!(tmp, 1, a.ev, 1, length(tmp))
end

function monom_is_supported_ordering(::Type{<:FixedMonom}, ::Ord) where {Ord}
    Ord <: Union{DegLex{true}, DegRevLex{true}, InputOrdering}
end

function monom_isless(a::FixedMonom{N}, b::FixedMonom{N}, ::DegLex{true}) where {N}
    a.deg < b.deg || (a.deg == b.deg && a.ev < b.ev)
end

function monom_isless(a::FixedMonom{N}, b::FixedMonom{N}, ::DegRevLex{true}) where {N}
    if sizeof(a) <= 64
        a.deg < b.deg || (a.deg == b.deg && bits(a.ev) > bits(b.ev))
    else
        a.deg != b.deg && return a.deg < b.deg
        aev = reinterpret(UInt64, a.ev)
        bev = reinterpret(UInt64, b.ev)
        @inbounds for i in length(aev):-1:1
            aev[i] != bev[i] && return aev[i] > bev[i]
        end
        false
    end
end

function monom_lcm!(_, a::FixedMonom{N}, b::FixedMonom{N}) where {N}
    ev = max.(a.ev, b.ev)
    d = sum_fast(ev)
    d < a.deg && __throw_monom_overflow_error()
    FixedMonom(ev, d)
end

function monom_lcm!(_, a::FixedMonom{8, UInt8}, b::FixedMonom{8, UInt8})
    # conversion to UInt16 to force vectorization
    ev = max.(a.ev .% UInt16, b.ev .% UInt16)
    d = sum_fast(ev) % UInt8
    d < a.deg && __throw_monom_overflow_error()
    FixedMonom(ev .% UInt8, d)
end

function monom_is_gcd_const(a::FixedMonom{N}, b::FixedMonom{N}) where {N}
    iszero(min.(a.ev, b.ev))
end

function monom_product!(_, a::FixedMonom{N}, b::FixedMonom{N}) where {N}
    d = a.deg + b.deg
    d < a.deg && __throw_monom_overflow_error()
    FixedMonom(a.ev + b.ev, d)
end

function monom_division!(_, a::FixedMonom{N}, b::FixedMonom{N}) where {N}
    FixedMonom(a.ev - b.ev, a.deg - b.deg)
end

function monom_is_divisible(a::FixedMonom{N}, b::FixedMonom{N}) where {N}
    all(a.ev .>= b.ev)
end

function monom_is_divisible!(_, a::FixedMonom{N}, b::FixedMonom{N}) where {N}
    ev, s = Base.Checked.sub_with_overflow(a.ev, b.ev)
    isempty(s), FixedMonom(ev, a.deg - b.deg)
end

function monom_is_equal(a::FixedMonom{N}, b::FixedMonom{N}) where {N}
    a.ev == b.ev
end

function monom_create_divmask(
    a::FixedMonom,
    ::Type{Mask},
    ndivvars::Int,
    divmap::Vector{U},
    ndivbits::Int,
    strategy::Symbol
) where {Mask, U}
    @invariant strategy == :first_variables
    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)
    @inbounds for i in 1:ndivvars
        for _ in 1:ndivbits
            if a.ev[i] >= divmap[ctr]
                res |= o << ((ctr - 1) % UInt)
            end
            ctr += o
        end
    end
    res
end

import AbstractAlgebra

function read_MQ_GF(filename)
    @info "Reading MQ problem: $filename"
    polys = []
    apath = (@__DIR__) * "/$filename"
    open(apath, "r") do fio
        line1, line2, line3 = readline(fio), readline(fio), readline(fio)
        ch = parse(Int, line1[(findfirst('(', line1) + 1):(findfirst(')', line1) - 1)])
        nv = parse(Int, line2[(findfirst(':', line2) + 1):end])
        ne = parse(Int, line3[(findfirst(':', line3) + 1):end])

        R, xs = AbstractAlgebra.polynomial_ring(
            AbstractAlgebra.GF(ch),
            nv,
            internal_ordering=:degrevlex
        )
        @debug "Created ring" R xs

        labels = sort!(union([x * y for x in xs for y in xs], xs, [R(1)]), rev=true)

        rest = readlines(fio)
        rest = rest[5:end]

        for (i, s) in enumerate(rest)
            @debug "Reading poly $i/$(length(rest))"
            s = replace(s, " ;" => "")
            poly = sum(map(x -> parse(Int, x), split(s, " ")) .* labels)
            push!(polys, poly)
        end
    end
    @debug "Read" length(polys)
    R = parent(first(polys))
    map(R, polys)
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

module GroebnerDynamicPolynomialsExt

using DynamicPolynomials

if isdefined(Base, :get_extension)
    using Groebner
else
    using ..Groebner
end

###
# Conversion from DynamicPolynomials.jl to intermediate representation and back.

function Groebner.io_convert_polynomials_to_ir(
    polynomials::Vector{<:AbstractPolynomialLike{T}},
    options::Groebner.KeywordArguments
) where {T}
    isempty(polynomials) && throw(DomainError("Empty input."))
    ring = io_extract_ring(polynomials)
    coeffs = io_extract_coeffs(ring, polynomials)
    reversed_order, var_to_index, monoms = io_extract_monoms(ring, polynomials)
    if reversed_order
        for i in 1:length(monoms)
            reverse!(monoms[i])
            reverse!(coeffs[i])
        end
    end
    ring = Groebner.PolyRing(
        ring.nvars,
        Groebner.ordering_transform(ring.ord, var_to_index),
        ring.characteristic
    )
    options.ordering = Groebner.ordering_transform(options.ordering, var_to_index)
    ring, monoms, coeffs, options
end

function Groebner.io_convert_ir_to_polynomials(
    ring::Groebner.PolyRing,
    polynomials::Vector{<:AbstractPolynomialLike{T}},
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    options
) where {M <: Groebner.Monom, C <: Groebner.Coeff, T}
    _io_convert_to_output(ring, polynomials, monoms, coeffs, options)
end

function dp_ordering_sym2typed(ord::Symbol)
    if !(ord in (:lex, :deglex, :degrevlex))
        throw(DomainError("Not a supported ordering."))
    end
    if ord === :lex
        Lex()
    elseif ord === :deglex
        DegLex()
    elseif ord === :degrevlex
        DegRevLex()
    end
end

function dp_ord_to_symbol(ord)
    if ord === MultivariatePolynomials.LexOrder
        :lex
    elseif ord === MultivariatePolynomials.Graded{MultivariatePolynomials.LexOrder}
        :deglex
    elseif ord === MultivariatePolynomials.Graded{
        MultivariatePolynomials.Reverse{MultivariatePolynomials.InverseLexOrder}
    }
        :degrevlex
    else
        throw(
            DomainError(
                ord,
                """This ordering from DynamicPolynomials.jl is not supported by Groebner.jl. 
                Consider opening a Github issue if you need it."""
            )
        )
    end
end

function io_extract_ring(orig_polys::Vector{<:AbstractPolynomialLike{T}}) where {T}
    nv = MultivariatePolynomials.nvariables(orig_polys)
    ord = dp_ord_to_symbol(MultivariatePolynomials.ordering(orig_polys[1]))
    ord_typed = dp_ordering_sym2typed(ord)
    Groebner.PolyRing(nv, ord_typed, UInt(0))
end

function io_extract_coeffs(ring, orig_polys)
    npolys = length(orig_polys)
    coeffs = Vector{Vector{Rational{BigInt}}}(undef, npolys)
    @inbounds for i in 1:npolys
        poly = orig_polys[i]
        coeffs[i] = map(Rational, MultivariatePolynomials.coefficients(poly))
    end
    coeffs
end

function exponents_wrt_vars(t, var2idx)
    exp = zeros(Int, length(var2idx))
    @inbounds for (v, p) in MultivariatePolynomials.powers(t)
        exp[var2idx[v]] = p
    end
    exp
end

multivariate_length(p::MultivariatePolynomials.AbstractMonomialLike) = 1
multivariate_length(p::MultivariatePolynomials.AbstractTermLike) = 1
multivariate_length(p::AbstractPolynomialLike) = MultivariatePolynomials.nterms(p)

function io_extract_monoms(
    ring::Groebner.PolyRing,
    orig_polys::Vector{T}
) where {T <: AbstractPolynomialLike{U}} where {U}
    reversed_order = false
    npolys = length(orig_polys)
    exps = Vector{Vector{Vector{Int}}}(undef, npolys)
    vars = MultivariatePolynomials.variables(orig_polys)
    @assert issorted(vars, rev=true)

    var2idx = Dict(vars[i] => i for i in 1:length(vars))
    for i in 1:npolys
        poly = orig_polys[i]
        exps[i] = Vector{Vector{Int}}(undef, multivariate_length(poly))
        monoms = MultivariatePolynomials.monomials(poly)
        if length(monoms) > 1
            if monoms[1] < monoms[2]
                reversed_order = true
            end
        end
        @inbounds for (j, t) in enumerate(monoms)
            exps[i][j] = exponents_wrt_vars(t, var2idx)
        end
    end
    reversed_order, var2idx, exps
end

function _io_convert_to_output(
    ring::Groebner.PolyRing,
    origpolys::Vector{P},
    gbexps::Vector{Vector{M}},
    gbcoeffs::Vector{Vector{I}},
    params
) where {M <: Groebner.Monom, P <: AbstractPolynomialLike{J}, I <: Groebner.Coeff} where {J}
    origvars = MultivariatePolynomials.variables(origpolys)
    exported = Vector{Any}(undef, length(gbexps))
    tmp = Vector{Int}(undef, length(origvars))
    for i in 1:length(gbexps)
        cfs = Vector{Rational{BigInt}}(undef, length(gbcoeffs[i]))
        for j in 1:length(gbcoeffs[i])
            cfs[j] = gbcoeffs[i][j]
        end
        expvectors = [gbexps[i][j] for j in 1:length(gbexps[i])]
        expvars = map(t -> t[1] * prod(map(^, origvars, t[2])), zip(cfs, expvectors))
        exported[i] = sum(expvars; init=zero(origpolys[1]))
    end
    map(identity, exported)
end

end

using InteractiveUtils, Groebner, Random

function get_native_code(N, MonomT)
    ord = Groebner.DegRevLex()
    ring = Groebner.PolyRing(N, ord, Groebner.CoeffModular(2), :zp)
    rng = Random.default_rng()

    ht = Groebner.hashtable_initialize(ring, rng, MonomT)

    monom_str = string(MonomT)
    monom_name = replace(monom_str, "Groebner." => "", "{" => "_", "}" => "", ", " => "_", " " => "")
    
    func_name = "hashtable_insert"
    filename = "native_$(monom_name)_N$(N)_$(func_name).txt"
    mkpath(joinpath(@__DIR__, "native"))
    filepath = joinpath(@__DIR__, "native", filename)
    
    @info "Generating native code for $monom_name with $N vars to $filepath"
    
    open(filepath, "w") do io
        code_native(
            io,
            Groebner.hashtable_insert!,
            Tuple{
                typeof(ht),
                MonomT
            },
            # debuginfo=:none
        )
    end
end

N = 11

configs = [
    (N, Groebner.PackedTuple2{UInt64, UInt8}),
    (N, Vector{UInt8}),
    (N, Groebner.FixedVector{nextpow(2, N), UInt8}),
    (N, Groebner.FixedMonom{nextpow(2, N), UInt8}),
    (N, Groebner.FixedMonomNoDeg{nextpow(2, N), UInt8}),
    (N, Groebner.NibbleMonom{nextpow(2, N) ÷ 2})
]

for (N, MonomT) in configs
    get_native_code(N, MonomT)
end

using Test, AbstractAlgebra, Groebner

@testset "isgroebner" begin
    R, x = polynomial_ring(GF(2^31 - 1), "x")
    @test Groebner.isgroebner([x])
    @test Groebner.isgroebner([x, x, x, x])
    @test !Groebner.isgroebner([x^2, x^2 + 1])

    R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"], internal_ordering=:degrevlex)

    @test Groebner.isgroebner([R(1)])
    @test Groebner.isgroebner([x])
    @test Groebner.isgroebner([x, y])
    @test Groebner.isgroebner([x, x])
    @test Groebner.isgroebner([x, y, z])

    @test !Groebner.isgroebner([x + y, x])
    @test Groebner.isgroebner([z * x, z * x, R(1)])

    fs = Groebner.Examples.rootn(3, internal_ordering=:degrevlex)
    @test !Groebner.isgroebner(fs)
    @test Groebner.isgroebner(Groebner.groebner(fs))

    fs = Groebner.Examples.rootn(5, internal_ordering=:degrevlex)
    @test !Groebner.isgroebner(fs)
    @test Groebner.isgroebner(Groebner.groebner(fs))
    @test Groebner.isgroebner(Groebner.groebner(fs, reduced=false))

    fs = Groebner.Examples.noonn(2, internal_ordering=:degrevlex)
    @test !Groebner.isgroebner(fs)
    @test Groebner.isgroebner(Groebner.groebner(fs))

    fs = Groebner.Examples.noonn(3, internal_ordering=:degrevlex)
    @test !Groebner.isgroebner(fs)
    @test Groebner.isgroebner(Groebner.groebner(fs))
    @test Groebner.isgroebner(Groebner.groebner(fs, reduced=false))

    fs = Groebner.Examples.noonn(6, internal_ordering=:degrevlex)
    @test !Groebner.isgroebner(fs)
    @test Groebner.isgroebner(Groebner.groebner(fs))
end

@testset "isgroebner orderings" begin
    R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"])

    @test Groebner.isgroebner([x^2 + y, y])
    @test Groebner.isgroebner([x^2 + y, y], ordering=Groebner.Lex(x, y, z))
    @test !Groebner.isgroebner([x^2 + y, y], ordering=Groebner.Lex(y, x, z))

    @test Groebner.isgroebner([x^2 + y, y], ordering=Groebner.DegLex())
    @test Groebner.isgroebner([x^2 + y, y], ordering=Groebner.DegLex(y, x, z))
end

@testset "isgroebner certify" begin
    for certify in [false, true]
        for field in [GF(17), GF(2^31 - 1), QQ]
            R, (x, y, z) = polynomial_ring(field, ["x", "y", "z"], internal_ordering=:degrevlex)

            @test Groebner.isgroebner([R(0)], certify=certify)
            @test Groebner.isgroebner([R(1)], certify=certify)
            @test Groebner.isgroebner([x], certify=certify)
            @test Groebner.isgroebner([x, y], certify=certify)
            @test Groebner.isgroebner([x, x], certify=certify)
            @test Groebner.isgroebner([x, y, z], certify=certify)

            @test !Groebner.isgroebner([x + y, x], certify=certify)
            @test Groebner.isgroebner([z * x, z * x, R(1)], certify=certify)
        end
        fs = Groebner.Examples.rootn(3, k=GF(2^31 - 1), internal_ordering=:degrevlex)
        @test !Groebner.isgroebner(fs, certify=certify)
        @test Groebner.isgroebner(Groebner.groebner(fs), certify=certify)

        fs = Groebner.Examples.rootn(3, k=QQ, internal_ordering=:degrevlex)
        @test !Groebner.isgroebner(fs, certify=certify)
        @test Groebner.isgroebner(Groebner.groebner(fs), certify=certify)

        fs = Groebner.Examples.noonn(2, k=GF(2^31 - 1), internal_ordering=:degrevlex)
        @test !Groebner.isgroebner(fs, certify=certify)
        @test Groebner.isgroebner(Groebner.groebner(fs), certify=certify)

        fs = Groebner.Examples.noonn(2, internal_ordering=:degrevlex)
        @test !Groebner.isgroebner(fs, certify=certify)
        @test Groebner.isgroebner(Groebner.groebner(fs), certify=certify)

        fs = Groebner.Examples.noonn(6, k=GF(2^31 - 1), internal_ordering=:degrevlex)
        @test !Groebner.isgroebner(fs, certify=certify)
        @test Groebner.isgroebner(Groebner.groebner(fs), certify=certify)
    end
end

using AbstractAlgebra, Groebner, BenchmarkTools, PrettyTables, Printf, TimerOutputs

include("gizmos.jl")

k = AbstractAlgebra.GF(2^30+3)

N, D = 6, 6
random = [
    ("rand-$(n)-$d", randsys(n, d))
    for n in 1:N, d in 1:D
]

systems = vcat(random)

println("Running the following systems: ", map(first, systems))

timers = []
for (name, sys) in systems
    @info "Running $name.."
    for t in 1:2
        TimerOutputs.enable_timer!(Groebner._TIMER); 
        reset_timer!(Groebner._TIMER); 
        groebner(sys); 
        if t == 2 show(Groebner._TIMER, allocations=false); println() end
    end
    push!(timers, [name, copy(Groebner._TIMER)])
end

data = Matrix{Any}(undef, N, D)
for i in 1:N, j in 1:D
    name = "rand-$(i)-$j"
    timer = timers[findfirst(t -> t[1] == name, timers)][2]
    time = TimerOutputs.tottime(timer)
    data[i, j] = time
end

pretty_table(
    data,
    column_labels = ["d=$j" for j in 1:D],
    row_labels = ["n=$i" for i in 1:N],
    alignment = :l,
    formatters=[
        (v,i,j) -> v isa Number ? @sprintf("%.2f", v / 1e9) : v, 
    ],
    title = "Time (s) for random systems over $k",
)

using Test, Primes, Groebner

@testset "arithmetic in Zp" begin
    a = Groebner.select_arithmetic(UInt32, 2^31 - 1, :auto, false)
    @test a isa Groebner.SpecializedArithmeticZp{UInt64, UInt32}
    a = Groebner.select_arithmetic(UInt64, 2^31 - 1, :auto, true)
    @test a isa Groebner.SpecializedArithmeticZp{UInt64, UInt64}

    a = Groebner.select_arithmetic(UInt32, Primes.prevprime(2^27 - 1), :auto, false)
    @test a isa Groebner.DelayedArithmeticZp{UInt64, UInt32}
    a = Groebner.select_arithmetic(UInt64, Primes.prevprime(2^27 - 1), :auto, true)
    @test a isa Groebner.DelayedArithmeticZp{UInt64, UInt64}
    a = Groebner.select_arithmetic(UInt64, Primes.prevprime(2^28 - 1), :auto, true)
    @test a isa Groebner.SpecializedArithmeticZp{UInt64, UInt64}
    a = Groebner.select_arithmetic(UInt32, Primes.prevprime(2^28 - 1), :auto, false)
    @test a isa Groebner.SpecializedArithmeticZp{UInt64, UInt32}

    m = UInt64(2^30 + 3)
    a = Groebner.DelayedArithmeticZp(UInt64, UInt64, m)
    @test Groebner.n_spare_bits(a) == 1
    @test Groebner.n_safe_consecutive_additions(a) == 2
    @test Groebner.mod_p(UInt64(2^30 + 6), a) === UInt64(3)

    m = UInt64(2^27 + 29)
    a = Groebner.DelayedArithmeticZp(UInt64, UInt32, UInt32(m))
    @test Groebner.n_spare_bits(a) == 4
    @test Groebner.n_safe_consecutive_additions(a) == 2^7

    m = UInt16(61)
    a = Groebner.DelayedArithmeticZp(UInt16, UInt16, m)
    @test Groebner.n_spare_bits(a) == 2
    @test Groebner.n_safe_consecutive_additions(a) == 8

    for (A, C) in [(UInt64, UInt32), (UInt32, UInt16), (UInt16, UInt8)]
        modulo = Primes.prevprime(typemax(C) >> 2)
        for arithmetic in [
            Groebner.ArithmeticZp(A, C, modulo),
            Groebner.DelayedArithmeticZp(A, C, modulo),
            Groebner.SignedArithmeticZp(signed(A), signed(C), signed(modulo)),
            Groebner.SpecializedArithmeticZp(A, C, modulo)
        ]
            for _ in 1:1000
                T = typeof(Groebner.divisor(arithmetic))
                x = abs(rand(T))
                @test Groebner.mod_p(T(x), arithmetic) == Base.mod(x, T(modulo))
                if gcd(modulo, T(x)) == 1
                    @test Groebner.inv_mod_p(T(x), arithmetic) == Base.invmod(T(x), T(modulo))
                end
            end
        end
    end
end

@testset "arithmetic in Zp x 4" begin
    m = (Primes.nextprimes(2^30 + 3, 4)...,)
    i32_4x = Groebner.CompositeNumber{4, Int32}
    i64_4x = Groebner.CompositeNumber{4, Int64}
    m_4x = i32_4x(m)
    arithmetic = Groebner.SignedCompositeArithmeticZp(i64_4x, i32_4x, m_4x)

    for _ in 1:1000
        T = Int64
        x = ntuple(_ -> rand(T), 4)
        @test Groebner.mod_p(i64_4x(x), arithmetic).data == Base.mod.(x, m)
        if all(==(1), gcd.(m, x))
            @test Groebner.inv_mod_p(i64_4x(x), arithmetic).data == Base.invmod.(x, m)
        end
    end
end

using DynamicPolynomials, Test, Groebner

@testset "DynamicPolynomials.jl input-output" begin
    @polyvar x y

    fs = [zero(x)]
    @test Groebner.groebner(fs) == [zero(x)]

    fs = [zero(x), zero(x), zero(x)]
    @test Groebner.groebner(fs) == [zero(x)]

    fs = [zero(x), 3 * one(x), zero(x)]
    @test Groebner.groebner(fs) == [one(x)]

    fs = [2x + 3, 4y + 5]
    @test Groebner.groebner(fs) == [y + 5 // 4, x + 3 // 2]

    fs = [UInt16(2)x + UInt16(3), UInt16(2)y]
    @test Groebner.groebner(fs) == [y, x + 3 // 2]

    fs = [BigInt(1)x + BigInt(20), y]
    @test Groebner.groebner(fs) == [y, x + 20]

    fs = [x + BigInt(20) // BigInt(3), 4y + 5]
    @test Groebner.groebner(fs) == [y + 5 // 4, x + BigInt(20) // BigInt(3)]

    fs = [BigInt(34343343433)x * y^2 + 3431234567833, 3434343434x * y - 342343242342]
    @test Groebner.isgroebner(Groebner.groebner(fs))
    @test all(iszero, Groebner.normalform(Groebner.groebner(fs), fs))

    @polyvar x1 x2 x3
    noon3 = [
        10 * x1 * x2^2 + 10 * x1 * x3^2 - 11 * x1 + 10
        10 * x1^2 * x2 + 10 * x2 * x3^2 - 11 * x2 + 10
        10 * x1^2 * x3 + 10 * x2^2 * x3 - 11 * x3 + 10
    ]
    @test Groebner.groebner(noon3) == [
        x1 * x2^2 + x1 * x3^2 - 11 // 10 * x1 + 1,
        x1^2 * x3 + x2^2 * x3 - 11 // 10 * x3 + 1,
        x1^2 * x2 + x2 * x3^2 - 11 // 10 * x2 + 1,
        x2^2 * x3^2 + 11 // 20 * x1^2 - 11 // 20 * x2^2 - 11 // 20 * x3^2 - 1 // 2 * x1 +
        1 // 2 * x2 +
        1 // 2 * x3,
        x2^3 * x3 - x2 * x3^3 + x2 - x3,
        x2^4 - x3^4 - 20 // 11 * x1 * x3^2 - 10 // 11 * x2^3 + 10 // 11 * x2^2 * x3 -
        10 // 11 * x2 * x3^2 + 10 // 11 * x3^3 - 11 // 10 * x2^2 +
        11 // 10 * x3^2 +
        x1 +
        x2 - x3 - 10 // 11,
        x1^4 - x3^4 - 10 // 11 * x1^3 - 10 // 11 * x1 * x3^2 - 10 // 11 * x2^2 * x3 -
        20 // 11 * x2 * x3^2 + 10 // 11 * x3^3 - 11 // 10 * x1^2 +
        11 // 10 * x3^2 +
        x1 +
        x2 - 20 // 11,
        x3^5 + 20 // 11 * x1 * x3^3 + 20 // 11 * x2 * x3^3 - 10 // 11 * x3^4 - 33 // 20 * x3^3 +
        1 // 2 * x1^2 - 3 // 2 * x1 * x3 + 1 // 2 * x2^2 - 3 // 2 * x2 * x3 + x3^2 - 5 // 11 * x1 -
        5 // 11 * x2 + 6331 // 2200 * x3 - 11 // 20,
        x2 * x3^4 - 11 // 20 * x2^3 - 11 // 10 * x2 * x3^2 - 1 // 2 * x1 * x2 + 1 // 2 * x2^2 -
        1 // 2 * x2 * x3 +
        x3^2 +
        121 // 200 * x2 - 11 // 20,
        x1 * x3^4 - 11 // 20 * x1^3 - 11 // 10 * x1 * x3^2 + 1 // 2 * x1^2 - 1 // 2 * x1 * x2 -
        1 // 2 * x1 * x3 +
        x3^2 +
        121 // 200 * x1 - 11 // 20,
        x1 * x2 * x3^3 - 11 // 20 * x1 * x2 * x3 - 1 // 2 * x1 * x2 +
        1 // 2 * x1 * x3 +
        1 // 2 * x2 * x3
    ]

    # Test for different Groebner.jl orderings
    @polyvar x
    for gb_ord in [
        Groebner.Lex(),
        Groebner.DegLex(),
        Groebner.DegRevLex(),
        Groebner.Lex(x),
        Groebner.DegRevLex(x)
    ]
        gb = Groebner.groebner([x^2 + 1], ordering=gb_ord)
        @test gb == [x^2 + 1]
    end

    @polyvar x y
    fs = [x^2 + 3, y - 1]
    gb = Groebner.groebner(fs)
    for case in [
        (gb_ord=Groebner.Lex(), result=[y - 1, x^2 + 3]),
        (gb_ord=Groebner.DegLex(y, x), result=[y - 1, x^2 + 3]),
        (gb_ord=Groebner.DegRevLex(y, x), result=[y - 1, x^2 + 3]),
        (gb_ord=Groebner.Lex(x, y), result=[y - 1, x^2 + 3]),
        (gb_ord=Groebner.Lex(y, x), result=[x^2 + 3, y - 1])
    ]
        gb_ord = case.gb_ord
        result = case.result
        gb = Groebner.groebner(fs, ordering=gb_ord)
        @test gb == result
    end

    @polyvar x y z
    Groebner.groebner([x, y, z^2], ordering=Groebner.Lex(x, y, z)) == [z^2, y, x]
    Groebner.groebner([x, y, z^2], ordering=Groebner.Lex(y, x, z)) == [z^2, x, y]
    Groebner.groebner([x, y, z^2], ordering=Groebner.Lex(z, x, y)) == [y, x, z^2]

    # Test for different DynamicPolynomials.jl orderings
    @polyvar x y monomial_order = LexOrder
    F = [2x^2 * y + 3x, 4x * y^2 + 5y^3]
    gb = Groebner.groebner(F, ordering=Groebner.DegLex())
    @test gb == [(5 // 4) * x * y + x^2, y^3 + (24 // 25) * x, (-6 // 5) * x + x * y^2]
    gb = Groebner.groebner(F, ordering=Groebner.DegRevLex())
    @test gb == [(5 // 4) * x * y + x^2, y^3 + (24 // 25) * x, (-6 // 5) * x + x * y^2]
    gb = Groebner.groebner(F, ordering=Groebner.Lex())
    @test gb == [(-6 // 5) * y^3 + y^5, (25 // 24) * y^3 + x]
    gb = Groebner.groebner(F, ordering=Groebner.Lex(y, x))
    @test gb == [(-15 // 8) * x + x^3, x * y + (4 // 5) * x^2, (24 // 25) * x + y^3]

    # It is possible to over-specify the ordering
    @polyvar x y z
    @test groebner([x, y], ordering=Lex(x, y, z)) == [y, x]
    @test groebner([x, y], ordering=Lex(y, x, z)) == [x, y]

    @polyvar x y monomial_order = Graded{Reverse{InverseLexOrder}}
    F = [2x^2 * y + 3x, 4x * y^2 + 5y^3]
    gb = Groebner.groebner(F)
    @test gb == [(5 // 4) * x * y + x^2, y^3 + (24 // 25) * x, (-6 // 5) * x + x * y^2]
    gb = Groebner.groebner(F, ordering=Groebner.Lex())
    @test gb == [(-6 // 5) * y^3 + y^5, (25 // 24) * y^3 + x]

    for dp_ord in [LexOrder, Graded{LexOrder}, Graded{Reverse{InverseLexOrder}}]
        @polyvar x y monomial_order = dp_ord
        F = [2x^2 * y + 3x, 4x * y^2 + 5y^3]
        for gb_ord in [
            Groebner.Lex(),
            Groebner.DegLex(),
            Groebner.DegRevLex(),
            Groebner.Lex(x, y),
            Groebner.Lex(y, x)
        ]
            gb = Groebner.groebner(F, ordering=gb_ord)
            @test Groebner.isgroebner(gb, ordering=gb_ord)
        end
    end

    @polyvar x y monomial_order = InverseLexOrder
    F = [2x^2 * y + 3x, 4x * y^2 + 5y^3]
    @test_throws DomainError Groebner.groebner(F)
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# High level

function linalg_deterministic_sparse_changematrix!(
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    arithmetic::AbstractArithmetic
)
    sort_matrix_upper_rows!(matrix) # for the AB part
    sort_matrix_lower_rows!(matrix) # for the CD part

    matrix_changematrix_initialize!(matrix, matrix.nrows_filled_lower)

    # Reduce CD with AB
    linalg_reduce_matrix_lower_part_changematrix!(matrix, basis, arithmetic)
    # Interreduce CD
    linalg_interreduce_matrix_pivots_changematrix!(matrix, basis, arithmetic)
    true
end

function linalg_deterministic_sparse_interreduction_changematrix!(
    matrix::MacaulayMatrix,
    basis::Basis{C},
    arithmetic::AbstractArithmetic
) where {C}
    sort_matrix_upper_rows!(matrix)

    matrix_changematrix_initialize!(matrix, matrix.nrows_filled_upper)
    for i in 1:(matrix.nrows_filled_upper)
        poly_id = matrix.upper_to_coeffs[i]
        mult_id = matrix.upper_to_mult[i]
        matrix.changematrix[i] = Dict{Tuple{Int, MonomId}, C}((poly_id, mult_id) => one(C))
    end

    # Prepare the matrix
    linalg_prepare_matrix_pivots_in_interreduction!(matrix, basis)
    # Interreduce AB
    linalg_interreduce_matrix_pivots_changematrix!(matrix, basis, arithmetic, left_to_right=true)
    true
end

###
# Low level

function linalg_reduce_matrix_lower_part_changematrix!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType, CoeffType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    nleft, _ = matrix_ncols_filled(matrix)
    nup, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_idx_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, nlow)
    changematrix = matrix.changematrix

    # Allocate the buffers
    reducer_rows = Vector{Tuple{Int, CoeffType}}()
    row = zeros(AccumType, ncols)
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)

    @inbounds for i in 1:nlow
        sparse_row_support = matrix.lower_rows[i]
        sparse_row_coeffs = basis.coeffs[row_idx_to_coeffs[i]]

        linalg_load_sparse_row!(row, sparse_row_support, sparse_row_coeffs)

        # Additionally record the indices of rows that participated in reduction
        # of the given row
        empty!(reducer_rows)
        first_nnz_column = sparse_row_support[1]
        zeroed = linalg_reduce_dense_row_by_pivots_sparse_changematrix!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            first_nnz_column,
            ncols,
            arithmetic,
            reducer_rows
        )

        # if fully reduced
        zeroed && continue

        # NOTE: we are not recording reducers from the lower part of the matrix
        cm = changematrix[i]
        cm[(row_idx_to_coeffs[i], matrix.lower_to_mult[i])] = one(CoeffType)
        for (idx, quo) in reducer_rows
            if idx <= nleft
                poly_idx, poly_mult = matrix.upper_to_coeffs[idx], matrix.upper_to_mult[idx]
                if !haskey(cm, (poly_idx, poly_mult))
                    cm[(poly_idx, poly_mult)] = zero(CoeffType)
                end
                cm[(poly_idx, poly_mult)] =
                    mod_p(cm[(poly_idx, poly_mult)] + AccumType(quo), arithmetic)
            else
                row_idx = matrix.lower_to_coeffs[idx]
                for ((poly_idx, poly_mult), cf) in changematrix[row_idx]
                    if !haskey(cm, (poly_idx, poly_mult))
                        cm[(poly_idx, poly_mult)] = zero(CoeffType)
                    end
                    cm[(poly_idx, poly_mult)] =
                        mod_p(cm[(poly_idx, poly_mult)] + quo * AccumType(cf), arithmetic)
                end
            end
        end

        @invariant length(new_sparse_row_support) == length(new_sparse_row_coeffs)
        _, pinv = linalg_row_make_monic!(new_sparse_row_coeffs, arithmetic)

        cm2 = empty(cm)
        for ((poly_idx, quo_idx), quo_cf) in cm
            cm2[(poly_idx, quo_idx)] = mod_p(AccumType(pinv) * quo_cf, arithmetic)
        end
        changematrix[i] = cm2

        matrix.some_coeffs[i] = new_sparse_row_coeffs
        pivots[new_sparse_row_support[1]] = new_sparse_row_support
        matrix.lower_to_coeffs[new_sparse_row_support[1]] = i

        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
    end

    true
end

function linalg_interreduce_matrix_pivots_changematrix!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType, CoeffType};
    left_to_right::Bool=false
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    nleft, nright = matrix_ncols_filled(matrix)

    # Prepare the matrix
    resize!(matrix.lower_rows, nright)
    pivots = matrix.pivots
    new_pivots = 0
    any_zeroed = false
    changematrix = matrix.changematrix
    compact_changematrix = similar(changematrix)

    # Allocate the buffers
    reducer_rows = Vector{Tuple{Int, CoeffType}}()
    row = zeros(AccumType, ncols)
    # Indices of rows that did no reduce to zero
    not_reduced_to_zero = Vector{Int}(undef, nright)

    column_indices = left_to_right ? ((nleft + 1):ncols) : (ncols:-1:(nleft + 1))
    @inbounds for abs_column_idx in column_indices
        # Check if there is a row that starts at `abs_column_idx`
        !isassigned(pivots, abs_column_idx) && continue

        # Locate the row support and coefficients
        sparse_row_support = pivots[abs_column_idx]
        if abs_column_idx <= nleft
            # upper part of matrix
            sparse_row_coeffs = basis.coeffs[matrix.upper_to_coeffs[abs_column_idx]]
        else
            # lower part of matrix
            sparse_row_coeffs = matrix.some_coeffs[matrix.lower_to_coeffs[abs_column_idx]]
        end
        @invariant length(sparse_row_support) == length(sparse_row_coeffs)

        # Load the row into a dense array
        linalg_load_sparse_row!(row, sparse_row_support, sparse_row_coeffs)

        empty!(reducer_rows)
        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
        first_nnz_column = sparse_row_support[1]
        zeroed = linalg_reduce_dense_row_by_pivots_sparse_changematrix!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            first_nnz_column,
            ncols,
            arithmetic,
            ignore_column=first_nnz_column,
            reducer_rows
        )

        # If the row reduced to zero
        if zeroed
            any_zeroed = true
            continue
        end

        current_row_idx = matrix.lower_to_coeffs[abs_column_idx]
        cm = changematrix[current_row_idx]
        for (idx, quo) in reducer_rows
            if idx <= nleft
                @assert false
                poly_idx, poly_mult = matrix.upper_to_coeffs[idx], matrix.upper_to_mult[idx]
                cm[(poly_idx, poly_mult)] = quo
            else
                row_idx = matrix.lower_to_coeffs[idx]
                for ((poly_idx, poly_mult), cf) in changematrix[row_idx]
                    if !haskey(cm, (poly_idx, poly_mult))
                        cm[(poly_idx, poly_mult)] = zero(CoeffType)
                    end
                    cm[(poly_idx, poly_mult)] =
                        mod_p(cm[(poly_idx, poly_mult)] + quo * convert(AccumType, cf), arithmetic)
                end
            end
        end

        new_pivots += 1
        not_reduced_to_zero[new_pivots] =
            left_to_right ? (abs_column_idx - nleft) : (ncols - abs_column_idx + 1)

        # Update the row support and coefficients.
        compact_changematrix[new_pivots] = cm
        matrix.lower_rows[new_pivots] = new_sparse_row_support
        matrix.some_coeffs[matrix.lower_to_coeffs[abs_column_idx]] = new_sparse_row_coeffs
        pivots[abs_column_idx] = matrix.lower_rows[new_pivots]
    end

    matrix.npivots = new_pivots
    matrix.changematrix = compact_changematrix
    resize!(matrix.changematrix, new_pivots)
    resize!(matrix.lower_rows, new_pivots)
    resize!(not_reduced_to_zero, new_pivots)

    true, any_zeroed, not_reduced_to_zero
end

function linalg_reduce_dense_row_by_pivots_sparse_changematrix!(
    new_sparse_row_support::Vector{I},
    new_sparse_row_coeffs::Vector{C},
    row::Vector{A},
    matrix::MacaulayMatrix{C},
    basis::Basis{C},
    pivots::Vector{Vector{I}},
    start_column::Integer,
    end_column::Integer,
    arithmetic::AbstractArithmeticZp{A, C},
    active_reducers;
    ignore_column::Integer=-1
) where {I, C <: Union{CoeffZp, CompositeCoeffZp}, A <: Union{CoeffZp, CompositeCoeffZp}}
    _, ncols = size(matrix)
    nleft, _ = matrix_ncols_filled(matrix)

    n_nonzeros = 0
    new_pivot_column = -1

    @inbounds for i in start_column:end_column
        # if the element is zero -- no reduction is needed
        if iszero(row[i])
            continue
        end

        # if there is no pivot with the leading column equal to i
        if !isassigned(pivots, i) || ignore_column == i
            if new_pivot_column == -1
                new_pivot_column = i
            end
            n_nonzeros += 1
            continue
        end
        # At this point, we have determined that pivots[i] is a valid pivot.

        # Locate the support and the coefficients of the pivot row
        pivot_support = pivots[i]
        if i <= nleft
            # if pivot comes from the original pivots
            pivot_coeffs = basis.coeffs[matrix.upper_to_coeffs[i]]
        else
            pivot_coeffs = matrix.some_coeffs[matrix.lower_to_coeffs[i]]
        end
        @invariant length(pivot_support) == length(pivot_coeffs)

        mul = linalg_vector_addmul_sparsedense_mod_p!(row, pivot_support, pivot_coeffs, arithmetic)

        push!(active_reducers, (i, mul))

        @invariant iszero(row[i])
    end

    # all row elements reduced to zero!
    if n_nonzeros == 0
        return true
    end

    # form the resulting row in sparse format
    resize!(new_sparse_row_support, n_nonzeros)
    resize!(new_sparse_row_coeffs, n_nonzeros)
    linalg_extract_sparse_row!(
        new_sparse_row_support,
        new_sparse_row_coeffs,
        row,
        convert(Int, start_column),
        ncols
    )

    false
end

using Pkg
Pkg.activate(@__DIR__)
Pkg.instantiate()
Pkg.status()

Pkg.add(url="https://github.com/sumiya11/Groebner.jl")

id = ARGS[1]

include("../common.jl")
include("../run_benchmarks.jl")

dump_results((@__DIR__) * "/results_$id", "master")

using Groebner, Nemo

function to_msolve(sys)
  s = ""
  s = s*join(map(string, gens(parent(sys[1]))), ",")*"\n"
  s = s*string(characteristic(parent(sys[1])))*"\n"
  s = s*join(map(string, sys), ",\n")
  s
end

systems = [
  ("cyclic7_zp.txt", Groebner.Examples.cyclicn(7,k=GF(2^30+3))),
  ("cyclic7_qq.txt", Groebner.Examples.cyclicn(7))
]

for (name, sys) in systems
  sys = to_msolve(sys)
  io = open(joinpath(@__DIR__, name), "w")
  println(io, sys)
  close(io)
end

import AbstractAlgebra

include((@__DIR__) * "/parser.jl")

function load_MQ_problem(name)
    sys = read_MQ_GF(name)
    @assert AbstractAlgebra.internal_ordering(AbstractAlgebra.parent(sys[1])) == :degrevlex
    sys
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

### 
# Backends for `groebner_learn` & `groebner_apply!`

###
# Learn stage

# polynomials => polynomials
function groebner_learn0(polynomials::AbstractVector, options::KeywordArguments)
    isempty(polynomials) && throw(DomainError("Empty input."))
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    trace, gb_monoms, gb_coeffs = _groebner_learn1(ring, monoms, coeffs, options)
    result = io_convert_ir_to_polynomials(ring, polynomials, gb_monoms, gb_coeffs, options)
    trace, result
end

# (exponent vectors, coefficients) => (exponent vectors, coefficients)
function groebner_learn1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    _groebner_learn1(ring, monoms, coeffs, options)
end

function _groebner_learn1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    try
        params = AlgorithmParameters(ring, options)
        return __groebner_learn1(ring, monoms, coeffs, params)
    catch err
        if isa(err, MonomialDegreeOverflow)
            _info_possible_overflow()
            params = AlgorithmParameters(ring, options; hint=:large_exponents)
            return __groebner_learn1(ring, monoms, coeffs, params)
        else
            # Something bad happened.
            rethrow(err)
        end
    end
end

function __groebner_learn1(
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {I <: Integer, C <: Coeff}
    @invariant ir_is_valid(ring, monoms, coeffs)
    term_sorting_permutations, ring2, monoms2, coeffs2 =
        ir_convert_ir_to_internal(ring, monoms, coeffs, params)
    trace, gb_monoms2, gb_coeffs2 = groebner_learn2(ring2, monoms2, coeffs2, params)
    gb_monoms, gb_coeffs = ir_convert_internal_to_ir(ring2, gb_monoms2, gb_coeffs2, params)

    trace.representation = params.representation
    trace.term_sorting_permutations = term_sorting_permutations

    wrapped_trace = WrappedTrace(monoms, gb_monoms, params.target_ord)
    wrapped_trace_save!(wrapped_trace, trace)

    wrapped_trace, gb_monoms, gb_coeffs
end

# internal structs => internal structs
function groebner_learn2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    _monoms = filter(!isempty, monoms)
    _coeffs = filter(!isempty, coeffs)
    if isempty(_monoms)
        return trace_initialize_empty(ring, monoms, coeffs, params), [monoms[1]], [coeffs[1]]
    end
    monoms, coeffs = _monoms, _coeffs

    if params.homogenize
        term_homogenizing_permutation, ring, monoms, coeffs, params =
            homogenize_generators(ring, monoms, coeffs, params)
    end

    trace, gb_monoms, gb_coeffs = _groebner_learn2(ring, monoms, coeffs, params)

    if params.homogenize
        ring, gb_monoms, gb_coeffs, params =
            dehomogenize_generators(ring, gb_monoms, gb_coeffs, params)
        if params.reduced
            gb_monoms, gb_coeffs = autoreduce2(ring, gb_monoms, gb_coeffs, params)
        end
        trace.term_homogenizing_permutations = term_homogenizing_permutation
    end

    trace, gb_monoms, gb_coeffs
end

function _groebner_learn2(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters
) where {M <: Monom, C <: Coeff}
    trace, basis, pairset, hashtable =
        f4_initialize_structs_with_trace(ring, monoms, coeffs, params)
    f4_learn!(trace, pairset, params)
    gb_monoms, gb_coeffs = basis_export_data(trace.gb_basis, trace.hashtable)
    trace, gb_monoms, gb_coeffs
end

###
# Apply stage

# polynomials => polynomials
function groebner_apply0!(
    wrapped_trace::WrappedTrace,
    polynomials::AbstractVector,
    options::KeywordArguments
)
    ring, monoms, coeffs, options = io_convert_polynomials_to_ir(polynomials, options)
    flag, gb_coeffs = __groebner_apply1!(wrapped_trace, ring, monoms, coeffs, options)
    !flag && return (flag, polynomials)
    result = io_convert_ir_to_polynomials(
        ring,
        polynomials,
        wrapped_trace.gb_support,
        gb_coeffs,
        options
    )
    flag, result
end

# batch of polynomials => batch of polynomials
function groebner_apply_batch0!(
    wrapped_trace::WrappedTrace,
    batch::NTuple{N, T},
    options::KeywordArguments
) where {N, T}
    ir_batch = map(f -> io_convert_polynomials_to_ir(f, deepcopy(options)), batch)
    options = ir_batch[1][end]
    ir_batch = map(f -> f[1:3], ir_batch)
    flag, gb_batch = _groebner_apply_batch1!(wrapped_trace, ir_batch, options)
    !flag && return (flag, batch)
    result_ir = map(
        i -> io_convert_ir_to_polynomials(
            ir_batch[i][1],
            batch[i],
            wrapped_trace.gb_support,
            gb_batch[i],
            options
        ),
        1:length(gb_batch)
    )
    flag, result_ir
end

# (exponent vectors, coefficients) => (exponent vectors, coefficients)
function groebner_apply1!(
    wrapped_trace::WrappedTrace,
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    ring, monoms, coeffs = ir_ensure_valid(ring, monoms, coeffs)
    __groebner_apply1!(wrapped_trace, ring, monoms, coeffs, options)
end

# batch of (exponent vectors, coefficients) 
# => 
# batch of (exponent vectors, coefficients)
function groebner_apply_batch1!(
    wrapped_trace::WrappedTrace,
    batch::NTuple{N, T},
    options::KeywordArguments
) where {N, T}
    batch = map(x -> ir_ensure_valid(x...), batch)
    _groebner_apply_batch1!(wrapped_trace, batch, options)
end

function _groebner_apply_batch1!(
    wrapped_trace::WrappedTrace,
    batch::NTuple{N, T},
    options::KeywordArguments
) where {N, T}
    flag, ring, monoms, coeffs = ir_pack_coeffs(batch)
    !flag && return flag, map(el -> el[2:end], batch)
    flag, gb_coeffs = __groebner_apply1!(wrapped_trace, ring, monoms, coeffs, options)
    !flag && return flag, map(el -> el[2:end], batch)
    unpacked = ir_unpack_composite_coefficients(gb_coeffs)
    true, unpacked
end

function __groebner_apply1!(
    wrapped_trace::WrappedTrace,
    ring::PolyRing,
    monoms::Vector{Vector{Vector{I}}},
    coeffs::Vector{Vector{C}},
    options::KeywordArguments
) where {I <: Integer, C <: Coeff}
    if options.ordering === InputOrdering() || options.ordering === nothing
        options.ordering = wrapped_trace.target_ord
    end
    if options.homogenize === :auto
        options.homogenize =
            first(values(wrapped_trace.recorded_traces)).params.homogenize ? :yes : :no
    end

    params = AlgorithmParameters(ring, options)
    ring = PolyRing(ring.nvars, params.target_ord, ring.characteristic, ring.ground)

    if params.homogenize
        new_ord = extend_ordering_in_homogenization(ring.nvars, ring.ord)
        ring = PolyRing(ring.nvars + 1, new_ord, ring.characteristic, ring.ground)
        new_ord = extend_ordering_in_saturation(ring.nvars, ring.ord)
        ring = PolyRing(ring.nvars + 1, new_ord, ring.characteristic, ring.ground)
    end

    flag = wrapped_trace_check_input(wrapped_trace, monoms, coeffs)
    !flag && return flag, coeffs

    trace = wrapped_trace_create_suitable_trace!(wrapped_trace, ring, params, C)

    _monoms = filter(!isempty, monoms)
    _coeffs = filter(!isempty, coeffs)
    if trace.empty
        if isempty(_monoms)
            return true, [coeffs[1]]
        else
            return false, coeffs
        end
    end
    monoms, coeffs = _monoms, _coeffs

    flag = ir_extract_coeffs_raw!(trace, coeffs)
    !flag && return flag, coeffs

    flag, ring, gb_coeffs2 = groebner_apply2!(trace, params)
    if !flag
        return flag, coeffs
    end

    @assert length(gb_coeffs2) == length(wrapped_trace.gb_support)
    for i in 1:length(wrapped_trace.gb_support)
        @assert length(gb_coeffs2[i]) == length(wrapped_trace.gb_support[i])
    end

    flag, gb_coeffs2
end

function groebner_apply2!(trace, params)
    flag, ring, gb_coeffs = _groebner_apply2!(trace, params)
    if !flag
        # Recover trace
        @info "Trace might be corrupted. Recovering..." maxlog = 1
        trace.nfail += 1
        empty!(trace.matrix_sorted_columns)
        C = eltype(eltype(trace.buf_basis.coeffs))
        coeffs = Vector{Vector{C}}(undef, length(trace.input_basis.monoms))
        for i in 1:(trace.input_basis.n_filled)
            coeffs[i] = Vector{C}(undef, length(trace.input_basis.monoms[i]))
        end
        trace.buf_basis = basis_deep_copy_with_new_coeffs(trace.input_basis, coeffs)
        return flag, ring, gb_coeffs
    end
    flag, ring, gb_coeffs
end

function _groebner_apply2!(trace, params)
    flag = f4_apply!(trace, params)

    gb_coeffs = basis_export_coeffs(trace.gb_basis)

    ring = trace.ring
    if trace.params.homogenize
        gb_monoms, gb_coeffs = basis_export_data(trace.gb_basis, trace.hashtable)
        ring, gb_monoms, gb_coeffs, params =
            dehomogenize_generators(trace.ring, gb_monoms, gb_coeffs, params)
        if params.reduced
            gb_monoms, gb_coeffs = autoreduce2(ring, gb_monoms, gb_coeffs, params)
        end
    end

    flag, ring, gb_coeffs
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# ExponentVector implements the monomial interface (whatever this interface is).
#
# ExponentVector{T} is a vector of integers of type T. It is commonly used with
# the UInt8 element type (that is 8 bits per exponent).
#
# Note: Some functions that implement monomial arithmetic and monomial
# comparisons are not automatically vectorized with the use of AVX2 or AVX512
# (in Julia 1.10). When vectorized, the code does not handle scalar tails well.
# At the same time, in hand-vectorized code it is hard to do masked load.  

const ExponentVector{T} = Vector{T} where {T <: Integer}

# MonomialDegreeOverflow is thrown if there is a risk of monomial degree
# overflow. If we catch a MonomialDegreeOverflow, there is some hope to recover
# the program by restarting with a wider integer type for storing exponents.
struct MonomialDegreeOverflow <: Exception end

@noinline __throw_monom_overflow_error() = throw(MonomialDegreeOverflow())

monom_overflow_threshold(::Type{T}) where {T <: Integer} = div(typemax(T), 2)
monom_overflow_check(a::T) where {T <: Integer} = monom_overflow_check(a, T)

function monom_overflow_check(a::Integer, ::Type{T}) where {T}
    a >= monom_overflow_threshold(T) && __throw_monom_overflow_error()
    true
end

function monom_overflow_check(e::ExponentVector{T}) where {T}
    # Exponent vector overflows if the total degree overflows
    monom_overflow_check(monom_totaldeg(e))
end

monom_max_vars(::Type{ExponentVector{T}}) where {T} = 2^32
monom_max_vars(p::ExponentVector{T}) where {T} = monom_max_vars(typeof(p))

# The return type should be as tight as possible, since F4 uses this type
# as a hint to initialize storage for total degrees of appropriate size.
monom_totaldeg(pv::ExponentVector) = @inbounds pv[1]

monom_copy(pv::ExponentVector) = Base.copy(pv)

monom_construct_const(::Type{ExponentVector{T}}, n::Integer) where {T} = zeros(T, n + 1)

function monom_construct_from_vector(::Type{ExponentVector{T}}, ev::Vector{U}) where {T, U}
    v = ExponentVector{T}(undef, length(ev) + 1)
    s = zero(T)
    @inbounds for i in 1:length(ev)
        monom_overflow_check(ev[i], T)
        s += T(ev[i])
        monom_overflow_check(s, T)
        v[i + 1] = T(ev[i])
    end
    @inbounds v[1] = s
    v
end

function monom_to_vector!(tmp::Vector{M}, pv::ExponentVector{T}) where {M, T}
    @invariant length(tmp) == length(pv) - 1
    if promote_type(M, T) !== M
        if !(all(i -> pv[i] < typemax(M), 2:length(pv)))
            __throw_monom_overflow_error()
        end
    end
    @inbounds tmp[1:end] .= pv[2:end]
    tmp
end

function monom_construct_hash_vector(
    rng::AbstractRNG,
    ::Type{ExponentVector{T}},
    n::Integer
) where {T}
    rand(rng, MonomHash, n + 1)
end

function monom_hash(x::ExponentVector{T}, b::Vector{MH}) where {T, MH}
    @invariant length(x) == length(b)
    h = zero(MH)
    @inbounds for i in 1:length(x)
        h += (x[i] % MH) * b[i]
    end
    mod(h, MonomHash)
end

###
# Monomial comparators.

function monom_is_supported_ordering(::Type{ExponentVector{T}}, ::Any) where {T}
    # ExponentVector implements all monomial orderings.
    true
end

# DegRevLex monomial comparison. 
function monom_isless(ea::ExponentVector, eb::ExponentVector, ::DegRevLex{true})
    @invariant length(ea) == length(eb)
    @invariant length(ea) > 1
    if monom_totaldeg(ea) < monom_totaldeg(eb)
        return true
    elseif monom_totaldeg(ea) != monom_totaldeg(eb)
        return false
    end
    i = length(ea)
    @inbounds while i > 2 && ea[i] == eb[i]
        i -= 1
    end
    @inbounds return ea[i] > eb[i]
end

# DegRevLex monomial comparison (shuffled variables).
function monom_isless(ea::ExponentVector{T}, eb::ExponentVector{T}, ord::DegRevLex{false}) where {T}
    @invariant length(ea) == length(eb)
    @invariant length(ea) > 1
    variables = ordering_variables(ord)
    eatotaldeg = zero(T)
    ebtotaldeg = zero(T)
    @inbounds for i in variables
        eatotaldeg += ea[i + 1]
        ebtotaldeg += eb[i + 1]
    end
    if eatotaldeg < ebtotaldeg
        return true
    elseif eatotaldeg != ebtotaldeg
        return false
    end
    i = length(variables)
    @inbounds while i > 1 && ea[variables[i] + 1] == eb[variables[i] + 1]
        i -= 1
    end
    @inbounds ea[variables[i] + 1] > eb[variables[i] + 1]
end

# DegLex monomial comparison.
function monom_isless(ea::ExponentVector, eb::ExponentVector, ::DegLex{true})
    @invariant length(ea) == length(eb)
    @invariant length(ea) > 1
    if monom_totaldeg(ea) < monom_totaldeg(eb)
        return true
    elseif monom_totaldeg(ea) != monom_totaldeg(eb)
        return false
    end
    monom_isless(ea, eb, Lex())
end

# DegLex monomial comparison (shuffled variables).
function monom_isless(ea::ExponentVector{T}, eb::ExponentVector{T}, ord::DegLex{false}) where {T}
    @invariant length(ea) == length(eb)
    @invariant length(ea) > 1
    variables = ordering_variables(ord)
    eatotaldeg = zero(T)
    ebtotaldeg = zero(T)
    @inbounds for i in variables
        eatotaldeg += ea[i + 1]
        ebtotaldeg += eb[i + 1]
    end
    if eatotaldeg < ebtotaldeg
        return true
    elseif eatotaldeg != ebtotaldeg
        return false
    end
    i = 1
    @inbounds while i < length(variables) && ea[variables[i] + 1] == eb[variables[i] + 1]
        i += 1
    end
    @inbounds ea[variables[i] + 1] < eb[variables[i] + 1]
end

# Lex monomial comparison.
function monom_isless(ea::ExponentVector, eb::ExponentVector, ::Lex{true})
    @invariant length(ea) == length(eb)
    @invariant length(ea) > 1
    i = 2
    @inbounds while i < length(ea) && ea[i] == eb[i]
        i += 1
    end
    @inbounds return ea[i] < eb[i]
end

# Lex monomial comparison (shuffled variables).
function monom_isless(ea::ExponentVector, eb::ExponentVector, ord::Lex{false})
    variables = ordering_variables(ord)
    @invariant length(ea) == length(eb)
    @invariant length(ea) > 1
    i = 1
    @inbounds while i < length(variables) && ea[variables[i] + 1] == eb[variables[i] + 1]
        i += 1
    end
    @inbounds ea[variables[i] + 1] < eb[variables[i] + 1]
end

# Weighted monomial comparison.
function monom_isless(
    ea::ExponentVector{T},
    eb::ExponentVector{T},
    ord::WeightedOrdering{U}
) where {U, T}
    weights = ord.weights
    variables = ordering_variables(ord)
    @invariant length(ea) == length(eb)
    @invariant length(ea) > 1
    sa, sb = zero(U), zero(U)
    @inbounds for i in 1:length(variables)
        sa += ea[variables[i] + 1] * weights[i]
        sb += eb[variables[i] + 1] * weights[i]
    end
    if sa < sb
        return true
    elseif sa != sb
        return false
    end
    monom_isless(ea, eb, Lex())
end

# Product ordering exponent vector comparison.
function monom_isless(ea::ExponentVector, eb::ExponentVector, b::ProductOrdering)
    if monom_isless(ea, eb, b.ord1)
        return true
    end
    if monom_isless(eb, ea, b.ord1)
        return false
    end
    monom_isless(ea, eb, b.ord2)
end

# Matrix ordering exponent vector comparison.
function monom_isless(ea::ExponentVector, eb::ExponentVector, m::MatrixOrdering)
    rows = m.rows
    variables = ordering_variables(m)
    @inbounds common_type = signed(promote_type(eltype(rows[1]), eltype(ea)))
    @inbounds for i in 1:length(rows)
        sa, sb = zero(common_type), zero(common_type)
        for j in 1:length(variables)
            sa += rows[i][j] * common_type(ea[variables[j] + 1])
            sb += rows[i][j] * common_type(eb[variables[j] + 1])
        end
        if sa < sb
            return true
        elseif sa > sb
            return false
        end
    end
    false
end

###
# Monomial-monomial arithmetic.

# Returns the lcm of two monomials. Writes the result to ec.
function monom_lcm!(ec::ExponentVector{T}, ea::ExponentVector{T}, eb::ExponentVector{T}) where {T}
    @invariant length(ec) == length(ea) == length(eb)
    s = zero(T)
    @inbounds for i in 2:length(ec)
        ec[i] = max(ea[i], eb[i])
        s += ec[i]
    end
    @inbounds ec[1] = s
    monom_overflow_check(ec)
    ec
end

# Checks if the gcd of monomials is constant.
function monom_is_gcd_const(ea::ExponentVector{T}, eb::ExponentVector{T}) where {T}
    @invariant length(ea) == length(eb)
    @inbounds for j in 2:length(ea)
        if !iszero(ea[j]) && !iszero(eb[j])
            return false
        end
    end
    true
end

# Returns the product of two monomials. Writes the result to ec.
function monom_product!(
    ec::ExponentVector{T},
    ea::ExponentVector{T},
    eb::ExponentVector{T}
) where {T}
    @invariant length(ec) == length(ea) == length(eb)
    @inbounds for j in 1:length(ec)
        ec[j] = ea[j] + eb[j]
    end
    monom_overflow_check(ec)
    ec
end

# Returns the result of monomial division. Writes the result to ec.
function monom_division!(
    ec::ExponentVector{T},
    ea::ExponentVector{T},
    eb::ExponentVector{T}
) where {T}
    @invariant length(ec) == length(ea) == length(eb)
    @inbounds for j in 1:length(ec)
        @invariant ea[j] >= eb[j]
        ec[j] = ea[j] - eb[j]
    end
    ec
end

# Checks monomial divisibility.
function monom_is_divisible(ea::ExponentVector{T}, eb::ExponentVector{T}) where {T}
    @invariant length(ea) == length(eb)
    @inbounds for j in 2:length(ea)
        if ea[j] < eb[j]
            return false
        end
    end
    return true
end

# Checks monomial divisibility and performs division
function monom_is_divisible!(
    ec::ExponentVector{T},
    ea::ExponentVector{T},
    eb::ExponentVector{T}
) where {T}
    @invariant length(ec) == length(ea) == length(eb)
    !monom_is_divisible(ea, eb) && return false, ec
    monom_division!(ec, ea, eb)
    true, ec
end

# Checks monomials for element-wise equality
function monom_is_equal(ea::ExponentVector{T}, eb::ExponentVector{T}) where {T}
    ea == eb
end

###
# Monomial division masks.

# Constructs the division mask for the given monomial.
#
# If compressed is true, the mask will be compressed so that more variables can
# be handled. Compressed and non-compressed division masks are not compatible.
function monom_create_divmask(
    e::ExponentVector{T},
    _::Type{Mask},
    ndivvars::Int,
    divmap::Vector{U},
    ndivbits::Int,
    strategy::Symbol
) where {T, Mask, U}
    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)
    if strategy === :first_variables
        # if the number of variables is small (<= 32)
        @inbounds for i in 1:ndivvars
            for _ in 1:ndivbits
                if e[i + 1] >= divmap[ctr]
                    res |= o << (ctr - 1)
                end
                ctr += o
            end
        end
    else
        # if the number of variables is large (> 32)
        @invariant ndivbits == 1
        @invariant length(divmap) == 8 * sizeof(Mask)
        @inbounds for i in 1:length(divmap)
            nvars_per_bit = divmap[i]
            bit = Mask(0)
            for _ in 1:nvars_per_bit
                bit |= Mask(!iszero(e[ctr + 1]))
                ctr += o
            end
            res |= bit << (i - 1)
        end
        res
    end
    res
end

using AbstractAlgebra
using BenchmarkTools
using BitIntegers
using Nemo
using Primes
using Printf
using Random

const ROW_LENGTH = 50_000
const SUPPORT_LENGTH = 5_000
const PRIME64 = UInt64(18446744073709551557)
const PRIME256_BIG = Primes.nextprime(big(2)^255)
const PRIME256 = UInt256(PRIME256_BIG)
const PRIME512 = UInt512(PRIME256_BIG)
const PRIME64_WIDE = UInt128(PRIME64)
const PRIME64_INV = Base.multiplicativeinverse(PRIME64_WIDE)
const PRIME256_INV = Base.multiplicativeinverse(PRIME512)

function rand_big_lt(rng::AbstractRNG, p::BigInt)
    x = (BigInt(rand(rng, UInt128)) << 128) + BigInt(rand(rng, UInt128))
    mod(x, p)
end

function make_indices(rng::AbstractRNG, n::Int, k::Int)
    sort!(randperm(rng, n)[1:k])
end

@inline addmod_u64(a::UInt64, b::UInt64) = UInt64(rem(UInt128(a) + UInt128(b), PRIME64_INV))
@inline mulmod_u64(a::UInt64, b::UInt64) = UInt64(rem(widen(a) * widen(b), PRIME64_INV))

@inline addmod_u256(a::UInt256, b::UInt256) = UInt256(rem(UInt512(a) + UInt512(b), PRIME256_INV))
@inline mulmod_u256(a::UInt256, b::UInt256) = UInt256(rem(UInt512(a) * UInt512(b), PRIME256_INV))

function groebner_like_addmul_u64!(row::Vector{UInt64}, indices::Vector{Int}, coeffs::Vector{UInt64})
    mul = PRIME64 - row[indices[1]]
    @inbounds for j in eachindex(indices, coeffs)
        idx = indices[j]
        row[idx] = addmod_u64(row[idx], mulmod_u64(mul, coeffs[j]))
    end
    row
end

function groebner_like_addmul_u256!(row::Vector{UInt256}, indices::Vector{Int}, coeffs::Vector{UInt256})
    mul = PRIME256 - row[indices[1]]
    @inbounds for j in eachindex(indices, coeffs)
        idx = indices[j]
        row[idx] = addmod_u256(row[idx], mulmod_u256(mul, coeffs[j]))
    end
    row
end

function groebner_like_addmul_bigint!(row::Vector{BigInt}, indices::Vector{Int}, coeffs::Vector{BigInt}, p::BigInt)
    mul = p - row[indices[1]]
    @inbounds for j in eachindex(indices, coeffs)
        idx = indices[j]
        row[idx] = mod(row[idx] + mul * coeffs[j], p)
    end
    row
end

function groebner_like_addmul_generic!(row, indices::Vector{Int}, coeffs)
    mul = -row[indices[1]]
    @inbounds for j in eachindex(indices, coeffs)
        idx = indices[j]
        row[idx] = row[idx] + mul * coeffs[j]
    end
    row
end

function build_inputs(; row_length::Int=ROW_LENGTH, support_length::Int=SUPPORT_LENGTH, seed::Int=0)
    rng = MersenneTwister(seed)
    indices = make_indices(rng, row_length, support_length)

    row64 = [rand(rng, UInt64) % PRIME64 for _ in 1:row_length]
    coeffs64 = [rand(rng, UInt64) % PRIME64 for _ in 1:support_length]
    coeffs64[1] = one(UInt64)

    row_big = [rand_big_lt(rng, PRIME256_BIG) for _ in 1:row_length]
    coeffs_big = [rand_big_lt(rng, PRIME256_BIG) for _ in 1:support_length]
    coeffs_big[1] = BigInt(1)

    row_u256 = UInt256.(row_big)
    coeffs_u256 = UInt256.(coeffs_big)

    F256 = Nemo.GF(PRIME256_BIG)
    row_nemo = F256.(row_big)
    coeffs_nemo = F256.(coeffs_big)
    coeffs_nemo[1] = one(F256)

    R256, _ = AbstractAlgebra.residue_ring(AbstractAlgebra.ZZ, PRIME256_BIG)
    row_aa = R256.(row_big)
    coeffs_aa = R256.(coeffs_big)
    coeffs_aa[1] = one(R256)

    F64 = Nemo.GF(BigInt(PRIME64))
    row_nemo64 = F64.(BigInt.(row64))
    coeffs_nemo64 = F64.(BigInt.(coeffs64))
    coeffs_nemo64[1] = one(F64)

    (; indices, row64, coeffs64, row_nemo64, coeffs_nemo64, row_big, coeffs_big, row_u256, coeffs_u256, row_nemo, coeffs_nemo, row_aa, coeffs_aa)
end

function verify_correctness(data)
    idx1 = data.indices[1]

    row_big = copy(data.row_big)
    groebner_like_addmul_bigint!(row_big, data.indices, data.coeffs_big, PRIME256_BIG)
    @assert iszero(row_big[idx1])

    row_u256 = copy(data.row_u256)
    groebner_like_addmul_u256!(row_u256, data.indices, data.coeffs_u256)
    @assert iszero(row_u256[idx1])
    @assert BigInt(row_u256[idx1]) == row_big[idx1]

    row_nemo = copy(data.row_nemo)
    groebner_like_addmul_generic!(row_nemo, data.indices, data.coeffs_nemo)
    @assert iszero(row_nemo[idx1])
    @assert BigInt(lift(Nemo.ZZ, row_nemo[idx1])) == row_big[idx1]

    row_aa = copy(data.row_aa)
    groebner_like_addmul_generic!(row_aa, data.indices, data.coeffs_aa)
    @assert iszero(row_aa[idx1])

    row64 = copy(data.row64)
    groebner_like_addmul_u64!(row64, data.indices, data.coeffs64)
    @assert iszero(row64[idx1])

    row_nemo64 = copy(data.row_nemo64)
    groebner_like_addmul_generic!(row_nemo64, data.indices, data.coeffs_nemo64)
    @assert iszero(row_nemo64[idx1])
end

function run_case(name::AbstractString, kernel, row_seed, indices, coeffs; samples::Int=40)
    trial = run(
        @benchmarkable $kernel(row, $indices, $coeffs) setup=(row = copy($row_seed)),
        samples=samples,
        evals=1
    )
    median_ns = BenchmarkTools.median(trial).time
    min_ns = minimum(trial).time
    updates_per_second = 1.0e9 * length(indices) / median_ns
    (; name, median_ns, min_ns, updates_per_second)
end

function run_case(name::AbstractString, kernel, row_seed, indices, coeffs, p; samples::Int=40)
    trial = run(
        @benchmarkable $kernel(row, $indices, $coeffs, $p) setup=(row = copy($row_seed)),
        samples=samples,
        evals=1
    )
    median_ns = BenchmarkTools.median(trial).time
    min_ns = minimum(trial).time
    updates_per_second = 1.0e9 * length(indices) / median_ns
    (; name, median_ns, min_ns, updates_per_second)
end

function main()
    data = build_inputs()
    verify_correctness(data)

    results = [
        run_case("UInt64 + MultInv", groebner_like_addmul_u64!, data.row64, data.indices, data.coeffs64),
        run_case("Nemo GF(64-bit)", groebner_like_addmul_generic!, data.row_nemo64, data.indices, data.coeffs_nemo64),
        run_case("BigInt mod p", groebner_like_addmul_bigint!, data.row_big, data.indices, data.coeffs_big, PRIME256_BIG),
        run_case("UInt256 + MultInv", groebner_like_addmul_u256!, data.row_u256, data.indices, data.coeffs_u256),
        run_case("Nemo GF(256-bit)", groebner_like_addmul_generic!, data.row_nemo, data.indices, data.coeffs_nemo),
        run_case("AA residue(256-bit)", groebner_like_addmul_generic!, data.row_aa, data.indices, data.coeffs_aa),
    ]

    println("Groebner-like sparse/dense addmul benchmark")
    println("row_length=$(ROW_LENGTH), support_length=$(SUPPORT_LENGTH)")
    println("prime64_bits=$(ndigits(BigInt(PRIME64), base=2)), prime256_bits=$(ndigits(PRIME256_BIG, base=2))")
    println()
    @printf("%-22s %14s %14s %16s\n", "backend", "median ns", "best ns", "updates/sec")
    for result in results
        @printf(
            "%-22s %14.0f %14.0f %16.2f\n",
            result.name,
            result.median_ns,
            result.min_ns,
            result.updates_per_second
        )
    end
end

main()

using Revise, Groebner, Random, BenchmarkTools, Printf, SmallCollections

function construct_random_monom(MonomT, nvars, rng)
    ev = rand(rng, 0:3, nvars)
    return Groebner.monom_construct_from_vector(MonomT, ev)
end

function bench_insert_only(nvars, MonomT, n_insertions=500)
    ord = Groebner.DegRevLex()
    ring = Groebner.PolyRing(nvars, ord, Groebner.CoeffModular(1009), :zp)
    rng = Random.default_rng()
    
    monoms = [construct_random_monom(MonomT, nvars, rng) for _ in 1:n_insertions]
    
    function fill_many(ht, monoms)
        for m in monoms
            Groebner.hashtable_insert!(ht, m)
        end
    end

    # Case 1: Inserting into an empty hashtable
    b_not_filled = @benchmarkable $fill_many(ht, $monoms) setup=begin
        ht = Groebner.hashtable_initialize($ring, $rng, $MonomT);
        Groebner.hashtable_resize_if_needed!(ht, $(3*length(monoms)))
    end evals=1
    
    # Case 2: Inserting into an already filled hashtable
    ht_filled = Groebner.hashtable_initialize(ring, rng, MonomT)
    Groebner.hashtable_resize_if_needed!(ht_filled, 3*length(monoms))
    fill_many(ht_filled, monoms)
    
    b_filled = @benchmarkable $fill_many($ht_filled, $monoms)
    
    return b_not_filled, b_filled
end

function run_benchmarks(N)
    if N == 11
        configs = [
            (N, Groebner.PackedTuple2{UInt64, UInt8}),
            (N, Vector{UInt8}),
            (N, SmallCollections.FixedVector{nextpow(2,N), UInt8}),
            (N, Groebner.FixedMonom{nextpow(2,N), UInt8}),
            (N, Groebner.FixedMonomNoDeg{nextpow(2,N), UInt8}),
            (N, Groebner.NibbleMonom{nextpow(2,N) ÷ 2})
        ]
    elseif N == 55
        configs = [
            (N, Vector{UInt8}),
            (N, SmallCollections.FixedVector{nextpow(2,N), UInt8}),
            (N, Groebner.FixedMonom{nextpow(2,N), UInt8}),
            (N, Groebner.FixedMonomNoDeg{nextpow(2,N), UInt8}),
            (N, Groebner.NibbleMonom{nextpow(2,N) ÷ 2})
        ]
    end

    results = []
    
    for (nvars, MonomT) in configs
        insertions = 10000
        @info "Benchmarking $insertions insertions for $MonomT with nvars=$nvars"
        
        b_not_filled, b_filled = bench_insert_only(nvars, MonomT, insertions)
        
        res_not_filled = run(b_not_filled)
        res_filled = run(b_filled)
        
        t_not_filled = minimum(res_not_filled).time / insertions
        t_filled = minimum(res_filled).time / insertions
        
        monom_name = string(MonomT)
        monom_name = replace(monom_name, "Groebner." => "")
        
        push!(results, (monom_name, t_not_filled, t_filled))
    end
    
    println("\n=======================================================")
    println(" Benchmark Results for N = $N (Min ns / Insertion) ")
    println("=======================================================")
    @printf("%-30s | %-10s | %-10s\n", "Monomial Type", "Empty HT", "Filled HT")
    println("-------------------------------+------------+----------")
    for (name, t1, t2) in results
        @printf("%-30s | %8.2f   | %8.2f \n", name, t1, t2)
    end
    println("=======================================================\n")
end

run_benchmarks(11)
run_benchmarks(55)

using AbstractAlgebra

include("gizmos.jl")

function fukuoka_mq(n::Int, m::Int, char::Int)
    k = GF(char)
    R, x = polynomial_ring(k, ["x$i" for i in 1:n], internal_ordering=:degrevlex)
    sol = map(_ -> rand(k), 1:n)
    sys = [randpoly(x, 2) for _ in 1:m]
    c = map(f -> evaluate(f, sol), sys)
    sys = sys .- c
    sys
end

include("../standard/parser.jl")

import AbstractAlgebra
using BenchmarkTools
using Logging

global_logger(ConsoleLogger(stderr, Logging.Error))

BenchmarkTools.DEFAULT_PARAMETERS.samples = 2

function benchmark_system(system)
    @btime Groebner.groebner($s, internal_ordering=:degrevlex)
end

function run_for_gleb()
    fns = ["gbSIWR", "gbSEAIJRC"]

    for fn in fns
        system = load_system(fn)
        benchmark_system(system)
    end
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# F4 learn & apply with tracing
#
# Tracing is implemented as an add-on to the F4 algorithm. Here, we try to reuse
# the functions from F4 as much as possible. At the same time, F4 is completely
# independent from this file.

###
# F4 learn stage

function f4_initialize_structs_with_trace(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    params::AlgorithmParameters;
    make_monic=true,
    sort_input=true
) where {M <: Monom, C <: Coeff}
    basis, pairset, hashtable, permutation = f4_initialize_structs(
        ring,
        monoms,
        coeffs,
        params,
        make_monic=make_monic,
        sort_input=sort_input
    )
    trace = trace_initialize(ring, basis, hashtable, permutation, params)
    trace, basis, pairset, hashtable, permutation
end

function matrix_compute_pivot_signature(pivots::Vector{Vector{MonomId}}, from::Int, sz::Int)
    sgn = UInt64(0x7e2d6fb6448beb77)
    sgn = sgn - UInt64(89 * sz)
    @inbounds for i in from:(from + sz - 1)
        p = pivots[i]
        sgni = zero(UInt64)
        for j in 1:length(p)
            sgni = p[j] - UInt64(13) * sgni
        end
        sgn = sgn - UInt(13) * sgni
    end
    sgn
end

@timeit _TIMER function f4_reduction_learn!(
    trace::Trace,
    basis::Basis,
    matrix::MacaulayMatrix,
    hashtable::MonomialHashtable,
    symbol_ht::MonomialHashtable,
    params::AlgorithmParameters
)
    matrix_fill_column_to_monom_map!(matrix, symbol_ht)
    linalg_main!(matrix, basis, params, trace, linalg=LinearAlgebra(:learn, :sparse))
    matrix_convert_rows_to_basis_elements!(
        matrix,
        basis,
        hashtable,
        symbol_ht,
        params;
        batched_ht_insert=true
    )
    pivot_indices = map(i -> Int32(basis.monoms[basis.n_processed + i][1]), 1:(matrix.npivots))
    push!(trace.matrix_pivot_indices, pivot_indices)
    matrix_pivot_signature =
        matrix_compute_pivot_signature(basis.monoms, basis.n_processed + 1, matrix.npivots)
    push!(trace.matrix_pivot_signatures, matrix_pivot_signature)
end

@timeit _TIMER function f4_reducegb_learn!(
    trace::Trace,
    ring::PolyRing,
    basis::Basis,
    matrix::MacaulayMatrix,
    ht::MonomialHashtable{M},
    symbol_ht::MonomialHashtable{M},
    params::AlgorithmParameters
) where {M <: Monom}
    etmp = monom_construct_const(M, ht.nvars)
    # etmp is now set to zero, and has zero hash

    matrix_reinitialize!(matrix, basis.n_nonredundant)
    uprows = matrix.upper_rows

    # add all non redundant elements from basis
    # as matrix upper rows
    @inbounds for i in 1:(basis.n_nonredundant) #
        row_idx = matrix.nrows_filled_upper += 1
        uprows[row_idx] = matrix_polynomial_multiple_to_row!(
            matrix,
            symbol_ht,
            ht,
            MonomHash(0),
            etmp,
            basis.monoms[basis.nonredundant_indices[i]]
        )

        matrix.upper_to_coeffs[row_idx] = basis.nonredundant_indices[i]
        matrix.upper_to_mult[row_idx] = hashtable_insert!(ht, etmp)
        symbol_ht.labels[uprows[row_idx][1]] = UNKNOWN_PIVOT_COLUMN
    end
    trace.nonredundant_indices_before_reduce = basis.nonredundant_indices[1:(basis.n_nonredundant)]

    # needed for correct column count in symbol hashtable
    matrix.ncols_left = matrix.nrows_filled_upper

    f4_symbolic_preprocessing!(basis, matrix, ht, symbol_ht)
    # set all pivots to unknown
    @inbounds for i in (symbol_ht.offset):(symbol_ht.load)
        symbol_ht.labels[i] = UNKNOWN_PIVOT_COLUMN
    end

    matrix_fill_column_to_monom_map!(matrix, symbol_ht)

    linalg_autoreduce!(matrix, basis, params, trace, linalg=LinearAlgebra(:learn, :sparse))

    matrix_convert_rows_to_basis_elements!(matrix, basis, ht, symbol_ht, params)

    pivot_indices = map(i -> Int32(basis.monoms[basis.n_processed + i][1]), 1:(matrix.npivots))
    push!(trace.matrix_pivot_indices, pivot_indices)
    matrix_pivot_signature =
        matrix_compute_pivot_signature(basis.monoms, basis.n_processed + 1, matrix.npivots)
    push!(trace.matrix_pivot_signatures, matrix_pivot_signature)

    basis.n_filled = matrix.npivots + basis.n_processed
    basis.n_processed = matrix.npivots

    # we may have added some multiples of reduced basis polynomials
    # from the matrix, so get rid of them
    k = 0
    i = 1
    @label Letsgo
    @inbounds while i <= basis.n_processed
        for j in 1:k
            if hashtable_monom_is_divisible(
                basis.monoms[basis.n_filled - i + 1][1],
                basis.monoms[basis.nonredundant_indices[j]][1],
                ht
            )
                i += 1
                @goto Letsgo
            end
        end
        k += 1
        basis.nonredundant_indices[k] = basis.n_filled - i + 1
        basis.divmasks[k] = ht.divmasks[basis.monoms[basis.nonredundant_indices[k]][1]]
        i += 1
    end
    basis.n_nonredundant = k

    trace.output_nonredundant_indices = copy(basis.nonredundant_indices[1:k])
end

@timeit _TIMER function f4_learn!(trace::Trace, pairset::Pairset, params::AlgorithmParameters)
    ring = trace.ring
    basis = trace.gb_basis
    hashtable = trace.hashtable

    @invariant basis_well_formed(ring, basis, hashtable)
    @invariant params.reduced

    basis_make_monic!(basis, params.arithmetic, params.changematrix)

    matrix = matrix_initialize(ring, eltype(eltype(basis.coeffs)))
    update_ht = hashtable_initialize_secondary(hashtable)
    symbol_ht = hashtable_initialize_secondary(hashtable)

    f4_update!(pairset, basis, hashtable, update_ht)

    while !isempty(pairset)
        degree_i, npairs_i = f4_select_critical_pairs!(pairset, basis, matrix, hashtable, symbol_ht)
        push!(trace.critical_pair_sequence, (degree_i, npairs_i))

        f4_symbolic_preprocessing!(basis, matrix, hashtable, symbol_ht)

        f4_reduction_learn!(trace, basis, matrix, hashtable, symbol_ht, params)

        f4_update!(pairset, basis, hashtable, update_ht)

        hashtable_reinitialize!(symbol_ht)
    end

    basis_discard_redundant_elements!(basis)

    if params.reduced
        f4_reducegb_learn!(trace, ring, basis, matrix, hashtable, symbol_ht, params)
    end

    trace_finalize!(trace)

    perm = basis_standardize!(ring, basis, hashtable, params.arithmetic, false)
    trace.output_sort_indices = perm

    @invariant basis_well_formed(ring, basis, hashtable)

    nothing
end

###
# F4 apply stage

function matrix_fill_column_to_monom_map!(
    trace::Trace,
    matrix::MacaulayMatrix,
    symbol_ht::MonomialHashtable
)
    # monoms from symbolic table represent one column in the matrix
    load = symbol_ht.load

    # number of pivotal cols
    k = 0
    @inbounds for i in (symbol_ht.offset):load
        if symbol_ht.labels[i] == PIVOT_COLUMN
            k += 1
        end
    end

    column_to_monom = matrix.column_to_monom

    matrix.ncols_left = k  # CHECK!
    # -1 as long as hashtable load is always 1 more than actual
    matrix.ncols_right = load - matrix.ncols_left - 1

    # store the other direction of mapping,
    # hash -> column
    @inbounds for k in 1:length(column_to_monom)
        symbol_ht.labels[column_to_monom[k]] = k
    end

    @inbounds for k in 1:(matrix.nrows_filled_upper)
        row = matrix.upper_rows[k]
        for j in 1:length(row)
            row[j] = symbol_ht.labels[row[j]]
        end
    end

    @inbounds for k in 1:(matrix.nrows_filled_lower)
        row = matrix.lower_rows[k]
        for j in 1:length(row)
            row[j] = symbol_ht.labels[row[j]]
        end
    end
end

@timeit _TIMER function f4_reduction_apply!(
    trace::Trace,
    basis::Basis,
    matrix::MacaulayMatrix,
    ht::MonomialHashtable,
    symbol_ht::MonomialHashtable,
    f4_iteration::Int,
    cache_column_order::Bool,
    params::AlgorithmParameters
)
    # We bypass the sorting of the matrix columns when apply is used the second
    # time
    if cache_column_order
        if length(trace.matrix_sorted_columns) >= f4_iteration
            matrix.column_to_monom = trace.matrix_sorted_columns[f4_iteration]
            matrix_fill_column_to_monom_map!(trace, matrix, symbol_ht)
        else
            matrix_fill_column_to_monom_map!(matrix, symbol_ht)
            push!(trace.matrix_sorted_columns, matrix.column_to_monom)
        end
    else
        matrix_fill_column_to_monom_map!(matrix, symbol_ht)
    end

    flag = linalg_main!(matrix, basis, params, trace, linalg=LinearAlgebra(:apply, :sparse))
    !flag && return (false, false)

    matrix_convert_rows_to_basis_elements!(matrix, basis, ht, symbol_ht, params)

    # Check that the leading terms were not reduced to zero accidentally
    pivot_indices = trace.matrix_pivot_indices[f4_iteration]
    @inbounds for i in 1:(matrix.npivots)
        sgn = basis.monoms[basis.n_processed + i][1]
        sgn != pivot_indices[i] && return (false, false)
    end

    if cache_column_order
        matrix_pivot_signature =
            matrix_compute_pivot_signature(basis.monoms, basis.n_processed + 1, matrix.npivots)
        if matrix_pivot_signature != trace.matrix_pivot_signatures[f4_iteration]
            return false, false
        end
    end

    true, cache_column_order
end

@timeit _TIMER function f4_symbolic_preprocessing!(
    trace::Trace,
    f4_iteration::Int,
    basis::Basis,
    matrix::MacaulayMatrix,
    hashtable::MonomialHashtable,
    symbol_ht::MonomialHashtable
)
    lowrows, lowmults = trace.matrix_lower_rows[f4_iteration]
    uprows, upmults = trace.matrix_upper_rows[f4_iteration]
    matrix_info = trace.matrix_infos[f4_iteration]
    nonzeroed_rows = trace.matrix_nonzeroed_rows[f4_iteration]
    nlow = length(nonzeroed_rows)
    nup = length(uprows)

    resize!(matrix.upper_rows, nup)
    resize!(matrix.lower_rows, nlow)
    resize!(matrix.lower_to_coeffs, nlow)
    resize!(matrix.upper_to_coeffs, nup)

    hashtable_resize_if_needed!(symbol_ht, nlow + nup + 2)
    @inbounds for i in 1:nlow
        mult_idx = lowmults[i]
        poly_idx = lowrows[i]

        h = hashtable.hashvals[mult_idx]
        etmp = hashtable.monoms[mult_idx]
        rpoly = basis.monoms[poly_idx]

        matrix.lower_rows[i] =
            matrix_polynomial_multiple_to_row!(matrix, symbol_ht, hashtable, h, etmp, rpoly)

        symbol_ht.labels[matrix.lower_rows[i][1]] = PIVOT_COLUMN

        matrix.lower_to_coeffs[i] = poly_idx
    end

    @invariant map(i -> length(matrix.lower_rows[i]), 1:nlow) ==
               map(i -> length(basis.coeffs[matrix.lower_to_coeffs[i]]), 1:nlow)

    @inbounds for i in 1:nup
        mult_idx = upmults[i]
        poly_idx = uprows[i]

        h = hashtable.hashvals[mult_idx]
        etmp = hashtable.monoms[mult_idx]
        rpoly = basis.monoms[poly_idx]

        matrix.upper_rows[i] =
            matrix_polynomial_multiple_to_row!(matrix, symbol_ht, hashtable, h, etmp, rpoly)

        symbol_ht.labels[matrix.upper_rows[i][1]] = PIVOT_COLUMN

        matrix.upper_to_coeffs[i] = poly_idx
    end

    @invariant map(i -> length(matrix.upper_rows[i]), 1:nup) ==
               map(i -> length(basis.coeffs[matrix.upper_to_coeffs[i]]), 1:nup)

    i = MonomId(symbol_ht.offset)
    @inbounds while i <= symbol_ht.load
        if symbol_ht.labels[i] == NON_PIVOT_COLUMN
            symbol_ht.labels[i] = UNKNOWN_PIVOT_COLUMN
        end
        i += MonomId(1)
    end

    matrix.nrows_filled_lower = nlow
    matrix.nrows_filled_upper = nup
end

@timeit _TIMER function f4_autoreduce_apply!(
    trace::Trace,
    basis::Basis,
    matrix::MacaulayMatrix,
    hashtable::MonomialHashtable{M},
    symbol_ht::MonomialHashtable{M},
    f4_iteration::Int,
    cache_column_order::Bool,
    params::AlgorithmParameters
) where {M}
    lowrows, _ = trace.matrix_lower_rows[end]
    uprows, upmults = trace.matrix_upper_rows[end]
    nlow = length(lowrows)
    nup = length(uprows)

    resize!(matrix.upper_rows, nup)
    resize!(matrix.lower_rows, nlow)
    resize!(matrix.lower_to_coeffs, nlow)
    resize!(matrix.upper_to_coeffs, nup)

    matrix.ncols_left = 0
    matrix.ncols_right = 0
    matrix.nrows_filled_upper = nup
    matrix.nrows_filled_lower = nlow

    etmp = monom_construct_const(M, hashtable.nvars)
    # etmp is now set to zero, and has zero hash

    hashtable_resize_if_needed!(symbol_ht, nlow + nup + 2)

    # needed for correct column count in symbol hashtable
    matrix.ncols_left = matrix.nrows_filled_upper

    @inbounds for i in 1:nup
        mult_idx = upmults[i]
        poly_idx = uprows[i]

        h = hashtable.hashvals[mult_idx]
        etmp = hashtable.monoms[mult_idx]
        rpoly = basis.monoms[poly_idx]

        # vidx = hashtable_insert!(symbol_ht, etmp)
        matrix.upper_rows[i] =
            matrix_polynomial_multiple_to_row!(matrix, symbol_ht, hashtable, h, etmp, rpoly)

        matrix.upper_to_coeffs[i] = poly_idx
    end

    # set all pivots to unknown
    @inbounds for i in (symbol_ht.offset):(symbol_ht.load)
        symbol_ht.labels[i] = UNKNOWN_PIVOT_COLUMN
    end

    matrix.nrows_filled_lower = nlow
    matrix.nrows_filled_upper = nup

    if cache_column_order
        if length(trace.matrix_sorted_columns) >= f4_iteration
            matrix.column_to_monom = trace.matrix_sorted_columns[f4_iteration]
            matrix_fill_column_to_monom_map!(trace, matrix, symbol_ht)
        else
            matrix_fill_column_to_monom_map!(matrix, symbol_ht)
            push!(trace.matrix_sorted_columns, matrix.column_to_monom)
        end
    else
        matrix_fill_column_to_monom_map!(matrix, symbol_ht)
    end

    flag = linalg_autoreduce!(matrix, basis, params, linalg=LinearAlgebra(:apply, :sparse))
    !flag && return false

    matrix_convert_rows_to_basis_elements!(matrix, basis, hashtable, symbol_ht, params)

    # Check that the leading terms were not reduced to zero accidentally
    pivot_indices = trace.matrix_pivot_indices[f4_iteration]
    @inbounds for i in 1:(matrix.npivots)
        sgn = basis.monoms[basis.n_processed + i][1]
        sgn != pivot_indices[i] && return false
    end

    if cache_column_order
        matrix_pivot_signature =
            matrix_compute_pivot_signature(basis.monoms, basis.n_processed + 1, matrix.npivots)
        if matrix_pivot_signature != trace.matrix_pivot_signatures[f4_iteration]
            return false
        end
    end

    basis.n_filled = matrix.npivots + basis.n_processed
    basis.n_processed = matrix.npivots

    output_nonredundant = trace.output_nonredundant_indices
    for i in 1:length(output_nonredundant)
        basis.nonredundant_indices[i] = output_nonredundant[i]
        basis.divmasks[i] = hashtable.divmasks[basis.monoms[basis.nonredundant_indices[i]][1]]
    end
    basis.n_nonredundant = length(output_nonredundant)
    true
end

function f4_standardize_basis_in_apply!(ring::PolyRing, trace::Trace, arithmetic)
    basis = trace.gb_basis
    buf = trace.buf_basis
    basis.n_processed = basis.n_filled = basis.n_nonredundant
    output_nonredundant = trace.output_nonredundant_indices
    output_sort = trace.output_sort_indices
    @inbounds for i in 1:(basis.n_processed)
        basis.coeffs[i] = buf.coeffs[output_nonredundant[output_sort[i]]]
    end
    buf.n_processed = buf.n_nonredundant = 0
    buf.n_filled = trace.input_basis.n_filled
    basis_make_monic!(basis, arithmetic, false)
end

@timeit _TIMER function f4_apply!(trace::Trace, params::AlgorithmParameters)
    ring = trace.ring
    basis = trace.buf_basis
    hashtable = trace.hashtable

    @invariant basis_well_formed(ring, basis, trace.hashtable)
    @invariant params.reduced

    iters_total = length(trace.matrix_infos) - 1
    iters = 0

    basis_make_monic!(basis, params.arithmetic, params.changematrix)

    symbol_ht = hashtable_initialize_secondary(hashtable)
    matrix = matrix_initialize(ring, eltype(eltype(basis.coeffs)))

    basis_update!(basis, hashtable)

    cache_column_order = true

    while iters < iters_total
        iters += 1

        f4_symbolic_preprocessing!(trace, iters, basis, matrix, hashtable, symbol_ht)

        flag, new_cache_column_order = f4_reduction_apply!(
            trace,
            basis,
            matrix,
            hashtable,
            symbol_ht,
            iters,
            cache_column_order,
            params
        )
        !flag && return false
        cache_column_order = new_cache_column_order && cache_column_order

        basis_update!(basis, hashtable)

        hashtable_reinitialize!(symbol_ht)
    end

    if params.reduced
        symbol_ht = hashtable_initialize_secondary(hashtable)
        flag = f4_autoreduce_apply!(
            trace,
            basis,
            matrix,
            hashtable,
            symbol_ht,
            iters_total + 1,
            cache_column_order,
            params
        )
        !flag && return false
    end

    f4_standardize_basis_in_apply!(ring, trace, params.arithmetic)

    trace.napply += 1

    @invariant basis_well_formed(ring, trace.gb_basis, hashtable)

    true
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

###
# High level

function linalg_deterministic_sparse!(
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    arithmetic::AbstractArithmetic
)
    sort_matrix_upper_rows!(matrix) # for the AB part
    sort_matrix_lower_rows!(matrix) # for the CD part

    @invariant matrix.nrows_filled_upper == matrix.ncols_left
    for i in 1:(matrix.nrows_filled_upper)
        @invariant matrix.upper_rows[i][1] == i
    end

    # Reduce CD with AB
    linalg_reduce_matrix_lower_part!(matrix, basis, arithmetic)
    # Interreduce CD
    linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic)
    true
end

function linalg_deterministic_sparse_interreduction!(
    matrix::MacaulayMatrix,
    basis::Basis,
    arithmetic::AbstractArithmetic
)
    sort_matrix_upper_rows!(matrix)

    # Prepare the matrix
    linalg_prepare_matrix_pivots_in_interreduction!(matrix, basis)
    # Interreduce AB
    linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic, left_to_right=true)
    true
end

###
# Low level

# Given a matrix of the following form, where A is in REF,
#   A B
#   C D
# reduces the lower part CD with respect to the pivots in the upper part AB.
# As a result, a matrix of the following form is produced:
#   A B
#   0 D'
# The new pivots in the D' block are known, but possibly not fully interreduced.
function linalg_reduce_matrix_lower_part!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    _, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_index_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, nlow)

    # Allocate the buffers
    # TODO: allocate just once, and then reuse for later iterations of F4
    row = [AccumType(zero(basis.coeffs[1][1])) for _ in 1:ncols]
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)

    # At each iteration, take a row from the lower part of the matrix (from the
    # CD block), reduce it by the pivots, and put the result back to the matrix
    @inbounds for i in 1:nlow
        # Select a row to be reduced from the lower part of the matrix
        # NOTE: no copy of coefficients is needed
        sparse_row_support = matrix.lower_rows[i]
        sparse_row_coeffs = basis.coeffs[row_index_to_coeffs[i]]
        @invariant length(sparse_row_support) == length(sparse_row_coeffs)

        # Load the coefficients into a dense array
        linalg_load_sparse_row!(row, sparse_row_support, sparse_row_coeffs)

        # Reduce the row with respect to the known pivots
        first_nnz_column = sparse_row_support[1]
        zeroed = linalg_reduce_dense_row_by_pivots_sparse!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            first_nnz_column,
            ncols,
            arithmetic
        )

        # If the row is fully reduced
        zeroed && continue

        @invariant length(new_sparse_row_support) == length(new_sparse_row_coeffs)
        linalg_row_make_monic!(new_sparse_row_coeffs, arithmetic)

        # Store the new row in the matrix, AND add the new row to the list of
        # known pivots
        pivots[new_sparse_row_support[1]] = new_sparse_row_support

        matrix.some_coeffs[i] = new_sparse_row_coeffs
        matrix.lower_to_coeffs[new_sparse_row_support[1]] = i

        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
    end

    true
end

# Given a matrix of the form,
#   A B
#   0 D'
# interreduces the D' block. Stores results in the lower part of the matrix inplace.
#
# Assumes that the pivots in the matrix are correctly filled.
# 
# Returns the indices of the rows that did not reduce to zero.
function linalg_interreduce_matrix_pivots!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType};
    left_to_right::Bool=false
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    nleft, nright = matrix_ncols_filled(matrix)

    # Prepare the matrix
    resize!(matrix.lower_rows, nright)
    pivots = matrix.pivots
    new_pivots = 0
    any_zeroed = false

    # Allocate the buffers
    row = [AccumType(zero(basis.coeffs[1][1])) for _ in 1:ncols]
    # Indices of rows that did no reduce to zero
    not_reduced_to_zero = Vector{Int}(undef, nright)

    # Visit pivot columns in the order in which output rows should be stored.
    # Ordinary F4 reduction goes 1...n, whereas final autoreduction n...1.
    column_indices = left_to_right ? ((nleft + 1):ncols) : (ncols:-1:(nleft + 1))
    @inbounds for abs_column_idx in column_indices
        # Check if there is a row that starts at `abs_column_idx`
        !isassigned(pivots, abs_column_idx) && continue

        # Locate the row support and coefficients
        sparse_row_support = pivots[abs_column_idx]
        if abs_column_idx <= nleft
            # upper part of matrix
            sparse_row_coeffs = basis.coeffs[matrix.upper_to_coeffs[abs_column_idx]]
        else
            # lower part of matrix
            sparse_row_coeffs = matrix.some_coeffs[matrix.lower_to_coeffs[abs_column_idx]]
        end
        @invariant length(sparse_row_support) == length(sparse_row_coeffs)

        # Load the row into a dense array
        linalg_load_sparse_row!(row, sparse_row_support, sparse_row_coeffs)

        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
        first_nnz_column = sparse_row_support[1]
        zeroed = linalg_reduce_dense_row_by_pivots_sparse!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            first_nnz_column,
            ncols,
            arithmetic,
            ignore_column=first_nnz_column
        )

        # If the row reduced to zero
        if zeroed
            any_zeroed = true
            continue
        end

        new_pivots += 1
        not_reduced_to_zero[new_pivots] =
            left_to_right ? (abs_column_idx - nleft) : (ncols - abs_column_idx + 1)

        # Update the row support and coefficients.
        matrix.lower_rows[new_pivots] = new_sparse_row_support
        matrix.some_coeffs[matrix.lower_to_coeffs[abs_column_idx]] = new_sparse_row_coeffs
        pivots[abs_column_idx] = matrix.lower_rows[new_pivots]
    end

    matrix.npivots = new_pivots
    resize!(matrix.lower_rows, new_pivots)
    resize!(not_reduced_to_zero, new_pivots)

    true, any_zeroed, not_reduced_to_zero
end

function linalg_reduce_matrix_lower_part_do_not_modify_pivots!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    _, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_idx_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, nlow)

    # Allocate the buffers
    row = [AccumType(zero(basis.coeffs[1][1])) for _ in 1:ncols]
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)

    @inbounds for i in 1:nlow
        sparse_row_support = matrix.lower_rows[i]
        sparse_row_coeffs = matrix.some_coeffs[row_idx_to_coeffs[i]]

        linalg_load_sparse_row!(row, sparse_row_support, sparse_row_coeffs)

        first_nnz_column = sparse_row_support[1]
        _ = linalg_reduce_dense_row_by_pivots_sparse!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            # first_nnz_column,
            # TODO: using first_nnz_column is incorrect here; 
            # for the counter-example see
            # https://github.com/sumiya11/Groebner.jl/issues/82
            1,
            ncols,
            arithmetic
        )

        # NOTE: no normalization here
        # NOTE: the array may be empty, signalling the row is zero
        @invariant length(new_sparse_row_coeffs) == length(new_sparse_row_support)

        matrix.some_coeffs[i] = new_sparse_row_coeffs
        matrix.lower_rows[i] = new_sparse_row_support
        matrix.lower_to_coeffs[i] = i

        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)
    end

    matrix.npivots = matrix.nrows_filled_lower = matrix.nrows_filled_lower
end

function linalg_reduce_matrix_lower_part_all_zero!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    arithmetic::AbstractArithmetic{AccumType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    _, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_idx_to_coeffs = linalg_prepare_matrix_pivots!(matrix)

    # Allocate the buffers
    row = [AccumType(zero(basis.coeffs[1][1])) for _ in 1:ncols]
    new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)

    @inbounds for i in 1:nlow
        sparse_row_support = matrix.lower_rows[i]
        sparse_row_coeffs = basis.coeffs[row_idx_to_coeffs[i]]

        linalg_load_sparse_row!(row, sparse_row_support, sparse_row_coeffs)

        first_nnz_column = sparse_row_support[1]
        zeroed = linalg_reduce_dense_row_by_pivots_sparse!(
            new_sparse_row_support,
            new_sparse_row_coeffs,
            row,
            matrix,
            basis,
            pivots,
            first_nnz_column,
            ncols,
            arithmetic
        )

        # If fully reduced
        zeroed && continue

        return false
    end

    true
end

###
# Utilities

function linalg_prepare_matrix_pivots!(matrix::MacaulayMatrix)
    _, ncols = size(matrix)
    nup, nlow = matrix_nrows_filled(matrix)

    pivots = Vector{Vector{ColumnLabel}}(undef, ncols)
    @inbounds for i in 1:nup
        pivots[matrix.upper_rows[i][1]] = matrix.upper_rows[i]
    end

    absolute_lower_to_coeffs = Vector{Int}(undef, max(ncols, nlow))
    @inbounds for i in 1:nlow
        absolute_lower_to_coeffs[matrix.lower_rows[i][1]] = matrix.lower_to_coeffs[i]
    end

    lower_to_coeffs = matrix.lower_to_coeffs
    matrix.lower_to_coeffs = absolute_lower_to_coeffs
    matrix.pivots = pivots

    pivots, lower_to_coeffs
end

function linalg_prepare_matrix_pivots_in_interreduction!(matrix::MacaulayMatrix, basis::Basis)
    _, ncols = size(matrix)
    nup, nlow = matrix_nrows_filled(matrix)
    nrows = nup + nlow
    row_or_column_size = max(nrows, ncols)

    resize!(matrix.lower_rows, ncols)
    resize!(matrix.upper_to_coeffs, row_or_column_size)
    resize!(matrix.upper_to_mult, row_or_column_size)
    resize!(matrix.lower_to_coeffs, ncols)
    resize!(matrix.lower_to_mult, ncols)
    resize!(matrix.some_coeffs, row_or_column_size)

    pivots = Vector{Vector{ColumnLabel}}(undef, ncols)
    @inbounds for i in 1:nrows
        pivots[matrix.upper_rows[i][1]] = matrix.upper_rows[i]
        matrix.lower_to_coeffs[matrix.upper_rows[i][1]] = i
        matrix.some_coeffs[i] = copy(basis.coeffs[matrix.upper_to_coeffs[i]])
    end

    matrix.pivots = pivots

    pivots
end

###
# Reducing one dense vector by many pivots.

# Reduces the given dense row by the given pivots.
#
# Returns `true` if the row is reduced to zero and `false`, otherwise.
# Writes the nonzero elements of the resulting row to `new_sparse_row_support`
# and `new_sparse_row_coeffs`.
#
# The function may mutate
#   - `new_sparse_row_support`,
#   - `new_sparse_row_coeffs`, 
#   - `row`.
# It also mutates `active_reducers`, if provided.
function linalg_reduce_dense_row_by_pivots_sparse!(
    new_sparse_row_support::Vector{I},
    new_sparse_row_coeffs::Vector{C},
    row::Vector{A},
    matrix::MacaulayMatrix{C},
    basis::Basis{C},
    pivots::Vector{Vector{I}},
    start_column::Integer,
    end_column::Integer,
    arithmetic::AbstractArithmeticZp{A, C},
    active_reducers=nothing;
    ignore_column::Integer=-1
) where {I, C <: Union{CoeffZp, CompositeCoeffZp}, A <: Union{CoeffZp, CompositeCoeffZp}}
    _, ncols = size(matrix)
    nleft, _ = matrix_ncols_filled(matrix)

    n_nonzeros = 0
    new_pivot_column = -1

    @inbounds for i in start_column:end_column
        # if the element is zero -- no reduction is needed
        if iszero(row[i])
            continue
        end

        # if there is no pivot with the leading column equal to i
        if !isassigned(pivots, i) || ignore_column == i
            if new_pivot_column == -1
                new_pivot_column = i
            end
            n_nonzeros += 1
            continue
        end
        # At this point, we have determined that pivots[i] is a valid pivot.

        # Locate the support and the coefficients of the pivot row
        pivot_support = pivots[i]
        if i <= nleft
            # if pivot comes from the original pivots
            pivot_coeffs = basis.coeffs[matrix.upper_to_coeffs[i]]
            record_active_reducer(active_reducers, matrix, i)
        else
            pivot_coeffs = matrix.some_coeffs[matrix.lower_to_coeffs[i]]
        end
        @invariant length(pivot_support) == length(pivot_coeffs)

        linalg_vector_addmul_sparsedense_mod_p!(row, pivot_support, pivot_coeffs, arithmetic)

        @invariant iszero(row[i])
    end

    # all row elements reduced to zero!
    if n_nonzeros == 0
        return true
    end

    # form the resulting row in sparse format
    resize!(new_sparse_row_support, n_nonzeros)
    resize!(new_sparse_row_coeffs, n_nonzeros)
    linalg_extract_sparse_row!(
        new_sparse_row_support,
        new_sparse_row_coeffs,
        row,
        convert(Int, start_column),
        ncols
    )

    false
end

# Specialization for delayed modular arithmetic
function linalg_reduce_dense_row_by_pivots_sparse!(
    new_sparse_row_support::Vector{I},
    new_sparse_row_coeffs::Vector{C},
    row::Vector{A},
    matrix::MacaulayMatrix{C},
    basis::Basis{C},
    pivots::Vector{Vector{I}},
    start_column::Integer,
    end_column::Integer,
    arithmetic::DelayedArithmeticZp{A, C},
    active_reducers=nothing;
    ignore_column::Integer=-1
) where {I, C <: CoeffZp, A <: CoeffZp}
    _, ncols = size(matrix)
    nleft, _ = matrix_ncols_filled(matrix)

    n_nonzeros = 0
    new_pivot_column = -1

    n_adds = 0
    n_safe = n_safe_consecutive_additions(arithmetic)

    @inbounds for i in start_column:end_column
        # if the element is zero - no reduction is needed
        row[i] = mod_p(row[i], arithmetic)
        if iszero(row[i])
            continue
        end

        # if there is no pivot with the leading column index equal to i
        if !isassigned(pivots, i) || ignore_column == i
            if new_pivot_column == -1
                new_pivot_column = i
            end
            n_nonzeros += 1
            continue
        end
        # at this point, we have determined that row[i] is nonzero and that
        # pivots[i] is a valid reducer of row

        # Locate the support and the coefficients of the reducer row
        indices = pivots[i]
        if i <= nleft
            # if reducer is from the upper part of the matrix
            coeffs = basis.coeffs[matrix.upper_to_coeffs[i]]
            record_active_reducer(active_reducers, matrix, i)
        else
            # if reducer is from the lower part of the matrix
            coeffs = matrix.some_coeffs[matrix.lower_to_coeffs[i]]
        end
        @invariant length(indices) == length(coeffs)

        linalg_vector_addmul_sparsedense!(row, indices, coeffs, arithmetic)

        n_adds += 1
        if iszero(n_adds % n_safe)
            linalg_dense_row_mod_p!(row, arithmetic, i, end_column)
        end
        row[i] = zero(row[i])

        @invariant iszero(row[i])
    end

    # all reduced to zero!
    if n_nonzeros == 0
        return true
    end

    # form the resulting row in sparse format
    resize!(new_sparse_row_support, n_nonzeros)
    resize!(new_sparse_row_coeffs, n_nonzeros)
    linalg_extract_sparse_row!(
        new_sparse_row_support,
        new_sparse_row_coeffs,
        row,
        convert(Int, start_column),
        ncols
    )

    false
end

# Specialization for signed modular arithmetic
function linalg_reduce_dense_row_by_pivots_sparse!(
    new_sparse_row_support::Vector{I},
    new_sparse_row_coeffs::Vector{C},
    row::Vector{A},
    matrix::MacaulayMatrix{C},
    basis::Basis{C},
    pivots::Vector{Vector{I}},
    start_column::Integer,
    end_column::Integer,
    arithmetic::Union{SignedArithmeticZp{A, C}, SignedCompositeArithmeticZp{A, C}},
    active_reducers=nothing;
    ignore_column::Integer=-1
) where {I, C <: Union{CoeffZp, CompositeCoeffZp}, A <: Union{CoeffZp, CompositeCoeffZp}}
    _, ncols = size(matrix)
    nleft, _ = matrix_ncols_filled(matrix)

    n_nonzeros = 0
    new_pivot_column = -1

    @inbounds for i in start_column:end_column
        # if the element is zero - no reduction is needed
        if iszero(row[i])
            continue
        end
        row[i] = mod_p(row[i], arithmetic)
        if iszero(row[i])
            continue
        end

        # if there is no pivot with the leading column index equal to i
        if !isassigned(pivots, i) || ignore_column == i
            if new_pivot_column == -1
                new_pivot_column = i
            end
            n_nonzeros += 1
            continue
        end
        # at this point, we have determined that row[i] is nonzero and that
        # pivots[i] is a valid reducer of row

        # Locate the support and the coefficients of the reducer row
        indices = pivots[i]
        if i <= nleft
            # if reducer is from the upper part of the matrix
            coeffs = basis.coeffs[matrix.upper_to_coeffs[i]]
            record_active_reducer(active_reducers, matrix, i)
        else
            # if reducer is from the lower part of the matrix
            coeffs = matrix.some_coeffs[matrix.lower_to_coeffs[i]]
        end
        @invariant length(indices) == length(coeffs)

        linalg_vector_addmul_sparsedense!(row, indices, coeffs, arithmetic)

        @invariant iszero(row[i])
    end

    if n_nonzeros == 0
        return true
    end

    if end_column != length(row)
        linalg_dense_row_mod_p!(row, arithmetic, end_column + 1, length(row))
    end

    # form the resulting row in sparse format
    resize!(new_sparse_row_support, n_nonzeros)
    resize!(new_sparse_row_coeffs, n_nonzeros)
    linalg_extract_sparse_row!(
        new_sparse_row_support,
        new_sparse_row_coeffs,
        row,
        convert(Int, start_column),
        ncols
    )

    false
end

# Generic fallback.
function linalg_reduce_dense_row_by_pivots_sparse!(
    new_sparse_row_support::Vector{I},
    new_sparse_row_coeffs::Vector{C},
    row::Vector{C},
    matrix::MacaulayMatrix{C},
    basis::Basis{C},
    pivots::Vector{Vector{I}},
    start_column::Integer,
    end_column::Integer,
    arithmetic::AbstractArithmetic,
    active_reducers=nothing;
    ignore_column::Integer=-1
) where {I, C <: Coeff}
    _, ncols = size(matrix)
    nleft, _ = matrix_ncols_filled(matrix)

    n_nonzeros = 0
    new_pivot_column = -1

    @inbounds for i in start_column:end_column
        # if the element is zero - no reduction is needed
        if iszero(row[i])
            continue
        end

        # if there is no pivot with the leading column index equal to i
        if !isassigned(pivots, i) || ignore_column == i
            if new_pivot_column == -1
                new_pivot_column = i
            end
            n_nonzeros += 1
            continue
        end
        # at this point, we have determined that row[i] is nonzero and that
        # pivots[i] is a valid reducer of row

        # Locate the support and the coefficients of the reducer row
        indices = pivots[i]
        if i <= nleft
            # if reducer is from the upper part of the matrix
            coeffs = basis.coeffs[matrix.upper_to_coeffs[i]]
            record_active_reducer(active_reducers, matrix, i)
        else
            # if reducer is from the lower part of the matrix
            coeffs = matrix.some_coeffs[matrix.lower_to_coeffs[i]]
        end
        @invariant length(indices) == length(coeffs)

        linalg_vector_addmul_sparsedense!(row, indices, coeffs, arithmetic)

        @invariant iszero(row[i])
    end

    # all reduced to zero!
    if n_nonzeros == 0
        return true
    end

    # form the resulting row in sparse format
    resize!(new_sparse_row_support, n_nonzeros)
    resize!(new_sparse_row_coeffs, n_nonzeros)
    linalg_extract_sparse_row!(
        new_sparse_row_support,
        new_sparse_row_coeffs,
        row,
        convert(Int, start_column),
        ncols
    )

    false
end

###
# Basic routines for dense and sparse vectors

function linalg_new_empty_sparse_row(::Type{C}) where {C <: Coeff}
    Vector{ColumnLabel}(), Vector{C}()
end

function linalg_dense_row_mod_p!(
    row::Vector{T},
    arithmetic::AbstractArithmeticZp{T},
    from::Int=1,
    to::Int=length(row)
) where {T <: Union{CoeffZp, CompositeCoeffZp}}
    # This loop is usually successfully vectorized for all kinds of arithmetic.
    # Still, the resulting code may be not optimal
    @fastmath @inbounds for i in from:to
        row[i] = mod_p(row[i], arithmetic)
    end
    nothing
end

# Returns false when the row has 0 at the first_nnz_index position,
# but a nonzero was expected.
function linalg_row_make_monic!(
    row::Vector{T},
    arithmetic::AbstractArithmeticZp{A, T},
    first_nnz_index::Int=1
) where {A <: CoeffZp, T <: CoeffZp}
    @inbounds lead = row[first_nnz_index]
    iszero(lead) && return false, lead
    isone(lead) && return true, lead

    @inbounds pinv = inv_mod_p(A(lead), arithmetic) % T
    @inbounds row[first_nnz_index] = one(T)
    @inbounds for i in (first_nnz_index + 1):length(row)
        row[i] = mod_p(A(row[i]) * A(pinv), arithmetic) % T
    end

    true, pinv
end

function linalg_row_make_monic!(
    row::Vector{T},
    arithmetic::AbstractArithmeticZp{A, T},
    first_nnz_index::Int=1
) where {A <: CompositeCoeffZp, T <: CompositeCoeffZp}
    @inbounds lead = row[first_nnz_index]
    # Composite coefficients are invertible only when every component is nonzero.
    any(iszero, lead.data) && return false, lead
    isone(lead) && return true, lead

    @inbounds pinv = inv_mod_p(A(lead), arithmetic) % T
    @inbounds row[first_nnz_index] = one(T)
    @inbounds for i in (first_nnz_index + 1):length(row)
        row[i] = mod_p(A(row[i]) * A(pinv), arithmetic) % T
    end

    true, pinv
end

# Generic fallback
function linalg_row_make_monic!(
    row::Vector{T},
    arithmetic::AbstractArithmetic,
    first_nnz_index::Int=1
) where {T <: Coeff}
    @inbounds lead = row[first_nnz_index]
    iszero(lead) && return false, lead
    isone(lead) && return true, lead

    @inbounds pinv = inv(lead)
    @inbounds row[1] = one(row[1])
    @inbounds for i in 2:length(row)
        row[i] = row[i] * pinv
    end

    true, pinv
end

# Linear combination of dense vector and sparse vector
# with explicit reduction modulo a prime.
function linalg_vector_addmul_sparsedense_mod_p!(
    row::Vector{A},
    indices::Vector{I},
    coeffs::Vector{T},
    arithmetic::AbstractArithmeticZp
) where {I, A <: Union{CoeffZp, CompositeCoeffZp}, T <: Union{CoeffZp, CompositeCoeffZp}}
    @invariant isone(coeffs[1])
    @invariant length(indices) == length(coeffs)
    @invariant !isempty(indices)

    @inbounds mul = divisor(arithmetic) - row[indices[1]]
    @inbounds for j in 1:length(indices)
        idx = indices[j]
        # if A === T, then the type cast is a no-op
        a = row[idx] + A(mul) * A(coeffs[j])
        row[idx] = mod_p(a, arithmetic)
    end

    mul
end

# Linear combination of dense vector and sparse vector.
function linalg_vector_addmul_sparsedense!(
    row::Vector{A},
    indices::Vector{I},
    coeffs::Vector{T},
    arithmetic::AbstractArithmeticZp
) where {I, A <: Union{CoeffZp, CompositeCoeffZp}, T <: Union{CoeffZp, CompositeCoeffZp}}
    @invariant isone(coeffs[1])
    @invariant length(indices) == length(coeffs)
    @invariant !isempty(indices)

    @inbounds mul = divisor(arithmetic) - row[indices[1]]
    @inbounds for j in 1:length(indices)
        idx = indices[j]
        # if A === T, then the type cast is a no-op
        a = row[idx] + A(mul) * A(coeffs[j])
        row[idx] = a
    end

    nothing
end

# Linear combination of dense vector and sparse vector.
function linalg_vector_addmul_sparsedense!(
    row::Vector{A},
    indices::Vector{I},
    coeffs::Vector{T},
    arithmetic::SignedArithmeticZp{A, T}
) where {I, A <: CoeffZp, T <: CoeffZp}
    @invariant isone(coeffs[1])
    @invariant length(indices) == length(coeffs)
    @invariant !isempty(indices)

    p2 = arithmetic.p2
    @invariant row[indices[1]] < typemax(T)
    @inbounds mul = row[indices[1]] % T

    @fastmath @inbounds for j in 1:length(indices)
        idx = indices[j]
        a = row[idx] - A(mul) * A(coeffs[j])
        a = a + ((a >> (8 * sizeof(A) - 1)) & p2)
        row[idx] = a
    end

    nothing
end

# Linear combination of dense vector and sparse vector.
function linalg_vector_addmul_sparsedense!(
    row::Vector{CompositeNumber{N, A}},
    indices::Vector{I},
    coeffs::Vector{CompositeNumber{N, T}},
    arithmetic::SignedCompositeArithmeticZp{CompositeNumber{N, A}, CompositeNumber{N, T}}
) where {I, A <: CoeffZp, T <: CoeffZp, N}
    @invariant isone(coeffs[1])
    @invariant length(indices) == length(coeffs)
    @invariant !isempty(indices)

    p2 = arithmetic.p2s
    @invariant row[indices[1]] < typemax(T)
    @inbounds mul = row[indices[1]].data .% T

    @fastmath @inbounds for j in 1:length(indices)
        idx = indices[j]
        a = row[idx].data .- A.(mul) .* A.(coeffs[j].data)
        a = a .+ ((a .>> (8 * sizeof(A) - 1)) .& p2.data)
        row[idx] = CompositeNumber(a)
    end

    nothing
end

# Generic fallback.
function linalg_vector_addmul_sparsedense!(
    row::Vector{A},
    indices::Vector{I},
    coeffs::Vector{T},
    arithmetic::AbstractArithmetic
) where {I, A <: Coeff, T <: Coeff}
    @invariant isone(coeffs[1])
    @invariant length(indices) == length(coeffs)
    @invariant !isempty(indices)

    @inbounds mul = -row[indices[1]]
    @inbounds for j in 1:length(indices)
        idx = indices[j]
        row[idx] = row[idx] + A(mul) * coeffs[j]
    end

    nothing
end

# Loads the given sparse row into the given dense row.
# Zero out the entries of the dense row before that.
function linalg_load_sparse_row!(
    row::Vector{A},
    indices::Vector{I},
    coeffs::Vector{T}
) where {I, A <: Coeff, T <: Coeff}
    @invariant length(indices) == length(coeffs)

    @inbounds z = zero(row[1])
    @inbounds for i in 1:length(row)
        row[i] = z
    end

    @inbounds for j in 1:length(indices)
        row[indices[j]] = A(coeffs[j])
    end

    nothing
end

# Extracts nonzeroes from the given dense row into the given sparse row.
# Returns the number of extracted nonzeroes.
function linalg_extract_sparse_row!(
    indices::Vector{I},
    coeffs::Vector{T},
    row::Vector{A},
    from::Int,
    to::Int
) where {I, T <: Coeff, A <: Coeff}
    # NOTE: assumes that the sparse row has the necessary capacity
    @invariant length(indices) == length(coeffs)
    @invariant 1 <= from <= to <= length(row)

    nnz = 1
    @inbounds for i in from:to
        if !iszero(row[i])
            indices[nnz] = i
            @invariant row[i] <= typemax(T)
            coeffs[nnz] = row[i] % T
            nnz += 1
        end
    end

    @invariant nnz - 1 <= length(coeffs)
    nnz - 1
end

# Generic fallback.
function linalg_extract_sparse_row!(
    indices::Vector{I},
    coeffs::Vector{T},
    row::Vector{T},
    from::Int,
    to::Int
) where {I, T <: Coeff}
    # NOTE: assumes that the sparse row has the necessary capacity
    @invariant length(indices) == length(coeffs)
    @invariant 1 <= from <= to <= length(row)

    nnz = 1
    @inbounds for i in from:to
        if !iszero(row[i])
            indices[nnz] = i
            coeffs[nnz] = row[i]
            nnz += 1
        end
    end

    @invariant nnz - 1 <= length(coeffs)
    nnz - 1
end

using SmallCollections: FixedVector, SmallVector, fixedvector, setindex, sum_fast, bits

monom_max_vars(a::FixedVector) = monom_max_vars(typeof(a))

function monom_overflow_check(a::FixedVector)
    c = ~a[end]
    signbit(signed(c)) && __throw_monom_overflow_error()
end

monom_max_vars(::Type{A}) where {A <: FixedVector} = capacity(A) - 1
monom_totaldeg(a::FixedVector{N, T}) where {N, T} = ~a[end] % T
monom_copy(a::FixedVector) = a

function monom_construct_hash_vector(
    rng::AbstractRNG,
    ::Type{<:FixedVector{N}},
    ::Integer
) where {N}
    setindex(rand(rng, FixedVector{N, MonomHash}), zero(MonomHash), N)
end

function monom_construct_from_vector(::Type{FixedVector{N, T}}, ev::AbstractVector) where {N, T}
    d = sum(ev)
    d <= typemax(signed(T)) || __throw_monom_overflow_error()
    a = fixedvector(SmallVector{N, T}(ev))
    setindex(a, ~(d % T), N)
end

function monom_construct_const(::Type{FixedVector{N, T}}, ::Integer) where {N, T}
    setindex(zero(FixedVector{N, T}), ~zero(T), N)
end

function monom_hash(a::FixedVector{N}, b::FixedVector{N}) where {N}
    dot_fast(a, b) % MonomHash
end

function monom_to_vector!(tmp::AbstractVector, a::FixedVector)
    copyto!(tmp, 1, a, 1, length(tmp))
end

function monom_is_supported_ordering(::Type{<:FixedVector}, ::Ord) where {Ord}
    Ord <: Union{DegLex{true}, DegRevLex{true}, InputOrdering}
end

function monom_isless(a::FixedVector{N}, b::FixedVector{N}, ::DegLex{true}) where {N}
    a[end] > b[end] || (a[end] == b[end] && a < b)
end

function monom_isless(a::FixedVector{N}, b::FixedVector{N}, ::DegRevLex{true}) where {N}
    if sizeof(a) <= 64
        bits(a) > bits(b)
    else
        aev = reinterpret(UInt64, a)
        bev = reinterpret(UInt64, b)
        @inbounds for i in length(aev):-1:1
            aev[i] != bev[i] && return aev[i] > bev[i]
        end
        false
    end
end

function monom_lcm!(_, a::FixedVector{N, T}, b::FixedVector{N, T}) where {N, T}
    u = FixedVector{N, T}(ntuple(i -> i == N ? zero(T) : ~zero(T), Val(N)))
    c = max.(a, b) .& u
    c = setindex(c, ~sum_fast(c), N)
    monom_overflow_check(c)
    c
end

function monom_is_gcd_const(a::FixedVector{N}, b::FixedVector{N}) where {N}
    a1 = bits(map(!iszero, a))
    b1 = bits(map(!iszero, b))
    l = one(a1) << (N - 1)
    iszero(a1 & b1 & ~l)
end

function monom_product!(_, a::FixedVector{N, T}, b::FixedVector{N, T}) where {N, T}
    u = FixedVector{N, T}(ntuple(k -> T(k == N), Val(N)))
    c = a + b + u
    monom_overflow_check(c)
    c
end

function monom_division!(_, a::FixedVector{N, T}, b::FixedVector{N, T}) where {N, T}
    u = FixedVector{N, T}(ntuple(k -> T(k == N), Val(N)))
    c = a - b - u
end

function monom_is_divisible(a::FixedVector{N}, b::FixedVector{N}) where {N}
    m = bits(a .< b)
    l = one(m) << (N - 1)
    iszero(m & ~l)
end

function monom_is_divisible!(_, a::FixedVector{N}, b::FixedVector{N}) where {N}
    monom_is_divisible(a, b) ? (true, monom_division!(a, a, b)) : (false, a)
    # the first `a` argument for `monom_division!` is a dummy
end

function monom_is_equal(a::FixedVector{N}, b::FixedVector{N}) where {N}
    a == b
end

function monom_create_divmask(
    e::FixedVector,
    ::Type{Mask},
    ndivvars::Int,
    divmap::Vector{U},
    ndivbits::Int,
    strategy::Symbol
) where {Mask, U}
    @invariant strategy == :first_variables
    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)
    @inbounds for i in 1:ndivvars
        for _ in 1:ndivbits
            if e[i] >= divmap[ctr]
                res |= o << ((ctr - 1) % UInt)
            end
            ctr += o
        end
    end
    res
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# This file provides some operations on packed integers.
# One 64-bit integer packs 8 integers 8-bit each.

# checks that a[i] >= b[i] for all i.
@inline @generated function _packed_vec_ge(a::UInt64, b::UInt64)
    N = 8
    textir = """
    define i8 @entry(i64 %0, i64 %1) #0 {
    top:
        %av      = bitcast i64 %0 to <$N x i8>
        %bv      = bitcast i64 %1 to <$N x i8>
        %mask    = icmp uge <$N x i8> %av, %bv
        %mask.i  = bitcast <$N x i1> %mask to i$N
        %res     = icmp eq i$N %mask.i, $(big(2)^N - 1)
        %retval  = zext i1 %res to i8
        ret i8 %retval
    }
    attributes #0 = { alwaysinline }
    """
    quote
        Base.llvmcall(($textir, "entry"), Bool, Tuple{UInt64, UInt64}, a, b)
    end
end

# checks that a, b are orthogonal
@inline @generated function _packed_vec_is_orth(a::UInt64, b::UInt64)
    N = 8
    textir = """
    define i8 @entry(i64 %0, i64 %1) #0 {
    top:
        %av      = bitcast i64 %0 to <$N x i8>
        %bv      = bitcast i64 %1 to <$N x i8>
        %zero    = bitcast i64 0 to <$N x i8>
        %mask.a  = icmp ne <$N x i8> %av, %zero
        %mask.b  = icmp ne <$N x i8> %bv, %zero
        %mask    = and <$N x i1> %mask.a, %mask.b
        %mask.i  = bitcast <$N x i1> %mask to i$N
        %res     = icmp eq i$N %mask.i, 0
        %retval  = zext i1 %res to i8
        ret i8 %retval
    }
    attributes #0 = { alwaysinline }
    """
    quote
        Base.llvmcall(($textir, "entry"), Bool, Tuple{UInt64, UInt64}, a, b)
    end
end

# returns sum a[i]
@inline @generated function _packed_vec_reduce(a::UInt64)
    N = 8
    textir = """
    declare i8 @llvm.vector.reduce.add.v$(N)i8(<$N x i8>)
    define i8 @entry(i64 %0) #0 {
    top:
        %a.v    = bitcast i64 %0 to <$N x i8>
        %sum    = call i8 @llvm.vector.reduce.add.v$(N)i8(<$N x i8> %a.v)
        ret i8 %sum
    }
    attributes #0 = { alwaysinline }
    """
    quote
        Base.llvmcall(($textir, "entry"), UInt8, Tuple{UInt64}, a)
    end
end

# returns c[i] = max a[i], b[i]
@inline @generated function _packed_vec_max(a::UInt64, b::UInt64)
    N = 8
    textir = """
    declare <$N x i8> @llvm.umax.v$(N)i8(<$N x i8>, <$N x i8>)
    define i64 @entry(i64 %0, i64 %1) #0 {
    top:
        %a.v    = bitcast i64 %0 to <$N x i8>
        %b.v    = bitcast i64 %1 to <$N x i8>
        %max.v  = call <$N x i8> @llvm.umax.v$(N)i8(<$N x i8> %a.v, <$N x i8> %b.v)
        %max    = bitcast <$N x i8> %max.v to i64
        ret i64 %max
    }
    attributes #0 = { alwaysinline }
    """
    quote
        Base.llvmcall(($textir, "entry"), UInt64, Tuple{UInt64, UInt64}, a, b)
    end
end

@inline @generated function _packed_vec_unpack!(
    b::AbstractVector{MH},
    a::T,
    ::Type{B},
    I::Integer
) where {T, MH, B}
    ts, bs = sizeof(T), sizeof(B)
    @assert bs * div(ts, bs) == ts
    epc = div(ts, bs)
    shift = bs * 8
    ans = :()
    for i in 1:epc
        ans = :($ans;
        ($i + I > $epc) && return $b;
        @inbounds b[$i] = mod(a, $B);
        a = a >> $shift)
    end
    :($ans; return $b)
end

@inline @generated function _packed_vec_dot(
    a::T,
    b::AbstractVector{MH},
    ::Type{B},
    I::Integer
) where {T, MH, B}
    ts, bs = sizeof(T), sizeof(B)
    @assert bs * div(ts, bs) == ts
    epc = div(ts, bs)
    shift = bs * 8
    x = :x
    ans = :(x = $MH(0))
    for i in 1:epc
        ans = :($ans;
        ($i + I > $epc) && return $x;
        @inbounds iz = $MH(mod(a, $B)) * b[$i];
        x = x + iz;
        a = a >> $shift)
    end
    :($ans; return $x)
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Select parameters in Groebner basis computation

# Specifies linear algebra algorithm
struct LinearAlgebra
    algorithm::Symbol
    sparsity::Symbol
end

# Specifies polynomial representation
struct PolynomialRepresentation
    monomtype::Any
    coefftype::Any
    # If this field is false, then any implementation of the arithmetic in Z/Zp
    # must cast the coefficients into a wider integer type before performing any
    # arithmetic operations to avoid the risk of overflow.
    using_wide_type_for_coeffs::Bool
end

function param_select_polynomial_representation(
    char::Coeff,
    nvars::Int,
    ground::Symbol,
    ordering::AbstractMonomialOrdering,
    homogenize::Bool,
    monoms::Symbol,
    arithmetic::Symbol;
    hint::Symbol=:none
)
    if !(hint in (:none, :large_exponents))
        @info "The given hint=$hint was discarded"
    end
    monomtype = param_select_monomtype(char, nvars, ordering, homogenize, hint, monoms)
    coefftype, using_wide_type_for_coeffs =
        param_select_coefftype(char, nvars, ground, ordering, homogenize, hint, monoms, arithmetic)
    PolynomialRepresentation(monomtype, coefftype, using_wide_type_for_coeffs)
end

function param_select_monomtype(
    char::Coeff,
    nvars::Int,
    ordering::AbstractMonomialOrdering,
    homogenize::Bool,
    hint::Symbol,
    monoms::Symbol
)
    if hint === :large_exponents
        # use 64 bits if large exponents detected
        desired_monom_type = ExponentVector{UInt64}
        @assert monom_is_supported_ordering(desired_monom_type, ordering)
        return desired_monom_type
    end

    # If homogenization is requested, or if a part of the ordering is
    # lexicographical, the generators will potentially be homogenized later.
    if homogenize
        desired_monom_type = ExponentVector{UInt32}
        @assert monom_is_supported_ordering(desired_monom_type, ordering)
        return desired_monom_type
    end

    ExponentSize = UInt8
    variables_per_word = div(sizeof(UInt), sizeof(ExponentSize))
    # if dense representation is requested
    if monoms === :dense
        @assert monom_is_supported_ordering(ExponentVector{ExponentSize}, ordering)
        return ExponentVector{ExponentSize}
    end

    # if packed representation is requested
    if monoms === :packed
        if monom_is_supported_ordering(PackedTuple1{UInt64, ExponentSize}, ordering)
            if nvars < variables_per_word
                return PackedTuple1{UInt64, ExponentSize}
            elseif nvars < 2 * variables_per_word
                return PackedTuple2{UInt64, ExponentSize}
            elseif nvars < 3 * variables_per_word
                return PackedTuple3{UInt64, ExponentSize}
            elseif nvars < 4 * variables_per_word
                return PackedTuple4{UInt64, ExponentSize}
            end
            # falling back to dense representation
        end
    end

    if monoms === :fixed && monom_is_supported_ordering(FixedVector, ordering)
        N = max(8, nextpow(2, nvars + 1))
        return FixedVector{N, UInt8}
    end

    if monoms === :fixed2 && monom_is_supported_ordering(FixedMonom, ordering)
        N = max(8, nextpow(2, max(nvars, 1)))
        return FixedMonom{N, UInt8}
    end

    if monoms === :fixednodeg && monom_is_supported_ordering(FixedMonomNoDeg, ordering)
        N = max(8, nextpow(2, max(nvars, 1)))
        return FixedMonomNoDeg{N, UInt8}
    end

    if monoms === :nibble && monom_is_supported_ordering(NibbleMonom, ordering)
        N = max(8, nextpow(2, max(nvars, 1)) ÷ 2)
        return NibbleMonom{N}
    end

    if monoms === :nibblenodeg && monom_is_supported_ordering(NibbleNoDeg, ordering)
        N = max(8, nextpow(2, max(nvars, 1)) ÷ 2)
        return NibbleNoDeg{N}
    end

    # in the automatic choice, we always prefer non-allocating representations
    if monoms === :auto
        if nvars > 31
            N = max(8, nextpow(2, max(nvars, 1)) ÷ 2)
            if monom_is_supported_ordering(NibbleMonom{N}, ordering)
                return NibbleMonom{N}
            end
        end

        if monom_is_supported_ordering(PackedTuple1{UInt64, ExponentSize}, ordering)
            if nvars < variables_per_word
                return PackedTuple1{UInt64, ExponentSize}
            elseif nvars < 2 * variables_per_word
                return PackedTuple2{UInt64, ExponentSize}
            elseif nvars < 3 * variables_per_word
                return PackedTuple3{UInt64, ExponentSize}
            elseif nvars < 4 * variables_per_word
                return PackedTuple4{UInt64, ExponentSize}
            end
        end
    end

    ExponentVector{ExponentSize}
end

tight_signed_int_type(x::CompositeNumber{N, T}) where {N, T} =
    CompositeNumber{N, mapreduce(tight_signed_int_type, promote_type, x.data)}
tight_unsigned_int_type(x::CompositeNumber{N, T}) where {N, T} =
    CompositeNumber{N, mapreduce(tight_signed_int_type, promote_type, x.data)}

function tight_signed_int_type(x::T) where {T <: Integer}
    types = (Int8, Int16, Int32, Int64, Int128)
    idx = findfirst(T -> x <= typemax(T), types)
    @assert !isnothing(idx)
    types[idx]
end

function tight_unsigned_int_type(x::T) where {T <: Integer}
    types = (UInt8, UInt16, UInt32, UInt64, UInt128)
    idx = findfirst(T -> x <= typemax(T), types)
    @assert !isnothing(idx)
    types[idx]
end

function param_select_coefftype(
    char::Coeff,
    nvars::Int,
    ground::Symbol,
    ordering::AbstractMonomialOrdering,
    homogenize::Bool,
    hint::Symbol,
    monoms::Symbol,
    arithmetic::Symbol;
    using_wide_type_for_coeffs::Bool=false
)
    if ground == :generic
        return CoeffGeneric, true
    end
    if iszero(char)
        return Rational{BigInt}, true
    end
    @assert char > 0
    @assert char < typemax(UInt64)

    tight_signed_type = tight_signed_int_type(char)

    if arithmetic === :signed
        if typemax(Int32) < char < typemax(UInt32) || typemax(Int64) < char < typemax(UInt64)
            @info "Cannot use $(arithmetic) arithmetic with characteristic $char"
            @assert false
        elseif !using_wide_type_for_coeffs
            return tight_signed_type, using_wide_type_for_coeffs
        else
            return widen(tight_signed_type), using_wide_type_for_coeffs
        end
    end

    tight_unsigned_type = tight_unsigned_int_type(char)
    tight_unsigned_type = if !using_wide_type_for_coeffs
        tight_unsigned_type
    else
        widen(tight_unsigned_type)
    end

    tight_unsigned_type, using_wide_type_for_coeffs
end

# Stores parameters for a single GB computation.
struct AlgorithmParameters{Arithmetic <: AbstractArithmetic}
    # Desired monomial ordering of output polynomials
    target_ord::AbstractMonomialOrdering
    # Original monomial ordering of input polynomials
    original_ord::AbstractMonomialOrdering

    # Specifies correctness checks levels
    heuristic_check::Bool
    randomized_check::Bool
    certify_check::Bool

    # If do homogenize input generators
    homogenize::Bool

    # This option only makes sense for some functions (e.g., `normalform`). It
    # specifies if we should check if the input is indeed a Groebner basis.
    check::Bool

    # Linear algebra backend
    linalg::LinearAlgebra

    # Arithmetic in the ground field
    arithmetic::Arithmetic

    # Representation of polynomials in F4
    representation::PolynomialRepresentation

    # If reduced Groebner basis is needed
    reduced::Bool

    # Strategy for modular computation in groebner. This can be one of the
    # following:
    # - :classic_modular
    # - :learn_and_apply
    modular_strategy::Symbol
    batch_scaling::Float64

    # The width of composite numbers in learn & apply
    composite::Int
    # If use  divisibility masks
    use_divmask::Bool

    # Multi-threading
    tasks::Int

    rng::Random.Xoshiro

    changematrix::Bool
end

function AlgorithmParameters(ring::PolyRing, kwargs::KeywordArguments; hint=:none)
    if kwargs.ordering === InputOrdering() || kwargs.ordering === nothing
        ordering = ring.ord
    else
        ordering = kwargs.ordering
    end
    target_ord = ordering
    original_ord = ring.ord

    heuristic_check = true
    randomized_check = true
    certify_check = kwargs.certify

    homogenize = if kwargs.homogenize === :yes
        true
    else
        if kwargs.homogenize === :auto
            if ring.nvars <= 1
                false
            elseif target_ord isa Lex || target_ord isa ProductOrdering
                true
            else
                false
            end
        else
            false
        end
    end

    # Over Z_p, linalg = :randomized signals randomized linear algebra.
    # Over Q, linalg = :randomized has almost no effect since multi-modular
    # tracing is used by default. Still, we say "almost" since some routines in
    # multi-modular tracing may compute Groebner bases in Zp for
    # checking/verification, and they benefit from linalg = :randomized.
    linalg = kwargs.linalg
    if ring.ground === :zp && (linalg === :randomized || linalg === :auto)
        # Do not use randomized linear algebra if the field characteristic is
        # too small.
        # TODO: In the future, it would be good to adapt randomized linear
        # algebra to this case by taking more random samples
        if ring.characteristic < 500
            if linalg === :randomized
                @info """
                The option linalg=:randomized was ignored:
                the ground field characteristic is small."""
            end
            linalg = :deterministic
        end
    end
    if ring.ground === :generic
        linalg = :deterministic
    end
    if linalg === :auto
        linalg = :randomized
    end
    if kwargs.function_id === :isgroebner
        linalg =
            if ring.ground in (:zp, :qq) &&
               (kwargs.linalg === :randomized || kwargs.linalg === :auto) &&
               ring.characteristic > 500 &&
               !certify_check
                :randomized
            else
                :deterministic
            end
    end
    linalg_sparsity = :sparse
    linalg_algorithm = LinearAlgebra(linalg, linalg_sparsity)

    representation = param_select_polynomial_representation(
        ring.characteristic,
        ring.nvars,
        ring.ground,
        target_ord,
        homogenize,
        kwargs.monoms,
        kwargs.arithmetic,
        hint=hint
    )

    arithmetic = select_arithmetic(
        representation.coefftype,
        ring.characteristic,
        kwargs.arithmetic,
        representation.using_wide_type_for_coeffs
    )

    reduced = kwargs.reduced

    tasks = 1
    _tasks = kwargs.tasks
    if _tasks === :auto
        tasks = Base.Threads.nthreads()
    elseif _tasks isa Integer
        tasks = _tasks
    else
        @assert false "Unreachable"
    end
    if !threading_enabled()
        if _tasks isa Integer && _tasks > 1
            @info """
            The option `tasks = $_tasks` was provided to Groebner.jl,
            however, multi-threading is disabled globally in Groebner.jl.
            The option `tasks` was ignored.
            See `Groebner.threading_enabled()` for details.""" maxlog = 1
        end
        tasks = 1
    end
    if ring.ground === :generic
        tasks = 1
    end

    # By default, modular computation uses learn & apply
    modular_strategy = kwargs.modular
    if modular_strategy === :auto
        modular_strategy = :learn_and_apply
    end
    if !reduced
        # The option reduced=false was passed in the input,
        # falling back to classic multi-modular algorithm.
        modular_strategy = :classic_modular
    end
    # Use at most 10% more primes than needed.
    batch_scaling = 0.1
    composite = kwargs._composite
    use_divmask = kwargs._use_divmask

    seed = kwargs.seed
    rng = Random.Xoshiro(seed)

    changematrix = kwargs.changematrix
    if changematrix
        if !(target_ord isa DegRevLex)
            throw(DomainError("Only DegRevLex is supported with changematrix = true."))
        end
        if (ring.ground == :generic)
            throw(DomainError("Generic fields are not supported with changematrix = true."))
        end
    end

    AlgorithmParameters(
        target_ord,
        original_ord,
        heuristic_check,
        randomized_check,
        certify_check,
        homogenize,
        kwargs.check,
        linalg_algorithm,
        arithmetic,
        representation,
        reduced,
        modular_strategy,
        batch_scaling,
        composite,
        use_divmask,
        tasks,
        rng,
        changematrix
    )
end

function param_mod_p(
    params::AlgorithmParameters,
    prime::C;
    using_wide_type_for_coeffs=nothing
) where {C <: Coeff}
    is_wide_type_coeffs = if !isnothing(using_wide_type_for_coeffs)
        using_wide_type_for_coeffs
    else
        params.representation.using_wide_type_for_coeffs
    end
    representation = PolynomialRepresentation(
        params.representation.monomtype,
        params.representation.coefftype,
        is_wide_type_coeffs
    )
    struct_update(
        AlgorithmParameters,
        params,
        (
            arithmetic=select_arithmetic(C, prime, :auto, is_wide_type_coeffs),
            representation=representation
        )
    )
end

import AbstractAlgebra

function read_BIOMDs(nspecies)
    @info "Reading biomodels"
    systems = []
    for smth in readdir((@__DIR__))
        system = []

        @info "" smth
        !(occursin("BIOMD", smth)) && continue

        io = open((@__DIR__) * "/$smth/species_map.txt", "r")
        vs = map(strip ∘ first, map(split, readlines(io)))
        close(io)
        # @info "variables" vs
        !(length(vs) in nspecies) && continue

        io = open((@__DIR__) * "/$smth/parameters.txt", "r")
        params = readlines(io)
        params = map(p -> replace(p, "/" => "//"), params)
        params = map(params) do p
            p = split(p, " = ")
            if occursin("//", p[2])
                n, d = split(p[2], "//")
                "$(p[1]) = BigInt($n)//BigInt($d)"
            else
                "$(p[1]) = BigInt($(p[2]))"
            end
        end
        close(io)

        io = open((@__DIR__) * "/$smth/odes.txt", "r")
        odes = readlines(io)
        close(io)

        symvs = map(x -> Symbol(x), vs)
        expvs = Meta.parse(join(symvs, ","))
        R, xs = eval(:((R, $expvs) = AbstractAlgebra.polynomial_ring(AbstractAlgebra.QQ, $symvs)))

        for p in params
            p = eval(Meta.parse(p))
        end

        for ode in odes
            ode = replace(ode, "{" => "", "}" => "", "/" => "//", "," => " ")
            ode = strip(last(split(ode, "=")))
            poly = eval(Meta.parse(ode))
            push!(system, poly)
        end

        system = map(system) do f
            if f isa AbstractAlgebra.Generic.MPoly
                f
            elseif f isa AbstractAlgebra.Generic.Frac
                lc = AbstractAlgebra.leading_coefficient(denominator(f))
                AbstractAlgebra.map_coefficients(c -> c // lc, numerator(f))
            else
                R(f)
            end
        end
        system = filter(!iszero, system)
        push!(systems, (smth, map(R, system)))
    end

    @info "Loaded" length(systems)
    systems
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# PackedTupleN implements the monomial interface.
#
# PackedTupleN packs exponents in integers in a degrevlex-favorable ordering.
# Currently implemented packed monomials support up to 31 variables.

abstract type AbstractPackedTuple{T <: Unsigned, B <: Unsigned} end

# Note: in practice we always have T = UInt64 and B = UInt8.
struct PackedTuple1{T <: Unsigned, B <: Unsigned} <: AbstractPackedTuple{T, B}
    a1::T
end

struct PackedTuple2{T <: Unsigned, B <: Unsigned} <: AbstractPackedTuple{T, B}
    a1::T
    a2::T
end

struct PackedTuple3{T <: Unsigned, B <: Unsigned} <: AbstractPackedTuple{T, B}
    a1::T
    a2::T
    a3::T
end

struct PackedTuple4{T <: Unsigned, B <: Unsigned} <: AbstractPackedTuple{T, B}
    a1::T
    a2::T
    a3::T
    a4::T
end

monom_max_vars(p::AbstractPackedTuple) = monom_max_vars(typeof(p))

function monom_overflow_check(a::AbstractPackedTuple{T, B}) where {T, B}
    monom_overflow_check(monom_totaldeg(a), B)
end

function packed_elperchunk(::Type{T}, ::Type{B}) where {T, B}
    div(sizeof(T), sizeof(B))
end

# How many bytes are allocated for the monomial degree.
packed_degsize(::Type{T}, ::Type{B}, n) where {T, B} = sizeof(B)

# How many chunks of type T are needed to store n elements of type B.
packed_nchunks(::Type{T}, ::Type{B}, n) where {T, B} =
    div((n - 1) * sizeof(B) + packed_degsize(T, B, n), sizeof(T)) + 1

const _defined_packed_tuples =
    ((:PackedTuple1, 1), (:PackedTuple2, 2), (:PackedTuple3, 3), (:PackedTuple4, 4))

# for each PackedTupleI define something..
for (op, n) in _defined_packed_tuples
    @eval begin
        monom_max_vars(::Type{$op{T, B}}) where {T, B} = $n * packed_elperchunk(T, B) - 1
        monom_totaldeg(a::$op{T, B}) where {T, B} = (a.a1 >> (8 * (sizeof(T) - sizeof(B)))) % B
        monom_copy(a::$op{T, B}) where {T, B} = a
    end

    @eval begin
        function monom_construct_hash_vector(
            rng::AbstractRNG,
            ::Type{$op{T, B}},
            n::Integer
        ) where {T, B}
            rand(rng, MonomHash, $n * packed_elperchunk(T, B))
        end
    end
end

# Creates a packed monomial from a regular vector
function monom_construct_from_vector(::Type{PackedTuple1{T, B}}, ev::Vector{U}) where {T, B, U}
    n = length(ev)
    epc = packed_elperchunk(T, B)
    @invariant n < epc
    indent = sizeof(T) - packed_degsize(T, B, n)
    a1 = zero(T)
    s = zero(T)
    @inbounds for i in n:-1:1
        monom_overflow_check(ev[i], B)
        d = T(ev[i])
        a1 = a1 << (sizeof(B) * 8)
        a1 = a1 | d
        monom_overflow_check(s, B)
        s += d
    end
    a1 |= s << (indent * 8)
    PackedTuple1{T, B}(a1)
end
function monom_construct_from_vector(::Type{PackedTuple2{T, B}}, ev::Vector{U}) where {T, B, U}
    n = length(ev)
    epc = packed_elperchunk(T, B)
    @invariant n < 2 * epc
    if n < epc
        small = monom_construct_from_vector(PackedTuple1{T, B}, ev)
        return PackedTuple2{T, B}(small.a1, zero(T))
    end
    indent = sizeof(T) - packed_degsize(T, B, n)
    a1, a2 = zero(T), zero(T)
    s = zero(T)
    @inbounds for i in n:-1:1
        monom_overflow_check(ev[i], B)
        d = T(ev[i])
        if div(i - 1, epc) == 1
            a1 = a1 << (sizeof(B) * 8)
            a1 = a1 | d
        else
            a2 = a2 << (sizeof(B) * 8)
            a2 = a2 | d
        end
        monom_overflow_check(s, B)
        s += d
    end
    a1 |= s << (indent * 8)
    PackedTuple2{T, B}(a1, a2)
end
function monom_construct_from_vector(::Type{PackedTuple3{T, B}}, ev::Vector{U}) where {T, B, U}
    n = length(ev)
    epc = packed_elperchunk(T, B)
    @invariant n < 3 * epc
    if n < 2 * epc
        small = monom_construct_from_vector(PackedTuple2{T, B}, ev)
        return PackedTuple3{T, B}(small.a1, small.a2, zero(T))
    end
    indent = sizeof(T) - packed_degsize(T, B, n)
    a1, a2, a3 = zero(T), zero(T), zero(T)
    s = zero(T)
    @inbounds for i in n:-1:1
        monom_overflow_check(ev[i], B)
        d = T(ev[i])
        if div(i - 1, epc) == 2
            a1 = a1 << (sizeof(B) * 8)
            a1 = a1 | d
        elseif div(i - 1, epc) == 1
            a2 = a2 << (sizeof(B) * 8)
            a2 = a2 | d
        else
            a3 = a3 << (sizeof(B) * 8)
            a3 = a3 | d
        end
        monom_overflow_check(s, B)
        s += d
    end
    a1 |= s << (indent * 8)
    PackedTuple3{T, B}(a1, a2, a3)
end
function monom_construct_from_vector(::Type{PackedTuple4{T, B}}, ev::Vector{U}) where {T, B, U}
    n = length(ev)
    epc = packed_elperchunk(T, B)
    @invariant n < 4 * epc
    if n < 3 * epc
        small = monom_construct_from_vector(PackedTuple3{T, B}, ev)
        return PackedTuple4{T, B}(small.a1, small.a2, small.a3, zero(T))
    end
    indent = sizeof(T) - packed_degsize(T, B, n)
    a1, a2, a3, a4 = zero(T), zero(T), zero(T), zero(T)
    s = zero(T)
    @inbounds for i in n:-1:1
        monom_overflow_check(ev[i], B)
        d = T(ev[i])
        if div(i - 1, epc) == 3
            a1 = a1 << (sizeof(B) * 8)
            a1 = a1 | d
        elseif div(i - 1, epc) == 2
            a2 = a2 << (sizeof(B) * 8)
            a2 = a2 | d
        elseif div(i - 1, epc) == 1
            a3 = a3 << (sizeof(B) * 8)
            a3 = a3 | d
        else
            a4 = a4 << (sizeof(B) * 8)
            a4 = a4 | d
        end
        monom_overflow_check(s, B)
        s += d
    end
    a1 |= s << (indent * 8)
    PackedTuple4{T, B}(a1, a2, a3, a4)
end

# Creates a constant packed monomial of the given type of length n
function monom_construct_const(::Type{PackedTuple1{T, B}}, n::Integer) where {T, B}
    @invariant n < packed_elperchunk(T, B)
    PackedTuple1{T, B}(zero(T))
end
function monom_construct_const(::Type{PackedTuple2{T, B}}, n::Integer) where {T, B}
    @invariant n < 2 * packed_elperchunk(T, B)
    PackedTuple2{T, B}(zero(T), zero(T))
end
function monom_construct_const(::Type{PackedTuple3{T, B}}, n::Integer) where {T, B}
    @invariant n < 3 * packed_elperchunk(T, B)
    PackedTuple3{T, B}(zero(T), zero(T), zero(T))
end
function monom_construct_const(::Type{PackedTuple4{T, B}}, n::Integer) where {T, B}
    @invariant n < 4 * packed_elperchunk(T, B)
    PackedTuple4{T, B}(zero(T), zero(T), zero(T), zero(T))
end

# Hash of a packed monomial
function monom_hash(x::PackedTuple1{T, B}, b::Vector{MH}) where {T, B, MH}
    h = _packed_vec_dot(x.a1, b, B, 1)
    mod(h, MonomHash)
end
function monom_hash(x::PackedTuple2{T, B}, b::Vector{MH}) where {T, B, MH}
    epc = packed_elperchunk(T, B)
    h = _packed_vec_dot(x.a2, b, B, 0)
    h =
        h +
        _packed_vec_dot(x.a1, view(b, (epc + 1):length(b)), B, epc - max(epc - 1, length(b) - epc))
    mod(h, MonomHash)
end
function monom_hash(x::PackedTuple3{T, B}, b::Vector{MH}) where {T, B, MH}
    epc = packed_elperchunk(T, B)
    h = _packed_vec_dot(x.a3, b, B, 0)
    h = h + _packed_vec_dot(x.a2, view(b, (epc + 1):(2 * epc)), B, 0)
    h =
        h + _packed_vec_dot(
            x.a1,
            view(b, (2 * epc + 1):length(b)),
            B,
            epc - max(epc - 1, length(b) - 2 * epc)
        )
    mod(h, MonomHash)
end
function monom_hash(x::PackedTuple4{T, B}, b::Vector{MH}) where {T, B, MH}
    epc = packed_elperchunk(T, B)
    h = _packed_vec_dot(x.a4, b, B, 0)
    h = h + _packed_vec_dot(x.a3, view(b, (epc + 1):(2 * epc)), B, 0)
    h = h + _packed_vec_dot(x.a2, view(b, (2 * epc + 1):(3 * epc)), B, 0)
    h =
        h + _packed_vec_dot(
            x.a1,
            view(b, (3 * epc + 1):length(b)),
            B,
            epc - max(epc - 1, length(b) - 3 * epc)
        )
    mod(h, MonomHash)
end

# Creates a regular vector from a packed monomial and writes result to `tmp`
function monom_to_vector!(tmp::Vector{I}, pv::PackedTuple1{T, B}) where {I, T, B}
    epc = packed_elperchunk(T, B)
    indent = epc - min(epc - 1, length(tmp))
    _packed_vec_unpack!(tmp, pv.a1, B, indent)
    tmp
end
function monom_to_vector!(tmp::Vector{I}, pv::PackedTuple2{T, B}) where {I, T, B}
    epc = packed_elperchunk(T, B)
    (length(tmp) < epc) && return monom_to_vector!(tmp, PackedTuple1{T, B}(pv.a1))
    indent = 0
    _packed_vec_unpack!(tmp, pv.a2, B, indent)
    indent = epc - min(epc - 1, length(tmp) - epc)
    _packed_vec_unpack!(view(tmp, (epc + 1):length(tmp)), pv.a1, B, indent)
    tmp
end
function monom_to_vector!(tmp::Vector{I}, pv::PackedTuple3{T, B}) where {I, T, B}
    epc = packed_elperchunk(T, B)
    (length(tmp) < 2 * epc) && return monom_to_vector!(tmp, PackedTuple2{T, B}(pv.a1, pv.a2))
    indent = 0
    _packed_vec_unpack!(tmp, pv.a3, B, indent)
    indent = 0
    _packed_vec_unpack!(view(tmp, (epc + 1):(2 * epc)), pv.a2, B, indent)
    indent = epc - min(epc - 1, length(tmp) - 2 * epc)
    _packed_vec_unpack!(view(tmp, (2 * epc + 1):length(tmp)), pv.a1, B, indent)
    tmp
end
function monom_to_vector!(tmp::Vector{I}, pv::PackedTuple4{T, B}) where {I, T, B}
    epc = packed_elperchunk(T, B)
    (length(tmp) < 3 * epc) && return monom_to_vector!(tmp, PackedTuple3{T, B}(pv.a1, pv.a2, pv.a3))
    indent = 0
    _packed_vec_unpack!(tmp, pv.a4, B, indent)
    indent = 0
    _packed_vec_unpack!(view(tmp, (epc + 1):(2 * epc)), pv.a3, B, indent)
    indent = 0
    _packed_vec_unpack!(view(tmp, (2 * epc + 1):(3 * epc)), pv.a2, B, indent)
    indent = epc - min(epc - 1, length(tmp) - 3 * epc)
    _packed_vec_unpack!(view(tmp, (3 * epc + 1):length(tmp)), pv.a1, B, indent)
    tmp
end

###
# Monomial orderings for the `PackedTupleI` monomial implementation.

function monom_is_supported_ordering(::Type{APP}, ::Ord) where {APP <: AbstractPackedTuple, Ord}
    Ord <: Union{DegRevLex{true}, InputOrdering}
end

function monom_isless(
    ea::PackedTuple1{T, B},
    eb::PackedTuple1{T, B},
    ::DegRevLex{true}
) where {T, B}
    da, db = monom_totaldeg(ea), monom_totaldeg(eb)
    if da < db
        return true
    end
    if da > db
        return false
    end

    if ea.a1 <= eb.a1
        return false
    else
        return true
    end
end

function monom_isless(
    ea::PackedTuple2{T, B},
    eb::PackedTuple2{T, B},
    ::DegRevLex{true}
) where {T, B}
    da, db = monom_totaldeg(ea), monom_totaldeg(eb)
    if da < db
        return true
    end
    if da > db
        return false
    end

    if ea.a1 == eb.a1
        return !(ea.a2 <= eb.a2)
    else
        return !(ea.a1 <= eb.a1)
    end
end

function monom_isless(
    ea::PackedTuple3{T, B},
    eb::PackedTuple3{T, B},
    ::DegRevLex{true}
) where {T, B}
    da, db = monom_totaldeg(ea), monom_totaldeg(eb)
    if da < db
        return true
    end
    if da > db
        return false
    end

    if ea.a1 == eb.a1
        if ea.a2 == eb.a2
            return !(ea.a3 <= eb.a3)
        else
            return !(ea.a2 <= eb.a2)
        end
    else
        return !(ea.a1 <= eb.a1)
    end
end

function monom_isless(
    ea::PackedTuple4{T, B},
    eb::PackedTuple4{T, B},
    ::DegRevLex{true}
) where {T, B}
    da, db = monom_totaldeg(ea), monom_totaldeg(eb)
    if da < db
        return true
    end
    if da > db
        return false
    end

    if ea.a1 == eb.a1
        if ea.a2 == eb.a2
            if ea.a3 == eb.a3
                return !(ea.a4 <= eb.a4)
            else
                return !(ea.a3 <= eb.a3)
            end
        else
            return !(ea.a2 <= eb.a2)
        end
    else
        return !(ea.a1 <= eb.a1)
    end
end

###
# Monomial-Monomial arithmetic.

function monom_lcm!(
    ec::PackedTuple1{T, B},
    ea::PackedTuple1{T, B},
    eb::PackedTuple1{T, B}
) where {T, B}
    x = _packed_vec_max(ea.a1, eb.a1)
    x = x & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    tdeg = T(_packed_vec_reduce(x))
    x = x + (tdeg << ((sizeof(T) - sizeof(B)) * 8))
    ans = PackedTuple1{T, B}(x)
    monom_overflow_check(ans)
    ans
end
function monom_lcm!(
    ec::PackedTuple2{T, B},
    ea::PackedTuple2{T, B},
    eb::PackedTuple2{T, B}
) where {T, B}
    x1 = _packed_vec_max(ea.a1, eb.a1)
    x2 = _packed_vec_max(ea.a2, eb.a2)
    x1 = x1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    tdeg = T(_packed_vec_reduce(x1) + _packed_vec_reduce(x2))
    x1 = x1 + (tdeg << ((sizeof(T) - sizeof(B)) * 8))
    ans = PackedTuple2{T, B}(x1, x2)
    monom_overflow_check(ans)
    ans
end
function monom_lcm!(
    ec::PackedTuple3{T, B},
    ea::PackedTuple3{T, B},
    eb::PackedTuple3{T, B}
) where {T, B}
    x1 = _packed_vec_max(ea.a1, eb.a1)
    x2 = _packed_vec_max(ea.a2, eb.a2)
    x3 = _packed_vec_max(ea.a3, eb.a3)
    x1 = x1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    tdeg = T(_packed_vec_reduce(x1) + _packed_vec_reduce(x2) + _packed_vec_reduce(x3))
    x1 = x1 + (tdeg << ((sizeof(T) - sizeof(B)) * 8))
    ans = PackedTuple3{T, B}(x1, x2, x3)
    monom_overflow_check(ans)
    ans
end
function monom_lcm!(
    ec::PackedTuple4{T, B},
    ea::PackedTuple4{T, B},
    eb::PackedTuple4{T, B}
) where {T, B}
    x1 = _packed_vec_max(ea.a1, eb.a1)
    x2 = _packed_vec_max(ea.a2, eb.a2)
    x3 = _packed_vec_max(ea.a3, eb.a3)
    x4 = _packed_vec_max(ea.a4, eb.a4)
    x1 = x1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    tdeg = T(
        _packed_vec_reduce(x1) +
        _packed_vec_reduce(x2) +
        _packed_vec_reduce(x3) +
        _packed_vec_reduce(x4)
    )
    x1 = x1 + (tdeg << ((sizeof(T) - sizeof(B)) * 8))
    ans = PackedTuple4{T, B}(x1, x2, x3, x4)
    monom_overflow_check(ans)
    ans
end

function monom_is_gcd_const(ea::PackedTuple1{T, B}, eb::PackedTuple1{T, B}) where {T, B}
    ea1 = ea.a1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    eb1 = eb.a1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    _packed_vec_is_orth(ea1, eb1)
end
function monom_is_gcd_const(ea::PackedTuple2{T, B}, eb::PackedTuple2{T, B}) where {T, B}
    ea1 = ea.a1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    eb1 = eb.a1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    res1 = _packed_vec_is_orth(ea1, eb1)
    res2 = _packed_vec_is_orth(ea.a2, eb.a2)
    res1 && res2
end
function monom_is_gcd_const(ea::PackedTuple3{T, B}, eb::PackedTuple3{T, B}) where {T, B}
    ea1 = ea.a1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    eb1 = eb.a1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    res1 = _packed_vec_is_orth(ea1, eb1)
    res2 = _packed_vec_is_orth(ea.a2, eb.a2)
    res3 = _packed_vec_is_orth(ea.a3, eb.a3)
    res1 && res2 && res3
end
function monom_is_gcd_const(ea::PackedTuple4{T, B}, eb::PackedTuple4{T, B}) where {T, B}
    ea1 = ea.a1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    eb1 = eb.a1 & xor(typemax(T), T(typemax(B)) << ((sizeof(T) - sizeof(B)) * 8))
    res1 = _packed_vec_is_orth(ea1, eb1)
    res2 = _packed_vec_is_orth(ea.a2, eb.a2)
    res3 = _packed_vec_is_orth(ea.a3, eb.a3)
    res4 = _packed_vec_is_orth(ea.a4, eb.a4)
    res1 && res2 && res3 && res4
end

function monom_product!(
    ec::PackedTuple1{T, B},
    ea::PackedTuple1{T, B},
    eb::PackedTuple1{T, B}
) where {T, B}
    x = ea.a1 + eb.a1
    ans = PackedTuple1{T, B}(x)
    monom_overflow_check(ans)
    ans
end
function monom_product!(
    ec::PackedTuple2{T, B},
    ea::PackedTuple2{T, B},
    eb::PackedTuple2{T, B}
) where {T, B}
    x1 = ea.a1 + eb.a1
    x2 = ea.a2 + eb.a2
    ans = PackedTuple2{T, B}(x1, x2)
    monom_overflow_check(ans)
    ans
end
function monom_product!(
    ec::PackedTuple3{T, B},
    ea::PackedTuple3{T, B},
    eb::PackedTuple3{T, B}
) where {T, B}
    x1 = ea.a1 + eb.a1
    x2 = ea.a2 + eb.a2
    x3 = ea.a3 + eb.a3
    ans = PackedTuple3{T, B}(x1, x2, x3)
    monom_overflow_check(ans)
    ans
end
function monom_product!(
    ec::PackedTuple4{T, B},
    ea::PackedTuple4{T, B},
    eb::PackedTuple4{T, B}
) where {T, B}
    x1 = ea.a1 + eb.a1
    x2 = ea.a2 + eb.a2
    x3 = ea.a3 + eb.a3
    x4 = ea.a4 + eb.a4
    ans = PackedTuple4{T, B}(x1, x2, x3, x4)
    monom_overflow_check(ans)
    ans
end

function monom_division!(
    ec::PackedTuple1{T, B},
    ea::PackedTuple1{T, B},
    eb::PackedTuple1{T, B}
) where {T, B}
    x = ea.a1 - eb.a1
    PackedTuple1{T, B}(x)
end
function monom_division!(
    ec::PackedTuple2{T, B},
    ea::PackedTuple2{T, B},
    eb::PackedTuple2{T, B}
) where {T, B}
    x1 = ea.a1 - eb.a1
    x2 = ea.a2 - eb.a2
    PackedTuple2{T, B}(x1, x2)
end
function monom_division!(
    ec::PackedTuple3{T, B},
    ea::PackedTuple3{T, B},
    eb::PackedTuple3{T, B}
) where {T, B}
    x1 = ea.a1 - eb.a1
    x2 = ea.a2 - eb.a2
    x3 = ea.a3 - eb.a3
    PackedTuple3{T, B}(x1, x2, x3)
end
function monom_division!(
    ec::PackedTuple4{T, B},
    ea::PackedTuple4{T, B},
    eb::PackedTuple4{T, B}
) where {T, B}
    x1 = ea.a1 - eb.a1
    x2 = ea.a2 - eb.a2
    x3 = ea.a3 - eb.a3
    x4 = ea.a4 - eb.a4
    PackedTuple4{T, B}(x1, x2, x3, x4)
end

function monom_is_divisible(ea::PackedTuple1{T, B}, eb::PackedTuple1{T, B}) where {T, B}
    res1 = _packed_vec_ge(ea.a1, eb.a1)
    res1
end

function monom_is_divisible(ea::PackedTuple2{T, B}, eb::PackedTuple2{T, B}) where {T, B}
    res1 = _packed_vec_ge(ea.a1, eb.a1)
    res2 = _packed_vec_ge(ea.a2, eb.a2)
    res1 && res2
end

function monom_is_divisible(ea::PackedTuple3{T, B}, eb::PackedTuple3{T, B}) where {T, B}
    res1 = _packed_vec_ge(ea.a1, eb.a1)
    res2 = _packed_vec_ge(ea.a2, eb.a2)
    res3 = _packed_vec_ge(ea.a3, eb.a3)
    res1 && res2 && res3
end
function monom_is_divisible(ea::PackedTuple4{T, B}, eb::PackedTuple4{T, B}) where {T, B}
    res1 = _packed_vec_ge(ea.a1, eb.a1)
    res2 = _packed_vec_ge(ea.a2, eb.a2)
    res3 = _packed_vec_ge(ea.a3, eb.a3)
    res4 = _packed_vec_ge(ea.a4, eb.a4)
    res1 && res2 && res3 && res4
end

function monom_is_divisible!(
    ec::PackedTuple1{T, B},
    ea::PackedTuple1{T, B},
    eb::PackedTuple1{T, B}
) where {T, B}
    ans = monom_is_divisible(ea, eb)
    e = ec
    ans && (e = monom_division!(ec, ea, eb))
    ans, e
end
function monom_is_divisible!(
    ec::PackedTuple2{T, B},
    ea::PackedTuple2{T, B},
    eb::PackedTuple2{T, B}
) where {T, B}
    ans = monom_is_divisible(ea, eb)
    e = ec
    ans && (e = monom_division!(ec, ea, eb))
    ans, e
end
function monom_is_divisible!(
    ec::PackedTuple3{T, B},
    ea::PackedTuple3{T, B},
    eb::PackedTuple3{T, B}
) where {T, B}
    ans = monom_is_divisible(ea, eb)
    e = ec
    ans && (e = monom_division!(ec, ea, eb))
    ans, e
end
function monom_is_divisible!(
    ec::PackedTuple4{T, B},
    ea::PackedTuple4{T, B},
    eb::PackedTuple4{T, B}
) where {T, B}
    ans = monom_is_divisible(ea, eb)
    e = ec
    ans && (e = monom_division!(ec, ea, eb))
    ans, e
end

function monom_is_equal(ea::PackedTuple1{T, B}, eb::PackedTuple1{T, B}) where {T, B}
    ea.a1 == eb.a1
end
function monom_is_equal(ea::PackedTuple2{T, B}, eb::PackedTuple2{T, B}) where {T, B}
    ea.a1 == eb.a1 && ea.a2 == eb.a2
end
function monom_is_equal(ea::PackedTuple3{T, B}, eb::PackedTuple3{T, B}) where {T, B}
    ea.a1 == eb.a1 && ea.a2 == eb.a2 && ea.a3 == eb.a3
end
function monom_is_equal(ea::PackedTuple4{T, B}, eb::PackedTuple4{T, B}) where {T, B}
    ea.a1 == eb.a1 && ea.a2 == eb.a2 && ea.a3 == eb.a3 && ea.a4 == eb.a4
end

###
# Monomial division masks.

function monom_create_divmask(
    e::PackedTuple1{T, B},
    DM::Type{Mask},
    ndivvars,
    divmap,
    ndivbits,
    strategy
) where {T, B, Mask}
    @invariant strategy == :first_variables
    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)
    a1 = e.a1
    for i in 1:ndivvars
        ei = mod(a1, B)
        a1 = a1 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    res
end

function monom_create_divmask(
    e::PackedTuple2{T, B},
    DM::Type{Mask},
    ndivvars,
    divmap,
    ndivbits,
    strategy
) where {T, B, Mask}
    @invariant strategy == :first_variables

    epc = div(sizeof(T), sizeof(B))

    if ndivvars < epc
        return monom_create_divmask(
            PackedTuple1{T, B}(e.a1),
            DM,
            ndivvars,
            divmap,
            ndivbits,
            strategy
        )
    end

    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)

    a2 = e.a2
    for i in 1:epc
        ei = mod(a2, B)
        a2 = a2 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    a1 = e.a1
    for i in (epc + 1):min(2 * epc - 1, ndivvars)
        ei = mod(a1, B)
        a1 = a1 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    res
end

function monom_create_divmask(
    e::PackedTuple3{T, B},
    DM::Type{Mask},
    ndivvars,
    divmap,
    ndivbits,
    strategy
) where {T, B, Mask}
    @invariant strategy == :first_variables

    epc = packed_elperchunk(T, B)

    if ndivvars < 2 * epc
        return monom_create_divmask(
            PackedTuple2{T, B}(e.a1, e.a2),
            DM,
            ndivvars,
            divmap,
            ndivbits,
            strategy
        )
    end

    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)

    a3 = e.a3
    for i in 1:epc
        ei = mod(a3, B)
        a3 = a3 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    a2 = e.a2
    for i in (epc + 1):(2 * epc)
        ei = mod(a2, B)
        a2 = a2 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    a1 = e.a1
    for i in (2 * epc + 1):min(3 * epc - 1, ndivvars)
        ei = mod(a1, B)
        a1 = a1 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    res
end

function monom_create_divmask(
    e::PackedTuple4{T, B},
    DM::Type{Mask},
    ndivvars,
    divmap,
    ndivbits,
    strategy
) where {T, B, Mask}
    @invariant strategy == :first_variables

    epc = packed_elperchunk(T, B)

    if ndivvars < 3 * epc
        return monom_create_divmask(
            PackedTuple3{T, B}(e.a1, e.a2, e.a3),
            DM,
            ndivvars,
            divmap,
            ndivbits,
            strategy
        )
    end

    ctr = one(Mask)
    res = zero(Mask)
    o = one(Mask)

    a4 = e.a4
    for i in 1:epc
        ei = mod(a4, B)
        a4 = a4 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    a3 = e.a3
    for i in (epc + 1):(2 * epc)
        ei = mod(a3, B)
        a3 = a3 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    a2 = e.a2
    for i in (2 * epc + 1):(3 * epc)
        ei = mod(a2, B)
        a2 = a2 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    a1 = e.a1
    for i in (3 * epc + 1):min(4 * epc - 1, ndivvars)
        ei = mod(a1, B)
        a1 = a1 >> (sizeof(B) * 8)
        for j in 1:ndivbits
            @inbounds if ei >= divmap[ctr]
                res |= o << (ctr - 1)
            end
            ctr += o
        end
    end

    res
end

# Test for performance regressions.
using Pkg; Pkg.activate(@__DIR__); Pkg.resolve(); Pkg.instantiate()

using ArgParse, GitHubActions, GitHub, Random, Logging
using Test, TestSetExtensions, InteractiveUtils, PrettyTables
using Base.Threads, Statistics

const MAX_DEVIATION = 0.2
const IGNORE_SMALL = 1e-3
const SAMPLES = length(ARGS) > 0 ? parse(Int, ARGS[1]) : 1

const dir_master = (@__DIR__) * "/run-on-master"
const dir_nightly = (@__DIR__) * "/run-on-nightly"

function runbench()
    @info "Start benchmarking.."
    @info "Using $(nthreads()) threads"
    @info "Using $SAMPLES samples"

    for i in 1:SAMPLES
        # Run benchmarks on master
        @info "Benchmarking Groebner.jl, master, running $dir_master"
        @time run(
            `$(Base.julia_cmd()) --startup-file=no --threads=$(nthreads()) --project=$dir_master $dir_master/run_benchmarks.jl $i`,
            wait=true
        )

        # Run benchmarks on nightly
        @info "Benchmarking Groebner.jl, nightly, running $dir_nightly"
        @time run(
            `$(Base.julia_cmd()) --startup-file=no --threads=$(nthreads()) --project=$dir_nightly $dir_nightly/run_benchmarks.jl $i`,
            wait=true
        )
    end
end

# Adapted from https://github.com/MakieOrg/Makie.jl/blob/v0.21.0/metrics/ttfp/run-benchmark.jl.
# License is MIT.
function best_unit(m)
    if m < 1e3
        return 1, "ns"
    elseif m < 1e6
        return 1e3, "μs"
    elseif m < 1e9
        return 1e6, "ms"
    else
        return 1e9, "s"
    end
end

function load_data()
    results = []
    for i in 1:SAMPLES
        results_master_i = nothing
        results_nightly_i = nothing
        try
            results_master_file = open(dir_master * "/results_$i", "r")
            @info "Reading $results_master_file"
            results_master_i = readlines(results_master_file)
            close(results_master_file)
        catch e
            @warn "Error when reading the file with results"
        end
        try
            results_nightly_file = open(dir_nightly * "/results_$i", "r")
            @info "Reading $results_nightly_file"
            results_nightly_i = readlines(results_nightly_file)
            close(results_nightly_file)
        catch e
            @warn "Error when reading the file with results, sample $i"
        end
        @assert !(results_master_i === nothing) && !(results_nightly_i === nothing)
        @assert length(results_master_i) == length(results_nightly_i)
        @assert !isempty(results_master_i)
        @assert results_master_i[1] == "master" && results_nightly_i[1] == "nightly"
        results_master_i = results_master_i[2:end]
        results_nightly_i = results_nightly_i[2:end]
        push!(results, (master=results_master_i, nightly=results_nightly_i))
    end
    results
end

function clean_data(results)
    nrecords = length(results[1][1])
    results_problems = Vector{Any}(undef, nrecords)
    results_types = Vector{Any}(undef, nrecords)
    results_master = [[] for _ in 1:nrecords]
    results_nightly = [[] for _ in 1:nrecords]
    for i in 1:SAMPLES
        for j in 1:nrecords
            master = results[i].master[j]
            nightly = results[i].nightly[j]
            problem_name_master, type, times_master = split(master, ":")
            problem_name_nightly, type, times_nightly = split(nightly, ":")
            @assert problem_name_master == problem_name_nightly
            times_master = map(
                x -> parse(Float64, String(strip(x, ['[', ']', ' ', '\t']))),
                split(times_master, ",")
            )
            times_nightly = map(
                x -> parse(Float64, String(strip(x, ['[', ']', ' ', '\t']))),
                split(times_nightly, ",")
            )
            append!(results_master[j], times_master)
            append!(results_nightly[j], times_nightly)
            results_problems[j] = join(split(problem_name_master, ","), " ")
            results_types[j] = type
        end
    end
    results_problems, results_types, results_master, results_nightly
end

# Compare results
function compare()
    results = load_data()
    results_problems, results_types, results_master, results_nightly = clean_data(results)
    table = Matrix{Any}(undef, length(results_master), 4)
    fail = false
    tolerance = 0.02
    for (i, (master, nightly)) in enumerate(zip(results_master, results_nightly))
        if results_types[i] == "time"
            master = 1e9 .* master
            nightly = 1e9 .* nightly
            f, unit = best_unit(maximum(master))
            m1 = round(mean(master) / f, digits=2)
            d1 = round(std(master) / f, digits=2)
            label_master = "$m1 ± $d1 $unit"
            m2 = round(mean(nightly) / f, digits=2)
            d2 = round(std(nightly) / f, digits=2)
            label_nightly = "$m2 ± $d2 $unit"
            indicator = if mean(master) < 1e9 * IGNORE_SMALL
                0, "insignificant"
            elseif (1 + MAX_DEVIATION) * m1 < m2
                fail = true
                2, "worse❌"
            elseif m1 > (1 + MAX_DEVIATION) * m2
                1, "better✅"
            else
                0, "don't care"
            end
        elseif results_types[i] == "allocs"
            label_master = mean(master)
            label_nightly = mean(nightly)
            indicator = if label_master < (1 - tolerance) * label_nightly
                fail = true
                2, "worse❌"
            elseif label_master > (1 + tolerance) * label_nightly
                1, "better✅"
            else
                0, "don't care"
            end
        else
            error("Beda!")
        end
        table[i, 1] = results_problems[i]
        table[i, 2] = label_master
        table[i, 3] = label_nightly
        table[i, 4] = indicator[2]
    end
    fail, table
end

function post(fail, table)
    comment_header = """
    ## Running times benchmark

    Note, that these numbers may fluctuate on the CI servers, so take them with a grain of salt.

    """
    io = IOBuffer()
    println(io, comment_header)
    if fail
        println(io, "Potential regressions detected❌")
    else
        println(io, "No regressions detected✅")
    end
    table_header = ["Problem", "Master", "This commit", "Result"]
    pretty_table(
        io,
        table,
        column_labels=table_header,
        alignment=[:l, :r, :r, :r],
        fit_table_in_display_vertically=false,
        fit_table_in_display_horizontally=false
    )
    comment_str = String(take!(io))
    println(comment_str)
end

function main()
    runbench()
    fail, table = compare()
    post(fail, table)
    versioninfo(verbose=true)
    @testset "Benchmarks" begin
        @test !fail
        if fail
            exit(1)
        end
    end
end

main()

#=
@macroexpand Base.Threads.@threads for i in 1:100
    println(i)
end
=#

# quote
#     local var"#17#threadsfor_fun"
#     begin
#         let var"#16#range" = 1:100
#             function var"#17#threadsfor_fun"(var"#28#tid" = 1; onethread = false)
#                 var"#21#r" = var"#16#range"
#                 var"#22#lenr" = Base.Threads.length(var"#21#r")
#                 if onethread
#                     var"#28#tid" = 1
#                     (var"#23#len", var"#24#rem") = (var"#22#lenr", 0)
#                 else
#                     (var"#23#len", var"#24#rem") = Base.Threads.divrem(var"#22#lenr", Base.Threads.threadpoolsize())
#                 end
#                 if var"#23#len" == 0
#                     if var"#28#tid" > var"#24#rem"
#                         return
#                     end
#                     (var"#23#len", var"#24#rem") = (1, 0)
#                 end
#                 var"#25#f" = Base.Threads.firstindex(var"#21#r") + (var"#28#tid" - 1) * var"#23#len"
#                 var"#26#l" = (var"#25#f" + var"#23#len") - 1
#                 if var"#24#rem" > 0
#                     #= threadingconstructs.jl:242 =#
#                     if var"#28#tid" <= var"#24#rem"
#                         #= threadingconstructs.jl:243 =#
#                         var"#25#f" = var"#25#f" + (var"#28#tid" - 1)
#                         #= threadingconstructs.jl:244 =#
#                         var"#26#l" = var"#26#l" + var"#28#tid"
#                     else
#                         #= threadingconstructs.jl:246 =#
#                         var"#25#f" = var"#25#f" + var"#24#rem"
#                         #= threadingconstructs.jl:247 =#
#                         var"#26#l" = var"#26#l" + var"#24#rem"
#                     end
#                 end
#                 #= threadingconstructs.jl:251 =#
#                 for var"#27#i" = var"#25#f":var"#26#l"
#                     #= threadingconstructs.jl:252 =#
#                     local i = begin
#                                 $(Expr(:inbounds, true))
#                                 local var"#29#val" = var"#21#r"[var"#27#i"]
#                                 $(Expr(:inbounds, :pop))
#                                 var"#29#val"
#                             end
#                     #= threadingconstructs.jl:253 =#
#                     begin
#                         #= REPL[3]:2 =#
#                         println(i)
#                         #= REPL[3]:3 =#
#                     end
#                     #= threadingconstructs.jl:254 =#
#                 end
#             end
#         end
#     end
#     Base.Threads.threading_run(var"#17#threadsfor_fun", false)
# end

using Base.Threads: nthreads, @threads, @spawn
using Base.Iterators: partition

tasks_per_thread = 2

some_data = collect(1:1000)

chunk_size = max(1, length(some_data) ÷ (tasks_per_thread * nthreads()))
data_chunks = partition(some_data, chunk_size) # partition your data into chunks that
                                               # individual tasks will deal with
#See also ChunkSplitters.jl and SplittablesBase.jl for partitioning data

tasks = Task[]
for chunk in data_chunks
    @info "chunk" chunk
    task = @spawn begin
        # state = some_initial_value
        for x in chunk
            # Core.print("threadid=$(Base.Threads.threadid()), value=$x\n")
            # state = some_operator(state, f(x))
        end
        # return state
    end
    push!(tasks, task)
end
fetch.(tasks)

using Base.Threads: nthreads, @threads, @spawn
using Base.Iterators: partition
using Primes, BenchmarkTools

function crt!(M, buf, n1, n2, ai, ci)
    Base.GMP.MPZ.set_ui!(n1, UInt(0))
    for i in 1:length(ai)
        Base.GMP.MPZ.mul_ui!(n2, ci[i], ai[i])
        Base.GMP.MPZ.add!(n1, n2)
    end
    Base.GMP.MPZ.set!(buf, n1)
    Base.GMP.MPZ.fdiv_r!(buf, M)
end

function crt_vec_full!(table_zz, modulo, tables_ff, mults, moduli)
    # NN = Threads.maxthreadid()
    # buf = [BigInt() for _ in 1:NN]
    # n1 = [BigInt() for _ in 1:NN]
    # n2 = [BigInt() for _ in 1:NN]
    # rems = [Vector{UInt64}(undef, length(moduli)) for _ in 1:NN]
    tasks_per_thread = 1
    n_threads = nthreads()
    chunk_size = max(1, div(length(table_zz), (tasks_per_thread * n_threads)))
    data_chunks = partition(Random.shuffle(1:length(table_zz)), chunk_size)
    tasks = Task[]
    for chunk in data_chunks
        # @info "chunk" chunk
        task = @spawn begin
            # state = some_initial_value
            buf = BigInt()
            n1 = BigInt()
            n2 = BigInt()
            rems = Vector{UInt64}(undef, length(moduli))
            for i in chunk
                for j in 1:length(table_zz[i])
                    for k in 1:length(moduli)
                        rems[k] = UInt64(tables_ff[k][i][j])
                    end
                    crt!(modulo, buf, n1, n2, rems, mults)
                    Base.GMP.MPZ.set!(table_zz[i][j], buf)
                end
            end
            # return state
        end
        push!(tasks, task)
    end
    for task in tasks
        wait(task)
    end
    #=
    Threads.@threads :static for i in 1:length(table_zz)
        t = Threads.threadid()
        for j in 1:length(table_zz[i])
            for k in 1:length(moduli)
                rems[t][k] = UInt64(tables_ff[k][i][j])
            end
            crt!(modulo, buf[t], n1[t], n2[t], rems[t], mults)
            Base.GMP.MPZ.set!(table_zz[i][j], buf[t])
        end
    end
    =#
end

# Preallocate data
M, P = 512, 101
table_zz = [[BigInt() for _ in 1:i] for i in 1:M]
moduli = UInt64.(prevprimes(2^31-1, P))
modulo = prod(BigInt, moduli)
mults = [rand(1:modulo-1) for _ in 1:length(moduli)]
tables_ff = [ [[mod(rand(UInt64), moduli[j]) for _ in 1:i] for i in 1:M] for j in 1:P]

@time crt_vec_full!(table_zz,modulo,tables_ff,mults,moduli)
@btime crt_vec_full!($table_zz,$modulo,$tables_ff,$mults,$moduli)

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

###
# Pairset

const CRITICAL_PAIR_REDUNDANT = MonomId(0)

struct CriticalPair
    poly1::Int32
    poly2::Int32
    # Index of lcm(lm(poly1), lm(poly2)) in the hashtable
    lcm::MonomId

    function CriticalPair(poly1, poly2, lcm)
        @invariant poly1 < poly2
        new(poly1, poly2, lcm)
    end
end

mutable struct Pairset{ExponentType <: Integer}
    pairs::Vector{CriticalPair}
    degrees::Vector{ExponentType}
    lcms::Vector{MonomId}
    load::Int
    scratch1::Vector{Int}           # Scratch spaces for faster sorting
    scratch2::Vector{CriticalPair}
    scratch3::Vector{ExponentType}
    scratch4::Vector{Int}
end

function pairset_initialize(::Type{ExponentType}; initial_size=2^6) where {ExponentType}
    Pairset(
        Vector{CriticalPair}(undef, initial_size),
        Vector{ExponentType}(undef, initial_size),
        Vector{MonomId}(),
        0,
        Vector{Int}(),
        Vector{CriticalPair}(),
        Vector{ExponentType}(),
        Vector{Int}()
    )
end

Base.isempty(ps::Pairset) = ps.load == 0

function pairset_resize_if_needed!(ps::Pairset, to_add::Int)
    newsize = length(ps.pairs)
    while ps.load + to_add > newsize
        newsize = max(2 * newsize, ps.load + to_add)
    end
    resize!(ps.pairs, newsize)
    resize!(ps.degrees, newsize)
    nothing
end

function pairset_resize_lcms_if_needed!(ps::Pairset, n_filled::Int)
    if length(ps.lcms) < n_filled + 1
        resize!(ps.lcms, floor(Int, n_filled * 1.1) + 1)
    end
    nothing
end

function pairset_find_smallest_degree_pair(ps::Pairset)
    @invariant ps.load > 0 && length(ps.pairs) > 0 && length(ps.degrees) > 0
    degs = ps.degrees
    @inbounds pair_idx, pair_min_deg = 1, degs[1]
    @inbounds for i in 1:(ps.load)
        if degs[i] <= pair_min_deg
            pair_min_deg = degs[i]
            pair_idx = i
        end
    end
    pair_idx, pair_min_deg
end

# Returns N, the number of critical pairs of the smallest degree. Sorts the
# critical pairs so that the first N pairs in the pairset are the smallest with
# respect to degree.
function pairset_partition_by_degree!(ps::Pairset)
    @invariant ps.load > 0
    _, pair_min_deg = pairset_find_smallest_degree_pair(ps)

    pairs = ps.pairs
    degs = ps.degrees
    i, j = 0, ps.load + 1
    @inbounds while true
        i += 1
        j -= 1
        while i <= ps.load && degs[i] == pair_min_deg
            i += 1
        end
        while j > 1 && degs[j] > pair_min_deg
            j -= 1
        end
        i >= j && break
        pairs[i], pairs[j] = pairs[j], pairs[i]
        degs[i], degs[j] = degs[j], degs[i]
    end

    i - 1
end

###
# Basis

# Basis is a list of polynomials. A polynomial is represented by a sorted vector
# of monomials and a sorted vector of coefficients. Monomials and coefficients
# are stored in the basis separately. A monomial is represented by an integer, a
# unique identifier provided by the hashtable.
mutable struct Basis{C <: Coeff}
    # Monomial identifiers are integers greater than zero. 
    # Zero and negative values are reserved.
    monoms::Vector{Vector{MonomId}}
    coeffs::Vector{Vector{C}}

    # filled >= processed at any time.
    n_filled::Int
    n_processed::Int

    n_nonredundant::Int
    is_redundant::Vector{Bool}
    nonredundant_indices::Vector{Int}

    divmasks::Vector{DivisionMask}

    # usually empty
    changematrix::Vector{Dict{Int, Dict{MonomId, C}}}
end

function basis_initialize(ring::PolyRing, sz::Int, ::Type{C}) where {C <: Coeff}
    Basis(
        Vector{Vector{MonomId}}(undef, sz),
        Vector{Vector{C}}(undef, sz),
        0,
        0,
        0,
        zeros(Bool, sz),
        Vector{Int}(undef, sz),
        Vector{DivisionMask}(undef, sz),
        Vector{Dict{Int, Dict{MonomId, C}}}(undef, 0)
    )
end

# Same as basis_initialize, but uses an existing hashtable.
function basis_initialize_using_existing_hashtable(
    ring::PolyRing,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    present_ht::MonomialHashtable;
) where {M <: Monom, C <: Coeff}
    basis = basis_initialize(ring, length(monoms), C)
    basis_fill_data!(basis, present_ht, monoms, coeffs)
    basis
end

function basis_well_formed(ring::PolyRing, basis::Basis, hashtable::MonomialHashtable)
    !(0 <= basis.n_processed <= basis.n_filled) && error("Bad indices in basis")
    !(0 <= basis.n_nonredundant <= basis.n_filled) && error("Bad indices in basis")
    (isempty(basis.monoms) || isempty(basis.coeffs)) && error("Basis cannot be empty")
    !is_sorted_by_lead_increasing(basis, hashtable) && error("Basis elements must be sorted")
    for i in basis.n_filled
        isempty(basis.monoms[i]) && error("Zero polynomials are not allowed.")
        !(length(basis.monoms[i]) == length(basis.coeffs[i])) && error("Bad polynomial")
        !allunique(basis.monoms[i]) && error("Bad polynomial")
        !issorted(
            basis.monoms[i],
            lt=(j, k) -> monom_isless(hashtable.monoms[k], hashtable.monoms[j], ring.ord)
        ) && error("Bad polynomial")
        iszero(basis.coeffs[i][1]) && error("Leading coefficient is zero")
        for j in 1:length(basis.coeffs[i])
            (ring.ground == :zp) &&
                !(-1 < basis.coeffs[i][j] < ring.characteristic) &&
                error("Coefficients must be normalized")
            (basis.monoms[i][j] > hashtable.load) && error("Bad monomial")
        end
    end
    true
end

###
# Change matrix

function basis_changematrix_initialize!(
    basis::Basis{C},
    hashtable::MonomialHashtable{M, Ord}
) where {C <: Coeff, M <: Monom, Ord}
    resize!(basis.changematrix, basis.n_filled)
    id_of_1 = hashtable_insert!(hashtable, monom_construct_const(M, hashtable.nvars))
    for i in 1:(basis.n_filled)
        basis.changematrix[i] = Dict{Int, Dict{MonomId, C}}()
        basis.changematrix[i][i] = Dict{MonomId, C}(id_of_1 => one(C))
    end
end

function basis_changematrix_mul!(
    basis::Basis,
    idx::Int,
    cf::C,
    arithmetic::AbstractArithmetic
) where {C <: Coeff}
    row = basis.changematrix[idx]
    new_row = empty(row)
    for (pos, poly) in row
        new_poly = empty(poly)
        for (monom_id, monom_cf) in poly
            new_poly[monom_id] = mod_p(monom_cf * cf, arithmetic)
        end
        new_row[pos] = new_poly
    end
    basis.changematrix[idx] = new_row
end

function basis_changematrix_addmul!(
    basis::Basis,
    ht::MonomialHashtable,
    symbol_ht,
    idx::Int,
    poly_idx,
    poly_mult,
    cf::C,
    arithmetic::AbstractArithmeticZp{AccumType, CoeffType}
) where {C <: Coeff, AccumType, CoeffType}
    row = basis.changematrix[idx]
    @inbounds for (ref_poly_idx, ref_quo) in basis.changematrix[poly_idx]
        if !haskey(row, ref_poly_idx)
            row[ref_poly_idx] = Dict{MonomId, C}()
        end
        poly = row[ref_poly_idx]
        hashtable_resize_if_needed!(ht, length(ref_quo))
        for (ref_mult, ref_cf) in ref_quo
            ref_monom = ht.monoms[ref_mult]
            quo_monom = ht.monoms[poly_mult]
            new_monom = monom_copy(ref_monom)
            new_monom = monom_product!(new_monom, ref_monom, quo_monom)
            new_monom_id = hashtable_insert!(ht, new_monom)
            if !haskey(poly, new_monom_id)
                poly[new_monom_id] = zero(CoeffType)
            end
            poly[new_monom_id] = mod_p(poly[new_monom_id] + ref_cf * AccumType(cf), arithmetic)
        end
    end
end

function basis_changematrix_deep_copy_with_new_type(
    changematrix,
    new_sparse_row_coeffs::Vector{Vector{C}}
) where {C}
    new_changematrix = Vector{Dict{Int, Dict{MonomId, C}}}(undef, length(changematrix))
    for i in 1:length(changematrix)
        !isassigned(changematrix, i) && continue
        obj = changematrix[i]
        new_obj = Dict{Int, Dict{MonomId, C}}()
        for (k, v) in obj
            new_obj[k] = Dict{MonomId, C}()
            for (k2, v2) in v
                new_obj[k][k2] = C(v2)
            end
        end
        new_changematrix[i] = new_obj
    end
    new_changematrix
end

function basis_changematrix_shallow_copy_with_new_type(changematrix, new_sparse_row_coeffs)
    basis_changematrix_deep_copy_with_new_type(changematrix, new_sparse_row_coeffs)
end

function basis_changematrix_export(
    basis::Basis{C},
    ht::MonomialHashtable{M},
    npolys
) where {C <: Coeff, M <: Monom}
    matrix_monoms = Vector{Vector{Vector{M}}}(undef, basis.n_nonredundant)
    matrix_coeffs = Vector{Vector{Vector{C}}}(undef, basis.n_nonredundant)
    @inbounds for i in 1:(basis.n_nonredundant)
        matrix_monoms[i] = Vector{Vector{M}}(undef, npolys)
        matrix_coeffs[i] = Vector{Vector{M}}(undef, npolys)
        idx = basis.nonredundant_indices[i]
        row = basis.changematrix[idx]
        for poly_idx in 1:npolys
            matrix_monoms[i][poly_idx] = Vector{M}()
            matrix_coeffs[i][poly_idx] = Vector{C}()
            !haskey(row, poly_idx) && continue
            for (monom_id, monom_cf) in row[poly_idx]
                push!(matrix_monoms[i][poly_idx], ht.monoms[monom_id])
                push!(matrix_coeffs[i][poly_idx], monom_cf)
            end
        end
        sort_input_terms_to_change_ordering!(matrix_monoms[i], matrix_coeffs[i], ht.ord)
    end
    matrix_monoms, matrix_coeffs
end

###
# Basis utils

function basis_shallow_copy_with_new_coeffs(
    basis::Basis{C},
    new_sparse_row_coeffs::Vector{Vector{T}}
) where {C <: Coeff, T <: Coeff}
    Basis(
        basis.monoms,
        new_sparse_row_coeffs,
        basis.n_filled,
        basis.n_processed,
        basis.n_nonredundant,
        basis.is_redundant,
        basis.nonredundant_indices,
        basis.divmasks,
        basis_changematrix_shallow_copy_with_new_type(basis.changematrix, new_sparse_row_coeffs)
    )
end

function basis_deep_copy_with_new_coeffs(
    basis::Basis{C},
    new_sparse_row_coeffs::Vector{Vector{T}}
) where {C <: Coeff, T <: Coeff}
    monoms = Vector{Vector{MonomId}}(undef, length(basis.monoms))
    @inbounds for i in 1:length(basis.monoms)
        !isassigned(basis.monoms, i) && continue
        monoms[i] = Vector{MonomId}(undef, length(basis.monoms[i]))
        for j in 1:length(basis.monoms[i])
            monoms[i][j] = basis.monoms[i][j]
        end
    end

    Basis(
        monoms,
        new_sparse_row_coeffs,
        basis.n_filled,
        basis.n_processed,
        basis.n_nonredundant,
        copy(basis.is_redundant),
        copy(basis.nonredundant_indices),
        copy(basis.divmasks),
        basis_changematrix_deep_copy_with_new_type(basis.changematrix, new_sparse_row_coeffs)
    )
end

function basis_deepcopy(basis::Basis{C}) where {C <: Coeff}
    coeffs = Vector{Vector{C}}(undef, length(basis.coeffs))

    if isbitstype(C)  # For Z/pZ
        @inbounds for i in 1:length(basis.coeffs)
            !isassigned(basis.coeffs, i) && continue
            coeffs[i] = Vector{C}(undef, length(basis.coeffs[i]))
            for j in 1:length(basis.coeffs[i])
                coeffs[i][j] = basis.coeffs[i][j]
            end
        end
    else  # For Z and Q
        @inbounds for i in 1:length(basis.coeffs)
            !isassigned(basis.coeffs, i) && continue
            coeffs[i] = Vector{C}(undef, length(basis.coeffs[i]))
            for j in 1:length(basis.coeffs[i])
                # We cannot just use copy, since we mutate BigInts
                coeffs[i][j] = deepcopy(basis.coeffs[i][j])
            end
        end
    end

    basis_deep_copy_with_new_coeffs(basis, coeffs)
end

function basis_resize_if_needed!(basis::Basis{T}, to_add::Int) where {T}
    size = length(basis.monoms)
    while basis.n_processed + to_add >= size
        size = max(size * 2, basis.n_processed + to_add)
        resize!(basis.monoms, size)
        resize!(basis.coeffs, size)
        resize!(basis.is_redundant, size)
        @inbounds basis.is_redundant[(basis.n_processed + 1):end] .= false
        resize!(basis.nonredundant_indices, size)
        resize!(basis.divmasks, size)
    end
    @invariant size >= basis.n_processed + to_add
    nothing
end

function basis_make_monic!(
    basis::Basis{C},
    arithmetic::AbstractArithmeticZp{A, C},
    changematrix::Bool
) where {A <: Union{CoeffZp, CompositeCoeffZp}, C <: Union{CoeffZp, CompositeCoeffZp}}
    cfs = basis.coeffs
    @inbounds for i in 1:(basis.n_filled)
        !isassigned(cfs, i) && continue
        isone(cfs[i][1]) && continue
        mul = inv_mod_p(A(cfs[i][1]), arithmetic)
        cfs[i][1] = one(C)
        for j in 2:length(cfs[i])
            cfs[i][j] = mod_p(A(cfs[i][j]) * A(mul), arithmetic) % C
        end
        @invariant isone(cfs[i][1])
        if changematrix
            basis_changematrix_mul!(basis, i, A(mul), arithmetic)
        end
    end
    basis
end

function basis_make_monic!(
    basis::Basis{C},
    arithmetic::AbstractArithmetic,
    changematrix::Bool
) where {C <: Union{CoeffQQ, CoeffGeneric}}
    cfs = basis.coeffs
    @inbounds for i in 1:(basis.n_filled)
        !isassigned(cfs, i) && continue
        isone(cfs[i][1]) && continue
        mul = inv(cfs[i][1])
        for j in 2:length(cfs[i])
            cfs[i][j] *= mul
        end
        cfs[i][1] = one(cfs[i][1])
    end
    basis
end

# Follows paragraph 4.4. from 
# Gebauer, Möller, On an Installation of Buchberger's Algorithm
function pairset_update!(
    pairset::Pairset{D},
    basis::Basis{C},
    ht::MonomialHashtable{M},
    update_ht::MonomialHashtable{M},
    idx::Int
) where {D, C <: Coeff, M <: Monom}
    pairset_resize_lcms_if_needed!(pairset, basis.n_filled)
    pairset_resize_if_needed!(pairset, basis.n_filled)

    pairs = pairset.pairs
    lcms = pairset.lcms
    degs = pairset.degrees

    @inbounds lead_idx = basis.monoms[idx][1]

    # Generate new pairs.
    hashtable_resize_if_needed!(update_ht, idx)
    @inbounds for i in 1:(idx - 1)
        newidx = pairset.load + i
        if !basis.is_redundant[i] &&
           !monom_is_gcd_const(ht.monoms[basis.monoms[i][1]], ht.monoms[lead_idx])
            lcms[i] = hashtable_get_lcm!(basis.monoms[i][1], lead_idx, ht, update_ht)
            degs[newidx] = monom_totaldeg(update_ht.monoms[lcms[i]])
            pairs[newidx] = CriticalPair(Int32(i), Int32(idx), lcms[i])
        else
            lcms[i] = CRITICAL_PAIR_REDUNDANT
            degs[newidx] = typemax(D)
            pairs[newidx] = CriticalPair(Int32(i), Int32(idx), CRITICAL_PAIR_REDUNDANT)
        end
    end

    # Criterion B_k(j, l).
    # T(j, l) is divisible by T(k)
    # max(deg T(j, k), deg T(l, k)) < deg T(j, l)
    @inbounds for i in 1:(pairset.load)
        (pairs[i].lcm == CRITICAL_PAIR_REDUNDANT) && continue
        j = pairs[i].poly1
        l = pairs[i].poly2
        m = max(degs[pairset.load + l], degs[pairset.load + j])
        if degs[i] > m && hashtable_monom_is_divisible(pairs[i].lcm, lead_idx, ht)
            pairs[i] = CriticalPair(pairs[i].poly1, pairs[i].poly2, CRITICAL_PAIR_REDUNDANT)
        end
    end

    # Traverse new pairs to move non-redundant ones first.
    cnt = 1
    @inbounds for i in 1:(idx - 1)
        (lcms[i] == CRITICAL_PAIR_REDUNDANT) && continue
        # if !basis.is_redundant[i]
        pairs[pairset.load + cnt] = pairs[pairset.load + i]
        degs[pairset.load + cnt] = degs[pairset.load + i]
        cnt += 1
        # end
    end

    sort_pairset_by_degree!(pairset, pairset.load + 1, cnt - 2)

    @inbounds for i in 1:(cnt - 1)
        lcms[i] = pairs[pairset.load + i].lcm
    end
    @inbounds lcms[cnt] = CRITICAL_PAIR_REDUNDANT
    new_pairs = cnt - 1

    # Criterion M(i, j).
    # T(i, j) | T(k, j)
    @inbounds for i in 1:new_pairs
        (lcms[i] == CRITICAL_PAIR_REDUNDANT) && continue
        divmask_i = update_ht.divmasks[lcms[i]]
        lcm_i = update_ht.monoms[lcms[i]]
        k = i + 1
        for k in (i + 1):new_pairs
            (lcms[k] == CRITICAL_PAIR_REDUNDANT) && continue
            if update_ht.use_divmask &&
               !divmask_is_probably_divisible(update_ht.divmasks[lcms[k]], divmask_i)
                continue
            end
            ea = update_ht.monoms[lcms[k]]
            if monom_is_divisible(update_ht.monoms[lcms[k]], lcm_i)
                lcms[k] = CRITICAL_PAIR_REDUNDANT
            end
        end
    end

    # Remove redundant pairs from the pairset.
    cnt = 1
    @inbounds for i in 1:(pairset.load)
        (pairs[i].lcm == CRITICAL_PAIR_REDUNDANT) && continue
        pairs[cnt] = pairs[i]
        degs[cnt] = degs[i]
        cnt += 1
    end

    # Add new lcm monomials to the main hashtable.
    hashtable_resize_if_needed!(ht, new_pairs)
    @inbounds for i in 1:new_pairs
        (lcms[i] == CRITICAL_PAIR_REDUNDANT) && continue
        id = hashtable_insert!(ht, update_ht.monoms[lcms[i]])
        pair = pairs[pairset.load + i]
        pairs[cnt] = CriticalPair(pair.poly1, pair.poly2, id)
        degs[cnt] = degs[pairset.load + i]
        cnt += 1
    end
    pairset.load = cnt - 1

    # Mark redundant polynomials in the generating set.
    nonred = basis.nonredundant_indices
    @inbounds for i in 1:(basis.n_nonredundant)
        basis.is_redundant[nonred[i]] && continue
        if hashtable_monom_is_divisible(basis.monoms[nonred[i]][1], lead_idx, ht)
            basis.is_redundant[nonred[i]] = true
        end
    end
end

function basis_update!(basis::Basis, ht::MonomialHashtable{M}) where {M <: Monom}
    k = 1
    lead = basis.divmasks
    nonred = basis.nonredundant_indices
    @inbounds for i in 1:(basis.n_nonredundant)
        if !basis.is_redundant[nonred[i]]
            basis.divmasks[k] = lead[i]
            basis.nonredundant_indices[k] = nonred[i]
            k += 1
        end
    end
    basis.n_nonredundant = k - 1

    @inbounds for i in (basis.n_processed + 1):(basis.n_filled)
        if !basis.is_redundant[i]
            lead[k] = ht.divmasks[basis.monoms[i][1]]
            nonred[k] = i
            k += 1
        end
    end

    basis.n_nonredundant = k - 1
    basis.n_processed = basis.n_filled
end

function basis_mark_redundant_elements!(
    pairset::Pairset,
    basis::Basis,
    ht::MonomialHashtable{M},
    update_ht::MonomialHashtable{M},
    idx::Int
) where {M <: Monom}
    @inbounds lead_idx = basis.monoms[idx][1]
    ps = pairset.pairs
    degs = pairset.degrees
    @inbounds for i in (idx + 1):(basis.n_filled)
        basis.is_redundant[i] && continue
        lead_i = basis.monoms[i][1]
        @invariant !monom_isless(ht.monoms[lead_i], ht.monoms[lead_idx], ht.ord)
        !hashtable_monom_is_divisible(lead_i, lead_idx, ht) && continue

        # Add a new critical pair corresponding to Spoly(i, idx).
        pairset_resize_if_needed!(pairset, 1)
        ps[pairset.load + 1] = CriticalPair(Int32(idx), Int32(i), lead_i)
        degs[pairset.load + 1] = monom_totaldeg(ht.monoms[lead_i])
        pairset.load += 1

        basis.is_redundant[i] = true
    end
end

function basis_fill_data!(
    basis::Basis,
    ht::MonomialHashtable{M},
    exponents::Vector{Vector{M}},
    coeffs::Vector{Vector{T}}
) where {M, T}
    ngens = length(exponents)
    @inbounds for i in 1:ngens
        @invariant length(exponents[i]) == length(coeffs[i])
        hashtable_resize_if_needed!(ht, length(exponents[i]))

        nterms = length(coeffs[i])
        basis.coeffs[i] = coeffs[i]
        basis.monoms[i] = Vector{MonomId}(undef, nterms)
        poly = basis.monoms[i]
        @inbounds for j in 1:nterms
            poly[j] = hashtable_insert!(ht, exponents[i][j])
        end
    end

    basis.n_filled = ngens
end

function basis_discard_redundant_elements!(basis::Basis)
    j = 1
    @inbounds for i in 1:(basis.n_nonredundant)
        if !basis.is_redundant[basis.nonredundant_indices[i]]
            basis.divmasks[j] = basis.divmasks[i]
            basis.nonredundant_indices[j] = basis.nonredundant_indices[i]
            j += 1
        end
    end
    basis.n_nonredundant = j - 1
    @invariant basis.n_processed == basis.n_filled
    basis
end

function basis_standardize!(
    ring::PolyRing,
    basis::Basis,
    ht::MonomialHashtable,
    arithmetic::AbstractArithmetic,
    changematrix::Bool
)
    @inbounds for i in 1:(basis.n_nonredundant)
        idx = basis.nonredundant_indices[i]
        basis.nonredundant_indices[i] = i
        basis.is_redundant[i] = false
        basis.coeffs[i] = basis.coeffs[idx]
        basis.monoms[i] = basis.monoms[idx]
        if changematrix
            basis.changematrix[i] = basis.changematrix[idx]
        end
    end
    basis.n_processed = basis.n_filled = basis.n_nonredundant
    resize!(basis.coeffs, basis.n_processed)
    resize!(basis.monoms, basis.n_processed)
    resize!(basis.divmasks, basis.n_processed)
    resize!(basis.nonredundant_indices, basis.n_processed)
    resize!(basis.is_redundant, basis.n_processed)
    resize!(basis.changematrix, basis.n_processed)
    perm = sort_polys_by_lead_increasing!(basis, ht, changematrix, ord=ht.ord)
    basis_make_monic!(basis, arithmetic, changematrix)
    perm
end

function basis_get_monoms_by_identifiers(basis::Basis, ht::MonomialHashtable{M}) where {M <: Monom}
    monoms = Vector{Vector{M}}(undef, basis.n_nonredundant)
    @inbounds for i in 1:(basis.n_nonredundant)
        poly = basis.monoms[basis.nonredundant_indices[i]]
        monoms[i] = Vector{M}(undef, length(poly))
        for j in 1:length(poly)
            monoms[i][j] = ht.monoms[poly[j]]
        end
    end
    monoms
end

function basis_export_coeffs(basis::Basis{C}) where {C <: Coeff}
    coeffs = Vector{Vector{C}}(undef, basis.n_nonredundant)
    @inbounds for i in 1:(basis.n_nonredundant)
        coeffs[i] = basis.coeffs[basis.nonredundant_indices[i]]
    end
    coeffs
end

function basis_export_data(basis::Basis{C}, ht::MonomialHashtable{M}) where {M <: Monom, C <: Coeff}
    exps = basis_get_monoms_by_identifiers(basis, ht)
    coeffs = basis_export_coeffs(basis)
    exps, coeffs
end

# Adapted from JUMP. The license is MPL version 2.0.

using Groebner
using Documenter

# Setup

const _IS_GITHUB_ACTIONS = get(ENV, "GITHUB_ACTIONS", "false") == "true"

latex_platform = _IS_GITHUB_ACTIONS ? "docker" : "native"

# Documentation structure

PAGES = [
    "Home" => "index.md",
    "Examples" => "examples.md",
    "Interface" => "interface.md"
    # "Papers" => [
    #     "Groebner.jl: Fast Gröbner Tracing in Julia" => "papers/fast-groebner-tracing-in-julia.md"
    # ]
]

# Build the HTML documentation

# Needed to make Documenter think that there is a PDF in the right place when
# link checking. Inn production we replace this by running the LaTeX build.
write(joinpath(@__DIR__, "src", "Groebner.jl.pdf"), "")

@time Documenter.makedocs(
    modules   = [Groebner],
    sitename  = "Groebner.jl",
    format    = Documenter.HTML(analytics="G-09PS33NY4L"    # assets = ["assets/favicon.ico"],
    ),
    doctest   = true,
    linkcheck = true,
    checkdocs = :exports,
    warnonly  = true,
    pages     = PAGES
)

# Build the PDF documentation

@time Documenter.makedocs(
    sitename = "Groebner.jl",
    authors  = "The Groebner.jl developers and contributors",
    format   = Documenter.LaTeX(; platform=latex_platform),
    build    = "latex_build",
    pages    = PAGES,
    debug    = true
)
cp(
    joinpath(@__DIR__, "latex_build", "Groebner.jl.pdf"),
    joinpath(@__DIR__, "build", "Groebner.jl.pdf");
    force=true
)

# Deploy build/

deploydocs(repo="github.com/sumiya11/Groebner.jl.git", versions=nothing, push_preview=true)

import AbstractAlgebra

eqpath(path1, path2) = normpath(path1) == normpath(path2)

for (root, dir, files) in walkdir((@__DIR__))
    for file in files
        if eqpath((@__DIR__) * "/$file", (@__FILE__))
            continue
        end
        include((@__DIR__) * "/$file")
    end
end

function load_SIAN_all(; np=AbstractAlgebra, ground=np.QQ, internal_ordering=:degrevlex)
    systems = []
    for (root, dir, files) in walkdir((@__DIR__))
        for file in files
            if eqpath((@__DIR__) * "/$file", (@__FILE__))
                continue
            end
            name = Symbol(split(file, "/")[end][1:(end - 3)])
            sys = eval(:($name(np=($np), k=($ground), ordering=($(Meta.quot(ordering))))))
            push!(systems, (string(name), sys))
        end
    end
    systems
end

using Test, Random, Groebner

monom_construct_from_vector = Groebner.monom_construct_from_vector
monom_to_vector! = Groebner.monom_to_vector!
monom_copy = Groebner.monom_copy
monom_product! = Groebner.monom_product!
monom_division! = Groebner.monom_division!
monom_lcm! = Groebner.monom_lcm!
monom_is_gcd_const = Groebner.monom_is_gcd_const
monom_is_divisible = Groebner.monom_is_divisible
monom_is_divisible! = Groebner.monom_is_divisible!
monom_is_equal = Groebner.monom_is_equal

degree_types_to_test = [UInt64]
implementations_to_test = [
    Groebner.ExponentVector{T} where {T},
    Groebner.ExponentVector{UInt8},
    Groebner.PackedTuple1{T, UInt8} where {T},
    Groebner.PackedTuple2{T, UInt8} where {T},
    Groebner.PackedTuple3{T, UInt8} where {T},
    Groebner.PackedTuple4{T, UInt8} where {T},
    Groebner.NibbleMonom{16},
    Groebner.NibbleNoDeg{16},
    Groebner.FixedMonomNoDeg{16, UInt8},
    # SmallCollections.FixedVector{16, UInt8},
    Groebner.FixedMonom{16, UInt8}
]

max_deg(::Type{<:Groebner.ExponentVector{T}}) where {T} = typemax(T)
max_deg(::Type{<:Groebner.AbstractPackedTuple{T, B}}) where {T, B} = typemax(B)
max_deg(::Type{Groebner.NibbleMonom{N}}) where {N} = 15
max_deg(::Type{Groebner.NibbleNoDeg{N}}) where {N} = 15
max_deg(::Type{Groebner.FixedMonomNoDeg{N, T}}) where {N, T} = typemax(T)
max_deg(::Type{Groebner.FixedMonom{N, T}}) where {N, T} = typemax(T)

@testset "monom arithmetic" begin
    for T in degree_types_to_test
        for EV in implementations_to_test
            MonomType = isconcretetype(EV) ? EV : EV{T}
            (T != UInt64) && (MonomType <: Groebner.AbstractPackedTuple) && continue

            a = monom_construct_from_vector(MonomType, [0, 0])
            b = monom_construct_from_vector(MonomType, [0, 0])
            c = monom_copy(a)
            @test monom_is_gcd_const(a, b)
            c = monom_product!(c, a, b)
            @test monom_is_equal(c, a)
            @test monom_is_equal(c, b)

            d = monom_construct_from_vector(MonomType, [1, 2])
            @test monom_is_equal(a, b)
            @test !monom_is_equal(a, d)
            @test monom_is_gcd_const(d, a)
            c = monom_product!(c, a, d)
            @test monom_is_equal(c, d)
            b = monom_product!(b, d, d)
            c = monom_product!(c, d, c)
            @test monom_is_equal(c, b)
            d = monom_product!(d, d, d)
            @test monom_is_equal(c, d)

            a = monom_construct_from_vector(MonomType, [2, 0])
            b = monom_construct_from_vector(MonomType, [0, 1])
            @test !monom_is_divisible(a, b)

            a = monom_construct_from_vector(MonomType, [0, 1, 3])
            b = monom_construct_from_vector(MonomType, [0, 0, 4])
            @test !monom_is_divisible(a, b)

            n = 6
            if n > Groebner.monom_max_vars(MonomType)
                continue
            end
            a = monom_construct_from_vector(MonomType, [1, 2, 0, 3, 0, 4])
            b = monom_construct_from_vector(MonomType, [0, 1, 0, 2, 0, 4])
            c = monom_construct_from_vector(MonomType, [1, 3, 0, 5, 0, 8])
            d = monom_construct_from_vector(MonomType, [1, 1, 0, 1, 0, 0])
            e = monom_construct_from_vector(MonomType, [1, 2, 0, 3, 0, 4])
            tmp = monom_copy(a)
            @test monom_is_divisible(a, b)
            flag, tmp = monom_is_divisible!(tmp, a, b)
            @test flag
            @test monom_is_equal(tmp, d)
            tmp = monom_product!(tmp, a, b)
            @test monom_is_equal(tmp, c)
            tmp = monom_division!(tmp, a, b)
            @test monom_is_equal(tmp, d)
            tmp = monom_lcm!(tmp, a, b)
            @test monom_is_equal(tmp, e)
            @test !monom_is_gcd_const(a, b)
            @test monom_is_equal(tmp, e)

            n = 9
            if n > Groebner.monom_max_vars(MonomType)
                continue
            end
            a = monom_construct_from_vector(MonomType, [1, 2, 0, 3, 0, 4, 0, 5, 6])
            b = monom_construct_from_vector(MonomType, [0, 1, 0, 2, 0, 4, 0, 0, 2])
            c = monom_construct_from_vector(MonomType, [1, 3, 0, 5, 0, 8, 0, 5, 8])
            d = monom_construct_from_vector(MonomType, [1, 1, 0, 1, 0, 0, 0, 5, 4])
            e = monom_construct_from_vector(MonomType, [1, 2, 0, 3, 0, 4, 0, 5, 6])
            tmp = monom_copy(a)
            @test monom_is_divisible(a, b)
            flag, tmp = monom_is_divisible!(tmp, a, b)
            @test flag
            @test monom_is_equal(tmp, d)
            tmp = monom_product!(tmp, a, b)
            @test monom_is_equal(tmp, c)
            tmp = monom_division!(tmp, a, b)
            @test monom_is_equal(tmp, d)
            tmp = monom_lcm!(tmp, a, b)
            @test monom_is_equal(tmp, e)
            @test !monom_is_gcd_const(a, b)
            @test monom_is_equal(tmp, e)

            n = 30
            if n > Groebner.monom_max_vars(MonomType)
                continue
            end
            a = monom_construct_from_vector(MonomType, 2 .* ones(Int, n))
            b = monom_construct_from_vector(MonomType, 1 .* ones(Int, n))
            tmp = monom_copy(a)
            @test monom_is_divisible(a, b)
            flag, tmp = monom_is_divisible!(tmp, a, b)
            @test flag
            @test monom_is_equal(tmp, b)
            @test !monom_is_gcd_const(a, b)
        end

        # test that different implementations agree
        for n in 1:5
            k = rand(1:50)

            implementations_to_test_spec = map(
                MonomType -> isconcretetype(MonomType) ? MonomType : MonomType{T},
                implementations_to_test
            )
            implementations_to_test_local = filter(
                MonomType -> Groebner.monom_max_vars(MonomType) >= k,
                implementations_to_test_spec
            )

            t = div(typemax(UInt8), 2k) - 1
            t = min(t, div(minimum(max_deg.(implementations_to_test_local)), 2))
            x, y = rand(0:t, k), rand(0:t, k)
            as = [monom_construct_from_vector(MT, x) for MT in implementations_to_test_local]
            bs = [monom_construct_from_vector(MT, y) for MT in implementations_to_test_local]

            results = []
            for (a, b) in zip(as, bs)
                c = monom_copy(a)
                tmp1 = similar(x)
                monom_to_vector!(tmp1, c)
                c = monom_product!(c, a, b)
                tmp2 = similar(x)
                monom_to_vector!(tmp2, c)
                flag = monom_is_divisible(a, b)
                _, a = monom_is_divisible!(a, c, b)
                tmp3 = similar(x)
                monom_to_vector!(tmp3, a)
                _, c = monom_is_divisible!(c, c, c)
                tmp4 = similar(x)
                monom_to_vector!(tmp4, a)
                push!(results, (tmp1, tmp2, flag, tmp3, tmp4))
            end
            @test length(unique(results)) == 1
        end
    end
end

@testset "monom division mask" begin
    nvars = 4
    #! format: off
    divmap = UInt32[1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8]
    #! format: on
    ndivbits = 8
    cases = [
        (monom=UInt8[0x00, 0x00, 0x00, 0x00], mask="00000000000000000000000000000000"),
        (monom=UInt8[0x01, 0x00, 0x1a, 0x00], mask="00000000111111110000000000000001"),
        (monom=UInt8[0x00, 0x01, 0x00, 0x00], mask="00000000000000000000000100000000"),
        (monom=UInt8[0x00, 0x00, 0x01, 0x00], mask="00000000000000010000000000000000"),
        (monom=UInt8[0x00, 0x00, 0x00, 0x01], mask="00000001000000000000000000000000"),
        (monom=UInt8[0x01, 0x01, 0x00, 0x00], mask="00000000000000000000000100000001"),
        (monom=UInt8[0x01, 0x00, 0x01, 0x00], mask="00000000000000010000000000000001"),
        (monom=UInt8[0x00, 0x03, 0x02, 0x00], mask="00000000000000110000011100000000"),
        (monom=UInt8[0x01, 0x00, 0x00, 0x01], mask="00000001000000000000000000000001"),
        (monom=UInt8[0x00, 0x01, 0x00, 0x01], mask="00000001000000000000000100000000"),
        (monom=UInt8[0x00, 0x00, 0x01, 0x01], mask="00000001000000010000000000000000"),
        (monom=UInt8[0x01, 0x01, 0x01, 0x00], mask="00000000000000010000000100000001"),
        (monom=UInt8[0x01, 0x01, 0x00, 0x01], mask="00000001000000000000000100000001"),
        (monom=UInt8[0x01, 0x0a, 0x01, 0x01], mask="00000001000000011111111100000001"),
        (monom=UInt8[0x00, 0x01, 0x01, 0x01], mask="00000001000000010000000100000000"),
        (monom=UInt8[0x01, 0x01, 0x01, 0x01], mask="00000001000000010000000100000001")
    ]

    for case in cases
        monom, mask = case.monom, case.mask
        for T in degree_types_to_test
            for EV in implementations_to_test
                MonomType = isconcretetype(EV) ? EV : EV{T}

                n = nvars
                if n > Groebner.monom_max_vars(MonomType)
                    continue
                end
                if any(e -> e > max_deg(MonomType), monom)
                    continue
                end

                m = monom_construct_from_vector(MonomType, monom)
                ans = parse(Groebner.DivisionMask, mask, base=2)
                dm = Groebner.monom_create_divmask(
                    m,
                    Groebner.DivisionMask,
                    nvars,
                    divmap,
                    ndivbits,
                    :first_variables
                )
                @test ans == dm
            end
        end
    end
end

@testset "monom hash linearity" begin
    for _ in 1:30
        for T in degree_types_to_test
            for EV in implementations_to_test
                MonomType = isconcretetype(EV) ? EV : EV{T}
                n = rand(1:50)
                if n > Groebner.monom_max_vars(MonomType)
                    continue
                end
                t = div(typemax(UInt8), 8 * n)
                t = min(t, div(max_deg(MonomType), 2))
                x, y = rand(0:min(t, 7), n), rand(0:min(t, 8), n)
                a = monom_construct_from_vector(MonomType, x)
                b = monom_construct_from_vector(MonomType, y)
                c = Groebner.monom_construct_const(MonomType, n)
                c = monom_product!(c, a, b)
                h = Groebner.monom_construct_hash_vector(Random.MersenneTwister(), MonomType, n)
                @test typeof(Groebner.monom_hash(a, h)) === Groebner.MonomHash
                @test Groebner.monom_hash(a, h) + Groebner.monom_hash(b, h) ==
                      Groebner.monom_hash(c, h)
            end
        end
    end
end

@testset "monom hash sensitivity" begin
    rng = Random.MersenneTwister(42)
    for _ in 1:30
        for T in degree_types_to_test
            for EV in implementations_to_test
                MonomType = isconcretetype(EV) ? EV : EV{T}
                n = rand(rng, 1:50)
                if n > Groebner.monom_max_vars(MonomType)
                    continue
                end

                hv = Groebner.monom_construct_hash_vector(rng, MonomType, n)
                x1 = zeros(Int, n)
                x1[rand(rng, 1:n, 4)] .+= rand(rng, 1:3)

                for i in 1:n
                    x2 = copy(x1)
                    x2[i] += 1

                    m1 = monom_construct_from_vector(MonomType, x1)
                    m2 = monom_construct_from_vector(MonomType, x2)

                    @test !monom_is_equal(m1, m2)
                    @test Groebner.monom_hash(m1, hv) != Groebner.monom_hash(m2, hv)
                end
            end
        end
    end
end

using InteractiveUtils

function new_modular(A, B, P::UInt32, R::UInt64)
    C = (((((UInt64(A)*UInt64(B))*R) >>> 32) + 1)*UInt64(P)) >>> 32
    C % UInt32
    # if C == P
    #     0 % UInt32
    # else
    #     C % UInt32
    # end
end

function new_modular_2(A, BR::UInt64, P::UInt32)
    C = ((((UInt64(A)*BR) >>> 32) + 1)*UInt64(P)) >>> 32
    C % UInt32
    # if C == P
    #     0 % UInt32
    # else
    #     C % UInt32
    # end
end

function new_modular_3(C, A, B, P::UInt32, R::UInt64)
    C = (((((C + UInt64(A)*UInt64(B))*R) >>> 32) + 1)*UInt64(P)) >>> 32
    C % UInt32
    # if C == P
    #     0 % UInt32
    # else
    #     C % UInt32
    # end
end

n = 32
phi = (1 + sqrt(5)) / 2
P = UInt32(2^30+3)
@assert P < 2^n / phi
R = UInt64(invmod(P, big(2)^(2n)))

A, B = UInt32(641008720), UInt32(423423)
@assert A < P && B < P

B_repr = UInt64(mod(B*(mod(-mod(BigInt(2)^(2n), P), P)), P))
# B_repr = B

res1 = new_modular(A, B_repr, P, R)

res2 = UInt32((big(A)*B) % P)

res3 = new_modular(res1, 1, P, R)

B_repr_R = B_repr*R

res4 = new_modular_2(A, B_repr_R, P)

@code_native debuginfo=:none new_modular(A, B_repr, P, R)
@code_native debuginfo=:none new_modular_2(A, B_repr_R, P)

@info "" res1 res2 res3 res4

C = UInt64(342342311)
@assert C < P

C_repr = UInt64(mod(C*(mod(-mod(BigInt(2)^(2n), P), P)), P))
res5 = new_modular_3(C_repr, A, B_repr, P, R)

res6 = UInt32((big(C) + big(A)*B) % P)

@info "" res5 res6

# using Groebner, BenchmarkTools, InteractiveUtils
# m = Groebner.SpecializedArithmeticZp(UInt, UInt32, UInt32(2^30+3))
# function uwu(x,y,m)
#     Groebner.mod_p(x*y, m)
# end
# @code_native debuginfo=:none uwu(UInt64(A), UInt64(B_repr), m)
# @btime uwu($(UInt64(A)), $(UInt64(B_repr)), $m)
# @btime new_modular($(UInt64(A)), $(UInt64(B_repr)), $P, $R)
# @btime new_modular_2($(UInt32(A)), $(UInt64(B_repr_R)), $P)

function add_row_1(row, indices, coeffs, val, m)
    @inbounds for i in 1:length(indices)
        ind = indices[i]
        row[ind] = Groebner.mod_p(row[ind] + UInt64(coeffs[i]) * UInt64(val), m)
    end
end

function add_row_2(row, indices, coeffs, val, m)
    @inbounds for i in 1:length(indices)
        ind = indices[i]
        row[ind] = row[ind] + new_modular_2(coeffs[i], val, m)
        row[ind] = row[ind] <= m ? row[ind] : row[ind] - m
    end
end

# @code_native debuginfo=:none add_row_1(zeros(UInt64, 10), [1,3,5], [UInt32(2), UInt32(3), UInt32(4)], UInt32(5), m)
# @code_native debuginfo=:none add_row_2(zeros(UInt64, 10), [1,3,5], [UInt32(2), UInt32(3), UInt32(4)], UInt64(B_repr_R), P)

# @btime add_row_1(__row, __inds, __coeffs, $(UInt32(5)), $m) setup=(__row=rand(UInt64, 1000); __inds=sort(rand(1:1000, 100)); __coeffs=rand(UInt32(1):UInt32(2^30), 100))
# @btime add_row_2(__row, __inds, __coeffs, $(UInt64(B_repr_R)), $P) setup=(__row=rand(UInt64, 1000); __inds=sort(rand(1:1000, 100)); __coeffs=rand(UInt32(1):UInt32(2^30), 100))

#=
.LBB0_4:                                # %L20
        mov     r15, qword ptr [r11 + 8*r8]
        mov     edx, dword ptr [rbx + 4*r8]
        imul    rdx, r10
        add     rdx, qword ptr [rax + 8*r15 - 8]
        mulx    r12, r12, rdi
        shrx    r12, r12, rsi
        imul    r12, rcx
        sub     rdx, r12
        mov     qword ptr [rax + 8*r15 - 8], rdx
        mov     r15, qword ptr [r11 + 8*r8 + 8]
        mov     edx, dword ptr [rbx + 4*r8 + 4]
        imul    rdx, r10
        add     rdx, qword ptr [rax + 8*r15 - 8]
        mulx    r12, r12, rdi
        shrx    r12, r12, rsi
        imul    r12, rcx
        sub     rdx, r12
        mov     qword ptr [rax + 8*r15 - 8], rdx
        add     r8, 2
        cmp     r14, r8
        jne     .LBB0_4

vs.

.LBB0_4:                                # %L20
        mov     r11, qword ptr [rsi + 8*r8]
        mov     ebx, dword ptr [rdi + 4*r8]
        imul    rbx, rcx
        shr     rbx, 32
        inc     rbx
        imul    rbx, rdx
        shr     rbx, 32
        add     qword ptr [rax + 8*r11 - 8], rbx
        mov     r11, qword ptr [rsi + 8*r8 + 8]
        mov     ebx, dword ptr [rdi + 4*r8 + 4]
        imul    rbx, rcx
        shr     rbx, 32
        inc     rbx
        imul    rbx, rdx
        shr     rbx, 32
        add     qword ptr [rax + 8*r11 - 8], rbx
        add     r8, 2
        cmp     r10, r8
        jne     .LBB0_4
=#

using Nemo, Groebner, BenchmarkTools, PrettyTables, Printf

k = Nemo.GF(2^30+3)
systems = [
    ("chandra-9", Groebner.Examples.chandran(9, k=k)),
    ("chandra-10", Groebner.Examples.chandran(10, k=k)),
    ("cyclic-7", Groebner.Examples.cyclicn(7, k=k)),
    ("eco-11", Groebner.Examples.econ(11, k=k)),
    ("noon-7", Groebner.Examples.noonn(7, k=k)),
    ("katsura-9", Groebner.Examples.katsuran(9, k=k)),
    ("katsura-10", Groebner.Examples.katsuran(10, k=k)),
    ("hexapod", Groebner.Examples.hexapod(k=k)),
]

println("Running the following systems: ", map(first, systems))

data = []
for (name, sys) in systems
    @info "Running $name.."
    t1, t2, t3, t4, t5 = 0, 0, 0, 0, 0
    for _ in 1:2
        t1 = @elapsed groebner(sys; threaded=:no)
        t2 = @elapsed trace, _ = groebner_learn(sys)
        t3 = @elapsed groebner_apply!(trace, sys)
        t3 = @elapsed groebner_apply!(trace, sys)
        t4 = @elapsed groebner_apply!(trace, (sys, sys, sys, sys))
        t4 = @elapsed groebner_apply!(trace, (sys, sys, sys, sys))
        t5 = @elapsed groebner_apply!(trace, (sys, sys, sys, sys, sys, sys, sys, sys))
        t5 = @elapsed groebner_apply!(trace, (sys, sys, sys, sys, sys, sys, sys, sys))
    end
    push!(data, [name, t1, t2, t3, t4, t5])
end

matrix = permutedims(reduce(hcat, data))
pretty_table(
    matrix, 
    column_labels=[
        [EmptyCells(2), MultiColumn(4, "Learn & Apply")], 
        ["Name", "Monte-Carlo", "Learn", "Apply", "Apply 4x", "Apply 8x"]
    ],
    title="Timings in seconds",
    formatters=[(v,i,j) -> v isa Number ? @sprintf("%.2f", v) : v],
    table_format = TextTableFormat(borders = text_table_borders__ascii_rounded);  
)

using Test, Groebner, Random

@testset "NibbleMonom, NibbleNoDeg" begin
    for NM in [Groebner.NibbleMonom{16}, Groebner.NibbleNoDeg{16}]
        x = [1, 2, 3, 0, 4]
        ev = Groebner.monom_construct_from_vector(NM, x)
        if NM <: Groebner.NibbleMonom
            @test typeof(Groebner.monom_totaldeg(ev)) === UInt8
            @test Groebner.monom_totaldeg(ev) === UInt8(10)
        else
            @test typeof(Groebner.monom_totaldeg(ev)) === UInt16
            @test Groebner.monom_totaldeg(ev) === UInt16(10)
        end
        tmp = similar(x)
        @test Groebner.monom_to_vector!(tmp, ev) == [1, 2, 3, 0, 4]
        @test tmp == [1, 2, 3, 0, 4]

        @test Groebner.monom_max_vars(NM) == 32

        y = [10, 10, 10, 16, 10]
        @test_throws Groebner.MonomialDegreeOverflow Groebner.monom_construct_from_vector(NM, y)

        y = [10, 10, 10, 10, 10]
        m = Groebner.monom_construct_from_vector(NM, y)
        @test_throws Groebner.MonomialDegreeOverflow Groebner.monom_product!(m, m, m)
    end

    for i in 1:8
        N = 2^i
        for NM in [Groebner.NibbleMonom{N}, Groebner.NibbleNoDeg{N}]
            for k in 1:100
                for (x1, x2) in [
                    (rand(0:15, 2N), rand(0:15, 2N)),
                    (rand(0:1, 2N), rand(0:1, 2N)),
                    (vcat([1, 2, 3], zeros(Int, 2N - 3)), vcat([4, 5, 6], zeros(Int, 2N - 3)))
                ]
                    if NM == Groebner.NibbleMonom{N} && sum(x1) + sum(x2) > typemax(UInt8)
                        continue
                    end
                    if any(>(15), x1 .+ x2)
                        continue
                    end
                    m1 = Groebner.monom_construct_from_vector(NM, x1)
                    m2 = Groebner.monom_construct_from_vector(NM, x2)
                    m3 = Groebner.monom_product!(m1, m1, m2)
                    x3 = Groebner.monom_to_vector!(similar(x1), m3)
                    @test x3 == (x1 .+ x2)
                    flag, m4 = Groebner.monom_is_divisible!(m1, m3, m2)
                    @test flag && Groebner.monom_is_equal(m4, m1)
                    m5 = Groebner.monom_lcm!(m4, m1, m2)
                    x5 = Groebner.monom_to_vector!(similar(x1), m5)
                    @test x5 == max.(x1, x2)
                    flag = Groebner.monom_is_gcd_const(m1, m2)
                    @test flag == all(iszero, x1 .* x2)
                    rng = Random.Xoshiro(42)
                    hv = Groebner.monom_construct_hash_vector(rng, NM, 2N)
                    h1, h2 = Groebner.monom_hash(m1, hv), Groebner.monom_hash(m2, hv)
                    @test h1 + h2 == Groebner.monom_hash(m3, hv)
                end
            end
        end
    end
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Parts of this file were adapted from msolve:
# https://github.com/algebraic-solving/msolve
# msolve is distributed under GNU GPL v2+:
# https://github.com/algebraic-solving/msolve/blob/master/COPYING

###
# High level

function linalg_deterministic_sparse_threaded!(
    matrix::MacaulayMatrix,
    basis::Basis,
    linalg::LinearAlgebra,
    tasks::Int,
    arithmetic::AbstractArithmetic
)
    sort_matrix_upper_rows!(matrix) # for the AB part
    sort_matrix_lower_rows!(matrix) # for the CD part

    # Reduce CD with AB
    linalg_reduce_matrix_lower_part_threaded_cas!(matrix, basis, tasks, arithmetic)
    # Interreduce CD
    linalg_interreduce_matrix_pivots!(matrix, basis, arithmetic)
    true
end

###
# Low level

# internal function for multi-threading
function _linalg_reduce_matrix_lower_part_threaded_cas!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    chunk::Vector{Int},
    pivots::Vector{Vector{ColumnLabel}},
    row_index_to_coeffs::Vector{Int},
    sentinels::Vector{Int8},
    arithmetic::AbstractArithmetic{AccumType, CoeffType},
    t_local_row::Vector{AccumType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    @inbounds for i in chunk
        new_sparse_row_support, new_sparse_row_coeffs = linalg_new_empty_sparse_row(CoeffType)

        # Select a row to be reduced from the lower part of the matrix
        # NOTE: no copy of coefficients is needed
        sparse_row_support = matrix.lower_rows[i]
        sparse_row_coeffs = basis.coeffs[row_index_to_coeffs[i]]
        @invariant length(sparse_row_support) == length(sparse_row_coeffs)

        # Load the coefficients into a dense array
        linalg_load_sparse_row!(t_local_row, sparse_row_support, sparse_row_coeffs)

        first_nnz_column = sparse_row_support[1]

        # In a somewhat ideal scenario, the while loop below executes just once
        success = false
        @inbounds while !success
            @invariant 1 <= first_nnz_column <= length(t_local_row)

            # Note that this call may only mutate the first three arguments, and
            # the arguments do not overlap in memory with each other
            zeroed = linalg_reduce_dense_row_by_pivots_sparse_threadsafe0!(
                new_sparse_row_support,
                new_sparse_row_coeffs,
                t_local_row,
                matrix,
                basis,
                pivots,
                first_nnz_column,
                ncols,
                arithmetic,
                sentinels
            )

            # If the row is fully reduced
            zeroed && break

            # Sync point. Everything before this point becomes visible to
            # all other threads once they reach this point.
            # Note the absense of a total ordering on atomic operations
            old, success = Atomix.replace!(
                Atomix.IndexableRef(sentinels, (Int(new_sparse_row_support[1]),)),
                Int8(0),
                Int8(1),
                Atomix.acquire_release,
                Atomix.acquire
            )

            @invariant length(new_sparse_row_support) == length(new_sparse_row_coeffs)

            if success
                # new pivot is formed, wake up from the inner loop
                @invariant iszero(old)

                linalg_row_make_monic!(new_sparse_row_coeffs, arithmetic)

                matrix.some_coeffs[i] = new_sparse_row_coeffs
                matrix.lower_to_coeffs[new_sparse_row_support[1]] = i
                pivots[new_sparse_row_support[1]] = new_sparse_row_support

                # This atomic write is paired by an atomic load in
                # `linalg_reduce_dense_row_by_pivots_sparse_threadsafe0!`. The
                # purpose of these atomics is to fence the above assignment
                #    pivots[new_sparse_row_support[1]] = new_sparse_row_support
                # 
                # This way, the next atomic load from the same location in
                # `sentinels` will also receive all relevant modifications to
                # `pivots` as a side-effect.
                Atomix.set!(
                    Atomix.IndexableRef(sentinels, (Int(new_sparse_row_support[1]),)),
                    Int8(2),
                    Atomix.release
                )
            else
                # go for another iteration
                first_nnz_column = new_sparse_row_support[1]
            end
        end
    end
end

# Given a matrix of the following form, where A is in REF,
#   A B
#   C D
# reduces the lower part CD with respect to the pivots in the upper part AB.
# As a result, a matrix of the following form is produced:
#   A B
#   0 D'
# The new pivots in the D' block are known, but possibly not fully interreduced.
function linalg_reduce_matrix_lower_part_threaded_cas!(
    matrix::MacaulayMatrix{CoeffType},
    basis::Basis{CoeffType},
    tasks::Int,
    arithmetic::AbstractArithmetic{AccumType, CoeffType}
) where {CoeffType <: Coeff, AccumType <: Coeff}
    _, ncols = size(matrix)
    nup, nlow = matrix_nrows_filled(matrix)

    # Prepare the matrix
    pivots, row_index_to_coeffs = linalg_prepare_matrix_pivots!(matrix)
    resize!(matrix.some_coeffs, nlow)
    resize!(matrix.sentinels, ncols)

    # If there is a pivot with the leading column i, then we set
    #   sentinels[i] = 1.
    # If sentinels[i] = 1, and if the pivot is synced, then we set
    #   sentinels[i] = 2.
    # Otherwise, sentinels[i] = 0.
    # Once sentinels[i] becomes 1 or 2, this is unchanged.
    sentinels = matrix.sentinels
    @inbounds for i in 1:ncols
        sentinels[i] = 0
    end
    @inbounds for i in 1:nup
        sentinels[matrix.upper_rows[i][1]] = 2
    end

    # Allocate thread-local buffers
    buffers_row = map(_ -> zeros(AccumType, ncols), 1:tasks)

    tasks = min(tasks, nlow)
    data_chunks = split_round_robin(1:nlow, tasks)
    task_results = Vector{Task}(undef, tasks)
    for (tid, chunk) in enumerate(data_chunks)
        t_local_row = buffers_row[tid]
        task = @spawn begin
            _linalg_reduce_matrix_lower_part_threaded_cas!(
                matrix,
                basis,
                chunk,
                pivots,
                row_index_to_coeffs,
                sentinels,
                arithmetic,
                t_local_row
            )
        end
        task_results[tid] = task
    end
    for task in task_results
        wait(task)
    end

    true
end

function linalg_reduce_dense_row_by_pivots_sparse_threadsafe0!(
    new_sparse_row_support::Vector{I},
    new_sparse_row_coeffs::Vector{C},
    row::Vector{A},
    matrix::MacaulayMatrix{C},
    basis::Basis{C},
    pivots::Vector{Vector{I}},
    start_column::Integer,
    end_column::Integer,
    arithmetic::AbstractArithmeticZp{A, C},
    sentinels::Vector{Int8},
    active_reducers=nothing;
    ignore_column::Integer=-1
) where {I, C <: Union{CoeffZp, CompositeCoeffZp}, A <: Union{CoeffZp, CompositeCoeffZp}}
    _, ncols = size(matrix)
    nleft, _ = matrix_ncols_filled(matrix)

    n_nonzeros = 0
    new_pivot_column = -1

    @inbounds for i in start_column:end_column
        # if the element is zero -- no reduction is needed
        if iszero(row[i])
            continue
        end

        if 2 != Atomix.get(Atomix.IndexableRef(sentinels, (i,)), Atomix.acquire)
            if new_pivot_column == -1
                new_pivot_column = i
            end
            n_nonzeros += 1
            continue
        end
        # At this point, the value of pivots[i] is in sync with any other thread
        # that modifies, modified, or will modify it

        # if there is no pivot with the leading column equal to i
        if !isassigned(pivots, i) || ignore_column == i
            if new_pivot_column == -1
                new_pivot_column = i
            end
            n_nonzeros += 1
            continue
        end
        # At this point, we have determined that pivots[i] is a valid pivot.

        # Locate the support and the coefficients of the pivot row
        pivot_support = pivots[i]
        if i <= nleft
            # if pivot comes from the original pivots
            pivot_coeffs = basis.coeffs[matrix.upper_to_coeffs[i]]
            record_active_reducer(active_reducers, matrix, i)
        else
            pivot_coeffs = matrix.some_coeffs[matrix.lower_to_coeffs[i]]
        end
        @invariant length(pivot_support) == length(pivot_coeffs)

        linalg_vector_addmul_sparsedense_mod_p!(row, pivot_support, pivot_coeffs, arithmetic)

        @invariant iszero(row[i])
    end

    # all row elements reduced to zero!
    if n_nonzeros == 0
        return true
    end

    # form the resulting row in sparse format
    resize!(new_sparse_row_support, n_nonzeros)
    resize!(new_sparse_row_coeffs, n_nonzeros)
    linalg_extract_sparse_row!(
        new_sparse_row_support,
        new_sparse_row_coeffs,
        row,
        convert(Int, start_column),
        ncols
    )

    false
end

using Pkg;
Pkg.develop(path=joinpath((@__DIR__), "../"))
# Pkg.add(url="https://github.com/sumiya11/Groebner.jl", rev="benchmark-composite")

using Plots, Groebner, BenchmarkTools

SAVE_DIR = (@__DIR__)
BOOT = 10
COMPOSITE = (1, 2, 4, 8, 16, 32, 64)

@info "Benchmarking composite widths: $COMPOSITE"
@info "Using BOOT=$BOOT"
@info "Saving result to $SAVE_DIR"

systems = [
    ("chandra-9", Groebner.Examples.chandran(9)),
    ("chandra-10", Groebner.Examples.chandran(10)),
    ("cyclic-7", Groebner.Examples.cyclicn(7)),
    ("cyclic-8", Groebner.Examples.cyclicn(8)),
    ("eco-11", Groebner.Examples.eco11()),
    ("katsura-9", Groebner.Examples.katsuran(9)),
    ("katsura-10", Groebner.Examples.katsuran(10)),
    ("hexapod", Groebner.Examples.hexapod()),
    ("hiv2", Groebner.Examples.HIV2()),
    ("alea6", Groebner.Examples.alea6())
]

data = Dict()
for (name, sys) in systems
    @info "Running $name.."
    data[name] = Dict("time" => [], "memory" => [], "primes" => 0)
    groebner(sys, threaded=:no)
    data[name]["primes"] = Groebner.PRIMES[]
    for _composite in COMPOSITE
        ts = [@elapsed groebner(sys; _composite=_composite, threaded=:no) for _ in 1:BOOT]
        a = @allocated groebner(sys; _composite=_composite, threaded=:no)
        t = minimum(ts)
        push!(data[name]["time"], t)
        push!(data[name]["memory"], a)
    end
    data[name]["time_ratio"] = data[name]["time"] / data[name]["time"][1]
    data[name]["memory_ratio"] = data[name]["memory"] / data[name]["memory"][1]
end

function draw()
    begin
        dpi = 200
        figsize = (700, 900)
        linewidth = 2
        titlesize = 8
        linestyles = [:solid, :dash, :dot, :dashdot, :dashdotdot]
        p1 = plot(
            size=figsize,
            xticks=(1:length(COMPOSITE), collect(COMPOSITE)),
            yticks=[0.25, 0.5, 0.75, 1.0, 1.25, 1.5],
            ylims=(0.30, 1.70),
            xlabel="composite width",
            ylabel="time ratio",
            legend=:topleft,
            title="Runtime",
            titlesize=titlesize
        )
        p2 = plot(
            size=figsize,
            xticks=(1:length(COMPOSITE), collect(COMPOSITE)),
            yticks=[0.25, 0.5, 0.75, 1.0, 1.25, 1.5],
            ylims=(0.20, 1.60),
            xlabel="composite width",
            ylabel="memory ratio",
            legend=:topleft,
            title="Memory",
            titlesize=titlesize
        )
        for (i, (name, _)) in enumerate(systems)
            name_padded = rpad(name, 13)
            label1 = "$name_padded ($(round(data[name]["time"][1], digits=1)) s)"
            plot!(
                p1,
                1:length(COMPOSITE),
                data[name]["time_ratio"],
                label=label1,
                alpha=0.7,
                linewidth=linewidth,
                linestyle=linestyles[i % length(linestyles) + 1]
            )
            primes = data[name]["primes"]
            annotate!(
                p1,
                3.0,
                1.6 - 0.048 * (i - 1),
                Plots.text(
                    "∘ $(name) - $(primes) primes",
                    halign=:left,
                    color="black",
                    pointsize=9
                )
            )

            label2 = "$name_padded ($(BenchmarkTools.prettymemory(data[name]["memory"][1])))"
            plot!(
                p2,
                1:length(COMPOSITE),
                data[name]["memory_ratio"],
                label=label2,
                alpha=0.7,
                linewidth=linewidth,
                linestyle=linestyles[i % length(linestyles) + 1]
            )
        end
        P = plot(p1, p2, layout=(2, 1))
        savefig(P, joinpath([SAVE_DIR, "plot.pdf"]))
        P
    end
end

draw()

import Nemo

function read_SEAIJRC()
    @info "Reading SEAIJRC"
    polys = []
    apath = "C:\\data\\projects\\gbdata\\gbSEAIJRC"
    open(apath, "r") do f
        head = "b, alpha, g2, Ninv, k, g1, q, r, sat_aux1, sat_aux2"
        body = readline(f)
        @info "First line" head
        headv = map(x -> Symbol(x), split(head, ", "))
        e = Meta.parse(join(headv, ","))
        R, xs = eval(:((R, $e) = Nemo.polynomial_ring(Nemo.QQ, $headv)))
        @info "Created ring" R xs
        rrr = split(body, ",")
        for (i, s) in enumerate(rrr)
            @info "Reading poly $i/$(length(rrr))"
            poly = eval(Meta.parse(s))
            push!(polys, poly)
        end
    end
    @info "Read" length(polys)
    R.(polys)
end

function read_SIWR()
    @info "Reading SIWR"
    polys = []
    apath = "C:\\data\\projects\\gbdata\\gbSIWR"
    open(apath, "r") do f
        head = readline(f)
        body = readline(f)
        headv = map(x -> Symbol(x), split(head, ", "))
        e = Meta.parse(join(headv, ","))
        R, xs = eval(:((R, $e) = Nemo.polynomial_ring(Nemo.QQ, $headv)))
        @info "Created ring" R xs
        rrr = split(body, ",")
        for (i, s) in enumerate(rrr)
            @info "Reading poly $i/$(length(rrr))"
            poly = eval(Meta.parse(s))
            push!(polys, poly)
        end
    end
    @info "Read" length(polys)
    R.(polys)
end

function read_MAPK()
    @info "Reading MAPK"
    polys = []
    apath = "../../MAPK"
    # apath = "MAPK"
    open(apath, "r") do f
        head = "c0001, a10, gamma1000, alpha10, b00, beta11, c0111, beta10, alpha11, beta01, alpha01, gamma1100, c0011, c0010, b10, gamma1101, a00, b01, c1011, a01, gamma1110, gamma0100, sat_aux1, sat_aux2, sat_aux3, sat_aux4, sat_aux5"
        body = readline(f)
        @info "First line" head
        headv = map(x -> Symbol(x), split(head, ", "))
        e = Meta.parse(join(headv, ","))
        R, xs = eval(:((R, $e) = Nemo.polynomial_ring(Nemo.QQ, $headv)))
        @info "Created ring" R xs
        rrr = split(body, ",")
        l = length(rrr)
        for i in 1:length(rrr)
            @info "Reading poly $i/$(length(rrr))"
            str = map(strip, split(rrr[1], "+"))
            poly = R(0)
            for s1 in str
                # println(s1)
                # println("_________________")
                if occursin("-", s1)
                    sp1 = split(s1, "-")
                    if startswith(s1, "-")
                        sp1 = sp1[2:end]
                        poly -= eval(Meta.parse(sp1[1]))
                    else
                        poly += eval(Meta.parse(sp1[1]))
                    end
                    for s2 in sp1[2:end]
                        poly -= eval(Meta.parse(s2))
                    end
                else
                    poly += eval(Meta.parse(s1))
                end
            end
            push!(polys, poly)
            popfirst!(rrr)
        end
    end
    @info "Read" length(polys)
    R.(polys)
end

function read_MAPK_include()
    @info "Reading MAPK"
    polys = []
    apath = "../../MAPK"

    head = "c0001, a10, gamma1000, alpha10, b00, beta11, c0111, beta10, alpha11, beta01, alpha01, gamma1100, c0011, c0010, b10, gamma1101, a00, b01, c1011, a01, gamma1110, gamma0100, sat_aux1, sat_aux2, sat_aux3, sat_aux4, sat_aux5"
    @info "First line" head
    headv = map(x -> Symbol(x), split(head, ", "))
    e = Meta.parse(join(headv, ","))
    R, xs = eval(:((R, $e) = Nemo.polynomial_ring(Nemo.QQ, $headv)))

    collect(include(apath))
end

function parse_include(filename)
    head = "x, y, z"
    headv = map(x -> Symbol(x), split(head, ", "))
    e = Meta.parse("x, y, z")
    R, xs = eval(:((R, $e) = Nemo.polynomial_ring(Nemo.QQ, $headv)))

    include(abspath("benchmark\\data\\$filename"))
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Struct <--> NamedTuple.
# Adapted from NamedTupleTools.jl. License is MIT.

function fieldvalues(x::T) where {T}
    !isstructtype(T) && throw(ArgumentError("$(T) is not a struct type"))
    return ((getfield(x, name) for name in fieldnames(T))...,)
end

function nt_from_struct(x::T) where {T}
    !isstructtype(T) && throw(ArgumentError("$(T) is not a struct type"))
    names = fieldnames(T)
    types = fieldtypes(T)
    values = fieldvalues(x)
    return NamedTuple{names, Tuple{types...}}(values)
end

function struct_from_nt(::Type{S}, x::NT) where {S, N, T, NT <: NamedTuple{N, T}}
    names = N
    values = fieldvalues(x)
    fieldnames(S) != names && throw(ErrorException("fields in ($S) do not match ($x)"))
    return S(values...)
end

function struct_update(::Type{T}, str, new_options::NamedTuple) where {T}
    options = nt_from_struct(str)
    options = merge(options, new_options)
    struct_from_nt(T, options)
end

using Test, Groebner

@testset "ratrec" begin
    ZZ = Groebner.Nemo.ZZRingElem
    m = ZZ(2^30 + 3)
    p, q = -8, 111
    a = ZZ(mod(p * invmod(ZZ(q), m), m))
    N = ZZ((isqrt(m) >> 1) - 1)
    D = ZZ((isqrt(m) >> 1) - 1)
    @test Groebner.ratrec_nemo(a, m, N, D) == (true, Rational{BigInt}(p // q))
    p, q = N + 2, D + 1
    a = ZZ(mod(p * invmod(ZZ(q), m), m))
    @test Groebner.ratrec_nemo(a, m, N, D)[1] == false
end

@testset "ratrec table" begin
    table_qq = [Rational{BigInt}[], Rational{BigInt}[0, 0, 0], Rational{BigInt}[0, 0]]
    res = [
        Rational{BigInt}[],
        Rational{BigInt}[2 // 3, 0 // 1, -5 // 8],
        Rational{BigInt}[-11 // 1, 7 // 4]
    ]

    modulo = BigInt(131)
    table_zz = [
        BigInt[mod(numerator(r) * invmod(denominator(r), modulo), modulo) for r in row] for
        row in res
    ]
    mask = [falses(length(table_qq[i])) for i in 1:length(table_qq)]
    success = Groebner.ratrec_vec_full!(table_qq, table_zz, modulo, mask)
    @test !success

    modulo = BigInt(251)
    table_zz = [
        BigInt[mod(numerator(r) * invmod(denominator(r), modulo), modulo) for r in row] for
        row in res
    ]
    success = Groebner.ratrec_vec_full!(table_qq, table_zz, modulo, mask)
    @test success && table_qq == res
    for tasks in [1, 2, 3, 4]
        success = Groebner.ratrec_vec_full!(table_qq, table_zz, modulo, mask, tasks=tasks)
        @test success && table_qq == res
    end
end

using Revise, Groebner, Nemo, TimerOutputs


@info "nthreads=$(Base.Threads.nthreads())"
sys = Groebner.Examples.alea6();

TimerOutputs.enable_timer!(Groebner._TIMER); reset_timer!(Groebner._TIMER); @time gb = groebner(sys; tasks=1); show(Groebner._TIMER, allocations=false); TimerOutputs.disable_timer!(Groebner._TIMER);

TimerOutputs.enable_timer!(Groebner._TIMER2); reset_timer!(Groebner._TIMER2); @time gb = groebner(sys; tasks=1); show(Groebner._TIMER2, allocations=false); println(); TimerOutputs.disable_timer!(Groebner._TIMER2);
TimerOutputs.enable_timer!(Groebner._TIMER2); reset_timer!(Groebner._TIMER2); @time gb = groebner(sys; tasks=2); show(Groebner._TIMER2, allocations=false); println(); TimerOutputs.disable_timer!(Groebner._TIMER2);
TimerOutputs.enable_timer!(Groebner._TIMER2); reset_timer!(Groebner._TIMER2); @time gb = groebner(sys; tasks=4); show(Groebner._TIMER2, allocations=false); println(); TimerOutputs.disable_timer!(Groebner._TIMER2);
TimerOutputs.enable_timer!(Groebner._TIMER2); reset_timer!(Groebner._TIMER2); @time gb = groebner(sys; tasks=8); show(Groebner._TIMER2, allocations=false); println(); TimerOutputs.disable_timer!(Groebner._TIMER2);

nothing

# Rational reconstruction
function mqrr(x::BigInt, m::BigInt)
    if m <= 0
        throw(ArgumentError("modulus must be positive"))
    end
    if x < 0 || x >= m
        throw(ArgumentError("x must be in [0, m)"))
    end
    T = 2^20*ceil(Int, log(2, m))
    t0, r0 = BigInt(0), m
    t1, r1 = BigInt(1), x
    n, d = 0, 0
    while r1 != 0 && r0 > T
        q = div(r0, r1)
        if q > T
            n, d, T = r1, t1, q
        end
        r0, r1 = r1, r0 - q*r1
        t0, t1 = t1, t0 - q*t1
    end
    (d == 0 || gcd(n, d) != 1) && return false, n, d
    if d < 0
        n, d = -n, -d
    end
    true, n, d
end

using Groebner, Random, AbstractAlgebra, Primes

systems = [
    ("chandra-9", Groebner.Examples.chandran(9)),
    ("chandra-10", Groebner.Examples.chandran(10)),
    ("cyclic-7", Groebner.Examples.cyclicn(7)),
    ("eco-11", Groebner.Examples.eco11()),
    ("katsura-9", Groebner.Examples.katsuran(9)),
    ("hexapod", Groebner.Examples.hexapod()),
    ("hiv2", Groebner.Examples.HIV2()),
    ("alea6", Groebner.Examples.alea6())
]

if false
    for (name, sys) in systems
        @info "Running $name.."
        gb = groebner(sys)
        @time res1 = isgroebner(gb, linalg=:deterministic)
        @time res2 = isgroebner(gb, linalg=:randomized)
        @assert res1 == res2
    end
end

rng = Random.Xoshiro(42)

for k in [GF(prevprime(600)), GF(prevprime(2^10)), GF(prevprime(2^20))]
    boot = 100000
    for _ in 1:boot
        sys = Groebner.Examples.random_generating_set(
            rng,
            k,
            rand(rng, (:lex, :deglex, :degrevlex)),
            rand(rng, 2:4),
            rand(rng, 1:10),
            rand(rng, 1:10),
            rand(rng, 1:10),
            rand(rng, 100:(2 ^ 30))
        )
        if isempty(sys)
            continue
        end
        res1 = isgroebner(sys, linalg=:deterministic)
        res2 = isgroebner(sys, linalg=:randomized)
        if res1 != res2
            @info "Hehe"
        end
    end
end

using Nemo, StructuralIdentifiability

function siwr()
    ode = StructuralIdentifiability.@ODEmodel(
        S'(t) = mu - bi * S(t) * I(t) - bw * S(t) * W(t) - mu * S(t) + a * R(t),
        I'(t) = bw * S(t) * W(t) + bi * S(t) * I(t) - (gam + mu) * I(t),
        W'(t) = xi * (I(t) - W(t)),
        R'(t) = gam * I(t) - (mu + a) * R(t),
        y(t) = k * I(t)
    )

    io_eqs = StructuralIdentifiability.find_ioequations(ode)
    id_funcs, bring = StructuralIdentifiability.extract_identifiable_functions_raw(io_eqs, ode, empty(ode.parameters), true)
    param_ring, _ = polynomial_ring(base_ring(bring), map(string, ode.parameters))
    id_funcs_no_states = map(polys -> map(poly -> StructuralIdentifiability.parent_ring_change(poly, param_ring), polys), id_funcs[:no_states])
    rff = StructuralIdentifiability.RationalFunctionField(id_funcs_no_states)

	# Output system
    StructuralIdentifiability.fractionfree_generators_raw(rff.mqs)[1]
end

import Pkg

include("../utils.jl")
julia_pkg_preamble("$(@__DIR__)")

using CpuId, Logging, Pkg, Printf
using Statistics

using Groebner
using AlgebraicSolving

logger = Logging.ConsoleLogger(stdout, Logging.Info)
global_logger(logger)

const runtime = Dict()

const PROBLEM_NAME = ARGS[1]
const NUM_RUNS = parse(Int, ARGS[2])
const BENCHMARK_SET = parse(Int, ARGS[3])
const VALIDATE = parse(Bool, ARGS[4])

const BENCHMARK_DIR = "../../" * get_benchmark_dir("siggb", BENCHMARK_SET)

@info "" ARGS
@info "" PROBLEM_NAME
@info "" NUM_RUNS
@info "" BENCHMARK_SET
@info "" VALIDATE
@info "" "$(@__DIR__)"
flush(stdout)
flush(stderr)

# Load the system
path = (@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$PROBLEM_NAME.jl"
include(path)

# Compile
system_hom = AlgebraicSolving._homogenize(system)
timing = @timed result = AlgebraicSolving.sig_groebner_basis(system_hom)

function process_system()
    @info "Processing $PROBLEM_NAME"
    @info """
    Averaging over $NUM_RUNS runs."""

    runtime[PROBLEM_NAME] = Dict{Any, Any}()
    for cat in ALL_CATEGORIES
        runtime[PROBLEM_NAME][cat] = Inf
    end
    for iter in 1:NUM_RUNS
        @info "Computing GB.." iter
        system_hom = AlgebraicSolving._homogenize(system)
        timing = @timed result = AlgebraicSolving.sig_groebner_basis(system_hom)
        @debug "Result is" result
        if VALIDATE
            output_fn = (@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$(output_filename())"
            @info "Printing the basis to $output_fn"
            output_file = open(output_fn, "w")
            ring = parent(system[1])
            vars_str = join(map(repr, AbstractAlgebra.gens(ring)), ", ")
            system_str = join(map(repr, result), ",\n")
            println(output_file, vars_str)
            println(output_file, AbstractAlgebra.characteristic(base_ring(ring)))
            println(output_file, system_str)
            close(output_file)
        end
        # for cat in ID_TIME_CATEGORIES
        #     if haskey(StructuralIdentifiability._runtime_logger, cat)
        #         runtime[PROBLEM_NAME][cat] = StructuralIdentifiability._runtime_logger[cat]
        #     end
        # end
        # for cat in ID_runtime_CATEGORIES
        #     if haskey(StructuralIdentifiability._runtime_logger, cat)
        #         runtime[PROBLEM_NAME][cat] =
        #             deepcopy(StructuralIdentifiability._runtime_logger[cat])
        #     end
        # end
        runtime[PROBLEM_NAME][:total_time] = min(runtime[PROBLEM_NAME][:total_time], timing.time)
    end
    # for cat in ID_TIME_CATEGORIES
    #     if haskey(runtime[PROBLEM_NAME], cat)
    #         runtime[PROBLEM_NAME][cat] = runtime[PROBLEM_NAME][cat] / NUM_RUNS
    #     end
    # end
end

function dump_timings()
    timings = ""
    timings *= "$PROBLEM_NAME\n"
    for (key, model_runtime) in runtime
        for c in [:total_time]
            timings *= "$c, "
            timings *= string(model_runtime[c]) * "\n"
        end
    end
    filename = timings_filename()
    open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "w") do io
        write(io, timings)
    end
end

function dump_results()
    filename = result_filename(GLOBAL_ID)
    open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "w") do io
        if haskey(runtime, PROBLEM_NAME)
            println(io, runtime[PROBLEM_NAME][:return_value])
        end
    end
    filename = data_filename(GLOBAL_ID)
    open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "w") do io
        write(io, "$PROBLEM_NAME\n")
    end
    for cat in ID_DATA_CATEGORIES
        if !haskey(runtime[PROBLEM_NAME], cat)
            continue
        end
        if cat === :something_important
            # make a separate file for it
            filename_cat = generic_filename(cat, GLOBAL_ID)
            open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename_cat", "w") do io
                # print something
            end
            continue
        end
        # otherwise, print in the data file
        open((@__DIR__) * "/$BENCHMARK_DIR/$PROBLEM_NAME/$filename", "a+") do io
            write(io, "$cat, ")
            write(io, string(runtime[PROBLEM_NAME][cat]))
            write(io, "\n")
        end
    end
end

process_system()
dump_timings()
# dump_results()

# This file is a part of Groebner.jl. License is GNU GPL v2.

# Arithmetic in Zp.

# The arithmetic type is parametrized by the type of the accumulator, AccumType,
# and the type of the coefficient, CoeffType. Generally,
#   a + b*c
# must be representable in AccumType for feasible a,b,c of type CoeffType. One
# example is AccumType = UInt64 and CoeffType = UInt32 with prime moduli.
abstract type AbstractArithmetic{AccumType, CoeffType} end

# All implementations of arithmetic in Z_p are a subtype of this.
#
# Implementations of AbstractArithmeticZp need to implement three functions to
# be usable in F4:
# - divisor(arithmetic)      : returns the prime number p
# - mod_p(x, arithmetic)     : returns x modulo p
# - inv_mod_p(x, arithmetic) : returns x^(-1) modulo p
abstract type AbstractArithmeticZp{AccumType, CoeffType} <: AbstractArithmetic{AccumType, CoeffType} end

###
# ArithmeticZp

less_than_half(p, ::Type{T}) where {T} = p < (typemax(T) >> ((8 >> 1) * sizeof(T)))

# Modular arithmetic based on builtin classes in Base.MultiplicativeInverses. 
struct ArithmeticZp{AccumType, CoeffType} <: AbstractArithmeticZp{AccumType, CoeffType}
    multiplier::AccumType
    shift::UInt8
    divisor::AccumType
    add::Bool

    function ArithmeticZp(
        ::Type{AccumType},
        ::Type{CoeffType},
        p::CoeffType
    ) where {AccumType <: CoeffZp, CoeffType <: CoeffZp}
        @invariant less_than_half(p, AccumType)
        @invariant Primes.isprime(p)
        uinv = UnsignedMultiplicativeInverse{AccumType}(convert(AccumType, p))
        # Further in the code we need the guarantee that the shift is < 64
        @invariant uinv.shift < 8 * sizeof(AccumType)
        new{AccumType, CoeffType}(uinv.multiplier, uinv.shift, uinv.divisor, uinv.add)
    end
end

divisor(arithm::ArithmeticZp) = arithm.divisor

@inline function mod_p(a::T, mod::ArithmeticZp{T}) where {T}
    x = _mul_high(a, mod.multiplier)
    x = ifelse(mod.add, convert(T, convert(T, (convert(T, a - x) >>> UInt8(1))) + x), x)
    unsafe_assume(mod.shift < 8 * sizeof(T))
    a - (x >>> mod.shift) * mod.divisor
end

inv_mod_p(a::T, arithm::ArithmeticZp{T}) where {T} = invmod(a, divisor(arithm))

###
# SpecializedArithmeticZp

# Same as ArithmeticZp, but stores the fields inline and additionally
# specializes on magic.add
# NOTE: can specialize even further if we only consider the primes such that
# shift = 0. However, the number of such primes is perhaps < 100 in the range
# 1..2^64 
struct SpecializedArithmeticZp{AccumType, CoeffType, Add} <:
       AbstractArithmeticZp{AccumType, CoeffType}
    multiplier::AccumType
    shift::UInt8
    divisor::AccumType

    function SpecializedArithmeticZp(
        ::Type{AccumType},
        ::Type{CoeffType},
        p::CoeffType
    ) where {AccumType <: CoeffZp, CoeffType <: CoeffZp}
        @invariant less_than_half(p, AccumType)
        @invariant Primes.isprime(p)
        uinv = UnsignedMultiplicativeInverse{AccumType}(convert(AccumType, p))
        SpecializedArithmeticZp(AccumType, CoeffType, uinv)
    end

    function SpecializedArithmeticZp(
        ::Type{AccumType},
        ::Type{CoeffType},
        uinv::UnsignedMultiplicativeInverse{AccumType}
    ) where {AccumType <: CoeffZp, CoeffType <: CoeffZp}
        # Further in the code we need the guarantee that the shift is < 64
        @invariant uinv.shift < 8 * sizeof(AccumType)
        new{AccumType, CoeffType, uinv.add}(uinv.multiplier, uinv.shift, uinv.divisor)
    end
end

divisor(arithm::SpecializedArithmeticZp) = arithm.divisor

# Returns the higher half of the product a*b
@inline function _mul_high(a::T, b::T) where {T <: Union{Signed, Unsigned}}
    ((widen(a) * b) >>> (sizeof(a) * 8)) % T
end

@inline function _mul_high(a::UInt128, b::UInt128)
    shift = sizeof(a) * 4
    mask = typemax(UInt128) >> shift
    a1, a2 = a >>> shift, a & mask
    b1, b2 = b >>> shift, b & mask
    a1b1, a1b2, a2b1, a2b2 = a1 * b1, a1 * b2, a2 * b1, a2 * b2
    carry = ((a1b2 & mask) + (a2b1 & mask) + (a2b2 >>> shift)) >>> shift
    a1b1 + (a1b2 >>> shift) + (a2b1 >>> shift) + carry
end

# NOTE: the compiler sometimes fails to simd this for T ≥ UInt32.
@inline function mod_p(a::T, mod::SpecializedArithmeticZp{T, C, true}) where {T, C}
    x = _mul_high(a, mod.multiplier)
    x = convert(T, convert(T, (convert(T, a - x) >>> UInt8(1))) + x)
    # Bit shifts in Julia check that the shift value is less than the bitsize of
    # the argument type. The assumption here allows us to bypass this check.
    unsafe_assume(mod.shift < 8 * sizeof(T))
    a - (x >>> mod.shift) * mod.divisor
end

@inline function mod_p(a::T, mod::SpecializedArithmeticZp{T, C, false}) where {T, C}
    x = _mul_high(a, mod.multiplier)
    unsafe_assume(mod.shift < 8 * sizeof(T))
    a - (x >>> mod.shift) * mod.divisor
end

inv_mod_p(a::T, arithm::SpecializedArithmeticZp{T}) where {T} = invmod(a, divisor(arithm))

###
# DelayedArithmeticZp

# Exploits the case when the representation of the prime has spare leading bits
# and thus delays reduction modulo a prime
struct DelayedArithmeticZp{AccumType, CoeffType, Add} <: AbstractArithmeticZp{AccumType, CoeffType}
    multiplier::AccumType
    shift::UInt8
    divisor::AccumType

    function DelayedArithmeticZp(
        ::Type{AccumType},
        ::Type{CoeffType},
        p::CoeffType
    ) where {AccumType <: CoeffZp, CoeffType <: CoeffZp}
        @invariant less_than_half(p, AccumType)
        @invariant leading_zeros(p) > 0
        @invariant Primes.isprime(p)
        uinv = UnsignedMultiplicativeInverse{AccumType}(convert(AccumType, p))
        DelayedArithmeticZp(AccumType, CoeffType, uinv)
    end

    function DelayedArithmeticZp(
        ::Type{AccumType},
        ::Type{CoeffType},
        uinv::UnsignedMultiplicativeInverse{AccumType}
    ) where {AccumType <: CoeffZp, CoeffType <: CoeffZp}
        @invariant uinv.shift < 8 * sizeof(AccumType)
        new{AccumType, CoeffType, uinv.add}(uinv.multiplier, uinv.shift, uinv.divisor)
    end
end

divisor(arithm::DelayedArithmeticZp) = arithm.divisor

function n_spare_bits(arithm::DelayedArithmeticZp{T}) where {T <: Unsigned}
    res = leading_zeros(divisor(arithm)) - (8 >> 1) * sizeof(T)
    @invariant res >= 0
    res
end

function n_safe_consecutive_additions(arithm::DelayedArithmeticZp{T}) where {T <: Unsigned}
    T(1) << (2 * n_spare_bits(arithm) - 1)
end

# a modulo p (addition specialization)
@inline function mod_p(a::A, mod::DelayedArithmeticZp{A, T, true}) where {A, T}
    x = _mul_high(a, mod.multiplier)
    x = convert(A, convert(A, (convert(A, a - x) >>> UInt8(1))) + x)
    unsafe_assume(mod.shift < 8 * sizeof(T))
    a - (x >>> mod.shift) * mod.divisor
end
# a modulo p (no addition specialization)
@inline function mod_p(a::A, mod::DelayedArithmeticZp{A, T, false}) where {A, T}
    x = _mul_high(a, mod.multiplier)
    unsafe_assume(mod.shift < 8 * sizeof(T))
    a - (x >>> mod.shift) * mod.divisor
end

inv_mod_p(a::T, arithm::DelayedArithmeticZp{T}) where {T} = invmod(a, divisor(arithm))

###
# CompositeArithmeticZp

# Can operate on several integers at once
struct CompositeArithmeticZp{AccumType, CoeffType, TT} <: AbstractArithmeticZp{AccumType, CoeffType}
    arithmetics::TT

    function CompositeArithmeticZp(
        ::Type{CompositeNumber{N, AccumType}},
        ::Type{CompositeNumber{N, CoeffType}},
        p::CompositeNumber{N, CoeffType}
    ) where {N, AccumType <: CoeffZp, CoeffType <: CoeffZp}
        ai = ntuple(i -> SpecializedArithmeticZp(AccumType, CoeffType, p.data[i]), N)
        new{CompositeNumber{N, AccumType}, CompositeNumber{N, CoeffType}, Tuple{map(typeof, ai)...}}(
            ai
        )
    end
end

divisor(arithm::CompositeArithmeticZp) = CompositeNumber(map(divisor, arithm.arithmetics))

# No chance vectorizing this!
function mod_p(a::CompositeNumber{N, T}, arithm::CompositeArithmeticZp) where {N, T}
    CompositeNumber(map(mod_p, a.data, arithm.arithmetics))
end

function inv_mod_p(a::T, arithm::CompositeArithmeticZp) where {T}
    CompositeNumber(invmod.(a.data, divisor(arithm).data))
end

###
# SignedArithmeticZp

# Uses signed types and exploits the trick with adding p^2 to negative values
struct SignedArithmeticZp{AccumType, CoeffType} <: AbstractArithmeticZp{AccumType, CoeffType}
    p::AccumType
    p2::AccumType # = p*p

    multiplier::AccumType
    addmul::Int8
    shift::UInt8

    function SignedArithmeticZp(
        ::Type{AccumType},
        ::Type{CoeffType},
        p::CoeffType
    ) where {AccumType <: CoeffZp, CoeffType <: CoeffZp}
        @invariant Primes.isprime(p)
        pa = convert(AccumType, p)
        magic = Base.MultiplicativeInverses.SignedMultiplicativeInverse(pa)
        @invariant magic.shift < 8 * sizeof(AccumType)
        new{AccumType, CoeffType}(pa, pa * pa, magic.multiplier, magic.addmul, magic.shift)
    end
end

divisor(arithm::SignedArithmeticZp) = arithm.p

@inline function mod_p(a::T, mod::SignedArithmeticZp{T}) where {T}
    x = _mul_high(a, mod.multiplier)
    x += a * mod.addmul
    unsafe_assume(mod.shift < 8 * sizeof(T))
    d = (signbit(x) + (x >> mod.shift)) % T
    res = a - d * mod.p
    ifelse(res >= zero(T), res, res + mod.p)
end

function inv_mod_p(a::T, arithm::SignedArithmeticZp{T}) where {T}
    invmod(a, divisor(arithm))
end

###
# SignedCompositeArithmeticZp

# Operates on several integers at once, uses signed representation
struct SignedCompositeArithmeticZp{AccumType, CoeffType, T, N} <:
       AbstractArithmeticZp{AccumType, CoeffType}
    ps::CompositeNumber{N, T}
    p2s::CompositeNumber{N, T}

    multipliers::CompositeNumber{N, T}
    addmuls::CompositeNumber{N, Int8}
    shifts::CompositeNumber{N, UInt8}

    function SignedCompositeArithmeticZp(
        ::Type{CompositeNumber{N, AT}},
        ::Type{CompositeNumber{N, CT}},
        ps::CompositeNumber{N, CT}
    ) where {N, AT <: CoeffZp, CT <: CoeffZp}
        arithms = map(pj -> SignedArithmeticZp(AT, CT, pj), ps.data)
        multipliers = map(a -> a.multiplier, arithms)
        addmuls = map(a -> a.addmul, arithms)
        shifts = map(a -> a.shift, arithms)
        @invariant all(x -> x < 8 * sizeof(AT), shifts)
        p2s = CompositeNumber{N, AT}(ps) * CompositeNumber{N, AT}(ps)
        new{CompositeNumber{N, AT}, CompositeNumber{N, CT}, AT, N}(
            CompositeNumber{N, AT}(ps),
            p2s,
            CompositeNumber(multipliers),
            CompositeNumber(addmuls),
            CompositeNumber(shifts)
        )
    end
end

divisor(arithm::SignedCompositeArithmeticZp) = arithm.ps

@inline function mod_p(
    a::CompositeNumber{N, T},
    arithm::SignedCompositeArithmeticZp{CompositeNumber{N, T}, U, W, N}
) where {N, T, U, W}
    x = _mul_high.(a.data, arithm.multipliers.data)
    x = x .+ a.data .* arithm.addmuls.data
    unsafe_assume(all(arithm.shifts.data .< (8 * sizeof(T))))
    d = (signbit.(x) .+ (x .>> arithm.shifts.data)) .% T
    res = a.data .- d .* arithm.ps.data
    res = ifelse.(res .>= T(0), res, res .+ arithm.ps.data)
    CompositeNumber(res)
end

function inv_mod_p(a::T, arithm::SignedCompositeArithmeticZp{T}) where {T}
    CompositeNumber(invmod.(a.data, arithm.ps.data))
end

###
# Selection of arithmetic

# Returns the most suitable algorithm for doing arithmetic in the ground field.
function select_arithmetic(
    ::Type{CoeffType},
    characteristic::CharType,
    hint::Symbol,
    using_wide_type_for_coeffs::Bool
) where {
    CoeffType <: Union{CoeffZp, CompositeCoeffZp},
    CharType <: Union{CoeffZp, CompositeCoeffZp}
}
    # We guarantee that the characteristic is representable by CoeffType. 
    # Maybe change the type of characteristic to CoeffType?
    @invariant characteristic <= typemax(CoeffType)
    @invariant isinteger(characteristic)

    # The type that would act as an accumulator. Usually, this type must be
    # wider than CoeffType
    AccumType = if using_wide_type_for_coeffs
        CoeffType
    else
        # If the coefficients are stored tightly, say, using UInt32 paired with
        # characteristic = 2^31-1, then we need a bigger accumulator
        widen(CoeffType)
    end

    if CoeffType <: CompositeCoeffZp
        if hint === :signed || CoeffType <: CompositeNumber{N, T} where {N, T <: Signed}
            return SignedCompositeArithmeticZp(AccumType, CoeffType, CoeffType(characteristic))
        else
            return CompositeArithmeticZp(AccumType, CoeffType, CoeffType(characteristic))
        end
    end

    if hint === :signed
        return SignedArithmeticZp(AccumType, CoeffType, CoeffType(characteristic))
    end

    if hint === :delayed
        if iszero(leading_zeros(characteristic) - (8 >> 1) * sizeof(AccumType))
            @assert false
        end
        return DelayedArithmeticZp(AccumType, CoeffType, CoeffType(characteristic))
    end

    if hint === :basic
        SpecializedArithmeticZp(AccumType, CoeffType, CoeffType(characteristic))
    end

    if hint === :auto
        @assert CoeffType <: Unsigned

        # Use delayed modular arithmetic if the prime is one of the following:
        #   2^16 <= prime < 2^28
        #   2^8  <= prime < 2^12
        #           prime < 2^4
        # The trade-offs are a bit shifted for large moduli that are > 2^32. It
        # looks like it rarely pays off to use delayed modular arithmetic in
        # such cases
        if !(AccumType === UInt128)
            if !using_wide_type_for_coeffs && leading_zeros(CoeffType(characteristic)) > 4 ||
               using_wide_type_for_coeffs &&
               ((8 * sizeof(CoeffType)) >> 1) -
               (8 * sizeof(CoeffType) - leading_zeros(CoeffType(characteristic))) > 4
                return DelayedArithmeticZp(AccumType, CoeffType, CoeffType(characteristic))
            end
        end
    end

    SpecializedArithmeticZp(AccumType, CoeffType, CoeffType(characteristic))
end

function dump_results(file, key)
    open(file, "w") do out
        println(out, key)
        for problem in suite
            problem_name = problem.problem_name
            result = problem.result
            type = problem.type
            println(out, "$problem_name:$(String(type)):$(join(map(string, result), ","))")
        end
    end
end

using Test, Groebner, AbstractAlgebra

@testset "output type inferred" begin
    R, (x, y) = polynomial_ring(AbstractAlgebra.QQ, ["x", "y"]; internal_ordering=:lex)
    @test @inferred Groebner.groebner([x, y]) == [y, x]
    @test @inferred Groebner.normalform([x, y], x + 1) == R(1)
    @test @inferred Groebner.normalform([x, y], [x + 1, y + 1, R(0)]) == [R(1), R(1), R(0)]
    @test @inferred Groebner.isgroebner([x, y]) == true

    R, (x, y) =
        polynomial_ring(AbstractAlgebra.GF(2^31 - 1), ["x", "y"]; internal_ordering=:degrevlex)
    @test @inferred Groebner.groebner([x, y]) == [y, x]
    @test @inferred Groebner.normalform([x, y], x + 1) == R(1)
    @test @inferred Groebner.normalform([x, y], [x + 1, y + 1, R(0)]) == [R(1), R(1), R(0)]
    @test @inferred Groebner.isgroebner([x, y]) == true

    context, gb = Groebner.groebner_learn([x, y])
    @test @inferred Groebner.groebner_learn([x, y])[2] == gb
    @test @inferred Groebner.groebner_apply!(context, [x, y]) == (true, gb)
end

# This file is a part of Groebner.jl. License is GNU GPL v2.

###
# Conversion from AbstractAlgebra.jl/Nemo.jl to intermediate representation and back.

# Conversions in this file must be thread-safe, since functions in the interface
# can be used in parallel. In particular, we rely on the fact that some
# functions in AbstractAlgebra.jl are thread-safe
# https://github.com/Nemocas/AbstractAlgebra.jl/issues/1542

const aa_supported_orderings = (:lex, :deglex, :degrevlex)
const aa_exponent_type = UInt64

aa_is_multivariate_ring(ring) = AbstractAlgebra.elem_type(ring) <: AbstractAlgebra.MPolyRingElem

@timeit _TIMER function io_convert_polynomials_to_ir(polynomials, options::KeywordArguments)
    isempty(polynomials) && throw(DomainError("Empty input."))
    ring = io_extract_ring(polynomials)
    if options._generic
        ring = struct_update(PolyRing, ring, (ground=:generic,))
    end
    coeffs = io_extract_coeffs_ir(ring, polynomials)
    reversed_order, var_to_index, monoms = io_extract_monoms_ir(ring, polynomials)
    @invariant length(coeffs) == length(monoms)
    ring = PolyRing(
        ring.nvars,
        ordering_transform(ring.ord, var_to_index),
        ring.characteristic,
        ring.ground
    )
    ordering = ordering_transform(options.ordering, var_to_index)
    options = struct_update(KeywordArguments, options, (ordering=ordering,))
    ring, monoms, coeffs, options
end

@timeit _TIMER function io_convert_ir_to_polynomials(
    ring::PolyRing,
    polynomials,
    monoms::Vector{Vector{M}},
    coeffs::Vector{Vector{C}},
    options
) where {M <: Monom, C <: Coeff}
    origring = AbstractAlgebra.parent(first(polynomials))
    _io_convert_ir_to_polynomials(origring, monoms, coeffs, options)::typeof(polynomials)
end

function io_extract_ring(polynomials)
    if !all(
        f -> f isa AbstractAlgebra.MPolyRingElem || f isa AbstractAlgebra.PolyRingElem,
        polynomials
    )
        throw(DomainError("Unknown type of polynomials: $(typeof(polynomials))."))
    end
    R = AbstractAlgebra.parent(first(polynomials))
    K = AbstractAlgebra.base_ring(R)
    if !(K isa AbstractAlgebra.Field)
        throw(DomainError("Coefficient ring must be a field, but got: $K"))
    end
    ch = AbstractAlgebra.characteristic(R)
    ground = iszero(ch) ? :qq : :zp
    # Only characteristics < 2^64 are supported natively
    if (ch > typemax(UInt64))
        ground = :generic
    end
    if !iszero(ch)
        # Only prime fields are supported natively
        if !(hasmethod(AbstractAlgebra.degree, (typeof(K),)))
            ground = :generic
        elseif !isone(AbstractAlgebra.degree(K))
            ground = :generic
        end
    else
        if !(K isa AbstractAlgebra.Rationals{<:Integer} || K isa Nemo.QQField)
            ground = :generic
        end
    end
    if ground == :generic
        @warn "Groebner.jl does not have a native implementation for the given field: $K.\n" *
              "Falling back to a generic implementation (may be slow).\n" *
              "If this is unexpected, please consider submitting a GitHub issue." maxlog = 1
    end
    nv = AbstractAlgebra.nvars(R)
    # lex is the default ordering on univariate polynomials
    ord = if aa_is_multivariate_ring(R)
        AbstractAlgebra.internal_ordering(R)
    else
        :lex
    end
    # type unstable:
    ordT = ordering_sym2typed(ord)
    ch_uint = ground == :zp ? UInt(ch) : UInt(0)
    ring = PolyRing(nv, ordT, ch_uint, ground)
    ring
end

function io_extract_coeffs_ir(ring::PolyRing, polys)
    if ring.ground == :generic
        io_extract_coeffs_ir_generic(ring, polys)
    elseif ring.ground == :zp
        io_extract_coeffs_ir_ff(ring, polys)
    else
        io_extract_coeffs_ir_qq(ring, polys)
    end
end

io_lift_coeff_ff(c) = UInt64(AbstractAlgebra.lift(c))
io_lift_coeff_ff(c::AbstractAlgebra.GFElem) = AbstractAlgebra.data(c)
io_lift_coeff_ff(c::Union{Nemo.FqFieldElem, Nemo.fpFieldElem}) =
    UInt64(AbstractAlgebra.lift(Nemo.ZZ, c))

function io_extract_coeffs_ir_ff(ring::PolyRing{T}, polys) where {T}
    res = Vector{Vector{UInt64}}(undef, length(polys))
    for i in 1:length(polys)
        poly = polys[i]
        if !aa_is_multivariate_ring(parent(polys[1]))
            res[i] = map(io_lift_coeff_ff, AbstractAlgebra.coefficients(poly))
            reverse!(res[i])
            filter!(!iszero, res[i])
        else
            res[i] = map(io_lift_coeff_ff, AbstractAlgebra.coefficients(poly))
        end
    end
    res
end

function io_extract_coeffs_ir_qq(ring::PolyRing, polys)
    res = Vector{Vector{Rational{BigInt}}}(undef, length(polys))
    for i in 1:length(polys)
        poly = polys[i]
        if !aa_is_multivariate_ring(parent(polys[1]))
            res[i] = map(Rational{BigInt}, collect(AbstractAlgebra.coefficients(poly)))
            reverse!(res[i])
            filter!(!iszero, res[i])
        else
            res[i] = map(Rational{BigInt}, collect(AbstractAlgebra.coefficients(poly)))
        end
    end
    res
end

function io_extract_coeffs_ir_generic(ring::PolyRing, polys)
    T = AbstractAlgebra.elem_type(AbstractAlgebra.base_ring(polys[1]))
    res = Vector{Vector{CoeffGeneric{T}}}(undef, length(polys))
    for i in 1:length(polys)
        poly = polys[i]
        if !aa_is_multivariate_ring(parent(polys[1]))
            res[i] = map(CoeffGeneric{T}, collect(AbstractAlgebra.coefficients(poly)))
            reverse!(res[i])
            filter!(!iszero, res[i])
        else
            res[i] = map(CoeffGeneric{T}, collect(AbstractAlgebra.coefficients(poly)))
        end
    end
    res
end

function io_extract_monoms_ir(ring::PolyRing, polys)
    ring_aa = AbstractAlgebra.parent(polys[1])
    v = AbstractAlgebra.gens(ring_aa)
    var_to_index = Dict{elem_type(ring_aa), Int}(v .=> 1:AbstractAlgebra.nvars(ring_aa))
    res = Vector{Vector{Vector{Int}}}(undef, length(polys))
    @inbounds for i in 1:length(polys)
        poly = polys[i]
        if !aa_is_multivariate_ring(parent(polys[1]))
            perm = filter(
                j -> !iszero(AbstractAlgebra.coeff(polys[i], j - 1)),
                collect(1:length(polys[i]))
            )
            res[i] = collect(AbstractAlgebra.exponent_vectors(polys[i]))
            res[i] = res[i][perm]
            reverse!(res[i])
        else
            res[i] = collect(AbstractAlgebra.exponent_vectors(polys[i]))
        end
    end
    false, var_to_index, res
end

###
# Converting from AbstractAlgebra to internal representation.

function ordering_sym2typed(ord::Symbol)
    if !(ord in aa_supported_orderings)
        __throw_input_not_supported(ord, "Not a supported ordering.")
    end
    if ord === :lex
        Lex()
    elseif ord === :deglex
        DegLex()
    elseif ord === :degrevlex
        DegRevLex()
    end
end

###
# Converting from internal representation to AbstractAlgebra.jl

# Specialization for univariate polynomials
function _io_convert_ir_to_polynomials(
    origring::R,
    gbexps::Vector{Vector{M}},
    gbcoeffs::Vector{Vector{C}},
    params
) where {
    R <: Union{AbstractAlgebra.Generic.PolyRing, AbstractAlgebra.PolyRing},
    M <: Monom,
    C <: Coeff
}
    ground   = AbstractAlgebra.base_ring(origring)
    exported = Vector{elem_type(origring)}(undef, length(gbexps))
    @inbounds for i in 1:length(gbexps)
        if isempty(gbexps[i])
            exported[i] = origring()
            continue
        end
        cfs = [zero(ground) for _ in 1:Int(sum(gbexps[i][1]) + 1)]
        for (idx, j) in enumerate(gbexps[i])
            cfs[sum(j) + 1] = ground(generic_coeff_data(gbcoeffs[i][idx]))
        end
        exported[i] = origring(cfs)
    end
    exported
end

# The most generic specialization
# (Nemo.jl opts for this specialization)
function _io_convert_ir_to_polynomials(
    origring::R,
    gbexps::Vector{Vector{M}},
    gbcoeffs::Vector{Vector{C}},
    params
) where {R, M <: Monom, C <: Coeff}
    nv       = AbstractAlgebra.nvars(origring)
    ground   = AbstractAlgebra.base_ring(origring)
    exported = Vector{elem_type(origring)}(undef, length(gbexps))
    @inbounds for i in 1:length(gbexps)
        cfs = map(ground ∘ generic_coeff_data, gbcoeffs[i])
        exps = Vector{Vector{Int}}(undef, length(gbcoeffs[i]))
        for jt in 1:length(gbcoeffs[i])
            exps[jt] = gbexps[i][jt]
        end
        exported[i] = origring(cfs, exps)
    end
    exported
end

function create_aa_polynomial(
    origring::AbstractAlgebra.Generic.MPolyRing{T},
    coeffs::Vector{T},
    exps::Matrix{U}
) where {T, U}
    ground = AbstractAlgebra.base_ring(origring)
    if !isempty(coeffs)
        AbstractAlgebra.Generic.MPoly{elem_type(ground)}(origring, coeffs, exps)
    else
        AbstractAlgebra.Generic.MPoly{elem_type(ground)}(origring)
    end
end

function create_aa_polynomial(
    origring::AbstractAlgebra.Generic.MPolyRing{T},
    coeffs::Vector{T},
    exps::Vector{Vector{U}}
) where {T, U}
    ground = AbstractAlgebra.base_ring(origring)
    if !isempty(coeffs)
        origring(coeffs, exps)
    else
        AbstractAlgebra.Generic.MPoly{elem_type(ground)}(origring)
    end
end

# Dispatch between monomial orderings
function _io_convert_ir_to_polynomials(
    origring::AbstractAlgebra.Generic.MPolyRing{T},
    gbexps::Vector{Vector{M}},
    gbcoeffs::Vector{Vector{C}},
    params
) where {T, M <: Monom, C <: Coeff}
    ord_aa = AbstractAlgebra.internal_ordering(origring)
    _ord_aa = ordering_sym2typed(ord_aa)
    input_ordering_matches_output = true
    target_ord = params.ordering isa InputOrdering ? _ord_aa : params.ordering
    if (target_ord != _ord_aa)
        input_ordering_matches_output = false
    end
    _io_convert_ir_to_polynomials(
        origring,
        gbexps,
        gbcoeffs,
        target_ord,
        Val{input_ordering_matches_output}()
    )
end

# Specialization for degrevlex for matching orderings
function _io_convert_ir_to_polynomials(
    origring::AbstractAlgebra.Generic.MPolyRing{T},
    gbexps::Vector{Vector{M}},
    gbcoeffs::Vector{Vector{C}},
    ::DegRevLex,
    input_ordering_matches_output::Val{true}
) where {T, M <: Monom, C <: Coeff}
    nv       = AbstractAlgebra.nvars(origring)
    ground   = AbstractAlgebra.base_ring(origring)
    exported = Vector{elem_type(origring)}(undef, length(gbexps))
    tmp      = Vector{aa_exponent_type}(undef, nv)
    @inbounds for i in 1:length(gbexps)
        cfs  = map(ground ∘ generic_coeff_data, gbcoeffs[i])
        exps = Matrix{aa_exponent_type}(undef, nv + 1, length(gbcoeffs[i]))
        for jt in 1:length(gbcoeffs[i])
            for k in 1:length(tmp)
                exps[k, jt] = gbexps[i][jt][k]
            end
            exps[end, jt] = sum(gbexps[i][jt])
        end
        exported[i] = create_aa_polynomial(origring, cfs, exps)
    end
    exported
end

# Specialization for lex for matching orderings
function _io_convert_ir_to_polynomials(
    origring::AbstractAlgebra.Generic.MPolyRing{T},
    gbexps::Vector{Vector{M}},
    gbcoeffs::Vector{Vector{C}},
    ::Lex,
    input_ordering_matches_output::Val{true}
) where {T, M <: Monom, C <: Coeff}
    nv       = AbstractAlgebra.nvars(origring)
    ground   = AbstractAlgebra.base_ring(origring)
    exported = Vector{elem_type(origring)}(undef, length(gbexps))
    tmp      = Vector{aa_exponent_type}(undef, nv)
    @inbounds for i in 1:length(gbexps)
        cfs  = map(ground ∘ generic_coeff_data, gbcoeffs[i])
        exps = Matrix{aa_exponent_type}(undef, nv, length(gbcoeffs[i]))
        for jt in 1:length(gbcoeffs[i])
            exps[end:-1:1, jt] .= gbexps[i][jt]
        end
        exported[i] = create_aa_polynomial(origring, cfs, exps)
    end
    exported
end

# Specialization for deglex for matching orderings
function _io_convert_ir_to_polynomials(
    origring::AbstractAlgebra.Generic.MPolyRing{T},
    gbexps::Vector{Vector{M}},
    gbcoeffs::Vector{Vector{C}},
    ::DegLex,
    input_ordering_matches_output::Val{true}
) where {T, M <: Monom, C <: Coeff}
    nv       = AbstractAlgebra.nvars(origring)
    ground   = AbstractAlgebra.base_ring(origring)
    exported = Vector{elem_type(origring)}(undef, length(gbexps))
    tmp      = Vector{aa_exponent_type}(undef, nv)
    @inbounds for i in 1:length(gbexps)
        cfs  = map(ground ∘ generic_coeff_data, gbcoeffs[i])
        exps = Matrix{aa_exponent_type}(undef, nv + 1, length(gbcoeffs[i]))
        for jt in 1:length(gbcoeffs[i])
            # monom_to_vector!(tmp, gbexps[i][jt])
            exps[(end - 1):-1:1, jt] .= gbexps[i][jt]
            exps[end, jt] = sum(gbexps[i][jt])
        end
        exported[i] = create_aa_polynomial(origring, cfs, exps)
    end
    exported
end

# All other orderings
function _io_convert_ir_to_polynomials(
    origring::AbstractAlgebra.Generic.MPolyRing{T},
    gbexps::Vector{Vector{M}},
    gbcoeffs::Vector{Vector{C}},
    ord::Ord,
    input_ordering_matches_output
) where {T, M <: Monom, C <: Coeff, Ord <: AbstractMonomialOrdering}
    nv       = AbstractAlgebra.nvars(origring)
    ground   = AbstractAlgebra.base_ring(origring)
    exported = Vector{elem_type(origring)}(undef, length(gbexps))
    tmp      = Vector{aa_exponent_type}(undef, nv)
    @inbounds for i in 1:length(gbexps)
        cfs  = map(ground ∘ generic_coeff_data, gbcoeffs[i])
        exps = Vector{Vector{Int}}(undef, length(gbcoeffs[i]))
        for jt in 1:length(gbcoeffs[i])
            exps[jt] = gbexps[i][jt]
        end
        exported[i] = create_aa_polynomial(origring, cfs, exps)
    end
    exported
end

#! /usr/bin/env -S bash -e

TAG=v0.9.0

# MPFR_BUILD=$PWD/mpfr_build

# rm -rf mpfr mpfr_build mpfr_check
# git clone --depth 1 https://gitlab.inria.fr/mpfr/mpfr.git
# cd mpfr
# ./autogen.sh
# ./configure --prefix=$MPFR_BUILD
# make
# make install

# gcc -o mpfr_check mpfr_check.c -lmpfr -lgmp
# ./mpfr_check

julia julia_to_msolve.jl

MSOLVE=msolve_no_vectorize
rm -rf $MSOLVE && mkdir $MSOLVE
cd $MSOLVE
git clone --depth 1 --branch=$TAG https://github.com/algebraic-solving/msolve
cd msolve
./autogen.sh
./configure
#--with-mpfr=$MPFR_BUILD
make
cd ../../
time ./$MSOLVE/msolve/msolve -g 2 -f -v 1 cyclic7_qq.txt -o cyclic7_qq_out.txt 
time ./$MSOLVE/msolve/msolve -g 2 -v 1 -f cyclic7_zp.txt -o cyclic7_zp_out.txt

MSOLVE=msolve_default
rm -rf $MSOLVE && mkdir $MSOLVE
cd $MSOLVE
git clone --depth 1 --branch=$TAG https://github.com/algebraic-solving/msolve
cd msolve
./autogen.sh
./configure
#--with-mpfr=$MPFR_BUILD
make
cd ../../
time ./$MSOLVE/msolve/msolve -g 2 -f -v 1 cyclic7_qq.txt -o cyclic7_qq_out.txt 
time ./$MSOLVE/msolve/msolve -g 2 -v 1 -f cyclic7_zp.txt -o cyclic7_zp_out.txt

#! /usr/bin/env -S bash -e

TAG=v1.12.0-rc1

JULIA=julia_no_vectorize
rm -rf $JULIA && mkdir $JULIA
cd $JULIA
git clone --depth 1 --branch=$TAG https://github.com/JuliaLang/julia/
cd julia
git apply ../../Julia_disable_LoopVectorizePass.patch
make -j 8
cd ../../
cp Project.toml $JULIA/
./$JULIA/julia/julia --project=$JULIA -e 'using Pkg; Pkg.resolve(); Pkg.instantiate()'
./$JULIA/julia/julia --project=$JULIA produce_native_code.jl
./$JULIA/julia/julia --project=$JULIA experiment.jl

JULIA=julia_default
rm -rf $JULIA && mkdir $JULIA
cd $JULIA
git clone --depth=1 --branch=$TAG https://github.com/JuliaLang/julia/
cd julia
make -j 8
cd ../../
cp Project.toml $JULIA/
./$JULIA/julia/julia --project=$JULIA -e 'using Pkg; Pkg.resolve(); Pkg.instantiate()'
./$JULIA/julia/julia --project=$JULIA produce_native_code.jl
./$JULIA/julia/julia --project=$JULIA experiment.jl

## Benchmark results

2024-02-06T12:16:34.827

Benchmarked backend: maple

Benchmark suite: The rationals

- Workers: 8
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|chandra 9|5.37|
|chandra 10|25.70|
|chandra 11|129.58|
|chandra 12|1052.14|
|chandra 13| - |
|cyclic 7|1.41|
|cyclic 8|23.82|
|dummy|0.01|
|eco 10|0.71|
|eco 11|4.87|
|eco 12|35.06|
|eco 13|496.48|
|henrion 6|1.74|
|henrion 7| - |
|ipp|173.43|
|katsura 9|9.00|
|katsura 10|84.81|
|katsura 11|1318.31|
|noon 7|1.03|
|noon 8|9.23|
|noon 9|98.78|
|reimer 6|0.57|
|reimer 7|32.33|
|reimer 8| - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-01-13T16:43:22.203

Benchmarked backend: siggb

Benchmark suite: Integers modulo 2^30 + 3

- Workers: 16
- Timeout: 10 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|chandra 11| - |
|chandra 12| - |
|chandra 13| - |
|chandra 14| - |
|cyclic 7| - |
|cyclic 8| - |
|cyclic 9| - |
|cyclic 10| - |
|dummy| - |
|eco 11| - |
|eco 12| - |
|eco 13| - |
|eco 14| - |
|henrion 5| - |
|henrion 6| - |
|henrion 7| - |
|henrion 8| - |
|katsura 10| - |
|katsura 11| - |
|katsura 12| - |
|katsura 13| - |
|noon 7| - |
|noon 8| - |
|noon 9| - |
|noon 10| - |
|noon 11| - |
|reimer 6| - |
|reimer 7| - |
|reimer 8| - |
|reimer 9| - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-02-02T22:44:27.037

Benchmarked backend: maple

Benchmark suite: SIAN modulo 2^30 + 3

- Workers: 10
- Timeout: 2000 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|Biohydrogenation|0.18|
|Biohydrogenation_with_weights|0.25|
|COVID_m1|0.82|
|COVID_m1_with_weights|0.28|
|ChemicalReactionNetwork|0.41|
|ChemicalReactionNetwork_with_weights|0.37|
|Cholera|40.30|
|Cholera_with_weights|44.84|
|DAISY_ex3|0.14|
|DAISY_ex3_with_weights|0.16|
|DAISY_mamil3|0.17|
|DAISY_mamil3_with_weights|0.16|
|DAISY_mamil4|0.56|
|DAISY_mamil4_with_weights|0.57|
|Goodwin| - |
|Goodwin_with_weights|206.42|
|HIV|0.18|
|HIV2|3.18|
|HIV2_with_weights|1.57|
|HIV_with_weights|0.17|
|LV|0.16|
|LV_with_weights|0.18|
|Lipolysis|0.15|
|Lipolysis_with_weights|0.20|
|NFkB|878.10|
|NFkB_with_weights|249.35|
|OralGlucose|0.17|
|OralGlucose_with_weights|0.18|
|Pharm| - |
|Pharm_with_weights|1310.25|
|SEIR|0.15|
|SEIR2|0.22|
|SEIR2_with_weights|0.35|
|SEIRP|103.72|
|SEIRP_with_weights|38.65|
|SEIR_with_weights|0.20|
|SIRSForced|1.11|
|SIRSForced_with_weights|0.31|
|SIR_R0|0.23|
|SIR_R0_with_weights|0.21|
|SlowFast|0.19|
|SlowFast_with_weights|0.21|
|Treatment|0.22|
|Treatment_with_weights|0.19|
|Tumor|0.25|
|Tumor_with_weights|0.23|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-01-12T00:10:51.376

Benchmarked backend: openf4

Benchmark suite: SIAN modulo 2^30 + 3

- Workers: 8
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|Biohydrogenation|0.06|
|Biohydrogenation_with_weights| - |
|ChemicalReactionNetwork|2.30|
|ChemicalReactionNetwork_with_weights|14.89|
|Cholera| - |
|Cholera_with_weights| - |
|DAISY_ex3|0.03|
|DAISY_ex3_with_weights|33.04|
|DAISY_mamil3|0.03|
|DAISY_mamil3_with_weights|1.39|
|DAISY_mamil4|2.03|
|DAISY_mamil4_with_weights|43.27|
|HIV|1.13|
|HIV2|95.36|
|HIV2_with_weights| - |
|HIV_with_weights|945.47|
|LV|0.02|
|LV_with_weights|0.31|
|Lipolysis|0.02|
|Lipolysis_with_weights|0.07|
|NFkB| - |
|NFkB_with_weights| - |
|OralGlucose|0.02|
|OralGlucose_with_weights|0.91|
|Pharm| - |
|Pharm_with_weights| - |
|SEIR|0.02|
|SEIR2|0.08|
|SEIR2_with_weights| - |
|SEIR_with_weights|2.95|
|SIRSForced|7.44|
|SIRSForced_with_weights| - |
|SIR_R0|0.02|
|SIR_R0_with_weights|0.02|
|SlowFast|0.02|
|SlowFast_with_weights|0.03|
|Treatment|0.07|
|Treatment_with_weights|12.35|
|Tumor|1.07|
|Tumor_with_weights| - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2023-12-29T22:11:44.031

Benchmarked backend: maple
Benchmark suite: The rationals

- Workers: 4
- Timeout: 600 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total|
|-----|---|
|cyclic 7|1.74|
|cyclic 8|30.75|
|dummy|0.01|
|eco 10|0.74|
|eco 11|5.58|
|henrion 6| - |
|katsura 10|126.77|
|katsura 9|9.77|
|noon 8|9.73|
|noon 9|122.21|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-08-16T09:48:56.801

Benchmarked backend: maplefgb

Benchmark suite: Integers modulo 2^30 + 3

- Workers: 16
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|BIOMD0000000103|0.20|
|BIOMD0000000123|1.77|
|Cholera|53.67|
|Goodwin (w.)|273.11|
|HIV2|3.00|
|NFkB (w.)|434.36|
|alea6|0.11|
|bayes148|30.44|
|cyclic 7|0.10|
|cyclic 8|1.29|
|cyclic 9|195.90|
|dummy|0.02|
|eco 11|0.36|
|eco 12|2.05|
|eco 13|11.58|
|eco 14|104.79|
|gametwo2|13.40|
|henrion 5|0.01|
|henrion 6|0.05|
|henrion 7|3.25|
|henrion 8| - |
|jason210|7.76|
|katsura 10|1.18|
|katsura 11|11.36|
|katsura 12|53.16|
|katsura 13|879.25|
|mayr42|52.03|
|noon 7|0.19|
|noon 8|1.48|
|noon 9|14.80|
|noon 10|182.06|
|reimer 6|0.05|
|reimer 7|1.18|
|reimer 8|31.03|
|yang1|40.33|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.10.2

Versions of the dependencies:

* Primes : 0.5.6
* TimerOutputs : 0.5.24
* PrecompileTools : 1.2.1
* MultivariatePolynomials : 0.5.6
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.17
* AbstractAlgebra : 0.42.0
* Nemo : 0.46.0
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-08-16T07:06:06.957

Benchmarked backend: maple

Benchmark suite: dummy benchmark set

- Workers: 1
- Timeout: 600 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|dummy 1|0.01|
|dummy 2|0.04|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.10.2

Versions of the dependencies:

* Primes : 0.5.6
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.4
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.40.0
* Nemo : 0.43.0
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-02-06T16:48:54.678

Benchmarked backend: maple

Benchmark suite: Integers modulo 2^30 + 3

- Workers: 8
- Timeout: 1000 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|cyclic 7|0.10|
|cyclic 8|1.23|
|cyclic 9|340.73|
|dummy|0.01|
|eco 11|0.35|
|eco 12|2.00|
|eco 13|13.18|
|eco 14|216.66|
|henrion 5|0.01|
|henrion 6|0.05|
|henrion 7|3.15|
|henrion 8| - |
|katsura 10|1.41|
|katsura 11|7.72|
|katsura 12|52.66|
|katsura 13| - |
|noon 7|0.23|
|noon 8|1.95|
|noon 9|18.67|
|reimer 6|0.06|
|reimer 7|1.16|
|reimer 8|31.81|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-02-06T12:27:10.131

Benchmarked backend: msolve

Benchmark suite: The rationals

- Workers: 8
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|chandra 9|1.29|
|chandra 10|4.55|
|chandra 11|21.31|
|chandra 12|104.74|
|chandra 13|553.96|
|cyclic 7|1.13|
|cyclic 8|26.10|
|dummy|0.02|
|eco 10|0.59|
|eco 11|3.72|
|eco 12|29.19|
|eco 13|269.46|
|henrion 6|0.67|
|henrion 7|391.25|
|ipp|16.87|
|katsura 9|2.27|
|katsura 10|17.54|
|katsura 11|167.57|
|noon 7|1.51|
|noon 8|11.37|
|noon 9|91.26|
|reimer 6|0.32|
|reimer 7|6.68|
|reimer 8|256.74|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-01-13T16:54:39.545

Benchmarked backend: siggb

Benchmark suite: SIAN modulo 2^30 + 3

- Workers: 16
- Timeout: 600 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|Biohydrogenation| - |
|Biohydrogenation_with_weights| - |
|COVID_m1| - |
|COVID_m1_with_weights| - |
|ChemicalReactionNetwork| - |
|ChemicalReactionNetwork_with_weights| - |
|Cholera| - |
|Cholera_with_weights| - |
|DAISY_ex3| - |
|DAISY_ex3_with_weights| - |
|DAISY_mamil3|13.06|
|DAISY_mamil3_with_weights|11.90|
|DAISY_mamil4| - |
|DAISY_mamil4_with_weights| - |
|Goodwin| - |
|Goodwin_with_weights| - |
|HIV| - |
|HIV2| - |
|HIV2_with_weights| - |
|HIV_with_weights| - |
|LV|0.01|
|LV_with_weights|0.01|
|Lipolysis|0.23|
|Lipolysis_with_weights|0.14|
|NFkB| - |
|NFkB_with_weights| - |
|OralGlucose| - |
|OralGlucose_with_weights| - |
|Pharm| - |
|Pharm_with_weights| - |
|SEIR|0.44|
|SEIR2| - |
|SEIR2_with_weights| - |
|SEIRP| - |
|SEIRP_with_weights| - |
|SEIR_with_weights|0.19|
|SIRSForced| - |
|SIRSForced_with_weights| - |
|SIR_R0|0.06|
|SIR_R0_with_weights|0.07|
|SlowFast|0.01|
|SlowFast_with_weights|0.02|
|Treatment| - |
|Treatment_with_weights| - |
|Tumor| - |
|Tumor_with_weights| - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

# Interface

```@meta
CurrentModule = Groebner
```

## Main functions

```@docs
groebner
isgroebner
normalform
leading_ideal
dimension
quotient_basis
groebner_with_change_matrix
```

## Monomial orderings

!!! note

    Some frontends, for example, AbstractAlgebra.jl, may not support weighted/product/matrix orderings from Groebner.jl. In such cases, the basis is computed in the ordering requested by user, but the terms of polynomials in the output are ordered w.r.t. some other ordering that is supported by the frontend.

```@docs
Lex
DegLex
DegRevLex
InputOrdering
WeightedOrdering
ProductOrdering
MatrixOrdering
```

## Learn and Apply

```@docs
groebner_learn
groebner_apply!
```

## Benchmark results

2024-02-02T16:46:36.124

Benchmarked backend: groebner

Benchmark suite: SIAN modulo 2^30 + 3

- Workers: 10
- Timeout: 2000 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|Biohydrogenation|0.00|
|Biohydrogenation_with_weights|0.00|
|COVID_m1|0.50|
|COVID_m1_with_weights|0.12|
|ChemicalReactionNetwork|0.23|
|ChemicalReactionNetwork_with_weights|0.24|
|Cholera|43.00|
|Cholera_with_weights|45.60|
|DAISY_ex3|0.00|
|DAISY_ex3_with_weights|0.00|
|DAISY_mamil3|0.02|
|DAISY_mamil3_with_weights|0.00|
|DAISY_mamil4|0.22|
|DAISY_mamil4_with_weights|0.23|
|Goodwin| - |
|Goodwin_with_weights|152.54|
|HIV|0.01|
|HIV2|2.27|
|HIV2_with_weights|1.22|
|HIV_with_weights|0.00|
|LV|0.00|
|LV_with_weights|0.02|
|Lipolysis|0.00|
|Lipolysis_with_weights|0.00|
|NFkB|690.76|
|NFkB_with_weights|171.85|
|OralGlucose|0.00|
|OralGlucose_with_weights|0.00|
|Pharm| - |
|Pharm_with_weights|742.05|
|SEIR|0.03|
|SEIR2|0.00|
|SEIR2_with_weights|0.02|
|SEIRP|76.15|
|SEIRP_with_weights|25.77|
|SEIR_with_weights|0.00|
|SIRSForced|0.63|
|SIRSForced_with_weights|0.13|
|SIR_R0|0.00|
|SIR_R0_with_weights|0.00|
|SlowFast|0.00|
|SlowFast_with_weights|0.00|
|Treatment|0.00|
|Treatment_with_weights|0.01|
|Tumor|0.04|
|Tumor_with_weights|0.06|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-08-16T10:16:31.371

Benchmarked backend: mgb

Benchmark suite: Integers modulo 2^30 + 3

- Workers: 16
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|BIOMD0000000103|0.19|
|BIOMD0000000123|1.71|
|Cholera|62.09|
|Goodwin (w.)|292.68|
|HIV2|3.13|
|NFkB (w.)|413.70|
|alea6|0.11|
|bayes148|31.36|
|cyclic 7|0.10|
|cyclic 8|1.32|
|cyclic 9|193.91|
|dummy|0.00|
|eco 11|0.39|
|eco 12|2.30|
|eco 13|14.70|
|eco 14|126.38|
|gametwo2|19.09|
|henrion 5|0.01|
|henrion 6|0.06|
|henrion 7|4.20|
|henrion 8|1624.98|
|jason210|8.23|
|katsura 10|1.17|
|katsura 11|11.35|
|katsura 12|61.22|
|katsura 13|1056.05|
|mayr42|68.16|
|noon 7|0.18|
|noon 8|1.91|
|noon 9|17.26|
|noon 10|200.18|
|reimer 6|0.05|
|reimer 7|1.19|
|reimer 8|37.34|
|yang1|47.20|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.10.2

Versions of the dependencies:

* Primes : 0.5.6
* TimerOutputs : 0.5.24
* PrecompileTools : 1.2.1
* MultivariatePolynomials : 0.5.6
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.17
* AbstractAlgebra : 0.42.0
* Nemo : 0.46.0
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

# Groebner.jl: Fast Gröbner Tracing in Julia

This page mirrors the code snippets from the paper _Groebner.jl: Fast Gröbner Tracing in Julia_ that appeared in the proceedings of the [International Congress on Mathematical Software 2026](https://icms-conference.org/2026/).

## Setup

```julia
using Pkg; Pkg.add("Groebner"); Pkg.add("Nemo")
```

## Generic coefficient arithmetic

```@example paper_generic_coefficients
using Groebner, Nemo

K, t = rational_function_field(QQ, "t")
R, (x, y, z) = K["x", "y", "z"]

F = [t * x^2 * y + y^3, x * y^2 + 3 // t * z]

G = groebner(F);
@assert isgroebner(G)
nothing
```

## Learn and apply

```@example paper_trace
using Groebner, Nemo

kat = Groebner.Examples.katsuran(10)

kat_zp1 = map(f -> change_base_ring(GF(2^30 + 3), f), kat)
kat_zp2 = map(f -> change_base_ring(GF(2^30 + 7), f), kat)

trace, _ = groebner_learn(kat_zp1)
success, gb = groebner_apply!(trace, kat_zp2)

@assert success && isgroebner(gb)
nothing
```

## Timing the apply phase

The paper reports these timings using `BenchmarkTools`. Here we run one timing pass without rendering benchmark output into the page so the examples remain lightweight in CI.

```@example paper_trace
trace_timing, _ = groebner_learn(kat_zp1)

groebner_time = @elapsed groebner(kat_zp2)
apply_time = @elapsed groebner_apply!(trace_timing, kat_zp2)

@assert groebner_time >= 0
@assert apply_time >= 0
nothing
```

## Batched application over several primes

```@example paper_trace
kat_zp3 = map(f -> change_base_ring(GF(2^30 + 9), f), kat)
kat_zp4 = map(f -> change_base_ring(GF(2^30 + 15), f), kat)
kat_zp5 = map(f -> change_base_ring(GF(2^30 + 19), f), kat)

success, (gb2, gb3, gb4, gb5) = groebner_apply!(trace, (kat_zp2, kat_zp3, kat_zp4, kat_zp5))

@assert success && all(isgroebner, (gb2, gb3, gb4, gb5))
nothing
```

## Hybrid exact-numeric coefficients

```@example paper_hybrid
import Base: +, -, *, zero, one, inv, iszero, isone

const M = 256
setprecision(BigFloat, M)

struct Hybrid{Zp, Float}
    a::Zp
    b::Float
end

iszero(x::Hybrid) = iszero(x.a)
isone(x::Hybrid) = isone(x.a)
zero(x::Hybrid) = Hybrid(zero(x.a), zero(x.b))
one(x::Hybrid) = Hybrid(one(x.a), one(x.b))

+(x::Hybrid, y::Hybrid) = Hybrid(x.a + y.a, x.b + y.b)
-(x::Hybrid, y::Hybrid) = Hybrid(x.a - y.a, x.b - y.b)
*(x::Hybrid, y::Hybrid) = Hybrid(x.a * y.a, x.b * y.b)
inv(x::Hybrid) = Hybrid(inv(x.a), inv(x.b))
```

```@example paper_hybrid
using Groebner, Nemo

to_hybrid(q) = Hybrid(GF(2^30 + 3)(q), BigFloat(q))

sys = Groebner.Examples.hexapod(k = QQ)

sys_exps = map(f -> collect(exponent_vectors(f)), sys)
sys_cfs = map(f -> collect(coefficients(f)), sys)

cfs_hybrid = map(c -> Groebner.CoeffGeneric.(to_hybrid.(c)), sys_cfs)

ring = Groebner.PolyRing(6, DegRevLex(), 0, :generic)
gb_exps, gb_cfs = groebner(ring, sys_exps, cfs_hybrid);

@assert !isempty(gb_exps)
@assert length(gb_exps) == length(gb_cfs)
nothing
```

## Benchmark results

2024-01-12T03:37:20.131

Benchmarked backend: groebner

Benchmark suite: MQ

- Workers: 4
- Timeout: 20000 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|mq_n10_m7_p2_s0|0.43|
|mq_n10_m20_p2_s0|0.01|
|mq_n10_m20_p2_s1|0.01|
|mq_n15_m10_p2_s0|185.03|
|mq_n15_m30_p2_s0|0.63|
|mq_n24_m16_p31_s0| - |
|mq_n34_m68_p31_s0| - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-01-13T09:50:12.191

Benchmarked backend: msolve

Benchmark suite: HC

- Workers: 2
- Timeout: 120 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|boon|0.04|
|chandra 2|0.04|
|chandra 3|0.04|
|chandra 4|0.04|
|chandra 5|0.05|
|chandra 6|0.07|
|chandra 7|0.14|
|chandra 8|0.34|
|chandra 9|1.49|
|chandra 10|6.85|
|chandra 11|31.64|
|chandra 12| - |
|ipp|14.48|
|rps10| - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2023-10-03T20:44:04.983

Benchmarked backend: singular
Benchmark suite: The rationals

- Workers: 20
- Timeout: 1200 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total|
|-----|---|
|cyclic 7| - |
|cyclic 8| - |
|dummy|0.00|
|eco 10|29.41|
|eco 11| - |
|henrion 6|4.05|
|katsura 10| - |
|katsura 9|127.50|
|noon 8|10.66|
|noon 9|109.81|

*Benchmarking environment:*

* Total RAM (GiB): 2003
* Processor: AMD EPYC 7702 64-Core Processor                
* Julia version: 1.9.1

Versions of the dependencies:

* Combinatorics : 1.0.2
* MultivariatePolynomials : 0.5.2
* Primes : 0.5.4
* ExprTools : 0.1.10
* SIMD : 3.4.5
* AbstractAlgebra : 0.32.3
* SnoopPrecompile : 1.0.3

## Benchmark results

2024-02-03T03:29:11.091

Benchmarked backend: maple

Benchmark suite: SIAN, the rationals

- Workers: 10
- Timeout: 3000 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|Biohydrogenation|0.47|
|Biohydrogenation_with_weights|0.48|
|COVID_m1|3.73|
|COVID_m1_with_weights|1.57|
|ChemicalReactionNetwork|1.32|
|ChemicalReactionNetwork_with_weights|1.11|
|Cholera|203.83|
|Cholera_with_weights|219.35|
|DAISY_ex3|0.10|
|DAISY_ex3_with_weights|0.05|
|DAISY_mamil3|0.10|
|DAISY_mamil3_with_weights|0.09|
|DAISY_mamil4|3.34|
|DAISY_mamil4_with_weights|10.71|
|Goodwin| - |
|Goodwin_with_weights|711.06|
|HIV|0.33|
|HIV2|14.94|
|HIV2_with_weights|22.68|
|HIV_with_weights|0.21|
|LV|0.02|
|LV_with_weights|0.02|
|Lipolysis|0.12|
|Lipolysis_with_weights|0.10|
|NFkB|2049.79|
|NFkB_with_weights|971.21|
|OralGlucose|0.06|
|OralGlucose_with_weights|0.02|
|Pharm| - |
|Pharm_with_weights|2339.03|
|SEIR|0.18|
|SEIR2|0.11|
|SEIR2_with_weights|0.16|
|SEIRP|330.92|
|SEIRP_with_weights|84.65|
|SEIR_with_weights|0.08|
|SIRSForced|3.51|
|SIRSForced_with_weights|1.41|
|SIR_R0|0.01|
|SIR_R0_with_weights|0.01|
|SlowFast|0.04|
|SlowFast_with_weights|0.02|
|Treatment|0.12|
|Treatment_with_weights|0.13|
|Tumor|0.48|
|Tumor_with_weights|0.42|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-02-07T07:14:58.308

Benchmarked backends: Any["groebner", "maple", "msolve"]

Benchmark suite: SIAN, QQ

- Workers: 8
- Timeout: 7200 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|groebner|maple|msolve|
|:----|---|---|---|
|Cholera|1245.15|527.64| - |
|Goodwin (w.)|2282.27|2120.47| - |
|HIV2|14.58|23.85|146.70|
|NFkB (w.)| - |3411.72| - |
|Pharm (w.)| - | - | - |
|SEIRP| - |1235.47| - |
|dummy|0.00|0.01|0.03|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-02-04T07:47:35.168

Benchmarked backends: Any["groebner", "maple", "msolve"]

Benchmark suite: BIOMD, the rationals

- Workers: 8
- Timeout: 500 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|groebner|maple|msolve|
|:----|---|---|---|
|BIOMD0000000103|24.97|168.87|22.80|
|BIOMD0000000123|140.91| - |362.60|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

# Examples

Groebner.jl supports polynomials from the following frontends:

- AbstractAlgebra.jl
- Nemo.jl
- DynamicPolynomials.jl

Additionally, Groebner.jl has a low-level entry point that accepts raw polynomial data.

## Using AbstractAlgebra.jl

First, we import AbstractAlgebra.jl. 
Then, we create an array of polynomials over a finite field

```@example aa
using AbstractAlgebra

R, (x, y, z) = polynomial_ring(GF(2^31 - 1), ["x", "y", "z"])
polys = [x^2 + y + z, x*y + z];
```

and compute a Gröbner basis with the `groebner` command

```@example aa
using Groebner

basis = groebner(polys)
```

We can check if a set of polynomials forms a Gröbner basis

```@example aa
isgroebner(basis)
```

Groebner.jl also provides several monomial orderings. 
For example, we can eliminate `z` from the above system:

```@example aa
ordering = Lex(z) * DegRevLex(x, y)  # z > x, y
groebner(polys, ordering=ordering)
```

You can find more information on monomial orderings in Groebner.jl in [Monomial orderings](@ref).

## Using DynamicPolynomials.jl

Computing the Gröbner basis of some system:

```@example dp
using DynamicPolynomials, Groebner

@polyvar x1 x2
system = [10*x1*x2^2 - 11*x1 + 10,
        10*x1^2*x2 - 11*x2 + 10]

groebner(system)
```

## Using Low-level interface

Some functions in the interface have a low-level entry point. Low-level functions accept and output ''raw'' exponent vectors and coefficients. This could be convenient when one does not want to depend on a frontend.

For example,

```@example
using Groebner

# define {x * y - 1, x^3 + 7 * y^2} modulo 65537 in DRL
ring = Groebner.PolyRing(2, Groebner.DegRevLex(), 65537)
monoms = [ [[1, 1], [0, 0]], [[3, 0], [0, 2]] ]
coeffs = [ [    1,     -1 ], [    1,      7 ] ]

# compute a GB
gb_monoms, gb_coeffs = Groebner.groebner(ring, monoms, coeffs)
```

The list of functions that provide a low-level entry point: `groebner`, `normalform`, `isgroebner`, `groebner_learn`, `groebner_apply`.

Low-level functions may be faster than their user-facing analogues since they bypass data conversions. Low-level functions do not make any specific assumptions on input polynomials, that is, all of these cases are correctly handled: unsorted monomials, non-normalized coefficients, duplicate terms, aliasing memory.

## Generic coefficients

The implementation in Groebner.jl uses a generic type for coefficients. Hence, in theory, Groebner.jl can compute Gröbner bases over any type that behaves like a field.

For the following ground fields Groebner.jl runs an efficient native implementation:
- integers modulo a prime,
- rationals numbers.

For other ground fields, a possibly slower generic fallback is used. In this case, coefficients of polynomials are treated as black-boxes which implement field operations: `zero`, `one`, `inv`, `==`, `+`, `*`, `-`.

For example, we can compute a Gröbner basis over a univariate rational function field over a finite field:

```@example generic2
using Groebner, AbstractAlgebra

R, t = GF(101)["t"]
ff = fraction_field(R)
_, (x, y) = ff["x","y"]

sys = [(t//t+1)*x*y - t^3, y^2 + t]

gb = groebner(sys)
```

Many functions reuse the core implementation, so they can also be used over generic fields:

```julia
@assert isgroebner(gb)
normalform(gb, x*y)
```
### Computing over floating point intervals

In the following example, we combine low-level interface and generic coefficients. 

We are going to compute a basis of the hexapod system over tuples (Z_p, Interval): each coefficient is treated as a pair, the first coordinate is a finite field element used for zero testing, and the second coordinate is a floating point interval with some fixed precision, the payload. For floating point arithmetic, we will be using MPFI.jl.

```@example zp_and_interval
using Pkg;
Pkg.add(url="https://gitlab.inria.fr/ckatsama/mpfi.jl")

import Base: +, -, *, zero, iszero, one, isone, inv
using AbstractAlgebra, Groebner, MPFI

PRECISION = 1024 # For MPFI intervals

struct Zp_And_FloatInterval{Zp, FloatInterval}
    a::Zp
    b::FloatInterval
end

# Pretend it is a field and hakuna matata
+(x::Zp_And_FloatInterval, y::Zp_And_FloatInterval) = Zp_And_FloatInterval(x.a + y.a, x.b + y.b)
*(x::Zp_And_FloatInterval, y::Zp_And_FloatInterval) = Zp_And_FloatInterval(x.a * y.a, x.b * y.b)
-(x::Zp_And_FloatInterval, y::Zp_And_FloatInterval) = Zp_And_FloatInterval(x.a - y.a, x.b - y.b)
zero(x::Zp_And_FloatInterval) = Zp_And_FloatInterval(zero(x.a), zero(x.b))
one(x::Zp_And_FloatInterval) = Zp_And_FloatInterval(one(x.a), one(x.b))
inv(x::Zp_And_FloatInterval) = Zp_And_FloatInterval(inv(x.a), inv(x.b))
iszero(x::Zp_And_FloatInterval) = iszero(x.a)
isone(x::Zp_And_FloatInterval) = isone(x.a)

@info "Computing Hexapod over QQ"
c_zp = Groebner.Examples.hexapod(k=AbstractAlgebra.GF(2^30+3));
c_qq = Groebner.Examples.hexapod(k=AbstractAlgebra.QQ);
@time gb_truth = groebner(c_qq);
gbcoeffs_truth = map(f -> collect(coefficients(f)), gb_truth);
@info "Coefficient size (in bits): $(maximum(f -> maximum(c -> log2(abs(numerator(c))) + log2(denominator(c)), f), gbcoeffs_truth))"

@info "Computing Hexapod over (Zp, Interval). Precision = $PRECISION bits"
ring = Groebner.PolyRing(nvars(parent(c_qq[1])), Groebner.DegRevLex(), 0, :generic); # Note :generic
exps = map(f -> collect(exponent_vectors(f)), c_zp);
cfs_qq = map(f -> collect(coefficients(f)), c_qq);
cfs_zp = map(f -> collect(coefficients(f)), c_zp);
cfs = map(f -> map(c -> Groebner.CoeffGeneric(Zp_And_FloatInterval(c[1], BigInterval(c[2], precision=PRECISION))), zip(f...)), zip(cfs_zp, cfs_qq));
@time gbexps, gbcoeffs = groebner(ring, exps, cfs);

to_inspect = gbcoeffs[end][end]
@info "
    Inspect one coefficient in the basis:
    Zp         = $(to_inspect.data.a)
    Interval   = $(to_inspect.data.b)
    Diam       = $(diam(to_inspect.data.b))
    Diam (rel) = $(diam_rel(to_inspect.data.b))"

# Sanity check
all_are_inside(x::Zp_And_FloatInterval, truth) = is_inside(BigInterval(truth; precision=PRECISION), x.b)
all_are_inside(x::Groebner.CoeffGeneric, truth) = all_are_inside(x.data, truth)
all_are_inside(x::AbstractVector, truth) = all(map(all_are_inside, x, truth))
@assert all_are_inside(gbcoeffs, gbcoeffs_truth)

# Max |midpoint - truth|
max_error(x::Zp_And_FloatInterval, y; rel=false) = abs(mid(x.b) - y) / ifelse(rel, max(abs(y), 0), 1)
max_error(x::Groebner.CoeffGeneric, y; rel=false) = max_error(x.data, y; rel=rel)
max_error(x::AbstractVector, y::AbstractVector; rel=false) = maximum(map(f -> max_error(f...; rel=rel), zip(x, y)))
@info "
    Max error      : $(max_error(gbcoeffs, gbcoeffs_truth))
    Max error (rel): $(max_error(gbcoeffs, gbcoeffs_truth; rel=true))"

# Max diameter
max_diam(x::Zp_And_FloatInterval; rel=false) = ifelse(rel, diam_rel(x.b), diam(x.b))
max_diam(x::Groebner.CoeffGeneric; rel=false) = max_diam(x.data; rel=rel)
max_diam(x::AbstractVector; rel=false) = maximum(map(f -> max_diam(f; rel=rel), x))
@info "
    Max diam      : $(max_diam(gbcoeffs))
    Max diam (rel): $(max_diam(gbcoeffs; rel=true))"
```

However, if we lower MPFI precision to 256 bits, some of the intervals become NaN.

## Benchmark results

2024-02-07T04:07:14.794

Benchmarked backend: singular

Benchmark suite: The rationals

- Workers: 4
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|chandra 9|2.99|
|chandra 10|44.93|
|chandra 11|341.61|
|chandra 12| - |
|chandra 13| - |
|cyclic 7| - |
|cyclic 8| - |
|dummy|0.00|
|eco 10|38.52|
|eco 11| - |
|eco 12| - |
|eco 13| - |
|henrion 6|6.22|
|henrion 7| - |
|ipp|858.20|
|katsura 9|275.01|
|katsura 10| - |
|katsura 11| - |
|noon 7|1.11|
|noon 8|12.26|
|noon 9|184.11|
|reimer 6| - |
|reimer 7| - |
|reimer 8| - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-08-16T10:21:30.684

Benchmarked backend: openf4

Benchmark suite: Integers modulo 2^30 + 3

- Workers: 16
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|BIOMD0000000103| - |
|BIOMD0000000123| - |
|Cholera| - |
|Goodwin (w.)| - |
|HIV2| - |
|NFkB (w.)| - |
|alea6| - |
|bayes148| - |
|cyclic 7| - |
|cyclic 8| - |
|cyclic 9| - |
|dummy| - |
|eco 11| - |
|eco 12| - |
|eco 13| - |
|eco 14| - |
|gametwo2| - |
|henrion 5| - |
|henrion 6| - |
|henrion 7| - |
|henrion 8| - |
|jason210| - |
|katsura 10| - |
|katsura 11| - |
|katsura 12| - |
|katsura 13| - |
|mayr42| - |
|noon 7| - |
|noon 8| - |
|noon 9| - |
|noon 10| - |
|reimer 6| - |
|reimer 7| - |
|reimer 8| - |
|yang1| - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.10.2

Versions of the dependencies:

* Primes : 0.5.6
* TimerOutputs : 0.5.24
* PrecompileTools : 1.2.1
* MultivariatePolynomials : 0.5.6
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.17
* AbstractAlgebra : 0.42.0
* Nemo : 0.46.0
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-02-06T11:44:07.983

Benchmarked backend: groebner

Benchmark suite: The rationals

- Workers: 8
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|chandra 9|1.03|
|chandra 10|3.98|
|chandra 11|15.26|
|chandra 12|95.65|
|chandra 13|527.64|
|cyclic 7|0.95|
|cyclic 8|19.67|
|dummy|0.00|
|eco 10|0.48|
|eco 11|2.69|
|eco 12|24.53|
|eco 13|288.08|
|henrion 6|0.47|
|henrion 7|347.42|
|ipp|34.76|
|katsura 9|3.17|
|katsura 10|18.65|
|katsura 11|306.59|
|noon 7|0.81|
|noon 8|4.90|
|noon 9|30.11|
|reimer 6|0.47|
|reimer 7|9.08|
|reimer 8|838.21|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-02-03T04:20:37.617

Benchmarked backend: msolve

Benchmark suite: SIAN, the rationals

- Workers: 10
- Timeout: 3000 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|Biohydrogenation|0.42|
|Biohydrogenation_with_weights|0.36|
|COVID_m1|10.85|
|COVID_m1_with_weights|8.36|
|ChemicalReactionNetwork|5.17|
|ChemicalReactionNetwork_with_weights|3.84|
|Cholera|1841.30|
|Cholera_with_weights|1639.68|
|DAISY_ex3|0.06|
|DAISY_ex3_with_weights|0.10|
|DAISY_mamil3|0.08|
|DAISY_mamil3_with_weights|0.11|
|DAISY_mamil4|2.72|
|DAISY_mamil4_with_weights|7.22|
|Goodwin| - |
|Goodwin_with_weights|2240.06|
|HIV|0.30|
|HIV2|67.04|
|HIV2_with_weights|41.33|
|HIV_with_weights|0.30|
|LV|0.04|
|LV_with_weights|0.04|
|Lipolysis|0.05|
|Lipolysis_with_weights|0.04|
|NFkB| - |
|NFkB_with_weights| - |
|OralGlucose|0.04|
|OralGlucose_with_weights|0.07|
|Pharm| - |
|Pharm_with_weights| - |
|SEIR|0.06|
|SEIR2|0.16|
|SEIR2_with_weights|0.44|
|SEIRP|2450.64|
|SEIRP_with_weights|313.82|
|SEIR_with_weights|0.07|
|SIRSForced|11.94|
|SIRSForced_with_weights|8.93|
|SIR_R0|0.04|
|SIR_R0_with_weights|0.05|
|SlowFast|0.04|
|SlowFast_with_weights|0.04|
|Treatment|0.14|
|Treatment_with_weights|0.18|
|Tumor|0.82|
|Tumor_with_weights|10.30|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-02-07T06:42:34.534

Benchmarked backend: maple

Benchmark suite: SIAN, QQ

- Workers: 8
- Timeout: 7200 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|Cholera|527.64|
|Goodwin (w.)|2120.47|
|HIV2|23.85|
|NFkB (w.)|3411.72|
|Pharm (w.)| - |
|SEIRP|1235.47|
|dummy|0.01|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-01-27T02:30:44.878

Benchmarked backend: groebner

Benchmark suite: Integers modulo 1031

- Workers: 16
- Timeout: 1800 s
- Aggregated over: 3 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|chandra 11|0.48|
|chandra 12|2.43|
|chandra 13|20.02|
|chandra 14| - |
|cyclic 7|0.08|
|cyclic 8|1.19|
|cyclic 9| - |
|dummy|0.00|
|eco 11|0.31|
|eco 12|1.84|
|eco 13|8.61|
|eco 14|163.92|
|henrion 5|0.00|
|henrion 6|0.04|
|henrion 7|2.10|
|henrion 8| - |
|katsura 10|0.77|
|katsura 11|5.15|
|katsura 12|52.61|
|katsura 13| - |
|noon 7|0.18|
|noon 8|1.32|
|noon 9|12.09|
|noon 10| - |
|reimer 6|0.04|
|reimer 7|0.75|
|reimer 8|18.54|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.16
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-01-12T13:17:57.172

Benchmarked backends: Any["groebner", "maple"]

Benchmark suite: HC

- Workers: 8
- Timeout: 1200 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|groebner|maple|
|:----|---|---|
|boon|0.00|0.01|
|chandra 5|0.01|0.10|
|chandra 6|0.02|0.15|
|chandra 7|0.07|0.46|
|chandra 8|0.30| - |
|chandra 9|1.26| - |
|chandra 10|4.70| - |
|chandra 11|16.81| - |
|chandra 12|107.68| - |
|ipp|195.66| - |
|rps10| - | - |

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.9.2

Versions of the dependencies:

* Primes : 0.5.5
* TimerOutputs : 0.5.23
* PrecompileTools : 1.2.0
* MultivariatePolynomials : 0.5.3
* Combinatorics : 1.0.2
* AbstractAlgebra : 0.34.7
* Nemo : 0.38.3
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

## Benchmark results

2024-08-16T09:26:06.425

Benchmarked backend: groebner

Benchmark suite: Integers modulo 2^30 + 3

- Workers: 16
- Timeout: 1800 s
- Aggregated over: 1 runs

**All timings in seconds.**

|Model|Total, s|
|:----|---|
|BIOMD0000000103|0.18|
|BIOMD0000000123|0.77|
|Cholera|42.38|
|Goodwin (w.)|311.96|
|HIV2|2.00|
|NFkB (w.)|356.92|
|alea6|0.14|
|bayes148|35.39|
|cyclic 7|0.10|
|cyclic 8|1.42|
|cyclic 9|155.86|
|dummy|0.00|
|eco 11|0.55|
|eco 12|2.14|
|eco 13|8.98|
|eco 14|106.58|
|gametwo2|10.59|
|henrion 5|0.00|
|henrion 6|0.05|
|henrion 7|2.22|
|henrion 8| - |
|jason210|5.50|
|katsura 10|0.78|
|katsura 11|5.81|
|katsura 12|33.74|
|katsura 13|723.35|
|mayr42|48.07|
|noon 7|0.15|
|noon 8|1.55|
|noon 9|14.02|
|noon 10|230.04|
|reimer 6|0.05|
|reimer 7|1.57|
|reimer 8|18.06|
|yang1|16.29|

*Benchmarking environment:*

* Total RAM (GiB): 188
* Processor: Intel(R) Xeon(R) Gold 6130 CPU @ 2.10GHz
* Julia version: 1.10.2

Versions of the dependencies:

* Primes : 0.5.6
* TimerOutputs : 0.5.24
* PrecompileTools : 1.2.1
* MultivariatePolynomials : 0.5.6
* Combinatorics : 1.0.2
* HostCPUFeatures : 0.1.17
* AbstractAlgebra : 0.42.0
* Nemo : 0.46.0
* Atomix : 0.1.0
* ExprTools : 0.1.10
* PrettyTables : 2.3.1

# Home

Groebner.jl is a package for computing Gröbner bases written in Julia.

!!! note

      This documentation is also available in PDF format: [Groebner.jl.pdf](Groebner.jl.pdf).

## Installation

To install Groebner.jl, run the following in the Julia REPL:

```julia
using Pkg; Pkg.add("Groebner")
```

## Features

Groebner.jl features:

- Gröbner basis over integers modulo a prime and over the rationals
- Gröbner trace algorithms
- Multi-threading

## Contacts

This library is maintained by Alexander Demin ([demin@lix.polytechnique.fr](mailto:demin@lix.polytechnique.fr)).

## Citation

```
@misc{demin2024groebnerjl,
      title={Groebner.jl: A package for Gr\"obner bases computations in Julia}, 
      author={Alexander Demin and Shashi Gowda},
      year={2024},
      eprint={2304.06935},
      archivePrefix={arXiv},
      primaryClass={cs.MS}
}
```

## Acknowledgement

We would like to acknowledge the developers of the msolve library ([https://msolve.lip6.fr/](https://msolve.lip6.fr/)), as several components of Groebner.jl were adapted from msolve. In our F4 implementation, we adapt and adjust the code of monomial hashtable, critical pair handling and symbolic preprocessing, and linear algebra from msolve. The source code of msolve is available at [https://github.com/algebraic-solving/msolve](https://github.com/algebraic-solving/msolve).

We thank Vladimir Kuznetsov for helpful discussions and providing the sources of his F4 implementation.

We are grateful to The Max Planck Institute for Informatics, The MAX team at l'X, and the OURAGAN team at Inria for providing computational resources.
